#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 5991
#define LARGE_STATE_COUNT 2172
#define SYMBOL_COUNT 349
#define ALIAS_COUNT 4
#define TOKEN_COUNT 159
#define EXTERNAL_TOKEN_COUNT 30
#define FIELD_COUNT 32
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 127

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_program_token1 = 2,
  anon_sym___END__ = 3,
  anon_sym_ = 4,
  sym_uninterpreted = 5,
  anon_sym_BEGIN = 6,
  anon_sym_LBRACE = 7,
  anon_sym_RBRACE = 8,
  anon_sym_END = 9,
  anon_sym_def = 10,
  anon_sym_LPAREN = 11,
  anon_sym_RPAREN = 12,
  anon_sym_DOT = 13,
  anon_sym_COLON_COLON = 14,
  anon_sym_end = 15,
  anon_sym_rescue = 16,
  anon_sym_EQ = 17,
  anon_sym_COMMA = 18,
  anon_sym_PIPE = 19,
  anon_sym_SEMI = 20,
  anon_sym_DOT_DOT_DOT = 21,
  anon_sym_STAR = 22,
  anon_sym_STAR_STAR = 23,
  anon_sym_nil = 24,
  anon_sym_AMP = 25,
  anon_sym_COLON = 26,
  anon_sym_class = 27,
  anon_sym_LT = 28,
  anon_sym_module = 29,
  anon_sym_return = 30,
  anon_sym_yield = 31,
  anon_sym_break = 32,
  anon_sym_next = 33,
  anon_sym_redo = 34,
  anon_sym_retry = 35,
  anon_sym_if = 36,
  anon_sym_unless = 37,
  anon_sym_while = 38,
  anon_sym_until = 39,
  anon_sym_for = 40,
  anon_sym_in = 41,
  anon_sym_do = 42,
  anon_sym_case = 43,
  anon_sym_when = 44,
  anon_sym_EQ_GT = 45,
  anon_sym_LBRACK = 46,
  anon_sym_RBRACK = 47,
  anon_sym_LBRACK2 = 48,
  anon_sym_LPAREN2 = 49,
  anon_sym_DOT_DOT = 50,
  sym_line = 51,
  sym_file = 52,
  sym_encoding = 53,
  anon_sym_CARET = 54,
  anon_sym_elsif = 55,
  anon_sym_else = 56,
  anon_sym_then = 57,
  anon_sym_begin = 58,
  anon_sym_ensure = 59,
  anon_sym_COLON_COLON2 = 60,
  anon_sym_AMP_DOT = 61,
  anon_sym_PLUS_EQ = 62,
  anon_sym_DASH_EQ = 63,
  anon_sym_STAR_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_SLASH_EQ = 66,
  anon_sym_PIPE_PIPE_EQ = 67,
  anon_sym_PIPE_EQ = 68,
  anon_sym_AMP_AMP_EQ = 69,
  anon_sym_AMP_EQ = 70,
  anon_sym_PERCENT_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_LT_LT_EQ = 73,
  anon_sym_CARET_EQ = 74,
  anon_sym_QMARK = 75,
  anon_sym_COLON2 = 76,
  anon_sym_and = 77,
  anon_sym_or = 78,
  anon_sym_PIPE_PIPE = 79,
  anon_sym_AMP_AMP = 80,
  anon_sym_LT_LT = 81,
  anon_sym_GT_GT = 82,
  anon_sym_LT_EQ = 83,
  anon_sym_GT = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_PLUS = 86,
  anon_sym_SLASH = 87,
  anon_sym_PERCENT = 88,
  anon_sym_EQ_EQ = 89,
  anon_sym_BANG_EQ = 90,
  anon_sym_EQ_EQ_EQ = 91,
  anon_sym_LT_EQ_GT = 92,
  anon_sym_EQ_TILDE = 93,
  anon_sym_BANG_TILDE = 94,
  anon_sym_defined_QMARK = 95,
  anon_sym_not = 96,
  anon_sym_BANG = 97,
  anon_sym_TILDE = 98,
  anon_sym_DASH = 99,
  anon_sym_PLUS_AT = 100,
  anon_sym_DASH_AT = 101,
  anon_sym_TILDE_AT = 102,
  anon_sym_LBRACK_RBRACK = 103,
  anon_sym_LBRACK_RBRACK_EQ = 104,
  anon_sym_BQUOTE = 105,
  anon_sym_EQ2 = 106,
  anon_sym_undef = 107,
  anon_sym_alias = 108,
  sym_comment = 109,
  sym_integer = 110,
  sym_float = 111,
  anon_sym_i = 112,
  anon_sym_ri = 113,
  anon_sym_r = 114,
  sym_super = 115,
  sym_self = 116,
  sym_true = 117,
  sym_false = 118,
  sym_constant = 119,
  aux_sym_constant_suffix_token1 = 120,
  aux_sym_identifier_suffix_token1 = 121,
  sym_instance_variable = 122,
  sym_class_variable = 123,
  sym_global_variable = 124,
  sym_character = 125,
  anon_sym_POUND_LBRACE = 126,
  aux_sym_string_array_token1 = 127,
  sym_escape_sequence = 128,
  anon_sym_DASH_GT = 129,
  sym__line_break = 130,
  sym__no_line_break = 131,
  sym_simple_symbol = 132,
  sym__string_start = 133,
  sym__symbol_start = 134,
  sym__subshell_start = 135,
  sym__regex_start = 136,
  sym__string_array_start = 137,
  sym__symbol_array_start = 138,
  sym__heredoc_body_start = 139,
  sym_string_content = 140,
  sym_heredoc_content = 141,
  sym__string_end = 142,
  sym_heredoc_end = 143,
  sym_heredoc_beginning = 144,
  sym__block_ampersand = 145,
  sym__splat_star = 146,
  sym__unary_minus = 147,
  sym__unary_minus_num = 148,
  sym__binary_minus = 149,
  sym__binary_star = 150,
  sym__singleton_class_left_angle_left_langle = 151,
  sym_hash_key_symbol = 152,
  sym__identifier_suffix = 153,
  sym__constant_suffix = 154,
  sym__hash_splat_star_star = 155,
  sym__binary_star_star = 156,
  sym__element_reference_bracket = 157,
  sym__short_interpolation = 158,
  sym_program = 159,
  sym_block_body = 160,
  sym__statements = 161,
  sym_begin_block = 162,
  sym_end_block = 163,
  sym__statement = 164,
  sym_method = 165,
  sym_singleton_method = 166,
  sym__method_rest = 167,
  sym_rescue_modifier_arg = 168,
  sym_rescue_modifier_expression = 169,
  sym__body_expr = 170,
  sym_parameters = 171,
  sym_bare_parameters = 172,
  sym_block_parameters = 173,
  sym__formal_parameter = 174,
  sym__simple_formal_parameter = 175,
  sym_forward_parameter = 176,
  sym_splat_parameter = 177,
  sym_hash_splat_parameter = 178,
  sym_hash_splat_nil = 179,
  sym_block_parameter = 180,
  sym_keyword_parameter = 181,
  sym_optional_parameter = 182,
  sym_class = 183,
  sym_superclass = 184,
  sym_singleton_class = 185,
  sym_module = 186,
  sym_return_command = 187,
  sym_yield_command = 188,
  sym_break_command = 189,
  sym_next_command = 190,
  sym_return = 191,
  sym_yield = 192,
  sym_break = 193,
  sym_next = 194,
  sym_redo = 195,
  sym_retry = 196,
  sym_if_modifier = 197,
  sym_unless_modifier = 198,
  sym_while_modifier = 199,
  sym_until_modifier = 200,
  sym_rescue_modifier = 201,
  sym_while = 202,
  sym_until = 203,
  sym_for = 204,
  sym_in = 205,
  sym_do = 206,
  sym_case = 207,
  sym_case_match = 208,
  sym_when = 209,
  sym_in_clause = 210,
  sym_pattern = 211,
  sym__guard = 212,
  sym_if_guard = 213,
  sym_unless_guard = 214,
  sym__pattern_top_expr_body = 215,
  sym__array_pattern_n = 216,
  sym__pattern_expr = 217,
  sym_as_pattern = 218,
  sym__pattern_expr_alt = 219,
  sym_alternative_pattern = 220,
  sym__array_pattern_body = 221,
  sym_array_pattern = 222,
  sym__find_pattern_body = 223,
  sym_find_pattern = 224,
  sym__hash_pattern_body = 225,
  sym_keyword_pattern = 226,
  sym__hash_pattern_any_rest = 227,
  sym_hash_pattern = 228,
  sym__pattern_expr_basic = 229,
  sym_parenthesized_pattern = 230,
  sym__pattern_value = 231,
  sym__pattern_range = 232,
  sym__pattern_primitive = 233,
  sym__pattern_lambda = 234,
  sym__pattern_literal = 235,
  sym__keyword_variable = 236,
  sym_variable_reference_pattern = 237,
  sym_expression_reference_pattern = 238,
  sym__pattern_constant = 239,
  sym__pattern_constant_resolution = 240,
  sym_if = 241,
  sym_unless = 242,
  sym_elsif = 243,
  sym_else = 244,
  sym_then = 245,
  sym_begin = 246,
  sym_ensure = 247,
  sym_rescue = 248,
  sym_exceptions = 249,
  sym_exception_variable = 250,
  sym_body_statement = 251,
  sym__body_statement = 252,
  sym__expression = 253,
  sym_match_pattern = 254,
  sym_test_pattern = 255,
  sym__arg = 256,
  sym__unary_minus_pow = 257,
  sym__pow = 258,
  sym__primary = 259,
  sym_parenthesized_statements = 260,
  sym_element_reference = 261,
  sym_scope_resolution = 262,
  sym__call = 263,
  sym_command_call = 264,
  sym_command_call_with_block = 265,
  sym__chained_command_call = 266,
  sym_call = 267,
  sym_command_argument_list = 268,
  sym_argument_list = 269,
  sym__argument_list_with_trailing_comma = 270,
  sym__argument = 271,
  sym_forward_argument = 272,
  sym_splat_argument = 273,
  sym_hash_splat_argument = 274,
  sym_block_argument = 275,
  sym_do_block = 276,
  sym_block = 277,
  sym_assignment = 278,
  sym_command_assignment = 279,
  sym_operator_assignment = 280,
  sym_command_operator_assignment = 281,
  sym_conditional = 282,
  sym_range = 283,
  sym_binary = 284,
  sym_command_binary = 285,
  sym_unary = 286,
  sym_command_unary = 287,
  sym_parenthesized_unary = 288,
  sym_unary_literal = 289,
  sym__literal = 290,
  sym__numeric = 291,
  sym__simple_numeric = 292,
  sym_right_assignment_list = 293,
  sym_left_assignment_list = 294,
  sym__mlhs = 295,
  sym_destructured_left_assignment = 296,
  sym_rest_assignment = 297,
  sym__function_identifier = 298,
  sym__function_identifier_call = 299,
  sym__lhs = 300,
  sym__variable = 301,
  sym_operator = 302,
  sym__method_name = 303,
  sym__nonlocal_variable = 304,
  sym_setter = 305,
  sym_undef = 306,
  sym_alias = 307,
  sym__int_or_float = 308,
  sym_complex = 309,
  sym_rational = 310,
  sym_nil = 311,
  sym_constant_suffix = 312,
  sym_identifier_suffix = 313,
  sym_chained_string = 314,
  sym_interpolation = 315,
  sym_string = 316,
  sym_subshell = 317,
  sym_string_array = 318,
  sym_symbol_array = 319,
  sym_delimited_symbol = 320,
  sym_regex = 321,
  sym_heredoc_body = 322,
  aux_sym__literal_contents = 323,
  sym_array = 324,
  sym_hash = 325,
  sym_pair = 326,
  sym_lambda = 327,
  sym_empty_statement = 328,
  sym__terminator = 329,
  aux_sym__statements_repeat1 = 330,
  aux_sym_parameters_repeat1 = 331,
  aux_sym_block_parameters_repeat1 = 332,
  aux_sym_case_repeat1 = 333,
  aux_sym_case_match_repeat1 = 334,
  aux_sym_when_repeat1 = 335,
  aux_sym__array_pattern_n_repeat1 = 336,
  aux_sym_alternative_pattern_repeat1 = 337,
  aux_sym__hash_pattern_body_repeat1 = 338,
  aux_sym_exceptions_repeat1 = 339,
  aux_sym__body_statement_repeat1 = 340,
  aux_sym_command_argument_list_repeat1 = 341,
  aux_sym__mlhs_repeat1 = 342,
  aux_sym_undef_repeat1 = 343,
  aux_sym_chained_string_repeat1 = 344,
  aux_sym_string_array_repeat1 = 345,
  aux_sym_symbol_array_repeat1 = 346,
  aux_sym_heredoc_body_repeat1 = 347,
  aux_sym_hash_repeat1 = 348,
  alias_sym_bare_string = 349,
  alias_sym_bare_symbol = 350,
  alias_sym_destructured_parameter = 351,
  alias_sym_lambda_parameters = 352,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_program_token1] = "program_token1",
  [anon_sym___END__] = "__END__",
  [anon_sym_] = "uninterpreted",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_end] = "end",
  [anon_sym_rescue] = "rescue",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_nil] = "nil",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [anon_sym_redo] = "redo",
  [anon_sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT_DOT] = "..",
  [sym_line] = "line",
  [sym_file] = "file",
  [sym_encoding] = "encoding",
  [anon_sym_CARET] = "^",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON2] = ":",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_defined_QMARK] = "defined\?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_TILDE_AT] = "~@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_EQ2] = "=",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_i] = "i",
  [anon_sym_ri] = "ri",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [sym_self] = "self",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_constant] = "constant",
  [aux_sym_constant_suffix_token1] = "constant_suffix_token1",
  [aux_sym_identifier_suffix_token1] = "identifier_suffix_token1",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_string_array_token1] = "string_array_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_DASH_GT] = "->",
  [sym__line_break] = "_line_break",
  [sym__no_line_break] = "_no_line_break",
  [sym_simple_symbol] = "simple_symbol",
  [sym__string_start] = "\"",
  [sym__symbol_start] = ":\"",
  [sym__subshell_start] = "`",
  [sym__regex_start] = "/",
  [sym__string_array_start] = "%w(",
  [sym__symbol_array_start] = "%i(",
  [sym__heredoc_body_start] = "_heredoc_body_start",
  [sym_string_content] = "string_content",
  [sym_heredoc_content] = "heredoc_content",
  [sym__string_end] = ")",
  [sym_heredoc_end] = "heredoc_end",
  [sym_heredoc_beginning] = "heredoc_beginning",
  [sym__block_ampersand] = "&",
  [sym__splat_star] = "*",
  [sym__unary_minus] = "-",
  [sym__unary_minus_num] = "-",
  [sym__binary_minus] = "-",
  [sym__binary_star] = "*",
  [sym__singleton_class_left_angle_left_langle] = "<<",
  [sym_hash_key_symbol] = "hash_key_symbol",
  [sym__identifier_suffix] = "_identifier_suffix",
  [sym__constant_suffix] = "_constant_suffix",
  [sym__hash_splat_star_star] = "**",
  [sym__binary_star_star] = "**",
  [sym__element_reference_bracket] = "[",
  [sym__short_interpolation] = "_short_interpolation",
  [sym_program] = "program",
  [sym_block_body] = "block_body",
  [sym__statements] = "_statements",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_rescue_modifier_arg] = "rescue_modifier",
  [sym_rescue_modifier_expression] = "rescue_modifier",
  [sym__body_expr] = "_body_expr",
  [sym_parameters] = "method_parameters",
  [sym_bare_parameters] = "method_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_forward_parameter] = "forward_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_hash_splat_nil] = "hash_splat_nil",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return_command] = "return",
  [sym_yield_command] = "yield",
  [sym_break_command] = "break",
  [sym_next_command] = "next",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym_do] = "do",
  [sym_case] = "case",
  [sym_case_match] = "case_match",
  [sym_when] = "when",
  [sym_in_clause] = "in_clause",
  [sym_pattern] = "pattern",
  [sym__guard] = "_guard",
  [sym_if_guard] = "if_guard",
  [sym_unless_guard] = "unless_guard",
  [sym__pattern_top_expr_body] = "_pattern_top_expr_body",
  [sym__array_pattern_n] = "_array_pattern_n",
  [sym__pattern_expr] = "_pattern_expr",
  [sym_as_pattern] = "as_pattern",
  [sym__pattern_expr_alt] = "_pattern_expr_alt",
  [sym_alternative_pattern] = "alternative_pattern",
  [sym__array_pattern_body] = "_array_pattern_body",
  [sym_array_pattern] = "array_pattern",
  [sym__find_pattern_body] = "_find_pattern_body",
  [sym_find_pattern] = "find_pattern",
  [sym__hash_pattern_body] = "_hash_pattern_body",
  [sym_keyword_pattern] = "keyword_pattern",
  [sym__hash_pattern_any_rest] = "_hash_pattern_any_rest",
  [sym_hash_pattern] = "hash_pattern",
  [sym__pattern_expr_basic] = "_pattern_expr_basic",
  [sym_parenthesized_pattern] = "parenthesized_pattern",
  [sym__pattern_value] = "_pattern_value",
  [sym__pattern_range] = "range",
  [sym__pattern_primitive] = "_pattern_primitive",
  [sym__pattern_lambda] = "_pattern_lambda",
  [sym__pattern_literal] = "_pattern_literal",
  [sym__keyword_variable] = "_keyword_variable",
  [sym_variable_reference_pattern] = "variable_reference_pattern",
  [sym_expression_reference_pattern] = "expression_reference_pattern",
  [sym__pattern_constant] = "_pattern_constant",
  [sym__pattern_constant_resolution] = "scope_resolution",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym_then] = "then",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym_body_statement] = "body_statement",
  [sym__body_statement] = "_body_statement",
  [sym__expression] = "_expression",
  [sym_match_pattern] = "match_pattern",
  [sym_test_pattern] = "test_pattern",
  [sym__arg] = "_arg",
  [sym__unary_minus_pow] = "unary",
  [sym__pow] = "binary",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym__call] = "_call",
  [sym_command_call] = "call",
  [sym_command_call_with_block] = "call",
  [sym__chained_command_call] = "_chained_command_call",
  [sym_call] = "call",
  [sym_command_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_forward_argument] = "forward_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_command_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_command_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_command_binary] = "binary",
  [sym_unary] = "unary",
  [sym_command_unary] = "unary",
  [sym_parenthesized_unary] = "unary",
  [sym_unary_literal] = "unary",
  [sym__literal] = "_literal",
  [sym__numeric] = "_numeric",
  [sym__simple_numeric] = "_simple_numeric",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__function_identifier] = "_function_identifier",
  [sym__function_identifier_call] = "call",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym__nonlocal_variable] = "_nonlocal_variable",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym__int_or_float] = "_int_or_float",
  [sym_complex] = "complex",
  [sym_rational] = "rational",
  [sym_nil] = "nil",
  [sym_constant_suffix] = "hash_key_symbol",
  [sym_identifier_suffix] = "hash_key_symbol",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_delimited_symbol] = "delimited_symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [aux_sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_case_match_repeat1] = "case_match_repeat1",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym__array_pattern_n_repeat1] = "_array_pattern_n_repeat1",
  [aux_sym_alternative_pattern_repeat1] = "alternative_pattern_repeat1",
  [aux_sym__hash_pattern_body_repeat1] = "_hash_pattern_body_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym__body_statement_repeat1] = "_body_statement_repeat1",
  [aux_sym_command_argument_list_repeat1] = "command_argument_list_repeat1",
  [aux_sym__mlhs_repeat1] = "_mlhs_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_hash_repeat1] = "hash_repeat1",
  [alias_sym_bare_string] = "bare_string",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_destructured_parameter] = "destructured_parameter",
  [alias_sym_lambda_parameters] = "lambda_parameters",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_program_token1] = aux_sym_program_token1,
  [anon_sym___END__] = anon_sym___END__,
  [anon_sym_] = sym_uninterpreted,
  [sym_uninterpreted] = sym_uninterpreted,
  [anon_sym_BEGIN] = anon_sym_BEGIN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_END] = anon_sym_END,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_rescue] = anon_sym_rescue,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_nil] = anon_sym_nil,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_next] = anon_sym_next,
  [anon_sym_redo] = anon_sym_redo,
  [anon_sym_retry] = anon_sym_retry,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_unless] = anon_sym_unless,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [sym_line] = sym_line,
  [sym_file] = sym_file,
  [sym_encoding] = sym_encoding,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_elsif] = anon_sym_elsif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_ensure] = anon_sym_ensure,
  [anon_sym_COLON_COLON2] = anon_sym_COLON_COLON,
  [anon_sym_AMP_DOT] = anon_sym_AMP_DOT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON2] = anon_sym_COLON,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_defined_QMARK] = anon_sym_defined_QMARK,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_AT] = anon_sym_PLUS_AT,
  [anon_sym_DASH_AT] = anon_sym_DASH_AT,
  [anon_sym_TILDE_AT] = anon_sym_TILDE_AT,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK_RBRACK_EQ] = anon_sym_LBRACK_RBRACK_EQ,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_EQ2] = anon_sym_EQ,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_alias] = anon_sym_alias,
  [sym_comment] = sym_comment,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_i] = anon_sym_i,
  [anon_sym_ri] = anon_sym_ri,
  [anon_sym_r] = anon_sym_r,
  [sym_super] = sym_super,
  [sym_self] = sym_self,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_constant] = sym_constant,
  [aux_sym_constant_suffix_token1] = aux_sym_constant_suffix_token1,
  [aux_sym_identifier_suffix_token1] = aux_sym_identifier_suffix_token1,
  [sym_instance_variable] = sym_instance_variable,
  [sym_class_variable] = sym_class_variable,
  [sym_global_variable] = sym_global_variable,
  [sym_character] = sym_character,
  [anon_sym_POUND_LBRACE] = anon_sym_POUND_LBRACE,
  [aux_sym_string_array_token1] = aux_sym_string_array_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym__line_break] = sym__line_break,
  [sym__no_line_break] = sym__no_line_break,
  [sym_simple_symbol] = sym_simple_symbol,
  [sym__string_start] = sym__string_start,
  [sym__symbol_start] = sym__symbol_start,
  [sym__subshell_start] = anon_sym_BQUOTE,
  [sym__regex_start] = anon_sym_SLASH,
  [sym__string_array_start] = sym__string_array_start,
  [sym__symbol_array_start] = sym__symbol_array_start,
  [sym__heredoc_body_start] = sym__heredoc_body_start,
  [sym_string_content] = sym_string_content,
  [sym_heredoc_content] = sym_heredoc_content,
  [sym__string_end] = anon_sym_RPAREN,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym_heredoc_beginning] = sym_heredoc_beginning,
  [sym__block_ampersand] = anon_sym_AMP,
  [sym__splat_star] = anon_sym_STAR,
  [sym__unary_minus] = anon_sym_DASH,
  [sym__unary_minus_num] = anon_sym_DASH,
  [sym__binary_minus] = anon_sym_DASH,
  [sym__binary_star] = anon_sym_STAR,
  [sym__singleton_class_left_angle_left_langle] = anon_sym_LT_LT,
  [sym_hash_key_symbol] = sym_hash_key_symbol,
  [sym__identifier_suffix] = sym__identifier_suffix,
  [sym__constant_suffix] = sym__constant_suffix,
  [sym__hash_splat_star_star] = anon_sym_STAR_STAR,
  [sym__binary_star_star] = anon_sym_STAR_STAR,
  [sym__element_reference_bracket] = anon_sym_LBRACK,
  [sym__short_interpolation] = sym__short_interpolation,
  [sym_program] = sym_program,
  [sym_block_body] = sym_block_body,
  [sym__statements] = sym__statements,
  [sym_begin_block] = sym_begin_block,
  [sym_end_block] = sym_end_block,
  [sym__statement] = sym__statement,
  [sym_method] = sym_method,
  [sym_singleton_method] = sym_singleton_method,
  [sym__method_rest] = sym__method_rest,
  [sym_rescue_modifier_arg] = sym_rescue_modifier,
  [sym_rescue_modifier_expression] = sym_rescue_modifier,
  [sym__body_expr] = sym__body_expr,
  [sym_parameters] = sym_parameters,
  [sym_bare_parameters] = sym_parameters,
  [sym_block_parameters] = sym_block_parameters,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym__simple_formal_parameter] = sym__simple_formal_parameter,
  [sym_forward_parameter] = sym_forward_parameter,
  [sym_splat_parameter] = sym_splat_parameter,
  [sym_hash_splat_parameter] = sym_hash_splat_parameter,
  [sym_hash_splat_nil] = sym_hash_splat_nil,
  [sym_block_parameter] = sym_block_parameter,
  [sym_keyword_parameter] = sym_keyword_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym_class] = sym_class,
  [sym_superclass] = sym_superclass,
  [sym_singleton_class] = sym_singleton_class,
  [sym_module] = sym_module,
  [sym_return_command] = sym_return,
  [sym_yield_command] = sym_yield,
  [sym_break_command] = sym_break,
  [sym_next_command] = sym_next,
  [sym_return] = sym_return,
  [sym_yield] = sym_yield,
  [sym_break] = sym_break,
  [sym_next] = sym_next,
  [sym_redo] = sym_redo,
  [sym_retry] = sym_retry,
  [sym_if_modifier] = sym_if_modifier,
  [sym_unless_modifier] = sym_unless_modifier,
  [sym_while_modifier] = sym_while_modifier,
  [sym_until_modifier] = sym_until_modifier,
  [sym_rescue_modifier] = sym_rescue_modifier,
  [sym_while] = sym_while,
  [sym_until] = sym_until,
  [sym_for] = sym_for,
  [sym_in] = sym_in,
  [sym_do] = sym_do,
  [sym_case] = sym_case,
  [sym_case_match] = sym_case_match,
  [sym_when] = sym_when,
  [sym_in_clause] = sym_in_clause,
  [sym_pattern] = sym_pattern,
  [sym__guard] = sym__guard,
  [sym_if_guard] = sym_if_guard,
  [sym_unless_guard] = sym_unless_guard,
  [sym__pattern_top_expr_body] = sym__pattern_top_expr_body,
  [sym__array_pattern_n] = sym__array_pattern_n,
  [sym__pattern_expr] = sym__pattern_expr,
  [sym_as_pattern] = sym_as_pattern,
  [sym__pattern_expr_alt] = sym__pattern_expr_alt,
  [sym_alternative_pattern] = sym_alternative_pattern,
  [sym__array_pattern_body] = sym__array_pattern_body,
  [sym_array_pattern] = sym_array_pattern,
  [sym__find_pattern_body] = sym__find_pattern_body,
  [sym_find_pattern] = sym_find_pattern,
  [sym__hash_pattern_body] = sym__hash_pattern_body,
  [sym_keyword_pattern] = sym_keyword_pattern,
  [sym__hash_pattern_any_rest] = sym__hash_pattern_any_rest,
  [sym_hash_pattern] = sym_hash_pattern,
  [sym__pattern_expr_basic] = sym__pattern_expr_basic,
  [sym_parenthesized_pattern] = sym_parenthesized_pattern,
  [sym__pattern_value] = sym__pattern_value,
  [sym__pattern_range] = sym_range,
  [sym__pattern_primitive] = sym__pattern_primitive,
  [sym__pattern_lambda] = sym__pattern_lambda,
  [sym__pattern_literal] = sym__pattern_literal,
  [sym__keyword_variable] = sym__keyword_variable,
  [sym_variable_reference_pattern] = sym_variable_reference_pattern,
  [sym_expression_reference_pattern] = sym_expression_reference_pattern,
  [sym__pattern_constant] = sym__pattern_constant,
  [sym__pattern_constant_resolution] = sym_scope_resolution,
  [sym_if] = sym_if,
  [sym_unless] = sym_unless,
  [sym_elsif] = sym_elsif,
  [sym_else] = sym_else,
  [sym_then] = sym_then,
  [sym_begin] = sym_begin,
  [sym_ensure] = sym_ensure,
  [sym_rescue] = sym_rescue,
  [sym_exceptions] = sym_exceptions,
  [sym_exception_variable] = sym_exception_variable,
  [sym_body_statement] = sym_body_statement,
  [sym__body_statement] = sym__body_statement,
  [sym__expression] = sym__expression,
  [sym_match_pattern] = sym_match_pattern,
  [sym_test_pattern] = sym_test_pattern,
  [sym__arg] = sym__arg,
  [sym__unary_minus_pow] = sym_unary,
  [sym__pow] = sym_binary,
  [sym__primary] = sym__primary,
  [sym_parenthesized_statements] = sym_parenthesized_statements,
  [sym_element_reference] = sym_element_reference,
  [sym_scope_resolution] = sym_scope_resolution,
  [sym__call] = sym__call,
  [sym_command_call] = sym_call,
  [sym_command_call_with_block] = sym_call,
  [sym__chained_command_call] = sym__chained_command_call,
  [sym_call] = sym_call,
  [sym_command_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym__argument_list_with_trailing_comma] = sym__argument_list_with_trailing_comma,
  [sym__argument] = sym__argument,
  [sym_forward_argument] = sym_forward_argument,
  [sym_splat_argument] = sym_splat_argument,
  [sym_hash_splat_argument] = sym_hash_splat_argument,
  [sym_block_argument] = sym_block_argument,
  [sym_do_block] = sym_do_block,
  [sym_block] = sym_block,
  [sym_assignment] = sym_assignment,
  [sym_command_assignment] = sym_assignment,
  [sym_operator_assignment] = sym_operator_assignment,
  [sym_command_operator_assignment] = sym_operator_assignment,
  [sym_conditional] = sym_conditional,
  [sym_range] = sym_range,
  [sym_binary] = sym_binary,
  [sym_command_binary] = sym_binary,
  [sym_unary] = sym_unary,
  [sym_command_unary] = sym_unary,
  [sym_parenthesized_unary] = sym_unary,
  [sym_unary_literal] = sym_unary,
  [sym__literal] = sym__literal,
  [sym__numeric] = sym__numeric,
  [sym__simple_numeric] = sym__simple_numeric,
  [sym_right_assignment_list] = sym_right_assignment_list,
  [sym_left_assignment_list] = sym_left_assignment_list,
  [sym__mlhs] = sym__mlhs,
  [sym_destructured_left_assignment] = sym_destructured_left_assignment,
  [sym_rest_assignment] = sym_rest_assignment,
  [sym__function_identifier] = sym__function_identifier,
  [sym__function_identifier_call] = sym_call,
  [sym__lhs] = sym__lhs,
  [sym__variable] = sym__variable,
  [sym_operator] = sym_operator,
  [sym__method_name] = sym__method_name,
  [sym__nonlocal_variable] = sym__nonlocal_variable,
  [sym_setter] = sym_setter,
  [sym_undef] = sym_undef,
  [sym_alias] = sym_alias,
  [sym__int_or_float] = sym__int_or_float,
  [sym_complex] = sym_complex,
  [sym_rational] = sym_rational,
  [sym_nil] = sym_nil,
  [sym_constant_suffix] = sym_hash_key_symbol,
  [sym_identifier_suffix] = sym_hash_key_symbol,
  [sym_chained_string] = sym_chained_string,
  [sym_interpolation] = sym_interpolation,
  [sym_string] = sym_string,
  [sym_subshell] = sym_subshell,
  [sym_string_array] = sym_string_array,
  [sym_symbol_array] = sym_symbol_array,
  [sym_delimited_symbol] = sym_delimited_symbol,
  [sym_regex] = sym_regex,
  [sym_heredoc_body] = sym_heredoc_body,
  [aux_sym__literal_contents] = aux_sym__literal_contents,
  [sym_array] = sym_array,
  [sym_hash] = sym_hash,
  [sym_pair] = sym_pair,
  [sym_lambda] = sym_lambda,
  [sym_empty_statement] = sym_empty_statement,
  [sym__terminator] = sym__terminator,
  [aux_sym__statements_repeat1] = aux_sym__statements_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_block_parameters_repeat1] = aux_sym_block_parameters_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_case_match_repeat1] = aux_sym_case_match_repeat1,
  [aux_sym_when_repeat1] = aux_sym_when_repeat1,
  [aux_sym__array_pattern_n_repeat1] = aux_sym__array_pattern_n_repeat1,
  [aux_sym_alternative_pattern_repeat1] = aux_sym_alternative_pattern_repeat1,
  [aux_sym__hash_pattern_body_repeat1] = aux_sym__hash_pattern_body_repeat1,
  [aux_sym_exceptions_repeat1] = aux_sym_exceptions_repeat1,
  [aux_sym__body_statement_repeat1] = aux_sym__body_statement_repeat1,
  [aux_sym_command_argument_list_repeat1] = aux_sym_command_argument_list_repeat1,
  [aux_sym__mlhs_repeat1] = aux_sym__mlhs_repeat1,
  [aux_sym_undef_repeat1] = aux_sym_undef_repeat1,
  [aux_sym_chained_string_repeat1] = aux_sym_chained_string_repeat1,
  [aux_sym_string_array_repeat1] = aux_sym_string_array_repeat1,
  [aux_sym_symbol_array_repeat1] = aux_sym_symbol_array_repeat1,
  [aux_sym_heredoc_body_repeat1] = aux_sym_heredoc_body_repeat1,
  [aux_sym_hash_repeat1] = aux_sym_hash_repeat1,
  [alias_sym_bare_string] = alias_sym_bare_string,
  [alias_sym_bare_symbol] = alias_sym_bare_symbol,
  [alias_sym_destructured_parameter] = alias_sym_destructured_parameter,
  [alias_sym_lambda_parameters] = alias_sym_lambda_parameters,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_] = {
    .visible = true,
    .named = true,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_redo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_retry] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_line] = {
    .visible = true,
    .named = true,
  },
  [sym_file] = {
    .visible = true,
    .named = true,
  },
  [sym_encoding] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_constant_suffix_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_identifier_suffix_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_array_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__no_line_break] = {
    .visible = false,
    .named = true,
  },
  [sym_simple_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_start] = {
    .visible = true,
    .named = false,
  },
  [sym__subshell_start] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__heredoc_body_start] = {
    .visible = false,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_content] = {
    .visible = true,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand] = {
    .visible = true,
    .named = false,
  },
  [sym__splat_star] = {
    .visible = true,
    .named = false,
  },
  [sym__unary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__unary_minus_num] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star] = {
    .visible = true,
    .named = false,
  },
  [sym__singleton_class_left_angle_left_langle] = {
    .visible = true,
    .named = false,
  },
  [sym_hash_key_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym__hash_splat_star_star] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star_star] = {
    .visible = true,
    .named = false,
  },
  [sym__element_reference_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__short_interpolation] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_block_body] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_rescue_modifier_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__body_expr] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_bare_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_forward_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return_command] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_command] = {
    .visible = true,
    .named = true,
  },
  [sym_break_command] = {
    .visible = true,
    .named = true,
  },
  [sym_next_command] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_case_match] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__guard] = {
    .visible = false,
    .named = true,
  },
  [sym_if_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_guard] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_top_expr_body] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__array_pattern_n] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_expr] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_expr_alt] = {
    .visible = false,
    .named = true,
  },
  [sym_alternative_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__array_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__find_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_find_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_pattern_any_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_hash_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_expr_basic] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_value] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_range] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_primitive] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__pattern_lambda] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__keyword_variable] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_constant] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__pattern_constant_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_then] = {
    .visible = true,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_body_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_test_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unary_minus_pow] = {
    .visible = true,
    .named = true,
  },
  [sym__pow] = {
    .visible = true,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym__call] = {
    .visible = false,
    .named = true,
  },
  [sym_command_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_call_with_block] = {
    .visible = true,
    .named = true,
  },
  [sym__chained_command_call] = {
    .visible = false,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_forward_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_command_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_command_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym__numeric] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_numeric] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__function_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__function_identifier_call] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__nonlocal_variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym__int_or_float] = {
    .visible = false,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_delimited_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__literal_contents] = {
    .visible = false,
    .named = false,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_match_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__array_pattern_n_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alternative_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hash_pattern_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__body_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mlhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hash_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_alternatives = 3,
  field_arguments = 4,
  field_begin = 5,
  field_block = 6,
  field_body = 7,
  field_class = 8,
  field_clauses = 9,
  field_condition = 10,
  field_consequence = 11,
  field_else = 12,
  field_end = 13,
  field_exceptions = 14,
  field_guard = 15,
  field_handler = 16,
  field_key = 17,
  field_left = 18,
  field_locals = 19,
  field_method = 20,
  field_name = 21,
  field_object = 22,
  field_operand = 23,
  field_operator = 24,
  field_parameters = 25,
  field_pattern = 26,
  field_receiver = 27,
  field_right = 28,
  field_scope = 29,
  field_superclass = 30,
  field_value = 31,
  field_variable = 32,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_alternatives] = "alternatives",
  [field_arguments] = "arguments",
  [field_begin] = "begin",
  [field_block] = "block",
  [field_body] = "body",
  [field_class] = "class",
  [field_clauses] = "clauses",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_else] = "else",
  [field_end] = "end",
  [field_exceptions] = "exceptions",
  [field_guard] = "guard",
  [field_handler] = "handler",
  [field_key] = "key",
  [field_left] = "left",
  [field_locals] = "locals",
  [field_method] = "method",
  [field_name] = "name",
  [field_object] = "object",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_receiver] = "receiver",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_superclass] = "superclass",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 3},
  [4] = {.index = 5, .length = 1},
  [5] = {.index = 6, .length = 1},
  [11] = {.index = 7, .length = 2},
  [12] = {.index = 9, .length = 5},
  [13] = {.index = 14, .length = 3},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 2},
  [16] = {.index = 20, .length = 1},
  [17] = {.index = 21, .length = 2},
  [18] = {.index = 23, .length = 4},
  [19] = {.index = 27, .length = 4},
  [20] = {.index = 31, .length = 2},
  [21] = {.index = 33, .length = 2},
  [28] = {.index = 35, .length = 1},
  [29] = {.index = 35, .length = 1},
  [30] = {.index = 36, .length = 1},
  [31] = {.index = 37, .length = 2},
  [32] = {.index = 39, .length = 2},
  [33] = {.index = 41, .length = 1},
  [34] = {.index = 42, .length = 1},
  [35] = {.index = 43, .length = 2},
  [37] = {.index = 45, .length = 2},
  [38] = {.index = 47, .length = 2},
  [39] = {.index = 49, .length = 2},
  [40] = {.index = 51, .length = 3},
  [41] = {.index = 54, .length = 3},
  [42] = {.index = 57, .length = 2},
  [46] = {.index = 59, .length = 3},
  [47] = {.index = 62, .length = 2},
  [48] = {.index = 64, .length = 1},
  [49] = {.index = 65, .length = 3},
  [50] = {.index = 68, .length = 3},
  [51] = {.index = 71, .length = 2},
  [52] = {.index = 73, .length = 5},
  [53] = {.index = 78, .length = 2},
  [54] = {.index = 80, .length = 3},
  [57] = {.index = 83, .length = 2},
  [58] = {.index = 83, .length = 2},
  [59] = {.index = 85, .length = 4},
  [60] = {.index = 89, .length = 2},
  [61] = {.index = 91, .length = 3},
  [62] = {.index = 94, .length = 2},
  [63] = {.index = 96, .length = 2},
  [64] = {.index = 98, .length = 1},
  [65] = {.index = 99, .length = 3},
  [66] = {.index = 102, .length = 1},
  [67] = {.index = 103, .length = 2},
  [68] = {.index = 105, .length = 1},
  [69] = {.index = 106, .length = 2},
  [70] = {.index = 108, .length = 2},
  [71] = {.index = 110, .length = 2},
  [72] = {.index = 112, .length = 1},
  [73] = {.index = 113, .length = 2},
  [74] = {.index = 115, .length = 1},
  [75] = {.index = 116, .length = 1},
  [76] = {.index = 117, .length = 2},
  [78] = {.index = 119, .length = 2},
  [79] = {.index = 121, .length = 2},
  [80] = {.index = 123, .length = 4},
  [81] = {.index = 127, .length = 3},
  [82] = {.index = 130, .length = 2},
  [83] = {.index = 132, .length = 2},
  [84] = {.index = 134, .length = 2},
  [85] = {.index = 136, .length = 3},
  [86] = {.index = 139, .length = 2},
  [87] = {.index = 141, .length = 2},
  [88] = {.index = 143, .length = 3},
  [89] = {.index = 146, .length = 2},
  [90] = {.index = 148, .length = 2},
  [91] = {.index = 150, .length = 2},
  [92] = {.index = 152, .length = 3},
  [93] = {.index = 155, .length = 3},
  [94] = {.index = 158, .length = 2},
  [95] = {.index = 45, .length = 2},
  [96] = {.index = 160, .length = 1},
  [97] = {.index = 161, .length = 1},
  [98] = {.index = 162, .length = 2},
  [99] = {.index = 164, .length = 1},
  [100] = {.index = 165, .length = 2},
  [101] = {.index = 167, .length = 1},
  [102] = {.index = 168, .length = 3},
  [103] = {.index = 171, .length = 2},
  [104] = {.index = 173, .length = 4},
  [105] = {.index = 177, .length = 3},
  [106] = {.index = 180, .length = 2},
  [107] = {.index = 182, .length = 3},
  [108] = {.index = 185, .length = 2},
  [109] = {.index = 187, .length = 3},
  [110] = {.index = 190, .length = 3},
  [111] = {.index = 193, .length = 2},
  [112] = {.index = 195, .length = 3},
  [113] = {.index = 198, .length = 1},
  [114] = {.index = 199, .length = 2},
  [115] = {.index = 201, .length = 2},
  [116] = {.index = 203, .length = 3},
  [117] = {.index = 206, .length = 1},
  [118] = {.index = 207, .length = 1},
  [119] = {.index = 208, .length = 2},
  [120] = {.index = 210, .length = 2},
  [121] = {.index = 212, .length = 2},
  [122] = {.index = 214, .length = 2},
  [123] = {.index = 216, .length = 1},
  [124] = {.index = 217, .length = 2},
  [125] = {.index = 219, .length = 1},
  [126] = {.index = 220, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [2] =
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [5] =
    {field_method, 0},
  [6] =
    {field_method, 0, .inherited = true},
  [7] =
    {field_operand, 1},
    {field_operator, 0},
  [9] =
    {field_left, 1, .inherited = true},
    {field_operand, 1},
    {field_operator, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [14] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [17] =
    {field_name, 1},
  [18] =
    {field_end, 1},
    {field_operator, 0},
  [20] =
    {field_body, 1},
  [21] =
    {field_begin, 0},
    {field_operator, 1},
  [23] =
    {field_arguments, 1},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [27] =
    {field_block, 1},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [31] =
    {field_arguments, 1},
    {field_method, 0},
  [33] =
    {field_block, 1},
    {field_method, 0},
  [35] =
    {field_key, 0},
  [36] =
    {field_name, 0},
  [37] =
    {field_body, 1, .inherited = true},
    {field_name, 0},
  [39] =
    {field_body, 2},
    {field_condition, 1},
  [41] =
    {field_value, 1},
  [42] =
    {field_clauses, 0},
  [43] =
    {field_alias, 2},
    {field_name, 1},
  [45] =
    {field_body, 2},
    {field_parameters, 1},
  [47] =
    {field_body, 0},
    {field_handler, 2},
  [49] =
    {field_body, 0},
    {field_condition, 2},
  [51] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [54] =
    {field_begin, 0},
    {field_end, 2},
    {field_operator, 1},
  [57] =
    {field_pattern, 2},
    {field_value, 0},
  [59] =
    {field_begin, 0, .inherited = true},
    {field_end, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [62] =
    {field_name, 0, .inherited = true},
    {field_scope, 0, .inherited = true},
  [64] =
    {field_object, 0},
  [65] =
    {field_method, 2},
    {field_operator, 1},
    {field_receiver, 0},
  [68] =
    {field_arguments, 2},
    {field_operator, 1},
    {field_receiver, 0},
  [71] =
    {field_name, 2},
    {field_scope, 0},
  [73] =
    {field_arguments, 1},
    {field_block, 2},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [78] =
    {field_left, 0},
    {field_right, 2},
  [80] =
    {field_arguments, 1},
    {field_block, 2},
    {field_method, 0},
  [83] =
    {field_key, 0},
    {field_value, 2},
  [85] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_object, 1},
    {field_parameters, 3, .inherited = true},
  [89] =
    {field_name, 0},
    {field_parameters, 1},
  [91] =
    {field_body, 2, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [94] =
    {field_body, 2},
    {field_name, 1},
  [96] =
    {field_condition, 1},
    {field_consequence, 2},
  [98] =
    {field_condition, 1},
  [99] =
    {field_body, 3},
    {field_pattern, 1},
    {field_value, 2},
  [102] =
    {field_value, 2},
  [103] =
    {field_body, 2},
    {field_pattern, 1},
  [105] =
    {field_pattern, 1},
  [106] =
    {field_clauses, 2, .inherited = true},
    {field_value, 1},
  [108] =
    {field_clauses, 0, .inherited = true},
    {field_clauses, 1, .inherited = true},
  [110] =
    {field_body, 2},
    {field_exceptions, 1},
  [112] =
    {field_exceptions, 1},
  [113] =
    {field_body, 2},
    {field_variable, 1},
  [115] =
    {field_variable, 1},
  [116] =
    {field_parameters, 1},
  [117] =
    {field_name, 0},
    {field_value, 2},
  [119] =
    {field_alternatives, 0},
    {field_alternatives, 1, .inherited = true},
  [121] =
    {field_block, 3},
    {field_object, 0},
  [123] =
    {field_arguments, 2},
    {field_block, 3},
    {field_operator, 1},
    {field_receiver, 0},
  [127] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [130] =
    {field_body, 2},
    {field_name, 0},
  [132] =
    {field_name, 1},
    {field_superclass, 2},
  [134] =
    {field_body, 3},
    {field_name, 1},
  [136] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [139] =
    {field_alternative, 3},
    {field_condition, 1},
  [141] =
    {field_clauses, 3, .inherited = true},
    {field_value, 2},
  [143] =
    {field_body, 3},
    {field_pattern, 1},
    {field_pattern, 2, .inherited = true},
  [146] =
    {field_pattern, 1},
    {field_pattern, 2, .inherited = true},
  [148] =
    {field_pattern, 0, .inherited = true},
    {field_pattern, 1, .inherited = true},
  [150] =
    {field_clauses, 3, .inherited = true},
    {field_value, 1},
  [152] =
    {field_clauses, 2, .inherited = true},
    {field_else, 3},
    {field_value, 1},
  [155] =
    {field_body, 3},
    {field_exceptions, 1},
    {field_variable, 2},
  [158] =
    {field_exceptions, 1},
    {field_variable, 2},
  [160] =
    {field_parameters, 2},
  [161] =
    {field_body, 2},
  [162] =
    {field_name, 2},
    {field_value, 0},
  [164] =
    {field_alternatives, 1},
  [165] =
    {field_alternatives, 0, .inherited = true},
    {field_alternatives, 1, .inherited = true},
  [167] =
    {field_class, 0},
  [168] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [171] =
    {field_block, 4},
    {field_object, 0},
  [173] =
    {field_body, 5, .inherited = true},
    {field_name, 5, .inherited = true},
    {field_object, 2},
    {field_parameters, 5, .inherited = true},
  [177] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 1},
  [180] =
    {field_body, 4},
    {field_value, 2},
  [182] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 2},
  [185] =
    {field_clauses, 4, .inherited = true},
    {field_value, 2},
  [187] =
    {field_clauses, 3, .inherited = true},
    {field_else, 4},
    {field_value, 2},
  [190] =
    {field_body, 3},
    {field_guard, 2},
    {field_pattern, 1},
  [193] =
    {field_guard, 2},
    {field_pattern, 1},
  [195] =
    {field_clauses, 3, .inherited = true},
    {field_else, 4},
    {field_value, 1},
  [198] =
    {field_locals, 2},
  [199] =
    {field_body, 3},
    {field_parameters, 1},
  [201] =
    {field_body, 3},
    {field_parameters, 2},
  [203] =
    {field_clauses, 4, .inherited = true},
    {field_else, 5},
    {field_value, 2},
  [206] =
    {field_locals, 3},
  [207] =
    {field_locals, 1},
  [208] =
    {field_locals, 2},
    {field_locals, 3, .inherited = true},
  [210] =
    {field_locals, 0, .inherited = true},
    {field_locals, 1, .inherited = true},
  [212] =
    {field_body, 4},
    {field_parameters, 2},
  [214] =
    {field_locals, 3},
    {field_locals, 4, .inherited = true},
  [216] =
    {field_locals, 4},
  [217] =
    {field_locals, 4},
    {field_locals, 5, .inherited = true},
  [219] =
    {field_locals, 5},
  [220] =
    {field_locals, 5},
    {field_locals, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = sym_call,
  },
  [3] = {
    [0] = sym_call,
  },
  [6] = {
    [0] = sym_constant,
  },
  [7] = {
    [0] = sym_identifier,
  },
  [8] = {
    [1] = sym__string_start,
  },
  [9] = {
    [1] = anon_sym_BQUOTE,
  },
  [10] = {
    [1] = anon_sym_SLASH,
  },
  [22] = {
    [0] = sym_rational,
  },
  [23] = {
    [2] = sym__string_start,
  },
  [24] = {
    [2] = anon_sym_BQUOTE,
  },
  [25] = {
    [2] = anon_sym_SLASH,
  },
  [26] = {
    [1] = alias_sym_bare_string,
  },
  [27] = {
    [1] = alias_sym_bare_symbol,
  },
  [29] = {
    [0] = sym_hash_key_symbol,
  },
  [36] = {
    [0] = alias_sym_destructured_parameter,
  },
  [37] = {
    [1] = alias_sym_lambda_parameters,
  },
  [43] = {
    [0] = sym_array_pattern,
  },
  [44] = {
    [0] = sym_find_pattern,
  },
  [45] = {
    [0] = sym_hash_pattern,
  },
  [55] = {
    [2] = alias_sym_bare_string,
  },
  [56] = {
    [2] = alias_sym_bare_symbol,
  },
  [58] = {
    [0] = sym_hash_key_symbol,
  },
  [77] = {
    [1] = sym_splat_parameter,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_parameters, 3,
    sym_parameters,
    alias_sym_destructured_parameter,
    alias_sym_lambda_parameters,
  sym_bare_parameters, 2,
    sym_parameters,
    alias_sym_lambda_parameters,
  sym__array_pattern_n, 2,
    sym__array_pattern_n,
    sym_array_pattern,
  sym__find_pattern_body, 2,
    sym__find_pattern_body,
    sym_find_pattern,
  sym__hash_pattern_body, 2,
    sym__hash_pattern_body,
    sym_hash_pattern,
  sym__call, 2,
    sym__call,
    sym_call,
  sym__chained_command_call, 2,
    sym__chained_command_call,
    sym_call,
  sym__int_or_float, 2,
    sym__int_or_float,
    sym_rational,
  sym_constant_suffix, 2,
    sym_hash_key_symbol,
    sym_constant,
  sym_identifier_suffix, 2,
    sym_hash_key_symbol,
    sym_identifier,
  aux_sym__literal_contents, 3,
    aux_sym__literal_contents,
    alias_sym_bare_string,
    alias_sym_bare_symbol,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 3,
  [6] = 2,
  [7] = 3,
  [8] = 3,
  [9] = 3,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 3,
  [14] = 3,
  [15] = 2,
  [16] = 3,
  [17] = 2,
  [18] = 2,
  [19] = 3,
  [20] = 2,
  [21] = 3,
  [22] = 3,
  [23] = 3,
  [24] = 2,
  [25] = 3,
  [26] = 2,
  [27] = 2,
  [28] = 2,
  [29] = 3,
  [30] = 2,
  [31] = 2,
  [32] = 3,
  [33] = 3,
  [34] = 3,
  [35] = 2,
  [36] = 3,
  [37] = 2,
  [38] = 3,
  [39] = 2,
  [40] = 2,
  [41] = 3,
  [42] = 42,
  [43] = 42,
  [44] = 42,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 45,
  [50] = 46,
  [51] = 47,
  [52] = 48,
  [53] = 42,
  [54] = 42,
  [55] = 42,
  [56] = 45,
  [57] = 47,
  [58] = 42,
  [59] = 48,
  [60] = 46,
  [61] = 42,
  [62] = 42,
  [63] = 46,
  [64] = 42,
  [65] = 42,
  [66] = 47,
  [67] = 42,
  [68] = 42,
  [69] = 48,
  [70] = 45,
  [71] = 42,
  [72] = 48,
  [73] = 47,
  [74] = 42,
  [75] = 42,
  [76] = 42,
  [77] = 42,
  [78] = 45,
  [79] = 46,
  [80] = 48,
  [81] = 47,
  [82] = 45,
  [83] = 46,
  [84] = 47,
  [85] = 48,
  [86] = 45,
  [87] = 46,
  [88] = 47,
  [89] = 48,
  [90] = 45,
  [91] = 46,
  [92] = 42,
  [93] = 47,
  [94] = 48,
  [95] = 45,
  [96] = 46,
  [97] = 45,
  [98] = 46,
  [99] = 47,
  [100] = 48,
  [101] = 46,
  [102] = 47,
  [103] = 48,
  [104] = 45,
  [105] = 46,
  [106] = 45,
  [107] = 47,
  [108] = 48,
  [109] = 42,
  [110] = 46,
  [111] = 45,
  [112] = 47,
  [113] = 48,
  [114] = 114,
  [115] = 114,
  [116] = 114,
  [117] = 114,
  [118] = 118,
  [119] = 118,
  [120] = 118,
  [121] = 118,
  [122] = 118,
  [123] = 123,
  [124] = 123,
  [125] = 123,
  [126] = 126,
  [127] = 127,
  [128] = 126,
  [129] = 127,
  [130] = 126,
  [131] = 127,
  [132] = 132,
  [133] = 132,
  [134] = 132,
  [135] = 135,
  [136] = 135,
  [137] = 135,
  [138] = 138,
  [139] = 135,
  [140] = 135,
  [141] = 138,
  [142] = 135,
  [143] = 135,
  [144] = 138,
  [145] = 135,
  [146] = 135,
  [147] = 135,
  [148] = 135,
  [149] = 135,
  [150] = 138,
  [151] = 138,
  [152] = 138,
  [153] = 135,
  [154] = 135,
  [155] = 135,
  [156] = 135,
  [157] = 135,
  [158] = 138,
  [159] = 135,
  [160] = 135,
  [161] = 135,
  [162] = 135,
  [163] = 138,
  [164] = 135,
  [165] = 138,
  [166] = 138,
  [167] = 135,
  [168] = 135,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 169,
  [173] = 170,
  [174] = 171,
  [175] = 169,
  [176] = 170,
  [177] = 171,
  [178] = 169,
  [179] = 170,
  [180] = 171,
  [181] = 169,
  [182] = 171,
  [183] = 169,
  [184] = 170,
  [185] = 171,
  [186] = 169,
  [187] = 170,
  [188] = 171,
  [189] = 169,
  [190] = 170,
  [191] = 171,
  [192] = 170,
  [193] = 171,
  [194] = 171,
  [195] = 169,
  [196] = 170,
  [197] = 169,
  [198] = 170,
  [199] = 199,
  [200] = 199,
  [201] = 199,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 203,
  [208] = 208,
  [209] = 209,
  [210] = 206,
  [211] = 208,
  [212] = 209,
  [213] = 205,
  [214] = 214,
  [215] = 204,
  [216] = 216,
  [217] = 205,
  [218] = 218,
  [219] = 204,
  [220] = 204,
  [221] = 202,
  [222] = 205,
  [223] = 205,
  [224] = 204,
  [225] = 205,
  [226] = 204,
  [227] = 206,
  [228] = 205,
  [229] = 208,
  [230] = 204,
  [231] = 209,
  [232] = 205,
  [233] = 214,
  [234] = 204,
  [235] = 216,
  [236] = 205,
  [237] = 218,
  [238] = 214,
  [239] = 216,
  [240] = 218,
  [241] = 204,
  [242] = 204,
  [243] = 205,
  [244] = 244,
  [245] = 203,
  [246] = 244,
  [247] = 244,
  [248] = 248,
  [249] = 249,
  [250] = 249,
  [251] = 249,
  [252] = 248,
  [253] = 249,
  [254] = 254,
  [255] = 249,
  [256] = 256,
  [257] = 249,
  [258] = 249,
  [259] = 249,
  [260] = 260,
  [261] = 203,
  [262] = 262,
  [263] = 202,
  [264] = 202,
  [265] = 265,
  [266] = 202,
  [267] = 265,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 269,
  [272] = 265,
  [273] = 269,
  [274] = 203,
  [275] = 203,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 276,
  [280] = 280,
  [281] = 202,
  [282] = 276,
  [283] = 203,
  [284] = 203,
  [285] = 285,
  [286] = 202,
  [287] = 287,
  [288] = 287,
  [289] = 287,
  [290] = 287,
  [291] = 287,
  [292] = 292,
  [293] = 287,
  [294] = 294,
  [295] = 287,
  [296] = 287,
  [297] = 297,
  [298] = 203,
  [299] = 287,
  [300] = 287,
  [301] = 301,
  [302] = 302,
  [303] = 203,
  [304] = 304,
  [305] = 203,
  [306] = 202,
  [307] = 202,
  [308] = 203,
  [309] = 203,
  [310] = 202,
  [311] = 248,
  [312] = 202,
  [313] = 203,
  [314] = 202,
  [315] = 202,
  [316] = 203,
  [317] = 256,
  [318] = 254,
  [319] = 319,
  [320] = 319,
  [321] = 319,
  [322] = 319,
  [323] = 202,
  [324] = 248,
  [325] = 203,
  [326] = 319,
  [327] = 319,
  [328] = 319,
  [329] = 203,
  [330] = 319,
  [331] = 319,
  [332] = 319,
  [333] = 203,
  [334] = 334,
  [335] = 335,
  [336] = 334,
  [337] = 335,
  [338] = 334,
  [339] = 334,
  [340] = 248,
  [341] = 334,
  [342] = 334,
  [343] = 343,
  [344] = 334,
  [345] = 334,
  [346] = 202,
  [347] = 334,
  [348] = 203,
  [349] = 334,
  [350] = 334,
  [351] = 351,
  [352] = 335,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 355,
  [357] = 343,
  [358] = 343,
  [359] = 334,
  [360] = 355,
  [361] = 203,
  [362] = 334,
  [363] = 248,
  [364] = 203,
  [365] = 202,
  [366] = 248,
  [367] = 202,
  [368] = 203,
  [369] = 248,
  [370] = 203,
  [371] = 203,
  [372] = 248,
  [373] = 203,
  [374] = 202,
  [375] = 203,
  [376] = 202,
  [377] = 248,
  [378] = 203,
  [379] = 202,
  [380] = 203,
  [381] = 381,
  [382] = 248,
  [383] = 203,
  [384] = 381,
  [385] = 248,
  [386] = 381,
  [387] = 202,
  [388] = 203,
  [389] = 202,
  [390] = 203,
  [391] = 203,
  [392] = 248,
  [393] = 203,
  [394] = 203,
  [395] = 202,
  [396] = 203,
  [397] = 202,
  [398] = 202,
  [399] = 203,
  [400] = 203,
  [401] = 203,
  [402] = 402,
  [403] = 403,
  [404] = 203,
  [405] = 405,
  [406] = 202,
  [407] = 405,
  [408] = 408,
  [409] = 402,
  [410] = 410,
  [411] = 408,
  [412] = 405,
  [413] = 408,
  [414] = 403,
  [415] = 402,
  [416] = 203,
  [417] = 403,
  [418] = 203,
  [419] = 202,
  [420] = 203,
  [421] = 203,
  [422] = 422,
  [423] = 423,
  [424] = 422,
  [425] = 202,
  [426] = 423,
  [427] = 422,
  [428] = 428,
  [429] = 429,
  [430] = 423,
  [431] = 203,
  [432] = 428,
  [433] = 433,
  [434] = 428,
  [435] = 423,
  [436] = 203,
  [437] = 423,
  [438] = 438,
  [439] = 423,
  [440] = 423,
  [441] = 441,
  [442] = 203,
  [443] = 443,
  [444] = 443,
  [445] = 443,
  [446] = 443,
  [447] = 443,
  [448] = 443,
  [449] = 443,
  [450] = 443,
  [451] = 443,
  [452] = 443,
  [453] = 443,
  [454] = 443,
  [455] = 443,
  [456] = 443,
  [457] = 457,
  [458] = 457,
  [459] = 457,
  [460] = 457,
  [461] = 457,
  [462] = 457,
  [463] = 457,
  [464] = 457,
  [465] = 457,
  [466] = 457,
  [467] = 457,
  [468] = 457,
  [469] = 457,
  [470] = 457,
  [471] = 457,
  [472] = 457,
  [473] = 457,
  [474] = 457,
  [475] = 457,
  [476] = 457,
  [477] = 457,
  [478] = 457,
  [479] = 457,
  [480] = 457,
  [481] = 457,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 484,
  [486] = 484,
  [487] = 484,
  [488] = 484,
  [489] = 484,
  [490] = 484,
  [491] = 202,
  [492] = 492,
  [493] = 484,
  [494] = 494,
  [495] = 484,
  [496] = 484,
  [497] = 484,
  [498] = 484,
  [499] = 484,
  [500] = 484,
  [501] = 484,
  [502] = 484,
  [503] = 484,
  [504] = 484,
  [505] = 484,
  [506] = 484,
  [507] = 484,
  [508] = 508,
  [509] = 484,
  [510] = 483,
  [511] = 482,
  [512] = 484,
  [513] = 484,
  [514] = 484,
  [515] = 508,
  [516] = 202,
  [517] = 494,
  [518] = 492,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 519,
  [523] = 519,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 520,
  [533] = 530,
  [534] = 531,
  [535] = 520,
  [536] = 521,
  [537] = 519,
  [538] = 521,
  [539] = 519,
  [540] = 531,
  [541] = 520,
  [542] = 521,
  [543] = 519,
  [544] = 530,
  [545] = 545,
  [546] = 531,
  [547] = 530,
  [548] = 531,
  [549] = 520,
  [550] = 521,
  [551] = 519,
  [552] = 531,
  [553] = 531,
  [554] = 520,
  [555] = 521,
  [556] = 519,
  [557] = 520,
  [558] = 521,
  [559] = 519,
  [560] = 530,
  [561] = 561,
  [562] = 529,
  [563] = 530,
  [564] = 524,
  [565] = 565,
  [566] = 566,
  [567] = 531,
  [568] = 530,
  [569] = 520,
  [570] = 521,
  [571] = 519,
  [572] = 525,
  [573] = 531,
  [574] = 520,
  [575] = 530,
  [576] = 521,
  [577] = 524,
  [578] = 525,
  [579] = 526,
  [580] = 527,
  [581] = 528,
  [582] = 529,
  [583] = 530,
  [584] = 519,
  [585] = 529,
  [586] = 526,
  [587] = 530,
  [588] = 527,
  [589] = 528,
  [590] = 529,
  [591] = 531,
  [592] = 520,
  [593] = 521,
  [594] = 519,
  [595] = 530,
  [596] = 530,
  [597] = 529,
  [598] = 520,
  [599] = 531,
  [600] = 520,
  [601] = 521,
  [602] = 519,
  [603] = 530,
  [604] = 521,
  [605] = 530,
  [606] = 531,
  [607] = 520,
  [608] = 521,
  [609] = 519,
  [610] = 531,
  [611] = 530,
  [612] = 530,
  [613] = 530,
  [614] = 530,
  [615] = 520,
  [616] = 521,
  [617] = 531,
  [618] = 520,
  [619] = 521,
  [620] = 519,
  [621] = 561,
  [622] = 531,
  [623] = 520,
  [624] = 521,
  [625] = 519,
  [626] = 519,
  [627] = 531,
  [628] = 531,
  [629] = 520,
  [630] = 521,
  [631] = 519,
  [632] = 520,
  [633] = 521,
  [634] = 519,
  [635] = 530,
  [636] = 531,
  [637] = 520,
  [638] = 521,
  [639] = 519,
  [640] = 519,
  [641] = 531,
  [642] = 520,
  [643] = 521,
  [644] = 531,
  [645] = 520,
  [646] = 530,
  [647] = 521,
  [648] = 519,
  [649] = 530,
  [650] = 531,
  [651] = 530,
  [652] = 520,
  [653] = 521,
  [654] = 531,
  [655] = 531,
  [656] = 520,
  [657] = 521,
  [658] = 519,
  [659] = 531,
  [660] = 520,
  [661] = 521,
  [662] = 519,
  [663] = 531,
  [664] = 520,
  [665] = 521,
  [666] = 519,
  [667] = 530,
  [668] = 530,
  [669] = 530,
  [670] = 483,
  [671] = 482,
  [672] = 672,
  [673] = 672,
  [674] = 672,
  [675] = 672,
  [676] = 672,
  [677] = 482,
  [678] = 492,
  [679] = 508,
  [680] = 680,
  [681] = 202,
  [682] = 483,
  [683] = 494,
  [684] = 202,
  [685] = 492,
  [686] = 508,
  [687] = 494,
  [688] = 688,
  [689] = 483,
  [690] = 482,
  [691] = 482,
  [692] = 483,
  [693] = 483,
  [694] = 482,
  [695] = 695,
  [696] = 695,
  [697] = 695,
  [698] = 508,
  [699] = 492,
  [700] = 695,
  [701] = 695,
  [702] = 695,
  [703] = 695,
  [704] = 483,
  [705] = 695,
  [706] = 483,
  [707] = 202,
  [708] = 494,
  [709] = 695,
  [710] = 482,
  [711] = 483,
  [712] = 494,
  [713] = 508,
  [714] = 202,
  [715] = 492,
  [716] = 482,
  [717] = 494,
  [718] = 695,
  [719] = 695,
  [720] = 695,
  [721] = 695,
  [722] = 508,
  [723] = 492,
  [724] = 695,
  [725] = 482,
  [726] = 202,
  [727] = 492,
  [728] = 492,
  [729] = 508,
  [730] = 202,
  [731] = 508,
  [732] = 494,
  [733] = 482,
  [734] = 492,
  [735] = 508,
  [736] = 202,
  [737] = 202,
  [738] = 494,
  [739] = 494,
  [740] = 483,
  [741] = 741,
  [742] = 742,
  [743] = 483,
  [744] = 744,
  [745] = 741,
  [746] = 202,
  [747] = 742,
  [748] = 742,
  [749] = 202,
  [750] = 492,
  [751] = 494,
  [752] = 508,
  [753] = 482,
  [754] = 741,
  [755] = 744,
  [756] = 744,
  [757] = 757,
  [758] = 757,
  [759] = 757,
  [760] = 757,
  [761] = 757,
  [762] = 757,
  [763] = 757,
  [764] = 757,
  [765] = 757,
  [766] = 757,
  [767] = 757,
  [768] = 757,
  [769] = 757,
  [770] = 757,
  [771] = 757,
  [772] = 757,
  [773] = 757,
  [774] = 757,
  [775] = 757,
  [776] = 494,
  [777] = 757,
  [778] = 757,
  [779] = 757,
  [780] = 757,
  [781] = 757,
  [782] = 757,
  [783] = 757,
  [784] = 757,
  [785] = 757,
  [786] = 757,
  [787] = 757,
  [788] = 757,
  [789] = 757,
  [790] = 757,
  [791] = 757,
  [792] = 757,
  [793] = 757,
  [794] = 757,
  [795] = 757,
  [796] = 757,
  [797] = 757,
  [798] = 757,
  [799] = 757,
  [800] = 757,
  [801] = 757,
  [802] = 757,
  [803] = 757,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 806,
  [808] = 808,
  [809] = 508,
  [810] = 202,
  [811] = 811,
  [812] = 811,
  [813] = 811,
  [814] = 811,
  [815] = 811,
  [816] = 811,
  [817] = 811,
  [818] = 811,
  [819] = 811,
  [820] = 811,
  [821] = 811,
  [822] = 811,
  [823] = 811,
  [824] = 811,
  [825] = 811,
  [826] = 811,
  [827] = 811,
  [828] = 806,
  [829] = 811,
  [830] = 811,
  [831] = 806,
  [832] = 811,
  [833] = 811,
  [834] = 811,
  [835] = 811,
  [836] = 811,
  [837] = 811,
  [838] = 811,
  [839] = 811,
  [840] = 811,
  [841] = 811,
  [842] = 842,
  [843] = 843,
  [844] = 842,
  [845] = 842,
  [846] = 842,
  [847] = 842,
  [848] = 842,
  [849] = 843,
  [850] = 842,
  [851] = 842,
  [852] = 842,
  [853] = 842,
  [854] = 843,
  [855] = 842,
  [856] = 842,
  [857] = 842,
  [858] = 842,
  [859] = 842,
  [860] = 842,
  [861] = 842,
  [862] = 843,
  [863] = 842,
  [864] = 842,
  [865] = 843,
  [866] = 842,
  [867] = 843,
  [868] = 842,
  [869] = 842,
  [870] = 842,
  [871] = 843,
  [872] = 842,
  [873] = 843,
  [874] = 842,
  [875] = 843,
  [876] = 842,
  [877] = 842,
  [878] = 842,
  [879] = 842,
  [880] = 843,
  [881] = 843,
  [882] = 843,
  [883] = 843,
  [884] = 843,
  [885] = 842,
  [886] = 842,
  [887] = 843,
  [888] = 842,
  [889] = 842,
  [890] = 843,
  [891] = 842,
  [892] = 842,
  [893] = 842,
  [894] = 842,
  [895] = 842,
  [896] = 842,
  [897] = 843,
  [898] = 842,
  [899] = 842,
  [900] = 843,
  [901] = 843,
  [902] = 843,
  [903] = 842,
  [904] = 842,
  [905] = 842,
  [906] = 843,
  [907] = 843,
  [908] = 842,
  [909] = 843,
  [910] = 842,
  [911] = 843,
  [912] = 912,
  [913] = 912,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 914,
  [928] = 928,
  [929] = 915,
  [930] = 916,
  [931] = 917,
  [932] = 918,
  [933] = 919,
  [934] = 934,
  [935] = 935,
  [936] = 920,
  [937] = 921,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 922,
  [946] = 924,
  [947] = 926,
  [948] = 923,
  [949] = 938,
  [950] = 939,
  [951] = 940,
  [952] = 941,
  [953] = 914,
  [954] = 915,
  [955] = 916,
  [956] = 917,
  [957] = 918,
  [958] = 919,
  [959] = 914,
  [960] = 915,
  [961] = 916,
  [962] = 917,
  [963] = 918,
  [964] = 919,
  [965] = 965,
  [966] = 920,
  [967] = 921,
  [968] = 922,
  [969] = 923,
  [970] = 965,
  [971] = 920,
  [972] = 925,
  [973] = 921,
  [974] = 922,
  [975] = 923,
  [976] = 928,
  [977] = 925,
  [978] = 942,
  [979] = 943,
  [980] = 944,
  [981] = 928,
  [982] = 938,
  [983] = 939,
  [984] = 940,
  [985] = 941,
  [986] = 935,
  [987] = 914,
  [988] = 915,
  [989] = 916,
  [990] = 917,
  [991] = 918,
  [992] = 919,
  [993] = 965,
  [994] = 920,
  [995] = 921,
  [996] = 922,
  [997] = 923,
  [998] = 925,
  [999] = 928,
  [1000] = 942,
  [1001] = 943,
  [1002] = 944,
  [1003] = 938,
  [1004] = 939,
  [1005] = 940,
  [1006] = 941,
  [1007] = 1007,
  [1008] = 914,
  [1009] = 915,
  [1010] = 916,
  [1011] = 917,
  [1012] = 918,
  [1013] = 919,
  [1014] = 920,
  [1015] = 921,
  [1016] = 922,
  [1017] = 923,
  [1018] = 925,
  [1019] = 942,
  [1020] = 943,
  [1021] = 944,
  [1022] = 938,
  [1023] = 939,
  [1024] = 940,
  [1025] = 941,
  [1026] = 942,
  [1027] = 914,
  [1028] = 915,
  [1029] = 916,
  [1030] = 917,
  [1031] = 918,
  [1032] = 919,
  [1033] = 920,
  [1034] = 921,
  [1035] = 922,
  [1036] = 923,
  [1037] = 925,
  [1038] = 943,
  [1039] = 944,
  [1040] = 942,
  [1041] = 944,
  [1042] = 925,
  [1043] = 938,
  [1044] = 928,
  [1045] = 939,
  [1046] = 940,
  [1047] = 941,
  [1048] = 938,
  [1049] = 939,
  [1050] = 940,
  [1051] = 941,
  [1052] = 924,
  [1053] = 926,
  [1054] = 914,
  [1055] = 915,
  [1056] = 916,
  [1057] = 938,
  [1058] = 939,
  [1059] = 940,
  [1060] = 941,
  [1061] = 917,
  [1062] = 918,
  [1063] = 919,
  [1064] = 965,
  [1065] = 920,
  [1066] = 921,
  [1067] = 922,
  [1068] = 923,
  [1069] = 914,
  [1070] = 915,
  [1071] = 916,
  [1072] = 917,
  [1073] = 918,
  [1074] = 919,
  [1075] = 920,
  [1076] = 921,
  [1077] = 922,
  [1078] = 923,
  [1079] = 925,
  [1080] = 925,
  [1081] = 928,
  [1082] = 928,
  [1083] = 912,
  [1084] = 935,
  [1085] = 942,
  [1086] = 943,
  [1087] = 944,
  [1088] = 1088,
  [1089] = 942,
  [1090] = 943,
  [1091] = 944,
  [1092] = 924,
  [1093] = 926,
  [1094] = 938,
  [1095] = 939,
  [1096] = 940,
  [1097] = 941,
  [1098] = 914,
  [1099] = 915,
  [1100] = 916,
  [1101] = 917,
  [1102] = 918,
  [1103] = 919,
  [1104] = 965,
  [1105] = 920,
  [1106] = 921,
  [1107] = 922,
  [1108] = 923,
  [1109] = 925,
  [1110] = 938,
  [1111] = 928,
  [1112] = 939,
  [1113] = 940,
  [1114] = 941,
  [1115] = 942,
  [1116] = 943,
  [1117] = 944,
  [1118] = 938,
  [1119] = 939,
  [1120] = 940,
  [1121] = 941,
  [1122] = 914,
  [1123] = 915,
  [1124] = 916,
  [1125] = 917,
  [1126] = 918,
  [1127] = 919,
  [1128] = 965,
  [1129] = 920,
  [1130] = 921,
  [1131] = 922,
  [1132] = 923,
  [1133] = 925,
  [1134] = 942,
  [1135] = 943,
  [1136] = 944,
  [1137] = 938,
  [1138] = 939,
  [1139] = 940,
  [1140] = 941,
  [1141] = 1007,
  [1142] = 914,
  [1143] = 915,
  [1144] = 916,
  [1145] = 917,
  [1146] = 918,
  [1147] = 919,
  [1148] = 965,
  [1149] = 920,
  [1150] = 921,
  [1151] = 922,
  [1152] = 923,
  [1153] = 925,
  [1154] = 942,
  [1155] = 943,
  [1156] = 944,
  [1157] = 938,
  [1158] = 939,
  [1159] = 940,
  [1160] = 941,
  [1161] = 914,
  [1162] = 915,
  [1163] = 916,
  [1164] = 917,
  [1165] = 918,
  [1166] = 919,
  [1167] = 920,
  [1168] = 921,
  [1169] = 922,
  [1170] = 923,
  [1171] = 925,
  [1172] = 942,
  [1173] = 944,
  [1174] = 1174,
  [1175] = 914,
  [1176] = 915,
  [1177] = 916,
  [1178] = 917,
  [1179] = 924,
  [1180] = 924,
  [1181] = 926,
  [1182] = 938,
  [1183] = 939,
  [1184] = 940,
  [1185] = 941,
  [1186] = 918,
  [1187] = 919,
  [1188] = 920,
  [1189] = 914,
  [1190] = 915,
  [1191] = 916,
  [1192] = 917,
  [1193] = 918,
  [1194] = 919,
  [1195] = 920,
  [1196] = 921,
  [1197] = 922,
  [1198] = 923,
  [1199] = 921,
  [1200] = 922,
  [1201] = 925,
  [1202] = 923,
  [1203] = 935,
  [1204] = 928,
  [1205] = 925,
  [1206] = 942,
  [1207] = 943,
  [1208] = 944,
  [1209] = 942,
  [1210] = 924,
  [1211] = 926,
  [1212] = 943,
  [1213] = 944,
  [1214] = 938,
  [1215] = 939,
  [1216] = 940,
  [1217] = 941,
  [1218] = 914,
  [1219] = 915,
  [1220] = 916,
  [1221] = 917,
  [1222] = 918,
  [1223] = 919,
  [1224] = 965,
  [1225] = 920,
  [1226] = 921,
  [1227] = 922,
  [1228] = 923,
  [1229] = 925,
  [1230] = 928,
  [1231] = 942,
  [1232] = 944,
  [1233] = 938,
  [1234] = 939,
  [1235] = 940,
  [1236] = 941,
  [1237] = 914,
  [1238] = 915,
  [1239] = 916,
  [1240] = 917,
  [1241] = 918,
  [1242] = 919,
  [1243] = 920,
  [1244] = 921,
  [1245] = 922,
  [1246] = 923,
  [1247] = 925,
  [1248] = 942,
  [1249] = 944,
  [1250] = 938,
  [1251] = 939,
  [1252] = 940,
  [1253] = 941,
  [1254] = 914,
  [1255] = 915,
  [1256] = 916,
  [1257] = 917,
  [1258] = 918,
  [1259] = 919,
  [1260] = 920,
  [1261] = 921,
  [1262] = 922,
  [1263] = 923,
  [1264] = 925,
  [1265] = 942,
  [1266] = 944,
  [1267] = 938,
  [1268] = 939,
  [1269] = 940,
  [1270] = 941,
  [1271] = 914,
  [1272] = 915,
  [1273] = 916,
  [1274] = 917,
  [1275] = 918,
  [1276] = 919,
  [1277] = 920,
  [1278] = 921,
  [1279] = 922,
  [1280] = 923,
  [1281] = 925,
  [1282] = 942,
  [1283] = 944,
  [1284] = 938,
  [1285] = 939,
  [1286] = 924,
  [1287] = 926,
  [1288] = 938,
  [1289] = 939,
  [1290] = 940,
  [1291] = 941,
  [1292] = 940,
  [1293] = 941,
  [1294] = 914,
  [1295] = 915,
  [1296] = 916,
  [1297] = 917,
  [1298] = 918,
  [1299] = 919,
  [1300] = 920,
  [1301] = 921,
  [1302] = 922,
  [1303] = 923,
  [1304] = 925,
  [1305] = 928,
  [1306] = 914,
  [1307] = 915,
  [1308] = 916,
  [1309] = 917,
  [1310] = 918,
  [1311] = 919,
  [1312] = 920,
  [1313] = 942,
  [1314] = 943,
  [1315] = 944,
  [1316] = 921,
  [1317] = 922,
  [1318] = 924,
  [1319] = 926,
  [1320] = 938,
  [1321] = 939,
  [1322] = 940,
  [1323] = 941,
  [1324] = 914,
  [1325] = 915,
  [1326] = 916,
  [1327] = 917,
  [1328] = 923,
  [1329] = 918,
  [1330] = 919,
  [1331] = 920,
  [1332] = 921,
  [1333] = 922,
  [1334] = 923,
  [1335] = 925,
  [1336] = 925,
  [1337] = 942,
  [1338] = 944,
  [1339] = 938,
  [1340] = 939,
  [1341] = 940,
  [1342] = 941,
  [1343] = 914,
  [1344] = 915,
  [1345] = 916,
  [1346] = 917,
  [1347] = 918,
  [1348] = 919,
  [1349] = 920,
  [1350] = 921,
  [1351] = 922,
  [1352] = 923,
  [1353] = 925,
  [1354] = 942,
  [1355] = 944,
  [1356] = 938,
  [1357] = 939,
  [1358] = 940,
  [1359] = 941,
  [1360] = 914,
  [1361] = 915,
  [1362] = 916,
  [1363] = 917,
  [1364] = 918,
  [1365] = 919,
  [1366] = 920,
  [1367] = 921,
  [1368] = 922,
  [1369] = 923,
  [1370] = 925,
  [1371] = 942,
  [1372] = 944,
  [1373] = 924,
  [1374] = 926,
  [1375] = 938,
  [1376] = 939,
  [1377] = 940,
  [1378] = 941,
  [1379] = 942,
  [1380] = 914,
  [1381] = 915,
  [1382] = 916,
  [1383] = 917,
  [1384] = 918,
  [1385] = 919,
  [1386] = 920,
  [1387] = 921,
  [1388] = 922,
  [1389] = 923,
  [1390] = 944,
  [1391] = 925,
  [1392] = 942,
  [1393] = 943,
  [1394] = 944,
  [1395] = 924,
  [1396] = 926,
  [1397] = 938,
  [1398] = 939,
  [1399] = 940,
  [1400] = 941,
  [1401] = 914,
  [1402] = 915,
  [1403] = 916,
  [1404] = 917,
  [1405] = 918,
  [1406] = 919,
  [1407] = 965,
  [1408] = 920,
  [1409] = 921,
  [1410] = 922,
  [1411] = 923,
  [1412] = 925,
  [1413] = 938,
  [1414] = 942,
  [1415] = 944,
  [1416] = 938,
  [1417] = 939,
  [1418] = 940,
  [1419] = 941,
  [1420] = 914,
  [1421] = 915,
  [1422] = 916,
  [1423] = 917,
  [1424] = 918,
  [1425] = 919,
  [1426] = 920,
  [1427] = 921,
  [1428] = 922,
  [1429] = 923,
  [1430] = 925,
  [1431] = 942,
  [1432] = 944,
  [1433] = 938,
  [1434] = 939,
  [1435] = 940,
  [1436] = 941,
  [1437] = 914,
  [1438] = 915,
  [1439] = 916,
  [1440] = 917,
  [1441] = 918,
  [1442] = 919,
  [1443] = 920,
  [1444] = 921,
  [1445] = 922,
  [1446] = 923,
  [1447] = 925,
  [1448] = 942,
  [1449] = 944,
  [1450] = 924,
  [1451] = 926,
  [1452] = 938,
  [1453] = 939,
  [1454] = 940,
  [1455] = 941,
  [1456] = 914,
  [1457] = 915,
  [1458] = 916,
  [1459] = 917,
  [1460] = 918,
  [1461] = 919,
  [1462] = 920,
  [1463] = 921,
  [1464] = 922,
  [1465] = 923,
  [1466] = 925,
  [1467] = 942,
  [1468] = 943,
  [1469] = 944,
  [1470] = 924,
  [1471] = 926,
  [1472] = 938,
  [1473] = 940,
  [1474] = 941,
  [1475] = 914,
  [1476] = 915,
  [1477] = 916,
  [1478] = 917,
  [1479] = 918,
  [1480] = 919,
  [1481] = 920,
  [1482] = 921,
  [1483] = 922,
  [1484] = 923,
  [1485] = 925,
  [1486] = 942,
  [1487] = 944,
  [1488] = 938,
  [1489] = 939,
  [1490] = 940,
  [1491] = 941,
  [1492] = 914,
  [1493] = 915,
  [1494] = 916,
  [1495] = 917,
  [1496] = 918,
  [1497] = 919,
  [1498] = 920,
  [1499] = 921,
  [1500] = 922,
  [1501] = 923,
  [1502] = 925,
  [1503] = 942,
  [1504] = 944,
  [1505] = 924,
  [1506] = 926,
  [1507] = 938,
  [1508] = 939,
  [1509] = 940,
  [1510] = 941,
  [1511] = 914,
  [1512] = 915,
  [1513] = 916,
  [1514] = 917,
  [1515] = 918,
  [1516] = 919,
  [1517] = 920,
  [1518] = 921,
  [1519] = 922,
  [1520] = 923,
  [1521] = 925,
  [1522] = 926,
  [1523] = 942,
  [1524] = 944,
  [1525] = 924,
  [1526] = 926,
  [1527] = 938,
  [1528] = 939,
  [1529] = 940,
  [1530] = 941,
  [1531] = 914,
  [1532] = 915,
  [1533] = 916,
  [1534] = 917,
  [1535] = 918,
  [1536] = 919,
  [1537] = 920,
  [1538] = 921,
  [1539] = 922,
  [1540] = 923,
  [1541] = 925,
  [1542] = 942,
  [1543] = 944,
  [1544] = 938,
  [1545] = 939,
  [1546] = 940,
  [1547] = 941,
  [1548] = 914,
  [1549] = 915,
  [1550] = 916,
  [1551] = 917,
  [1552] = 918,
  [1553] = 919,
  [1554] = 920,
  [1555] = 921,
  [1556] = 922,
  [1557] = 923,
  [1558] = 925,
  [1559] = 942,
  [1560] = 944,
  [1561] = 924,
  [1562] = 926,
  [1563] = 938,
  [1564] = 939,
  [1565] = 940,
  [1566] = 941,
  [1567] = 914,
  [1568] = 915,
  [1569] = 916,
  [1570] = 917,
  [1571] = 918,
  [1572] = 919,
  [1573] = 920,
  [1574] = 921,
  [1575] = 922,
  [1576] = 923,
  [1577] = 925,
  [1578] = 942,
  [1579] = 944,
  [1580] = 924,
  [1581] = 926,
  [1582] = 938,
  [1583] = 939,
  [1584] = 940,
  [1585] = 941,
  [1586] = 914,
  [1587] = 915,
  [1588] = 916,
  [1589] = 917,
  [1590] = 918,
  [1591] = 919,
  [1592] = 920,
  [1593] = 921,
  [1594] = 922,
  [1595] = 923,
  [1596] = 925,
  [1597] = 942,
  [1598] = 944,
  [1599] = 924,
  [1600] = 926,
  [1601] = 938,
  [1602] = 939,
  [1603] = 940,
  [1604] = 941,
  [1605] = 914,
  [1606] = 915,
  [1607] = 916,
  [1608] = 917,
  [1609] = 918,
  [1610] = 919,
  [1611] = 920,
  [1612] = 921,
  [1613] = 922,
  [1614] = 923,
  [1615] = 925,
  [1616] = 942,
  [1617] = 944,
  [1618] = 924,
  [1619] = 926,
  [1620] = 938,
  [1621] = 939,
  [1622] = 940,
  [1623] = 941,
  [1624] = 914,
  [1625] = 915,
  [1626] = 916,
  [1627] = 917,
  [1628] = 918,
  [1629] = 919,
  [1630] = 920,
  [1631] = 921,
  [1632] = 922,
  [1633] = 923,
  [1634] = 925,
  [1635] = 942,
  [1636] = 944,
  [1637] = 924,
  [1638] = 926,
  [1639] = 939,
  [1640] = 940,
  [1641] = 941,
  [1642] = 914,
  [1643] = 915,
  [1644] = 916,
  [1645] = 917,
  [1646] = 918,
  [1647] = 919,
  [1648] = 920,
  [1649] = 921,
  [1650] = 922,
  [1651] = 923,
  [1652] = 925,
  [1653] = 942,
  [1654] = 944,
  [1655] = 924,
  [1656] = 926,
  [1657] = 944,
  [1658] = 924,
  [1659] = 926,
  [1660] = 939,
  [1661] = 940,
  [1662] = 941,
  [1663] = 914,
  [1664] = 915,
  [1665] = 916,
  [1666] = 917,
  [1667] = 918,
  [1668] = 919,
  [1669] = 920,
  [1670] = 921,
  [1671] = 922,
  [1672] = 923,
  [1673] = 925,
  [1674] = 942,
  [1675] = 944,
  [1676] = 924,
  [1677] = 926,
  [1678] = 924,
  [1679] = 926,
  [1680] = 939,
  [1681] = 940,
  [1682] = 941,
  [1683] = 914,
  [1684] = 915,
  [1685] = 916,
  [1686] = 917,
  [1687] = 918,
  [1688] = 919,
  [1689] = 920,
  [1690] = 921,
  [1691] = 922,
  [1692] = 923,
  [1693] = 925,
  [1694] = 942,
  [1695] = 944,
  [1696] = 924,
  [1697] = 926,
  [1698] = 942,
  [1699] = 924,
  [1700] = 926,
  [1701] = 939,
  [1702] = 940,
  [1703] = 941,
  [1704] = 914,
  [1705] = 915,
  [1706] = 916,
  [1707] = 917,
  [1708] = 918,
  [1709] = 919,
  [1710] = 920,
  [1711] = 921,
  [1712] = 922,
  [1713] = 923,
  [1714] = 925,
  [1715] = 942,
  [1716] = 944,
  [1717] = 924,
  [1718] = 926,
  [1719] = 924,
  [1720] = 926,
  [1721] = 943,
  [1722] = 944,
  [1723] = 924,
  [1724] = 926,
  [1725] = 924,
  [1726] = 926,
  [1727] = 924,
  [1728] = 926,
  [1729] = 924,
  [1730] = 926,
  [1731] = 924,
  [1732] = 926,
  [1733] = 924,
  [1734] = 926,
  [1735] = 924,
  [1736] = 926,
  [1737] = 924,
  [1738] = 926,
  [1739] = 924,
  [1740] = 926,
  [1741] = 926,
  [1742] = 924,
  [1743] = 926,
  [1744] = 926,
  [1745] = 924,
  [1746] = 926,
  [1747] = 938,
  [1748] = 934,
  [1749] = 924,
  [1750] = 924,
  [1751] = 938,
  [1752] = 938,
  [1753] = 938,
  [1754] = 934,
  [1755] = 934,
  [1756] = 934,
  [1757] = 934,
  [1758] = 934,
  [1759] = 934,
  [1760] = 934,
  [1761] = 934,
  [1762] = 934,
  [1763] = 934,
  [1764] = 934,
  [1765] = 934,
  [1766] = 934,
  [1767] = 934,
  [1768] = 934,
  [1769] = 934,
  [1770] = 934,
  [1771] = 934,
  [1772] = 934,
  [1773] = 934,
  [1774] = 934,
  [1775] = 934,
  [1776] = 934,
  [1777] = 934,
  [1778] = 934,
  [1779] = 934,
  [1780] = 934,
  [1781] = 1174,
  [1782] = 934,
  [1783] = 928,
  [1784] = 938,
  [1785] = 939,
  [1786] = 940,
  [1787] = 941,
  [1788] = 914,
  [1789] = 915,
  [1790] = 916,
  [1791] = 917,
  [1792] = 918,
  [1793] = 919,
  [1794] = 920,
  [1795] = 921,
  [1796] = 922,
  [1797] = 923,
  [1798] = 925,
  [1799] = 942,
  [1800] = 926,
  [1801] = 944,
  [1802] = 938,
  [1803] = 914,
  [1804] = 915,
  [1805] = 916,
  [1806] = 917,
  [1807] = 918,
  [1808] = 919,
  [1809] = 920,
  [1810] = 921,
  [1811] = 922,
  [1812] = 923,
  [1813] = 925,
  [1814] = 942,
  [1815] = 943,
  [1816] = 939,
  [1817] = 940,
  [1818] = 941,
  [1819] = 938,
  [1820] = 939,
  [1821] = 940,
  [1822] = 941,
  [1823] = 914,
  [1824] = 915,
  [1825] = 916,
  [1826] = 917,
  [1827] = 918,
  [1828] = 919,
  [1829] = 920,
  [1830] = 921,
  [1831] = 922,
  [1832] = 923,
  [1833] = 925,
  [1834] = 942,
  [1835] = 944,
  [1836] = 944,
  [1837] = 924,
  [1838] = 924,
  [1839] = 926,
  [1840] = 939,
  [1841] = 940,
  [1842] = 941,
  [1843] = 914,
  [1844] = 915,
  [1845] = 916,
  [1846] = 917,
  [1847] = 918,
  [1848] = 919,
  [1849] = 920,
  [1850] = 921,
  [1851] = 922,
  [1852] = 923,
  [1853] = 925,
  [1854] = 942,
  [1855] = 944,
  [1856] = 924,
  [1857] = 926,
  [1858] = 926,
  [1859] = 924,
  [1860] = 926,
  [1861] = 924,
  [1862] = 938,
  [1863] = 934,
  [1864] = 934,
  [1865] = 1174,
  [1866] = 934,
  [1867] = 934,
  [1868] = 934,
  [1869] = 934,
  [1870] = 934,
  [1871] = 934,
  [1872] = 934,
  [1873] = 934,
  [1874] = 934,
  [1875] = 934,
  [1876] = 934,
  [1877] = 934,
  [1878] = 934,
  [1879] = 934,
  [1880] = 912,
  [1881] = 938,
  [1882] = 939,
  [1883] = 940,
  [1884] = 941,
  [1885] = 912,
  [1886] = 912,
  [1887] = 912,
  [1888] = 912,
  [1889] = 912,
  [1890] = 912,
  [1891] = 912,
  [1892] = 912,
  [1893] = 912,
  [1894] = 912,
  [1895] = 912,
  [1896] = 912,
  [1897] = 912,
  [1898] = 912,
  [1899] = 912,
  [1900] = 912,
  [1901] = 912,
  [1902] = 912,
  [1903] = 912,
  [1904] = 912,
  [1905] = 939,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1908,
  [1909] = 1909,
  [1910] = 1906,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 1913,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1007,
  [1918] = 1007,
  [1919] = 1913,
  [1920] = 1907,
  [1921] = 1909,
  [1922] = 1908,
  [1923] = 1906,
  [1924] = 1906,
  [1925] = 1912,
  [1926] = 1915,
  [1927] = 1911,
  [1928] = 1914,
  [1929] = 1929,
  [1930] = 1007,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1007,
  [1934] = 1916,
  [1935] = 1007,
  [1936] = 1906,
  [1937] = 1906,
  [1938] = 1007,
  [1939] = 1007,
  [1940] = 1007,
  [1941] = 1906,
  [1942] = 1007,
  [1943] = 1943,
  [1944] = 1007,
  [1945] = 1906,
  [1946] = 1907,
  [1947] = 1912,
  [1948] = 1915,
  [1949] = 1906,
  [1950] = 1911,
  [1951] = 1914,
  [1952] = 1913,
  [1953] = 1908,
  [1954] = 1909,
  [1955] = 1007,
  [1956] = 1956,
  [1957] = 1916,
  [1958] = 1932,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1914,
  [1963] = 1963,
  [1964] = 1911,
  [1965] = 1961,
  [1966] = 1966,
  [1967] = 1963,
  [1968] = 1966,
  [1969] = 1961,
  [1970] = 1970,
  [1971] = 1912,
  [1972] = 1915,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1974,
  [1976] = 1974,
  [1977] = 1911,
  [1978] = 1978,
  [1979] = 1978,
  [1980] = 1980,
  [1981] = 1914,
  [1982] = 1978,
  [1983] = 1963,
  [1984] = 1966,
  [1985] = 1966,
  [1986] = 1963,
  [1987] = 1915,
  [1988] = 1912,
  [1989] = 1963,
  [1990] = 1966,
  [1991] = 1911,
  [1992] = 1966,
  [1993] = 1966,
  [1994] = 1963,
  [1995] = 1963,
  [1996] = 1963,
  [1997] = 1966,
  [1998] = 1966,
  [1999] = 1963,
  [2000] = 1914,
  [2001] = 1966,
  [2002] = 1963,
  [2003] = 1963,
  [2004] = 1966,
  [2005] = 1912,
  [2006] = 1915,
  [2007] = 1966,
  [2008] = 1963,
  [2009] = 1966,
  [2010] = 1963,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2015,
  [2017] = 2014,
  [2018] = 2018,
  [2019] = 2018,
  [2020] = 2018,
  [2021] = 2021,
  [2022] = 2018,
  [2023] = 2021,
  [2024] = 2018,
  [2025] = 2021,
  [2026] = 2021,
  [2027] = 2021,
  [2028] = 2028,
  [2029] = 2011,
  [2030] = 2012,
  [2031] = 1907,
  [2032] = 2013,
  [2033] = 1915,
  [2034] = 1912,
  [2035] = 2035,
  [2036] = 1914,
  [2037] = 1911,
  [2038] = 2011,
  [2039] = 1906,
  [2040] = 2040,
  [2041] = 2011,
  [2042] = 2042,
  [2043] = 2043,
  [2044] = 2042,
  [2045] = 2040,
  [2046] = 2011,
  [2047] = 2013,
  [2048] = 2048,
  [2049] = 2012,
  [2050] = 2050,
  [2051] = 1911,
  [2052] = 2035,
  [2053] = 1914,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2054,
  [2057] = 1912,
  [2058] = 1915,
  [2059] = 2059,
  [2060] = 1907,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 2061,
  [2064] = 1911,
  [2065] = 2012,
  [2066] = 1914,
  [2067] = 2013,
  [2068] = 1906,
  [2069] = 1913,
  [2070] = 1909,
  [2071] = 2071,
  [2072] = 1915,
  [2073] = 2012,
  [2074] = 1906,
  [2075] = 2013,
  [2076] = 1932,
  [2077] = 1907,
  [2078] = 1908,
  [2079] = 1912,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 2050,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2090,
  [2099] = 2099,
  [2100] = 2100,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 1915,
  [2106] = 1911,
  [2107] = 1907,
  [2108] = 2108,
  [2109] = 1914,
  [2110] = 2110,
  [2111] = 2035,
  [2112] = 2112,
  [2113] = 1912,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2114,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2114,
  [2131] = 2055,
  [2132] = 2062,
  [2133] = 2114,
  [2134] = 2134,
  [2135] = 2118,
  [2136] = 2134,
  [2137] = 2118,
  [2138] = 2114,
  [2139] = 2134,
  [2140] = 2118,
  [2141] = 2134,
  [2142] = 2043,
  [2143] = 2114,
  [2144] = 2134,
  [2145] = 2059,
  [2146] = 2071,
  [2147] = 2127,
  [2148] = 2148,
  [2149] = 2123,
  [2150] = 2115,
  [2151] = 2120,
  [2152] = 2124,
  [2153] = 2125,
  [2154] = 2116,
  [2155] = 2121,
  [2156] = 2126,
  [2157] = 2129,
  [2158] = 2148,
  [2159] = 2119,
  [2160] = 2148,
  [2161] = 2161,
  [2162] = 2161,
  [2163] = 2122,
  [2164] = 2148,
  [2165] = 2148,
  [2166] = 2166,
  [2167] = 2118,
  [2168] = 2108,
  [2169] = 2071,
  [2170] = 2114,
  [2171] = 2114,
  [2172] = 2042,
  [2173] = 2040,
  [2174] = 2108,
  [2175] = 2118,
  [2176] = 2118,
  [2177] = 1932,
  [2178] = 2118,
  [2179] = 2114,
  [2180] = 2054,
  [2181] = 2061,
  [2182] = 2048,
  [2183] = 2114,
  [2184] = 2114,
  [2185] = 2114,
  [2186] = 1932,
  [2187] = 1906,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2188,
  [2191] = 2188,
  [2192] = 2054,
  [2193] = 2189,
  [2194] = 2061,
  [2195] = 2188,
  [2196] = 2188,
  [2197] = 2048,
  [2198] = 2198,
  [2199] = 1908,
  [2200] = 1913,
  [2201] = 2118,
  [2202] = 1906,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2114,
  [2206] = 1907,
  [2207] = 2207,
  [2208] = 2042,
  [2209] = 1912,
  [2210] = 2040,
  [2211] = 2118,
  [2212] = 2114,
  [2213] = 2114,
  [2214] = 1915,
  [2215] = 2114,
  [2216] = 1911,
  [2217] = 1914,
  [2218] = 2218,
  [2219] = 1909,
  [2220] = 2118,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 1914,
  [2225] = 2071,
  [2226] = 2226,
  [2227] = 2094,
  [2228] = 2095,
  [2229] = 2084,
  [2230] = 2097,
  [2231] = 2221,
  [2232] = 2099,
  [2233] = 2100,
  [2234] = 2050,
  [2235] = 2235,
  [2236] = 2082,
  [2237] = 2089,
  [2238] = 2086,
  [2239] = 2223,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2091,
  [2244] = 2092,
  [2245] = 2096,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2101,
  [2249] = 2102,
  [2250] = 2071,
  [2251] = 2093,
  [2252] = 2087,
  [2253] = 2253,
  [2254] = 2081,
  [2255] = 2085,
  [2256] = 2241,
  [2257] = 2088,
  [2258] = 2080,
  [2259] = 1911,
  [2260] = 2048,
  [2261] = 2103,
  [2262] = 2084,
  [2263] = 2118,
  [2264] = 2264,
  [2265] = 1915,
  [2266] = 2071,
  [2267] = 2267,
  [2268] = 1912,
  [2269] = 2269,
  [2270] = 2166,
  [2271] = 2054,
  [2272] = 2061,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2114,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 1932,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2114,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2094,
  [2302] = 2114,
  [2303] = 2089,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2118,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2108,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2103,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2101,
  [2355] = 2355,
  [2356] = 2114,
  [2357] = 2091,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2092,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2376,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2102,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2114,
  [2389] = 2389,
  [2390] = 2311,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2093,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2108,
  [2401] = 2081,
  [2402] = 2402,
  [2403] = 2087,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2088,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2114,
  [2411] = 2411,
  [2412] = 2080,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2311,
  [2416] = 2416,
  [2417] = 1906,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2095,
  [2428] = 2097,
  [2429] = 2099,
  [2430] = 2100,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2435,
  [2436] = 2118,
  [2437] = 2437,
  [2438] = 2438,
  [2439] = 2438,
  [2440] = 2084,
  [2441] = 2108,
  [2442] = 2438,
  [2443] = 1929,
  [2444] = 2114,
  [2445] = 2118,
  [2446] = 2118,
  [2447] = 2438,
  [2448] = 2118,
  [2449] = 2438,
  [2450] = 2264,
  [2451] = 2114,
  [2452] = 2438,
  [2453] = 2438,
  [2454] = 2438,
  [2455] = 2438,
  [2456] = 2438,
  [2457] = 2438,
  [2458] = 2114,
  [2459] = 2438,
  [2460] = 2114,
  [2461] = 2438,
  [2462] = 2438,
  [2463] = 2118,
  [2464] = 2438,
  [2465] = 2438,
  [2466] = 2438,
  [2467] = 2438,
  [2468] = 2438,
  [2469] = 2438,
  [2470] = 2438,
  [2471] = 2438,
  [2472] = 2438,
  [2473] = 2438,
  [2474] = 2048,
  [2475] = 1932,
  [2476] = 2399,
  [2477] = 2114,
  [2478] = 2478,
  [2479] = 2114,
  [2480] = 2118,
  [2481] = 2118,
  [2482] = 2482,
  [2483] = 2118,
  [2484] = 2114,
  [2485] = 2114,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2114,
  [2492] = 2118,
  [2493] = 2118,
  [2494] = 2118,
  [2495] = 2399,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2496,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2114,
  [2517] = 1931,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 2520,
  [2521] = 1007,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 2114,
  [2525] = 2486,
  [2526] = 2166,
  [2527] = 2478,
  [2528] = 2264,
  [2529] = 2114,
  [2530] = 2364,
  [2531] = 2114,
  [2532] = 2298,
  [2533] = 2488,
  [2534] = 2114,
  [2535] = 2114,
  [2536] = 2486,
  [2537] = 2297,
  [2538] = 2487,
  [2539] = 2114,
  [2540] = 2287,
  [2541] = 2355,
  [2542] = 2437,
  [2543] = 2346,
  [2544] = 2118,
  [2545] = 2478,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2546,
  [2549] = 2547,
  [2550] = 2546,
  [2551] = 2547,
  [2552] = 2546,
  [2553] = 2546,
  [2554] = 2547,
  [2555] = 2508,
  [2556] = 2509,
  [2557] = 2510,
  [2558] = 2511,
  [2559] = 2513,
  [2560] = 2546,
  [2561] = 2546,
  [2562] = 2547,
  [2563] = 2399,
  [2564] = 2518,
  [2565] = 2546,
  [2566] = 2547,
  [2567] = 2547,
  [2568] = 2519,
  [2569] = 2546,
  [2570] = 2547,
  [2571] = 2546,
  [2572] = 2547,
  [2573] = 2114,
  [2574] = 2114,
  [2575] = 2520,
  [2576] = 2496,
  [2577] = 2522,
  [2578] = 2546,
  [2579] = 2547,
  [2580] = 2497,
  [2581] = 2498,
  [2582] = 2499,
  [2583] = 2500,
  [2584] = 2501,
  [2585] = 2502,
  [2586] = 2503,
  [2587] = 2504,
  [2588] = 2505,
  [2589] = 2523,
  [2590] = 2507,
  [2591] = 2490,
  [2592] = 2546,
  [2593] = 2547,
  [2594] = 2546,
  [2595] = 2546,
  [2596] = 2546,
  [2597] = 2547,
  [2598] = 2269,
  [2599] = 2546,
  [2600] = 2547,
  [2601] = 2546,
  [2602] = 2547,
  [2603] = 2547,
  [2604] = 2547,
  [2605] = 2114,
  [2606] = 2546,
  [2607] = 2496,
  [2608] = 2547,
  [2609] = 2514,
  [2610] = 2546,
  [2611] = 2547,
  [2612] = 2084,
  [2613] = 2515,
  [2614] = 2546,
  [2615] = 2546,
  [2616] = 2547,
  [2617] = 2546,
  [2618] = 2547,
  [2619] = 2547,
  [2620] = 2547,
  [2621] = 2546,
  [2622] = 2547,
  [2623] = 2546,
  [2624] = 2547,
  [2625] = 2114,
  [2626] = 2626,
  [2627] = 2166,
  [2628] = 2519,
  [2629] = 2629,
  [2630] = 2498,
  [2631] = 2499,
  [2632] = 2500,
  [2633] = 2501,
  [2634] = 2502,
  [2635] = 2503,
  [2636] = 2504,
  [2637] = 2505,
  [2638] = 2523,
  [2639] = 2507,
  [2640] = 2640,
  [2641] = 2522,
  [2642] = 2264,
  [2643] = 2490,
  [2644] = 2508,
  [2645] = 2645,
  [2646] = 2497,
  [2647] = 2518,
  [2648] = 2629,
  [2649] = 2509,
  [2650] = 2513,
  [2651] = 2478,
  [2652] = 2114,
  [2653] = 2114,
  [2654] = 2496,
  [2655] = 2655,
  [2656] = 2520,
  [2657] = 2496,
  [2658] = 2626,
  [2659] = 2510,
  [2660] = 2114,
  [2661] = 2511,
  [2662] = 2488,
  [2663] = 2486,
  [2664] = 2487,
  [2665] = 2645,
  [2666] = 2114,
  [2667] = 2655,
  [2668] = 2166,
  [2669] = 2478,
  [2670] = 2497,
  [2671] = 2487,
  [2672] = 2515,
  [2673] = 2520,
  [2674] = 2519,
  [2675] = 2675,
  [2676] = 2676,
  [2677] = 2522,
  [2678] = 2488,
  [2679] = 2679,
  [2680] = 2513,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 2508,
  [2684] = 2498,
  [2685] = 2514,
  [2686] = 2499,
  [2687] = 2500,
  [2688] = 2501,
  [2689] = 2502,
  [2690] = 2503,
  [2691] = 2504,
  [2692] = 2505,
  [2693] = 2523,
  [2694] = 2507,
  [2695] = 2509,
  [2696] = 2490,
  [2697] = 2510,
  [2698] = 2698,
  [2699] = 2511,
  [2700] = 2700,
  [2701] = 2486,
  [2702] = 2502,
  [2703] = 2498,
  [2704] = 2508,
  [2705] = 2499,
  [2706] = 2518,
  [2707] = 2478,
  [2708] = 2486,
  [2709] = 2487,
  [2710] = 2640,
  [2711] = 2488,
  [2712] = 2500,
  [2713] = 2478,
  [2714] = 2489,
  [2715] = 2482,
  [2716] = 2501,
  [2717] = 2717,
  [2718] = 2515,
  [2719] = 2505,
  [2720] = 2720,
  [2721] = 2721,
  [2722] = 2496,
  [2723] = 2496,
  [2724] = 2264,
  [2725] = 2519,
  [2726] = 2486,
  [2727] = 2520,
  [2728] = 2522,
  [2729] = 2189,
  [2730] = 2513,
  [2731] = 2507,
  [2732] = 2732,
  [2733] = 2510,
  [2734] = 2490,
  [2735] = 2523,
  [2736] = 2509,
  [2737] = 2503,
  [2738] = 2511,
  [2739] = 2497,
  [2740] = 2640,
  [2741] = 2514,
  [2742] = 2504,
  [2743] = 2743,
  [2744] = 2399,
  [2745] = 2514,
  [2746] = 2679,
  [2747] = 2498,
  [2748] = 2499,
  [2749] = 2500,
  [2750] = 2501,
  [2751] = 2502,
  [2752] = 2503,
  [2753] = 2504,
  [2754] = 2505,
  [2755] = 2523,
  [2756] = 2507,
  [2757] = 2490,
  [2758] = 2487,
  [2759] = 2486,
  [2760] = 2218,
  [2761] = 2681,
  [2762] = 2488,
  [2763] = 2700,
  [2764] = 2698,
  [2765] = 2497,
  [2766] = 2508,
  [2767] = 2509,
  [2768] = 2510,
  [2769] = 2511,
  [2770] = 2522,
  [2771] = 2513,
  [2772] = 2520,
  [2773] = 2264,
  [2774] = 2519,
  [2775] = 2675,
  [2776] = 2676,
  [2777] = 2478,
  [2778] = 2515,
  [2779] = 2269,
  [2780] = 2478,
  [2781] = 2486,
  [2782] = 2242,
  [2783] = 2203,
  [2784] = 2508,
  [2785] = 2221,
  [2786] = 2509,
  [2787] = 2514,
  [2788] = 2700,
  [2789] = 2510,
  [2790] = 2511,
  [2791] = 2515,
  [2792] = 2513,
  [2793] = 2698,
  [2794] = 2497,
  [2795] = 2518,
  [2796] = 2519,
  [2797] = 2520,
  [2798] = 2522,
  [2799] = 2496,
  [2800] = 2207,
  [2801] = 2720,
  [2802] = 2497,
  [2803] = 2498,
  [2804] = 2499,
  [2805] = 2500,
  [2806] = 2501,
  [2807] = 2502,
  [2808] = 2503,
  [2809] = 2504,
  [2810] = 2505,
  [2811] = 2523,
  [2812] = 2507,
  [2813] = 2490,
  [2814] = 2520,
  [2815] = 2247,
  [2816] = 2681,
  [2817] = 2498,
  [2818] = 2204,
  [2819] = 2499,
  [2820] = 2500,
  [2821] = 2501,
  [2822] = 2502,
  [2823] = 2503,
  [2824] = 2504,
  [2825] = 2505,
  [2826] = 2523,
  [2827] = 2507,
  [2828] = 2490,
  [2829] = 2253,
  [2830] = 2496,
  [2831] = 2222,
  [2832] = 2675,
  [2833] = 2519,
  [2834] = 2508,
  [2835] = 2509,
  [2836] = 2732,
  [2837] = 2743,
  [2838] = 2246,
  [2839] = 2223,
  [2840] = 2510,
  [2841] = 2511,
  [2842] = 2241,
  [2843] = 2399,
  [2844] = 2522,
  [2845] = 2235,
  [2846] = 2721,
  [2847] = 2717,
  [2848] = 2198,
  [2849] = 2203,
  [2850] = 2676,
  [2851] = 2218,
  [2852] = 2513,
  [2853] = 2311,
  [2854] = 2478,
  [2855] = 2509,
  [2856] = 2510,
  [2857] = 2486,
  [2858] = 2496,
  [2859] = 2511,
  [2860] = 2488,
  [2861] = 2487,
  [2862] = 2519,
  [2863] = 2505,
  [2864] = 2523,
  [2865] = 2507,
  [2866] = 2496,
  [2867] = 2264,
  [2868] = 2518,
  [2869] = 2264,
  [2870] = 2720,
  [2871] = 2520,
  [2872] = 2513,
  [2873] = 2478,
  [2874] = 1914,
  [2875] = 2487,
  [2876] = 2490,
  [2877] = 2189,
  [2878] = 2488,
  [2879] = 2498,
  [2880] = 2499,
  [2881] = 2500,
  [2882] = 2501,
  [2883] = 2502,
  [2884] = 2311,
  [2885] = 2478,
  [2886] = 2240,
  [2887] = 1912,
  [2888] = 1915,
  [2889] = 2640,
  [2890] = 2503,
  [2891] = 2267,
  [2892] = 2497,
  [2893] = 2226,
  [2894] = 2486,
  [2895] = 2522,
  [2896] = 2486,
  [2897] = 2504,
  [2898] = 2508,
  [2899] = 1911,
  [2900] = 2095,
  [2901] = 2409,
  [2902] = 2414,
  [2903] = 2515,
  [2904] = 2351,
  [2905] = 2347,
  [2906] = 2352,
  [2907] = 2269,
  [2908] = 2514,
  [2909] = 2278,
  [2910] = 2358,
  [2911] = 2359,
  [2912] = 2306,
  [2913] = 2337,
  [2914] = 2433,
  [2915] = 2328,
  [2916] = 2273,
  [2917] = 2275,
  [2918] = 2332,
  [2919] = 2435,
  [2920] = 2089,
  [2921] = 2091,
  [2922] = 2092,
  [2923] = 2093,
  [2924] = 2094,
  [2925] = 2285,
  [2926] = 2343,
  [2927] = 2418,
  [2928] = 2425,
  [2929] = 2294,
  [2930] = 2295,
  [2931] = 2299,
  [2932] = 2307,
  [2933] = 2431,
  [2934] = 2308,
  [2935] = 2340,
  [2936] = 2314,
  [2937] = 2318,
  [2938] = 2319,
  [2939] = 2324,
  [2940] = 2325,
  [2941] = 2514,
  [2942] = 2515,
  [2943] = 2335,
  [2944] = 2277,
  [2945] = 2336,
  [2946] = 2350,
  [2947] = 2508,
  [2948] = 2509,
  [2949] = 2681,
  [2950] = 2313,
  [2951] = 2363,
  [2952] = 2264,
  [2953] = 2519,
  [2954] = 2675,
  [2955] = 2676,
  [2956] = 2333,
  [2957] = 2367,
  [2958] = 2372,
  [2959] = 2374,
  [2960] = 2380,
  [2961] = 2499,
  [2962] = 2327,
  [2963] = 2382,
  [2964] = 2312,
  [2965] = 2396,
  [2966] = 2419,
  [2967] = 2420,
  [2968] = 2421,
  [2969] = 2317,
  [2970] = 2339,
  [2971] = 2500,
  [2972] = 2329,
  [2973] = 2320,
  [2974] = 2370,
  [2975] = 2280,
  [2976] = 2284,
  [2977] = 2422,
  [2978] = 2434,
  [2979] = 2286,
  [2980] = 2399,
  [2981] = 2510,
  [2982] = 2218,
  [2983] = 2511,
  [2984] = 2700,
  [2985] = 2522,
  [2986] = 2384,
  [2987] = 2365,
  [2988] = 2097,
  [2989] = 2099,
  [2990] = 2698,
  [2991] = 2100,
  [2992] = 2497,
  [2993] = 2287,
  [2994] = 2101,
  [2995] = 2269,
  [2996] = 2397,
  [2997] = 2513,
  [2998] = 2520,
  [2999] = 2326,
  [3000] = 2376,
  [3001] = 2377,
  [3002] = 2394,
  [3003] = 2416,
  [3004] = 2274,
  [3005] = 2296,
  [3006] = 2344,
  [3007] = 2345,
  [3008] = 2366,
  [3009] = 2498,
  [3010] = 2371,
  [3011] = 2346,
  [3012] = 2102,
  [3013] = 2081,
  [3014] = 2088,
  [3015] = 2407,
  [3016] = 2408,
  [3017] = 2682,
  [3018] = 2080,
  [3019] = 2375,
  [3020] = 2398,
  [3021] = 2378,
  [3022] = 2355,
  [3023] = 2399,
  [3024] = 2386,
  [3025] = 2331,
  [3026] = 2361,
  [3027] = 2404,
  [3028] = 2501,
  [3029] = 2364,
  [3030] = 2379,
  [3031] = 2383,
  [3032] = 2502,
  [3033] = 2300,
  [3034] = 2309,
  [3035] = 2315,
  [3036] = 2503,
  [3037] = 2423,
  [3038] = 2316,
  [3039] = 2504,
  [3040] = 2505,
  [3041] = 2523,
  [3042] = 2507,
  [3043] = 2322,
  [3044] = 2323,
  [3045] = 2393,
  [3046] = 2490,
  [3047] = 2424,
  [3048] = 2304,
  [3049] = 2342,
  [3050] = 2290,
  [3051] = 2291,
  [3052] = 2508,
  [3053] = 2509,
  [3054] = 2510,
  [3055] = 2511,
  [3056] = 2513,
  [3057] = 2518,
  [3058] = 2519,
  [3059] = 2520,
  [3060] = 2348,
  [3061] = 2522,
  [3062] = 2293,
  [3063] = 2402,
  [3064] = 2392,
  [3065] = 2353,
  [3066] = 2385,
  [3067] = 2389,
  [3068] = 2437,
  [3069] = 2391,
  [3070] = 2297,
  [3071] = 2298,
  [3072] = 2087,
  [3073] = 2203,
  [3074] = 2496,
  [3075] = 2497,
  [3076] = 2498,
  [3077] = 2499,
  [3078] = 2500,
  [3079] = 2501,
  [3080] = 2502,
  [3081] = 2503,
  [3082] = 2504,
  [3083] = 2505,
  [3084] = 2523,
  [3085] = 2507,
  [3086] = 2490,
  [3087] = 2496,
  [3088] = 2103,
  [3089] = 2373,
  [3090] = 2276,
  [3091] = 2283,
  [3092] = 2369,
  [3093] = 2679,
  [3094] = 2281,
  [3095] = 2288,
  [3096] = 2289,
  [3097] = 2413,
  [3098] = 2387,
  [3099] = 2334,
  [3100] = 2330,
  [3101] = 2405,
  [3102] = 2411,
  [3103] = 2305,
  [3104] = 2426,
  [3105] = 2368,
  [3106] = 3106,
  [3107] = 2523,
  [3108] = 3108,
  [3109] = 3108,
  [3110] = 3108,
  [3111] = 2507,
  [3112] = 2490,
  [3113] = 2487,
  [3114] = 2241,
  [3115] = 2519,
  [3116] = 3108,
  [3117] = 2221,
  [3118] = 2510,
  [3119] = 2508,
  [3120] = 2360,
  [3121] = 3106,
  [3122] = 3106,
  [3123] = 3108,
  [3124] = 3106,
  [3125] = 2478,
  [3126] = 3126,
  [3127] = 2488,
  [3128] = 3108,
  [3129] = 2338,
  [3130] = 2520,
  [3131] = 3108,
  [3132] = 2349,
  [3133] = 3108,
  [3134] = 2640,
  [3135] = 2486,
  [3136] = 3108,
  [3137] = 2432,
  [3138] = 2496,
  [3139] = 2264,
  [3140] = 2522,
  [3141] = 2478,
  [3142] = 2338,
  [3143] = 2509,
  [3144] = 2360,
  [3145] = 3106,
  [3146] = 3108,
  [3147] = 3106,
  [3148] = 3108,
  [3149] = 3108,
  [3150] = 2511,
  [3151] = 2513,
  [3152] = 2223,
  [3153] = 2497,
  [3154] = 3106,
  [3155] = 2349,
  [3156] = 3108,
  [3157] = 2264,
  [3158] = 2518,
  [3159] = 2498,
  [3160] = 2499,
  [3161] = 2500,
  [3162] = 3106,
  [3163] = 2501,
  [3164] = 2502,
  [3165] = 3108,
  [3166] = 2432,
  [3167] = 3106,
  [3168] = 3108,
  [3169] = 2640,
  [3170] = 3106,
  [3171] = 3108,
  [3172] = 2496,
  [3173] = 3106,
  [3174] = 2503,
  [3175] = 2486,
  [3176] = 3108,
  [3177] = 3106,
  [3178] = 2504,
  [3179] = 2269,
  [3180] = 2478,
  [3181] = 2505,
  [3182] = 2496,
  [3183] = 2676,
  [3184] = 2720,
  [3185] = 2522,
  [3186] = 2508,
  [3187] = 2509,
  [3188] = 2518,
  [3189] = 2487,
  [3190] = 2305,
  [3191] = 2679,
  [3192] = 2373,
  [3193] = 1912,
  [3194] = 1915,
  [3195] = 2681,
  [3196] = 2264,
  [3197] = 2519,
  [3198] = 2675,
  [3199] = 2743,
  [3200] = 2486,
  [3201] = 2732,
  [3202] = 2721,
  [3203] = 2717,
  [3204] = 3204,
  [3205] = 1907,
  [3206] = 2488,
  [3207] = 2487,
  [3208] = 2486,
  [3209] = 2488,
  [3210] = 2478,
  [3211] = 2478,
  [3212] = 1911,
  [3213] = 2486,
  [3214] = 2522,
  [3215] = 1914,
  [3216] = 2515,
  [3217] = 1913,
  [3218] = 2698,
  [3219] = 2497,
  [3220] = 2513,
  [3221] = 3221,
  [3222] = 2520,
  [3223] = 2510,
  [3224] = 2511,
  [3225] = 2399,
  [3226] = 2264,
  [3227] = 2487,
  [3228] = 2488,
  [3229] = 2514,
  [3230] = 2490,
  [3231] = 2700,
  [3232] = 2498,
  [3233] = 2499,
  [3234] = 2500,
  [3235] = 2501,
  [3236] = 2478,
  [3237] = 2399,
  [3238] = 2502,
  [3239] = 2503,
  [3240] = 2504,
  [3241] = 2505,
  [3242] = 2523,
  [3243] = 2507,
  [3244] = 2478,
  [3245] = 2504,
  [3246] = 2432,
  [3247] = 2513,
  [3248] = 2522,
  [3249] = 2502,
  [3250] = 2498,
  [3251] = 2499,
  [3252] = 2500,
  [3253] = 2501,
  [3254] = 2502,
  [3255] = 2503,
  [3256] = 2504,
  [3257] = 2505,
  [3258] = 2523,
  [3259] = 2507,
  [3260] = 2490,
  [3261] = 2522,
  [3262] = 2520,
  [3263] = 2487,
  [3264] = 2503,
  [3265] = 2514,
  [3266] = 2700,
  [3267] = 2515,
  [3268] = 2522,
  [3269] = 2488,
  [3270] = 2500,
  [3271] = 2496,
  [3272] = 2513,
  [3273] = 2311,
  [3274] = 2487,
  [3275] = 2486,
  [3276] = 2349,
  [3277] = 2508,
  [3278] = 2498,
  [3279] = 2520,
  [3280] = 2509,
  [3281] = 2496,
  [3282] = 2482,
  [3283] = 2486,
  [3284] = 2486,
  [3285] = 2522,
  [3286] = 2487,
  [3287] = 2399,
  [3288] = 2518,
  [3289] = 2497,
  [3290] = 2519,
  [3291] = 2499,
  [3292] = 2519,
  [3293] = 2681,
  [3294] = 2498,
  [3295] = 2499,
  [3296] = 2500,
  [3297] = 2501,
  [3298] = 2502,
  [3299] = 2503,
  [3300] = 2478,
  [3301] = 2505,
  [3302] = 2523,
  [3303] = 2507,
  [3304] = 2490,
  [3305] = 2522,
  [3306] = 2399,
  [3307] = 2515,
  [3308] = 2520,
  [3309] = 2640,
  [3310] = 2497,
  [3311] = 2519,
  [3312] = 2520,
  [3313] = 2498,
  [3314] = 2499,
  [3315] = 2500,
  [3316] = 2501,
  [3317] = 2489,
  [3318] = 2503,
  [3319] = 2504,
  [3320] = 2505,
  [3321] = 2523,
  [3322] = 2507,
  [3323] = 2490,
  [3324] = 2511,
  [3325] = 2518,
  [3326] = 2504,
  [3327] = 2505,
  [3328] = 2497,
  [3329] = 2488,
  [3330] = 2508,
  [3331] = 2509,
  [3332] = 2510,
  [3333] = 2511,
  [3334] = 2513,
  [3335] = 3335,
  [3336] = 2496,
  [3337] = 2523,
  [3338] = 2507,
  [3339] = 2675,
  [3340] = 2698,
  [3341] = 2496,
  [3342] = 2518,
  [3343] = 2518,
  [3344] = 2338,
  [3345] = 3335,
  [3346] = 2676,
  [3347] = 2360,
  [3348] = 2489,
  [3349] = 2488,
  [3350] = 2640,
  [3351] = 2482,
  [3352] = 2496,
  [3353] = 2478,
  [3354] = 2490,
  [3355] = 2514,
  [3356] = 2515,
  [3357] = 2508,
  [3358] = 3358,
  [3359] = 3335,
  [3360] = 2496,
  [3361] = 2501,
  [3362] = 2311,
  [3363] = 2509,
  [3364] = 2486,
  [3365] = 2514,
  [3366] = 2510,
  [3367] = 2497,
  [3368] = 2519,
  [3369] = 2478,
  [3370] = 2510,
  [3371] = 2511,
  [3372] = 2508,
  [3373] = 2509,
  [3374] = 2510,
  [3375] = 2511,
  [3376] = 2513,
  [3377] = 2478,
  [3378] = 2502,
  [3379] = 2700,
  [3380] = 2509,
  [3381] = 2510,
  [3382] = 2497,
  [3383] = 2519,
  [3384] = 2355,
  [3385] = 2498,
  [3386] = 2499,
  [3387] = 2498,
  [3388] = 2499,
  [3389] = 2500,
  [3390] = 2501,
  [3391] = 2502,
  [3392] = 2503,
  [3393] = 2504,
  [3394] = 2505,
  [3395] = 2523,
  [3396] = 2507,
  [3397] = 2490,
  [3398] = 2500,
  [3399] = 2501,
  [3400] = 2502,
  [3401] = 2720,
  [3402] = 2503,
  [3403] = 2504,
  [3404] = 2505,
  [3405] = 2523,
  [3406] = 2507,
  [3407] = 2490,
  [3408] = 2511,
  [3409] = 2513,
  [3410] = 2508,
  [3411] = 2509,
  [3412] = 2510,
  [3413] = 2511,
  [3414] = 2513,
  [3415] = 3415,
  [3416] = 2514,
  [3417] = 2515,
  [3418] = 3415,
  [3419] = 2203,
  [3420] = 2486,
  [3421] = 2496,
  [3422] = 2743,
  [3423] = 2298,
  [3424] = 2496,
  [3425] = 2399,
  [3426] = 3415,
  [3427] = 2520,
  [3428] = 2364,
  [3429] = 2487,
  [3430] = 2518,
  [3431] = 2509,
  [3432] = 2510,
  [3433] = 2511,
  [3434] = 2522,
  [3435] = 2513,
  [3436] = 2520,
  [3437] = 2482,
  [3438] = 2519,
  [3439] = 2675,
  [3440] = 2676,
  [3441] = 2437,
  [3442] = 2721,
  [3443] = 2681,
  [3444] = 2498,
  [3445] = 2499,
  [3446] = 2500,
  [3447] = 2501,
  [3448] = 2502,
  [3449] = 2503,
  [3450] = 2504,
  [3451] = 2505,
  [3452] = 2523,
  [3453] = 2507,
  [3454] = 2490,
  [3455] = 2486,
  [3456] = 2717,
  [3457] = 2514,
  [3458] = 2488,
  [3459] = 2515,
  [3460] = 2732,
  [3461] = 3415,
  [3462] = 2496,
  [3463] = 2297,
  [3464] = 2679,
  [3465] = 2496,
  [3466] = 2698,
  [3467] = 2497,
  [3468] = 2515,
  [3469] = 2311,
  [3470] = 2497,
  [3471] = 2287,
  [3472] = 2519,
  [3473] = 2346,
  [3474] = 2489,
  [3475] = 2522,
  [3476] = 2520,
  [3477] = 2514,
  [3478] = 3415,
  [3479] = 2508,
  [3480] = 2508,
  [3481] = 2501,
  [3482] = 2499,
  [3483] = 2500,
  [3484] = 2522,
  [3485] = 2501,
  [3486] = 1911,
  [3487] = 1914,
  [3488] = 2478,
  [3489] = 2502,
  [3490] = 2503,
  [3491] = 2504,
  [3492] = 2681,
  [3493] = 2486,
  [3494] = 2496,
  [3495] = 2519,
  [3496] = 2505,
  [3497] = 2204,
  [3498] = 2679,
  [3499] = 2675,
  [3500] = 2478,
  [3501] = 2676,
  [3502] = 2513,
  [3503] = 2523,
  [3504] = 2482,
  [3505] = 2497,
  [3506] = 2520,
  [3507] = 2508,
  [3508] = 2498,
  [3509] = 2399,
  [3510] = 2509,
  [3511] = 2499,
  [3512] = 2500,
  [3513] = 2497,
  [3514] = 2478,
  [3515] = 2640,
  [3516] = 2207,
  [3517] = 2498,
  [3518] = 2720,
  [3519] = 2502,
  [3520] = 2503,
  [3521] = 2510,
  [3522] = 2522,
  [3523] = 2504,
  [3524] = 2505,
  [3525] = 2523,
  [3526] = 2511,
  [3527] = 2507,
  [3528] = 2490,
  [3529] = 2514,
  [3530] = 2519,
  [3531] = 2496,
  [3532] = 2515,
  [3533] = 2520,
  [3534] = 2507,
  [3535] = 2698,
  [3536] = 2508,
  [3537] = 2509,
  [3538] = 2490,
  [3539] = 2489,
  [3540] = 2478,
  [3541] = 2198,
  [3542] = 2478,
  [3543] = 2510,
  [3544] = 2511,
  [3545] = 2513,
  [3546] = 2700,
  [3547] = 2518,
  [3548] = 2717,
  [3549] = 2486,
  [3550] = 2486,
  [3551] = 2488,
  [3552] = 2478,
  [3553] = 2700,
  [3554] = 2487,
  [3555] = 2478,
  [3556] = 2496,
  [3557] = 2640,
  [3558] = 2478,
  [3559] = 2522,
  [3560] = 2478,
  [3561] = 2640,
  [3562] = 3562,
  [3563] = 3563,
  [3564] = 2520,
  [3565] = 1966,
  [3566] = 2498,
  [3567] = 2499,
  [3568] = 2500,
  [3569] = 2501,
  [3570] = 2502,
  [3571] = 2503,
  [3572] = 2488,
  [3573] = 2505,
  [3574] = 2523,
  [3575] = 2507,
  [3576] = 2486,
  [3577] = 2490,
  [3578] = 3578,
  [3579] = 2497,
  [3580] = 2519,
  [3581] = 1963,
  [3582] = 2487,
  [3583] = 2518,
  [3584] = 2508,
  [3585] = 2509,
  [3586] = 2510,
  [3587] = 2511,
  [3588] = 2513,
  [3589] = 2732,
  [3590] = 2743,
  [3591] = 2721,
  [3592] = 2487,
  [3593] = 2488,
  [3594] = 2487,
  [3595] = 2486,
  [3596] = 2522,
  [3597] = 2720,
  [3598] = 2486,
  [3599] = 2488,
  [3600] = 2496,
  [3601] = 2486,
  [3602] = 2504,
  [3603] = 2488,
  [3604] = 2478,
  [3605] = 2518,
  [3606] = 2640,
  [3607] = 2519,
  [3608] = 2360,
  [3609] = 2682,
  [3610] = 2522,
  [3611] = 2522,
  [3612] = 2498,
  [3613] = 2499,
  [3614] = 2500,
  [3615] = 2501,
  [3616] = 2700,
  [3617] = 2502,
  [3618] = 2478,
  [3619] = 2503,
  [3620] = 2508,
  [3621] = 2487,
  [3622] = 2509,
  [3623] = 2720,
  [3624] = 2510,
  [3625] = 2522,
  [3626] = 2511,
  [3627] = 2518,
  [3628] = 2681,
  [3629] = 2496,
  [3630] = 2504,
  [3631] = 2505,
  [3632] = 2523,
  [3633] = 2507,
  [3634] = 2490,
  [3635] = 2513,
  [3636] = 2700,
  [3637] = 2508,
  [3638] = 2509,
  [3639] = 2510,
  [3640] = 2511,
  [3641] = 2513,
  [3642] = 2513,
  [3643] = 2240,
  [3644] = 2675,
  [3645] = 2520,
  [3646] = 2515,
  [3647] = 2676,
  [3648] = 2486,
  [3649] = 2497,
  [3650] = 2679,
  [3651] = 2497,
  [3652] = 2513,
  [3653] = 3653,
  [3654] = 2487,
  [3655] = 2514,
  [3656] = 2486,
  [3657] = 2486,
  [3658] = 2488,
  [3659] = 2520,
  [3660] = 2478,
  [3661] = 2682,
  [3662] = 2510,
  [3663] = 2498,
  [3664] = 2499,
  [3665] = 2500,
  [3666] = 2515,
  [3667] = 2522,
  [3668] = 2501,
  [3669] = 2478,
  [3670] = 2502,
  [3671] = 2508,
  [3672] = 2509,
  [3673] = 2510,
  [3674] = 2511,
  [3675] = 2496,
  [3676] = 2522,
  [3677] = 2519,
  [3678] = 2478,
  [3679] = 2498,
  [3680] = 2499,
  [3681] = 2497,
  [3682] = 2522,
  [3683] = 2520,
  [3684] = 2500,
  [3685] = 2501,
  [3686] = 2502,
  [3687] = 2503,
  [3688] = 2504,
  [3689] = 2520,
  [3690] = 2679,
  [3691] = 2675,
  [3692] = 2496,
  [3693] = 2488,
  [3694] = 2503,
  [3695] = 2511,
  [3696] = 2504,
  [3697] = 2505,
  [3698] = 2523,
  [3699] = 2507,
  [3700] = 2496,
  [3701] = 2497,
  [3702] = 2519,
  [3703] = 2676,
  [3704] = 2514,
  [3705] = 2505,
  [3706] = 2698,
  [3707] = 2523,
  [3708] = 2507,
  [3709] = 2518,
  [3710] = 2338,
  [3711] = 2640,
  [3712] = 2519,
  [3713] = 2497,
  [3714] = 2519,
  [3715] = 2520,
  [3716] = 2498,
  [3717] = 2499,
  [3718] = 2500,
  [3719] = 2501,
  [3720] = 2502,
  [3721] = 2503,
  [3722] = 2504,
  [3723] = 2505,
  [3724] = 2523,
  [3725] = 2507,
  [3726] = 2490,
  [3727] = 2490,
  [3728] = 2522,
  [3729] = 3729,
  [3730] = 2487,
  [3731] = 2498,
  [3732] = 2499,
  [3733] = 2500,
  [3734] = 2501,
  [3735] = 2502,
  [3736] = 2503,
  [3737] = 2504,
  [3738] = 2505,
  [3739] = 2523,
  [3740] = 2507,
  [3741] = 2514,
  [3742] = 2486,
  [3743] = 2490,
  [3744] = 2681,
  [3745] = 2226,
  [3746] = 2490,
  [3747] = 2349,
  [3748] = 2508,
  [3749] = 2508,
  [3750] = 2509,
  [3751] = 2515,
  [3752] = 2510,
  [3753] = 2515,
  [3754] = 2509,
  [3755] = 2511,
  [3756] = 2432,
  [3757] = 2478,
  [3758] = 2698,
  [3759] = 2514,
  [3760] = 2513,
  [3761] = 2523,
  [3762] = 2498,
  [3763] = 2496,
  [3764] = 2514,
  [3765] = 2675,
  [3766] = 2676,
  [3767] = 2499,
  [3768] = 2499,
  [3769] = 2510,
  [3770] = 2496,
  [3771] = 2500,
  [3772] = 2522,
  [3773] = 2700,
  [3774] = 2500,
  [3775] = 2501,
  [3776] = 2520,
  [3777] = 2520,
  [3778] = 2498,
  [3779] = 2499,
  [3780] = 2500,
  [3781] = 2508,
  [3782] = 2509,
  [3783] = 2510,
  [3784] = 2511,
  [3785] = 2501,
  [3786] = 2502,
  [3787] = 2514,
  [3788] = 2503,
  [3789] = 2513,
  [3790] = 2486,
  [3791] = 2522,
  [3792] = 2501,
  [3793] = 2504,
  [3794] = 2510,
  [3795] = 2498,
  [3796] = 2515,
  [3797] = 2502,
  [3798] = 2499,
  [3799] = 2486,
  [3800] = 2505,
  [3801] = 2523,
  [3802] = 2513,
  [3803] = 2500,
  [3804] = 2503,
  [3805] = 2507,
  [3806] = 2501,
  [3807] = 2502,
  [3808] = 2515,
  [3809] = 2519,
  [3810] = 2520,
  [3811] = 2520,
  [3812] = 2490,
  [3813] = 2486,
  [3814] = 2504,
  [3815] = 2502,
  [3816] = 2504,
  [3817] = 2513,
  [3818] = 2503,
  [3819] = 2520,
  [3820] = 2505,
  [3821] = 2508,
  [3822] = 2508,
  [3823] = 2496,
  [3824] = 2523,
  [3825] = 2511,
  [3826] = 2509,
  [3827] = 2504,
  [3828] = 2503,
  [3829] = 2507,
  [3830] = 2487,
  [3831] = 2505,
  [3832] = 2501,
  [3833] = 2496,
  [3834] = 2504,
  [3835] = 2505,
  [3836] = 2514,
  [3837] = 2523,
  [3838] = 2503,
  [3839] = 2490,
  [3840] = 2502,
  [3841] = 2519,
  [3842] = 2509,
  [3843] = 2518,
  [3844] = 2487,
  [3845] = 2505,
  [3846] = 2507,
  [3847] = 2523,
  [3848] = 2490,
  [3849] = 2507,
  [3850] = 2490,
  [3851] = 2498,
  [3852] = 2511,
  [3853] = 2511,
  [3854] = 2500,
  [3855] = 2511,
  [3856] = 2497,
  [3857] = 2497,
  [3858] = 2508,
  [3859] = 2640,
  [3860] = 2509,
  [3861] = 2522,
  [3862] = 2496,
  [3863] = 2681,
  [3864] = 2519,
  [3865] = 2497,
  [3866] = 2488,
  [3867] = 2679,
  [3868] = 2518,
  [3869] = 2496,
  [3870] = 2488,
  [3871] = 2490,
  [3872] = 2499,
  [3873] = 2498,
  [3874] = 2486,
  [3875] = 2513,
  [3876] = 2682,
  [3877] = 2698,
  [3878] = 2513,
  [3879] = 2515,
  [3880] = 2497,
  [3881] = 2497,
  [3882] = 2640,
  [3883] = 2508,
  [3884] = 2510,
  [3885] = 2519,
  [3886] = 2509,
  [3887] = 2510,
  [3888] = 2519,
  [3889] = 2507,
  [3890] = 2515,
  [3891] = 2732,
  [3892] = 2515,
  [3893] = 2504,
  [3894] = 2501,
  [3895] = 2513,
  [3896] = 2505,
  [3897] = 2679,
  [3898] = 2478,
  [3899] = 2478,
  [3900] = 2514,
  [3901] = 2508,
  [3902] = 2509,
  [3903] = 2510,
  [3904] = 2511,
  [3905] = 2513,
  [3906] = 2732,
  [3907] = 2698,
  [3908] = 2743,
  [3909] = 2497,
  [3910] = 3910,
  [3911] = 2490,
  [3912] = 2522,
  [3913] = 2743,
  [3914] = 2681,
  [3915] = 2520,
  [3916] = 2679,
  [3917] = 2502,
  [3918] = 2497,
  [3919] = 2498,
  [3920] = 2511,
  [3921] = 2499,
  [3922] = 2519,
  [3923] = 2518,
  [3924] = 2720,
  [3925] = 2698,
  [3926] = 2478,
  [3927] = 2523,
  [3928] = 2507,
  [3929] = 2500,
  [3930] = 2519,
  [3931] = 2503,
  [3932] = 2675,
  [3933] = 2520,
  [3934] = 2498,
  [3935] = 2640,
  [3936] = 2499,
  [3937] = 2508,
  [3938] = 2518,
  [3939] = 2676,
  [3940] = 2509,
  [3941] = 2486,
  [3942] = 2496,
  [3943] = 2496,
  [3944] = 2520,
  [3945] = 2496,
  [3946] = 2721,
  [3947] = 2500,
  [3948] = 2501,
  [3949] = 2721,
  [3950] = 2717,
  [3951] = 2717,
  [3952] = 2503,
  [3953] = 2504,
  [3954] = 2505,
  [3955] = 2496,
  [3956] = 2523,
  [3957] = 2497,
  [3958] = 2720,
  [3959] = 2508,
  [3960] = 2509,
  [3961] = 2507,
  [3962] = 2700,
  [3963] = 2513,
  [3964] = 2510,
  [3965] = 2511,
  [3966] = 2700,
  [3967] = 2681,
  [3968] = 2640,
  [3969] = 2498,
  [3970] = 2700,
  [3971] = 2519,
  [3972] = 2675,
  [3973] = 2499,
  [3974] = 2676,
  [3975] = 2522,
  [3976] = 2500,
  [3977] = 2522,
  [3978] = 2501,
  [3979] = 2502,
  [3980] = 2503,
  [3981] = 2504,
  [3982] = 2514,
  [3983] = 2478,
  [3984] = 2505,
  [3985] = 2523,
  [3986] = 2507,
  [3987] = 2490,
  [3988] = 2510,
  [3989] = 2490,
  [3990] = 2502,
  [3991] = 2513,
  [3992] = 2676,
  [3993] = 2515,
  [3994] = 2496,
  [3995] = 2743,
  [3996] = 2486,
  [3997] = 2519,
  [3998] = 2510,
  [3999] = 2520,
  [4000] = 2501,
  [4001] = 2511,
  [4002] = 2498,
  [4003] = 2496,
  [4004] = 2499,
  [4005] = 2497,
  [4006] = 2502,
  [4007] = 2486,
  [4008] = 2490,
  [4009] = 2508,
  [4010] = 2509,
  [4011] = 2503,
  [4012] = 2510,
  [4013] = 2511,
  [4014] = 2500,
  [4015] = 2679,
  [4016] = 2513,
  [4017] = 2501,
  [4018] = 2488,
  [4019] = 2509,
  [4020] = 2502,
  [4021] = 2503,
  [4022] = 2504,
  [4023] = 2675,
  [4024] = 2675,
  [4025] = 2505,
  [4026] = 2514,
  [4027] = 2519,
  [4028] = 2721,
  [4029] = 2717,
  [4030] = 2698,
  [4031] = 2486,
  [4032] = 2523,
  [4033] = 2698,
  [4034] = 2679,
  [4035] = 2681,
  [4036] = 2498,
  [4037] = 2522,
  [4038] = 2507,
  [4039] = 2499,
  [4040] = 2676,
  [4041] = 2490,
  [4042] = 2500,
  [4043] = 2732,
  [4044] = 2508,
  [4045] = 2487,
  [4046] = 2504,
  [4047] = 2720,
  [4048] = 2518,
  [4049] = 2497,
  [4050] = 2520,
  [4051] = 2505,
  [4052] = 2523,
  [4053] = 2507,
  [4054] = 2681,
  [4055] = 2478,
  [4056] = 2743,
  [4057] = 2498,
  [4058] = 2499,
  [4059] = 2500,
  [4060] = 2501,
  [4061] = 2502,
  [4062] = 2503,
  [4063] = 2504,
  [4064] = 2721,
  [4065] = 2717,
  [4066] = 2520,
  [4067] = 2486,
  [4068] = 2505,
  [4069] = 2487,
  [4070] = 2520,
  [4071] = 2523,
  [4072] = 2507,
  [4073] = 1913,
  [4074] = 2490,
  [4075] = 2720,
  [4076] = 2497,
  [4077] = 2519,
  [4078] = 2721,
  [4079] = 2717,
  [4080] = 2522,
  [4081] = 2508,
  [4082] = 2681,
  [4083] = 2698,
  [4084] = 2509,
  [4085] = 2488,
  [4086] = 2675,
  [4087] = 2676,
  [4088] = 4088,
  [4089] = 2510,
  [4090] = 2511,
  [4091] = 2498,
  [4092] = 2499,
  [4093] = 2500,
  [4094] = 2501,
  [4095] = 2732,
  [4096] = 2503,
  [4097] = 2504,
  [4098] = 2505,
  [4099] = 2523,
  [4100] = 2507,
  [4101] = 2490,
  [4102] = 2508,
  [4103] = 2509,
  [4104] = 2510,
  [4105] = 2511,
  [4106] = 2513,
  [4107] = 2520,
  [4108] = 2486,
  [4109] = 2497,
  [4110] = 2514,
  [4111] = 2478,
  [4112] = 2522,
  [4113] = 2513,
  [4114] = 2519,
  [4115] = 2700,
  [4116] = 2515,
  [4117] = 2732,
  [4118] = 2743,
  [4119] = 2721,
  [4120] = 2717,
  [4121] = 2478,
  [4122] = 2522,
  [4123] = 2720,
  [4124] = 2700,
  [4125] = 2478,
  [4126] = 2732,
  [4127] = 2502,
  [4128] = 2676,
  [4129] = 2510,
  [4130] = 2511,
  [4131] = 2498,
  [4132] = 2490,
  [4133] = 2732,
  [4134] = 2743,
  [4135] = 2499,
  [4136] = 2509,
  [4137] = 2500,
  [4138] = 2501,
  [4139] = 2520,
  [4140] = 2373,
  [4141] = 2522,
  [4142] = 2497,
  [4143] = 2510,
  [4144] = 2519,
  [4145] = 2513,
  [4146] = 2502,
  [4147] = 2508,
  [4148] = 2503,
  [4149] = 4149,
  [4150] = 4150,
  [4151] = 2721,
  [4152] = 2717,
  [4153] = 2509,
  [4154] = 2720,
  [4155] = 4155,
  [4156] = 2498,
  [4157] = 2499,
  [4158] = 2500,
  [4159] = 2501,
  [4160] = 2502,
  [4161] = 2503,
  [4162] = 2504,
  [4163] = 2514,
  [4164] = 2505,
  [4165] = 2523,
  [4166] = 2507,
  [4167] = 2490,
  [4168] = 2743,
  [4169] = 2515,
  [4170] = 2720,
  [4171] = 2515,
  [4172] = 2520,
  [4173] = 4149,
  [4174] = 4150,
  [4175] = 2218,
  [4176] = 2519,
  [4177] = 2497,
  [4178] = 2519,
  [4179] = 2498,
  [4180] = 2499,
  [4181] = 2500,
  [4182] = 2501,
  [4183] = 2522,
  [4184] = 2502,
  [4185] = 2503,
  [4186] = 2487,
  [4187] = 2504,
  [4188] = 2505,
  [4189] = 2523,
  [4190] = 2507,
  [4191] = 2490,
  [4192] = 2486,
  [4193] = 2511,
  [4194] = 2305,
  [4195] = 2508,
  [4196] = 2509,
  [4197] = 2504,
  [4198] = 2505,
  [4199] = 2510,
  [4200] = 2523,
  [4201] = 4201,
  [4202] = 2497,
  [4203] = 2507,
  [4204] = 2511,
  [4205] = 2513,
  [4206] = 2486,
  [4207] = 4155,
  [4208] = 2513,
  [4209] = 2681,
  [4210] = 2488,
  [4211] = 2698,
  [4212] = 2675,
  [4213] = 2508,
  [4214] = 4155,
  [4215] = 2520,
  [4216] = 2500,
  [4217] = 2509,
  [4218] = 2510,
  [4219] = 2499,
  [4220] = 2503,
  [4221] = 2520,
  [4222] = 2513,
  [4223] = 4149,
  [4224] = 2520,
  [4225] = 2511,
  [4226] = 2490,
  [4227] = 2497,
  [4228] = 2508,
  [4229] = 2509,
  [4230] = 3653,
  [4231] = 2519,
  [4232] = 2497,
  [4233] = 2519,
  [4234] = 2498,
  [4235] = 2522,
  [4236] = 2499,
  [4237] = 2504,
  [4238] = 4150,
  [4239] = 2508,
  [4240] = 2498,
  [4241] = 2501,
  [4242] = 3729,
  [4243] = 2510,
  [4244] = 2501,
  [4245] = 2502,
  [4246] = 2505,
  [4247] = 2503,
  [4248] = 2511,
  [4249] = 2513,
  [4250] = 2504,
  [4251] = 2505,
  [4252] = 2523,
  [4253] = 4149,
  [4254] = 4150,
  [4255] = 2523,
  [4256] = 2514,
  [4257] = 2502,
  [4258] = 2507,
  [4259] = 2522,
  [4260] = 2490,
  [4261] = 2720,
  [4262] = 2515,
  [4263] = 2507,
  [4264] = 4264,
  [4265] = 2500,
  [4266] = 4266,
  [4267] = 4267,
  [4268] = 4267,
  [4269] = 4267,
  [4270] = 4266,
  [4271] = 2087,
  [4272] = 2103,
  [4273] = 4267,
  [4274] = 4267,
  [4275] = 4267,
  [4276] = 4267,
  [4277] = 4277,
  [4278] = 4267,
  [4279] = 4267,
  [4280] = 4267,
  [4281] = 4267,
  [4282] = 2508,
  [4283] = 4267,
  [4284] = 4284,
  [4285] = 4266,
  [4286] = 2509,
  [4287] = 2497,
  [4288] = 4267,
  [4289] = 4289,
  [4290] = 4267,
  [4291] = 2498,
  [4292] = 2499,
  [4293] = 2500,
  [4294] = 4267,
  [4295] = 4267,
  [4296] = 2501,
  [4297] = 2519,
  [4298] = 2510,
  [4299] = 4267,
  [4300] = 2089,
  [4301] = 4267,
  [4302] = 2502,
  [4303] = 2091,
  [4304] = 2092,
  [4305] = 2093,
  [4306] = 2094,
  [4307] = 2503,
  [4308] = 2511,
  [4309] = 2504,
  [4310] = 2505,
  [4311] = 2523,
  [4312] = 2507,
  [4313] = 4267,
  [4314] = 2490,
  [4315] = 4267,
  [4316] = 4267,
  [4317] = 4267,
  [4318] = 2513,
  [4319] = 2520,
  [4320] = 4267,
  [4321] = 4267,
  [4322] = 4267,
  [4323] = 2095,
  [4324] = 2097,
  [4325] = 2099,
  [4326] = 4267,
  [4327] = 2101,
  [4328] = 4267,
  [4329] = 4267,
  [4330] = 2102,
  [4331] = 2081,
  [4332] = 4267,
  [4333] = 4267,
  [4334] = 2088,
  [4335] = 2080,
  [4336] = 4267,
  [4337] = 4337,
  [4338] = 4267,
  [4339] = 2240,
  [4340] = 4267,
  [4341] = 4267,
  [4342] = 2720,
  [4343] = 4267,
  [4344] = 4267,
  [4345] = 4267,
  [4346] = 4267,
  [4347] = 4267,
  [4348] = 4267,
  [4349] = 4267,
  [4350] = 4267,
  [4351] = 4266,
  [4352] = 4267,
  [4353] = 4266,
  [4354] = 4267,
  [4355] = 4266,
  [4356] = 4266,
  [4357] = 4267,
  [4358] = 4266,
  [4359] = 4359,
  [4360] = 4266,
  [4361] = 4266,
  [4362] = 4266,
  [4363] = 4266,
  [4364] = 4266,
  [4365] = 4267,
  [4366] = 4266,
  [4367] = 2226,
  [4368] = 4368,
  [4369] = 4266,
  [4370] = 4266,
  [4371] = 4266,
  [4372] = 4266,
  [4373] = 4266,
  [4374] = 4266,
  [4375] = 4266,
  [4376] = 4266,
  [4377] = 4266,
  [4378] = 4266,
  [4379] = 2100,
  [4380] = 2087,
  [4381] = 2102,
  [4382] = 2369,
  [4383] = 2294,
  [4384] = 2295,
  [4385] = 2299,
  [4386] = 2307,
  [4387] = 2097,
  [4388] = 2312,
  [4389] = 2317,
  [4390] = 2376,
  [4391] = 2377,
  [4392] = 4392,
  [4393] = 2089,
  [4394] = 2320,
  [4395] = 2370,
  [4396] = 2375,
  [4397] = 2411,
  [4398] = 2378,
  [4399] = 4399,
  [4400] = 2426,
  [4401] = 4401,
  [4402] = 2293,
  [4403] = 2413,
  [4404] = 2387,
  [4405] = 2384,
  [4406] = 2081,
  [4407] = 2088,
  [4408] = 2080,
  [4409] = 4409,
  [4410] = 2283,
  [4411] = 2334,
  [4412] = 2092,
  [4413] = 2093,
  [4414] = 4414,
  [4415] = 2094,
  [4416] = 2091,
  [4417] = 2099,
  [4418] = 2103,
  [4419] = 2423,
  [4420] = 2281,
  [4421] = 2086,
  [4422] = 2276,
  [4423] = 2385,
  [4424] = 2095,
  [4425] = 2100,
  [4426] = 2288,
  [4427] = 2101,
  [4428] = 2389,
  [4429] = 2289,
  [4430] = 2391,
  [4431] = 2339,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 4434,
  [4435] = 4435,
  [4436] = 4436,
  [4437] = 4437,
  [4438] = 4438,
  [4439] = 4439,
  [4440] = 4440,
  [4441] = 4437,
  [4442] = 4438,
  [4443] = 4443,
  [4444] = 4444,
  [4445] = 4445,
  [4446] = 4446,
  [4447] = 4447,
  [4448] = 4448,
  [4449] = 4449,
  [4450] = 4450,
  [4451] = 4451,
  [4452] = 4452,
  [4453] = 4453,
  [4454] = 4454,
  [4455] = 4455,
  [4456] = 4456,
  [4457] = 4457,
  [4458] = 4458,
  [4459] = 4459,
  [4460] = 3653,
  [4461] = 4461,
  [4462] = 4462,
  [4463] = 4463,
  [4464] = 1907,
  [4465] = 1912,
  [4466] = 1911,
  [4467] = 4467,
  [4468] = 4468,
  [4469] = 4469,
  [4470] = 1915,
  [4471] = 3729,
  [4472] = 4472,
  [4473] = 1914,
  [4474] = 3221,
  [4475] = 3204,
  [4476] = 4476,
  [4477] = 4477,
  [4478] = 4478,
  [4479] = 4479,
  [4480] = 4480,
  [4481] = 4481,
  [4482] = 4482,
  [4483] = 4483,
  [4484] = 4484,
  [4485] = 4485,
  [4486] = 4486,
  [4487] = 4487,
  [4488] = 4488,
  [4489] = 4489,
  [4490] = 4490,
  [4491] = 4491,
  [4492] = 4492,
  [4493] = 4493,
  [4494] = 4494,
  [4495] = 4495,
  [4496] = 4496,
  [4497] = 4497,
  [4498] = 4498,
  [4499] = 4499,
  [4500] = 4500,
  [4501] = 4501,
  [4502] = 4502,
  [4503] = 4503,
  [4504] = 4504,
  [4505] = 4505,
  [4506] = 4506,
  [4507] = 4507,
  [4508] = 4508,
  [4509] = 4509,
  [4510] = 4510,
  [4511] = 4511,
  [4512] = 4512,
  [4513] = 4513,
  [4514] = 4514,
  [4515] = 3653,
  [4516] = 3729,
  [4517] = 3729,
  [4518] = 4518,
  [4519] = 3653,
  [4520] = 4520,
  [4521] = 4521,
  [4522] = 4522,
  [4523] = 4523,
  [4524] = 4524,
  [4525] = 4525,
  [4526] = 4526,
  [4527] = 4527,
  [4528] = 4528,
  [4529] = 4529,
  [4530] = 4530,
  [4531] = 4531,
  [4532] = 4532,
  [4533] = 4533,
  [4534] = 4534,
  [4535] = 4534,
  [4536] = 4534,
  [4537] = 4534,
  [4538] = 4534,
  [4539] = 4534,
  [4540] = 4534,
  [4541] = 4534,
  [4542] = 4534,
  [4543] = 4534,
  [4544] = 4534,
  [4545] = 4534,
  [4546] = 4534,
  [4547] = 4534,
  [4548] = 4534,
  [4549] = 4534,
  [4550] = 4534,
  [4551] = 4551,
  [4552] = 4552,
  [4553] = 4534,
  [4554] = 4534,
  [4555] = 4555,
  [4556] = 4534,
  [4557] = 4534,
  [4558] = 4534,
  [4559] = 4534,
  [4560] = 4534,
  [4561] = 4436,
  [4562] = 4562,
  [4563] = 4562,
  [4564] = 4524,
  [4565] = 4527,
  [4566] = 4562,
  [4567] = 4450,
  [4568] = 4568,
  [4569] = 4562,
  [4570] = 4570,
  [4571] = 4571,
  [4572] = 4562,
  [4573] = 4573,
  [4574] = 4562,
  [4575] = 4575,
  [4576] = 4532,
  [4577] = 4562,
  [4578] = 4578,
  [4579] = 4555,
  [4580] = 4580,
  [4581] = 3126,
  [4582] = 4582,
  [4583] = 4468,
  [4584] = 4552,
  [4585] = 2373,
  [4586] = 4586,
  [4587] = 2305,
  [4588] = 4588,
  [4589] = 4582,
  [4590] = 4590,
  [4591] = 4480,
  [4592] = 4592,
  [4593] = 4593,
  [4594] = 4594,
  [4595] = 4595,
  [4596] = 4596,
  [4597] = 4555,
  [4598] = 4598,
  [4599] = 4552,
  [4600] = 4487,
  [4601] = 4499,
  [4602] = 4602,
  [4603] = 4498,
  [4604] = 4592,
  [4605] = 4590,
  [4606] = 4510,
  [4607] = 4518,
  [4608] = 2218,
  [4609] = 1913,
  [4610] = 4610,
  [4611] = 4611,
  [4612] = 4612,
  [4613] = 4612,
  [4614] = 4612,
  [4615] = 4615,
  [4616] = 4611,
  [4617] = 4611,
  [4618] = 4615,
  [4619] = 4610,
  [4620] = 4610,
  [4621] = 4530,
  [4622] = 4622,
  [4623] = 4622,
  [4624] = 4522,
  [4625] = 4528,
  [4626] = 4622,
  [4627] = 4531,
  [4628] = 4628,
  [4629] = 4526,
  [4630] = 4521,
  [4631] = 4529,
  [4632] = 4533,
  [4633] = 4520,
  [4634] = 4634,
  [4635] = 4532,
  [4636] = 4524,
  [4637] = 4523,
  [4638] = 4622,
  [4639] = 4436,
  [4640] = 4527,
  [4641] = 4525,
  [4642] = 4552,
  [4643] = 4555,
  [4644] = 4450,
  [4645] = 2218,
  [4646] = 2218,
  [4647] = 2089,
  [4648] = 2240,
  [4649] = 4277,
  [4650] = 4368,
  [4651] = 2226,
  [4652] = 4337,
  [4653] = 4527,
  [4654] = 4264,
  [4655] = 4524,
  [4656] = 4468,
  [4657] = 4532,
  [4658] = 4359,
  [4659] = 2087,
  [4660] = 2103,
  [4661] = 2042,
  [4662] = 2040,
  [4663] = 4289,
  [4664] = 4436,
  [4665] = 2088,
  [4666] = 2091,
  [4667] = 2092,
  [4668] = 2093,
  [4669] = 2094,
  [4670] = 2080,
  [4671] = 2095,
  [4672] = 2097,
  [4673] = 2099,
  [4674] = 2100,
  [4675] = 2101,
  [4676] = 2102,
  [4677] = 2081,
  [4678] = 2307,
  [4679] = 2091,
  [4680] = 2092,
  [4681] = 2094,
  [4682] = 2095,
  [4683] = 2097,
  [4684] = 2099,
  [4685] = 2100,
  [4686] = 2101,
  [4687] = 2102,
  [4688] = 2081,
  [4689] = 2088,
  [4690] = 2080,
  [4691] = 4414,
  [4692] = 4401,
  [4693] = 2305,
  [4694] = 2293,
  [4695] = 2086,
  [4696] = 2373,
  [4697] = 2334,
  [4698] = 2411,
  [4699] = 4409,
  [4700] = 2426,
  [4701] = 2413,
  [4702] = 2339,
  [4703] = 2384,
  [4704] = 2042,
  [4705] = 4498,
  [4706] = 4436,
  [4707] = 2423,
  [4708] = 4518,
  [4709] = 2040,
  [4710] = 2385,
  [4711] = 2389,
  [4712] = 2391,
  [4713] = 4480,
  [4714] = 2276,
  [4715] = 2283,
  [4716] = 2281,
  [4717] = 2288,
  [4718] = 2289,
  [4719] = 2387,
  [4720] = 4552,
  [4721] = 4555,
  [4722] = 2369,
  [4723] = 4510,
  [4724] = 4487,
  [4725] = 2312,
  [4726] = 2317,
  [4727] = 2320,
  [4728] = 2370,
  [4729] = 2375,
  [4730] = 2378,
  [4731] = 2087,
  [4732] = 2103,
  [4733] = 4450,
  [4734] = 4392,
  [4735] = 2294,
  [4736] = 2295,
  [4737] = 2299,
  [4738] = 4399,
  [4739] = 2376,
  [4740] = 2377,
  [4741] = 2089,
  [4742] = 2093,
  [4743] = 4524,
  [4744] = 2061,
  [4745] = 4468,
  [4746] = 2054,
  [4747] = 4602,
  [4748] = 4596,
  [4749] = 4594,
  [4750] = 4593,
  [4751] = 4527,
  [4752] = 4552,
  [4753] = 4586,
  [4754] = 4532,
  [4755] = 4755,
  [4756] = 4588,
  [4757] = 4598,
  [4758] = 4450,
  [4759] = 4595,
  [4760] = 4468,
  [4761] = 3126,
  [4762] = 4580,
  [4763] = 4555,
  [4764] = 4453,
  [4765] = 1914,
  [4766] = 1909,
  [4767] = 4634,
  [4768] = 4533,
  [4769] = 2054,
  [4770] = 4525,
  [4771] = 4530,
  [4772] = 1907,
  [4773] = 2061,
  [4774] = 4529,
  [4775] = 4628,
  [4776] = 4528,
  [4777] = 1912,
  [4778] = 1915,
  [4779] = 3221,
  [4780] = 1911,
  [4781] = 4781,
  [4782] = 4523,
  [4783] = 4521,
  [4784] = 4781,
  [4785] = 4434,
  [4786] = 4435,
  [4787] = 3204,
  [4788] = 4447,
  [4789] = 4448,
  [4790] = 4449,
  [4791] = 4452,
  [4792] = 1914,
  [4793] = 4522,
  [4794] = 4531,
  [4795] = 4781,
  [4796] = 4520,
  [4797] = 4498,
  [4798] = 4781,
  [4799] = 4480,
  [4800] = 1913,
  [4801] = 4458,
  [4802] = 4487,
  [4803] = 4445,
  [4804] = 4487,
  [4805] = 1908,
  [4806] = 4552,
  [4807] = 4555,
  [4808] = 1906,
  [4809] = 4444,
  [4810] = 1907,
  [4811] = 4478,
  [4812] = 4812,
  [4813] = 1912,
  [4814] = 4433,
  [4815] = 4432,
  [4816] = 4443,
  [4817] = 4480,
  [4818] = 4440,
  [4819] = 4451,
  [4820] = 1913,
  [4821] = 4781,
  [4822] = 4476,
  [4823] = 4510,
  [4824] = 4455,
  [4825] = 4459,
  [4826] = 4456,
  [4827] = 4499,
  [4828] = 4457,
  [4829] = 4439,
  [4830] = 1915,
  [4831] = 4446,
  [4832] = 4454,
  [4833] = 4510,
  [4834] = 1911,
  [4835] = 4526,
  [4836] = 1908,
  [4837] = 4527,
  [4838] = 4838,
  [4839] = 4532,
  [4840] = 4462,
  [4841] = 4461,
  [4842] = 4842,
  [4843] = 4472,
  [4844] = 3126,
  [4845] = 4438,
  [4846] = 4552,
  [4847] = 4437,
  [4848] = 1907,
  [4849] = 4506,
  [4850] = 4555,
  [4851] = 4838,
  [4852] = 4469,
  [4853] = 4853,
  [4854] = 4467,
  [4855] = 4602,
  [4856] = 4856,
  [4857] = 4856,
  [4858] = 1914,
  [4859] = 4438,
  [4860] = 4437,
  [4861] = 4498,
  [4862] = 4594,
  [4863] = 1913,
  [4864] = 1909,
  [4865] = 4865,
  [4866] = 4865,
  [4867] = 4595,
  [4868] = 4856,
  [4869] = 2189,
  [4870] = 1906,
  [4871] = 4596,
  [4872] = 4865,
  [4873] = 4598,
  [4874] = 4593,
  [4875] = 4838,
  [4876] = 4853,
  [4877] = 4877,
  [4878] = 4524,
  [4879] = 1912,
  [4880] = 1915,
  [4881] = 1911,
  [4882] = 4853,
  [4883] = 4531,
  [4884] = 4508,
  [4885] = 4528,
  [4886] = 4533,
  [4887] = 4887,
  [4888] = 4523,
  [4889] = 4521,
  [4890] = 4890,
  [4891] = 4891,
  [4892] = 4484,
  [4893] = 4525,
  [4894] = 4489,
  [4895] = 4526,
  [4896] = 4896,
  [4897] = 4897,
  [4898] = 4898,
  [4899] = 4890,
  [4900] = 4890,
  [4901] = 4891,
  [4902] = 4891,
  [4903] = 4897,
  [4904] = 4898,
  [4905] = 4520,
  [4906] = 4887,
  [4907] = 4532,
  [4908] = 4483,
  [4909] = 4887,
  [4910] = 4486,
  [4911] = 4521,
  [4912] = 4505,
  [4913] = 4898,
  [4914] = 4890,
  [4915] = 4552,
  [4916] = 4555,
  [4917] = 4496,
  [4918] = 4891,
  [4919] = 4524,
  [4920] = 4525,
  [4921] = 4530,
  [4922] = 4527,
  [4923] = 4532,
  [4924] = 4897,
  [4925] = 4896,
  [4926] = 4896,
  [4927] = 4890,
  [4928] = 4897,
  [4929] = 4891,
  [4930] = 4898,
  [4931] = 4897,
  [4932] = 4524,
  [4933] = 4898,
  [4934] = 4527,
  [4935] = 4530,
  [4936] = 4522,
  [4937] = 4463,
  [4938] = 4532,
  [4939] = 4481,
  [4940] = 2223,
  [4941] = 4490,
  [4942] = 2095,
  [4943] = 4555,
  [4944] = 2097,
  [4945] = 2099,
  [4946] = 2100,
  [4947] = 2101,
  [4948] = 4526,
  [4949] = 2085,
  [4950] = 2102,
  [4951] = 2081,
  [4952] = 2088,
  [4953] = 2080,
  [4954] = 4528,
  [4955] = 4522,
  [4956] = 4531,
  [4957] = 4957,
  [4958] = 4495,
  [4959] = 4527,
  [4960] = 4960,
  [4961] = 4961,
  [4962] = 4494,
  [4963] = 4960,
  [4964] = 4961,
  [4965] = 4511,
  [4966] = 4966,
  [4967] = 4514,
  [4968] = 4968,
  [4969] = 4493,
  [4970] = 4533,
  [4971] = 4485,
  [4972] = 4520,
  [4973] = 2087,
  [4974] = 4502,
  [4975] = 4552,
  [4976] = 4555,
  [4977] = 4497,
  [4978] = 2089,
  [4979] = 4532,
  [4980] = 4980,
  [4981] = 4509,
  [4982] = 4479,
  [4983] = 2086,
  [4984] = 2241,
  [4985] = 4482,
  [4986] = 4986,
  [4987] = 2091,
  [4988] = 2092,
  [4989] = 4989,
  [4990] = 4552,
  [4991] = 2093,
  [4992] = 4524,
  [4993] = 4507,
  [4994] = 4966,
  [4995] = 2094,
  [4996] = 2221,
  [4997] = 2082,
  [4998] = 4998,
  [4999] = 4960,
  [5000] = 4524,
  [5001] = 4523,
  [5002] = 4961,
  [5003] = 4968,
  [5004] = 4961,
  [5005] = 4504,
  [5006] = 4501,
  [5007] = 5007,
  [5008] = 2103,
  [5009] = 4960,
  [5010] = 4966,
  [5011] = 4527,
  [5012] = 2096,
  [5013] = 4966,
  [5014] = 5014,
  [5015] = 4968,
  [5016] = 4477,
  [5017] = 4966,
  [5018] = 4492,
  [5019] = 4968,
  [5020] = 4968,
  [5021] = 4500,
  [5022] = 5022,
  [5023] = 4960,
  [5024] = 5024,
  [5025] = 4513,
  [5026] = 4986,
  [5027] = 2050,
  [5028] = 4957,
  [5029] = 5029,
  [5030] = 4503,
  [5031] = 4491,
  [5032] = 4488,
  [5033] = 5033,
  [5034] = 4957,
  [5035] = 4961,
  [5036] = 4512,
  [5037] = 2207,
  [5038] = 5038,
  [5039] = 5038,
  [5040] = 5040,
  [5041] = 5041,
  [5042] = 5042,
  [5043] = 5043,
  [5044] = 2082,
  [5045] = 5038,
  [5046] = 5046,
  [5047] = 5047,
  [5048] = 5041,
  [5049] = 5049,
  [5050] = 4527,
  [5051] = 5046,
  [5052] = 5049,
  [5053] = 5043,
  [5054] = 5054,
  [5055] = 5055,
  [5056] = 4524,
  [5057] = 5057,
  [5058] = 5038,
  [5059] = 5059,
  [5060] = 5038,
  [5061] = 5038,
  [5062] = 5042,
  [5063] = 5059,
  [5064] = 5043,
  [5065] = 5065,
  [5066] = 4527,
  [5067] = 5043,
  [5068] = 5038,
  [5069] = 5069,
  [5070] = 5038,
  [5071] = 5071,
  [5072] = 4524,
  [5073] = 5038,
  [5074] = 5074,
  [5075] = 5075,
  [5076] = 5059,
  [5077] = 5057,
  [5078] = 5078,
  [5079] = 5069,
  [5080] = 5047,
  [5081] = 5081,
  [5082] = 5082,
  [5083] = 5043,
  [5084] = 5074,
  [5085] = 5038,
  [5086] = 5059,
  [5087] = 5087,
  [5088] = 5046,
  [5089] = 5043,
  [5090] = 5074,
  [5091] = 4532,
  [5092] = 5069,
  [5093] = 5057,
  [5094] = 5038,
  [5095] = 5074,
  [5096] = 5057,
  [5097] = 5038,
  [5098] = 5098,
  [5099] = 5038,
  [5100] = 5069,
  [5101] = 5041,
  [5102] = 5038,
  [5103] = 5038,
  [5104] = 4532,
  [5105] = 4552,
  [5106] = 4555,
  [5107] = 5047,
  [5108] = 5108,
  [5109] = 5078,
  [5110] = 2096,
  [5111] = 5081,
  [5112] = 2087,
  [5113] = 2103,
  [5114] = 5082,
  [5115] = 5046,
  [5116] = 5098,
  [5117] = 2218,
  [5118] = 2089,
  [5119] = 2091,
  [5120] = 2092,
  [5121] = 5078,
  [5122] = 5081,
  [5123] = 5078,
  [5124] = 2085,
  [5125] = 5082,
  [5126] = 5081,
  [5127] = 2093,
  [5128] = 2094,
  [5129] = 5046,
  [5130] = 5038,
  [5131] = 5038,
  [5132] = 2095,
  [5133] = 2097,
  [5134] = 5038,
  [5135] = 2099,
  [5136] = 5038,
  [5137] = 2100,
  [5138] = 2101,
  [5139] = 5038,
  [5140] = 2102,
  [5141] = 2081,
  [5142] = 2088,
  [5143] = 2080,
  [5144] = 5054,
  [5145] = 5055,
  [5146] = 5038,
  [5147] = 5049,
  [5148] = 5047,
  [5149] = 5049,
  [5150] = 2050,
  [5151] = 5151,
  [5152] = 5038,
  [5153] = 5038,
  [5154] = 5154,
  [5155] = 5155,
  [5156] = 5041,
  [5157] = 4989,
  [5158] = 5038,
  [5159] = 5038,
  [5160] = 5054,
  [5161] = 5055,
  [5162] = 5059,
  [5163] = 2198,
  [5164] = 5038,
  [5165] = 5098,
  [5166] = 5082,
  [5167] = 5167,
  [5168] = 5054,
  [5169] = 5041,
  [5170] = 5042,
  [5171] = 5038,
  [5172] = 5046,
  [5173] = 5098,
  [5174] = 5038,
  [5175] = 5054,
  [5176] = 5047,
  [5177] = 5049,
  [5178] = 5038,
  [5179] = 5055,
  [5180] = 5038,
  [5181] = 5042,
  [5182] = 5038,
  [5183] = 5055,
  [5184] = 5038,
  [5185] = 5038,
  [5186] = 5074,
  [5187] = 5038,
  [5188] = 5038,
  [5189] = 5038,
  [5190] = 5038,
  [5191] = 5038,
  [5192] = 5038,
  [5193] = 5038,
  [5194] = 5038,
  [5195] = 5038,
  [5196] = 5038,
  [5197] = 5038,
  [5198] = 5041,
  [5199] = 5038,
  [5200] = 5042,
  [5201] = 5043,
  [5202] = 5078,
  [5203] = 5069,
  [5204] = 5081,
  [5205] = 5057,
  [5206] = 5082,
  [5207] = 5098,
  [5208] = 5038,
  [5209] = 5046,
  [5210] = 5042,
  [5211] = 2204,
  [5212] = 2086,
  [5213] = 5038,
  [5214] = 5214,
  [5215] = 5215,
  [5216] = 5216,
  [5217] = 5217,
  [5218] = 5218,
  [5219] = 1913,
  [5220] = 5220,
  [5221] = 5221,
  [5222] = 5217,
  [5223] = 5223,
  [5224] = 5217,
  [5225] = 5225,
  [5226] = 5226,
  [5227] = 5227,
  [5228] = 5228,
  [5229] = 5214,
  [5230] = 2246,
  [5231] = 5231,
  [5232] = 5223,
  [5233] = 2247,
  [5234] = 2253,
  [5235] = 5214,
  [5236] = 4555,
  [5237] = 2222,
  [5238] = 5238,
  [5239] = 4524,
  [5240] = 5240,
  [5241] = 4527,
  [5242] = 5216,
  [5243] = 5243,
  [5244] = 2112,
  [5245] = 5245,
  [5246] = 5246,
  [5247] = 5247,
  [5248] = 5226,
  [5249] = 5218,
  [5250] = 5250,
  [5251] = 5223,
  [5252] = 5252,
  [5253] = 5220,
  [5254] = 5228,
  [5255] = 5246,
  [5256] = 5250,
  [5257] = 4552,
  [5258] = 5240,
  [5259] = 5259,
  [5260] = 4552,
  [5261] = 4555,
  [5262] = 2242,
  [5263] = 5263,
  [5264] = 5217,
  [5265] = 2235,
  [5266] = 5228,
  [5267] = 4552,
  [5268] = 5268,
  [5269] = 5238,
  [5270] = 5240,
  [5271] = 4555,
  [5272] = 5226,
  [5273] = 5216,
  [5274] = 5218,
  [5275] = 2323,
  [5276] = 2110,
  [5277] = 2488,
  [5278] = 5268,
  [5279] = 5238,
  [5280] = 5268,
  [5281] = 5246,
  [5282] = 5250,
  [5283] = 2337,
  [5284] = 2104,
  [5285] = 4532,
  [5286] = 5286,
  [5287] = 5287,
  [5288] = 5217,
  [5289] = 5220,
  [5290] = 2240,
  [5291] = 5291,
  [5292] = 5292,
  [5293] = 5293,
  [5294] = 5294,
  [5295] = 5295,
  [5296] = 5252,
  [5297] = 5297,
  [5298] = 5287,
  [5299] = 5299,
  [5300] = 5300,
  [5301] = 5301,
  [5302] = 5302,
  [5303] = 5303,
  [5304] = 5297,
  [5305] = 5231,
  [5306] = 5300,
  [5307] = 5297,
  [5308] = 5231,
  [5309] = 5301,
  [5310] = 1913,
  [5311] = 1913,
  [5312] = 2364,
  [5313] = 5300,
  [5314] = 5314,
  [5315] = 5293,
  [5316] = 5293,
  [5317] = 5317,
  [5318] = 5301,
  [5319] = 2226,
  [5320] = 5320,
  [5321] = 5321,
  [5322] = 5252,
  [5323] = 5323,
  [5324] = 4511,
  [5325] = 2267,
  [5326] = 5326,
  [5327] = 2375,
  [5328] = 2419,
  [5329] = 2420,
  [5330] = 2392,
  [5331] = 2421,
  [5332] = 2353,
  [5333] = 2422,
  [5334] = 4555,
  [5335] = 2409,
  [5336] = 2414,
  [5337] = 2351,
  [5338] = 2284,
  [5339] = 2352,
  [5340] = 2286,
  [5341] = 2326,
  [5342] = 2358,
  [5343] = 2359,
  [5344] = 5344,
  [5345] = 2306,
  [5346] = 2328,
  [5347] = 5347,
  [5348] = 5348,
  [5349] = 2273,
  [5350] = 2332,
  [5351] = 2435,
  [5352] = 2376,
  [5353] = 2377,
  [5354] = 2394,
  [5355] = 2416,
  [5356] = 2274,
  [5357] = 2296,
  [5358] = 2344,
  [5359] = 2345,
  [5360] = 2366,
  [5361] = 2368,
  [5362] = 2371,
  [5363] = 2378,
  [5364] = 2407,
  [5365] = 2408,
  [5366] = 2290,
  [5367] = 2369,
  [5368] = 2386,
  [5369] = 2331,
  [5370] = 2334,
  [5371] = 2330,
  [5372] = 2404,
  [5373] = 2379,
  [5374] = 2411,
  [5375] = 2385,
  [5376] = 2291,
  [5377] = 5377,
  [5378] = 2389,
  [5379] = 2383,
  [5380] = 2426,
  [5381] = 2300,
  [5382] = 5382,
  [5383] = 2413,
  [5384] = 2391,
  [5385] = 2309,
  [5386] = 5386,
  [5387] = 2315,
  [5388] = 2316,
  [5389] = 2322,
  [5390] = 4552,
  [5391] = 2418,
  [5392] = 2425,
  [5393] = 5167,
  [5394] = 5344,
  [5395] = 5344,
  [5396] = 2305,
  [5397] = 5344,
  [5398] = 5398,
  [5399] = 2043,
  [5400] = 2423,
  [5401] = 2333,
  [5402] = 4392,
  [5403] = 5344,
  [5404] = 5404,
  [5405] = 5405,
  [5406] = 2327,
  [5407] = 5407,
  [5408] = 5408,
  [5409] = 5409,
  [5410] = 5410,
  [5411] = 2434,
  [5412] = 5412,
  [5413] = 2339,
  [5414] = 5414,
  [5415] = 5415,
  [5416] = 5386,
  [5417] = 2384,
  [5418] = 2433,
  [5419] = 2275,
  [5420] = 4532,
  [5421] = 2294,
  [5422] = 5414,
  [5423] = 2365,
  [5424] = 5424,
  [5425] = 2340,
  [5426] = 5426,
  [5427] = 2295,
  [5428] = 2299,
  [5429] = 2373,
  [5430] = 5377,
  [5431] = 2307,
  [5432] = 2276,
  [5433] = 2277,
  [5434] = 2283,
  [5435] = 2281,
  [5436] = 2308,
  [5437] = 2393,
  [5438] = 5408,
  [5439] = 2329,
  [5440] = 2280,
  [5441] = 2288,
  [5442] = 2289,
  [5443] = 2350,
  [5444] = 2387,
  [5445] = 5377,
  [5446] = 5446,
  [5447] = 2347,
  [5448] = 5415,
  [5449] = 5405,
  [5450] = 2278,
  [5451] = 2313,
  [5452] = 2312,
  [5453] = 2314,
  [5454] = 2318,
  [5455] = 2319,
  [5456] = 2324,
  [5457] = 2317,
  [5458] = 2325,
  [5459] = 2335,
  [5460] = 2336,
  [5461] = 4552,
  [5462] = 4555,
  [5463] = 5463,
  [5464] = 5464,
  [5465] = 2431,
  [5466] = 2405,
  [5467] = 2320,
  [5468] = 5344,
  [5469] = 5469,
  [5470] = 2370,
  [5471] = 2424,
  [5472] = 2304,
  [5473] = 2361,
  [5474] = 5474,
  [5475] = 2342,
  [5476] = 2363,
  [5477] = 2367,
  [5478] = 2348,
  [5479] = 2372,
  [5480] = 2285,
  [5481] = 5344,
  [5482] = 2374,
  [5483] = 2380,
  [5484] = 5414,
  [5485] = 5485,
  [5486] = 2343,
  [5487] = 2382,
  [5488] = 2293,
  [5489] = 2402,
  [5490] = 5410,
  [5491] = 2396,
  [5492] = 5492,
  [5493] = 5297,
  [5494] = 5405,
  [5495] = 2104,
  [5496] = 5496,
  [5497] = 5497,
  [5498] = 5498,
  [5499] = 5259,
  [5500] = 5500,
  [5501] = 5501,
  [5502] = 5502,
  [5503] = 5503,
  [5504] = 5377,
  [5505] = 2112,
  [5506] = 5506,
  [5507] = 5507,
  [5508] = 5508,
  [5509] = 5501,
  [5510] = 5510,
  [5511] = 5511,
  [5512] = 5512,
  [5513] = 5513,
  [5514] = 5514,
  [5515] = 5515,
  [5516] = 5507,
  [5517] = 5496,
  [5518] = 5510,
  [5519] = 5513,
  [5520] = 5221,
  [5521] = 2110,
  [5522] = 5514,
  [5523] = 5501,
  [5524] = 5524,
  [5525] = 5525,
  [5526] = 5526,
  [5527] = 5502,
  [5528] = 5528,
  [5529] = 5502,
  [5530] = 5524,
  [5531] = 5525,
  [5532] = 5502,
  [5533] = 5496,
  [5534] = 5534,
  [5535] = 5535,
  [5536] = 5528,
  [5537] = 5496,
  [5538] = 5535,
  [5539] = 5539,
  [5540] = 5501,
  [5541] = 5541,
  [5542] = 5526,
  [5543] = 5543,
  [5544] = 5514,
  [5545] = 5545,
  [5546] = 5498,
  [5547] = 5503,
  [5548] = 5535,
  [5549] = 5507,
  [5550] = 5535,
  [5551] = 5551,
  [5552] = 5552,
  [5553] = 5553,
  [5554] = 5514,
  [5555] = 5508,
  [5556] = 5514,
  [5557] = 5496,
  [5558] = 5541,
  [5559] = 5559,
  [5560] = 5502,
  [5561] = 5497,
  [5562] = 5562,
  [5563] = 5535,
  [5564] = 5227,
  [5565] = 5286,
  [5566] = 5503,
  [5567] = 5551,
  [5568] = 5562,
  [5569] = 5569,
  [5570] = 5551,
  [5571] = 5497,
  [5572] = 5498,
  [5573] = 5515,
  [5574] = 5243,
  [5575] = 5501,
  [5576] = 5541,
  [5577] = 5245,
  [5578] = 5578,
  [5579] = 5579,
  [5580] = 5578,
  [5581] = 5578,
  [5582] = 5578,
  [5583] = 5579,
  [5584] = 5584,
  [5585] = 5578,
  [5586] = 5586,
  [5587] = 5579,
  [5588] = 5579,
  [5589] = 5578,
  [5590] = 5590,
  [5591] = 5579,
  [5592] = 5578,
  [5593] = 5578,
  [5594] = 5578,
  [5595] = 5579,
  [5596] = 5579,
  [5597] = 5586,
  [5598] = 5578,
  [5599] = 5579,
  [5600] = 5578,
  [5601] = 5578,
  [5602] = 5602,
  [5603] = 5579,
  [5604] = 5578,
  [5605] = 5579,
  [5606] = 1909,
  [5607] = 5602,
  [5608] = 5578,
  [5609] = 5578,
  [5610] = 5579,
  [5611] = 5579,
  [5612] = 5579,
  [5613] = 5578,
  [5614] = 5579,
  [5615] = 5579,
  [5616] = 5578,
  [5617] = 5578,
  [5618] = 5618,
  [5619] = 5578,
  [5620] = 5579,
  [5621] = 5621,
  [5622] = 5578,
  [5623] = 5579,
  [5624] = 5579,
  [5625] = 5625,
  [5626] = 5579,
  [5627] = 5579,
  [5628] = 5628,
  [5629] = 5579,
  [5630] = 5625,
  [5631] = 5579,
  [5632] = 5579,
  [5633] = 5578,
  [5634] = 5579,
  [5635] = 5578,
  [5636] = 5636,
  [5637] = 5578,
  [5638] = 5625,
  [5639] = 5578,
  [5640] = 5640,
  [5641] = 5641,
  [5642] = 5642,
  [5643] = 5643,
  [5644] = 5644,
  [5645] = 5645,
  [5646] = 5646,
  [5647] = 5647,
  [5648] = 5648,
  [5649] = 5649,
  [5650] = 5650,
  [5651] = 5651,
  [5652] = 5652,
  [5653] = 5653,
  [5654] = 5654,
  [5655] = 5644,
  [5656] = 5656,
  [5657] = 5657,
  [5658] = 5658,
  [5659] = 5659,
  [5660] = 5649,
  [5661] = 5661,
  [5662] = 5662,
  [5663] = 5643,
  [5664] = 5664,
  [5665] = 5665,
  [5666] = 5651,
  [5667] = 5667,
  [5668] = 5668,
  [5669] = 5662,
  [5670] = 5670,
  [5671] = 5671,
  [5672] = 5668,
  [5673] = 5673,
  [5674] = 5649,
  [5675] = 5675,
  [5676] = 5676,
  [5677] = 5662,
  [5678] = 5662,
  [5679] = 5668,
  [5680] = 5653,
  [5681] = 5664,
  [5682] = 5682,
  [5683] = 5683,
  [5684] = 5683,
  [5685] = 5682,
  [5686] = 5686,
  [5687] = 5662,
  [5688] = 5688,
  [5689] = 5653,
  [5690] = 5650,
  [5691] = 5643,
  [5692] = 5692,
  [5693] = 5693,
  [5694] = 5694,
  [5695] = 5695,
  [5696] = 5696,
  [5697] = 5697,
  [5698] = 5698,
  [5699] = 5699,
  [5700] = 5700,
  [5701] = 5662,
  [5702] = 5676,
  [5703] = 5668,
  [5704] = 5704,
  [5705] = 5705,
  [5706] = 5706,
  [5707] = 5707,
  [5708] = 5662,
  [5709] = 5645,
  [5710] = 5710,
  [5711] = 5662,
  [5712] = 5646,
  [5713] = 5713,
  [5714] = 5668,
  [5715] = 5665,
  [5716] = 5668,
  [5717] = 5717,
  [5718] = 5650,
  [5719] = 5650,
  [5720] = 5720,
  [5721] = 5652,
  [5722] = 5722,
  [5723] = 5723,
  [5724] = 5645,
  [5725] = 5725,
  [5726] = 5659,
  [5727] = 5652,
  [5728] = 5667,
  [5729] = 5729,
  [5730] = 5653,
  [5731] = 5731,
  [5732] = 5662,
  [5733] = 5654,
  [5734] = 5656,
  [5735] = 5735,
  [5736] = 5722,
  [5737] = 5668,
  [5738] = 5668,
  [5739] = 5739,
  [5740] = 5665,
  [5741] = 5642,
  [5742] = 5713,
  [5743] = 5642,
  [5744] = 5641,
  [5745] = 5692,
  [5746] = 5692,
  [5747] = 5657,
  [5748] = 5748,
  [5749] = 5697,
  [5750] = 5656,
  [5751] = 5657,
  [5752] = 5661,
  [5753] = 5753,
  [5754] = 5644,
  [5755] = 5661,
  [5756] = 5646,
  [5757] = 5757,
  [5758] = 5662,
  [5759] = 5753,
  [5760] = 5673,
  [5761] = 5650,
  [5762] = 5717,
  [5763] = 5652,
  [5764] = 5764,
  [5765] = 5641,
  [5766] = 5646,
  [5767] = 5767,
  [5768] = 5668,
  [5769] = 5642,
  [5770] = 5656,
  [5771] = 5692,
  [5772] = 5682,
  [5773] = 5676,
  [5774] = 5774,
  [5775] = 5662,
  [5776] = 5653,
  [5777] = 5682,
  [5778] = 5668,
  [5779] = 5662,
  [5780] = 5729,
  [5781] = 5665,
  [5782] = 5668,
  [5783] = 5641,
  [5784] = 5662,
  [5785] = 5662,
  [5786] = 5739,
  [5787] = 5668,
  [5788] = 5665,
  [5789] = 5651,
  [5790] = 5668,
  [5791] = 5644,
  [5792] = 5646,
  [5793] = 5671,
  [5794] = 5648,
  [5795] = 5713,
  [5796] = 5641,
  [5797] = 5662,
  [5798] = 5659,
  [5799] = 5668,
  [5800] = 5671,
  [5801] = 5644,
  [5802] = 5802,
  [5803] = 5803,
  [5804] = 5668,
  [5805] = 5665,
  [5806] = 5806,
  [5807] = 5720,
  [5808] = 5668,
  [5809] = 5668,
  [5810] = 5668,
  [5811] = 5665,
  [5812] = 5682,
  [5813] = 5748,
  [5814] = 5713,
  [5815] = 5815,
  [5816] = 5642,
  [5817] = 5662,
  [5818] = 5662,
  [5819] = 5668,
  [5820] = 5713,
  [5821] = 5668,
  [5822] = 5650,
  [5823] = 5652,
  [5824] = 5668,
  [5825] = 5659,
  [5826] = 5748,
  [5827] = 5668,
  [5828] = 5641,
  [5829] = 5673,
  [5830] = 5692,
  [5831] = 5668,
  [5832] = 5688,
  [5833] = 5668,
  [5834] = 5665,
  [5835] = 5767,
  [5836] = 5647,
  [5837] = 5806,
  [5838] = 5838,
  [5839] = 5640,
  [5840] = 5658,
  [5841] = 5704,
  [5842] = 5815,
  [5843] = 5668,
  [5844] = 5662,
  [5845] = 5662,
  [5846] = 5659,
  [5847] = 5668,
  [5848] = 5652,
  [5849] = 5688,
  [5850] = 5668,
  [5851] = 5659,
  [5852] = 5668,
  [5853] = 5668,
  [5854] = 5668,
  [5855] = 5668,
  [5856] = 5670,
  [5857] = 5668,
  [5858] = 5858,
  [5859] = 5653,
  [5860] = 5668,
  [5861] = 5656,
  [5862] = 5668,
  [5863] = 5863,
  [5864] = 5642,
  [5865] = 5692,
  [5866] = 5653,
  [5867] = 5668,
  [5868] = 5868,
  [5869] = 5646,
  [5870] = 5668,
  [5871] = 5803,
  [5872] = 5668,
  [5873] = 5806,
  [5874] = 5668,
  [5875] = 5643,
  [5876] = 5675,
  [5877] = 5668,
  [5878] = 5650,
  [5879] = 5642,
  [5880] = 5692,
  [5881] = 5881,
  [5882] = 5882,
  [5883] = 5652,
  [5884] = 5662,
  [5885] = 5664,
  [5886] = 5641,
  [5887] = 5662,
  [5888] = 5668,
  [5889] = 5889,
  [5890] = 5890,
  [5891] = 5891,
  [5892] = 1911,
  [5893] = 1914,
  [5894] = 5693,
  [5895] = 5895,
  [5896] = 5650,
  [5897] = 5652,
  [5898] = 5863,
  [5899] = 5665,
  [5900] = 5731,
  [5901] = 5704,
  [5902] = 5704,
  [5903] = 5707,
  [5904] = 5815,
  [5905] = 5683,
  [5906] = 5653,
  [5907] = 5662,
  [5908] = 5694,
  [5909] = 5889,
  [5910] = 5910,
  [5911] = 5723,
  [5912] = 5686,
  [5913] = 5648,
  [5914] = 5659,
  [5915] = 5696,
  [5916] = 5725,
  [5917] = 5643,
  [5918] = 5735,
  [5919] = 5662,
  [5920] = 5858,
  [5921] = 5653,
  [5922] = 5659,
  [5923] = 5641,
  [5924] = 5729,
  [5925] = 5642,
  [5926] = 5692,
  [5927] = 5641,
  [5928] = 5698,
  [5929] = 5668,
  [5930] = 5890,
  [5931] = 5692,
  [5932] = 5646,
  [5933] = 5640,
  [5934] = 5665,
  [5935] = 5731,
  [5936] = 5723,
  [5937] = 5650,
  [5938] = 5643,
  [5939] = 5668,
  [5940] = 5652,
  [5941] = 5647,
  [5942] = 5641,
  [5943] = 5665,
  [5944] = 5668,
  [5945] = 5767,
  [5946] = 5662,
  [5947] = 5653,
  [5948] = 5646,
  [5949] = 5890,
  [5950] = 5665,
  [5951] = 5647,
  [5952] = 5642,
  [5953] = 5659,
  [5954] = 5646,
  [5955] = 5668,
  [5956] = 5662,
  [5957] = 5957,
  [5958] = 5717,
  [5959] = 5699,
  [5960] = 5700,
  [5961] = 5704,
  [5962] = 5686,
  [5963] = 5668,
  [5964] = 5964,
  [5965] = 5643,
  [5966] = 5668,
  [5967] = 5895,
  [5968] = 5964,
  [5969] = 5642,
  [5970] = 5692,
  [5971] = 5675,
  [5972] = 5707,
  [5973] = 5646,
  [5974] = 5974,
  [5975] = 5658,
  [5976] = 5739,
  [5977] = 5858,
  [5978] = 5978,
  [5979] = 5895,
  [5980] = 5647,
  [5981] = 5670,
  [5982] = 5757,
  [5983] = 5863,
  [5984] = 5650,
  [5985] = 5803,
  [5986] = 5652,
  [5987] = 5659,
  [5988] = 5889,
  [5989] = 5989,
  [5990] = 5990,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 361,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 279,
        '+', 335,
        ',', 271,
        '-', 352,
        '.', 264,
        '/', 338,
        '0', 364,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 360,
        '>', 330,
        '?', 317,
        '@', 139,
        'B', 373,
        'E', 376,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(172);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '`') ADVANCE(358);
      if (lookahead == 'd') ADVANCE(403);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`') ADVANCE(408);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0) ADVANCE(1);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(85);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(85);
      if (lookahead == '\r') SKIP(2);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(84);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(84);
      if (lookahead == '\r') SKIP(4);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(86);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(86);
      if (lookahead == '\r') SKIP(6);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(87);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(87);
      if (lookahead == '\r') SKIP(8);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(102);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(102);
      if (lookahead == '\r') SKIP(10);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(101);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(101);
      if (lookahead == '\r') SKIP(12);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(115);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(115);
      if (lookahead == '\r') SKIP(14);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(91);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(91);
      if (lookahead == '\r') SKIP(16);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(93);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(93);
      if (lookahead == '\r') SKIP(18);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(97);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(97);
      if (lookahead == '\r') SKIP(20);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(76);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(76);
      if (lookahead == '\r') SKIP(22);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(98);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(98);
      if (lookahead == '\r') SKIP(24);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(80);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(80);
      if (lookahead == '\r') SKIP(26);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(107);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(107);
      if (lookahead == '\r') SKIP(28);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(106);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(106);
      if (lookahead == '\r') SKIP(30);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(116);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(116);
      if (lookahead == '\r') SKIP(32);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(105);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(105);
      if (lookahead == '\r') SKIP(34);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(112);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(112);
      if (lookahead == '\r') SKIP(36);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(113);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(113);
      if (lookahead == '\r') SKIP(38);
      END_STATE();
    case 40:
      if (lookahead == '\n') ADVANCE(424);
      if (lookahead == '\r') ADVANCE(423);
      if (lookahead == 'u') ADVANCE(150);
      if (lookahead == 'x') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(427);
      if (lookahead != 0) ADVANCE(423);
      END_STATE();
    case 41:
      if (lookahead == '\n') ADVANCE(425);
      if (lookahead == '\r') ADVANCE(423);
      if (lookahead == 'u') ADVANCE(150);
      if (lookahead == 'x') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(427);
      if (lookahead != 0) ADVANCE(423);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(119);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(119);
      if (lookahead == '\r') SKIP(42);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(68);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(68);
      if (lookahead == '\r') SKIP(44);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(82);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(82);
      if (lookahead == '\r') SKIP(46);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(69);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(69);
      if (lookahead == '\r') SKIP(48);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(92);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(92);
      if (lookahead == '\r') SKIP(50);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(96);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(96);
      if (lookahead == '\r') SKIP(52);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(78);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(78);
      if (lookahead == '\r') SKIP(54);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(117);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(117);
      if (lookahead == '\r') SKIP(56);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(108);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(108);
      if (lookahead == '\r') SKIP(58);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(72);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(72);
      if (lookahead == '\r') SKIP(60);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(71);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(71);
      if (lookahead == '\r') SKIP(62);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(74);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(74);
      if (lookahead == '\r') SKIP(64);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 364,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 364,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(45);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 364,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(45);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 364,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 364,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(61);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 364,
        ':', 320,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(63);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 364,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(61);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 364,
        ':', 319,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(63);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 74:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 284,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '/', 337,
        '0', 364,
        ':', 320,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(65);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(74);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 282,
        '(', 261,
        '*', 278,
        '+', 336,
        '-', 352,
        '.', 127,
        '/', 337,
        ':', 286,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(358);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 76:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 282,
        '(', 261,
        '*', 278,
        '+', 336,
        '-', 352,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(358);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 77:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 352,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 360,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(358);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(78);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 78:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 352,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(358);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(78);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 79:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '%', 339,
        '&', 282,
        '(', 296,
        '*', 278,
        '+', 336,
        '-', 352,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(358);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 352,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(358);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '&', 124,
        '(', 296,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 364,
        ':', 128,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 373,
        'E', 376,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(82);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '&', 124,
        '(', 261,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 364,
        ':', 129,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 373,
        'E', 376,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(82);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '&', 124,
        '(', 261,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 364,
        ':', 128,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 373,
        'E', 376,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(82);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 84:
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 138,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(84);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 373,
        'E', 376,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(3);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(85);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(395);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        'B', 373,
        'E', 376,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(7);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(86);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '(', 261,
        '*', 278,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        '=', 142,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(87);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 89:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(93);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 90:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 319,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(92);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 91:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 318,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(92);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 93:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(93);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 94:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(97);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 319,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(96);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 318,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(96);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 97:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(97);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 98:
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 339,
        '&', 284,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 125,
        '/', 337,
        ':', 318,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(98);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 99:
      if (lookahead == '#') ADVANCE(361);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(421);
      END_STATE();
    case 100:
      if (lookahead == '#') ADVANCE(361);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') ADVANCE(41);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(100);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '#', 362,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 138,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 102:
      ADVANCE_MAP(
        '#', 362,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(11);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(102);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 103:
      ADVANCE_MAP(
        '#', 362,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ':', 286,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(105);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        '#', 362,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ':', 286,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(106);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 105:
      ADVANCE_MAP(
        '#', 362,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(105);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 106:
      ADVANCE_MAP(
        '#', 362,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(106);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 107:
      ADVANCE_MAP(
        '#', 362,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(107);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 108:
      ADVANCE_MAP(
        '#', 362,
        '&', 282,
        '(', 261,
        '*', 278,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(59);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(108);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 109:
      ADVANCE_MAP(
        '#', 362,
        '&', 282,
        '(', 261,
        '*', 278,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 359,
      );
      if (lookahead == '\\') SKIP(59);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(108);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 110:
      ADVANCE_MAP(
        '#', 362,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(37);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 111:
      ADVANCE_MAP(
        '#', 362,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(39);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(113);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 112:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(37);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 113:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == '=') ADVANCE(267);
      if (lookahead == '\\') SKIP(39);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(113);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 114:
      ADVANCE_MAP(
        '#', 362,
        '(', 296,
        ')', 262,
        ',', 271,
        ':', 288,
        ';', 275,
        '=', 138,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(33);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 115:
      ADVANCE_MAP(
        '#', 362,
        '(', 261,
        ')', 262,
        '*', 278,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 142,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(115);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 116:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ':') ADVANCE(129);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(33);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 117:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 118:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(359);
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 119:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(43);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(422);
      END_STATE();
    case 120:
      if (lookahead == '*') ADVANCE(281);
      END_STATE();
    case 121:
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 122:
      if (lookahead == '-') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(413);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~') ADVANCE(412);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(414);
      END_STATE();
    case 123:
      if (lookahead == '-') ADVANCE(169);
      END_STATE();
    case 124:
      if (lookahead == '.') ADVANCE(302);
      END_STATE();
    case 125:
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 126:
      if (lookahead == '.') ADVANCE(276);
      END_STATE();
    case 127:
      if (lookahead == '.') ADVANCE(297);
      END_STATE();
    case 128:
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 129:
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 130:
      if (lookahead == '=') ADVANCE(342);
      if (lookahead == '~') ADVANCE(346);
      END_STATE();
    case 131:
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(144);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 132:
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == 'b') ADVANCE(144);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 133:
      if (lookahead == '=') ADVANCE(145);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '*') ADVANCE(133);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 134:
      if (lookahead == '=') ADVANCE(304);
      END_STATE();
    case 135:
      if (lookahead == '=') ADVANCE(304);
      if (lookahead == '>') ADVANCE(429);
      END_STATE();
    case 136:
      if (lookahead == '=') ADVANCE(306);
      END_STATE();
    case 137:
      if (lookahead == '>') ADVANCE(429);
      END_STATE();
    case 138:
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(144);
      END_STATE();
    case 139:
      if (lookahead == '@') ADVANCE(168);
      if (lookahead > '@' &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(410);
      END_STATE();
    case 140:
      if (lookahead == '\\') ADVANCE(419);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(415);
      END_STATE();
    case 141:
      if (lookahead == ']') ADVANCE(356);
      END_STATE();
    case 142:
      if (lookahead == 'b') ADVANCE(144);
      END_STATE();
    case 143:
      if (lookahead == 'd') ADVANCE(362);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(149);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 146:
      if (lookahead == 'g') ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(1);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 150:
      if (lookahead == '{') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      END_STATE();
    case 151:
      if (lookahead == '}') ADVANCE(415);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(151);
      END_STATE();
    case 152:
      if (lookahead == '}') ADVANCE(423);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(152);
      END_STATE();
    case 153:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 154:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(366);
      END_STATE();
    case 155:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(363);
      END_STATE();
    case 156:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(367);
      END_STATE();
    case 157:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(365);
      END_STATE();
    case 158:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(370);
      END_STATE();
    case 159:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(369);
      END_STATE();
    case 160:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 161:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(368);
      END_STATE();
    case 162:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(423);
      END_STATE();
    case 163:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(428);
      END_STATE();
    case 164:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 165:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 166:
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(152);
      END_STATE();
    case 167:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(412);
      END_STATE();
    case 168:
      if (lookahead > '@' &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(411);
      END_STATE();
    case 169:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(415);
      END_STATE();
    case 170:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(417);
      END_STATE();
    case 171:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 172:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(171);
      END_STATE();
    case 173:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 174:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(173);
      END_STATE();
    case 175:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 176:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(175);
      END_STATE();
    case 177:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 178:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(177);
      END_STATE();
    case 179:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(231);
      END_STATE();
    case 180:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(231);
      if (lookahead == '\r') SKIP(179);
      END_STATE();
    case 181:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(218);
      END_STATE();
    case 182:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(218);
      if (lookahead == '\r') SKIP(181);
      END_STATE();
    case 183:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 184:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(183);
      END_STATE();
    case 185:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 186:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(185);
      END_STATE();
    case 187:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 188:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(187);
      END_STATE();
    case 189:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(228);
      END_STATE();
    case 190:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(228);
      if (lookahead == '\r') SKIP(189);
      END_STATE();
    case 191:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 192:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(191);
      END_STATE();
    case 193:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(234);
      END_STATE();
    case 194:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '\r') SKIP(193);
      END_STATE();
    case 195:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(233);
      END_STATE();
    case 196:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(233);
      if (lookahead == '\r') SKIP(195);
      END_STATE();
    case 197:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 198:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(197);
      END_STATE();
    case 199:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(222);
      END_STATE();
    case 200:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(222);
      if (lookahead == '\r') SKIP(199);
      END_STATE();
    case 201:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 202:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(201);
      END_STATE();
    case 203:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(211);
      END_STATE();
    case 204:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(211);
      if (lookahead == '\r') SKIP(203);
      END_STATE();
    case 205:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 206:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(205);
      END_STATE();
    case 207:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 361,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 279,
        '+', 335,
        ',', 271,
        '-', 352,
        '.', 264,
        '/', 338,
        '0', 364,
        ':', 320,
        ';', 275,
        '<', 290,
        '=', 269,
        '>', 330,
        '?', 317,
        '@', 139,
        'B', 373,
        'E', 376,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(172);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '`') ADVANCE(358);
      if (lookahead == 'd') ADVANCE(403);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`') ADVANCE(408);
      END_STATE();
    case 208:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 364,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(198);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 209:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 364,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(198);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 210:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 296,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 364,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 211:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 364,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 212:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 364,
        ':', 128,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 213:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 339,
        '&', 284,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '/', 337,
        '0', 364,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(206);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 214:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 138,
        '?', 140,
        '@', 139,
        'B', 373,
        'E', 376,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(174);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`') ADVANCE(395);
      END_STATE();
    case 215:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 348,
        '#', 362,
        '$', 122,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 142,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(176);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 216:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(182);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 217:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        '(', 296,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(184);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 218:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(182);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 219:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 340,
        '&', 283,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(184);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 220:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(186);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 221:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(186);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 222:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 362,
        '%', 339,
        '&', 284,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 125,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(200);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 223:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 362,
        '$', 122,
        '(', 261,
        '+', 333,
        ',', 271,
        '-', 137,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(178);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 224:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 362,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(190);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 225:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 362,
        '&', 124,
        '(', 296,
        '*', 120,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 142,
      );
      if (lookahead == '\\') SKIP(188);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 226:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 362,
        '&', 124,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(192);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 227:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(192);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 228:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(267);
      if (lookahead == '\\') SKIP(190);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 229:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '*') ADVANCE(120);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(188);
      if (lookahead == '_') ADVANCE(386);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(378);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 230:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 362,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 288,
        ';', 275,
        '=', 138,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(194);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 231:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 362,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 364,
        ':', 129,
        ';', 275,
        '=', 138,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(180);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(365);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 232:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ':') ADVANCE(286);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(196);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 233:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(196);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 234:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ':') ADVANCE(129);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(194);
      if (lookahead == '_') ADVANCE(399);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 235:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(202);
      if (lookahead == '_') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 236:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(359);
      if (lookahead == '\\') SKIP(202);
      if (lookahead == '_') ADVANCE(399);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_program_token1);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym___END__);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(238);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym___END__);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(238);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(246);
      if (lookahead == '\r') ADVANCE(243);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(246);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(256);
      if (lookahead != 0) ADVANCE(244);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(247);
      if (lookahead == '\r') ADVANCE(245);
      if (lookahead != 0) ADVANCE(245);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '#') ADVANCE(244);
      if (lookahead == '=') ADVANCE(248);
      if (lookahead == '\\') ADVANCE(242);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(246);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '=') ADVANCE(251);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '*') ADVANCE(247);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'b') ADVANCE(250);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'd') ADVANCE(244);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'e') ADVANCE(252);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'e') ADVANCE(254);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'g') ADVANCE(253);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'i') ADVANCE(255);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'n') ADVANCE(249);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'n') ADVANCE(245);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(126);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(292);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(309);
      if (lookahead == '|') ADVANCE(322);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(321);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(281);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(281);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(324);
      if (lookahead == '.') ADVANCE(302);
      if (lookahead == '=') ADVANCE(311);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(323);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(323);
      if (lookahead == '.') ADVANCE(302);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(326);
      if (lookahead == '=') ADVANCE(329);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(325);
      if (lookahead == '=') ADVANCE(329);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(276);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(315);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\') ADVANCE(419);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(415);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(308);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(310);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(314);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(313);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(344);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(332);
      if (lookahead == '>') ADVANCE(328);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(332);
      if (lookahead == '>') ADVANCE(327);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(303);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(353);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@') ADVANCE(353);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(307);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(312);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(343);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(342);
      if (lookahead == '~') ADVANCE(346);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '@') ADVANCE(355);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@') ADVANCE(354);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_TILDE_AT);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=') ADVANCE(357);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_EQ2);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_EQ2);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{') ADVANCE(420);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(362);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(362);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '_') ADVANCE(155);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(363);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 158,
        '_', 157,
        'B', 154,
        'b', 154,
        'D', 159,
        'd', 159,
        'E', 153,
        'e', 153,
        'O', 156,
        'o', 156,
        'X', 161,
        'x', 161,
        '8', 365,
        '9', 365,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(363);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '_') ADVANCE(157);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(365);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(154);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(366);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(367);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(368);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(369);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(158);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(370);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead == 'D') ADVANCE(260);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead == 'E') ADVANCE(374);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead == 'G') ADVANCE(375);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead == 'I') ADVANCE(377);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead == 'N') ADVANCE(372);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead == 'N') ADVANCE(257);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(380);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(378);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_constant_suffix_token1);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(347);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(347);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'D') ADVANCE(388);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'E') ADVANCE(385);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'N') ADVANCE(383);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == '_') ADVANCE(384);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == '_') ADVANCE(239);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'e') ADVANCE(392);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'e') ADVANCE(389);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'f') ADVANCE(393);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'i') ADVANCE(394);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead == 'n') ADVANCE(391);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(409);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(395);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'D') ADVANCE(401);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(398);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N') ADVANCE(396);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(397);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(240);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(381);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(405);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(402);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(406);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(407);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(404);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(408);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym_identifier_suffix_token1);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(410);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(411);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(413);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(414);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '{') ADVANCE(151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(418);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M') ADVANCE(123);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(418);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(416);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(421);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(422);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(421);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(41);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(423);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(426);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(423);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\\') SKIP(1);
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(19);
      if (lookahead == '\r') SKIP(20);
      END_STATE();
    case 2:
      if (lookahead == '_') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(24);
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'l') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'l') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_i);
      if (lookahead == 'f') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      END_STATE();
    case 12:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(42);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'u') ADVANCE(44);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(45);
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 16:
      if (lookahead == 'n') ADVANCE(47);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(48);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 19:
      if (lookahead == '\\') SKIP(1);
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(51);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(19);
      END_STATE();
    case 21:
      if (lookahead == 'E') ADVANCE(52);
      if (lookahead == 'F') ADVANCE(53);
      if (lookahead == 'L') ADVANCE(54);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(56);
      END_STATE();
    case 24:
      if (lookahead == 'g') ADVANCE(57);
      END_STATE();
    case 25:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(60);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(61);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(63);
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(65);
      END_STATE();
    case 33:
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(67);
      END_STATE();
    case 37:
      if (lookahead == 'x') ADVANCE(68);
      END_STATE();
    case 38:
      if (lookahead == 'l') ADVANCE(69);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 41:
      if (lookahead == 'd') ADVANCE(71);
      if (lookahead == 's') ADVANCE(72);
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_ri);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(75);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 47:
      if (lookahead == 'd') ADVANCE(78);
      if (lookahead == 'l') ADVANCE(79);
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(81);
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 50:
      if (lookahead == 'f') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 52:
      if (lookahead == 'N') ADVANCE(84);
      END_STATE();
    case 53:
      if (lookahead == 'I') ADVANCE(85);
      END_STATE();
    case 54:
      if (lookahead == 'I') ADVANCE(86);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(87);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(89);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 60:
      if (lookahead == 's') ADVANCE(91);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(92);
      if (lookahead == 'i') ADVANCE(93);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(94);
      END_STATE();
    case 65:
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(96);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(98);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(99);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(100);
      if (lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 74:
      if (lookahead == 'f') ADVANCE(102);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 76:
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(105);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(110);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 84:
      if (lookahead == 'C') ADVANCE(112);
      END_STATE();
    case 85:
      if (lookahead == 'L') ADVANCE(113);
      END_STATE();
    case 86:
      if (lookahead == 'N') ADVANCE(114);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 88:
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 89:
      if (lookahead == 'k') ADVANCE(117);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(118);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 93:
      if (lookahead == 'f') ADVANCE(119);
      END_STATE();
    case 94:
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(122);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_redo);
      END_STATE();
    case 99:
      if (lookahead == 'u') ADVANCE(123);
      END_STATE();
    case 100:
      if (lookahead == 'y') ADVANCE(124);
      END_STATE();
    case 101:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 106:
      if (lookahead == 'f') ADVANCE(127);
      END_STATE();
    case 107:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 108:
      if (lookahead == 'l') ADVANCE(129);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 111:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 112:
      if (lookahead == 'O') ADVANCE(132);
      END_STATE();
    case 113:
      if (lookahead == 'E') ADVANCE(133);
      END_STATE();
    case 114:
      if (lookahead == 'E') ADVANCE(134);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_retry);
      END_STATE();
    case 125:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 128:
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 132:
      if (lookahead == 'D') ADVANCE(140);
      END_STATE();
    case 133:
      if (lookahead == '_') ADVANCE(141);
      END_STATE();
    case 134:
      if (lookahead == '_') ADVANCE(142);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 140:
      if (lookahead == 'I') ADVANCE(143);
      END_STATE();
    case 141:
      if (lookahead == '_') ADVANCE(144);
      END_STATE();
    case 142:
      if (lookahead == '_') ADVANCE(145);
      END_STATE();
    case 143:
      if (lookahead == 'N') ADVANCE(146);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_file);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_line);
      END_STATE();
    case 146:
      if (lookahead == 'G') ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == '_') ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == '_') ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_encoding);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 214, .external_lex_state = 2},
  [2] = {.lex_state = 67, .external_lex_state = 3},
  [3] = {.lex_state = 67, .external_lex_state = 3},
  [4] = {.lex_state = 67, .external_lex_state = 3},
  [5] = {.lex_state = 67, .external_lex_state = 3},
  [6] = {.lex_state = 67, .external_lex_state = 3},
  [7] = {.lex_state = 67, .external_lex_state = 3},
  [8] = {.lex_state = 208, .external_lex_state = 3},
  [9] = {.lex_state = 208, .external_lex_state = 3},
  [10] = {.lex_state = 208, .external_lex_state = 3},
  [11] = {.lex_state = 208, .external_lex_state = 3},
  [12] = {.lex_state = 208, .external_lex_state = 3},
  [13] = {.lex_state = 208, .external_lex_state = 3},
  [14] = {.lex_state = 67, .external_lex_state = 3},
  [15] = {.lex_state = 67, .external_lex_state = 3},
  [16] = {.lex_state = 67, .external_lex_state = 3},
  [17] = {.lex_state = 67, .external_lex_state = 3},
  [18] = {.lex_state = 67, .external_lex_state = 3},
  [19] = {.lex_state = 67, .external_lex_state = 3},
  [20] = {.lex_state = 67, .external_lex_state = 3},
  [21] = {.lex_state = 67, .external_lex_state = 4},
  [22] = {.lex_state = 67, .external_lex_state = 4},
  [23] = {.lex_state = 67, .external_lex_state = 3},
  [24] = {.lex_state = 67, .external_lex_state = 3},
  [25] = {.lex_state = 67, .external_lex_state = 3},
  [26] = {.lex_state = 67, .external_lex_state = 4},
  [27] = {.lex_state = 67, .external_lex_state = 3},
  [28] = {.lex_state = 67, .external_lex_state = 4},
  [29] = {.lex_state = 67, .external_lex_state = 3},
  [30] = {.lex_state = 67, .external_lex_state = 3},
  [31] = {.lex_state = 67, .external_lex_state = 3},
  [32] = {.lex_state = 67, .external_lex_state = 3},
  [33] = {.lex_state = 67, .external_lex_state = 3},
  [34] = {.lex_state = 67, .external_lex_state = 4},
  [35] = {.lex_state = 67, .external_lex_state = 4},
  [36] = {.lex_state = 67, .external_lex_state = 4},
  [37] = {.lex_state = 67, .external_lex_state = 4},
  [38] = {.lex_state = 67, .external_lex_state = 4},
  [39] = {.lex_state = 67, .external_lex_state = 4},
  [40] = {.lex_state = 67, .external_lex_state = 4},
  [41] = {.lex_state = 67, .external_lex_state = 4},
  [42] = {.lex_state = 70, .external_lex_state = 3},
  [43] = {.lex_state = 70, .external_lex_state = 3},
  [44] = {.lex_state = 70, .external_lex_state = 3},
  [45] = {.lex_state = 70, .external_lex_state = 3},
  [46] = {.lex_state = 70, .external_lex_state = 3},
  [47] = {.lex_state = 70, .external_lex_state = 3},
  [48] = {.lex_state = 70, .external_lex_state = 3},
  [49] = {.lex_state = 70, .external_lex_state = 3},
  [50] = {.lex_state = 70, .external_lex_state = 3},
  [51] = {.lex_state = 70, .external_lex_state = 3},
  [52] = {.lex_state = 70, .external_lex_state = 3},
  [53] = {.lex_state = 210, .external_lex_state = 3},
  [54] = {.lex_state = 210, .external_lex_state = 3},
  [55] = {.lex_state = 210, .external_lex_state = 3},
  [56] = {.lex_state = 210, .external_lex_state = 3},
  [57] = {.lex_state = 210, .external_lex_state = 3},
  [58] = {.lex_state = 70, .external_lex_state = 3},
  [59] = {.lex_state = 210, .external_lex_state = 3},
  [60] = {.lex_state = 210, .external_lex_state = 3},
  [61] = {.lex_state = 70, .external_lex_state = 3},
  [62] = {.lex_state = 70, .external_lex_state = 3},
  [63] = {.lex_state = 210, .external_lex_state = 3},
  [64] = {.lex_state = 70, .external_lex_state = 3},
  [65] = {.lex_state = 70, .external_lex_state = 4},
  [66] = {.lex_state = 210, .external_lex_state = 3},
  [67] = {.lex_state = 70, .external_lex_state = 3},
  [68] = {.lex_state = 70, .external_lex_state = 4},
  [69] = {.lex_state = 210, .external_lex_state = 3},
  [70] = {.lex_state = 210, .external_lex_state = 3},
  [71] = {.lex_state = 70, .external_lex_state = 3},
  [72] = {.lex_state = 70, .external_lex_state = 3},
  [73] = {.lex_state = 70, .external_lex_state = 3},
  [74] = {.lex_state = 70, .external_lex_state = 4},
  [75] = {.lex_state = 70, .external_lex_state = 3},
  [76] = {.lex_state = 70, .external_lex_state = 4},
  [77] = {.lex_state = 70, .external_lex_state = 3},
  [78] = {.lex_state = 70, .external_lex_state = 3},
  [79] = {.lex_state = 70, .external_lex_state = 3},
  [80] = {.lex_state = 70, .external_lex_state = 3},
  [81] = {.lex_state = 70, .external_lex_state = 3},
  [82] = {.lex_state = 70, .external_lex_state = 3},
  [83] = {.lex_state = 70, .external_lex_state = 3},
  [84] = {.lex_state = 70, .external_lex_state = 3},
  [85] = {.lex_state = 70, .external_lex_state = 3},
  [86] = {.lex_state = 70, .external_lex_state = 3},
  [87] = {.lex_state = 70, .external_lex_state = 3},
  [88] = {.lex_state = 70, .external_lex_state = 3},
  [89] = {.lex_state = 70, .external_lex_state = 3},
  [90] = {.lex_state = 70, .external_lex_state = 4},
  [91] = {.lex_state = 70, .external_lex_state = 4},
  [92] = {.lex_state = 70, .external_lex_state = 4},
  [93] = {.lex_state = 70, .external_lex_state = 4},
  [94] = {.lex_state = 70, .external_lex_state = 4},
  [95] = {.lex_state = 70, .external_lex_state = 3},
  [96] = {.lex_state = 70, .external_lex_state = 3},
  [97] = {.lex_state = 70, .external_lex_state = 4},
  [98] = {.lex_state = 70, .external_lex_state = 4},
  [99] = {.lex_state = 70, .external_lex_state = 4},
  [100] = {.lex_state = 70, .external_lex_state = 4},
  [101] = {.lex_state = 70, .external_lex_state = 3},
  [102] = {.lex_state = 70, .external_lex_state = 3},
  [103] = {.lex_state = 70, .external_lex_state = 3},
  [104] = {.lex_state = 70, .external_lex_state = 4},
  [105] = {.lex_state = 70, .external_lex_state = 4},
  [106] = {.lex_state = 70, .external_lex_state = 3},
  [107] = {.lex_state = 70, .external_lex_state = 4},
  [108] = {.lex_state = 70, .external_lex_state = 4},
  [109] = {.lex_state = 70, .external_lex_state = 4},
  [110] = {.lex_state = 70, .external_lex_state = 4},
  [111] = {.lex_state = 70, .external_lex_state = 4},
  [112] = {.lex_state = 70, .external_lex_state = 4},
  [113] = {.lex_state = 70, .external_lex_state = 4},
  [114] = {.lex_state = 85, .external_lex_state = 2},
  [115] = {.lex_state = 85, .external_lex_state = 2},
  [116] = {.lex_state = 85, .external_lex_state = 2},
  [117] = {.lex_state = 85, .external_lex_state = 2},
  [118] = {.lex_state = 84, .external_lex_state = 5},
  [119] = {.lex_state = 84, .external_lex_state = 5},
  [120] = {.lex_state = 84, .external_lex_state = 5},
  [121] = {.lex_state = 84, .external_lex_state = 5},
  [122] = {.lex_state = 84, .external_lex_state = 5},
  [123] = {.lex_state = 81, .external_lex_state = 6},
  [124] = {.lex_state = 81, .external_lex_state = 6},
  [125] = {.lex_state = 81, .external_lex_state = 6},
  [126] = {.lex_state = 83, .external_lex_state = 6},
  [127] = {.lex_state = 81, .external_lex_state = 6},
  [128] = {.lex_state = 83, .external_lex_state = 6},
  [129] = {.lex_state = 81, .external_lex_state = 6},
  [130] = {.lex_state = 83, .external_lex_state = 6},
  [131] = {.lex_state = 81, .external_lex_state = 6},
  [132] = {.lex_state = 83, .external_lex_state = 6},
  [133] = {.lex_state = 83, .external_lex_state = 6},
  [134] = {.lex_state = 83, .external_lex_state = 6},
  [135] = {.lex_state = 86, .external_lex_state = 7},
  [136] = {.lex_state = 86, .external_lex_state = 7},
  [137] = {.lex_state = 86, .external_lex_state = 7},
  [138] = {.lex_state = 85, .external_lex_state = 7},
  [139] = {.lex_state = 86, .external_lex_state = 7},
  [140] = {.lex_state = 86, .external_lex_state = 7},
  [141] = {.lex_state = 85, .external_lex_state = 7},
  [142] = {.lex_state = 86, .external_lex_state = 7},
  [143] = {.lex_state = 86, .external_lex_state = 7},
  [144] = {.lex_state = 85, .external_lex_state = 7},
  [145] = {.lex_state = 86, .external_lex_state = 7},
  [146] = {.lex_state = 86, .external_lex_state = 7},
  [147] = {.lex_state = 86, .external_lex_state = 7},
  [148] = {.lex_state = 86, .external_lex_state = 7},
  [149] = {.lex_state = 86, .external_lex_state = 7},
  [150] = {.lex_state = 85, .external_lex_state = 7},
  [151] = {.lex_state = 85, .external_lex_state = 7},
  [152] = {.lex_state = 85, .external_lex_state = 7},
  [153] = {.lex_state = 86, .external_lex_state = 7},
  [154] = {.lex_state = 86, .external_lex_state = 7},
  [155] = {.lex_state = 86, .external_lex_state = 7},
  [156] = {.lex_state = 86, .external_lex_state = 7},
  [157] = {.lex_state = 86, .external_lex_state = 7},
  [158] = {.lex_state = 85, .external_lex_state = 7},
  [159] = {.lex_state = 86, .external_lex_state = 7},
  [160] = {.lex_state = 86, .external_lex_state = 7},
  [161] = {.lex_state = 86, .external_lex_state = 7},
  [162] = {.lex_state = 86, .external_lex_state = 7},
  [163] = {.lex_state = 85, .external_lex_state = 7},
  [164] = {.lex_state = 86, .external_lex_state = 7},
  [165] = {.lex_state = 85, .external_lex_state = 7},
  [166] = {.lex_state = 85, .external_lex_state = 7},
  [167] = {.lex_state = 86, .external_lex_state = 7},
  [168] = {.lex_state = 86, .external_lex_state = 7},
  [169] = {.lex_state = 85, .external_lex_state = 2},
  [170] = {.lex_state = 85, .external_lex_state = 7},
  [171] = {.lex_state = 85, .external_lex_state = 7},
  [172] = {.lex_state = 85, .external_lex_state = 2},
  [173] = {.lex_state = 85, .external_lex_state = 7},
  [174] = {.lex_state = 85, .external_lex_state = 7},
  [175] = {.lex_state = 85, .external_lex_state = 2},
  [176] = {.lex_state = 85, .external_lex_state = 7},
  [177] = {.lex_state = 85, .external_lex_state = 7},
  [178] = {.lex_state = 85, .external_lex_state = 2},
  [179] = {.lex_state = 85, .external_lex_state = 7},
  [180] = {.lex_state = 85, .external_lex_state = 7},
  [181] = {.lex_state = 85, .external_lex_state = 2},
  [182] = {.lex_state = 85, .external_lex_state = 7},
  [183] = {.lex_state = 85, .external_lex_state = 2},
  [184] = {.lex_state = 85, .external_lex_state = 7},
  [185] = {.lex_state = 85, .external_lex_state = 7},
  [186] = {.lex_state = 85, .external_lex_state = 2},
  [187] = {.lex_state = 85, .external_lex_state = 7},
  [188] = {.lex_state = 85, .external_lex_state = 7},
  [189] = {.lex_state = 85, .external_lex_state = 2},
  [190] = {.lex_state = 85, .external_lex_state = 7},
  [191] = {.lex_state = 85, .external_lex_state = 7},
  [192] = {.lex_state = 85, .external_lex_state = 7},
  [193] = {.lex_state = 85, .external_lex_state = 7},
  [194] = {.lex_state = 85, .external_lex_state = 7},
  [195] = {.lex_state = 85, .external_lex_state = 2},
  [196] = {.lex_state = 85, .external_lex_state = 7},
  [197] = {.lex_state = 85, .external_lex_state = 2},
  [198] = {.lex_state = 85, .external_lex_state = 7},
  [199] = {.lex_state = 85, .external_lex_state = 7},
  [200] = {.lex_state = 85, .external_lex_state = 7},
  [201] = {.lex_state = 85, .external_lex_state = 7},
  [202] = {.lex_state = 73, .external_lex_state = 8},
  [203] = {.lex_state = 73, .external_lex_state = 8},
  [204] = {.lex_state = 85, .external_lex_state = 2},
  [205] = {.lex_state = 85, .external_lex_state = 2},
  [206] = {.lex_state = 85, .external_lex_state = 2},
  [207] = {.lex_state = 73, .external_lex_state = 8},
  [208] = {.lex_state = 85, .external_lex_state = 2},
  [209] = {.lex_state = 85, .external_lex_state = 2},
  [210] = {.lex_state = 85, .external_lex_state = 2},
  [211] = {.lex_state = 85, .external_lex_state = 2},
  [212] = {.lex_state = 85, .external_lex_state = 2},
  [213] = {.lex_state = 85, .external_lex_state = 2},
  [214] = {.lex_state = 85, .external_lex_state = 2},
  [215] = {.lex_state = 85, .external_lex_state = 2},
  [216] = {.lex_state = 85, .external_lex_state = 2},
  [217] = {.lex_state = 85, .external_lex_state = 2},
  [218] = {.lex_state = 85, .external_lex_state = 2},
  [219] = {.lex_state = 85, .external_lex_state = 2},
  [220] = {.lex_state = 85, .external_lex_state = 2},
  [221] = {.lex_state = 73, .external_lex_state = 8},
  [222] = {.lex_state = 85, .external_lex_state = 2},
  [223] = {.lex_state = 85, .external_lex_state = 2},
  [224] = {.lex_state = 85, .external_lex_state = 2},
  [225] = {.lex_state = 85, .external_lex_state = 2},
  [226] = {.lex_state = 85, .external_lex_state = 2},
  [227] = {.lex_state = 85, .external_lex_state = 2},
  [228] = {.lex_state = 85, .external_lex_state = 2},
  [229] = {.lex_state = 85, .external_lex_state = 2},
  [230] = {.lex_state = 85, .external_lex_state = 2},
  [231] = {.lex_state = 85, .external_lex_state = 2},
  [232] = {.lex_state = 85, .external_lex_state = 2},
  [233] = {.lex_state = 85, .external_lex_state = 2},
  [234] = {.lex_state = 85, .external_lex_state = 2},
  [235] = {.lex_state = 85, .external_lex_state = 2},
  [236] = {.lex_state = 85, .external_lex_state = 2},
  [237] = {.lex_state = 85, .external_lex_state = 2},
  [238] = {.lex_state = 85, .external_lex_state = 2},
  [239] = {.lex_state = 85, .external_lex_state = 2},
  [240] = {.lex_state = 85, .external_lex_state = 2},
  [241] = {.lex_state = 85, .external_lex_state = 2},
  [242] = {.lex_state = 85, .external_lex_state = 2},
  [243] = {.lex_state = 85, .external_lex_state = 2},
  [244] = {.lex_state = 85, .external_lex_state = 2},
  [245] = {.lex_state = 73, .external_lex_state = 8},
  [246] = {.lex_state = 85, .external_lex_state = 2},
  [247] = {.lex_state = 85, .external_lex_state = 2},
  [248] = {.lex_state = 84, .external_lex_state = 9},
  [249] = {.lex_state = 85, .external_lex_state = 10},
  [250] = {.lex_state = 85, .external_lex_state = 10},
  [251] = {.lex_state = 85, .external_lex_state = 10},
  [252] = {.lex_state = 84, .external_lex_state = 9},
  [253] = {.lex_state = 85, .external_lex_state = 10},
  [254] = {.lex_state = 85, .external_lex_state = 2},
  [255] = {.lex_state = 85, .external_lex_state = 10},
  [256] = {.lex_state = 85, .external_lex_state = 2},
  [257] = {.lex_state = 85, .external_lex_state = 10},
  [258] = {.lex_state = 85, .external_lex_state = 10},
  [259] = {.lex_state = 85, .external_lex_state = 10},
  [260] = {.lex_state = 85, .external_lex_state = 2},
  [261] = {.lex_state = 74, .external_lex_state = 11},
  [262] = {.lex_state = 85, .external_lex_state = 2},
  [263] = {.lex_state = 74, .external_lex_state = 11},
  [264] = {.lex_state = 74, .external_lex_state = 11},
  [265] = {.lex_state = 85, .external_lex_state = 2},
  [266] = {.lex_state = 212, .external_lex_state = 8},
  [267] = {.lex_state = 85, .external_lex_state = 2},
  [268] = {.lex_state = 85, .external_lex_state = 2},
  [269] = {.lex_state = 85, .external_lex_state = 2},
  [270] = {.lex_state = 85, .external_lex_state = 7},
  [271] = {.lex_state = 85, .external_lex_state = 2},
  [272] = {.lex_state = 85, .external_lex_state = 2},
  [273] = {.lex_state = 85, .external_lex_state = 2},
  [274] = {.lex_state = 212, .external_lex_state = 8},
  [275] = {.lex_state = 74, .external_lex_state = 11},
  [276] = {.lex_state = 85, .external_lex_state = 7},
  [277] = {.lex_state = 85, .external_lex_state = 2},
  [278] = {.lex_state = 85, .external_lex_state = 2},
  [279] = {.lex_state = 85, .external_lex_state = 7},
  [280] = {.lex_state = 85, .external_lex_state = 2},
  [281] = {.lex_state = 212, .external_lex_state = 8},
  [282] = {.lex_state = 85, .external_lex_state = 7},
  [283] = {.lex_state = 74, .external_lex_state = 11},
  [284] = {.lex_state = 212, .external_lex_state = 8},
  [285] = {.lex_state = 85, .external_lex_state = 2},
  [286] = {.lex_state = 73, .external_lex_state = 12},
  [287] = {.lex_state = 85, .external_lex_state = 2},
  [288] = {.lex_state = 85, .external_lex_state = 2},
  [289] = {.lex_state = 85, .external_lex_state = 2},
  [290] = {.lex_state = 85, .external_lex_state = 2},
  [291] = {.lex_state = 85, .external_lex_state = 2},
  [292] = {.lex_state = 85, .external_lex_state = 2},
  [293] = {.lex_state = 85, .external_lex_state = 2},
  [294] = {.lex_state = 85, .external_lex_state = 2},
  [295] = {.lex_state = 85, .external_lex_state = 2},
  [296] = {.lex_state = 85, .external_lex_state = 2},
  [297] = {.lex_state = 85, .external_lex_state = 2},
  [298] = {.lex_state = 212, .external_lex_state = 8},
  [299] = {.lex_state = 85, .external_lex_state = 2},
  [300] = {.lex_state = 85, .external_lex_state = 2},
  [301] = {.lex_state = 85, .external_lex_state = 2},
  [302] = {.lex_state = 85, .external_lex_state = 2},
  [303] = {.lex_state = 73, .external_lex_state = 12},
  [304] = {.lex_state = 85, .external_lex_state = 2},
  [305] = {.lex_state = 73, .external_lex_state = 12},
  [306] = {.lex_state = 73, .external_lex_state = 12},
  [307] = {.lex_state = 73, .external_lex_state = 12},
  [308] = {.lex_state = 73, .external_lex_state = 8},
  [309] = {.lex_state = 73, .external_lex_state = 12},
  [310] = {.lex_state = 73, .external_lex_state = 8},
  [311] = {.lex_state = 215, .external_lex_state = 9},
  [312] = {.lex_state = 73, .external_lex_state = 8},
  [313] = {.lex_state = 73, .external_lex_state = 8},
  [314] = {.lex_state = 213, .external_lex_state = 11},
  [315] = {.lex_state = 73, .external_lex_state = 12},
  [316] = {.lex_state = 73, .external_lex_state = 8},
  [317] = {.lex_state = 214, .external_lex_state = 2},
  [318] = {.lex_state = 214, .external_lex_state = 2},
  [319] = {.lex_state = 85, .external_lex_state = 2},
  [320] = {.lex_state = 85, .external_lex_state = 2},
  [321] = {.lex_state = 85, .external_lex_state = 2},
  [322] = {.lex_state = 85, .external_lex_state = 2},
  [323] = {.lex_state = 73, .external_lex_state = 8},
  [324] = {.lex_state = 215, .external_lex_state = 9},
  [325] = {.lex_state = 213, .external_lex_state = 11},
  [326] = {.lex_state = 85, .external_lex_state = 2},
  [327] = {.lex_state = 85, .external_lex_state = 2},
  [328] = {.lex_state = 85, .external_lex_state = 2},
  [329] = {.lex_state = 73, .external_lex_state = 8},
  [330] = {.lex_state = 85, .external_lex_state = 2},
  [331] = {.lex_state = 85, .external_lex_state = 2},
  [332] = {.lex_state = 85, .external_lex_state = 2},
  [333] = {.lex_state = 73, .external_lex_state = 12},
  [334] = {.lex_state = 87, .external_lex_state = 2},
  [335] = {.lex_state = 85, .external_lex_state = 2},
  [336] = {.lex_state = 87, .external_lex_state = 2},
  [337] = {.lex_state = 85, .external_lex_state = 2},
  [338] = {.lex_state = 87, .external_lex_state = 2},
  [339] = {.lex_state = 87, .external_lex_state = 2},
  [340] = {.lex_state = 84, .external_lex_state = 9},
  [341] = {.lex_state = 87, .external_lex_state = 2},
  [342] = {.lex_state = 87, .external_lex_state = 2},
  [343] = {.lex_state = 85, .external_lex_state = 2},
  [344] = {.lex_state = 87, .external_lex_state = 2},
  [345] = {.lex_state = 87, .external_lex_state = 2},
  [346] = {.lex_state = 213, .external_lex_state = 11},
  [347] = {.lex_state = 87, .external_lex_state = 2},
  [348] = {.lex_state = 73, .external_lex_state = 8},
  [349] = {.lex_state = 87, .external_lex_state = 2},
  [350] = {.lex_state = 87, .external_lex_state = 2},
  [351] = {.lex_state = 85, .external_lex_state = 2},
  [352] = {.lex_state = 85, .external_lex_state = 2},
  [353] = {.lex_state = 85, .external_lex_state = 2},
  [354] = {.lex_state = 85, .external_lex_state = 2},
  [355] = {.lex_state = 85, .external_lex_state = 2},
  [356] = {.lex_state = 85, .external_lex_state = 2},
  [357] = {.lex_state = 85, .external_lex_state = 2},
  [358] = {.lex_state = 85, .external_lex_state = 2},
  [359] = {.lex_state = 87, .external_lex_state = 2},
  [360] = {.lex_state = 85, .external_lex_state = 2},
  [361] = {.lex_state = 213, .external_lex_state = 11},
  [362] = {.lex_state = 87, .external_lex_state = 2},
  [363] = {.lex_state = 84, .external_lex_state = 9},
  [364] = {.lex_state = 213, .external_lex_state = 11},
  [365] = {.lex_state = 74, .external_lex_state = 13},
  [366] = {.lex_state = 84, .external_lex_state = 5},
  [367] = {.lex_state = 73, .external_lex_state = 8},
  [368] = {.lex_state = 74, .external_lex_state = 13},
  [369] = {.lex_state = 84, .external_lex_state = 9},
  [370] = {.lex_state = 73, .external_lex_state = 12},
  [371] = {.lex_state = 73, .external_lex_state = 8},
  [372] = {.lex_state = 84, .external_lex_state = 9},
  [373] = {.lex_state = 74, .external_lex_state = 13},
  [374] = {.lex_state = 74, .external_lex_state = 11},
  [375] = {.lex_state = 74, .external_lex_state = 11},
  [376] = {.lex_state = 74, .external_lex_state = 13},
  [377] = {.lex_state = 84, .external_lex_state = 5},
  [378] = {.lex_state = 73, .external_lex_state = 8},
  [379] = {.lex_state = 73, .external_lex_state = 12},
  [380] = {.lex_state = 73, .external_lex_state = 12},
  [381] = {.lex_state = 85, .external_lex_state = 2},
  [382] = {.lex_state = 84, .external_lex_state = 9},
  [383] = {.lex_state = 73, .external_lex_state = 12},
  [384] = {.lex_state = 85, .external_lex_state = 2},
  [385] = {.lex_state = 84, .external_lex_state = 5},
  [386] = {.lex_state = 85, .external_lex_state = 2},
  [387] = {.lex_state = 74, .external_lex_state = 13},
  [388] = {.lex_state = 74, .external_lex_state = 13},
  [389] = {.lex_state = 74, .external_lex_state = 11},
  [390] = {.lex_state = 74, .external_lex_state = 11},
  [391] = {.lex_state = 74, .external_lex_state = 13},
  [392] = {.lex_state = 84, .external_lex_state = 5},
  [393] = {.lex_state = 74, .external_lex_state = 11},
  [394] = {.lex_state = 74, .external_lex_state = 11},
  [395] = {.lex_state = 74, .external_lex_state = 13},
  [396] = {.lex_state = 73, .external_lex_state = 12},
  [397] = {.lex_state = 74, .external_lex_state = 11},
  [398] = {.lex_state = 73, .external_lex_state = 12},
  [399] = {.lex_state = 73, .external_lex_state = 12},
  [400] = {.lex_state = 73, .external_lex_state = 12},
  [401] = {.lex_state = 74, .external_lex_state = 11},
  [402] = {.lex_state = 85, .external_lex_state = 2},
  [403] = {.lex_state = 85, .external_lex_state = 2},
  [404] = {.lex_state = 74, .external_lex_state = 13},
  [405] = {.lex_state = 85, .external_lex_state = 2},
  [406] = {.lex_state = 74, .external_lex_state = 11},
  [407] = {.lex_state = 85, .external_lex_state = 2},
  [408] = {.lex_state = 85, .external_lex_state = 2},
  [409] = {.lex_state = 85, .external_lex_state = 2},
  [410] = {.lex_state = 85, .external_lex_state = 2},
  [411] = {.lex_state = 85, .external_lex_state = 2},
  [412] = {.lex_state = 85, .external_lex_state = 2},
  [413] = {.lex_state = 85, .external_lex_state = 2},
  [414] = {.lex_state = 85, .external_lex_state = 2},
  [415] = {.lex_state = 85, .external_lex_state = 2},
  [416] = {.lex_state = 74, .external_lex_state = 11},
  [417] = {.lex_state = 85, .external_lex_state = 2},
  [418] = {.lex_state = 74, .external_lex_state = 11},
  [419] = {.lex_state = 74, .external_lex_state = 13},
  [420] = {.lex_state = 74, .external_lex_state = 13},
  [421] = {.lex_state = 74, .external_lex_state = 13},
  [422] = {.lex_state = 84, .external_lex_state = 5},
  [423] = {.lex_state = 84, .external_lex_state = 5},
  [424] = {.lex_state = 84, .external_lex_state = 5},
  [425] = {.lex_state = 74, .external_lex_state = 13},
  [426] = {.lex_state = 84, .external_lex_state = 5},
  [427] = {.lex_state = 84, .external_lex_state = 5},
  [428] = {.lex_state = 84, .external_lex_state = 5},
  [429] = {.lex_state = 84, .external_lex_state = 14},
  [430] = {.lex_state = 84, .external_lex_state = 5},
  [431] = {.lex_state = 74, .external_lex_state = 13},
  [432] = {.lex_state = 84, .external_lex_state = 5},
  [433] = {.lex_state = 84, .external_lex_state = 5},
  [434] = {.lex_state = 84, .external_lex_state = 5},
  [435] = {.lex_state = 84, .external_lex_state = 5},
  [436] = {.lex_state = 74, .external_lex_state = 13},
  [437] = {.lex_state = 84, .external_lex_state = 5},
  [438] = {.lex_state = 84, .external_lex_state = 5},
  [439] = {.lex_state = 84, .external_lex_state = 5},
  [440] = {.lex_state = 84, .external_lex_state = 5},
  [441] = {.lex_state = 84, .external_lex_state = 2},
  [442] = {.lex_state = 74, .external_lex_state = 13},
  [443] = {.lex_state = 84, .external_lex_state = 5},
  [444] = {.lex_state = 84, .external_lex_state = 5},
  [445] = {.lex_state = 84, .external_lex_state = 5},
  [446] = {.lex_state = 84, .external_lex_state = 5},
  [447] = {.lex_state = 84, .external_lex_state = 5},
  [448] = {.lex_state = 84, .external_lex_state = 5},
  [449] = {.lex_state = 84, .external_lex_state = 5},
  [450] = {.lex_state = 84, .external_lex_state = 5},
  [451] = {.lex_state = 84, .external_lex_state = 5},
  [452] = {.lex_state = 84, .external_lex_state = 5},
  [453] = {.lex_state = 84, .external_lex_state = 5},
  [454] = {.lex_state = 84, .external_lex_state = 5},
  [455] = {.lex_state = 84, .external_lex_state = 5},
  [456] = {.lex_state = 84, .external_lex_state = 5},
  [457] = {.lex_state = 84, .external_lex_state = 15},
  [458] = {.lex_state = 84, .external_lex_state = 15},
  [459] = {.lex_state = 84, .external_lex_state = 15},
  [460] = {.lex_state = 84, .external_lex_state = 15},
  [461] = {.lex_state = 84, .external_lex_state = 15},
  [462] = {.lex_state = 84, .external_lex_state = 15},
  [463] = {.lex_state = 84, .external_lex_state = 15},
  [464] = {.lex_state = 84, .external_lex_state = 15},
  [465] = {.lex_state = 84, .external_lex_state = 15},
  [466] = {.lex_state = 84, .external_lex_state = 15},
  [467] = {.lex_state = 84, .external_lex_state = 15},
  [468] = {.lex_state = 84, .external_lex_state = 15},
  [469] = {.lex_state = 84, .external_lex_state = 15},
  [470] = {.lex_state = 84, .external_lex_state = 15},
  [471] = {.lex_state = 84, .external_lex_state = 15},
  [472] = {.lex_state = 84, .external_lex_state = 15},
  [473] = {.lex_state = 84, .external_lex_state = 15},
  [474] = {.lex_state = 84, .external_lex_state = 15},
  [475] = {.lex_state = 84, .external_lex_state = 15},
  [476] = {.lex_state = 84, .external_lex_state = 15},
  [477] = {.lex_state = 84, .external_lex_state = 15},
  [478] = {.lex_state = 84, .external_lex_state = 15},
  [479] = {.lex_state = 84, .external_lex_state = 15},
  [480] = {.lex_state = 84, .external_lex_state = 15},
  [481] = {.lex_state = 84, .external_lex_state = 15},
  [482] = {.lex_state = 84, .external_lex_state = 16},
  [483] = {.lex_state = 84, .external_lex_state = 16},
  [484] = {.lex_state = 84, .external_lex_state = 2},
  [485] = {.lex_state = 84, .external_lex_state = 2},
  [486] = {.lex_state = 84, .external_lex_state = 2},
  [487] = {.lex_state = 84, .external_lex_state = 2},
  [488] = {.lex_state = 84, .external_lex_state = 2},
  [489] = {.lex_state = 84, .external_lex_state = 2},
  [490] = {.lex_state = 84, .external_lex_state = 2},
  [491] = {.lex_state = 84, .external_lex_state = 7},
  [492] = {.lex_state = 84, .external_lex_state = 7},
  [493] = {.lex_state = 84, .external_lex_state = 2},
  [494] = {.lex_state = 84, .external_lex_state = 7},
  [495] = {.lex_state = 84, .external_lex_state = 2},
  [496] = {.lex_state = 84, .external_lex_state = 2},
  [497] = {.lex_state = 84, .external_lex_state = 2},
  [498] = {.lex_state = 84, .external_lex_state = 2},
  [499] = {.lex_state = 84, .external_lex_state = 2},
  [500] = {.lex_state = 84, .external_lex_state = 2},
  [501] = {.lex_state = 84, .external_lex_state = 2},
  [502] = {.lex_state = 84, .external_lex_state = 2},
  [503] = {.lex_state = 84, .external_lex_state = 2},
  [504] = {.lex_state = 84, .external_lex_state = 2},
  [505] = {.lex_state = 84, .external_lex_state = 2},
  [506] = {.lex_state = 84, .external_lex_state = 2},
  [507] = {.lex_state = 84, .external_lex_state = 2},
  [508] = {.lex_state = 84, .external_lex_state = 7},
  [509] = {.lex_state = 84, .external_lex_state = 2},
  [510] = {.lex_state = 84, .external_lex_state = 16},
  [511] = {.lex_state = 84, .external_lex_state = 16},
  [512] = {.lex_state = 84, .external_lex_state = 2},
  [513] = {.lex_state = 84, .external_lex_state = 2},
  [514] = {.lex_state = 84, .external_lex_state = 2},
  [515] = {.lex_state = 84, .external_lex_state = 7},
  [516] = {.lex_state = 84, .external_lex_state = 7},
  [517] = {.lex_state = 84, .external_lex_state = 7},
  [518] = {.lex_state = 84, .external_lex_state = 7},
  [519] = {.lex_state = 84, .external_lex_state = 2},
  [520] = {.lex_state = 84, .external_lex_state = 2},
  [521] = {.lex_state = 84, .external_lex_state = 2},
  [522] = {.lex_state = 84, .external_lex_state = 2},
  [523] = {.lex_state = 84, .external_lex_state = 2},
  [524] = {.lex_state = 84, .external_lex_state = 2},
  [525] = {.lex_state = 84, .external_lex_state = 2},
  [526] = {.lex_state = 84, .external_lex_state = 2},
  [527] = {.lex_state = 84, .external_lex_state = 2},
  [528] = {.lex_state = 84, .external_lex_state = 2},
  [529] = {.lex_state = 84, .external_lex_state = 2},
  [530] = {.lex_state = 84, .external_lex_state = 2},
  [531] = {.lex_state = 84, .external_lex_state = 2},
  [532] = {.lex_state = 84, .external_lex_state = 2},
  [533] = {.lex_state = 84, .external_lex_state = 2},
  [534] = {.lex_state = 84, .external_lex_state = 2},
  [535] = {.lex_state = 84, .external_lex_state = 2},
  [536] = {.lex_state = 84, .external_lex_state = 2},
  [537] = {.lex_state = 84, .external_lex_state = 2},
  [538] = {.lex_state = 84, .external_lex_state = 2},
  [539] = {.lex_state = 84, .external_lex_state = 2},
  [540] = {.lex_state = 84, .external_lex_state = 2},
  [541] = {.lex_state = 84, .external_lex_state = 2},
  [542] = {.lex_state = 84, .external_lex_state = 2},
  [543] = {.lex_state = 84, .external_lex_state = 2},
  [544] = {.lex_state = 84, .external_lex_state = 2},
  [545] = {.lex_state = 84, .external_lex_state = 2},
  [546] = {.lex_state = 84, .external_lex_state = 2},
  [547] = {.lex_state = 84, .external_lex_state = 2},
  [548] = {.lex_state = 84, .external_lex_state = 2},
  [549] = {.lex_state = 84, .external_lex_state = 2},
  [550] = {.lex_state = 84, .external_lex_state = 2},
  [551] = {.lex_state = 84, .external_lex_state = 2},
  [552] = {.lex_state = 84, .external_lex_state = 2},
  [553] = {.lex_state = 84, .external_lex_state = 2},
  [554] = {.lex_state = 84, .external_lex_state = 2},
  [555] = {.lex_state = 84, .external_lex_state = 2},
  [556] = {.lex_state = 84, .external_lex_state = 2},
  [557] = {.lex_state = 84, .external_lex_state = 2},
  [558] = {.lex_state = 84, .external_lex_state = 2},
  [559] = {.lex_state = 84, .external_lex_state = 2},
  [560] = {.lex_state = 84, .external_lex_state = 2},
  [561] = {.lex_state = 84, .external_lex_state = 2},
  [562] = {.lex_state = 84, .external_lex_state = 2},
  [563] = {.lex_state = 84, .external_lex_state = 2},
  [564] = {.lex_state = 84, .external_lex_state = 2},
  [565] = {.lex_state = 84, .external_lex_state = 2},
  [566] = {.lex_state = 84, .external_lex_state = 2},
  [567] = {.lex_state = 84, .external_lex_state = 2},
  [568] = {.lex_state = 84, .external_lex_state = 2},
  [569] = {.lex_state = 84, .external_lex_state = 2},
  [570] = {.lex_state = 84, .external_lex_state = 2},
  [571] = {.lex_state = 84, .external_lex_state = 2},
  [572] = {.lex_state = 84, .external_lex_state = 2},
  [573] = {.lex_state = 84, .external_lex_state = 2},
  [574] = {.lex_state = 84, .external_lex_state = 2},
  [575] = {.lex_state = 84, .external_lex_state = 2},
  [576] = {.lex_state = 84, .external_lex_state = 2},
  [577] = {.lex_state = 84, .external_lex_state = 2},
  [578] = {.lex_state = 84, .external_lex_state = 2},
  [579] = {.lex_state = 84, .external_lex_state = 2},
  [580] = {.lex_state = 84, .external_lex_state = 2},
  [581] = {.lex_state = 84, .external_lex_state = 2},
  [582] = {.lex_state = 84, .external_lex_state = 2},
  [583] = {.lex_state = 84, .external_lex_state = 2},
  [584] = {.lex_state = 84, .external_lex_state = 2},
  [585] = {.lex_state = 84, .external_lex_state = 2},
  [586] = {.lex_state = 84, .external_lex_state = 2},
  [587] = {.lex_state = 84, .external_lex_state = 2},
  [588] = {.lex_state = 84, .external_lex_state = 2},
  [589] = {.lex_state = 84, .external_lex_state = 2},
  [590] = {.lex_state = 84, .external_lex_state = 2},
  [591] = {.lex_state = 84, .external_lex_state = 2},
  [592] = {.lex_state = 84, .external_lex_state = 2},
  [593] = {.lex_state = 84, .external_lex_state = 2},
  [594] = {.lex_state = 84, .external_lex_state = 2},
  [595] = {.lex_state = 84, .external_lex_state = 2},
  [596] = {.lex_state = 84, .external_lex_state = 2},
  [597] = {.lex_state = 84, .external_lex_state = 2},
  [598] = {.lex_state = 84, .external_lex_state = 2},
  [599] = {.lex_state = 84, .external_lex_state = 2},
  [600] = {.lex_state = 84, .external_lex_state = 2},
  [601] = {.lex_state = 84, .external_lex_state = 2},
  [602] = {.lex_state = 84, .external_lex_state = 2},
  [603] = {.lex_state = 84, .external_lex_state = 2},
  [604] = {.lex_state = 84, .external_lex_state = 2},
  [605] = {.lex_state = 84, .external_lex_state = 2},
  [606] = {.lex_state = 84, .external_lex_state = 2},
  [607] = {.lex_state = 84, .external_lex_state = 2},
  [608] = {.lex_state = 84, .external_lex_state = 2},
  [609] = {.lex_state = 84, .external_lex_state = 2},
  [610] = {.lex_state = 84, .external_lex_state = 2},
  [611] = {.lex_state = 84, .external_lex_state = 2},
  [612] = {.lex_state = 84, .external_lex_state = 2},
  [613] = {.lex_state = 84, .external_lex_state = 2},
  [614] = {.lex_state = 84, .external_lex_state = 2},
  [615] = {.lex_state = 84, .external_lex_state = 2},
  [616] = {.lex_state = 84, .external_lex_state = 2},
  [617] = {.lex_state = 84, .external_lex_state = 2},
  [618] = {.lex_state = 84, .external_lex_state = 2},
  [619] = {.lex_state = 84, .external_lex_state = 2},
  [620] = {.lex_state = 84, .external_lex_state = 2},
  [621] = {.lex_state = 84, .external_lex_state = 2},
  [622] = {.lex_state = 84, .external_lex_state = 2},
  [623] = {.lex_state = 84, .external_lex_state = 2},
  [624] = {.lex_state = 84, .external_lex_state = 2},
  [625] = {.lex_state = 84, .external_lex_state = 2},
  [626] = {.lex_state = 84, .external_lex_state = 2},
  [627] = {.lex_state = 84, .external_lex_state = 2},
  [628] = {.lex_state = 84, .external_lex_state = 2},
  [629] = {.lex_state = 84, .external_lex_state = 2},
  [630] = {.lex_state = 84, .external_lex_state = 2},
  [631] = {.lex_state = 84, .external_lex_state = 2},
  [632] = {.lex_state = 84, .external_lex_state = 2},
  [633] = {.lex_state = 84, .external_lex_state = 2},
  [634] = {.lex_state = 84, .external_lex_state = 2},
  [635] = {.lex_state = 84, .external_lex_state = 2},
  [636] = {.lex_state = 84, .external_lex_state = 2},
  [637] = {.lex_state = 84, .external_lex_state = 2},
  [638] = {.lex_state = 84, .external_lex_state = 2},
  [639] = {.lex_state = 84, .external_lex_state = 2},
  [640] = {.lex_state = 84, .external_lex_state = 2},
  [641] = {.lex_state = 84, .external_lex_state = 2},
  [642] = {.lex_state = 84, .external_lex_state = 2},
  [643] = {.lex_state = 84, .external_lex_state = 2},
  [644] = {.lex_state = 84, .external_lex_state = 2},
  [645] = {.lex_state = 84, .external_lex_state = 2},
  [646] = {.lex_state = 84, .external_lex_state = 2},
  [647] = {.lex_state = 84, .external_lex_state = 2},
  [648] = {.lex_state = 84, .external_lex_state = 2},
  [649] = {.lex_state = 84, .external_lex_state = 2},
  [650] = {.lex_state = 84, .external_lex_state = 2},
  [651] = {.lex_state = 84, .external_lex_state = 2},
  [652] = {.lex_state = 84, .external_lex_state = 2},
  [653] = {.lex_state = 84, .external_lex_state = 2},
  [654] = {.lex_state = 84, .external_lex_state = 2},
  [655] = {.lex_state = 84, .external_lex_state = 2},
  [656] = {.lex_state = 84, .external_lex_state = 2},
  [657] = {.lex_state = 84, .external_lex_state = 2},
  [658] = {.lex_state = 84, .external_lex_state = 2},
  [659] = {.lex_state = 84, .external_lex_state = 2},
  [660] = {.lex_state = 84, .external_lex_state = 2},
  [661] = {.lex_state = 84, .external_lex_state = 2},
  [662] = {.lex_state = 84, .external_lex_state = 2},
  [663] = {.lex_state = 84, .external_lex_state = 2},
  [664] = {.lex_state = 84, .external_lex_state = 2},
  [665] = {.lex_state = 84, .external_lex_state = 2},
  [666] = {.lex_state = 84, .external_lex_state = 2},
  [667] = {.lex_state = 84, .external_lex_state = 2},
  [668] = {.lex_state = 84, .external_lex_state = 2},
  [669] = {.lex_state = 84, .external_lex_state = 2},
  [670] = {.lex_state = 215, .external_lex_state = 16},
  [671] = {.lex_state = 215, .external_lex_state = 16},
  [672] = {.lex_state = 87, .external_lex_state = 10},
  [673] = {.lex_state = 87, .external_lex_state = 10},
  [674] = {.lex_state = 87, .external_lex_state = 10},
  [675] = {.lex_state = 87, .external_lex_state = 10},
  [676] = {.lex_state = 87, .external_lex_state = 10},
  [677] = {.lex_state = 215, .external_lex_state = 16},
  [678] = {.lex_state = 215, .external_lex_state = 7},
  [679] = {.lex_state = 215, .external_lex_state = 7},
  [680] = {.lex_state = 84, .external_lex_state = 17},
  [681] = {.lex_state = 215, .external_lex_state = 7},
  [682] = {.lex_state = 215, .external_lex_state = 16},
  [683] = {.lex_state = 215, .external_lex_state = 7},
  [684] = {.lex_state = 215, .external_lex_state = 7},
  [685] = {.lex_state = 215, .external_lex_state = 7},
  [686] = {.lex_state = 215, .external_lex_state = 7},
  [687] = {.lex_state = 215, .external_lex_state = 7},
  [688] = {.lex_state = 84, .external_lex_state = 2},
  [689] = {.lex_state = 84, .external_lex_state = 16},
  [690] = {.lex_state = 84, .external_lex_state = 16},
  [691] = {.lex_state = 84, .external_lex_state = 16},
  [692] = {.lex_state = 84, .external_lex_state = 16},
  [693] = {.lex_state = 84, .external_lex_state = 14},
  [694] = {.lex_state = 84, .external_lex_state = 14},
  [695] = {.lex_state = 84, .external_lex_state = 2},
  [696] = {.lex_state = 84, .external_lex_state = 2},
  [697] = {.lex_state = 84, .external_lex_state = 2},
  [698] = {.lex_state = 84, .external_lex_state = 2},
  [699] = {.lex_state = 84, .external_lex_state = 2},
  [700] = {.lex_state = 84, .external_lex_state = 2},
  [701] = {.lex_state = 84, .external_lex_state = 2},
  [702] = {.lex_state = 84, .external_lex_state = 2},
  [703] = {.lex_state = 84, .external_lex_state = 2},
  [704] = {.lex_state = 84, .external_lex_state = 14},
  [705] = {.lex_state = 84, .external_lex_state = 2},
  [706] = {.lex_state = 84, .external_lex_state = 14},
  [707] = {.lex_state = 84, .external_lex_state = 2},
  [708] = {.lex_state = 84, .external_lex_state = 2},
  [709] = {.lex_state = 84, .external_lex_state = 2},
  [710] = {.lex_state = 84, .external_lex_state = 14},
  [711] = {.lex_state = 84, .external_lex_state = 16},
  [712] = {.lex_state = 84, .external_lex_state = 7},
  [713] = {.lex_state = 84, .external_lex_state = 7},
  [714] = {.lex_state = 84, .external_lex_state = 7},
  [715] = {.lex_state = 84, .external_lex_state = 7},
  [716] = {.lex_state = 84, .external_lex_state = 16},
  [717] = {.lex_state = 84, .external_lex_state = 7},
  [718] = {.lex_state = 84, .external_lex_state = 2},
  [719] = {.lex_state = 84, .external_lex_state = 2},
  [720] = {.lex_state = 84, .external_lex_state = 2},
  [721] = {.lex_state = 84, .external_lex_state = 2},
  [722] = {.lex_state = 84, .external_lex_state = 7},
  [723] = {.lex_state = 84, .external_lex_state = 7},
  [724] = {.lex_state = 84, .external_lex_state = 2},
  [725] = {.lex_state = 84, .external_lex_state = 14},
  [726] = {.lex_state = 84, .external_lex_state = 7},
  [727] = {.lex_state = 84, .external_lex_state = 2},
  [728] = {.lex_state = 84, .external_lex_state = 2},
  [729] = {.lex_state = 84, .external_lex_state = 2},
  [730] = {.lex_state = 84, .external_lex_state = 2},
  [731] = {.lex_state = 84, .external_lex_state = 7},
  [732] = {.lex_state = 84, .external_lex_state = 7},
  [733] = {.lex_state = 84, .external_lex_state = 14},
  [734] = {.lex_state = 84, .external_lex_state = 7},
  [735] = {.lex_state = 84, .external_lex_state = 2},
  [736] = {.lex_state = 84, .external_lex_state = 7},
  [737] = {.lex_state = 84, .external_lex_state = 2},
  [738] = {.lex_state = 84, .external_lex_state = 2},
  [739] = {.lex_state = 84, .external_lex_state = 2},
  [740] = {.lex_state = 84, .external_lex_state = 14},
  [741] = {.lex_state = 84, .external_lex_state = 10},
  [742] = {.lex_state = 84, .external_lex_state = 10},
  [743] = {.lex_state = 84, .external_lex_state = 14},
  [744] = {.lex_state = 84, .external_lex_state = 10},
  [745] = {.lex_state = 84, .external_lex_state = 10},
  [746] = {.lex_state = 84, .external_lex_state = 7},
  [747] = {.lex_state = 84, .external_lex_state = 10},
  [748] = {.lex_state = 84, .external_lex_state = 10},
  [749] = {.lex_state = 84, .external_lex_state = 2},
  [750] = {.lex_state = 84, .external_lex_state = 2},
  [751] = {.lex_state = 84, .external_lex_state = 2},
  [752] = {.lex_state = 84, .external_lex_state = 2},
  [753] = {.lex_state = 84, .external_lex_state = 14},
  [754] = {.lex_state = 84, .external_lex_state = 10},
  [755] = {.lex_state = 84, .external_lex_state = 10},
  [756] = {.lex_state = 84, .external_lex_state = 10},
  [757] = {.lex_state = 84, .external_lex_state = 15},
  [758] = {.lex_state = 84, .external_lex_state = 15},
  [759] = {.lex_state = 84, .external_lex_state = 15},
  [760] = {.lex_state = 84, .external_lex_state = 15},
  [761] = {.lex_state = 84, .external_lex_state = 15},
  [762] = {.lex_state = 84, .external_lex_state = 15},
  [763] = {.lex_state = 84, .external_lex_state = 15},
  [764] = {.lex_state = 84, .external_lex_state = 15},
  [765] = {.lex_state = 84, .external_lex_state = 15},
  [766] = {.lex_state = 84, .external_lex_state = 15},
  [767] = {.lex_state = 84, .external_lex_state = 15},
  [768] = {.lex_state = 84, .external_lex_state = 15},
  [769] = {.lex_state = 84, .external_lex_state = 15},
  [770] = {.lex_state = 84, .external_lex_state = 15},
  [771] = {.lex_state = 84, .external_lex_state = 15},
  [772] = {.lex_state = 84, .external_lex_state = 15},
  [773] = {.lex_state = 84, .external_lex_state = 15},
  [774] = {.lex_state = 84, .external_lex_state = 15},
  [775] = {.lex_state = 84, .external_lex_state = 15},
  [776] = {.lex_state = 84, .external_lex_state = 2},
  [777] = {.lex_state = 84, .external_lex_state = 15},
  [778] = {.lex_state = 84, .external_lex_state = 15},
  [779] = {.lex_state = 84, .external_lex_state = 15},
  [780] = {.lex_state = 84, .external_lex_state = 15},
  [781] = {.lex_state = 84, .external_lex_state = 15},
  [782] = {.lex_state = 84, .external_lex_state = 15},
  [783] = {.lex_state = 84, .external_lex_state = 15},
  [784] = {.lex_state = 84, .external_lex_state = 15},
  [785] = {.lex_state = 84, .external_lex_state = 15},
  [786] = {.lex_state = 84, .external_lex_state = 15},
  [787] = {.lex_state = 84, .external_lex_state = 15},
  [788] = {.lex_state = 84, .external_lex_state = 15},
  [789] = {.lex_state = 84, .external_lex_state = 15},
  [790] = {.lex_state = 84, .external_lex_state = 15},
  [791] = {.lex_state = 84, .external_lex_state = 15},
  [792] = {.lex_state = 84, .external_lex_state = 15},
  [793] = {.lex_state = 84, .external_lex_state = 15},
  [794] = {.lex_state = 84, .external_lex_state = 15},
  [795] = {.lex_state = 84, .external_lex_state = 15},
  [796] = {.lex_state = 84, .external_lex_state = 15},
  [797] = {.lex_state = 84, .external_lex_state = 15},
  [798] = {.lex_state = 84, .external_lex_state = 15},
  [799] = {.lex_state = 84, .external_lex_state = 15},
  [800] = {.lex_state = 84, .external_lex_state = 15},
  [801] = {.lex_state = 84, .external_lex_state = 15},
  [802] = {.lex_state = 84, .external_lex_state = 15},
  [803] = {.lex_state = 84, .external_lex_state = 15},
  [804] = {.lex_state = 84, .external_lex_state = 10},
  [805] = {.lex_state = 84, .external_lex_state = 15},
  [806] = {.lex_state = 84, .external_lex_state = 7},
  [807] = {.lex_state = 84, .external_lex_state = 2},
  [808] = {.lex_state = 84, .external_lex_state = 15},
  [809] = {.lex_state = 84, .external_lex_state = 2},
  [810] = {.lex_state = 84, .external_lex_state = 2},
  [811] = {.lex_state = 84, .external_lex_state = 15},
  [812] = {.lex_state = 84, .external_lex_state = 15},
  [813] = {.lex_state = 84, .external_lex_state = 15},
  [814] = {.lex_state = 84, .external_lex_state = 15},
  [815] = {.lex_state = 84, .external_lex_state = 15},
  [816] = {.lex_state = 84, .external_lex_state = 15},
  [817] = {.lex_state = 84, .external_lex_state = 15},
  [818] = {.lex_state = 84, .external_lex_state = 15},
  [819] = {.lex_state = 84, .external_lex_state = 15},
  [820] = {.lex_state = 84, .external_lex_state = 15},
  [821] = {.lex_state = 84, .external_lex_state = 15},
  [822] = {.lex_state = 84, .external_lex_state = 15},
  [823] = {.lex_state = 84, .external_lex_state = 15},
  [824] = {.lex_state = 84, .external_lex_state = 15},
  [825] = {.lex_state = 84, .external_lex_state = 15},
  [826] = {.lex_state = 84, .external_lex_state = 15},
  [827] = {.lex_state = 84, .external_lex_state = 15},
  [828] = {.lex_state = 84, .external_lex_state = 2},
  [829] = {.lex_state = 84, .external_lex_state = 15},
  [830] = {.lex_state = 84, .external_lex_state = 15},
  [831] = {.lex_state = 84, .external_lex_state = 2},
  [832] = {.lex_state = 84, .external_lex_state = 15},
  [833] = {.lex_state = 84, .external_lex_state = 15},
  [834] = {.lex_state = 84, .external_lex_state = 15},
  [835] = {.lex_state = 84, .external_lex_state = 15},
  [836] = {.lex_state = 84, .external_lex_state = 15},
  [837] = {.lex_state = 84, .external_lex_state = 15},
  [838] = {.lex_state = 84, .external_lex_state = 15},
  [839] = {.lex_state = 84, .external_lex_state = 15},
  [840] = {.lex_state = 84, .external_lex_state = 15},
  [841] = {.lex_state = 84, .external_lex_state = 15},
  [842] = {.lex_state = 84, .external_lex_state = 2},
  [843] = {.lex_state = 84, .external_lex_state = 2},
  [844] = {.lex_state = 84, .external_lex_state = 2},
  [845] = {.lex_state = 84, .external_lex_state = 2},
  [846] = {.lex_state = 84, .external_lex_state = 2},
  [847] = {.lex_state = 84, .external_lex_state = 2},
  [848] = {.lex_state = 84, .external_lex_state = 2},
  [849] = {.lex_state = 84, .external_lex_state = 2},
  [850] = {.lex_state = 84, .external_lex_state = 2},
  [851] = {.lex_state = 84, .external_lex_state = 2},
  [852] = {.lex_state = 84, .external_lex_state = 2},
  [853] = {.lex_state = 84, .external_lex_state = 2},
  [854] = {.lex_state = 84, .external_lex_state = 2},
  [855] = {.lex_state = 84, .external_lex_state = 2},
  [856] = {.lex_state = 84, .external_lex_state = 2},
  [857] = {.lex_state = 84, .external_lex_state = 2},
  [858] = {.lex_state = 84, .external_lex_state = 2},
  [859] = {.lex_state = 84, .external_lex_state = 2},
  [860] = {.lex_state = 84, .external_lex_state = 2},
  [861] = {.lex_state = 84, .external_lex_state = 2},
  [862] = {.lex_state = 84, .external_lex_state = 2},
  [863] = {.lex_state = 84, .external_lex_state = 2},
  [864] = {.lex_state = 84, .external_lex_state = 2},
  [865] = {.lex_state = 84, .external_lex_state = 2},
  [866] = {.lex_state = 84, .external_lex_state = 2},
  [867] = {.lex_state = 84, .external_lex_state = 2},
  [868] = {.lex_state = 84, .external_lex_state = 2},
  [869] = {.lex_state = 84, .external_lex_state = 2},
  [870] = {.lex_state = 84, .external_lex_state = 2},
  [871] = {.lex_state = 84, .external_lex_state = 2},
  [872] = {.lex_state = 84, .external_lex_state = 2},
  [873] = {.lex_state = 84, .external_lex_state = 2},
  [874] = {.lex_state = 84, .external_lex_state = 2},
  [875] = {.lex_state = 84, .external_lex_state = 2},
  [876] = {.lex_state = 84, .external_lex_state = 2},
  [877] = {.lex_state = 84, .external_lex_state = 2},
  [878] = {.lex_state = 84, .external_lex_state = 2},
  [879] = {.lex_state = 84, .external_lex_state = 2},
  [880] = {.lex_state = 84, .external_lex_state = 2},
  [881] = {.lex_state = 84, .external_lex_state = 2},
  [882] = {.lex_state = 84, .external_lex_state = 2},
  [883] = {.lex_state = 84, .external_lex_state = 2},
  [884] = {.lex_state = 84, .external_lex_state = 2},
  [885] = {.lex_state = 84, .external_lex_state = 2},
  [886] = {.lex_state = 84, .external_lex_state = 2},
  [887] = {.lex_state = 84, .external_lex_state = 2},
  [888] = {.lex_state = 84, .external_lex_state = 2},
  [889] = {.lex_state = 84, .external_lex_state = 2},
  [890] = {.lex_state = 84, .external_lex_state = 2},
  [891] = {.lex_state = 84, .external_lex_state = 2},
  [892] = {.lex_state = 84, .external_lex_state = 2},
  [893] = {.lex_state = 84, .external_lex_state = 2},
  [894] = {.lex_state = 84, .external_lex_state = 2},
  [895] = {.lex_state = 84, .external_lex_state = 2},
  [896] = {.lex_state = 84, .external_lex_state = 2},
  [897] = {.lex_state = 84, .external_lex_state = 2},
  [898] = {.lex_state = 84, .external_lex_state = 2},
  [899] = {.lex_state = 84, .external_lex_state = 2},
  [900] = {.lex_state = 84, .external_lex_state = 2},
  [901] = {.lex_state = 84, .external_lex_state = 2},
  [902] = {.lex_state = 84, .external_lex_state = 2},
  [903] = {.lex_state = 84, .external_lex_state = 2},
  [904] = {.lex_state = 84, .external_lex_state = 2},
  [905] = {.lex_state = 84, .external_lex_state = 2},
  [906] = {.lex_state = 84, .external_lex_state = 2},
  [907] = {.lex_state = 84, .external_lex_state = 2},
  [908] = {.lex_state = 84, .external_lex_state = 2},
  [909] = {.lex_state = 84, .external_lex_state = 2},
  [910] = {.lex_state = 84, .external_lex_state = 2},
  [911] = {.lex_state = 84, .external_lex_state = 2},
  [912] = {.lex_state = 84, .external_lex_state = 2},
  [913] = {.lex_state = 84, .external_lex_state = 2},
  [914] = {.lex_state = 84, .external_lex_state = 2},
  [915] = {.lex_state = 84, .external_lex_state = 2},
  [916] = {.lex_state = 84, .external_lex_state = 2},
  [917] = {.lex_state = 84, .external_lex_state = 2},
  [918] = {.lex_state = 84, .external_lex_state = 2},
  [919] = {.lex_state = 84, .external_lex_state = 2},
  [920] = {.lex_state = 84, .external_lex_state = 2},
  [921] = {.lex_state = 84, .external_lex_state = 2},
  [922] = {.lex_state = 84, .external_lex_state = 2},
  [923] = {.lex_state = 84, .external_lex_state = 2},
  [924] = {.lex_state = 84, .external_lex_state = 2},
  [925] = {.lex_state = 84, .external_lex_state = 2},
  [926] = {.lex_state = 84, .external_lex_state = 2},
  [927] = {.lex_state = 84, .external_lex_state = 2},
  [928] = {.lex_state = 84, .external_lex_state = 2},
  [929] = {.lex_state = 84, .external_lex_state = 2},
  [930] = {.lex_state = 84, .external_lex_state = 2},
  [931] = {.lex_state = 84, .external_lex_state = 2},
  [932] = {.lex_state = 84, .external_lex_state = 2},
  [933] = {.lex_state = 84, .external_lex_state = 2},
  [934] = {.lex_state = 84, .external_lex_state = 2},
  [935] = {.lex_state = 84, .external_lex_state = 2},
  [936] = {.lex_state = 84, .external_lex_state = 2},
  [937] = {.lex_state = 84, .external_lex_state = 2},
  [938] = {.lex_state = 84, .external_lex_state = 2},
  [939] = {.lex_state = 84, .external_lex_state = 2},
  [940] = {.lex_state = 84, .external_lex_state = 2},
  [941] = {.lex_state = 84, .external_lex_state = 2},
  [942] = {.lex_state = 84, .external_lex_state = 2},
  [943] = {.lex_state = 84, .external_lex_state = 2},
  [944] = {.lex_state = 84, .external_lex_state = 2},
  [945] = {.lex_state = 84, .external_lex_state = 2},
  [946] = {.lex_state = 84, .external_lex_state = 2},
  [947] = {.lex_state = 84, .external_lex_state = 2},
  [948] = {.lex_state = 84, .external_lex_state = 2},
  [949] = {.lex_state = 84, .external_lex_state = 2},
  [950] = {.lex_state = 84, .external_lex_state = 2},
  [951] = {.lex_state = 84, .external_lex_state = 2},
  [952] = {.lex_state = 84, .external_lex_state = 2},
  [953] = {.lex_state = 84, .external_lex_state = 2},
  [954] = {.lex_state = 84, .external_lex_state = 2},
  [955] = {.lex_state = 84, .external_lex_state = 2},
  [956] = {.lex_state = 84, .external_lex_state = 2},
  [957] = {.lex_state = 84, .external_lex_state = 2},
  [958] = {.lex_state = 84, .external_lex_state = 2},
  [959] = {.lex_state = 84, .external_lex_state = 2},
  [960] = {.lex_state = 84, .external_lex_state = 2},
  [961] = {.lex_state = 84, .external_lex_state = 2},
  [962] = {.lex_state = 84, .external_lex_state = 2},
  [963] = {.lex_state = 84, .external_lex_state = 2},
  [964] = {.lex_state = 84, .external_lex_state = 2},
  [965] = {.lex_state = 84, .external_lex_state = 2},
  [966] = {.lex_state = 84, .external_lex_state = 2},
  [967] = {.lex_state = 84, .external_lex_state = 2},
  [968] = {.lex_state = 84, .external_lex_state = 2},
  [969] = {.lex_state = 84, .external_lex_state = 2},
  [970] = {.lex_state = 84, .external_lex_state = 2},
  [971] = {.lex_state = 84, .external_lex_state = 2},
  [972] = {.lex_state = 84, .external_lex_state = 2},
  [973] = {.lex_state = 84, .external_lex_state = 2},
  [974] = {.lex_state = 84, .external_lex_state = 2},
  [975] = {.lex_state = 84, .external_lex_state = 2},
  [976] = {.lex_state = 84, .external_lex_state = 2},
  [977] = {.lex_state = 84, .external_lex_state = 2},
  [978] = {.lex_state = 84, .external_lex_state = 2},
  [979] = {.lex_state = 84, .external_lex_state = 2},
  [980] = {.lex_state = 84, .external_lex_state = 2},
  [981] = {.lex_state = 84, .external_lex_state = 2},
  [982] = {.lex_state = 84, .external_lex_state = 2},
  [983] = {.lex_state = 84, .external_lex_state = 2},
  [984] = {.lex_state = 84, .external_lex_state = 2},
  [985] = {.lex_state = 84, .external_lex_state = 2},
  [986] = {.lex_state = 84, .external_lex_state = 2},
  [987] = {.lex_state = 84, .external_lex_state = 2},
  [988] = {.lex_state = 84, .external_lex_state = 2},
  [989] = {.lex_state = 84, .external_lex_state = 2},
  [990] = {.lex_state = 84, .external_lex_state = 2},
  [991] = {.lex_state = 84, .external_lex_state = 2},
  [992] = {.lex_state = 84, .external_lex_state = 2},
  [993] = {.lex_state = 84, .external_lex_state = 2},
  [994] = {.lex_state = 84, .external_lex_state = 2},
  [995] = {.lex_state = 84, .external_lex_state = 2},
  [996] = {.lex_state = 84, .external_lex_state = 2},
  [997] = {.lex_state = 84, .external_lex_state = 2},
  [998] = {.lex_state = 84, .external_lex_state = 2},
  [999] = {.lex_state = 84, .external_lex_state = 2},
  [1000] = {.lex_state = 84, .external_lex_state = 2},
  [1001] = {.lex_state = 84, .external_lex_state = 2},
  [1002] = {.lex_state = 84, .external_lex_state = 2},
  [1003] = {.lex_state = 84, .external_lex_state = 2},
  [1004] = {.lex_state = 84, .external_lex_state = 2},
  [1005] = {.lex_state = 84, .external_lex_state = 2},
  [1006] = {.lex_state = 84, .external_lex_state = 2},
  [1007] = {.lex_state = 67, .external_lex_state = 3},
  [1008] = {.lex_state = 84, .external_lex_state = 2},
  [1009] = {.lex_state = 84, .external_lex_state = 2},
  [1010] = {.lex_state = 84, .external_lex_state = 2},
  [1011] = {.lex_state = 84, .external_lex_state = 2},
  [1012] = {.lex_state = 84, .external_lex_state = 2},
  [1013] = {.lex_state = 84, .external_lex_state = 2},
  [1014] = {.lex_state = 84, .external_lex_state = 2},
  [1015] = {.lex_state = 84, .external_lex_state = 2},
  [1016] = {.lex_state = 84, .external_lex_state = 2},
  [1017] = {.lex_state = 84, .external_lex_state = 2},
  [1018] = {.lex_state = 84, .external_lex_state = 2},
  [1019] = {.lex_state = 84, .external_lex_state = 2},
  [1020] = {.lex_state = 84, .external_lex_state = 2},
  [1021] = {.lex_state = 84, .external_lex_state = 2},
  [1022] = {.lex_state = 84, .external_lex_state = 2},
  [1023] = {.lex_state = 84, .external_lex_state = 2},
  [1024] = {.lex_state = 84, .external_lex_state = 2},
  [1025] = {.lex_state = 84, .external_lex_state = 2},
  [1026] = {.lex_state = 84, .external_lex_state = 2},
  [1027] = {.lex_state = 84, .external_lex_state = 2},
  [1028] = {.lex_state = 84, .external_lex_state = 2},
  [1029] = {.lex_state = 84, .external_lex_state = 2},
  [1030] = {.lex_state = 84, .external_lex_state = 2},
  [1031] = {.lex_state = 84, .external_lex_state = 2},
  [1032] = {.lex_state = 84, .external_lex_state = 2},
  [1033] = {.lex_state = 84, .external_lex_state = 2},
  [1034] = {.lex_state = 84, .external_lex_state = 2},
  [1035] = {.lex_state = 84, .external_lex_state = 2},
  [1036] = {.lex_state = 84, .external_lex_state = 2},
  [1037] = {.lex_state = 84, .external_lex_state = 2},
  [1038] = {.lex_state = 84, .external_lex_state = 2},
  [1039] = {.lex_state = 84, .external_lex_state = 2},
  [1040] = {.lex_state = 84, .external_lex_state = 2},
  [1041] = {.lex_state = 84, .external_lex_state = 2},
  [1042] = {.lex_state = 84, .external_lex_state = 2},
  [1043] = {.lex_state = 84, .external_lex_state = 2},
  [1044] = {.lex_state = 84, .external_lex_state = 2},
  [1045] = {.lex_state = 84, .external_lex_state = 2},
  [1046] = {.lex_state = 84, .external_lex_state = 2},
  [1047] = {.lex_state = 84, .external_lex_state = 2},
  [1048] = {.lex_state = 84, .external_lex_state = 2},
  [1049] = {.lex_state = 84, .external_lex_state = 2},
  [1050] = {.lex_state = 84, .external_lex_state = 2},
  [1051] = {.lex_state = 84, .external_lex_state = 2},
  [1052] = {.lex_state = 84, .external_lex_state = 2},
  [1053] = {.lex_state = 84, .external_lex_state = 2},
  [1054] = {.lex_state = 84, .external_lex_state = 2},
  [1055] = {.lex_state = 84, .external_lex_state = 2},
  [1056] = {.lex_state = 84, .external_lex_state = 2},
  [1057] = {.lex_state = 84, .external_lex_state = 2},
  [1058] = {.lex_state = 84, .external_lex_state = 2},
  [1059] = {.lex_state = 84, .external_lex_state = 2},
  [1060] = {.lex_state = 84, .external_lex_state = 2},
  [1061] = {.lex_state = 84, .external_lex_state = 2},
  [1062] = {.lex_state = 84, .external_lex_state = 2},
  [1063] = {.lex_state = 84, .external_lex_state = 2},
  [1064] = {.lex_state = 84, .external_lex_state = 2},
  [1065] = {.lex_state = 84, .external_lex_state = 2},
  [1066] = {.lex_state = 84, .external_lex_state = 2},
  [1067] = {.lex_state = 84, .external_lex_state = 2},
  [1068] = {.lex_state = 84, .external_lex_state = 2},
  [1069] = {.lex_state = 84, .external_lex_state = 2},
  [1070] = {.lex_state = 84, .external_lex_state = 2},
  [1071] = {.lex_state = 84, .external_lex_state = 2},
  [1072] = {.lex_state = 84, .external_lex_state = 2},
  [1073] = {.lex_state = 84, .external_lex_state = 2},
  [1074] = {.lex_state = 84, .external_lex_state = 2},
  [1075] = {.lex_state = 84, .external_lex_state = 2},
  [1076] = {.lex_state = 84, .external_lex_state = 2},
  [1077] = {.lex_state = 84, .external_lex_state = 2},
  [1078] = {.lex_state = 84, .external_lex_state = 2},
  [1079] = {.lex_state = 84, .external_lex_state = 2},
  [1080] = {.lex_state = 84, .external_lex_state = 2},
  [1081] = {.lex_state = 84, .external_lex_state = 2},
  [1082] = {.lex_state = 84, .external_lex_state = 2},
  [1083] = {.lex_state = 84, .external_lex_state = 2},
  [1084] = {.lex_state = 84, .external_lex_state = 2},
  [1085] = {.lex_state = 84, .external_lex_state = 2},
  [1086] = {.lex_state = 84, .external_lex_state = 2},
  [1087] = {.lex_state = 84, .external_lex_state = 2},
  [1088] = {.lex_state = 84, .external_lex_state = 2},
  [1089] = {.lex_state = 84, .external_lex_state = 2},
  [1090] = {.lex_state = 84, .external_lex_state = 2},
  [1091] = {.lex_state = 84, .external_lex_state = 2},
  [1092] = {.lex_state = 84, .external_lex_state = 2},
  [1093] = {.lex_state = 84, .external_lex_state = 2},
  [1094] = {.lex_state = 84, .external_lex_state = 2},
  [1095] = {.lex_state = 84, .external_lex_state = 2},
  [1096] = {.lex_state = 84, .external_lex_state = 2},
  [1097] = {.lex_state = 84, .external_lex_state = 2},
  [1098] = {.lex_state = 84, .external_lex_state = 2},
  [1099] = {.lex_state = 84, .external_lex_state = 2},
  [1100] = {.lex_state = 84, .external_lex_state = 2},
  [1101] = {.lex_state = 84, .external_lex_state = 2},
  [1102] = {.lex_state = 84, .external_lex_state = 2},
  [1103] = {.lex_state = 84, .external_lex_state = 2},
  [1104] = {.lex_state = 84, .external_lex_state = 2},
  [1105] = {.lex_state = 84, .external_lex_state = 2},
  [1106] = {.lex_state = 84, .external_lex_state = 2},
  [1107] = {.lex_state = 84, .external_lex_state = 2},
  [1108] = {.lex_state = 84, .external_lex_state = 2},
  [1109] = {.lex_state = 84, .external_lex_state = 2},
  [1110] = {.lex_state = 84, .external_lex_state = 2},
  [1111] = {.lex_state = 84, .external_lex_state = 2},
  [1112] = {.lex_state = 84, .external_lex_state = 2},
  [1113] = {.lex_state = 84, .external_lex_state = 2},
  [1114] = {.lex_state = 84, .external_lex_state = 2},
  [1115] = {.lex_state = 84, .external_lex_state = 2},
  [1116] = {.lex_state = 84, .external_lex_state = 2},
  [1117] = {.lex_state = 84, .external_lex_state = 2},
  [1118] = {.lex_state = 84, .external_lex_state = 2},
  [1119] = {.lex_state = 84, .external_lex_state = 2},
  [1120] = {.lex_state = 84, .external_lex_state = 2},
  [1121] = {.lex_state = 84, .external_lex_state = 2},
  [1122] = {.lex_state = 84, .external_lex_state = 2},
  [1123] = {.lex_state = 84, .external_lex_state = 2},
  [1124] = {.lex_state = 84, .external_lex_state = 2},
  [1125] = {.lex_state = 84, .external_lex_state = 2},
  [1126] = {.lex_state = 84, .external_lex_state = 2},
  [1127] = {.lex_state = 84, .external_lex_state = 2},
  [1128] = {.lex_state = 84, .external_lex_state = 2},
  [1129] = {.lex_state = 84, .external_lex_state = 2},
  [1130] = {.lex_state = 84, .external_lex_state = 2},
  [1131] = {.lex_state = 84, .external_lex_state = 2},
  [1132] = {.lex_state = 84, .external_lex_state = 2},
  [1133] = {.lex_state = 84, .external_lex_state = 2},
  [1134] = {.lex_state = 84, .external_lex_state = 2},
  [1135] = {.lex_state = 84, .external_lex_state = 2},
  [1136] = {.lex_state = 84, .external_lex_state = 2},
  [1137] = {.lex_state = 84, .external_lex_state = 2},
  [1138] = {.lex_state = 84, .external_lex_state = 2},
  [1139] = {.lex_state = 84, .external_lex_state = 2},
  [1140] = {.lex_state = 84, .external_lex_state = 2},
  [1141] = {.lex_state = 67, .external_lex_state = 3},
  [1142] = {.lex_state = 84, .external_lex_state = 2},
  [1143] = {.lex_state = 84, .external_lex_state = 2},
  [1144] = {.lex_state = 84, .external_lex_state = 2},
  [1145] = {.lex_state = 84, .external_lex_state = 2},
  [1146] = {.lex_state = 84, .external_lex_state = 2},
  [1147] = {.lex_state = 84, .external_lex_state = 2},
  [1148] = {.lex_state = 84, .external_lex_state = 2},
  [1149] = {.lex_state = 84, .external_lex_state = 2},
  [1150] = {.lex_state = 84, .external_lex_state = 2},
  [1151] = {.lex_state = 84, .external_lex_state = 2},
  [1152] = {.lex_state = 84, .external_lex_state = 2},
  [1153] = {.lex_state = 84, .external_lex_state = 2},
  [1154] = {.lex_state = 84, .external_lex_state = 2},
  [1155] = {.lex_state = 84, .external_lex_state = 2},
  [1156] = {.lex_state = 84, .external_lex_state = 2},
  [1157] = {.lex_state = 84, .external_lex_state = 2},
  [1158] = {.lex_state = 84, .external_lex_state = 2},
  [1159] = {.lex_state = 84, .external_lex_state = 2},
  [1160] = {.lex_state = 84, .external_lex_state = 2},
  [1161] = {.lex_state = 84, .external_lex_state = 2},
  [1162] = {.lex_state = 84, .external_lex_state = 2},
  [1163] = {.lex_state = 84, .external_lex_state = 2},
  [1164] = {.lex_state = 84, .external_lex_state = 2},
  [1165] = {.lex_state = 84, .external_lex_state = 2},
  [1166] = {.lex_state = 84, .external_lex_state = 2},
  [1167] = {.lex_state = 84, .external_lex_state = 2},
  [1168] = {.lex_state = 84, .external_lex_state = 2},
  [1169] = {.lex_state = 84, .external_lex_state = 2},
  [1170] = {.lex_state = 84, .external_lex_state = 2},
  [1171] = {.lex_state = 84, .external_lex_state = 2},
  [1172] = {.lex_state = 84, .external_lex_state = 2},
  [1173] = {.lex_state = 84, .external_lex_state = 2},
  [1174] = {.lex_state = 84, .external_lex_state = 2},
  [1175] = {.lex_state = 84, .external_lex_state = 2},
  [1176] = {.lex_state = 84, .external_lex_state = 2},
  [1177] = {.lex_state = 84, .external_lex_state = 2},
  [1178] = {.lex_state = 84, .external_lex_state = 2},
  [1179] = {.lex_state = 84, .external_lex_state = 2},
  [1180] = {.lex_state = 84, .external_lex_state = 2},
  [1181] = {.lex_state = 84, .external_lex_state = 2},
  [1182] = {.lex_state = 84, .external_lex_state = 2},
  [1183] = {.lex_state = 84, .external_lex_state = 2},
  [1184] = {.lex_state = 84, .external_lex_state = 2},
  [1185] = {.lex_state = 84, .external_lex_state = 2},
  [1186] = {.lex_state = 84, .external_lex_state = 2},
  [1187] = {.lex_state = 84, .external_lex_state = 2},
  [1188] = {.lex_state = 84, .external_lex_state = 2},
  [1189] = {.lex_state = 84, .external_lex_state = 2},
  [1190] = {.lex_state = 84, .external_lex_state = 2},
  [1191] = {.lex_state = 84, .external_lex_state = 2},
  [1192] = {.lex_state = 84, .external_lex_state = 2},
  [1193] = {.lex_state = 84, .external_lex_state = 2},
  [1194] = {.lex_state = 84, .external_lex_state = 2},
  [1195] = {.lex_state = 84, .external_lex_state = 2},
  [1196] = {.lex_state = 84, .external_lex_state = 2},
  [1197] = {.lex_state = 84, .external_lex_state = 2},
  [1198] = {.lex_state = 84, .external_lex_state = 2},
  [1199] = {.lex_state = 84, .external_lex_state = 2},
  [1200] = {.lex_state = 84, .external_lex_state = 2},
  [1201] = {.lex_state = 84, .external_lex_state = 2},
  [1202] = {.lex_state = 84, .external_lex_state = 2},
  [1203] = {.lex_state = 84, .external_lex_state = 2},
  [1204] = {.lex_state = 84, .external_lex_state = 2},
  [1205] = {.lex_state = 84, .external_lex_state = 2},
  [1206] = {.lex_state = 84, .external_lex_state = 2},
  [1207] = {.lex_state = 84, .external_lex_state = 2},
  [1208] = {.lex_state = 84, .external_lex_state = 2},
  [1209] = {.lex_state = 84, .external_lex_state = 2},
  [1210] = {.lex_state = 84, .external_lex_state = 2},
  [1211] = {.lex_state = 84, .external_lex_state = 2},
  [1212] = {.lex_state = 84, .external_lex_state = 2},
  [1213] = {.lex_state = 84, .external_lex_state = 2},
  [1214] = {.lex_state = 84, .external_lex_state = 2},
  [1215] = {.lex_state = 84, .external_lex_state = 2},
  [1216] = {.lex_state = 84, .external_lex_state = 2},
  [1217] = {.lex_state = 84, .external_lex_state = 2},
  [1218] = {.lex_state = 84, .external_lex_state = 2},
  [1219] = {.lex_state = 84, .external_lex_state = 2},
  [1220] = {.lex_state = 84, .external_lex_state = 2},
  [1221] = {.lex_state = 84, .external_lex_state = 2},
  [1222] = {.lex_state = 84, .external_lex_state = 2},
  [1223] = {.lex_state = 84, .external_lex_state = 2},
  [1224] = {.lex_state = 84, .external_lex_state = 2},
  [1225] = {.lex_state = 84, .external_lex_state = 2},
  [1226] = {.lex_state = 84, .external_lex_state = 2},
  [1227] = {.lex_state = 84, .external_lex_state = 2},
  [1228] = {.lex_state = 84, .external_lex_state = 2},
  [1229] = {.lex_state = 84, .external_lex_state = 2},
  [1230] = {.lex_state = 84, .external_lex_state = 2},
  [1231] = {.lex_state = 84, .external_lex_state = 2},
  [1232] = {.lex_state = 84, .external_lex_state = 2},
  [1233] = {.lex_state = 84, .external_lex_state = 2},
  [1234] = {.lex_state = 84, .external_lex_state = 2},
  [1235] = {.lex_state = 84, .external_lex_state = 2},
  [1236] = {.lex_state = 84, .external_lex_state = 2},
  [1237] = {.lex_state = 84, .external_lex_state = 2},
  [1238] = {.lex_state = 84, .external_lex_state = 2},
  [1239] = {.lex_state = 84, .external_lex_state = 2},
  [1240] = {.lex_state = 84, .external_lex_state = 2},
  [1241] = {.lex_state = 84, .external_lex_state = 2},
  [1242] = {.lex_state = 84, .external_lex_state = 2},
  [1243] = {.lex_state = 84, .external_lex_state = 2},
  [1244] = {.lex_state = 84, .external_lex_state = 2},
  [1245] = {.lex_state = 84, .external_lex_state = 2},
  [1246] = {.lex_state = 84, .external_lex_state = 2},
  [1247] = {.lex_state = 84, .external_lex_state = 2},
  [1248] = {.lex_state = 84, .external_lex_state = 2},
  [1249] = {.lex_state = 84, .external_lex_state = 2},
  [1250] = {.lex_state = 84, .external_lex_state = 2},
  [1251] = {.lex_state = 84, .external_lex_state = 2},
  [1252] = {.lex_state = 84, .external_lex_state = 2},
  [1253] = {.lex_state = 84, .external_lex_state = 2},
  [1254] = {.lex_state = 84, .external_lex_state = 2},
  [1255] = {.lex_state = 84, .external_lex_state = 2},
  [1256] = {.lex_state = 84, .external_lex_state = 2},
  [1257] = {.lex_state = 84, .external_lex_state = 2},
  [1258] = {.lex_state = 84, .external_lex_state = 2},
  [1259] = {.lex_state = 84, .external_lex_state = 2},
  [1260] = {.lex_state = 84, .external_lex_state = 2},
  [1261] = {.lex_state = 84, .external_lex_state = 2},
  [1262] = {.lex_state = 84, .external_lex_state = 2},
  [1263] = {.lex_state = 84, .external_lex_state = 2},
  [1264] = {.lex_state = 84, .external_lex_state = 2},
  [1265] = {.lex_state = 84, .external_lex_state = 2},
  [1266] = {.lex_state = 84, .external_lex_state = 2},
  [1267] = {.lex_state = 84, .external_lex_state = 2},
  [1268] = {.lex_state = 84, .external_lex_state = 2},
  [1269] = {.lex_state = 84, .external_lex_state = 2},
  [1270] = {.lex_state = 84, .external_lex_state = 2},
  [1271] = {.lex_state = 84, .external_lex_state = 2},
  [1272] = {.lex_state = 84, .external_lex_state = 2},
  [1273] = {.lex_state = 84, .external_lex_state = 2},
  [1274] = {.lex_state = 84, .external_lex_state = 2},
  [1275] = {.lex_state = 84, .external_lex_state = 2},
  [1276] = {.lex_state = 84, .external_lex_state = 2},
  [1277] = {.lex_state = 84, .external_lex_state = 2},
  [1278] = {.lex_state = 84, .external_lex_state = 2},
  [1279] = {.lex_state = 84, .external_lex_state = 2},
  [1280] = {.lex_state = 84, .external_lex_state = 2},
  [1281] = {.lex_state = 84, .external_lex_state = 2},
  [1282] = {.lex_state = 84, .external_lex_state = 2},
  [1283] = {.lex_state = 84, .external_lex_state = 2},
  [1284] = {.lex_state = 84, .external_lex_state = 2},
  [1285] = {.lex_state = 84, .external_lex_state = 2},
  [1286] = {.lex_state = 84, .external_lex_state = 2},
  [1287] = {.lex_state = 84, .external_lex_state = 2},
  [1288] = {.lex_state = 84, .external_lex_state = 2},
  [1289] = {.lex_state = 84, .external_lex_state = 2},
  [1290] = {.lex_state = 84, .external_lex_state = 2},
  [1291] = {.lex_state = 84, .external_lex_state = 2},
  [1292] = {.lex_state = 84, .external_lex_state = 2},
  [1293] = {.lex_state = 84, .external_lex_state = 2},
  [1294] = {.lex_state = 84, .external_lex_state = 2},
  [1295] = {.lex_state = 84, .external_lex_state = 2},
  [1296] = {.lex_state = 84, .external_lex_state = 2},
  [1297] = {.lex_state = 84, .external_lex_state = 2},
  [1298] = {.lex_state = 84, .external_lex_state = 2},
  [1299] = {.lex_state = 84, .external_lex_state = 2},
  [1300] = {.lex_state = 84, .external_lex_state = 2},
  [1301] = {.lex_state = 84, .external_lex_state = 2},
  [1302] = {.lex_state = 84, .external_lex_state = 2},
  [1303] = {.lex_state = 84, .external_lex_state = 2},
  [1304] = {.lex_state = 84, .external_lex_state = 2},
  [1305] = {.lex_state = 84, .external_lex_state = 2},
  [1306] = {.lex_state = 84, .external_lex_state = 2},
  [1307] = {.lex_state = 84, .external_lex_state = 2},
  [1308] = {.lex_state = 84, .external_lex_state = 2},
  [1309] = {.lex_state = 84, .external_lex_state = 2},
  [1310] = {.lex_state = 84, .external_lex_state = 2},
  [1311] = {.lex_state = 84, .external_lex_state = 2},
  [1312] = {.lex_state = 84, .external_lex_state = 2},
  [1313] = {.lex_state = 84, .external_lex_state = 2},
  [1314] = {.lex_state = 84, .external_lex_state = 2},
  [1315] = {.lex_state = 84, .external_lex_state = 2},
  [1316] = {.lex_state = 84, .external_lex_state = 2},
  [1317] = {.lex_state = 84, .external_lex_state = 2},
  [1318] = {.lex_state = 84, .external_lex_state = 2},
  [1319] = {.lex_state = 84, .external_lex_state = 2},
  [1320] = {.lex_state = 84, .external_lex_state = 2},
  [1321] = {.lex_state = 84, .external_lex_state = 2},
  [1322] = {.lex_state = 84, .external_lex_state = 2},
  [1323] = {.lex_state = 84, .external_lex_state = 2},
  [1324] = {.lex_state = 84, .external_lex_state = 2},
  [1325] = {.lex_state = 84, .external_lex_state = 2},
  [1326] = {.lex_state = 84, .external_lex_state = 2},
  [1327] = {.lex_state = 84, .external_lex_state = 2},
  [1328] = {.lex_state = 84, .external_lex_state = 2},
  [1329] = {.lex_state = 84, .external_lex_state = 2},
  [1330] = {.lex_state = 84, .external_lex_state = 2},
  [1331] = {.lex_state = 84, .external_lex_state = 2},
  [1332] = {.lex_state = 84, .external_lex_state = 2},
  [1333] = {.lex_state = 84, .external_lex_state = 2},
  [1334] = {.lex_state = 84, .external_lex_state = 2},
  [1335] = {.lex_state = 84, .external_lex_state = 2},
  [1336] = {.lex_state = 84, .external_lex_state = 2},
  [1337] = {.lex_state = 84, .external_lex_state = 2},
  [1338] = {.lex_state = 84, .external_lex_state = 2},
  [1339] = {.lex_state = 84, .external_lex_state = 2},
  [1340] = {.lex_state = 84, .external_lex_state = 2},
  [1341] = {.lex_state = 84, .external_lex_state = 2},
  [1342] = {.lex_state = 84, .external_lex_state = 2},
  [1343] = {.lex_state = 84, .external_lex_state = 2},
  [1344] = {.lex_state = 84, .external_lex_state = 2},
  [1345] = {.lex_state = 84, .external_lex_state = 2},
  [1346] = {.lex_state = 84, .external_lex_state = 2},
  [1347] = {.lex_state = 84, .external_lex_state = 2},
  [1348] = {.lex_state = 84, .external_lex_state = 2},
  [1349] = {.lex_state = 84, .external_lex_state = 2},
  [1350] = {.lex_state = 84, .external_lex_state = 2},
  [1351] = {.lex_state = 84, .external_lex_state = 2},
  [1352] = {.lex_state = 84, .external_lex_state = 2},
  [1353] = {.lex_state = 84, .external_lex_state = 2},
  [1354] = {.lex_state = 84, .external_lex_state = 2},
  [1355] = {.lex_state = 84, .external_lex_state = 2},
  [1356] = {.lex_state = 84, .external_lex_state = 2},
  [1357] = {.lex_state = 84, .external_lex_state = 2},
  [1358] = {.lex_state = 84, .external_lex_state = 2},
  [1359] = {.lex_state = 84, .external_lex_state = 2},
  [1360] = {.lex_state = 84, .external_lex_state = 2},
  [1361] = {.lex_state = 84, .external_lex_state = 2},
  [1362] = {.lex_state = 84, .external_lex_state = 2},
  [1363] = {.lex_state = 84, .external_lex_state = 2},
  [1364] = {.lex_state = 84, .external_lex_state = 2},
  [1365] = {.lex_state = 84, .external_lex_state = 2},
  [1366] = {.lex_state = 84, .external_lex_state = 2},
  [1367] = {.lex_state = 84, .external_lex_state = 2},
  [1368] = {.lex_state = 84, .external_lex_state = 2},
  [1369] = {.lex_state = 84, .external_lex_state = 2},
  [1370] = {.lex_state = 84, .external_lex_state = 2},
  [1371] = {.lex_state = 84, .external_lex_state = 2},
  [1372] = {.lex_state = 84, .external_lex_state = 2},
  [1373] = {.lex_state = 84, .external_lex_state = 2},
  [1374] = {.lex_state = 84, .external_lex_state = 2},
  [1375] = {.lex_state = 84, .external_lex_state = 2},
  [1376] = {.lex_state = 84, .external_lex_state = 2},
  [1377] = {.lex_state = 84, .external_lex_state = 2},
  [1378] = {.lex_state = 84, .external_lex_state = 2},
  [1379] = {.lex_state = 84, .external_lex_state = 2},
  [1380] = {.lex_state = 84, .external_lex_state = 2},
  [1381] = {.lex_state = 84, .external_lex_state = 2},
  [1382] = {.lex_state = 84, .external_lex_state = 2},
  [1383] = {.lex_state = 84, .external_lex_state = 2},
  [1384] = {.lex_state = 84, .external_lex_state = 2},
  [1385] = {.lex_state = 84, .external_lex_state = 2},
  [1386] = {.lex_state = 84, .external_lex_state = 2},
  [1387] = {.lex_state = 84, .external_lex_state = 2},
  [1388] = {.lex_state = 84, .external_lex_state = 2},
  [1389] = {.lex_state = 84, .external_lex_state = 2},
  [1390] = {.lex_state = 84, .external_lex_state = 2},
  [1391] = {.lex_state = 84, .external_lex_state = 2},
  [1392] = {.lex_state = 84, .external_lex_state = 2},
  [1393] = {.lex_state = 84, .external_lex_state = 2},
  [1394] = {.lex_state = 84, .external_lex_state = 2},
  [1395] = {.lex_state = 84, .external_lex_state = 2},
  [1396] = {.lex_state = 84, .external_lex_state = 2},
  [1397] = {.lex_state = 84, .external_lex_state = 2},
  [1398] = {.lex_state = 84, .external_lex_state = 2},
  [1399] = {.lex_state = 84, .external_lex_state = 2},
  [1400] = {.lex_state = 84, .external_lex_state = 2},
  [1401] = {.lex_state = 84, .external_lex_state = 2},
  [1402] = {.lex_state = 84, .external_lex_state = 2},
  [1403] = {.lex_state = 84, .external_lex_state = 2},
  [1404] = {.lex_state = 84, .external_lex_state = 2},
  [1405] = {.lex_state = 84, .external_lex_state = 2},
  [1406] = {.lex_state = 84, .external_lex_state = 2},
  [1407] = {.lex_state = 84, .external_lex_state = 2},
  [1408] = {.lex_state = 84, .external_lex_state = 2},
  [1409] = {.lex_state = 84, .external_lex_state = 2},
  [1410] = {.lex_state = 84, .external_lex_state = 2},
  [1411] = {.lex_state = 84, .external_lex_state = 2},
  [1412] = {.lex_state = 84, .external_lex_state = 2},
  [1413] = {.lex_state = 84, .external_lex_state = 2},
  [1414] = {.lex_state = 84, .external_lex_state = 2},
  [1415] = {.lex_state = 84, .external_lex_state = 2},
  [1416] = {.lex_state = 84, .external_lex_state = 2},
  [1417] = {.lex_state = 84, .external_lex_state = 2},
  [1418] = {.lex_state = 84, .external_lex_state = 2},
  [1419] = {.lex_state = 84, .external_lex_state = 2},
  [1420] = {.lex_state = 84, .external_lex_state = 2},
  [1421] = {.lex_state = 84, .external_lex_state = 2},
  [1422] = {.lex_state = 84, .external_lex_state = 2},
  [1423] = {.lex_state = 84, .external_lex_state = 2},
  [1424] = {.lex_state = 84, .external_lex_state = 2},
  [1425] = {.lex_state = 84, .external_lex_state = 2},
  [1426] = {.lex_state = 84, .external_lex_state = 2},
  [1427] = {.lex_state = 84, .external_lex_state = 2},
  [1428] = {.lex_state = 84, .external_lex_state = 2},
  [1429] = {.lex_state = 84, .external_lex_state = 2},
  [1430] = {.lex_state = 84, .external_lex_state = 2},
  [1431] = {.lex_state = 84, .external_lex_state = 2},
  [1432] = {.lex_state = 84, .external_lex_state = 2},
  [1433] = {.lex_state = 84, .external_lex_state = 2},
  [1434] = {.lex_state = 84, .external_lex_state = 2},
  [1435] = {.lex_state = 84, .external_lex_state = 2},
  [1436] = {.lex_state = 84, .external_lex_state = 2},
  [1437] = {.lex_state = 84, .external_lex_state = 2},
  [1438] = {.lex_state = 84, .external_lex_state = 2},
  [1439] = {.lex_state = 84, .external_lex_state = 2},
  [1440] = {.lex_state = 84, .external_lex_state = 2},
  [1441] = {.lex_state = 84, .external_lex_state = 2},
  [1442] = {.lex_state = 84, .external_lex_state = 2},
  [1443] = {.lex_state = 84, .external_lex_state = 2},
  [1444] = {.lex_state = 84, .external_lex_state = 2},
  [1445] = {.lex_state = 84, .external_lex_state = 2},
  [1446] = {.lex_state = 84, .external_lex_state = 2},
  [1447] = {.lex_state = 84, .external_lex_state = 2},
  [1448] = {.lex_state = 84, .external_lex_state = 2},
  [1449] = {.lex_state = 84, .external_lex_state = 2},
  [1450] = {.lex_state = 84, .external_lex_state = 2},
  [1451] = {.lex_state = 84, .external_lex_state = 2},
  [1452] = {.lex_state = 84, .external_lex_state = 2},
  [1453] = {.lex_state = 84, .external_lex_state = 2},
  [1454] = {.lex_state = 84, .external_lex_state = 2},
  [1455] = {.lex_state = 84, .external_lex_state = 2},
  [1456] = {.lex_state = 84, .external_lex_state = 2},
  [1457] = {.lex_state = 84, .external_lex_state = 2},
  [1458] = {.lex_state = 84, .external_lex_state = 2},
  [1459] = {.lex_state = 84, .external_lex_state = 2},
  [1460] = {.lex_state = 84, .external_lex_state = 2},
  [1461] = {.lex_state = 84, .external_lex_state = 2},
  [1462] = {.lex_state = 84, .external_lex_state = 2},
  [1463] = {.lex_state = 84, .external_lex_state = 2},
  [1464] = {.lex_state = 84, .external_lex_state = 2},
  [1465] = {.lex_state = 84, .external_lex_state = 2},
  [1466] = {.lex_state = 84, .external_lex_state = 2},
  [1467] = {.lex_state = 84, .external_lex_state = 2},
  [1468] = {.lex_state = 84, .external_lex_state = 2},
  [1469] = {.lex_state = 84, .external_lex_state = 2},
  [1470] = {.lex_state = 84, .external_lex_state = 2},
  [1471] = {.lex_state = 84, .external_lex_state = 2},
  [1472] = {.lex_state = 84, .external_lex_state = 2},
  [1473] = {.lex_state = 84, .external_lex_state = 2},
  [1474] = {.lex_state = 84, .external_lex_state = 2},
  [1475] = {.lex_state = 84, .external_lex_state = 2},
  [1476] = {.lex_state = 84, .external_lex_state = 2},
  [1477] = {.lex_state = 84, .external_lex_state = 2},
  [1478] = {.lex_state = 84, .external_lex_state = 2},
  [1479] = {.lex_state = 84, .external_lex_state = 2},
  [1480] = {.lex_state = 84, .external_lex_state = 2},
  [1481] = {.lex_state = 84, .external_lex_state = 2},
  [1482] = {.lex_state = 84, .external_lex_state = 2},
  [1483] = {.lex_state = 84, .external_lex_state = 2},
  [1484] = {.lex_state = 84, .external_lex_state = 2},
  [1485] = {.lex_state = 84, .external_lex_state = 2},
  [1486] = {.lex_state = 84, .external_lex_state = 2},
  [1487] = {.lex_state = 84, .external_lex_state = 2},
  [1488] = {.lex_state = 84, .external_lex_state = 2},
  [1489] = {.lex_state = 84, .external_lex_state = 2},
  [1490] = {.lex_state = 84, .external_lex_state = 2},
  [1491] = {.lex_state = 84, .external_lex_state = 2},
  [1492] = {.lex_state = 84, .external_lex_state = 2},
  [1493] = {.lex_state = 84, .external_lex_state = 2},
  [1494] = {.lex_state = 84, .external_lex_state = 2},
  [1495] = {.lex_state = 84, .external_lex_state = 2},
  [1496] = {.lex_state = 84, .external_lex_state = 2},
  [1497] = {.lex_state = 84, .external_lex_state = 2},
  [1498] = {.lex_state = 84, .external_lex_state = 2},
  [1499] = {.lex_state = 84, .external_lex_state = 2},
  [1500] = {.lex_state = 84, .external_lex_state = 2},
  [1501] = {.lex_state = 84, .external_lex_state = 2},
  [1502] = {.lex_state = 84, .external_lex_state = 2},
  [1503] = {.lex_state = 84, .external_lex_state = 2},
  [1504] = {.lex_state = 84, .external_lex_state = 2},
  [1505] = {.lex_state = 84, .external_lex_state = 2},
  [1506] = {.lex_state = 84, .external_lex_state = 2},
  [1507] = {.lex_state = 84, .external_lex_state = 2},
  [1508] = {.lex_state = 84, .external_lex_state = 2},
  [1509] = {.lex_state = 84, .external_lex_state = 2},
  [1510] = {.lex_state = 84, .external_lex_state = 2},
  [1511] = {.lex_state = 84, .external_lex_state = 2},
  [1512] = {.lex_state = 84, .external_lex_state = 2},
  [1513] = {.lex_state = 84, .external_lex_state = 2},
  [1514] = {.lex_state = 84, .external_lex_state = 2},
  [1515] = {.lex_state = 84, .external_lex_state = 2},
  [1516] = {.lex_state = 84, .external_lex_state = 2},
  [1517] = {.lex_state = 84, .external_lex_state = 2},
  [1518] = {.lex_state = 84, .external_lex_state = 2},
  [1519] = {.lex_state = 84, .external_lex_state = 2},
  [1520] = {.lex_state = 84, .external_lex_state = 2},
  [1521] = {.lex_state = 84, .external_lex_state = 2},
  [1522] = {.lex_state = 84, .external_lex_state = 2},
  [1523] = {.lex_state = 84, .external_lex_state = 2},
  [1524] = {.lex_state = 84, .external_lex_state = 2},
  [1525] = {.lex_state = 84, .external_lex_state = 2},
  [1526] = {.lex_state = 84, .external_lex_state = 2},
  [1527] = {.lex_state = 84, .external_lex_state = 2},
  [1528] = {.lex_state = 84, .external_lex_state = 2},
  [1529] = {.lex_state = 84, .external_lex_state = 2},
  [1530] = {.lex_state = 84, .external_lex_state = 2},
  [1531] = {.lex_state = 84, .external_lex_state = 2},
  [1532] = {.lex_state = 84, .external_lex_state = 2},
  [1533] = {.lex_state = 84, .external_lex_state = 2},
  [1534] = {.lex_state = 84, .external_lex_state = 2},
  [1535] = {.lex_state = 84, .external_lex_state = 2},
  [1536] = {.lex_state = 84, .external_lex_state = 2},
  [1537] = {.lex_state = 84, .external_lex_state = 2},
  [1538] = {.lex_state = 84, .external_lex_state = 2},
  [1539] = {.lex_state = 84, .external_lex_state = 2},
  [1540] = {.lex_state = 84, .external_lex_state = 2},
  [1541] = {.lex_state = 84, .external_lex_state = 2},
  [1542] = {.lex_state = 84, .external_lex_state = 2},
  [1543] = {.lex_state = 84, .external_lex_state = 2},
  [1544] = {.lex_state = 84, .external_lex_state = 2},
  [1545] = {.lex_state = 84, .external_lex_state = 2},
  [1546] = {.lex_state = 84, .external_lex_state = 2},
  [1547] = {.lex_state = 84, .external_lex_state = 2},
  [1548] = {.lex_state = 84, .external_lex_state = 2},
  [1549] = {.lex_state = 84, .external_lex_state = 2},
  [1550] = {.lex_state = 84, .external_lex_state = 2},
  [1551] = {.lex_state = 84, .external_lex_state = 2},
  [1552] = {.lex_state = 84, .external_lex_state = 2},
  [1553] = {.lex_state = 84, .external_lex_state = 2},
  [1554] = {.lex_state = 84, .external_lex_state = 2},
  [1555] = {.lex_state = 84, .external_lex_state = 2},
  [1556] = {.lex_state = 84, .external_lex_state = 2},
  [1557] = {.lex_state = 84, .external_lex_state = 2},
  [1558] = {.lex_state = 84, .external_lex_state = 2},
  [1559] = {.lex_state = 84, .external_lex_state = 2},
  [1560] = {.lex_state = 84, .external_lex_state = 2},
  [1561] = {.lex_state = 84, .external_lex_state = 2},
  [1562] = {.lex_state = 84, .external_lex_state = 2},
  [1563] = {.lex_state = 84, .external_lex_state = 2},
  [1564] = {.lex_state = 84, .external_lex_state = 2},
  [1565] = {.lex_state = 84, .external_lex_state = 2},
  [1566] = {.lex_state = 84, .external_lex_state = 2},
  [1567] = {.lex_state = 84, .external_lex_state = 2},
  [1568] = {.lex_state = 84, .external_lex_state = 2},
  [1569] = {.lex_state = 84, .external_lex_state = 2},
  [1570] = {.lex_state = 84, .external_lex_state = 2},
  [1571] = {.lex_state = 84, .external_lex_state = 2},
  [1572] = {.lex_state = 84, .external_lex_state = 2},
  [1573] = {.lex_state = 84, .external_lex_state = 2},
  [1574] = {.lex_state = 84, .external_lex_state = 2},
  [1575] = {.lex_state = 84, .external_lex_state = 2},
  [1576] = {.lex_state = 84, .external_lex_state = 2},
  [1577] = {.lex_state = 84, .external_lex_state = 2},
  [1578] = {.lex_state = 84, .external_lex_state = 2},
  [1579] = {.lex_state = 84, .external_lex_state = 2},
  [1580] = {.lex_state = 84, .external_lex_state = 2},
  [1581] = {.lex_state = 84, .external_lex_state = 2},
  [1582] = {.lex_state = 84, .external_lex_state = 2},
  [1583] = {.lex_state = 84, .external_lex_state = 2},
  [1584] = {.lex_state = 84, .external_lex_state = 2},
  [1585] = {.lex_state = 84, .external_lex_state = 2},
  [1586] = {.lex_state = 84, .external_lex_state = 2},
  [1587] = {.lex_state = 84, .external_lex_state = 2},
  [1588] = {.lex_state = 84, .external_lex_state = 2},
  [1589] = {.lex_state = 84, .external_lex_state = 2},
  [1590] = {.lex_state = 84, .external_lex_state = 2},
  [1591] = {.lex_state = 84, .external_lex_state = 2},
  [1592] = {.lex_state = 84, .external_lex_state = 2},
  [1593] = {.lex_state = 84, .external_lex_state = 2},
  [1594] = {.lex_state = 84, .external_lex_state = 2},
  [1595] = {.lex_state = 84, .external_lex_state = 2},
  [1596] = {.lex_state = 84, .external_lex_state = 2},
  [1597] = {.lex_state = 84, .external_lex_state = 2},
  [1598] = {.lex_state = 84, .external_lex_state = 2},
  [1599] = {.lex_state = 84, .external_lex_state = 2},
  [1600] = {.lex_state = 84, .external_lex_state = 2},
  [1601] = {.lex_state = 84, .external_lex_state = 2},
  [1602] = {.lex_state = 84, .external_lex_state = 2},
  [1603] = {.lex_state = 84, .external_lex_state = 2},
  [1604] = {.lex_state = 84, .external_lex_state = 2},
  [1605] = {.lex_state = 84, .external_lex_state = 2},
  [1606] = {.lex_state = 84, .external_lex_state = 2},
  [1607] = {.lex_state = 84, .external_lex_state = 2},
  [1608] = {.lex_state = 84, .external_lex_state = 2},
  [1609] = {.lex_state = 84, .external_lex_state = 2},
  [1610] = {.lex_state = 84, .external_lex_state = 2},
  [1611] = {.lex_state = 84, .external_lex_state = 2},
  [1612] = {.lex_state = 84, .external_lex_state = 2},
  [1613] = {.lex_state = 84, .external_lex_state = 2},
  [1614] = {.lex_state = 84, .external_lex_state = 2},
  [1615] = {.lex_state = 84, .external_lex_state = 2},
  [1616] = {.lex_state = 84, .external_lex_state = 2},
  [1617] = {.lex_state = 84, .external_lex_state = 2},
  [1618] = {.lex_state = 84, .external_lex_state = 2},
  [1619] = {.lex_state = 84, .external_lex_state = 2},
  [1620] = {.lex_state = 84, .external_lex_state = 2},
  [1621] = {.lex_state = 84, .external_lex_state = 2},
  [1622] = {.lex_state = 84, .external_lex_state = 2},
  [1623] = {.lex_state = 84, .external_lex_state = 2},
  [1624] = {.lex_state = 84, .external_lex_state = 2},
  [1625] = {.lex_state = 84, .external_lex_state = 2},
  [1626] = {.lex_state = 84, .external_lex_state = 2},
  [1627] = {.lex_state = 84, .external_lex_state = 2},
  [1628] = {.lex_state = 84, .external_lex_state = 2},
  [1629] = {.lex_state = 84, .external_lex_state = 2},
  [1630] = {.lex_state = 84, .external_lex_state = 2},
  [1631] = {.lex_state = 84, .external_lex_state = 2},
  [1632] = {.lex_state = 84, .external_lex_state = 2},
  [1633] = {.lex_state = 84, .external_lex_state = 2},
  [1634] = {.lex_state = 84, .external_lex_state = 2},
  [1635] = {.lex_state = 84, .external_lex_state = 2},
  [1636] = {.lex_state = 84, .external_lex_state = 2},
  [1637] = {.lex_state = 84, .external_lex_state = 2},
  [1638] = {.lex_state = 84, .external_lex_state = 2},
  [1639] = {.lex_state = 84, .external_lex_state = 2},
  [1640] = {.lex_state = 84, .external_lex_state = 2},
  [1641] = {.lex_state = 84, .external_lex_state = 2},
  [1642] = {.lex_state = 84, .external_lex_state = 2},
  [1643] = {.lex_state = 84, .external_lex_state = 2},
  [1644] = {.lex_state = 84, .external_lex_state = 2},
  [1645] = {.lex_state = 84, .external_lex_state = 2},
  [1646] = {.lex_state = 84, .external_lex_state = 2},
  [1647] = {.lex_state = 84, .external_lex_state = 2},
  [1648] = {.lex_state = 84, .external_lex_state = 2},
  [1649] = {.lex_state = 84, .external_lex_state = 2},
  [1650] = {.lex_state = 84, .external_lex_state = 2},
  [1651] = {.lex_state = 84, .external_lex_state = 2},
  [1652] = {.lex_state = 84, .external_lex_state = 2},
  [1653] = {.lex_state = 84, .external_lex_state = 2},
  [1654] = {.lex_state = 84, .external_lex_state = 2},
  [1655] = {.lex_state = 84, .external_lex_state = 2},
  [1656] = {.lex_state = 84, .external_lex_state = 2},
  [1657] = {.lex_state = 84, .external_lex_state = 2},
  [1658] = {.lex_state = 84, .external_lex_state = 2},
  [1659] = {.lex_state = 84, .external_lex_state = 2},
  [1660] = {.lex_state = 84, .external_lex_state = 2},
  [1661] = {.lex_state = 84, .external_lex_state = 2},
  [1662] = {.lex_state = 84, .external_lex_state = 2},
  [1663] = {.lex_state = 84, .external_lex_state = 2},
  [1664] = {.lex_state = 84, .external_lex_state = 2},
  [1665] = {.lex_state = 84, .external_lex_state = 2},
  [1666] = {.lex_state = 84, .external_lex_state = 2},
  [1667] = {.lex_state = 84, .external_lex_state = 2},
  [1668] = {.lex_state = 84, .external_lex_state = 2},
  [1669] = {.lex_state = 84, .external_lex_state = 2},
  [1670] = {.lex_state = 84, .external_lex_state = 2},
  [1671] = {.lex_state = 84, .external_lex_state = 2},
  [1672] = {.lex_state = 84, .external_lex_state = 2},
  [1673] = {.lex_state = 84, .external_lex_state = 2},
  [1674] = {.lex_state = 84, .external_lex_state = 2},
  [1675] = {.lex_state = 84, .external_lex_state = 2},
  [1676] = {.lex_state = 84, .external_lex_state = 2},
  [1677] = {.lex_state = 84, .external_lex_state = 2},
  [1678] = {.lex_state = 84, .external_lex_state = 2},
  [1679] = {.lex_state = 84, .external_lex_state = 2},
  [1680] = {.lex_state = 84, .external_lex_state = 2},
  [1681] = {.lex_state = 84, .external_lex_state = 2},
  [1682] = {.lex_state = 84, .external_lex_state = 2},
  [1683] = {.lex_state = 84, .external_lex_state = 2},
  [1684] = {.lex_state = 84, .external_lex_state = 2},
  [1685] = {.lex_state = 84, .external_lex_state = 2},
  [1686] = {.lex_state = 84, .external_lex_state = 2},
  [1687] = {.lex_state = 84, .external_lex_state = 2},
  [1688] = {.lex_state = 84, .external_lex_state = 2},
  [1689] = {.lex_state = 84, .external_lex_state = 2},
  [1690] = {.lex_state = 84, .external_lex_state = 2},
  [1691] = {.lex_state = 84, .external_lex_state = 2},
  [1692] = {.lex_state = 84, .external_lex_state = 2},
  [1693] = {.lex_state = 84, .external_lex_state = 2},
  [1694] = {.lex_state = 84, .external_lex_state = 2},
  [1695] = {.lex_state = 84, .external_lex_state = 2},
  [1696] = {.lex_state = 84, .external_lex_state = 2},
  [1697] = {.lex_state = 84, .external_lex_state = 2},
  [1698] = {.lex_state = 84, .external_lex_state = 2},
  [1699] = {.lex_state = 84, .external_lex_state = 2},
  [1700] = {.lex_state = 84, .external_lex_state = 2},
  [1701] = {.lex_state = 84, .external_lex_state = 2},
  [1702] = {.lex_state = 84, .external_lex_state = 2},
  [1703] = {.lex_state = 84, .external_lex_state = 2},
  [1704] = {.lex_state = 84, .external_lex_state = 2},
  [1705] = {.lex_state = 84, .external_lex_state = 2},
  [1706] = {.lex_state = 84, .external_lex_state = 2},
  [1707] = {.lex_state = 84, .external_lex_state = 2},
  [1708] = {.lex_state = 84, .external_lex_state = 2},
  [1709] = {.lex_state = 84, .external_lex_state = 2},
  [1710] = {.lex_state = 84, .external_lex_state = 2},
  [1711] = {.lex_state = 84, .external_lex_state = 2},
  [1712] = {.lex_state = 84, .external_lex_state = 2},
  [1713] = {.lex_state = 84, .external_lex_state = 2},
  [1714] = {.lex_state = 84, .external_lex_state = 2},
  [1715] = {.lex_state = 84, .external_lex_state = 2},
  [1716] = {.lex_state = 84, .external_lex_state = 2},
  [1717] = {.lex_state = 84, .external_lex_state = 2},
  [1718] = {.lex_state = 84, .external_lex_state = 2},
  [1719] = {.lex_state = 84, .external_lex_state = 2},
  [1720] = {.lex_state = 84, .external_lex_state = 2},
  [1721] = {.lex_state = 84, .external_lex_state = 2},
  [1722] = {.lex_state = 84, .external_lex_state = 2},
  [1723] = {.lex_state = 84, .external_lex_state = 2},
  [1724] = {.lex_state = 84, .external_lex_state = 2},
  [1725] = {.lex_state = 84, .external_lex_state = 2},
  [1726] = {.lex_state = 84, .external_lex_state = 2},
  [1727] = {.lex_state = 84, .external_lex_state = 2},
  [1728] = {.lex_state = 84, .external_lex_state = 2},
  [1729] = {.lex_state = 84, .external_lex_state = 2},
  [1730] = {.lex_state = 84, .external_lex_state = 2},
  [1731] = {.lex_state = 84, .external_lex_state = 2},
  [1732] = {.lex_state = 84, .external_lex_state = 2},
  [1733] = {.lex_state = 84, .external_lex_state = 2},
  [1734] = {.lex_state = 84, .external_lex_state = 2},
  [1735] = {.lex_state = 84, .external_lex_state = 2},
  [1736] = {.lex_state = 84, .external_lex_state = 2},
  [1737] = {.lex_state = 84, .external_lex_state = 2},
  [1738] = {.lex_state = 84, .external_lex_state = 2},
  [1739] = {.lex_state = 84, .external_lex_state = 2},
  [1740] = {.lex_state = 84, .external_lex_state = 2},
  [1741] = {.lex_state = 84, .external_lex_state = 2},
  [1742] = {.lex_state = 84, .external_lex_state = 2},
  [1743] = {.lex_state = 84, .external_lex_state = 2},
  [1744] = {.lex_state = 84, .external_lex_state = 2},
  [1745] = {.lex_state = 84, .external_lex_state = 2},
  [1746] = {.lex_state = 84, .external_lex_state = 2},
  [1747] = {.lex_state = 84, .external_lex_state = 2},
  [1748] = {.lex_state = 84, .external_lex_state = 2},
  [1749] = {.lex_state = 84, .external_lex_state = 2},
  [1750] = {.lex_state = 84, .external_lex_state = 2},
  [1751] = {.lex_state = 84, .external_lex_state = 2},
  [1752] = {.lex_state = 84, .external_lex_state = 2},
  [1753] = {.lex_state = 84, .external_lex_state = 2},
  [1754] = {.lex_state = 84, .external_lex_state = 2},
  [1755] = {.lex_state = 84, .external_lex_state = 2},
  [1756] = {.lex_state = 84, .external_lex_state = 2},
  [1757] = {.lex_state = 84, .external_lex_state = 2},
  [1758] = {.lex_state = 84, .external_lex_state = 2},
  [1759] = {.lex_state = 84, .external_lex_state = 2},
  [1760] = {.lex_state = 84, .external_lex_state = 2},
  [1761] = {.lex_state = 84, .external_lex_state = 2},
  [1762] = {.lex_state = 84, .external_lex_state = 2},
  [1763] = {.lex_state = 84, .external_lex_state = 2},
  [1764] = {.lex_state = 84, .external_lex_state = 2},
  [1765] = {.lex_state = 84, .external_lex_state = 2},
  [1766] = {.lex_state = 84, .external_lex_state = 2},
  [1767] = {.lex_state = 84, .external_lex_state = 2},
  [1768] = {.lex_state = 84, .external_lex_state = 2},
  [1769] = {.lex_state = 84, .external_lex_state = 2},
  [1770] = {.lex_state = 84, .external_lex_state = 2},
  [1771] = {.lex_state = 84, .external_lex_state = 2},
  [1772] = {.lex_state = 84, .external_lex_state = 2},
  [1773] = {.lex_state = 84, .external_lex_state = 2},
  [1774] = {.lex_state = 84, .external_lex_state = 2},
  [1775] = {.lex_state = 84, .external_lex_state = 2},
  [1776] = {.lex_state = 84, .external_lex_state = 2},
  [1777] = {.lex_state = 84, .external_lex_state = 2},
  [1778] = {.lex_state = 84, .external_lex_state = 2},
  [1779] = {.lex_state = 84, .external_lex_state = 2},
  [1780] = {.lex_state = 84, .external_lex_state = 2},
  [1781] = {.lex_state = 84, .external_lex_state = 2},
  [1782] = {.lex_state = 84, .external_lex_state = 2},
  [1783] = {.lex_state = 84, .external_lex_state = 2},
  [1784] = {.lex_state = 84, .external_lex_state = 2},
  [1785] = {.lex_state = 84, .external_lex_state = 2},
  [1786] = {.lex_state = 84, .external_lex_state = 2},
  [1787] = {.lex_state = 84, .external_lex_state = 2},
  [1788] = {.lex_state = 84, .external_lex_state = 2},
  [1789] = {.lex_state = 84, .external_lex_state = 2},
  [1790] = {.lex_state = 84, .external_lex_state = 2},
  [1791] = {.lex_state = 84, .external_lex_state = 2},
  [1792] = {.lex_state = 84, .external_lex_state = 2},
  [1793] = {.lex_state = 84, .external_lex_state = 2},
  [1794] = {.lex_state = 84, .external_lex_state = 2},
  [1795] = {.lex_state = 84, .external_lex_state = 2},
  [1796] = {.lex_state = 84, .external_lex_state = 2},
  [1797] = {.lex_state = 84, .external_lex_state = 2},
  [1798] = {.lex_state = 84, .external_lex_state = 2},
  [1799] = {.lex_state = 84, .external_lex_state = 2},
  [1800] = {.lex_state = 84, .external_lex_state = 2},
  [1801] = {.lex_state = 84, .external_lex_state = 2},
  [1802] = {.lex_state = 84, .external_lex_state = 2},
  [1803] = {.lex_state = 84, .external_lex_state = 2},
  [1804] = {.lex_state = 84, .external_lex_state = 2},
  [1805] = {.lex_state = 84, .external_lex_state = 2},
  [1806] = {.lex_state = 84, .external_lex_state = 2},
  [1807] = {.lex_state = 84, .external_lex_state = 2},
  [1808] = {.lex_state = 84, .external_lex_state = 2},
  [1809] = {.lex_state = 84, .external_lex_state = 2},
  [1810] = {.lex_state = 84, .external_lex_state = 2},
  [1811] = {.lex_state = 84, .external_lex_state = 2},
  [1812] = {.lex_state = 84, .external_lex_state = 2},
  [1813] = {.lex_state = 84, .external_lex_state = 2},
  [1814] = {.lex_state = 84, .external_lex_state = 2},
  [1815] = {.lex_state = 84, .external_lex_state = 2},
  [1816] = {.lex_state = 84, .external_lex_state = 2},
  [1817] = {.lex_state = 84, .external_lex_state = 2},
  [1818] = {.lex_state = 84, .external_lex_state = 2},
  [1819] = {.lex_state = 84, .external_lex_state = 2},
  [1820] = {.lex_state = 84, .external_lex_state = 2},
  [1821] = {.lex_state = 84, .external_lex_state = 2},
  [1822] = {.lex_state = 84, .external_lex_state = 2},
  [1823] = {.lex_state = 84, .external_lex_state = 2},
  [1824] = {.lex_state = 84, .external_lex_state = 2},
  [1825] = {.lex_state = 84, .external_lex_state = 2},
  [1826] = {.lex_state = 84, .external_lex_state = 2},
  [1827] = {.lex_state = 84, .external_lex_state = 2},
  [1828] = {.lex_state = 84, .external_lex_state = 2},
  [1829] = {.lex_state = 84, .external_lex_state = 2},
  [1830] = {.lex_state = 84, .external_lex_state = 2},
  [1831] = {.lex_state = 84, .external_lex_state = 2},
  [1832] = {.lex_state = 84, .external_lex_state = 2},
  [1833] = {.lex_state = 84, .external_lex_state = 2},
  [1834] = {.lex_state = 84, .external_lex_state = 2},
  [1835] = {.lex_state = 84, .external_lex_state = 2},
  [1836] = {.lex_state = 84, .external_lex_state = 2},
  [1837] = {.lex_state = 84, .external_lex_state = 2},
  [1838] = {.lex_state = 84, .external_lex_state = 2},
  [1839] = {.lex_state = 84, .external_lex_state = 2},
  [1840] = {.lex_state = 84, .external_lex_state = 2},
  [1841] = {.lex_state = 84, .external_lex_state = 2},
  [1842] = {.lex_state = 84, .external_lex_state = 2},
  [1843] = {.lex_state = 84, .external_lex_state = 2},
  [1844] = {.lex_state = 84, .external_lex_state = 2},
  [1845] = {.lex_state = 84, .external_lex_state = 2},
  [1846] = {.lex_state = 84, .external_lex_state = 2},
  [1847] = {.lex_state = 84, .external_lex_state = 2},
  [1848] = {.lex_state = 84, .external_lex_state = 2},
  [1849] = {.lex_state = 84, .external_lex_state = 2},
  [1850] = {.lex_state = 84, .external_lex_state = 2},
  [1851] = {.lex_state = 84, .external_lex_state = 2},
  [1852] = {.lex_state = 84, .external_lex_state = 2},
  [1853] = {.lex_state = 84, .external_lex_state = 2},
  [1854] = {.lex_state = 84, .external_lex_state = 2},
  [1855] = {.lex_state = 84, .external_lex_state = 2},
  [1856] = {.lex_state = 84, .external_lex_state = 2},
  [1857] = {.lex_state = 84, .external_lex_state = 2},
  [1858] = {.lex_state = 84, .external_lex_state = 2},
  [1859] = {.lex_state = 84, .external_lex_state = 2},
  [1860] = {.lex_state = 84, .external_lex_state = 2},
  [1861] = {.lex_state = 84, .external_lex_state = 2},
  [1862] = {.lex_state = 84, .external_lex_state = 2},
  [1863] = {.lex_state = 84, .external_lex_state = 2},
  [1864] = {.lex_state = 84, .external_lex_state = 2},
  [1865] = {.lex_state = 84, .external_lex_state = 2},
  [1866] = {.lex_state = 84, .external_lex_state = 2},
  [1867] = {.lex_state = 84, .external_lex_state = 2},
  [1868] = {.lex_state = 84, .external_lex_state = 2},
  [1869] = {.lex_state = 84, .external_lex_state = 2},
  [1870] = {.lex_state = 84, .external_lex_state = 2},
  [1871] = {.lex_state = 84, .external_lex_state = 2},
  [1872] = {.lex_state = 84, .external_lex_state = 2},
  [1873] = {.lex_state = 84, .external_lex_state = 2},
  [1874] = {.lex_state = 84, .external_lex_state = 2},
  [1875] = {.lex_state = 84, .external_lex_state = 2},
  [1876] = {.lex_state = 84, .external_lex_state = 2},
  [1877] = {.lex_state = 84, .external_lex_state = 2},
  [1878] = {.lex_state = 84, .external_lex_state = 2},
  [1879] = {.lex_state = 84, .external_lex_state = 2},
  [1880] = {.lex_state = 84, .external_lex_state = 2},
  [1881] = {.lex_state = 84, .external_lex_state = 2},
  [1882] = {.lex_state = 84, .external_lex_state = 2},
  [1883] = {.lex_state = 84, .external_lex_state = 2},
  [1884] = {.lex_state = 84, .external_lex_state = 2},
  [1885] = {.lex_state = 84, .external_lex_state = 2},
  [1886] = {.lex_state = 84, .external_lex_state = 2},
  [1887] = {.lex_state = 84, .external_lex_state = 2},
  [1888] = {.lex_state = 84, .external_lex_state = 2},
  [1889] = {.lex_state = 84, .external_lex_state = 2},
  [1890] = {.lex_state = 84, .external_lex_state = 2},
  [1891] = {.lex_state = 84, .external_lex_state = 2},
  [1892] = {.lex_state = 84, .external_lex_state = 2},
  [1893] = {.lex_state = 84, .external_lex_state = 2},
  [1894] = {.lex_state = 84, .external_lex_state = 2},
  [1895] = {.lex_state = 84, .external_lex_state = 2},
  [1896] = {.lex_state = 84, .external_lex_state = 2},
  [1897] = {.lex_state = 84, .external_lex_state = 2},
  [1898] = {.lex_state = 84, .external_lex_state = 2},
  [1899] = {.lex_state = 84, .external_lex_state = 2},
  [1900] = {.lex_state = 84, .external_lex_state = 2},
  [1901] = {.lex_state = 84, .external_lex_state = 2},
  [1902] = {.lex_state = 84, .external_lex_state = 2},
  [1903] = {.lex_state = 84, .external_lex_state = 2},
  [1904] = {.lex_state = 84, .external_lex_state = 2},
  [1905] = {.lex_state = 84, .external_lex_state = 2},
  [1906] = {.lex_state = 67, .external_lex_state = 3},
  [1907] = {.lex_state = 67, .external_lex_state = 3},
  [1908] = {.lex_state = 67, .external_lex_state = 3},
  [1909] = {.lex_state = 67, .external_lex_state = 3},
  [1910] = {.lex_state = 67, .external_lex_state = 3},
  [1911] = {.lex_state = 67, .external_lex_state = 3},
  [1912] = {.lex_state = 67, .external_lex_state = 3},
  [1913] = {.lex_state = 67, .external_lex_state = 3},
  [1914] = {.lex_state = 67, .external_lex_state = 3},
  [1915] = {.lex_state = 67, .external_lex_state = 3},
  [1916] = {.lex_state = 102, .external_lex_state = 18},
  [1917] = {.lex_state = 208, .external_lex_state = 3},
  [1918] = {.lex_state = 208, .external_lex_state = 3},
  [1919] = {.lex_state = 208, .external_lex_state = 3},
  [1920] = {.lex_state = 208, .external_lex_state = 3},
  [1921] = {.lex_state = 208, .external_lex_state = 3},
  [1922] = {.lex_state = 208, .external_lex_state = 3},
  [1923] = {.lex_state = 208, .external_lex_state = 3},
  [1924] = {.lex_state = 208, .external_lex_state = 3},
  [1925] = {.lex_state = 208, .external_lex_state = 3},
  [1926] = {.lex_state = 208, .external_lex_state = 3},
  [1927] = {.lex_state = 208, .external_lex_state = 3},
  [1928] = {.lex_state = 208, .external_lex_state = 3},
  [1929] = {.lex_state = 66, .external_lex_state = 3},
  [1930] = {.lex_state = 67, .external_lex_state = 3},
  [1931] = {.lex_state = 67, .external_lex_state = 3},
  [1932] = {.lex_state = 67, .external_lex_state = 3},
  [1933] = {.lex_state = 67, .external_lex_state = 4},
  [1934] = {.lex_state = 223, .external_lex_state = 18},
  [1935] = {.lex_state = 67, .external_lex_state = 3},
  [1936] = {.lex_state = 67, .external_lex_state = 3},
  [1937] = {.lex_state = 67, .external_lex_state = 3},
  [1938] = {.lex_state = 67, .external_lex_state = 3},
  [1939] = {.lex_state = 67, .external_lex_state = 3},
  [1940] = {.lex_state = 67, .external_lex_state = 4},
  [1941] = {.lex_state = 67, .external_lex_state = 4},
  [1942] = {.lex_state = 67, .external_lex_state = 4},
  [1943] = {.lex_state = 66, .external_lex_state = 4},
  [1944] = {.lex_state = 67, .external_lex_state = 4},
  [1945] = {.lex_state = 67, .external_lex_state = 4},
  [1946] = {.lex_state = 67, .external_lex_state = 4},
  [1947] = {.lex_state = 67, .external_lex_state = 4},
  [1948] = {.lex_state = 67, .external_lex_state = 4},
  [1949] = {.lex_state = 67, .external_lex_state = 3},
  [1950] = {.lex_state = 67, .external_lex_state = 4},
  [1951] = {.lex_state = 67, .external_lex_state = 4},
  [1952] = {.lex_state = 67, .external_lex_state = 4},
  [1953] = {.lex_state = 67, .external_lex_state = 4},
  [1954] = {.lex_state = 67, .external_lex_state = 4},
  [1955] = {.lex_state = 67, .external_lex_state = 4},
  [1956] = {.lex_state = 67, .external_lex_state = 4},
  [1957] = {.lex_state = 102, .external_lex_state = 19},
  [1958] = {.lex_state = 67, .external_lex_state = 4},
  [1959] = {.lex_state = 102, .external_lex_state = 19},
  [1960] = {.lex_state = 102, .external_lex_state = 19},
  [1961] = {.lex_state = 84, .external_lex_state = 19},
  [1962] = {.lex_state = 70, .external_lex_state = 3},
  [1963] = {.lex_state = 70, .external_lex_state = 3},
  [1964] = {.lex_state = 70, .external_lex_state = 3},
  [1965] = {.lex_state = 84, .external_lex_state = 19},
  [1966] = {.lex_state = 70, .external_lex_state = 3},
  [1967] = {.lex_state = 70, .external_lex_state = 3},
  [1968] = {.lex_state = 70, .external_lex_state = 3},
  [1969] = {.lex_state = 84, .external_lex_state = 19},
  [1970] = {.lex_state = 102, .external_lex_state = 19},
  [1971] = {.lex_state = 70, .external_lex_state = 3},
  [1972] = {.lex_state = 70, .external_lex_state = 3},
  [1973] = {.lex_state = 84, .external_lex_state = 19},
  [1974] = {.lex_state = 84, .external_lex_state = 20},
  [1975] = {.lex_state = 84, .external_lex_state = 20},
  [1976] = {.lex_state = 84, .external_lex_state = 20},
  [1977] = {.lex_state = 210, .external_lex_state = 3},
  [1978] = {.lex_state = 84, .external_lex_state = 19},
  [1979] = {.lex_state = 84, .external_lex_state = 19},
  [1980] = {.lex_state = 84, .external_lex_state = 19},
  [1981] = {.lex_state = 210, .external_lex_state = 3},
  [1982] = {.lex_state = 84, .external_lex_state = 19},
  [1983] = {.lex_state = 210, .external_lex_state = 3},
  [1984] = {.lex_state = 210, .external_lex_state = 3},
  [1985] = {.lex_state = 210, .external_lex_state = 3},
  [1986] = {.lex_state = 210, .external_lex_state = 3},
  [1987] = {.lex_state = 210, .external_lex_state = 3},
  [1988] = {.lex_state = 210, .external_lex_state = 3},
  [1989] = {.lex_state = 70, .external_lex_state = 3},
  [1990] = {.lex_state = 70, .external_lex_state = 3},
  [1991] = {.lex_state = 70, .external_lex_state = 4},
  [1992] = {.lex_state = 70, .external_lex_state = 4},
  [1993] = {.lex_state = 70, .external_lex_state = 3},
  [1994] = {.lex_state = 70, .external_lex_state = 3},
  [1995] = {.lex_state = 70, .external_lex_state = 3},
  [1996] = {.lex_state = 70, .external_lex_state = 4},
  [1997] = {.lex_state = 70, .external_lex_state = 4},
  [1998] = {.lex_state = 70, .external_lex_state = 3},
  [1999] = {.lex_state = 70, .external_lex_state = 4},
  [2000] = {.lex_state = 70, .external_lex_state = 4},
  [2001] = {.lex_state = 70, .external_lex_state = 3},
  [2002] = {.lex_state = 70, .external_lex_state = 3},
  [2003] = {.lex_state = 70, .external_lex_state = 4},
  [2004] = {.lex_state = 70, .external_lex_state = 4},
  [2005] = {.lex_state = 70, .external_lex_state = 4},
  [2006] = {.lex_state = 70, .external_lex_state = 4},
  [2007] = {.lex_state = 70, .external_lex_state = 4},
  [2008] = {.lex_state = 70, .external_lex_state = 4},
  [2009] = {.lex_state = 70, .external_lex_state = 4},
  [2010] = {.lex_state = 70, .external_lex_state = 4},
  [2011] = {.lex_state = 101, .external_lex_state = 21},
  [2012] = {.lex_state = 101, .external_lex_state = 21},
  [2013] = {.lex_state = 101, .external_lex_state = 21},
  [2014] = {.lex_state = 115, .external_lex_state = 19},
  [2015] = {.lex_state = 115, .external_lex_state = 19},
  [2016] = {.lex_state = 115, .external_lex_state = 19},
  [2017] = {.lex_state = 115, .external_lex_state = 19},
  [2018] = {.lex_state = 115, .external_lex_state = 19},
  [2019] = {.lex_state = 115, .external_lex_state = 19},
  [2020] = {.lex_state = 115, .external_lex_state = 19},
  [2021] = {.lex_state = 115, .external_lex_state = 19},
  [2022] = {.lex_state = 115, .external_lex_state = 19},
  [2023] = {.lex_state = 115, .external_lex_state = 19},
  [2024] = {.lex_state = 115, .external_lex_state = 19},
  [2025] = {.lex_state = 115, .external_lex_state = 19},
  [2026] = {.lex_state = 115, .external_lex_state = 19},
  [2027] = {.lex_state = 115, .external_lex_state = 19},
  [2028] = {.lex_state = 115, .external_lex_state = 19},
  [2029] = {.lex_state = 231, .external_lex_state = 21},
  [2030] = {.lex_state = 231, .external_lex_state = 21},
  [2031] = {.lex_state = 84, .external_lex_state = 9},
  [2032] = {.lex_state = 231, .external_lex_state = 21},
  [2033] = {.lex_state = 84, .external_lex_state = 9},
  [2034] = {.lex_state = 84, .external_lex_state = 9},
  [2035] = {.lex_state = 84, .external_lex_state = 9},
  [2036] = {.lex_state = 84, .external_lex_state = 9},
  [2037] = {.lex_state = 84, .external_lex_state = 9},
  [2038] = {.lex_state = 101, .external_lex_state = 21},
  [2039] = {.lex_state = 81, .external_lex_state = 6},
  [2040] = {.lex_state = 216, .external_lex_state = 22},
  [2041] = {.lex_state = 101, .external_lex_state = 23},
  [2042] = {.lex_state = 216, .external_lex_state = 22},
  [2043] = {.lex_state = 85, .external_lex_state = 2},
  [2044] = {.lex_state = 216, .external_lex_state = 22},
  [2045] = {.lex_state = 216, .external_lex_state = 22},
  [2046] = {.lex_state = 101, .external_lex_state = 23},
  [2047] = {.lex_state = 101, .external_lex_state = 21},
  [2048] = {.lex_state = 216, .external_lex_state = 22},
  [2049] = {.lex_state = 101, .external_lex_state = 21},
  [2050] = {.lex_state = 83, .external_lex_state = 6},
  [2051] = {.lex_state = 215, .external_lex_state = 9},
  [2052] = {.lex_state = 215, .external_lex_state = 9},
  [2053] = {.lex_state = 215, .external_lex_state = 9},
  [2054] = {.lex_state = 216, .external_lex_state = 22},
  [2055] = {.lex_state = 85, .external_lex_state = 2},
  [2056] = {.lex_state = 216, .external_lex_state = 22},
  [2057] = {.lex_state = 215, .external_lex_state = 9},
  [2058] = {.lex_state = 215, .external_lex_state = 9},
  [2059] = {.lex_state = 85, .external_lex_state = 2},
  [2060] = {.lex_state = 215, .external_lex_state = 9},
  [2061] = {.lex_state = 216, .external_lex_state = 22},
  [2062] = {.lex_state = 85, .external_lex_state = 2},
  [2063] = {.lex_state = 216, .external_lex_state = 22},
  [2064] = {.lex_state = 216, .external_lex_state = 22},
  [2065] = {.lex_state = 101, .external_lex_state = 23},
  [2066] = {.lex_state = 216, .external_lex_state = 22},
  [2067] = {.lex_state = 101, .external_lex_state = 23},
  [2068] = {.lex_state = 216, .external_lex_state = 22},
  [2069] = {.lex_state = 216, .external_lex_state = 22},
  [2070] = {.lex_state = 216, .external_lex_state = 22},
  [2071] = {.lex_state = 88, .external_lex_state = 22},
  [2072] = {.lex_state = 216, .external_lex_state = 22},
  [2073] = {.lex_state = 101, .external_lex_state = 23},
  [2074] = {.lex_state = 216, .external_lex_state = 22},
  [2075] = {.lex_state = 101, .external_lex_state = 23},
  [2076] = {.lex_state = 216, .external_lex_state = 22},
  [2077] = {.lex_state = 216, .external_lex_state = 22},
  [2078] = {.lex_state = 216, .external_lex_state = 22},
  [2079] = {.lex_state = 216, .external_lex_state = 22},
  [2080] = {.lex_state = 216, .external_lex_state = 22},
  [2081] = {.lex_state = 216, .external_lex_state = 22},
  [2082] = {.lex_state = 216, .external_lex_state = 22},
  [2083] = {.lex_state = 216, .external_lex_state = 22},
  [2084] = {.lex_state = 216, .external_lex_state = 22},
  [2085] = {.lex_state = 216, .external_lex_state = 22},
  [2086] = {.lex_state = 216, .external_lex_state = 22},
  [2087] = {.lex_state = 216, .external_lex_state = 22},
  [2088] = {.lex_state = 216, .external_lex_state = 22},
  [2089] = {.lex_state = 216, .external_lex_state = 22},
  [2090] = {.lex_state = 101, .external_lex_state = 23},
  [2091] = {.lex_state = 216, .external_lex_state = 22},
  [2092] = {.lex_state = 216, .external_lex_state = 22},
  [2093] = {.lex_state = 216, .external_lex_state = 22},
  [2094] = {.lex_state = 216, .external_lex_state = 22},
  [2095] = {.lex_state = 216, .external_lex_state = 22},
  [2096] = {.lex_state = 216, .external_lex_state = 22},
  [2097] = {.lex_state = 216, .external_lex_state = 22},
  [2098] = {.lex_state = 101, .external_lex_state = 23},
  [2099] = {.lex_state = 216, .external_lex_state = 22},
  [2100] = {.lex_state = 216, .external_lex_state = 22},
  [2101] = {.lex_state = 216, .external_lex_state = 22},
  [2102] = {.lex_state = 216, .external_lex_state = 22},
  [2103] = {.lex_state = 216, .external_lex_state = 22},
  [2104] = {.lex_state = 86, .external_lex_state = 7},
  [2105] = {.lex_state = 84, .external_lex_state = 5},
  [2106] = {.lex_state = 84, .external_lex_state = 5},
  [2107] = {.lex_state = 84, .external_lex_state = 5},
  [2108] = {.lex_state = 89, .external_lex_state = 22},
  [2109] = {.lex_state = 84, .external_lex_state = 5},
  [2110] = {.lex_state = 86, .external_lex_state = 7},
  [2111] = {.lex_state = 84, .external_lex_state = 5},
  [2112] = {.lex_state = 86, .external_lex_state = 7},
  [2113] = {.lex_state = 84, .external_lex_state = 5},
  [2114] = {.lex_state = 88, .external_lex_state = 22},
  [2115] = {.lex_state = 85, .external_lex_state = 7},
  [2116] = {.lex_state = 85, .external_lex_state = 7},
  [2117] = {.lex_state = 88, .external_lex_state = 22},
  [2118] = {.lex_state = 88, .external_lex_state = 22},
  [2119] = {.lex_state = 85, .external_lex_state = 7},
  [2120] = {.lex_state = 85, .external_lex_state = 7},
  [2121] = {.lex_state = 85, .external_lex_state = 7},
  [2122] = {.lex_state = 85, .external_lex_state = 7},
  [2123] = {.lex_state = 85, .external_lex_state = 7},
  [2124] = {.lex_state = 85, .external_lex_state = 7},
  [2125] = {.lex_state = 85, .external_lex_state = 7},
  [2126] = {.lex_state = 85, .external_lex_state = 7},
  [2127] = {.lex_state = 85, .external_lex_state = 7},
  [2128] = {.lex_state = 85, .external_lex_state = 2},
  [2129] = {.lex_state = 85, .external_lex_state = 7},
  [2130] = {.lex_state = 88, .external_lex_state = 22},
  [2131] = {.lex_state = 214, .external_lex_state = 2},
  [2132] = {.lex_state = 214, .external_lex_state = 2},
  [2133] = {.lex_state = 88, .external_lex_state = 22},
  [2134] = {.lex_state = 101, .external_lex_state = 23},
  [2135] = {.lex_state = 88, .external_lex_state = 22},
  [2136] = {.lex_state = 101, .external_lex_state = 23},
  [2137] = {.lex_state = 88, .external_lex_state = 22},
  [2138] = {.lex_state = 88, .external_lex_state = 22},
  [2139] = {.lex_state = 101, .external_lex_state = 23},
  [2140] = {.lex_state = 88, .external_lex_state = 22},
  [2141] = {.lex_state = 101, .external_lex_state = 23},
  [2142] = {.lex_state = 214, .external_lex_state = 2},
  [2143] = {.lex_state = 88, .external_lex_state = 22},
  [2144] = {.lex_state = 101, .external_lex_state = 23},
  [2145] = {.lex_state = 214, .external_lex_state = 2},
  [2146] = {.lex_state = 216, .external_lex_state = 22},
  [2147] = {.lex_state = 85, .external_lex_state = 2},
  [2148] = {.lex_state = 101, .external_lex_state = 23},
  [2149] = {.lex_state = 85, .external_lex_state = 2},
  [2150] = {.lex_state = 85, .external_lex_state = 2},
  [2151] = {.lex_state = 85, .external_lex_state = 2},
  [2152] = {.lex_state = 85, .external_lex_state = 2},
  [2153] = {.lex_state = 85, .external_lex_state = 2},
  [2154] = {.lex_state = 85, .external_lex_state = 2},
  [2155] = {.lex_state = 85, .external_lex_state = 2},
  [2156] = {.lex_state = 85, .external_lex_state = 2},
  [2157] = {.lex_state = 85, .external_lex_state = 2},
  [2158] = {.lex_state = 101, .external_lex_state = 23},
  [2159] = {.lex_state = 85, .external_lex_state = 2},
  [2160] = {.lex_state = 101, .external_lex_state = 23},
  [2161] = {.lex_state = 101, .external_lex_state = 23},
  [2162] = {.lex_state = 101, .external_lex_state = 23},
  [2163] = {.lex_state = 85, .external_lex_state = 2},
  [2164] = {.lex_state = 101, .external_lex_state = 23},
  [2165] = {.lex_state = 101, .external_lex_state = 23},
  [2166] = {.lex_state = 101, .external_lex_state = 21},
  [2167] = {.lex_state = 216, .external_lex_state = 22},
  [2168] = {.lex_state = 217, .external_lex_state = 22},
  [2169] = {.lex_state = 88, .external_lex_state = 22},
  [2170] = {.lex_state = 216, .external_lex_state = 22},
  [2171] = {.lex_state = 216, .external_lex_state = 22},
  [2172] = {.lex_state = 90, .external_lex_state = 24},
  [2173] = {.lex_state = 90, .external_lex_state = 24},
  [2174] = {.lex_state = 89, .external_lex_state = 22},
  [2175] = {.lex_state = 216, .external_lex_state = 22},
  [2176] = {.lex_state = 216, .external_lex_state = 22},
  [2177] = {.lex_state = 88, .external_lex_state = 22},
  [2178] = {.lex_state = 216, .external_lex_state = 22},
  [2179] = {.lex_state = 216, .external_lex_state = 22},
  [2180] = {.lex_state = 88, .external_lex_state = 22},
  [2181] = {.lex_state = 88, .external_lex_state = 22},
  [2182] = {.lex_state = 88, .external_lex_state = 22},
  [2183] = {.lex_state = 216, .external_lex_state = 22},
  [2184] = {.lex_state = 216, .external_lex_state = 22},
  [2185] = {.lex_state = 216, .external_lex_state = 22},
  [2186] = {.lex_state = 88, .external_lex_state = 22},
  [2187] = {.lex_state = 88, .external_lex_state = 22},
  [2188] = {.lex_state = 101, .external_lex_state = 23},
  [2189] = {.lex_state = 220, .external_lex_state = 22},
  [2190] = {.lex_state = 101, .external_lex_state = 23},
  [2191] = {.lex_state = 101, .external_lex_state = 23},
  [2192] = {.lex_state = 90, .external_lex_state = 24},
  [2193] = {.lex_state = 220, .external_lex_state = 22},
  [2194] = {.lex_state = 90, .external_lex_state = 24},
  [2195] = {.lex_state = 101, .external_lex_state = 23},
  [2196] = {.lex_state = 101, .external_lex_state = 23},
  [2197] = {.lex_state = 88, .external_lex_state = 22},
  [2198] = {.lex_state = 220, .external_lex_state = 25},
  [2199] = {.lex_state = 90, .external_lex_state = 24},
  [2200] = {.lex_state = 90, .external_lex_state = 24},
  [2201] = {.lex_state = 88, .external_lex_state = 22},
  [2202] = {.lex_state = 90, .external_lex_state = 24},
  [2203] = {.lex_state = 220, .external_lex_state = 25},
  [2204] = {.lex_state = 220, .external_lex_state = 25},
  [2205] = {.lex_state = 88, .external_lex_state = 22},
  [2206] = {.lex_state = 90, .external_lex_state = 24},
  [2207] = {.lex_state = 220, .external_lex_state = 25},
  [2208] = {.lex_state = 88, .external_lex_state = 24},
  [2209] = {.lex_state = 90, .external_lex_state = 24},
  [2210] = {.lex_state = 88, .external_lex_state = 24},
  [2211] = {.lex_state = 88, .external_lex_state = 22},
  [2212] = {.lex_state = 88, .external_lex_state = 22},
  [2213] = {.lex_state = 88, .external_lex_state = 22},
  [2214] = {.lex_state = 90, .external_lex_state = 24},
  [2215] = {.lex_state = 88, .external_lex_state = 22},
  [2216] = {.lex_state = 90, .external_lex_state = 24},
  [2217] = {.lex_state = 90, .external_lex_state = 24},
  [2218] = {.lex_state = 220, .external_lex_state = 22},
  [2219] = {.lex_state = 90, .external_lex_state = 24},
  [2220] = {.lex_state = 88, .external_lex_state = 22},
  [2221] = {.lex_state = 220, .external_lex_state = 22},
  [2222] = {.lex_state = 220, .external_lex_state = 22},
  [2223] = {.lex_state = 220, .external_lex_state = 22},
  [2224] = {.lex_state = 220, .external_lex_state = 22},
  [2225] = {.lex_state = 88, .external_lex_state = 22},
  [2226] = {.lex_state = 220, .external_lex_state = 25},
  [2227] = {.lex_state = 90, .external_lex_state = 24},
  [2228] = {.lex_state = 90, .external_lex_state = 24},
  [2229] = {.lex_state = 88, .external_lex_state = 22},
  [2230] = {.lex_state = 90, .external_lex_state = 24},
  [2231] = {.lex_state = 220, .external_lex_state = 22},
  [2232] = {.lex_state = 90, .external_lex_state = 24},
  [2233] = {.lex_state = 90, .external_lex_state = 24},
  [2234] = {.lex_state = 90, .external_lex_state = 24},
  [2235] = {.lex_state = 220, .external_lex_state = 22},
  [2236] = {.lex_state = 90, .external_lex_state = 24},
  [2237] = {.lex_state = 90, .external_lex_state = 24},
  [2238] = {.lex_state = 90, .external_lex_state = 24},
  [2239] = {.lex_state = 220, .external_lex_state = 22},
  [2240] = {.lex_state = 220, .external_lex_state = 25},
  [2241] = {.lex_state = 220, .external_lex_state = 22},
  [2242] = {.lex_state = 220, .external_lex_state = 22},
  [2243] = {.lex_state = 90, .external_lex_state = 24},
  [2244] = {.lex_state = 90, .external_lex_state = 24},
  [2245] = {.lex_state = 90, .external_lex_state = 24},
  [2246] = {.lex_state = 220, .external_lex_state = 22},
  [2247] = {.lex_state = 220, .external_lex_state = 22},
  [2248] = {.lex_state = 90, .external_lex_state = 24},
  [2249] = {.lex_state = 90, .external_lex_state = 24},
  [2250] = {.lex_state = 88, .external_lex_state = 24},
  [2251] = {.lex_state = 90, .external_lex_state = 24},
  [2252] = {.lex_state = 90, .external_lex_state = 24},
  [2253] = {.lex_state = 220, .external_lex_state = 22},
  [2254] = {.lex_state = 90, .external_lex_state = 24},
  [2255] = {.lex_state = 90, .external_lex_state = 24},
  [2256] = {.lex_state = 220, .external_lex_state = 22},
  [2257] = {.lex_state = 90, .external_lex_state = 24},
  [2258] = {.lex_state = 90, .external_lex_state = 24},
  [2259] = {.lex_state = 220, .external_lex_state = 22},
  [2260] = {.lex_state = 88, .external_lex_state = 24},
  [2261] = {.lex_state = 90, .external_lex_state = 24},
  [2262] = {.lex_state = 88, .external_lex_state = 22},
  [2263] = {.lex_state = 88, .external_lex_state = 22},
  [2264] = {.lex_state = 94, .external_lex_state = 25},
  [2265] = {.lex_state = 220, .external_lex_state = 22},
  [2266] = {.lex_state = 88, .external_lex_state = 24},
  [2267] = {.lex_state = 220, .external_lex_state = 25},
  [2268] = {.lex_state = 220, .external_lex_state = 22},
  [2269] = {.lex_state = 94, .external_lex_state = 25},
  [2270] = {.lex_state = 231, .external_lex_state = 21},
  [2271] = {.lex_state = 88, .external_lex_state = 24},
  [2272] = {.lex_state = 88, .external_lex_state = 24},
  [2273] = {.lex_state = 220, .external_lex_state = 22},
  [2274] = {.lex_state = 220, .external_lex_state = 22},
  [2275] = {.lex_state = 220, .external_lex_state = 22},
  [2276] = {.lex_state = 220, .external_lex_state = 22},
  [2277] = {.lex_state = 220, .external_lex_state = 22},
  [2278] = {.lex_state = 220, .external_lex_state = 22},
  [2279] = {.lex_state = 88, .external_lex_state = 22},
  [2280] = {.lex_state = 220, .external_lex_state = 22},
  [2281] = {.lex_state = 220, .external_lex_state = 22},
  [2282] = {.lex_state = 88, .external_lex_state = 24},
  [2283] = {.lex_state = 220, .external_lex_state = 22},
  [2284] = {.lex_state = 220, .external_lex_state = 22},
  [2285] = {.lex_state = 220, .external_lex_state = 22},
  [2286] = {.lex_state = 220, .external_lex_state = 22},
  [2287] = {.lex_state = 220, .external_lex_state = 22},
  [2288] = {.lex_state = 220, .external_lex_state = 22},
  [2289] = {.lex_state = 220, .external_lex_state = 22},
  [2290] = {.lex_state = 220, .external_lex_state = 22},
  [2291] = {.lex_state = 220, .external_lex_state = 22},
  [2292] = {.lex_state = 88, .external_lex_state = 22},
  [2293] = {.lex_state = 220, .external_lex_state = 22},
  [2294] = {.lex_state = 220, .external_lex_state = 22},
  [2295] = {.lex_state = 220, .external_lex_state = 22},
  [2296] = {.lex_state = 220, .external_lex_state = 22},
  [2297] = {.lex_state = 220, .external_lex_state = 22},
  [2298] = {.lex_state = 220, .external_lex_state = 22},
  [2299] = {.lex_state = 220, .external_lex_state = 22},
  [2300] = {.lex_state = 220, .external_lex_state = 22},
  [2301] = {.lex_state = 220, .external_lex_state = 22},
  [2302] = {.lex_state = 88, .external_lex_state = 24},
  [2303] = {.lex_state = 220, .external_lex_state = 22},
  [2304] = {.lex_state = 220, .external_lex_state = 22},
  [2305] = {.lex_state = 220, .external_lex_state = 22},
  [2306] = {.lex_state = 220, .external_lex_state = 22},
  [2307] = {.lex_state = 220, .external_lex_state = 22},
  [2308] = {.lex_state = 220, .external_lex_state = 22},
  [2309] = {.lex_state = 220, .external_lex_state = 22},
  [2310] = {.lex_state = 88, .external_lex_state = 22},
  [2311] = {.lex_state = 220, .external_lex_state = 22},
  [2312] = {.lex_state = 220, .external_lex_state = 22},
  [2313] = {.lex_state = 220, .external_lex_state = 22},
  [2314] = {.lex_state = 220, .external_lex_state = 22},
  [2315] = {.lex_state = 220, .external_lex_state = 22},
  [2316] = {.lex_state = 220, .external_lex_state = 22},
  [2317] = {.lex_state = 220, .external_lex_state = 22},
  [2318] = {.lex_state = 220, .external_lex_state = 22},
  [2319] = {.lex_state = 220, .external_lex_state = 22},
  [2320] = {.lex_state = 220, .external_lex_state = 22},
  [2321] = {.lex_state = 89, .external_lex_state = 22},
  [2322] = {.lex_state = 220, .external_lex_state = 22},
  [2323] = {.lex_state = 220, .external_lex_state = 22},
  [2324] = {.lex_state = 220, .external_lex_state = 22},
  [2325] = {.lex_state = 220, .external_lex_state = 22},
  [2326] = {.lex_state = 220, .external_lex_state = 22},
  [2327] = {.lex_state = 220, .external_lex_state = 22},
  [2328] = {.lex_state = 220, .external_lex_state = 22},
  [2329] = {.lex_state = 220, .external_lex_state = 22},
  [2330] = {.lex_state = 220, .external_lex_state = 22},
  [2331] = {.lex_state = 220, .external_lex_state = 22},
  [2332] = {.lex_state = 220, .external_lex_state = 22},
  [2333] = {.lex_state = 220, .external_lex_state = 22},
  [2334] = {.lex_state = 220, .external_lex_state = 22},
  [2335] = {.lex_state = 220, .external_lex_state = 22},
  [2336] = {.lex_state = 220, .external_lex_state = 22},
  [2337] = {.lex_state = 220, .external_lex_state = 22},
  [2338] = {.lex_state = 220, .external_lex_state = 22},
  [2339] = {.lex_state = 220, .external_lex_state = 22},
  [2340] = {.lex_state = 220, .external_lex_state = 22},
  [2341] = {.lex_state = 220, .external_lex_state = 22},
  [2342] = {.lex_state = 220, .external_lex_state = 22},
  [2343] = {.lex_state = 220, .external_lex_state = 22},
  [2344] = {.lex_state = 220, .external_lex_state = 22},
  [2345] = {.lex_state = 220, .external_lex_state = 22},
  [2346] = {.lex_state = 220, .external_lex_state = 22},
  [2347] = {.lex_state = 220, .external_lex_state = 22},
  [2348] = {.lex_state = 220, .external_lex_state = 22},
  [2349] = {.lex_state = 220, .external_lex_state = 22},
  [2350] = {.lex_state = 220, .external_lex_state = 22},
  [2351] = {.lex_state = 220, .external_lex_state = 22},
  [2352] = {.lex_state = 220, .external_lex_state = 22},
  [2353] = {.lex_state = 220, .external_lex_state = 22},
  [2354] = {.lex_state = 220, .external_lex_state = 22},
  [2355] = {.lex_state = 220, .external_lex_state = 22},
  [2356] = {.lex_state = 88, .external_lex_state = 24},
  [2357] = {.lex_state = 220, .external_lex_state = 22},
  [2358] = {.lex_state = 220, .external_lex_state = 22},
  [2359] = {.lex_state = 220, .external_lex_state = 22},
  [2360] = {.lex_state = 220, .external_lex_state = 22},
  [2361] = {.lex_state = 220, .external_lex_state = 22},
  [2362] = {.lex_state = 220, .external_lex_state = 22},
  [2363] = {.lex_state = 220, .external_lex_state = 22},
  [2364] = {.lex_state = 220, .external_lex_state = 22},
  [2365] = {.lex_state = 220, .external_lex_state = 22},
  [2366] = {.lex_state = 220, .external_lex_state = 22},
  [2367] = {.lex_state = 220, .external_lex_state = 22},
  [2368] = {.lex_state = 220, .external_lex_state = 22},
  [2369] = {.lex_state = 220, .external_lex_state = 22},
  [2370] = {.lex_state = 220, .external_lex_state = 22},
  [2371] = {.lex_state = 220, .external_lex_state = 22},
  [2372] = {.lex_state = 220, .external_lex_state = 22},
  [2373] = {.lex_state = 220, .external_lex_state = 22},
  [2374] = {.lex_state = 220, .external_lex_state = 22},
  [2375] = {.lex_state = 220, .external_lex_state = 22},
  [2376] = {.lex_state = 220, .external_lex_state = 22},
  [2377] = {.lex_state = 220, .external_lex_state = 22},
  [2378] = {.lex_state = 220, .external_lex_state = 22},
  [2379] = {.lex_state = 220, .external_lex_state = 22},
  [2380] = {.lex_state = 220, .external_lex_state = 22},
  [2381] = {.lex_state = 220, .external_lex_state = 22},
  [2382] = {.lex_state = 220, .external_lex_state = 22},
  [2383] = {.lex_state = 220, .external_lex_state = 22},
  [2384] = {.lex_state = 220, .external_lex_state = 22},
  [2385] = {.lex_state = 220, .external_lex_state = 22},
  [2386] = {.lex_state = 220, .external_lex_state = 22},
  [2387] = {.lex_state = 220, .external_lex_state = 22},
  [2388] = {.lex_state = 88, .external_lex_state = 24},
  [2389] = {.lex_state = 220, .external_lex_state = 22},
  [2390] = {.lex_state = 220, .external_lex_state = 22},
  [2391] = {.lex_state = 220, .external_lex_state = 22},
  [2392] = {.lex_state = 220, .external_lex_state = 22},
  [2393] = {.lex_state = 220, .external_lex_state = 22},
  [2394] = {.lex_state = 220, .external_lex_state = 22},
  [2395] = {.lex_state = 220, .external_lex_state = 22},
  [2396] = {.lex_state = 220, .external_lex_state = 22},
  [2397] = {.lex_state = 220, .external_lex_state = 22},
  [2398] = {.lex_state = 220, .external_lex_state = 22},
  [2399] = {.lex_state = 220, .external_lex_state = 22},
  [2400] = {.lex_state = 89, .external_lex_state = 24},
  [2401] = {.lex_state = 220, .external_lex_state = 22},
  [2402] = {.lex_state = 220, .external_lex_state = 22},
  [2403] = {.lex_state = 220, .external_lex_state = 22},
  [2404] = {.lex_state = 220, .external_lex_state = 22},
  [2405] = {.lex_state = 220, .external_lex_state = 22},
  [2406] = {.lex_state = 220, .external_lex_state = 22},
  [2407] = {.lex_state = 220, .external_lex_state = 22},
  [2408] = {.lex_state = 220, .external_lex_state = 22},
  [2409] = {.lex_state = 220, .external_lex_state = 22},
  [2410] = {.lex_state = 88, .external_lex_state = 24},
  [2411] = {.lex_state = 220, .external_lex_state = 22},
  [2412] = {.lex_state = 220, .external_lex_state = 22},
  [2413] = {.lex_state = 220, .external_lex_state = 22},
  [2414] = {.lex_state = 220, .external_lex_state = 22},
  [2415] = {.lex_state = 220, .external_lex_state = 22},
  [2416] = {.lex_state = 220, .external_lex_state = 22},
  [2417] = {.lex_state = 88, .external_lex_state = 24},
  [2418] = {.lex_state = 220, .external_lex_state = 22},
  [2419] = {.lex_state = 220, .external_lex_state = 22},
  [2420] = {.lex_state = 220, .external_lex_state = 22},
  [2421] = {.lex_state = 220, .external_lex_state = 22},
  [2422] = {.lex_state = 220, .external_lex_state = 22},
  [2423] = {.lex_state = 220, .external_lex_state = 22},
  [2424] = {.lex_state = 220, .external_lex_state = 22},
  [2425] = {.lex_state = 220, .external_lex_state = 22},
  [2426] = {.lex_state = 220, .external_lex_state = 22},
  [2427] = {.lex_state = 220, .external_lex_state = 22},
  [2428] = {.lex_state = 220, .external_lex_state = 22},
  [2429] = {.lex_state = 220, .external_lex_state = 22},
  [2430] = {.lex_state = 220, .external_lex_state = 22},
  [2431] = {.lex_state = 220, .external_lex_state = 22},
  [2432] = {.lex_state = 220, .external_lex_state = 22},
  [2433] = {.lex_state = 220, .external_lex_state = 22},
  [2434] = {.lex_state = 220, .external_lex_state = 22},
  [2435] = {.lex_state = 220, .external_lex_state = 22},
  [2436] = {.lex_state = 88, .external_lex_state = 24},
  [2437] = {.lex_state = 220, .external_lex_state = 22},
  [2438] = {.lex_state = 75, .external_lex_state = 26},
  [2439] = {.lex_state = 75, .external_lex_state = 26},
  [2440] = {.lex_state = 88, .external_lex_state = 24},
  [2441] = {.lex_state = 89, .external_lex_state = 24},
  [2442] = {.lex_state = 75, .external_lex_state = 26},
  [2443] = {.lex_state = 88, .external_lex_state = 24},
  [2444] = {.lex_state = 88, .external_lex_state = 24},
  [2445] = {.lex_state = 88, .external_lex_state = 22},
  [2446] = {.lex_state = 88, .external_lex_state = 22},
  [2447] = {.lex_state = 75, .external_lex_state = 26},
  [2448] = {.lex_state = 88, .external_lex_state = 24},
  [2449] = {.lex_state = 75, .external_lex_state = 26},
  [2450] = {.lex_state = 94, .external_lex_state = 25},
  [2451] = {.lex_state = 88, .external_lex_state = 24},
  [2452] = {.lex_state = 75, .external_lex_state = 26},
  [2453] = {.lex_state = 75, .external_lex_state = 26},
  [2454] = {.lex_state = 75, .external_lex_state = 26},
  [2455] = {.lex_state = 75, .external_lex_state = 26},
  [2456] = {.lex_state = 75, .external_lex_state = 26},
  [2457] = {.lex_state = 75, .external_lex_state = 26},
  [2458] = {.lex_state = 88, .external_lex_state = 24},
  [2459] = {.lex_state = 75, .external_lex_state = 26},
  [2460] = {.lex_state = 88, .external_lex_state = 24},
  [2461] = {.lex_state = 75, .external_lex_state = 26},
  [2462] = {.lex_state = 75, .external_lex_state = 26},
  [2463] = {.lex_state = 88, .external_lex_state = 22},
  [2464] = {.lex_state = 75, .external_lex_state = 26},
  [2465] = {.lex_state = 75, .external_lex_state = 26},
  [2466] = {.lex_state = 75, .external_lex_state = 26},
  [2467] = {.lex_state = 75, .external_lex_state = 26},
  [2468] = {.lex_state = 75, .external_lex_state = 26},
  [2469] = {.lex_state = 75, .external_lex_state = 26},
  [2470] = {.lex_state = 75, .external_lex_state = 26},
  [2471] = {.lex_state = 75, .external_lex_state = 26},
  [2472] = {.lex_state = 75, .external_lex_state = 26},
  [2473] = {.lex_state = 75, .external_lex_state = 26},
  [2474] = {.lex_state = 88, .external_lex_state = 24},
  [2475] = {.lex_state = 88, .external_lex_state = 24},
  [2476] = {.lex_state = 220, .external_lex_state = 22},
  [2477] = {.lex_state = 88, .external_lex_state = 22},
  [2478] = {.lex_state = 94, .external_lex_state = 22},
  [2479] = {.lex_state = 88, .external_lex_state = 22},
  [2480] = {.lex_state = 88, .external_lex_state = 24},
  [2481] = {.lex_state = 88, .external_lex_state = 22},
  [2482] = {.lex_state = 94, .external_lex_state = 22},
  [2483] = {.lex_state = 88, .external_lex_state = 22},
  [2484] = {.lex_state = 88, .external_lex_state = 22},
  [2485] = {.lex_state = 88, .external_lex_state = 22},
  [2486] = {.lex_state = 94, .external_lex_state = 22},
  [2487] = {.lex_state = 94, .external_lex_state = 22},
  [2488] = {.lex_state = 94, .external_lex_state = 22},
  [2489] = {.lex_state = 94, .external_lex_state = 22},
  [2490] = {.lex_state = 94, .external_lex_state = 22},
  [2491] = {.lex_state = 88, .external_lex_state = 24},
  [2492] = {.lex_state = 88, .external_lex_state = 24},
  [2493] = {.lex_state = 88, .external_lex_state = 24},
  [2494] = {.lex_state = 88, .external_lex_state = 24},
  [2495] = {.lex_state = 94, .external_lex_state = 22},
  [2496] = {.lex_state = 94, .external_lex_state = 22},
  [2497] = {.lex_state = 94, .external_lex_state = 22},
  [2498] = {.lex_state = 94, .external_lex_state = 22},
  [2499] = {.lex_state = 94, .external_lex_state = 22},
  [2500] = {.lex_state = 94, .external_lex_state = 22},
  [2501] = {.lex_state = 94, .external_lex_state = 22},
  [2502] = {.lex_state = 94, .external_lex_state = 22},
  [2503] = {.lex_state = 94, .external_lex_state = 22},
  [2504] = {.lex_state = 94, .external_lex_state = 22},
  [2505] = {.lex_state = 94, .external_lex_state = 22},
  [2506] = {.lex_state = 89, .external_lex_state = 24},
  [2507] = {.lex_state = 94, .external_lex_state = 22},
  [2508] = {.lex_state = 94, .external_lex_state = 22},
  [2509] = {.lex_state = 94, .external_lex_state = 22},
  [2510] = {.lex_state = 94, .external_lex_state = 22},
  [2511] = {.lex_state = 94, .external_lex_state = 22},
  [2512] = {.lex_state = 94, .external_lex_state = 22},
  [2513] = {.lex_state = 94, .external_lex_state = 22},
  [2514] = {.lex_state = 94, .external_lex_state = 22},
  [2515] = {.lex_state = 94, .external_lex_state = 22},
  [2516] = {.lex_state = 88, .external_lex_state = 24},
  [2517] = {.lex_state = 88, .external_lex_state = 24},
  [2518] = {.lex_state = 94, .external_lex_state = 22},
  [2519] = {.lex_state = 94, .external_lex_state = 22},
  [2520] = {.lex_state = 94, .external_lex_state = 22},
  [2521] = {.lex_state = 89, .external_lex_state = 24},
  [2522] = {.lex_state = 94, .external_lex_state = 22},
  [2523] = {.lex_state = 94, .external_lex_state = 22},
  [2524] = {.lex_state = 88, .external_lex_state = 22},
  [2525] = {.lex_state = 94, .external_lex_state = 22},
  [2526] = {.lex_state = 101, .external_lex_state = 21},
  [2527] = {.lex_state = 94, .external_lex_state = 22},
  [2528] = {.lex_state = 220, .external_lex_state = 25},
  [2529] = {.lex_state = 88, .external_lex_state = 24},
  [2530] = {.lex_state = 222, .external_lex_state = 27},
  [2531] = {.lex_state = 88, .external_lex_state = 22},
  [2532] = {.lex_state = 222, .external_lex_state = 27},
  [2533] = {.lex_state = 94, .external_lex_state = 22},
  [2534] = {.lex_state = 88, .external_lex_state = 22},
  [2535] = {.lex_state = 88, .external_lex_state = 22},
  [2536] = {.lex_state = 94, .external_lex_state = 22},
  [2537] = {.lex_state = 222, .external_lex_state = 27},
  [2538] = {.lex_state = 94, .external_lex_state = 22},
  [2539] = {.lex_state = 88, .external_lex_state = 24},
  [2540] = {.lex_state = 222, .external_lex_state = 27},
  [2541] = {.lex_state = 222, .external_lex_state = 27},
  [2542] = {.lex_state = 222, .external_lex_state = 27},
  [2543] = {.lex_state = 222, .external_lex_state = 27},
  [2544] = {.lex_state = 88, .external_lex_state = 24},
  [2545] = {.lex_state = 94, .external_lex_state = 22},
  [2546] = {.lex_state = 75, .external_lex_state = 26},
  [2547] = {.lex_state = 75, .external_lex_state = 26},
  [2548] = {.lex_state = 75, .external_lex_state = 26},
  [2549] = {.lex_state = 75, .external_lex_state = 26},
  [2550] = {.lex_state = 75, .external_lex_state = 26},
  [2551] = {.lex_state = 75, .external_lex_state = 26},
  [2552] = {.lex_state = 75, .external_lex_state = 26},
  [2553] = {.lex_state = 75, .external_lex_state = 26},
  [2554] = {.lex_state = 75, .external_lex_state = 26},
  [2555] = {.lex_state = 94, .external_lex_state = 22},
  [2556] = {.lex_state = 94, .external_lex_state = 22},
  [2557] = {.lex_state = 94, .external_lex_state = 22},
  [2558] = {.lex_state = 94, .external_lex_state = 22},
  [2559] = {.lex_state = 94, .external_lex_state = 22},
  [2560] = {.lex_state = 75, .external_lex_state = 26},
  [2561] = {.lex_state = 75, .external_lex_state = 26},
  [2562] = {.lex_state = 75, .external_lex_state = 26},
  [2563] = {.lex_state = 94, .external_lex_state = 22},
  [2564] = {.lex_state = 94, .external_lex_state = 22},
  [2565] = {.lex_state = 75, .external_lex_state = 26},
  [2566] = {.lex_state = 75, .external_lex_state = 26},
  [2567] = {.lex_state = 75, .external_lex_state = 26},
  [2568] = {.lex_state = 94, .external_lex_state = 22},
  [2569] = {.lex_state = 75, .external_lex_state = 26},
  [2570] = {.lex_state = 75, .external_lex_state = 26},
  [2571] = {.lex_state = 75, .external_lex_state = 26},
  [2572] = {.lex_state = 75, .external_lex_state = 26},
  [2573] = {.lex_state = 90, .external_lex_state = 24},
  [2574] = {.lex_state = 90, .external_lex_state = 24},
  [2575] = {.lex_state = 94, .external_lex_state = 22},
  [2576] = {.lex_state = 94, .external_lex_state = 22},
  [2577] = {.lex_state = 94, .external_lex_state = 22},
  [2578] = {.lex_state = 75, .external_lex_state = 26},
  [2579] = {.lex_state = 75, .external_lex_state = 26},
  [2580] = {.lex_state = 94, .external_lex_state = 22},
  [2581] = {.lex_state = 94, .external_lex_state = 22},
  [2582] = {.lex_state = 94, .external_lex_state = 22},
  [2583] = {.lex_state = 94, .external_lex_state = 22},
  [2584] = {.lex_state = 94, .external_lex_state = 22},
  [2585] = {.lex_state = 94, .external_lex_state = 22},
  [2586] = {.lex_state = 94, .external_lex_state = 22},
  [2587] = {.lex_state = 94, .external_lex_state = 22},
  [2588] = {.lex_state = 94, .external_lex_state = 22},
  [2589] = {.lex_state = 94, .external_lex_state = 22},
  [2590] = {.lex_state = 94, .external_lex_state = 22},
  [2591] = {.lex_state = 94, .external_lex_state = 22},
  [2592] = {.lex_state = 75, .external_lex_state = 26},
  [2593] = {.lex_state = 75, .external_lex_state = 26},
  [2594] = {.lex_state = 75, .external_lex_state = 26},
  [2595] = {.lex_state = 75, .external_lex_state = 26},
  [2596] = {.lex_state = 75, .external_lex_state = 26},
  [2597] = {.lex_state = 75, .external_lex_state = 26},
  [2598] = {.lex_state = 220, .external_lex_state = 25},
  [2599] = {.lex_state = 75, .external_lex_state = 26},
  [2600] = {.lex_state = 75, .external_lex_state = 26},
  [2601] = {.lex_state = 75, .external_lex_state = 26},
  [2602] = {.lex_state = 75, .external_lex_state = 26},
  [2603] = {.lex_state = 75, .external_lex_state = 26},
  [2604] = {.lex_state = 75, .external_lex_state = 26},
  [2605] = {.lex_state = 90, .external_lex_state = 24},
  [2606] = {.lex_state = 75, .external_lex_state = 26},
  [2607] = {.lex_state = 94, .external_lex_state = 22},
  [2608] = {.lex_state = 75, .external_lex_state = 26},
  [2609] = {.lex_state = 94, .external_lex_state = 22},
  [2610] = {.lex_state = 75, .external_lex_state = 26},
  [2611] = {.lex_state = 75, .external_lex_state = 26},
  [2612] = {.lex_state = 88, .external_lex_state = 24},
  [2613] = {.lex_state = 94, .external_lex_state = 22},
  [2614] = {.lex_state = 75, .external_lex_state = 26},
  [2615] = {.lex_state = 75, .external_lex_state = 26},
  [2616] = {.lex_state = 75, .external_lex_state = 26},
  [2617] = {.lex_state = 75, .external_lex_state = 26},
  [2618] = {.lex_state = 75, .external_lex_state = 26},
  [2619] = {.lex_state = 75, .external_lex_state = 26},
  [2620] = {.lex_state = 75, .external_lex_state = 26},
  [2621] = {.lex_state = 75, .external_lex_state = 26},
  [2622] = {.lex_state = 75, .external_lex_state = 26},
  [2623] = {.lex_state = 75, .external_lex_state = 26},
  [2624] = {.lex_state = 75, .external_lex_state = 26},
  [2625] = {.lex_state = 90, .external_lex_state = 24},
  [2626] = {.lex_state = 75, .external_lex_state = 26},
  [2627] = {.lex_state = 101, .external_lex_state = 23},
  [2628] = {.lex_state = 94, .external_lex_state = 22},
  [2629] = {.lex_state = 75, .external_lex_state = 26},
  [2630] = {.lex_state = 94, .external_lex_state = 22},
  [2631] = {.lex_state = 94, .external_lex_state = 22},
  [2632] = {.lex_state = 94, .external_lex_state = 22},
  [2633] = {.lex_state = 94, .external_lex_state = 22},
  [2634] = {.lex_state = 94, .external_lex_state = 22},
  [2635] = {.lex_state = 94, .external_lex_state = 22},
  [2636] = {.lex_state = 94, .external_lex_state = 22},
  [2637] = {.lex_state = 94, .external_lex_state = 22},
  [2638] = {.lex_state = 94, .external_lex_state = 22},
  [2639] = {.lex_state = 94, .external_lex_state = 22},
  [2640] = {.lex_state = 98, .external_lex_state = 27},
  [2641] = {.lex_state = 94, .external_lex_state = 22},
  [2642] = {.lex_state = 220, .external_lex_state = 25},
  [2643] = {.lex_state = 94, .external_lex_state = 22},
  [2644] = {.lex_state = 94, .external_lex_state = 22},
  [2645] = {.lex_state = 75, .external_lex_state = 26},
  [2646] = {.lex_state = 94, .external_lex_state = 22},
  [2647] = {.lex_state = 94, .external_lex_state = 22},
  [2648] = {.lex_state = 75, .external_lex_state = 26},
  [2649] = {.lex_state = 94, .external_lex_state = 22},
  [2650] = {.lex_state = 94, .external_lex_state = 22},
  [2651] = {.lex_state = 98, .external_lex_state = 27},
  [2652] = {.lex_state = 90, .external_lex_state = 24},
  [2653] = {.lex_state = 90, .external_lex_state = 24},
  [2654] = {.lex_state = 94, .external_lex_state = 22},
  [2655] = {.lex_state = 75, .external_lex_state = 26},
  [2656] = {.lex_state = 94, .external_lex_state = 22},
  [2657] = {.lex_state = 94, .external_lex_state = 22},
  [2658] = {.lex_state = 75, .external_lex_state = 26},
  [2659] = {.lex_state = 94, .external_lex_state = 22},
  [2660] = {.lex_state = 90, .external_lex_state = 24},
  [2661] = {.lex_state = 94, .external_lex_state = 22},
  [2662] = {.lex_state = 98, .external_lex_state = 27},
  [2663] = {.lex_state = 98, .external_lex_state = 27},
  [2664] = {.lex_state = 98, .external_lex_state = 27},
  [2665] = {.lex_state = 75, .external_lex_state = 26},
  [2666] = {.lex_state = 90, .external_lex_state = 24},
  [2667] = {.lex_state = 75, .external_lex_state = 26},
  [2668] = {.lex_state = 101, .external_lex_state = 23},
  [2669] = {.lex_state = 220, .external_lex_state = 22},
  [2670] = {.lex_state = 98, .external_lex_state = 27},
  [2671] = {.lex_state = 220, .external_lex_state = 22},
  [2672] = {.lex_state = 98, .external_lex_state = 27},
  [2673] = {.lex_state = 98, .external_lex_state = 27},
  [2674] = {.lex_state = 98, .external_lex_state = 27},
  [2675] = {.lex_state = 98, .external_lex_state = 27},
  [2676] = {.lex_state = 98, .external_lex_state = 27},
  [2677] = {.lex_state = 98, .external_lex_state = 27},
  [2678] = {.lex_state = 220, .external_lex_state = 22},
  [2679] = {.lex_state = 98, .external_lex_state = 27},
  [2680] = {.lex_state = 98, .external_lex_state = 27},
  [2681] = {.lex_state = 98, .external_lex_state = 27},
  [2682] = {.lex_state = 98, .external_lex_state = 27},
  [2683] = {.lex_state = 98, .external_lex_state = 27},
  [2684] = {.lex_state = 98, .external_lex_state = 27},
  [2685] = {.lex_state = 98, .external_lex_state = 27},
  [2686] = {.lex_state = 98, .external_lex_state = 27},
  [2687] = {.lex_state = 98, .external_lex_state = 27},
  [2688] = {.lex_state = 98, .external_lex_state = 27},
  [2689] = {.lex_state = 98, .external_lex_state = 27},
  [2690] = {.lex_state = 98, .external_lex_state = 27},
  [2691] = {.lex_state = 98, .external_lex_state = 27},
  [2692] = {.lex_state = 98, .external_lex_state = 27},
  [2693] = {.lex_state = 98, .external_lex_state = 27},
  [2694] = {.lex_state = 98, .external_lex_state = 27},
  [2695] = {.lex_state = 98, .external_lex_state = 27},
  [2696] = {.lex_state = 98, .external_lex_state = 27},
  [2697] = {.lex_state = 98, .external_lex_state = 27},
  [2698] = {.lex_state = 98, .external_lex_state = 27},
  [2699] = {.lex_state = 98, .external_lex_state = 27},
  [2700] = {.lex_state = 98, .external_lex_state = 27},
  [2701] = {.lex_state = 220, .external_lex_state = 22},
  [2702] = {.lex_state = 220, .external_lex_state = 22},
  [2703] = {.lex_state = 220, .external_lex_state = 22},
  [2704] = {.lex_state = 220, .external_lex_state = 22},
  [2705] = {.lex_state = 220, .external_lex_state = 22},
  [2706] = {.lex_state = 220, .external_lex_state = 22},
  [2707] = {.lex_state = 98, .external_lex_state = 27},
  [2708] = {.lex_state = 98, .external_lex_state = 27},
  [2709] = {.lex_state = 98, .external_lex_state = 27},
  [2710] = {.lex_state = 98, .external_lex_state = 27},
  [2711] = {.lex_state = 98, .external_lex_state = 27},
  [2712] = {.lex_state = 220, .external_lex_state = 22},
  [2713] = {.lex_state = 98, .external_lex_state = 27},
  [2714] = {.lex_state = 220, .external_lex_state = 22},
  [2715] = {.lex_state = 220, .external_lex_state = 22},
  [2716] = {.lex_state = 220, .external_lex_state = 22},
  [2717] = {.lex_state = 98, .external_lex_state = 27},
  [2718] = {.lex_state = 220, .external_lex_state = 22},
  [2719] = {.lex_state = 220, .external_lex_state = 22},
  [2720] = {.lex_state = 98, .external_lex_state = 27},
  [2721] = {.lex_state = 98, .external_lex_state = 27},
  [2722] = {.lex_state = 220, .external_lex_state = 22},
  [2723] = {.lex_state = 220, .external_lex_state = 22},
  [2724] = {.lex_state = 94, .external_lex_state = 25},
  [2725] = {.lex_state = 220, .external_lex_state = 22},
  [2726] = {.lex_state = 98, .external_lex_state = 27},
  [2727] = {.lex_state = 220, .external_lex_state = 22},
  [2728] = {.lex_state = 220, .external_lex_state = 22},
  [2729] = {.lex_state = 95, .external_lex_state = 24},
  [2730] = {.lex_state = 220, .external_lex_state = 22},
  [2731] = {.lex_state = 220, .external_lex_state = 22},
  [2732] = {.lex_state = 98, .external_lex_state = 27},
  [2733] = {.lex_state = 220, .external_lex_state = 22},
  [2734] = {.lex_state = 220, .external_lex_state = 22},
  [2735] = {.lex_state = 220, .external_lex_state = 22},
  [2736] = {.lex_state = 220, .external_lex_state = 22},
  [2737] = {.lex_state = 220, .external_lex_state = 22},
  [2738] = {.lex_state = 220, .external_lex_state = 22},
  [2739] = {.lex_state = 220, .external_lex_state = 22},
  [2740] = {.lex_state = 98, .external_lex_state = 27},
  [2741] = {.lex_state = 220, .external_lex_state = 22},
  [2742] = {.lex_state = 220, .external_lex_state = 22},
  [2743] = {.lex_state = 98, .external_lex_state = 27},
  [2744] = {.lex_state = 220, .external_lex_state = 22},
  [2745] = {.lex_state = 98, .external_lex_state = 27},
  [2746] = {.lex_state = 98, .external_lex_state = 27},
  [2747] = {.lex_state = 98, .external_lex_state = 27},
  [2748] = {.lex_state = 98, .external_lex_state = 27},
  [2749] = {.lex_state = 98, .external_lex_state = 27},
  [2750] = {.lex_state = 98, .external_lex_state = 27},
  [2751] = {.lex_state = 98, .external_lex_state = 27},
  [2752] = {.lex_state = 98, .external_lex_state = 27},
  [2753] = {.lex_state = 98, .external_lex_state = 27},
  [2754] = {.lex_state = 98, .external_lex_state = 27},
  [2755] = {.lex_state = 98, .external_lex_state = 27},
  [2756] = {.lex_state = 98, .external_lex_state = 27},
  [2757] = {.lex_state = 98, .external_lex_state = 27},
  [2758] = {.lex_state = 220, .external_lex_state = 22},
  [2759] = {.lex_state = 220, .external_lex_state = 22},
  [2760] = {.lex_state = 95, .external_lex_state = 24},
  [2761] = {.lex_state = 98, .external_lex_state = 27},
  [2762] = {.lex_state = 220, .external_lex_state = 22},
  [2763] = {.lex_state = 98, .external_lex_state = 27},
  [2764] = {.lex_state = 98, .external_lex_state = 27},
  [2765] = {.lex_state = 98, .external_lex_state = 27},
  [2766] = {.lex_state = 98, .external_lex_state = 27},
  [2767] = {.lex_state = 98, .external_lex_state = 27},
  [2768] = {.lex_state = 98, .external_lex_state = 27},
  [2769] = {.lex_state = 98, .external_lex_state = 27},
  [2770] = {.lex_state = 98, .external_lex_state = 27},
  [2771] = {.lex_state = 98, .external_lex_state = 27},
  [2772] = {.lex_state = 98, .external_lex_state = 27},
  [2773] = {.lex_state = 94, .external_lex_state = 25},
  [2774] = {.lex_state = 98, .external_lex_state = 27},
  [2775] = {.lex_state = 98, .external_lex_state = 27},
  [2776] = {.lex_state = 98, .external_lex_state = 27},
  [2777] = {.lex_state = 220, .external_lex_state = 22},
  [2778] = {.lex_state = 98, .external_lex_state = 27},
  [2779] = {.lex_state = 94, .external_lex_state = 25},
  [2780] = {.lex_state = 220, .external_lex_state = 22},
  [2781] = {.lex_state = 220, .external_lex_state = 22},
  [2782] = {.lex_state = 95, .external_lex_state = 24},
  [2783] = {.lex_state = 94, .external_lex_state = 25},
  [2784] = {.lex_state = 220, .external_lex_state = 22},
  [2785] = {.lex_state = 95, .external_lex_state = 24},
  [2786] = {.lex_state = 220, .external_lex_state = 22},
  [2787] = {.lex_state = 220, .external_lex_state = 22},
  [2788] = {.lex_state = 98, .external_lex_state = 27},
  [2789] = {.lex_state = 220, .external_lex_state = 22},
  [2790] = {.lex_state = 220, .external_lex_state = 22},
  [2791] = {.lex_state = 220, .external_lex_state = 22},
  [2792] = {.lex_state = 220, .external_lex_state = 22},
  [2793] = {.lex_state = 98, .external_lex_state = 27},
  [2794] = {.lex_state = 98, .external_lex_state = 27},
  [2795] = {.lex_state = 220, .external_lex_state = 22},
  [2796] = {.lex_state = 220, .external_lex_state = 22},
  [2797] = {.lex_state = 220, .external_lex_state = 22},
  [2798] = {.lex_state = 220, .external_lex_state = 22},
  [2799] = {.lex_state = 220, .external_lex_state = 22},
  [2800] = {.lex_state = 94, .external_lex_state = 28},
  [2801] = {.lex_state = 98, .external_lex_state = 27},
  [2802] = {.lex_state = 220, .external_lex_state = 22},
  [2803] = {.lex_state = 220, .external_lex_state = 22},
  [2804] = {.lex_state = 220, .external_lex_state = 22},
  [2805] = {.lex_state = 220, .external_lex_state = 22},
  [2806] = {.lex_state = 220, .external_lex_state = 22},
  [2807] = {.lex_state = 220, .external_lex_state = 22},
  [2808] = {.lex_state = 220, .external_lex_state = 22},
  [2809] = {.lex_state = 220, .external_lex_state = 22},
  [2810] = {.lex_state = 220, .external_lex_state = 22},
  [2811] = {.lex_state = 220, .external_lex_state = 22},
  [2812] = {.lex_state = 220, .external_lex_state = 22},
  [2813] = {.lex_state = 220, .external_lex_state = 22},
  [2814] = {.lex_state = 98, .external_lex_state = 27},
  [2815] = {.lex_state = 95, .external_lex_state = 24},
  [2816] = {.lex_state = 98, .external_lex_state = 27},
  [2817] = {.lex_state = 98, .external_lex_state = 27},
  [2818] = {.lex_state = 94, .external_lex_state = 28},
  [2819] = {.lex_state = 98, .external_lex_state = 27},
  [2820] = {.lex_state = 98, .external_lex_state = 27},
  [2821] = {.lex_state = 98, .external_lex_state = 27},
  [2822] = {.lex_state = 98, .external_lex_state = 27},
  [2823] = {.lex_state = 98, .external_lex_state = 27},
  [2824] = {.lex_state = 98, .external_lex_state = 27},
  [2825] = {.lex_state = 98, .external_lex_state = 27},
  [2826] = {.lex_state = 98, .external_lex_state = 27},
  [2827] = {.lex_state = 98, .external_lex_state = 27},
  [2828] = {.lex_state = 98, .external_lex_state = 27},
  [2829] = {.lex_state = 95, .external_lex_state = 24},
  [2830] = {.lex_state = 220, .external_lex_state = 22},
  [2831] = {.lex_state = 95, .external_lex_state = 24},
  [2832] = {.lex_state = 98, .external_lex_state = 27},
  [2833] = {.lex_state = 98, .external_lex_state = 27},
  [2834] = {.lex_state = 98, .external_lex_state = 27},
  [2835] = {.lex_state = 98, .external_lex_state = 27},
  [2836] = {.lex_state = 98, .external_lex_state = 27},
  [2837] = {.lex_state = 98, .external_lex_state = 27},
  [2838] = {.lex_state = 95, .external_lex_state = 24},
  [2839] = {.lex_state = 95, .external_lex_state = 24},
  [2840] = {.lex_state = 98, .external_lex_state = 27},
  [2841] = {.lex_state = 98, .external_lex_state = 27},
  [2842] = {.lex_state = 95, .external_lex_state = 24},
  [2843] = {.lex_state = 220, .external_lex_state = 22},
  [2844] = {.lex_state = 98, .external_lex_state = 27},
  [2845] = {.lex_state = 95, .external_lex_state = 24},
  [2846] = {.lex_state = 98, .external_lex_state = 27},
  [2847] = {.lex_state = 98, .external_lex_state = 27},
  [2848] = {.lex_state = 94, .external_lex_state = 28},
  [2849] = {.lex_state = 94, .external_lex_state = 25},
  [2850] = {.lex_state = 98, .external_lex_state = 27},
  [2851] = {.lex_state = 95, .external_lex_state = 24},
  [2852] = {.lex_state = 98, .external_lex_state = 27},
  [2853] = {.lex_state = 94, .external_lex_state = 22},
  [2854] = {.lex_state = 94, .external_lex_state = 22},
  [2855] = {.lex_state = 220, .external_lex_state = 22},
  [2856] = {.lex_state = 220, .external_lex_state = 22},
  [2857] = {.lex_state = 94, .external_lex_state = 22},
  [2858] = {.lex_state = 220, .external_lex_state = 22},
  [2859] = {.lex_state = 220, .external_lex_state = 22},
  [2860] = {.lex_state = 94, .external_lex_state = 22},
  [2861] = {.lex_state = 222, .external_lex_state = 27},
  [2862] = {.lex_state = 220, .external_lex_state = 22},
  [2863] = {.lex_state = 220, .external_lex_state = 22},
  [2864] = {.lex_state = 220, .external_lex_state = 22},
  [2865] = {.lex_state = 220, .external_lex_state = 22},
  [2866] = {.lex_state = 220, .external_lex_state = 22},
  [2867] = {.lex_state = 94, .external_lex_state = 28},
  [2868] = {.lex_state = 220, .external_lex_state = 22},
  [2869] = {.lex_state = 94, .external_lex_state = 25},
  [2870] = {.lex_state = 98, .external_lex_state = 27},
  [2871] = {.lex_state = 220, .external_lex_state = 22},
  [2872] = {.lex_state = 220, .external_lex_state = 22},
  [2873] = {.lex_state = 222, .external_lex_state = 27},
  [2874] = {.lex_state = 94, .external_lex_state = 24},
  [2875] = {.lex_state = 94, .external_lex_state = 22},
  [2876] = {.lex_state = 220, .external_lex_state = 22},
  [2877] = {.lex_state = 94, .external_lex_state = 24},
  [2878] = {.lex_state = 222, .external_lex_state = 27},
  [2879] = {.lex_state = 220, .external_lex_state = 22},
  [2880] = {.lex_state = 220, .external_lex_state = 22},
  [2881] = {.lex_state = 220, .external_lex_state = 22},
  [2882] = {.lex_state = 220, .external_lex_state = 22},
  [2883] = {.lex_state = 220, .external_lex_state = 22},
  [2884] = {.lex_state = 94, .external_lex_state = 22},
  [2885] = {.lex_state = 94, .external_lex_state = 22},
  [2886] = {.lex_state = 94, .external_lex_state = 28},
  [2887] = {.lex_state = 95, .external_lex_state = 24},
  [2888] = {.lex_state = 95, .external_lex_state = 24},
  [2889] = {.lex_state = 222, .external_lex_state = 27},
  [2890] = {.lex_state = 220, .external_lex_state = 22},
  [2891] = {.lex_state = 95, .external_lex_state = 28},
  [2892] = {.lex_state = 220, .external_lex_state = 22},
  [2893] = {.lex_state = 94, .external_lex_state = 28},
  [2894] = {.lex_state = 94, .external_lex_state = 22},
  [2895] = {.lex_state = 220, .external_lex_state = 22},
  [2896] = {.lex_state = 222, .external_lex_state = 27},
  [2897] = {.lex_state = 220, .external_lex_state = 22},
  [2898] = {.lex_state = 220, .external_lex_state = 22},
  [2899] = {.lex_state = 94, .external_lex_state = 24},
  [2900] = {.lex_state = 95, .external_lex_state = 24},
  [2901] = {.lex_state = 95, .external_lex_state = 24},
  [2902] = {.lex_state = 95, .external_lex_state = 24},
  [2903] = {.lex_state = 222, .external_lex_state = 27},
  [2904] = {.lex_state = 95, .external_lex_state = 24},
  [2905] = {.lex_state = 95, .external_lex_state = 24},
  [2906] = {.lex_state = 95, .external_lex_state = 24},
  [2907] = {.lex_state = 94, .external_lex_state = 28},
  [2908] = {.lex_state = 222, .external_lex_state = 27},
  [2909] = {.lex_state = 95, .external_lex_state = 24},
  [2910] = {.lex_state = 95, .external_lex_state = 24},
  [2911] = {.lex_state = 95, .external_lex_state = 24},
  [2912] = {.lex_state = 95, .external_lex_state = 24},
  [2913] = {.lex_state = 95, .external_lex_state = 24},
  [2914] = {.lex_state = 95, .external_lex_state = 24},
  [2915] = {.lex_state = 95, .external_lex_state = 24},
  [2916] = {.lex_state = 95, .external_lex_state = 24},
  [2917] = {.lex_state = 95, .external_lex_state = 24},
  [2918] = {.lex_state = 95, .external_lex_state = 24},
  [2919] = {.lex_state = 95, .external_lex_state = 24},
  [2920] = {.lex_state = 95, .external_lex_state = 24},
  [2921] = {.lex_state = 95, .external_lex_state = 24},
  [2922] = {.lex_state = 95, .external_lex_state = 24},
  [2923] = {.lex_state = 95, .external_lex_state = 24},
  [2924] = {.lex_state = 95, .external_lex_state = 24},
  [2925] = {.lex_state = 95, .external_lex_state = 24},
  [2926] = {.lex_state = 95, .external_lex_state = 24},
  [2927] = {.lex_state = 95, .external_lex_state = 24},
  [2928] = {.lex_state = 95, .external_lex_state = 24},
  [2929] = {.lex_state = 95, .external_lex_state = 24},
  [2930] = {.lex_state = 95, .external_lex_state = 24},
  [2931] = {.lex_state = 95, .external_lex_state = 24},
  [2932] = {.lex_state = 95, .external_lex_state = 24},
  [2933] = {.lex_state = 95, .external_lex_state = 24},
  [2934] = {.lex_state = 95, .external_lex_state = 24},
  [2935] = {.lex_state = 95, .external_lex_state = 24},
  [2936] = {.lex_state = 95, .external_lex_state = 24},
  [2937] = {.lex_state = 95, .external_lex_state = 24},
  [2938] = {.lex_state = 95, .external_lex_state = 24},
  [2939] = {.lex_state = 95, .external_lex_state = 24},
  [2940] = {.lex_state = 95, .external_lex_state = 24},
  [2941] = {.lex_state = 94, .external_lex_state = 22},
  [2942] = {.lex_state = 94, .external_lex_state = 22},
  [2943] = {.lex_state = 95, .external_lex_state = 24},
  [2944] = {.lex_state = 95, .external_lex_state = 24},
  [2945] = {.lex_state = 95, .external_lex_state = 24},
  [2946] = {.lex_state = 95, .external_lex_state = 24},
  [2947] = {.lex_state = 222, .external_lex_state = 27},
  [2948] = {.lex_state = 222, .external_lex_state = 27},
  [2949] = {.lex_state = 222, .external_lex_state = 27},
  [2950] = {.lex_state = 95, .external_lex_state = 24},
  [2951] = {.lex_state = 95, .external_lex_state = 24},
  [2952] = {.lex_state = 94, .external_lex_state = 28},
  [2953] = {.lex_state = 222, .external_lex_state = 27},
  [2954] = {.lex_state = 222, .external_lex_state = 27},
  [2955] = {.lex_state = 222, .external_lex_state = 27},
  [2956] = {.lex_state = 95, .external_lex_state = 24},
  [2957] = {.lex_state = 95, .external_lex_state = 24},
  [2958] = {.lex_state = 95, .external_lex_state = 24},
  [2959] = {.lex_state = 95, .external_lex_state = 24},
  [2960] = {.lex_state = 95, .external_lex_state = 24},
  [2961] = {.lex_state = 222, .external_lex_state = 27},
  [2962] = {.lex_state = 95, .external_lex_state = 24},
  [2963] = {.lex_state = 95, .external_lex_state = 24},
  [2964] = {.lex_state = 95, .external_lex_state = 24},
  [2965] = {.lex_state = 95, .external_lex_state = 24},
  [2966] = {.lex_state = 95, .external_lex_state = 24},
  [2967] = {.lex_state = 95, .external_lex_state = 24},
  [2968] = {.lex_state = 95, .external_lex_state = 24},
  [2969] = {.lex_state = 95, .external_lex_state = 24},
  [2970] = {.lex_state = 95, .external_lex_state = 24},
  [2971] = {.lex_state = 222, .external_lex_state = 27},
  [2972] = {.lex_state = 95, .external_lex_state = 24},
  [2973] = {.lex_state = 95, .external_lex_state = 24},
  [2974] = {.lex_state = 95, .external_lex_state = 24},
  [2975] = {.lex_state = 95, .external_lex_state = 24},
  [2976] = {.lex_state = 95, .external_lex_state = 24},
  [2977] = {.lex_state = 95, .external_lex_state = 24},
  [2978] = {.lex_state = 95, .external_lex_state = 24},
  [2979] = {.lex_state = 95, .external_lex_state = 24},
  [2980] = {.lex_state = 94, .external_lex_state = 22},
  [2981] = {.lex_state = 222, .external_lex_state = 27},
  [2982] = {.lex_state = 94, .external_lex_state = 22},
  [2983] = {.lex_state = 222, .external_lex_state = 27},
  [2984] = {.lex_state = 222, .external_lex_state = 27},
  [2985] = {.lex_state = 222, .external_lex_state = 27},
  [2986] = {.lex_state = 95, .external_lex_state = 24},
  [2987] = {.lex_state = 95, .external_lex_state = 24},
  [2988] = {.lex_state = 95, .external_lex_state = 24},
  [2989] = {.lex_state = 95, .external_lex_state = 24},
  [2990] = {.lex_state = 222, .external_lex_state = 27},
  [2991] = {.lex_state = 95, .external_lex_state = 24},
  [2992] = {.lex_state = 222, .external_lex_state = 27},
  [2993] = {.lex_state = 95, .external_lex_state = 24},
  [2994] = {.lex_state = 95, .external_lex_state = 24},
  [2995] = {.lex_state = 94, .external_lex_state = 25},
  [2996] = {.lex_state = 95, .external_lex_state = 24},
  [2997] = {.lex_state = 222, .external_lex_state = 27},
  [2998] = {.lex_state = 222, .external_lex_state = 27},
  [2999] = {.lex_state = 95, .external_lex_state = 24},
  [3000] = {.lex_state = 95, .external_lex_state = 24},
  [3001] = {.lex_state = 95, .external_lex_state = 24},
  [3002] = {.lex_state = 95, .external_lex_state = 24},
  [3003] = {.lex_state = 95, .external_lex_state = 24},
  [3004] = {.lex_state = 95, .external_lex_state = 24},
  [3005] = {.lex_state = 95, .external_lex_state = 24},
  [3006] = {.lex_state = 95, .external_lex_state = 24},
  [3007] = {.lex_state = 95, .external_lex_state = 24},
  [3008] = {.lex_state = 95, .external_lex_state = 24},
  [3009] = {.lex_state = 222, .external_lex_state = 27},
  [3010] = {.lex_state = 95, .external_lex_state = 24},
  [3011] = {.lex_state = 95, .external_lex_state = 24},
  [3012] = {.lex_state = 95, .external_lex_state = 24},
  [3013] = {.lex_state = 95, .external_lex_state = 24},
  [3014] = {.lex_state = 95, .external_lex_state = 24},
  [3015] = {.lex_state = 95, .external_lex_state = 24},
  [3016] = {.lex_state = 95, .external_lex_state = 24},
  [3017] = {.lex_state = 222, .external_lex_state = 27},
  [3018] = {.lex_state = 95, .external_lex_state = 24},
  [3019] = {.lex_state = 95, .external_lex_state = 24},
  [3020] = {.lex_state = 95, .external_lex_state = 24},
  [3021] = {.lex_state = 95, .external_lex_state = 24},
  [3022] = {.lex_state = 95, .external_lex_state = 24},
  [3023] = {.lex_state = 94, .external_lex_state = 22},
  [3024] = {.lex_state = 95, .external_lex_state = 24},
  [3025] = {.lex_state = 95, .external_lex_state = 24},
  [3026] = {.lex_state = 95, .external_lex_state = 24},
  [3027] = {.lex_state = 95, .external_lex_state = 24},
  [3028] = {.lex_state = 222, .external_lex_state = 27},
  [3029] = {.lex_state = 95, .external_lex_state = 24},
  [3030] = {.lex_state = 95, .external_lex_state = 24},
  [3031] = {.lex_state = 95, .external_lex_state = 24},
  [3032] = {.lex_state = 222, .external_lex_state = 27},
  [3033] = {.lex_state = 95, .external_lex_state = 24},
  [3034] = {.lex_state = 95, .external_lex_state = 24},
  [3035] = {.lex_state = 95, .external_lex_state = 24},
  [3036] = {.lex_state = 222, .external_lex_state = 27},
  [3037] = {.lex_state = 95, .external_lex_state = 24},
  [3038] = {.lex_state = 95, .external_lex_state = 24},
  [3039] = {.lex_state = 222, .external_lex_state = 27},
  [3040] = {.lex_state = 222, .external_lex_state = 27},
  [3041] = {.lex_state = 222, .external_lex_state = 27},
  [3042] = {.lex_state = 222, .external_lex_state = 27},
  [3043] = {.lex_state = 95, .external_lex_state = 24},
  [3044] = {.lex_state = 95, .external_lex_state = 24},
  [3045] = {.lex_state = 95, .external_lex_state = 24},
  [3046] = {.lex_state = 222, .external_lex_state = 27},
  [3047] = {.lex_state = 95, .external_lex_state = 24},
  [3048] = {.lex_state = 95, .external_lex_state = 24},
  [3049] = {.lex_state = 95, .external_lex_state = 24},
  [3050] = {.lex_state = 95, .external_lex_state = 24},
  [3051] = {.lex_state = 95, .external_lex_state = 24},
  [3052] = {.lex_state = 94, .external_lex_state = 22},
  [3053] = {.lex_state = 94, .external_lex_state = 22},
  [3054] = {.lex_state = 94, .external_lex_state = 22},
  [3055] = {.lex_state = 94, .external_lex_state = 22},
  [3056] = {.lex_state = 94, .external_lex_state = 22},
  [3057] = {.lex_state = 94, .external_lex_state = 22},
  [3058] = {.lex_state = 94, .external_lex_state = 22},
  [3059] = {.lex_state = 94, .external_lex_state = 22},
  [3060] = {.lex_state = 95, .external_lex_state = 24},
  [3061] = {.lex_state = 94, .external_lex_state = 22},
  [3062] = {.lex_state = 95, .external_lex_state = 24},
  [3063] = {.lex_state = 95, .external_lex_state = 24},
  [3064] = {.lex_state = 95, .external_lex_state = 24},
  [3065] = {.lex_state = 95, .external_lex_state = 24},
  [3066] = {.lex_state = 95, .external_lex_state = 24},
  [3067] = {.lex_state = 95, .external_lex_state = 24},
  [3068] = {.lex_state = 95, .external_lex_state = 24},
  [3069] = {.lex_state = 95, .external_lex_state = 24},
  [3070] = {.lex_state = 95, .external_lex_state = 24},
  [3071] = {.lex_state = 95, .external_lex_state = 24},
  [3072] = {.lex_state = 95, .external_lex_state = 24},
  [3073] = {.lex_state = 94, .external_lex_state = 28},
  [3074] = {.lex_state = 94, .external_lex_state = 22},
  [3075] = {.lex_state = 94, .external_lex_state = 22},
  [3076] = {.lex_state = 94, .external_lex_state = 22},
  [3077] = {.lex_state = 94, .external_lex_state = 22},
  [3078] = {.lex_state = 94, .external_lex_state = 22},
  [3079] = {.lex_state = 94, .external_lex_state = 22},
  [3080] = {.lex_state = 94, .external_lex_state = 22},
  [3081] = {.lex_state = 94, .external_lex_state = 22},
  [3082] = {.lex_state = 94, .external_lex_state = 22},
  [3083] = {.lex_state = 94, .external_lex_state = 22},
  [3084] = {.lex_state = 94, .external_lex_state = 22},
  [3085] = {.lex_state = 94, .external_lex_state = 22},
  [3086] = {.lex_state = 94, .external_lex_state = 22},
  [3087] = {.lex_state = 94, .external_lex_state = 22},
  [3088] = {.lex_state = 95, .external_lex_state = 24},
  [3089] = {.lex_state = 95, .external_lex_state = 24},
  [3090] = {.lex_state = 95, .external_lex_state = 24},
  [3091] = {.lex_state = 95, .external_lex_state = 24},
  [3092] = {.lex_state = 95, .external_lex_state = 24},
  [3093] = {.lex_state = 222, .external_lex_state = 27},
  [3094] = {.lex_state = 95, .external_lex_state = 24},
  [3095] = {.lex_state = 95, .external_lex_state = 24},
  [3096] = {.lex_state = 95, .external_lex_state = 24},
  [3097] = {.lex_state = 95, .external_lex_state = 24},
  [3098] = {.lex_state = 95, .external_lex_state = 24},
  [3099] = {.lex_state = 95, .external_lex_state = 24},
  [3100] = {.lex_state = 95, .external_lex_state = 24},
  [3101] = {.lex_state = 95, .external_lex_state = 24},
  [3102] = {.lex_state = 95, .external_lex_state = 24},
  [3103] = {.lex_state = 95, .external_lex_state = 24},
  [3104] = {.lex_state = 95, .external_lex_state = 24},
  [3105] = {.lex_state = 95, .external_lex_state = 24},
  [3106] = {.lex_state = 79, .external_lex_state = 29},
  [3107] = {.lex_state = 94, .external_lex_state = 22},
  [3108] = {.lex_state = 79, .external_lex_state = 29},
  [3109] = {.lex_state = 79, .external_lex_state = 29},
  [3110] = {.lex_state = 79, .external_lex_state = 29},
  [3111] = {.lex_state = 94, .external_lex_state = 22},
  [3112] = {.lex_state = 94, .external_lex_state = 22},
  [3113] = {.lex_state = 222, .external_lex_state = 27},
  [3114] = {.lex_state = 94, .external_lex_state = 24},
  [3115] = {.lex_state = 94, .external_lex_state = 22},
  [3116] = {.lex_state = 79, .external_lex_state = 29},
  [3117] = {.lex_state = 94, .external_lex_state = 24},
  [3118] = {.lex_state = 94, .external_lex_state = 22},
  [3119] = {.lex_state = 94, .external_lex_state = 22},
  [3120] = {.lex_state = 94, .external_lex_state = 22},
  [3121] = {.lex_state = 79, .external_lex_state = 29},
  [3122] = {.lex_state = 79, .external_lex_state = 29},
  [3123] = {.lex_state = 79, .external_lex_state = 29},
  [3124] = {.lex_state = 79, .external_lex_state = 29},
  [3125] = {.lex_state = 94, .external_lex_state = 22},
  [3126] = {.lex_state = 77, .external_lex_state = 26},
  [3127] = {.lex_state = 222, .external_lex_state = 27},
  [3128] = {.lex_state = 79, .external_lex_state = 29},
  [3129] = {.lex_state = 94, .external_lex_state = 22},
  [3130] = {.lex_state = 94, .external_lex_state = 22},
  [3131] = {.lex_state = 79, .external_lex_state = 29},
  [3132] = {.lex_state = 94, .external_lex_state = 22},
  [3133] = {.lex_state = 79, .external_lex_state = 29},
  [3134] = {.lex_state = 222, .external_lex_state = 27},
  [3135] = {.lex_state = 222, .external_lex_state = 27},
  [3136] = {.lex_state = 79, .external_lex_state = 29},
  [3137] = {.lex_state = 94, .external_lex_state = 22},
  [3138] = {.lex_state = 94, .external_lex_state = 22},
  [3139] = {.lex_state = 94, .external_lex_state = 28},
  [3140] = {.lex_state = 94, .external_lex_state = 22},
  [3141] = {.lex_state = 222, .external_lex_state = 27},
  [3142] = {.lex_state = 94, .external_lex_state = 22},
  [3143] = {.lex_state = 94, .external_lex_state = 22},
  [3144] = {.lex_state = 94, .external_lex_state = 22},
  [3145] = {.lex_state = 79, .external_lex_state = 29},
  [3146] = {.lex_state = 79, .external_lex_state = 29},
  [3147] = {.lex_state = 79, .external_lex_state = 29},
  [3148] = {.lex_state = 79, .external_lex_state = 29},
  [3149] = {.lex_state = 79, .external_lex_state = 29},
  [3150] = {.lex_state = 94, .external_lex_state = 22},
  [3151] = {.lex_state = 94, .external_lex_state = 22},
  [3152] = {.lex_state = 94, .external_lex_state = 24},
  [3153] = {.lex_state = 94, .external_lex_state = 22},
  [3154] = {.lex_state = 79, .external_lex_state = 29},
  [3155] = {.lex_state = 94, .external_lex_state = 22},
  [3156] = {.lex_state = 79, .external_lex_state = 29},
  [3157] = {.lex_state = 94, .external_lex_state = 25},
  [3158] = {.lex_state = 94, .external_lex_state = 22},
  [3159] = {.lex_state = 94, .external_lex_state = 22},
  [3160] = {.lex_state = 94, .external_lex_state = 22},
  [3161] = {.lex_state = 94, .external_lex_state = 22},
  [3162] = {.lex_state = 79, .external_lex_state = 29},
  [3163] = {.lex_state = 94, .external_lex_state = 22},
  [3164] = {.lex_state = 94, .external_lex_state = 22},
  [3165] = {.lex_state = 79, .external_lex_state = 29},
  [3166] = {.lex_state = 94, .external_lex_state = 22},
  [3167] = {.lex_state = 79, .external_lex_state = 29},
  [3168] = {.lex_state = 79, .external_lex_state = 29},
  [3169] = {.lex_state = 222, .external_lex_state = 27},
  [3170] = {.lex_state = 79, .external_lex_state = 29},
  [3171] = {.lex_state = 79, .external_lex_state = 29},
  [3172] = {.lex_state = 94, .external_lex_state = 22},
  [3173] = {.lex_state = 79, .external_lex_state = 29},
  [3174] = {.lex_state = 94, .external_lex_state = 22},
  [3175] = {.lex_state = 222, .external_lex_state = 27},
  [3176] = {.lex_state = 79, .external_lex_state = 29},
  [3177] = {.lex_state = 79, .external_lex_state = 29},
  [3178] = {.lex_state = 94, .external_lex_state = 22},
  [3179] = {.lex_state = 94, .external_lex_state = 28},
  [3180] = {.lex_state = 222, .external_lex_state = 27},
  [3181] = {.lex_state = 94, .external_lex_state = 22},
  [3182] = {.lex_state = 94, .external_lex_state = 22},
  [3183] = {.lex_state = 222, .external_lex_state = 27},
  [3184] = {.lex_state = 222, .external_lex_state = 27},
  [3185] = {.lex_state = 222, .external_lex_state = 27},
  [3186] = {.lex_state = 222, .external_lex_state = 27},
  [3187] = {.lex_state = 222, .external_lex_state = 27},
  [3188] = {.lex_state = 94, .external_lex_state = 22},
  [3189] = {.lex_state = 94, .external_lex_state = 24},
  [3190] = {.lex_state = 75, .external_lex_state = 26},
  [3191] = {.lex_state = 222, .external_lex_state = 27},
  [3192] = {.lex_state = 75, .external_lex_state = 26},
  [3193] = {.lex_state = 75, .external_lex_state = 26},
  [3194] = {.lex_state = 75, .external_lex_state = 26},
  [3195] = {.lex_state = 222, .external_lex_state = 27},
  [3196] = {.lex_state = 94, .external_lex_state = 28},
  [3197] = {.lex_state = 222, .external_lex_state = 27},
  [3198] = {.lex_state = 222, .external_lex_state = 27},
  [3199] = {.lex_state = 222, .external_lex_state = 27},
  [3200] = {.lex_state = 94, .external_lex_state = 24},
  [3201] = {.lex_state = 222, .external_lex_state = 27},
  [3202] = {.lex_state = 222, .external_lex_state = 27},
  [3203] = {.lex_state = 222, .external_lex_state = 27},
  [3204] = {.lex_state = 75, .external_lex_state = 26},
  [3205] = {.lex_state = 75, .external_lex_state = 26},
  [3206] = {.lex_state = 94, .external_lex_state = 24},
  [3207] = {.lex_state = 94, .external_lex_state = 24},
  [3208] = {.lex_state = 94, .external_lex_state = 24},
  [3209] = {.lex_state = 94, .external_lex_state = 24},
  [3210] = {.lex_state = 94, .external_lex_state = 24},
  [3211] = {.lex_state = 94, .external_lex_state = 24},
  [3212] = {.lex_state = 75, .external_lex_state = 26},
  [3213] = {.lex_state = 94, .external_lex_state = 22},
  [3214] = {.lex_state = 94, .external_lex_state = 22},
  [3215] = {.lex_state = 75, .external_lex_state = 26},
  [3216] = {.lex_state = 222, .external_lex_state = 27},
  [3217] = {.lex_state = 75, .external_lex_state = 26},
  [3218] = {.lex_state = 222, .external_lex_state = 27},
  [3219] = {.lex_state = 222, .external_lex_state = 27},
  [3220] = {.lex_state = 222, .external_lex_state = 27},
  [3221] = {.lex_state = 75, .external_lex_state = 26},
  [3222] = {.lex_state = 222, .external_lex_state = 27},
  [3223] = {.lex_state = 222, .external_lex_state = 27},
  [3224] = {.lex_state = 222, .external_lex_state = 27},
  [3225] = {.lex_state = 94, .external_lex_state = 22},
  [3226] = {.lex_state = 94, .external_lex_state = 28},
  [3227] = {.lex_state = 94, .external_lex_state = 22},
  [3228] = {.lex_state = 94, .external_lex_state = 22},
  [3229] = {.lex_state = 222, .external_lex_state = 27},
  [3230] = {.lex_state = 222, .external_lex_state = 27},
  [3231] = {.lex_state = 222, .external_lex_state = 27},
  [3232] = {.lex_state = 222, .external_lex_state = 27},
  [3233] = {.lex_state = 222, .external_lex_state = 27},
  [3234] = {.lex_state = 222, .external_lex_state = 27},
  [3235] = {.lex_state = 222, .external_lex_state = 27},
  [3236] = {.lex_state = 94, .external_lex_state = 24},
  [3237] = {.lex_state = 95, .external_lex_state = 24},
  [3238] = {.lex_state = 222, .external_lex_state = 27},
  [3239] = {.lex_state = 222, .external_lex_state = 27},
  [3240] = {.lex_state = 222, .external_lex_state = 27},
  [3241] = {.lex_state = 222, .external_lex_state = 27},
  [3242] = {.lex_state = 222, .external_lex_state = 27},
  [3243] = {.lex_state = 222, .external_lex_state = 27},
  [3244] = {.lex_state = 94, .external_lex_state = 24},
  [3245] = {.lex_state = 94, .external_lex_state = 24},
  [3246] = {.lex_state = 94, .external_lex_state = 24},
  [3247] = {.lex_state = 94, .external_lex_state = 24},
  [3248] = {.lex_state = 94, .external_lex_state = 24},
  [3249] = {.lex_state = 222, .external_lex_state = 27},
  [3250] = {.lex_state = 94, .external_lex_state = 24},
  [3251] = {.lex_state = 94, .external_lex_state = 24},
  [3252] = {.lex_state = 94, .external_lex_state = 24},
  [3253] = {.lex_state = 94, .external_lex_state = 24},
  [3254] = {.lex_state = 94, .external_lex_state = 24},
  [3255] = {.lex_state = 94, .external_lex_state = 24},
  [3256] = {.lex_state = 94, .external_lex_state = 24},
  [3257] = {.lex_state = 94, .external_lex_state = 24},
  [3258] = {.lex_state = 94, .external_lex_state = 24},
  [3259] = {.lex_state = 94, .external_lex_state = 24},
  [3260] = {.lex_state = 94, .external_lex_state = 24},
  [3261] = {.lex_state = 94, .external_lex_state = 24},
  [3262] = {.lex_state = 94, .external_lex_state = 24},
  [3263] = {.lex_state = 94, .external_lex_state = 24},
  [3264] = {.lex_state = 222, .external_lex_state = 27},
  [3265] = {.lex_state = 94, .external_lex_state = 24},
  [3266] = {.lex_state = 222, .external_lex_state = 27},
  [3267] = {.lex_state = 94, .external_lex_state = 24},
  [3268] = {.lex_state = 222, .external_lex_state = 27},
  [3269] = {.lex_state = 94, .external_lex_state = 24},
  [3270] = {.lex_state = 222, .external_lex_state = 27},
  [3271] = {.lex_state = 94, .external_lex_state = 24},
  [3272] = {.lex_state = 222, .external_lex_state = 27},
  [3273] = {.lex_state = 94, .external_lex_state = 24},
  [3274] = {.lex_state = 94, .external_lex_state = 24},
  [3275] = {.lex_state = 94, .external_lex_state = 24},
  [3276] = {.lex_state = 94, .external_lex_state = 24},
  [3277] = {.lex_state = 222, .external_lex_state = 27},
  [3278] = {.lex_state = 222, .external_lex_state = 27},
  [3279] = {.lex_state = 222, .external_lex_state = 27},
  [3280] = {.lex_state = 222, .external_lex_state = 27},
  [3281] = {.lex_state = 94, .external_lex_state = 22},
  [3282] = {.lex_state = 94, .external_lex_state = 22},
  [3283] = {.lex_state = 94, .external_lex_state = 24},
  [3284] = {.lex_state = 98, .external_lex_state = 27},
  [3285] = {.lex_state = 94, .external_lex_state = 24},
  [3286] = {.lex_state = 98, .external_lex_state = 27},
  [3287] = {.lex_state = 94, .external_lex_state = 24},
  [3288] = {.lex_state = 94, .external_lex_state = 24},
  [3289] = {.lex_state = 94, .external_lex_state = 24},
  [3290] = {.lex_state = 94, .external_lex_state = 24},
  [3291] = {.lex_state = 222, .external_lex_state = 27},
  [3292] = {.lex_state = 222, .external_lex_state = 27},
  [3293] = {.lex_state = 222, .external_lex_state = 27},
  [3294] = {.lex_state = 94, .external_lex_state = 24},
  [3295] = {.lex_state = 94, .external_lex_state = 24},
  [3296] = {.lex_state = 94, .external_lex_state = 24},
  [3297] = {.lex_state = 94, .external_lex_state = 24},
  [3298] = {.lex_state = 94, .external_lex_state = 24},
  [3299] = {.lex_state = 94, .external_lex_state = 24},
  [3300] = {.lex_state = 94, .external_lex_state = 22},
  [3301] = {.lex_state = 94, .external_lex_state = 24},
  [3302] = {.lex_state = 94, .external_lex_state = 24},
  [3303] = {.lex_state = 94, .external_lex_state = 24},
  [3304] = {.lex_state = 94, .external_lex_state = 24},
  [3305] = {.lex_state = 94, .external_lex_state = 24},
  [3306] = {.lex_state = 94, .external_lex_state = 24},
  [3307] = {.lex_state = 94, .external_lex_state = 24},
  [3308] = {.lex_state = 94, .external_lex_state = 24},
  [3309] = {.lex_state = 98, .external_lex_state = 27},
  [3310] = {.lex_state = 94, .external_lex_state = 22},
  [3311] = {.lex_state = 94, .external_lex_state = 22},
  [3312] = {.lex_state = 94, .external_lex_state = 22},
  [3313] = {.lex_state = 94, .external_lex_state = 22},
  [3314] = {.lex_state = 94, .external_lex_state = 22},
  [3315] = {.lex_state = 94, .external_lex_state = 22},
  [3316] = {.lex_state = 94, .external_lex_state = 22},
  [3317] = {.lex_state = 94, .external_lex_state = 22},
  [3318] = {.lex_state = 94, .external_lex_state = 22},
  [3319] = {.lex_state = 94, .external_lex_state = 22},
  [3320] = {.lex_state = 94, .external_lex_state = 22},
  [3321] = {.lex_state = 94, .external_lex_state = 22},
  [3322] = {.lex_state = 94, .external_lex_state = 22},
  [3323] = {.lex_state = 94, .external_lex_state = 22},
  [3324] = {.lex_state = 222, .external_lex_state = 27},
  [3325] = {.lex_state = 94, .external_lex_state = 24},
  [3326] = {.lex_state = 222, .external_lex_state = 27},
  [3327] = {.lex_state = 222, .external_lex_state = 27},
  [3328] = {.lex_state = 222, .external_lex_state = 27},
  [3329] = {.lex_state = 98, .external_lex_state = 27},
  [3330] = {.lex_state = 94, .external_lex_state = 22},
  [3331] = {.lex_state = 94, .external_lex_state = 22},
  [3332] = {.lex_state = 94, .external_lex_state = 22},
  [3333] = {.lex_state = 94, .external_lex_state = 22},
  [3334] = {.lex_state = 94, .external_lex_state = 22},
  [3335] = {.lex_state = 75, .external_lex_state = 29},
  [3336] = {.lex_state = 94, .external_lex_state = 22},
  [3337] = {.lex_state = 222, .external_lex_state = 27},
  [3338] = {.lex_state = 222, .external_lex_state = 27},
  [3339] = {.lex_state = 222, .external_lex_state = 27},
  [3340] = {.lex_state = 222, .external_lex_state = 27},
  [3341] = {.lex_state = 94, .external_lex_state = 24},
  [3342] = {.lex_state = 94, .external_lex_state = 24},
  [3343] = {.lex_state = 94, .external_lex_state = 24},
  [3344] = {.lex_state = 94, .external_lex_state = 24},
  [3345] = {.lex_state = 75, .external_lex_state = 29},
  [3346] = {.lex_state = 222, .external_lex_state = 27},
  [3347] = {.lex_state = 94, .external_lex_state = 24},
  [3348] = {.lex_state = 94, .external_lex_state = 24},
  [3349] = {.lex_state = 94, .external_lex_state = 24},
  [3350] = {.lex_state = 98, .external_lex_state = 27},
  [3351] = {.lex_state = 94, .external_lex_state = 24},
  [3352] = {.lex_state = 94, .external_lex_state = 24},
  [3353] = {.lex_state = 98, .external_lex_state = 27},
  [3354] = {.lex_state = 222, .external_lex_state = 27},
  [3355] = {.lex_state = 94, .external_lex_state = 22},
  [3356] = {.lex_state = 94, .external_lex_state = 22},
  [3357] = {.lex_state = 94, .external_lex_state = 24},
  [3358] = {.lex_state = 94, .external_lex_state = 28},
  [3359] = {.lex_state = 75, .external_lex_state = 29},
  [3360] = {.lex_state = 94, .external_lex_state = 24},
  [3361] = {.lex_state = 222, .external_lex_state = 27},
  [3362] = {.lex_state = 94, .external_lex_state = 24},
  [3363] = {.lex_state = 94, .external_lex_state = 24},
  [3364] = {.lex_state = 98, .external_lex_state = 27},
  [3365] = {.lex_state = 94, .external_lex_state = 24},
  [3366] = {.lex_state = 222, .external_lex_state = 27},
  [3367] = {.lex_state = 94, .external_lex_state = 24},
  [3368] = {.lex_state = 94, .external_lex_state = 24},
  [3369] = {.lex_state = 98, .external_lex_state = 27},
  [3370] = {.lex_state = 94, .external_lex_state = 24},
  [3371] = {.lex_state = 94, .external_lex_state = 24},
  [3372] = {.lex_state = 94, .external_lex_state = 24},
  [3373] = {.lex_state = 94, .external_lex_state = 24},
  [3374] = {.lex_state = 94, .external_lex_state = 24},
  [3375] = {.lex_state = 94, .external_lex_state = 24},
  [3376] = {.lex_state = 94, .external_lex_state = 24},
  [3377] = {.lex_state = 94, .external_lex_state = 22},
  [3378] = {.lex_state = 94, .external_lex_state = 22},
  [3379] = {.lex_state = 98, .external_lex_state = 27},
  [3380] = {.lex_state = 94, .external_lex_state = 24},
  [3381] = {.lex_state = 94, .external_lex_state = 24},
  [3382] = {.lex_state = 94, .external_lex_state = 24},
  [3383] = {.lex_state = 94, .external_lex_state = 24},
  [3384] = {.lex_state = 98, .external_lex_state = 30},
  [3385] = {.lex_state = 94, .external_lex_state = 24},
  [3386] = {.lex_state = 94, .external_lex_state = 24},
  [3387] = {.lex_state = 94, .external_lex_state = 24},
  [3388] = {.lex_state = 94, .external_lex_state = 24},
  [3389] = {.lex_state = 94, .external_lex_state = 24},
  [3390] = {.lex_state = 94, .external_lex_state = 24},
  [3391] = {.lex_state = 94, .external_lex_state = 24},
  [3392] = {.lex_state = 94, .external_lex_state = 24},
  [3393] = {.lex_state = 94, .external_lex_state = 24},
  [3394] = {.lex_state = 94, .external_lex_state = 24},
  [3395] = {.lex_state = 94, .external_lex_state = 24},
  [3396] = {.lex_state = 94, .external_lex_state = 24},
  [3397] = {.lex_state = 94, .external_lex_state = 24},
  [3398] = {.lex_state = 94, .external_lex_state = 24},
  [3399] = {.lex_state = 94, .external_lex_state = 24},
  [3400] = {.lex_state = 94, .external_lex_state = 24},
  [3401] = {.lex_state = 222, .external_lex_state = 27},
  [3402] = {.lex_state = 94, .external_lex_state = 24},
  [3403] = {.lex_state = 94, .external_lex_state = 24},
  [3404] = {.lex_state = 94, .external_lex_state = 24},
  [3405] = {.lex_state = 94, .external_lex_state = 24},
  [3406] = {.lex_state = 94, .external_lex_state = 24},
  [3407] = {.lex_state = 94, .external_lex_state = 24},
  [3408] = {.lex_state = 94, .external_lex_state = 24},
  [3409] = {.lex_state = 94, .external_lex_state = 24},
  [3410] = {.lex_state = 94, .external_lex_state = 24},
  [3411] = {.lex_state = 94, .external_lex_state = 24},
  [3412] = {.lex_state = 94, .external_lex_state = 24},
  [3413] = {.lex_state = 94, .external_lex_state = 24},
  [3414] = {.lex_state = 94, .external_lex_state = 24},
  [3415] = {.lex_state = 101, .external_lex_state = 23},
  [3416] = {.lex_state = 94, .external_lex_state = 24},
  [3417] = {.lex_state = 94, .external_lex_state = 24},
  [3418] = {.lex_state = 101, .external_lex_state = 23},
  [3419] = {.lex_state = 94, .external_lex_state = 28},
  [3420] = {.lex_state = 94, .external_lex_state = 22},
  [3421] = {.lex_state = 94, .external_lex_state = 24},
  [3422] = {.lex_state = 222, .external_lex_state = 27},
  [3423] = {.lex_state = 98, .external_lex_state = 30},
  [3424] = {.lex_state = 94, .external_lex_state = 24},
  [3425] = {.lex_state = 94, .external_lex_state = 22},
  [3426] = {.lex_state = 101, .external_lex_state = 23},
  [3427] = {.lex_state = 94, .external_lex_state = 24},
  [3428] = {.lex_state = 98, .external_lex_state = 30},
  [3429] = {.lex_state = 94, .external_lex_state = 22},
  [3430] = {.lex_state = 94, .external_lex_state = 22},
  [3431] = {.lex_state = 98, .external_lex_state = 27},
  [3432] = {.lex_state = 98, .external_lex_state = 27},
  [3433] = {.lex_state = 98, .external_lex_state = 27},
  [3434] = {.lex_state = 98, .external_lex_state = 27},
  [3435] = {.lex_state = 98, .external_lex_state = 27},
  [3436] = {.lex_state = 98, .external_lex_state = 27},
  [3437] = {.lex_state = 94, .external_lex_state = 24},
  [3438] = {.lex_state = 98, .external_lex_state = 27},
  [3439] = {.lex_state = 98, .external_lex_state = 27},
  [3440] = {.lex_state = 98, .external_lex_state = 27},
  [3441] = {.lex_state = 98, .external_lex_state = 30},
  [3442] = {.lex_state = 222, .external_lex_state = 27},
  [3443] = {.lex_state = 98, .external_lex_state = 27},
  [3444] = {.lex_state = 98, .external_lex_state = 27},
  [3445] = {.lex_state = 98, .external_lex_state = 27},
  [3446] = {.lex_state = 98, .external_lex_state = 27},
  [3447] = {.lex_state = 98, .external_lex_state = 27},
  [3448] = {.lex_state = 98, .external_lex_state = 27},
  [3449] = {.lex_state = 98, .external_lex_state = 27},
  [3450] = {.lex_state = 98, .external_lex_state = 27},
  [3451] = {.lex_state = 98, .external_lex_state = 27},
  [3452] = {.lex_state = 98, .external_lex_state = 27},
  [3453] = {.lex_state = 98, .external_lex_state = 27},
  [3454] = {.lex_state = 98, .external_lex_state = 27},
  [3455] = {.lex_state = 94, .external_lex_state = 22},
  [3456] = {.lex_state = 222, .external_lex_state = 27},
  [3457] = {.lex_state = 94, .external_lex_state = 24},
  [3458] = {.lex_state = 94, .external_lex_state = 22},
  [3459] = {.lex_state = 98, .external_lex_state = 27},
  [3460] = {.lex_state = 222, .external_lex_state = 27},
  [3461] = {.lex_state = 101, .external_lex_state = 23},
  [3462] = {.lex_state = 94, .external_lex_state = 24},
  [3463] = {.lex_state = 98, .external_lex_state = 30},
  [3464] = {.lex_state = 98, .external_lex_state = 27},
  [3465] = {.lex_state = 94, .external_lex_state = 24},
  [3466] = {.lex_state = 98, .external_lex_state = 27},
  [3467] = {.lex_state = 98, .external_lex_state = 27},
  [3468] = {.lex_state = 94, .external_lex_state = 24},
  [3469] = {.lex_state = 94, .external_lex_state = 24},
  [3470] = {.lex_state = 94, .external_lex_state = 24},
  [3471] = {.lex_state = 98, .external_lex_state = 30},
  [3472] = {.lex_state = 94, .external_lex_state = 24},
  [3473] = {.lex_state = 98, .external_lex_state = 30},
  [3474] = {.lex_state = 94, .external_lex_state = 24},
  [3475] = {.lex_state = 94, .external_lex_state = 22},
  [3476] = {.lex_state = 94, .external_lex_state = 24},
  [3477] = {.lex_state = 98, .external_lex_state = 27},
  [3478] = {.lex_state = 101, .external_lex_state = 23},
  [3479] = {.lex_state = 94, .external_lex_state = 24},
  [3480] = {.lex_state = 98, .external_lex_state = 27},
  [3481] = {.lex_state = 98, .external_lex_state = 27},
  [3482] = {.lex_state = 94, .external_lex_state = 22},
  [3483] = {.lex_state = 94, .external_lex_state = 22},
  [3484] = {.lex_state = 98, .external_lex_state = 27},
  [3485] = {.lex_state = 94, .external_lex_state = 22},
  [3486] = {.lex_state = 95, .external_lex_state = 24},
  [3487] = {.lex_state = 95, .external_lex_state = 24},
  [3488] = {.lex_state = 94, .external_lex_state = 22},
  [3489] = {.lex_state = 94, .external_lex_state = 22},
  [3490] = {.lex_state = 94, .external_lex_state = 22},
  [3491] = {.lex_state = 94, .external_lex_state = 22},
  [3492] = {.lex_state = 98, .external_lex_state = 27},
  [3493] = {.lex_state = 94, .external_lex_state = 24},
  [3494] = {.lex_state = 94, .external_lex_state = 22},
  [3495] = {.lex_state = 98, .external_lex_state = 27},
  [3496] = {.lex_state = 94, .external_lex_state = 22},
  [3497] = {.lex_state = 95, .external_lex_state = 28},
  [3498] = {.lex_state = 98, .external_lex_state = 27},
  [3499] = {.lex_state = 98, .external_lex_state = 27},
  [3500] = {.lex_state = 94, .external_lex_state = 24},
  [3501] = {.lex_state = 98, .external_lex_state = 27},
  [3502] = {.lex_state = 98, .external_lex_state = 27},
  [3503] = {.lex_state = 94, .external_lex_state = 22},
  [3504] = {.lex_state = 94, .external_lex_state = 24},
  [3505] = {.lex_state = 98, .external_lex_state = 27},
  [3506] = {.lex_state = 98, .external_lex_state = 27},
  [3507] = {.lex_state = 98, .external_lex_state = 27},
  [3508] = {.lex_state = 98, .external_lex_state = 27},
  [3509] = {.lex_state = 94, .external_lex_state = 24},
  [3510] = {.lex_state = 98, .external_lex_state = 27},
  [3511] = {.lex_state = 98, .external_lex_state = 27},
  [3512] = {.lex_state = 98, .external_lex_state = 27},
  [3513] = {.lex_state = 94, .external_lex_state = 22},
  [3514] = {.lex_state = 94, .external_lex_state = 22},
  [3515] = {.lex_state = 98, .external_lex_state = 27},
  [3516] = {.lex_state = 95, .external_lex_state = 28},
  [3517] = {.lex_state = 94, .external_lex_state = 22},
  [3518] = {.lex_state = 222, .external_lex_state = 27},
  [3519] = {.lex_state = 98, .external_lex_state = 27},
  [3520] = {.lex_state = 98, .external_lex_state = 27},
  [3521] = {.lex_state = 98, .external_lex_state = 27},
  [3522] = {.lex_state = 94, .external_lex_state = 22},
  [3523] = {.lex_state = 98, .external_lex_state = 27},
  [3524] = {.lex_state = 98, .external_lex_state = 27},
  [3525] = {.lex_state = 98, .external_lex_state = 27},
  [3526] = {.lex_state = 98, .external_lex_state = 27},
  [3527] = {.lex_state = 98, .external_lex_state = 27},
  [3528] = {.lex_state = 98, .external_lex_state = 27},
  [3529] = {.lex_state = 94, .external_lex_state = 22},
  [3530] = {.lex_state = 94, .external_lex_state = 22},
  [3531] = {.lex_state = 94, .external_lex_state = 22},
  [3532] = {.lex_state = 94, .external_lex_state = 22},
  [3533] = {.lex_state = 94, .external_lex_state = 22},
  [3534] = {.lex_state = 94, .external_lex_state = 22},
  [3535] = {.lex_state = 98, .external_lex_state = 27},
  [3536] = {.lex_state = 94, .external_lex_state = 22},
  [3537] = {.lex_state = 94, .external_lex_state = 22},
  [3538] = {.lex_state = 94, .external_lex_state = 22},
  [3539] = {.lex_state = 94, .external_lex_state = 24},
  [3540] = {.lex_state = 94, .external_lex_state = 24},
  [3541] = {.lex_state = 95, .external_lex_state = 28},
  [3542] = {.lex_state = 98, .external_lex_state = 27},
  [3543] = {.lex_state = 94, .external_lex_state = 22},
  [3544] = {.lex_state = 94, .external_lex_state = 22},
  [3545] = {.lex_state = 94, .external_lex_state = 22},
  [3546] = {.lex_state = 98, .external_lex_state = 27},
  [3547] = {.lex_state = 94, .external_lex_state = 22},
  [3548] = {.lex_state = 98, .external_lex_state = 27},
  [3549] = {.lex_state = 98, .external_lex_state = 27},
  [3550] = {.lex_state = 98, .external_lex_state = 30},
  [3551] = {.lex_state = 98, .external_lex_state = 30},
  [3552] = {.lex_state = 98, .external_lex_state = 30},
  [3553] = {.lex_state = 98, .external_lex_state = 27},
  [3554] = {.lex_state = 98, .external_lex_state = 30},
  [3555] = {.lex_state = 98, .external_lex_state = 30},
  [3556] = {.lex_state = 94, .external_lex_state = 22},
  [3557] = {.lex_state = 98, .external_lex_state = 30},
  [3558] = {.lex_state = 98, .external_lex_state = 30},
  [3559] = {.lex_state = 98, .external_lex_state = 27},
  [3560] = {.lex_state = 98, .external_lex_state = 30},
  [3561] = {.lex_state = 98, .external_lex_state = 30},
  [3562] = {.lex_state = 94, .external_lex_state = 24},
  [3563] = {.lex_state = 94, .external_lex_state = 24},
  [3564] = {.lex_state = 94, .external_lex_state = 22},
  [3565] = {.lex_state = 94, .external_lex_state = 24},
  [3566] = {.lex_state = 94, .external_lex_state = 22},
  [3567] = {.lex_state = 94, .external_lex_state = 22},
  [3568] = {.lex_state = 94, .external_lex_state = 22},
  [3569] = {.lex_state = 94, .external_lex_state = 22},
  [3570] = {.lex_state = 94, .external_lex_state = 22},
  [3571] = {.lex_state = 94, .external_lex_state = 22},
  [3572] = {.lex_state = 94, .external_lex_state = 22},
  [3573] = {.lex_state = 94, .external_lex_state = 22},
  [3574] = {.lex_state = 94, .external_lex_state = 22},
  [3575] = {.lex_state = 94, .external_lex_state = 22},
  [3576] = {.lex_state = 94, .external_lex_state = 24},
  [3577] = {.lex_state = 94, .external_lex_state = 22},
  [3578] = {.lex_state = 94, .external_lex_state = 28},
  [3579] = {.lex_state = 94, .external_lex_state = 22},
  [3580] = {.lex_state = 94, .external_lex_state = 22},
  [3581] = {.lex_state = 94, .external_lex_state = 24},
  [3582] = {.lex_state = 98, .external_lex_state = 30},
  [3583] = {.lex_state = 94, .external_lex_state = 22},
  [3584] = {.lex_state = 94, .external_lex_state = 22},
  [3585] = {.lex_state = 94, .external_lex_state = 22},
  [3586] = {.lex_state = 94, .external_lex_state = 22},
  [3587] = {.lex_state = 94, .external_lex_state = 22},
  [3588] = {.lex_state = 94, .external_lex_state = 22},
  [3589] = {.lex_state = 98, .external_lex_state = 27},
  [3590] = {.lex_state = 98, .external_lex_state = 27},
  [3591] = {.lex_state = 98, .external_lex_state = 27},
  [3592] = {.lex_state = 98, .external_lex_state = 27},
  [3593] = {.lex_state = 98, .external_lex_state = 27},
  [3594] = {.lex_state = 94, .external_lex_state = 22},
  [3595] = {.lex_state = 94, .external_lex_state = 22},
  [3596] = {.lex_state = 94, .external_lex_state = 22},
  [3597] = {.lex_state = 98, .external_lex_state = 27},
  [3598] = {.lex_state = 98, .external_lex_state = 30},
  [3599] = {.lex_state = 98, .external_lex_state = 30},
  [3600] = {.lex_state = 94, .external_lex_state = 22},
  [3601] = {.lex_state = 94, .external_lex_state = 22},
  [3602] = {.lex_state = 94, .external_lex_state = 22},
  [3603] = {.lex_state = 95, .external_lex_state = 24},
  [3604] = {.lex_state = 95, .external_lex_state = 24},
  [3605] = {.lex_state = 94, .external_lex_state = 24},
  [3606] = {.lex_state = 98, .external_lex_state = 27},
  [3607] = {.lex_state = 98, .external_lex_state = 27},
  [3608] = {.lex_state = 94, .external_lex_state = 24},
  [3609] = {.lex_state = 98, .external_lex_state = 30},
  [3610] = {.lex_state = 94, .external_lex_state = 24},
  [3611] = {.lex_state = 98, .external_lex_state = 30},
  [3612] = {.lex_state = 98, .external_lex_state = 27},
  [3613] = {.lex_state = 98, .external_lex_state = 27},
  [3614] = {.lex_state = 98, .external_lex_state = 27},
  [3615] = {.lex_state = 98, .external_lex_state = 27},
  [3616] = {.lex_state = 98, .external_lex_state = 30},
  [3617] = {.lex_state = 98, .external_lex_state = 27},
  [3618] = {.lex_state = 98, .external_lex_state = 27},
  [3619] = {.lex_state = 98, .external_lex_state = 27},
  [3620] = {.lex_state = 98, .external_lex_state = 30},
  [3621] = {.lex_state = 98, .external_lex_state = 30},
  [3622] = {.lex_state = 98, .external_lex_state = 30},
  [3623] = {.lex_state = 98, .external_lex_state = 27},
  [3624] = {.lex_state = 98, .external_lex_state = 30},
  [3625] = {.lex_state = 98, .external_lex_state = 30},
  [3626] = {.lex_state = 98, .external_lex_state = 30},
  [3627] = {.lex_state = 94, .external_lex_state = 24},
  [3628] = {.lex_state = 98, .external_lex_state = 27},
  [3629] = {.lex_state = 94, .external_lex_state = 24},
  [3630] = {.lex_state = 98, .external_lex_state = 27},
  [3631] = {.lex_state = 98, .external_lex_state = 27},
  [3632] = {.lex_state = 98, .external_lex_state = 27},
  [3633] = {.lex_state = 98, .external_lex_state = 27},
  [3634] = {.lex_state = 98, .external_lex_state = 27},
  [3635] = {.lex_state = 98, .external_lex_state = 30},
  [3636] = {.lex_state = 98, .external_lex_state = 30},
  [3637] = {.lex_state = 98, .external_lex_state = 27},
  [3638] = {.lex_state = 98, .external_lex_state = 27},
  [3639] = {.lex_state = 98, .external_lex_state = 27},
  [3640] = {.lex_state = 98, .external_lex_state = 27},
  [3641] = {.lex_state = 94, .external_lex_state = 24},
  [3642] = {.lex_state = 98, .external_lex_state = 27},
  [3643] = {.lex_state = 95, .external_lex_state = 28},
  [3644] = {.lex_state = 98, .external_lex_state = 27},
  [3645] = {.lex_state = 98, .external_lex_state = 27},
  [3646] = {.lex_state = 98, .external_lex_state = 30},
  [3647] = {.lex_state = 98, .external_lex_state = 27},
  [3648] = {.lex_state = 98, .external_lex_state = 30},
  [3649] = {.lex_state = 98, .external_lex_state = 27},
  [3650] = {.lex_state = 98, .external_lex_state = 27},
  [3651] = {.lex_state = 98, .external_lex_state = 30},
  [3652] = {.lex_state = 98, .external_lex_state = 30},
  [3653] = {.lex_state = 115, .external_lex_state = 31},
  [3654] = {.lex_state = 98, .external_lex_state = 30},
  [3655] = {.lex_state = 98, .external_lex_state = 30},
  [3656] = {.lex_state = 95, .external_lex_state = 24},
  [3657] = {.lex_state = 95, .external_lex_state = 24},
  [3658] = {.lex_state = 98, .external_lex_state = 30},
  [3659] = {.lex_state = 98, .external_lex_state = 30},
  [3660] = {.lex_state = 95, .external_lex_state = 24},
  [3661] = {.lex_state = 98, .external_lex_state = 27},
  [3662] = {.lex_state = 98, .external_lex_state = 30},
  [3663] = {.lex_state = 98, .external_lex_state = 30},
  [3664] = {.lex_state = 98, .external_lex_state = 30},
  [3665] = {.lex_state = 98, .external_lex_state = 30},
  [3666] = {.lex_state = 98, .external_lex_state = 27},
  [3667] = {.lex_state = 98, .external_lex_state = 30},
  [3668] = {.lex_state = 98, .external_lex_state = 30},
  [3669] = {.lex_state = 98, .external_lex_state = 27},
  [3670] = {.lex_state = 98, .external_lex_state = 30},
  [3671] = {.lex_state = 94, .external_lex_state = 22},
  [3672] = {.lex_state = 94, .external_lex_state = 22},
  [3673] = {.lex_state = 94, .external_lex_state = 22},
  [3674] = {.lex_state = 94, .external_lex_state = 22},
  [3675] = {.lex_state = 94, .external_lex_state = 22},
  [3676] = {.lex_state = 98, .external_lex_state = 30},
  [3677] = {.lex_state = 98, .external_lex_state = 30},
  [3678] = {.lex_state = 95, .external_lex_state = 24},
  [3679] = {.lex_state = 94, .external_lex_state = 24},
  [3680] = {.lex_state = 94, .external_lex_state = 24},
  [3681] = {.lex_state = 94, .external_lex_state = 24},
  [3682] = {.lex_state = 94, .external_lex_state = 22},
  [3683] = {.lex_state = 94, .external_lex_state = 24},
  [3684] = {.lex_state = 94, .external_lex_state = 24},
  [3685] = {.lex_state = 94, .external_lex_state = 24},
  [3686] = {.lex_state = 94, .external_lex_state = 24},
  [3687] = {.lex_state = 94, .external_lex_state = 24},
  [3688] = {.lex_state = 94, .external_lex_state = 24},
  [3689] = {.lex_state = 98, .external_lex_state = 30},
  [3690] = {.lex_state = 98, .external_lex_state = 30},
  [3691] = {.lex_state = 98, .external_lex_state = 30},
  [3692] = {.lex_state = 94, .external_lex_state = 22},
  [3693] = {.lex_state = 98, .external_lex_state = 30},
  [3694] = {.lex_state = 98, .external_lex_state = 30},
  [3695] = {.lex_state = 98, .external_lex_state = 30},
  [3696] = {.lex_state = 98, .external_lex_state = 30},
  [3697] = {.lex_state = 98, .external_lex_state = 30},
  [3698] = {.lex_state = 98, .external_lex_state = 30},
  [3699] = {.lex_state = 98, .external_lex_state = 30},
  [3700] = {.lex_state = 94, .external_lex_state = 24},
  [3701] = {.lex_state = 98, .external_lex_state = 30},
  [3702] = {.lex_state = 98, .external_lex_state = 30},
  [3703] = {.lex_state = 98, .external_lex_state = 30},
  [3704] = {.lex_state = 98, .external_lex_state = 27},
  [3705] = {.lex_state = 94, .external_lex_state = 24},
  [3706] = {.lex_state = 98, .external_lex_state = 27},
  [3707] = {.lex_state = 94, .external_lex_state = 24},
  [3708] = {.lex_state = 94, .external_lex_state = 24},
  [3709] = {.lex_state = 94, .external_lex_state = 22},
  [3710] = {.lex_state = 94, .external_lex_state = 24},
  [3711] = {.lex_state = 98, .external_lex_state = 27},
  [3712] = {.lex_state = 94, .external_lex_state = 24},
  [3713] = {.lex_state = 94, .external_lex_state = 22},
  [3714] = {.lex_state = 94, .external_lex_state = 22},
  [3715] = {.lex_state = 94, .external_lex_state = 22},
  [3716] = {.lex_state = 94, .external_lex_state = 22},
  [3717] = {.lex_state = 94, .external_lex_state = 22},
  [3718] = {.lex_state = 94, .external_lex_state = 22},
  [3719] = {.lex_state = 94, .external_lex_state = 22},
  [3720] = {.lex_state = 94, .external_lex_state = 22},
  [3721] = {.lex_state = 94, .external_lex_state = 22},
  [3722] = {.lex_state = 94, .external_lex_state = 22},
  [3723] = {.lex_state = 94, .external_lex_state = 22},
  [3724] = {.lex_state = 94, .external_lex_state = 22},
  [3725] = {.lex_state = 94, .external_lex_state = 22},
  [3726] = {.lex_state = 94, .external_lex_state = 22},
  [3727] = {.lex_state = 94, .external_lex_state = 24},
  [3728] = {.lex_state = 94, .external_lex_state = 24},
  [3729] = {.lex_state = 115, .external_lex_state = 31},
  [3730] = {.lex_state = 95, .external_lex_state = 24},
  [3731] = {.lex_state = 98, .external_lex_state = 30},
  [3732] = {.lex_state = 98, .external_lex_state = 30},
  [3733] = {.lex_state = 98, .external_lex_state = 30},
  [3734] = {.lex_state = 98, .external_lex_state = 30},
  [3735] = {.lex_state = 98, .external_lex_state = 30},
  [3736] = {.lex_state = 98, .external_lex_state = 30},
  [3737] = {.lex_state = 98, .external_lex_state = 30},
  [3738] = {.lex_state = 98, .external_lex_state = 30},
  [3739] = {.lex_state = 98, .external_lex_state = 30},
  [3740] = {.lex_state = 98, .external_lex_state = 30},
  [3741] = {.lex_state = 98, .external_lex_state = 30},
  [3742] = {.lex_state = 98, .external_lex_state = 30},
  [3743] = {.lex_state = 98, .external_lex_state = 30},
  [3744] = {.lex_state = 98, .external_lex_state = 30},
  [3745] = {.lex_state = 95, .external_lex_state = 28},
  [3746] = {.lex_state = 98, .external_lex_state = 30},
  [3747] = {.lex_state = 94, .external_lex_state = 24},
  [3748] = {.lex_state = 98, .external_lex_state = 30},
  [3749] = {.lex_state = 94, .external_lex_state = 24},
  [3750] = {.lex_state = 94, .external_lex_state = 24},
  [3751] = {.lex_state = 98, .external_lex_state = 30},
  [3752] = {.lex_state = 94, .external_lex_state = 24},
  [3753] = {.lex_state = 94, .external_lex_state = 22},
  [3754] = {.lex_state = 98, .external_lex_state = 30},
  [3755] = {.lex_state = 94, .external_lex_state = 24},
  [3756] = {.lex_state = 94, .external_lex_state = 24},
  [3757] = {.lex_state = 95, .external_lex_state = 24},
  [3758] = {.lex_state = 98, .external_lex_state = 30},
  [3759] = {.lex_state = 94, .external_lex_state = 22},
  [3760] = {.lex_state = 94, .external_lex_state = 22},
  [3761] = {.lex_state = 98, .external_lex_state = 30},
  [3762] = {.lex_state = 98, .external_lex_state = 30},
  [3763] = {.lex_state = 94, .external_lex_state = 22},
  [3764] = {.lex_state = 98, .external_lex_state = 30},
  [3765] = {.lex_state = 98, .external_lex_state = 30},
  [3766] = {.lex_state = 98, .external_lex_state = 30},
  [3767] = {.lex_state = 94, .external_lex_state = 24},
  [3768] = {.lex_state = 98, .external_lex_state = 30},
  [3769] = {.lex_state = 95, .external_lex_state = 24},
  [3770] = {.lex_state = 94, .external_lex_state = 24},
  [3771] = {.lex_state = 98, .external_lex_state = 30},
  [3772] = {.lex_state = 95, .external_lex_state = 24},
  [3773] = {.lex_state = 98, .external_lex_state = 27},
  [3774] = {.lex_state = 94, .external_lex_state = 24},
  [3775] = {.lex_state = 94, .external_lex_state = 24},
  [3776] = {.lex_state = 94, .external_lex_state = 22},
  [3777] = {.lex_state = 95, .external_lex_state = 24},
  [3778] = {.lex_state = 95, .external_lex_state = 24},
  [3779] = {.lex_state = 95, .external_lex_state = 24},
  [3780] = {.lex_state = 95, .external_lex_state = 24},
  [3781] = {.lex_state = 94, .external_lex_state = 24},
  [3782] = {.lex_state = 94, .external_lex_state = 24},
  [3783] = {.lex_state = 94, .external_lex_state = 24},
  [3784] = {.lex_state = 94, .external_lex_state = 24},
  [3785] = {.lex_state = 95, .external_lex_state = 24},
  [3786] = {.lex_state = 95, .external_lex_state = 24},
  [3787] = {.lex_state = 95, .external_lex_state = 24},
  [3788] = {.lex_state = 95, .external_lex_state = 24},
  [3789] = {.lex_state = 94, .external_lex_state = 24},
  [3790] = {.lex_state = 95, .external_lex_state = 24},
  [3791] = {.lex_state = 98, .external_lex_state = 27},
  [3792] = {.lex_state = 98, .external_lex_state = 30},
  [3793] = {.lex_state = 95, .external_lex_state = 24},
  [3794] = {.lex_state = 98, .external_lex_state = 30},
  [3795] = {.lex_state = 94, .external_lex_state = 22},
  [3796] = {.lex_state = 95, .external_lex_state = 24},
  [3797] = {.lex_state = 94, .external_lex_state = 24},
  [3798] = {.lex_state = 94, .external_lex_state = 22},
  [3799] = {.lex_state = 95, .external_lex_state = 24},
  [3800] = {.lex_state = 95, .external_lex_state = 24},
  [3801] = {.lex_state = 95, .external_lex_state = 24},
  [3802] = {.lex_state = 98, .external_lex_state = 30},
  [3803] = {.lex_state = 94, .external_lex_state = 22},
  [3804] = {.lex_state = 94, .external_lex_state = 24},
  [3805] = {.lex_state = 95, .external_lex_state = 24},
  [3806] = {.lex_state = 94, .external_lex_state = 22},
  [3807] = {.lex_state = 94, .external_lex_state = 22},
  [3808] = {.lex_state = 98, .external_lex_state = 30},
  [3809] = {.lex_state = 94, .external_lex_state = 24},
  [3810] = {.lex_state = 98, .external_lex_state = 30},
  [3811] = {.lex_state = 94, .external_lex_state = 24},
  [3812] = {.lex_state = 95, .external_lex_state = 24},
  [3813] = {.lex_state = 98, .external_lex_state = 27},
  [3814] = {.lex_state = 98, .external_lex_state = 30},
  [3815] = {.lex_state = 98, .external_lex_state = 30},
  [3816] = {.lex_state = 94, .external_lex_state = 24},
  [3817] = {.lex_state = 98, .external_lex_state = 30},
  [3818] = {.lex_state = 98, .external_lex_state = 30},
  [3819] = {.lex_state = 98, .external_lex_state = 30},
  [3820] = {.lex_state = 94, .external_lex_state = 24},
  [3821] = {.lex_state = 95, .external_lex_state = 24},
  [3822] = {.lex_state = 98, .external_lex_state = 30},
  [3823] = {.lex_state = 95, .external_lex_state = 24},
  [3824] = {.lex_state = 94, .external_lex_state = 24},
  [3825] = {.lex_state = 98, .external_lex_state = 30},
  [3826] = {.lex_state = 98, .external_lex_state = 30},
  [3827] = {.lex_state = 98, .external_lex_state = 30},
  [3828] = {.lex_state = 94, .external_lex_state = 22},
  [3829] = {.lex_state = 94, .external_lex_state = 24},
  [3830] = {.lex_state = 98, .external_lex_state = 27},
  [3831] = {.lex_state = 98, .external_lex_state = 30},
  [3832] = {.lex_state = 98, .external_lex_state = 30},
  [3833] = {.lex_state = 95, .external_lex_state = 24},
  [3834] = {.lex_state = 94, .external_lex_state = 22},
  [3835] = {.lex_state = 94, .external_lex_state = 22},
  [3836] = {.lex_state = 98, .external_lex_state = 30},
  [3837] = {.lex_state = 94, .external_lex_state = 22},
  [3838] = {.lex_state = 98, .external_lex_state = 30},
  [3839] = {.lex_state = 94, .external_lex_state = 24},
  [3840] = {.lex_state = 98, .external_lex_state = 30},
  [3841] = {.lex_state = 95, .external_lex_state = 24},
  [3842] = {.lex_state = 95, .external_lex_state = 24},
  [3843] = {.lex_state = 95, .external_lex_state = 24},
  [3844] = {.lex_state = 95, .external_lex_state = 24},
  [3845] = {.lex_state = 98, .external_lex_state = 30},
  [3846] = {.lex_state = 94, .external_lex_state = 22},
  [3847] = {.lex_state = 98, .external_lex_state = 30},
  [3848] = {.lex_state = 94, .external_lex_state = 22},
  [3849] = {.lex_state = 98, .external_lex_state = 30},
  [3850] = {.lex_state = 98, .external_lex_state = 30},
  [3851] = {.lex_state = 98, .external_lex_state = 30},
  [3852] = {.lex_state = 94, .external_lex_state = 22},
  [3853] = {.lex_state = 98, .external_lex_state = 30},
  [3854] = {.lex_state = 98, .external_lex_state = 30},
  [3855] = {.lex_state = 95, .external_lex_state = 24},
  [3856] = {.lex_state = 95, .external_lex_state = 24},
  [3857] = {.lex_state = 98, .external_lex_state = 30},
  [3858] = {.lex_state = 98, .external_lex_state = 30},
  [3859] = {.lex_state = 98, .external_lex_state = 30},
  [3860] = {.lex_state = 98, .external_lex_state = 30},
  [3861] = {.lex_state = 95, .external_lex_state = 24},
  [3862] = {.lex_state = 94, .external_lex_state = 22},
  [3863] = {.lex_state = 98, .external_lex_state = 30},
  [3864] = {.lex_state = 98, .external_lex_state = 30},
  [3865] = {.lex_state = 94, .external_lex_state = 24},
  [3866] = {.lex_state = 95, .external_lex_state = 24},
  [3867] = {.lex_state = 98, .external_lex_state = 30},
  [3868] = {.lex_state = 95, .external_lex_state = 24},
  [3869] = {.lex_state = 94, .external_lex_state = 24},
  [3870] = {.lex_state = 98, .external_lex_state = 27},
  [3871] = {.lex_state = 98, .external_lex_state = 30},
  [3872] = {.lex_state = 98, .external_lex_state = 30},
  [3873] = {.lex_state = 94, .external_lex_state = 24},
  [3874] = {.lex_state = 98, .external_lex_state = 27},
  [3875] = {.lex_state = 95, .external_lex_state = 24},
  [3876] = {.lex_state = 98, .external_lex_state = 30},
  [3877] = {.lex_state = 98, .external_lex_state = 30},
  [3878] = {.lex_state = 94, .external_lex_state = 22},
  [3879] = {.lex_state = 98, .external_lex_state = 30},
  [3880] = {.lex_state = 94, .external_lex_state = 22},
  [3881] = {.lex_state = 98, .external_lex_state = 30},
  [3882] = {.lex_state = 98, .external_lex_state = 30},
  [3883] = {.lex_state = 94, .external_lex_state = 22},
  [3884] = {.lex_state = 98, .external_lex_state = 30},
  [3885] = {.lex_state = 94, .external_lex_state = 22},
  [3886] = {.lex_state = 94, .external_lex_state = 22},
  [3887] = {.lex_state = 94, .external_lex_state = 22},
  [3888] = {.lex_state = 98, .external_lex_state = 30},
  [3889] = {.lex_state = 98, .external_lex_state = 30},
  [3890] = {.lex_state = 95, .external_lex_state = 24},
  [3891] = {.lex_state = 98, .external_lex_state = 30},
  [3892] = {.lex_state = 98, .external_lex_state = 27},
  [3893] = {.lex_state = 95, .external_lex_state = 24},
  [3894] = {.lex_state = 95, .external_lex_state = 24},
  [3895] = {.lex_state = 95, .external_lex_state = 24},
  [3896] = {.lex_state = 95, .external_lex_state = 24},
  [3897] = {.lex_state = 98, .external_lex_state = 30},
  [3898] = {.lex_state = 98, .external_lex_state = 27},
  [3899] = {.lex_state = 98, .external_lex_state = 30},
  [3900] = {.lex_state = 98, .external_lex_state = 27},
  [3901] = {.lex_state = 95, .external_lex_state = 24},
  [3902] = {.lex_state = 95, .external_lex_state = 24},
  [3903] = {.lex_state = 95, .external_lex_state = 24},
  [3904] = {.lex_state = 95, .external_lex_state = 24},
  [3905] = {.lex_state = 95, .external_lex_state = 24},
  [3906] = {.lex_state = 98, .external_lex_state = 27},
  [3907] = {.lex_state = 98, .external_lex_state = 27},
  [3908] = {.lex_state = 98, .external_lex_state = 27},
  [3909] = {.lex_state = 98, .external_lex_state = 27},
  [3910] = {.lex_state = 98, .external_lex_state = 27},
  [3911] = {.lex_state = 95, .external_lex_state = 24},
  [3912] = {.lex_state = 95, .external_lex_state = 24},
  [3913] = {.lex_state = 98, .external_lex_state = 30},
  [3914] = {.lex_state = 98, .external_lex_state = 30},
  [3915] = {.lex_state = 95, .external_lex_state = 24},
  [3916] = {.lex_state = 98, .external_lex_state = 27},
  [3917] = {.lex_state = 95, .external_lex_state = 24},
  [3918] = {.lex_state = 95, .external_lex_state = 24},
  [3919] = {.lex_state = 95, .external_lex_state = 24},
  [3920] = {.lex_state = 98, .external_lex_state = 27},
  [3921] = {.lex_state = 95, .external_lex_state = 24},
  [3922] = {.lex_state = 95, .external_lex_state = 24},
  [3923] = {.lex_state = 95, .external_lex_state = 24},
  [3924] = {.lex_state = 98, .external_lex_state = 27},
  [3925] = {.lex_state = 98, .external_lex_state = 30},
  [3926] = {.lex_state = 98, .external_lex_state = 27},
  [3927] = {.lex_state = 95, .external_lex_state = 24},
  [3928] = {.lex_state = 95, .external_lex_state = 24},
  [3929] = {.lex_state = 95, .external_lex_state = 24},
  [3930] = {.lex_state = 95, .external_lex_state = 24},
  [3931] = {.lex_state = 95, .external_lex_state = 24},
  [3932] = {.lex_state = 98, .external_lex_state = 30},
  [3933] = {.lex_state = 98, .external_lex_state = 27},
  [3934] = {.lex_state = 98, .external_lex_state = 27},
  [3935] = {.lex_state = 98, .external_lex_state = 30},
  [3936] = {.lex_state = 98, .external_lex_state = 27},
  [3937] = {.lex_state = 98, .external_lex_state = 27},
  [3938] = {.lex_state = 95, .external_lex_state = 24},
  [3939] = {.lex_state = 98, .external_lex_state = 30},
  [3940] = {.lex_state = 98, .external_lex_state = 27},
  [3941] = {.lex_state = 98, .external_lex_state = 30},
  [3942] = {.lex_state = 95, .external_lex_state = 24},
  [3943] = {.lex_state = 95, .external_lex_state = 24},
  [3944] = {.lex_state = 95, .external_lex_state = 24},
  [3945] = {.lex_state = 95, .external_lex_state = 24},
  [3946] = {.lex_state = 98, .external_lex_state = 30},
  [3947] = {.lex_state = 98, .external_lex_state = 27},
  [3948] = {.lex_state = 98, .external_lex_state = 27},
  [3949] = {.lex_state = 98, .external_lex_state = 27},
  [3950] = {.lex_state = 98, .external_lex_state = 30},
  [3951] = {.lex_state = 98, .external_lex_state = 27},
  [3952] = {.lex_state = 98, .external_lex_state = 27},
  [3953] = {.lex_state = 98, .external_lex_state = 27},
  [3954] = {.lex_state = 98, .external_lex_state = 27},
  [3955] = {.lex_state = 95, .external_lex_state = 24},
  [3956] = {.lex_state = 98, .external_lex_state = 27},
  [3957] = {.lex_state = 95, .external_lex_state = 24},
  [3958] = {.lex_state = 98, .external_lex_state = 30},
  [3959] = {.lex_state = 95, .external_lex_state = 24},
  [3960] = {.lex_state = 95, .external_lex_state = 24},
  [3961] = {.lex_state = 98, .external_lex_state = 27},
  [3962] = {.lex_state = 98, .external_lex_state = 30},
  [3963] = {.lex_state = 98, .external_lex_state = 27},
  [3964] = {.lex_state = 95, .external_lex_state = 24},
  [3965] = {.lex_state = 95, .external_lex_state = 24},
  [3966] = {.lex_state = 98, .external_lex_state = 30},
  [3967] = {.lex_state = 98, .external_lex_state = 27},
  [3968] = {.lex_state = 98, .external_lex_state = 30},
  [3969] = {.lex_state = 95, .external_lex_state = 24},
  [3970] = {.lex_state = 98, .external_lex_state = 27},
  [3971] = {.lex_state = 98, .external_lex_state = 27},
  [3972] = {.lex_state = 98, .external_lex_state = 27},
  [3973] = {.lex_state = 95, .external_lex_state = 24},
  [3974] = {.lex_state = 98, .external_lex_state = 27},
  [3975] = {.lex_state = 95, .external_lex_state = 24},
  [3976] = {.lex_state = 95, .external_lex_state = 24},
  [3977] = {.lex_state = 98, .external_lex_state = 27},
  [3978] = {.lex_state = 95, .external_lex_state = 24},
  [3979] = {.lex_state = 95, .external_lex_state = 24},
  [3980] = {.lex_state = 95, .external_lex_state = 24},
  [3981] = {.lex_state = 95, .external_lex_state = 24},
  [3982] = {.lex_state = 95, .external_lex_state = 24},
  [3983] = {.lex_state = 98, .external_lex_state = 30},
  [3984] = {.lex_state = 95, .external_lex_state = 24},
  [3985] = {.lex_state = 95, .external_lex_state = 24},
  [3986] = {.lex_state = 95, .external_lex_state = 24},
  [3987] = {.lex_state = 98, .external_lex_state = 27},
  [3988] = {.lex_state = 98, .external_lex_state = 27},
  [3989] = {.lex_state = 95, .external_lex_state = 24},
  [3990] = {.lex_state = 98, .external_lex_state = 27},
  [3991] = {.lex_state = 95, .external_lex_state = 24},
  [3992] = {.lex_state = 98, .external_lex_state = 30},
  [3993] = {.lex_state = 98, .external_lex_state = 27},
  [3994] = {.lex_state = 95, .external_lex_state = 24},
  [3995] = {.lex_state = 98, .external_lex_state = 30},
  [3996] = {.lex_state = 98, .external_lex_state = 27},
  [3997] = {.lex_state = 98, .external_lex_state = 27},
  [3998] = {.lex_state = 98, .external_lex_state = 27},
  [3999] = {.lex_state = 98, .external_lex_state = 27},
  [4000] = {.lex_state = 98, .external_lex_state = 27},
  [4001] = {.lex_state = 98, .external_lex_state = 27},
  [4002] = {.lex_state = 95, .external_lex_state = 24},
  [4003] = {.lex_state = 95, .external_lex_state = 24},
  [4004] = {.lex_state = 95, .external_lex_state = 24},
  [4005] = {.lex_state = 98, .external_lex_state = 27},
  [4006] = {.lex_state = 98, .external_lex_state = 27},
  [4007] = {.lex_state = 98, .external_lex_state = 27},
  [4008] = {.lex_state = 98, .external_lex_state = 27},
  [4009] = {.lex_state = 95, .external_lex_state = 24},
  [4010] = {.lex_state = 95, .external_lex_state = 24},
  [4011] = {.lex_state = 98, .external_lex_state = 27},
  [4012] = {.lex_state = 95, .external_lex_state = 24},
  [4013] = {.lex_state = 95, .external_lex_state = 24},
  [4014] = {.lex_state = 95, .external_lex_state = 24},
  [4015] = {.lex_state = 98, .external_lex_state = 30},
  [4016] = {.lex_state = 98, .external_lex_state = 27},
  [4017] = {.lex_state = 95, .external_lex_state = 24},
  [4018] = {.lex_state = 98, .external_lex_state = 27},
  [4019] = {.lex_state = 98, .external_lex_state = 27},
  [4020] = {.lex_state = 95, .external_lex_state = 24},
  [4021] = {.lex_state = 95, .external_lex_state = 24},
  [4022] = {.lex_state = 95, .external_lex_state = 24},
  [4023] = {.lex_state = 98, .external_lex_state = 30},
  [4024] = {.lex_state = 98, .external_lex_state = 27},
  [4025] = {.lex_state = 95, .external_lex_state = 24},
  [4026] = {.lex_state = 98, .external_lex_state = 27},
  [4027] = {.lex_state = 95, .external_lex_state = 24},
  [4028] = {.lex_state = 98, .external_lex_state = 30},
  [4029] = {.lex_state = 98, .external_lex_state = 30},
  [4030] = {.lex_state = 98, .external_lex_state = 27},
  [4031] = {.lex_state = 98, .external_lex_state = 30},
  [4032] = {.lex_state = 95, .external_lex_state = 24},
  [4033] = {.lex_state = 98, .external_lex_state = 30},
  [4034] = {.lex_state = 98, .external_lex_state = 30},
  [4035] = {.lex_state = 98, .external_lex_state = 30},
  [4036] = {.lex_state = 98, .external_lex_state = 27},
  [4037] = {.lex_state = 98, .external_lex_state = 27},
  [4038] = {.lex_state = 95, .external_lex_state = 24},
  [4039] = {.lex_state = 98, .external_lex_state = 27},
  [4040] = {.lex_state = 98, .external_lex_state = 27},
  [4041] = {.lex_state = 95, .external_lex_state = 24},
  [4042] = {.lex_state = 98, .external_lex_state = 27},
  [4043] = {.lex_state = 98, .external_lex_state = 30},
  [4044] = {.lex_state = 98, .external_lex_state = 27},
  [4045] = {.lex_state = 98, .external_lex_state = 27},
  [4046] = {.lex_state = 98, .external_lex_state = 27},
  [4047] = {.lex_state = 98, .external_lex_state = 30},
  [4048] = {.lex_state = 94, .external_lex_state = 24},
  [4049] = {.lex_state = 95, .external_lex_state = 24},
  [4050] = {.lex_state = 95, .external_lex_state = 24},
  [4051] = {.lex_state = 98, .external_lex_state = 27},
  [4052] = {.lex_state = 98, .external_lex_state = 27},
  [4053] = {.lex_state = 98, .external_lex_state = 27},
  [4054] = {.lex_state = 98, .external_lex_state = 27},
  [4055] = {.lex_state = 98, .external_lex_state = 30},
  [4056] = {.lex_state = 98, .external_lex_state = 30},
  [4057] = {.lex_state = 98, .external_lex_state = 30},
  [4058] = {.lex_state = 98, .external_lex_state = 30},
  [4059] = {.lex_state = 98, .external_lex_state = 30},
  [4060] = {.lex_state = 98, .external_lex_state = 30},
  [4061] = {.lex_state = 98, .external_lex_state = 30},
  [4062] = {.lex_state = 98, .external_lex_state = 30},
  [4063] = {.lex_state = 98, .external_lex_state = 30},
  [4064] = {.lex_state = 98, .external_lex_state = 30},
  [4065] = {.lex_state = 98, .external_lex_state = 30},
  [4066] = {.lex_state = 98, .external_lex_state = 30},
  [4067] = {.lex_state = 98, .external_lex_state = 30},
  [4068] = {.lex_state = 98, .external_lex_state = 30},
  [4069] = {.lex_state = 98, .external_lex_state = 30},
  [4070] = {.lex_state = 94, .external_lex_state = 24},
  [4071] = {.lex_state = 98, .external_lex_state = 30},
  [4072] = {.lex_state = 98, .external_lex_state = 30},
  [4073] = {.lex_state = 107, .external_lex_state = 32},
  [4074] = {.lex_state = 98, .external_lex_state = 30},
  [4075] = {.lex_state = 98, .external_lex_state = 27},
  [4076] = {.lex_state = 98, .external_lex_state = 30},
  [4077] = {.lex_state = 98, .external_lex_state = 30},
  [4078] = {.lex_state = 98, .external_lex_state = 30},
  [4079] = {.lex_state = 98, .external_lex_state = 30},
  [4080] = {.lex_state = 98, .external_lex_state = 30},
  [4081] = {.lex_state = 98, .external_lex_state = 30},
  [4082] = {.lex_state = 98, .external_lex_state = 30},
  [4083] = {.lex_state = 98, .external_lex_state = 30},
  [4084] = {.lex_state = 98, .external_lex_state = 30},
  [4085] = {.lex_state = 98, .external_lex_state = 30},
  [4086] = {.lex_state = 98, .external_lex_state = 30},
  [4087] = {.lex_state = 98, .external_lex_state = 30},
  [4088] = {.lex_state = 98, .external_lex_state = 27},
  [4089] = {.lex_state = 98, .external_lex_state = 30},
  [4090] = {.lex_state = 98, .external_lex_state = 30},
  [4091] = {.lex_state = 98, .external_lex_state = 27},
  [4092] = {.lex_state = 98, .external_lex_state = 27},
  [4093] = {.lex_state = 98, .external_lex_state = 27},
  [4094] = {.lex_state = 98, .external_lex_state = 27},
  [4095] = {.lex_state = 98, .external_lex_state = 30},
  [4096] = {.lex_state = 98, .external_lex_state = 27},
  [4097] = {.lex_state = 98, .external_lex_state = 27},
  [4098] = {.lex_state = 98, .external_lex_state = 27},
  [4099] = {.lex_state = 98, .external_lex_state = 27},
  [4100] = {.lex_state = 98, .external_lex_state = 27},
  [4101] = {.lex_state = 98, .external_lex_state = 27},
  [4102] = {.lex_state = 98, .external_lex_state = 27},
  [4103] = {.lex_state = 98, .external_lex_state = 27},
  [4104] = {.lex_state = 98, .external_lex_state = 27},
  [4105] = {.lex_state = 98, .external_lex_state = 27},
  [4106] = {.lex_state = 98, .external_lex_state = 27},
  [4107] = {.lex_state = 98, .external_lex_state = 27},
  [4108] = {.lex_state = 98, .external_lex_state = 30},
  [4109] = {.lex_state = 98, .external_lex_state = 27},
  [4110] = {.lex_state = 98, .external_lex_state = 27},
  [4111] = {.lex_state = 98, .external_lex_state = 30},
  [4112] = {.lex_state = 98, .external_lex_state = 30},
  [4113] = {.lex_state = 98, .external_lex_state = 30},
  [4114] = {.lex_state = 98, .external_lex_state = 27},
  [4115] = {.lex_state = 98, .external_lex_state = 30},
  [4116] = {.lex_state = 98, .external_lex_state = 27},
  [4117] = {.lex_state = 98, .external_lex_state = 27},
  [4118] = {.lex_state = 98, .external_lex_state = 27},
  [4119] = {.lex_state = 98, .external_lex_state = 27},
  [4120] = {.lex_state = 98, .external_lex_state = 27},
  [4121] = {.lex_state = 98, .external_lex_state = 30},
  [4122] = {.lex_state = 98, .external_lex_state = 27},
  [4123] = {.lex_state = 98, .external_lex_state = 30},
  [4124] = {.lex_state = 98, .external_lex_state = 30},
  [4125] = {.lex_state = 98, .external_lex_state = 30},
  [4126] = {.lex_state = 98, .external_lex_state = 30},
  [4127] = {.lex_state = 98, .external_lex_state = 27},
  [4128] = {.lex_state = 98, .external_lex_state = 30},
  [4129] = {.lex_state = 98, .external_lex_state = 30},
  [4130] = {.lex_state = 98, .external_lex_state = 30},
  [4131] = {.lex_state = 98, .external_lex_state = 30},
  [4132] = {.lex_state = 98, .external_lex_state = 30},
  [4133] = {.lex_state = 98, .external_lex_state = 30},
  [4134] = {.lex_state = 98, .external_lex_state = 30},
  [4135] = {.lex_state = 98, .external_lex_state = 30},
  [4136] = {.lex_state = 98, .external_lex_state = 30},
  [4137] = {.lex_state = 98, .external_lex_state = 30},
  [4138] = {.lex_state = 98, .external_lex_state = 30},
  [4139] = {.lex_state = 98, .external_lex_state = 27},
  [4140] = {.lex_state = 104, .external_lex_state = 32},
  [4141] = {.lex_state = 98, .external_lex_state = 30},
  [4142] = {.lex_state = 98, .external_lex_state = 30},
  [4143] = {.lex_state = 98, .external_lex_state = 30},
  [4144] = {.lex_state = 98, .external_lex_state = 30},
  [4145] = {.lex_state = 98, .external_lex_state = 30},
  [4146] = {.lex_state = 98, .external_lex_state = 30},
  [4147] = {.lex_state = 98, .external_lex_state = 30},
  [4148] = {.lex_state = 98, .external_lex_state = 30},
  [4149] = {.lex_state = 98, .external_lex_state = 27},
  [4150] = {.lex_state = 98, .external_lex_state = 27},
  [4151] = {.lex_state = 98, .external_lex_state = 30},
  [4152] = {.lex_state = 98, .external_lex_state = 30},
  [4153] = {.lex_state = 98, .external_lex_state = 30},
  [4154] = {.lex_state = 98, .external_lex_state = 30},
  [4155] = {.lex_state = 98, .external_lex_state = 27},
  [4156] = {.lex_state = 98, .external_lex_state = 30},
  [4157] = {.lex_state = 98, .external_lex_state = 30},
  [4158] = {.lex_state = 98, .external_lex_state = 30},
  [4159] = {.lex_state = 98, .external_lex_state = 30},
  [4160] = {.lex_state = 98, .external_lex_state = 30},
  [4161] = {.lex_state = 98, .external_lex_state = 30},
  [4162] = {.lex_state = 98, .external_lex_state = 30},
  [4163] = {.lex_state = 98, .external_lex_state = 30},
  [4164] = {.lex_state = 98, .external_lex_state = 30},
  [4165] = {.lex_state = 98, .external_lex_state = 30},
  [4166] = {.lex_state = 98, .external_lex_state = 30},
  [4167] = {.lex_state = 98, .external_lex_state = 30},
  [4168] = {.lex_state = 98, .external_lex_state = 30},
  [4169] = {.lex_state = 98, .external_lex_state = 30},
  [4170] = {.lex_state = 98, .external_lex_state = 27},
  [4171] = {.lex_state = 98, .external_lex_state = 30},
  [4172] = {.lex_state = 98, .external_lex_state = 30},
  [4173] = {.lex_state = 98, .external_lex_state = 30},
  [4174] = {.lex_state = 98, .external_lex_state = 30},
  [4175] = {.lex_state = 231, .external_lex_state = 32},
  [4176] = {.lex_state = 98, .external_lex_state = 27},
  [4177] = {.lex_state = 98, .external_lex_state = 30},
  [4178] = {.lex_state = 98, .external_lex_state = 30},
  [4179] = {.lex_state = 98, .external_lex_state = 27},
  [4180] = {.lex_state = 98, .external_lex_state = 27},
  [4181] = {.lex_state = 98, .external_lex_state = 27},
  [4182] = {.lex_state = 98, .external_lex_state = 27},
  [4183] = {.lex_state = 98, .external_lex_state = 30},
  [4184] = {.lex_state = 98, .external_lex_state = 27},
  [4185] = {.lex_state = 98, .external_lex_state = 27},
  [4186] = {.lex_state = 98, .external_lex_state = 30},
  [4187] = {.lex_state = 98, .external_lex_state = 27},
  [4188] = {.lex_state = 98, .external_lex_state = 27},
  [4189] = {.lex_state = 98, .external_lex_state = 27},
  [4190] = {.lex_state = 98, .external_lex_state = 27},
  [4191] = {.lex_state = 98, .external_lex_state = 27},
  [4192] = {.lex_state = 98, .external_lex_state = 30},
  [4193] = {.lex_state = 98, .external_lex_state = 30},
  [4194] = {.lex_state = 104, .external_lex_state = 32},
  [4195] = {.lex_state = 98, .external_lex_state = 27},
  [4196] = {.lex_state = 98, .external_lex_state = 27},
  [4197] = {.lex_state = 98, .external_lex_state = 30},
  [4198] = {.lex_state = 98, .external_lex_state = 30},
  [4199] = {.lex_state = 98, .external_lex_state = 27},
  [4200] = {.lex_state = 98, .external_lex_state = 30},
  [4201] = {.lex_state = 98, .external_lex_state = 27},
  [4202] = {.lex_state = 98, .external_lex_state = 27},
  [4203] = {.lex_state = 98, .external_lex_state = 30},
  [4204] = {.lex_state = 98, .external_lex_state = 27},
  [4205] = {.lex_state = 98, .external_lex_state = 30},
  [4206] = {.lex_state = 98, .external_lex_state = 30},
  [4207] = {.lex_state = 98, .external_lex_state = 27},
  [4208] = {.lex_state = 98, .external_lex_state = 27},
  [4209] = {.lex_state = 98, .external_lex_state = 30},
  [4210] = {.lex_state = 98, .external_lex_state = 30},
  [4211] = {.lex_state = 98, .external_lex_state = 30},
  [4212] = {.lex_state = 98, .external_lex_state = 30},
  [4213] = {.lex_state = 98, .external_lex_state = 30},
  [4214] = {.lex_state = 98, .external_lex_state = 27},
  [4215] = {.lex_state = 98, .external_lex_state = 30},
  [4216] = {.lex_state = 98, .external_lex_state = 30},
  [4217] = {.lex_state = 98, .external_lex_state = 30},
  [4218] = {.lex_state = 98, .external_lex_state = 30},
  [4219] = {.lex_state = 98, .external_lex_state = 30},
  [4220] = {.lex_state = 98, .external_lex_state = 30},
  [4221] = {.lex_state = 98, .external_lex_state = 30},
  [4222] = {.lex_state = 98, .external_lex_state = 30},
  [4223] = {.lex_state = 98, .external_lex_state = 30},
  [4224] = {.lex_state = 98, .external_lex_state = 30},
  [4225] = {.lex_state = 98, .external_lex_state = 30},
  [4226] = {.lex_state = 98, .external_lex_state = 30},
  [4227] = {.lex_state = 98, .external_lex_state = 30},
  [4228] = {.lex_state = 98, .external_lex_state = 30},
  [4229] = {.lex_state = 98, .external_lex_state = 30},
  [4230] = {.lex_state = 225, .external_lex_state = 31},
  [4231] = {.lex_state = 98, .external_lex_state = 30},
  [4232] = {.lex_state = 98, .external_lex_state = 30},
  [4233] = {.lex_state = 98, .external_lex_state = 30},
  [4234] = {.lex_state = 98, .external_lex_state = 30},
  [4235] = {.lex_state = 98, .external_lex_state = 30},
  [4236] = {.lex_state = 98, .external_lex_state = 30},
  [4237] = {.lex_state = 98, .external_lex_state = 30},
  [4238] = {.lex_state = 98, .external_lex_state = 30},
  [4239] = {.lex_state = 98, .external_lex_state = 30},
  [4240] = {.lex_state = 98, .external_lex_state = 30},
  [4241] = {.lex_state = 98, .external_lex_state = 30},
  [4242] = {.lex_state = 225, .external_lex_state = 31},
  [4243] = {.lex_state = 98, .external_lex_state = 30},
  [4244] = {.lex_state = 98, .external_lex_state = 30},
  [4245] = {.lex_state = 98, .external_lex_state = 30},
  [4246] = {.lex_state = 98, .external_lex_state = 30},
  [4247] = {.lex_state = 98, .external_lex_state = 30},
  [4248] = {.lex_state = 98, .external_lex_state = 30},
  [4249] = {.lex_state = 98, .external_lex_state = 30},
  [4250] = {.lex_state = 98, .external_lex_state = 30},
  [4251] = {.lex_state = 98, .external_lex_state = 30},
  [4252] = {.lex_state = 98, .external_lex_state = 30},
  [4253] = {.lex_state = 98, .external_lex_state = 30},
  [4254] = {.lex_state = 98, .external_lex_state = 30},
  [4255] = {.lex_state = 98, .external_lex_state = 30},
  [4256] = {.lex_state = 98, .external_lex_state = 30},
  [4257] = {.lex_state = 98, .external_lex_state = 30},
  [4258] = {.lex_state = 98, .external_lex_state = 30},
  [4259] = {.lex_state = 98, .external_lex_state = 30},
  [4260] = {.lex_state = 98, .external_lex_state = 30},
  [4261] = {.lex_state = 98, .external_lex_state = 30},
  [4262] = {.lex_state = 98, .external_lex_state = 30},
  [4263] = {.lex_state = 98, .external_lex_state = 30},
  [4264] = {.lex_state = 224, .external_lex_state = 33},
  [4265] = {.lex_state = 98, .external_lex_state = 30},
  [4266] = {.lex_state = 98, .external_lex_state = 30},
  [4267] = {.lex_state = 98, .external_lex_state = 30},
  [4268] = {.lex_state = 98, .external_lex_state = 30},
  [4269] = {.lex_state = 98, .external_lex_state = 30},
  [4270] = {.lex_state = 98, .external_lex_state = 30},
  [4271] = {.lex_state = 226, .external_lex_state = 32},
  [4272] = {.lex_state = 226, .external_lex_state = 32},
  [4273] = {.lex_state = 98, .external_lex_state = 30},
  [4274] = {.lex_state = 98, .external_lex_state = 30},
  [4275] = {.lex_state = 98, .external_lex_state = 30},
  [4276] = {.lex_state = 98, .external_lex_state = 30},
  [4277] = {.lex_state = 230, .external_lex_state = 32},
  [4278] = {.lex_state = 98, .external_lex_state = 30},
  [4279] = {.lex_state = 98, .external_lex_state = 30},
  [4280] = {.lex_state = 98, .external_lex_state = 30},
  [4281] = {.lex_state = 98, .external_lex_state = 30},
  [4282] = {.lex_state = 98, .external_lex_state = 30},
  [4283] = {.lex_state = 98, .external_lex_state = 30},
  [4284] = {.lex_state = 98, .external_lex_state = 30},
  [4285] = {.lex_state = 98, .external_lex_state = 30},
  [4286] = {.lex_state = 98, .external_lex_state = 30},
  [4287] = {.lex_state = 98, .external_lex_state = 30},
  [4288] = {.lex_state = 98, .external_lex_state = 30},
  [4289] = {.lex_state = 230, .external_lex_state = 32},
  [4290] = {.lex_state = 98, .external_lex_state = 30},
  [4291] = {.lex_state = 98, .external_lex_state = 30},
  [4292] = {.lex_state = 98, .external_lex_state = 30},
  [4293] = {.lex_state = 98, .external_lex_state = 30},
  [4294] = {.lex_state = 98, .external_lex_state = 30},
  [4295] = {.lex_state = 98, .external_lex_state = 30},
  [4296] = {.lex_state = 98, .external_lex_state = 30},
  [4297] = {.lex_state = 98, .external_lex_state = 30},
  [4298] = {.lex_state = 98, .external_lex_state = 30},
  [4299] = {.lex_state = 98, .external_lex_state = 30},
  [4300] = {.lex_state = 226, .external_lex_state = 32},
  [4301] = {.lex_state = 98, .external_lex_state = 30},
  [4302] = {.lex_state = 98, .external_lex_state = 30},
  [4303] = {.lex_state = 226, .external_lex_state = 32},
  [4304] = {.lex_state = 226, .external_lex_state = 32},
  [4305] = {.lex_state = 226, .external_lex_state = 32},
  [4306] = {.lex_state = 226, .external_lex_state = 32},
  [4307] = {.lex_state = 98, .external_lex_state = 30},
  [4308] = {.lex_state = 98, .external_lex_state = 30},
  [4309] = {.lex_state = 98, .external_lex_state = 30},
  [4310] = {.lex_state = 98, .external_lex_state = 30},
  [4311] = {.lex_state = 98, .external_lex_state = 30},
  [4312] = {.lex_state = 98, .external_lex_state = 30},
  [4313] = {.lex_state = 98, .external_lex_state = 30},
  [4314] = {.lex_state = 98, .external_lex_state = 30},
  [4315] = {.lex_state = 98, .external_lex_state = 30},
  [4316] = {.lex_state = 98, .external_lex_state = 30},
  [4317] = {.lex_state = 98, .external_lex_state = 30},
  [4318] = {.lex_state = 98, .external_lex_state = 30},
  [4319] = {.lex_state = 98, .external_lex_state = 30},
  [4320] = {.lex_state = 98, .external_lex_state = 30},
  [4321] = {.lex_state = 98, .external_lex_state = 30},
  [4322] = {.lex_state = 98, .external_lex_state = 30},
  [4323] = {.lex_state = 226, .external_lex_state = 32},
  [4324] = {.lex_state = 226, .external_lex_state = 32},
  [4325] = {.lex_state = 226, .external_lex_state = 32},
  [4326] = {.lex_state = 98, .external_lex_state = 30},
  [4327] = {.lex_state = 226, .external_lex_state = 32},
  [4328] = {.lex_state = 98, .external_lex_state = 30},
  [4329] = {.lex_state = 98, .external_lex_state = 30},
  [4330] = {.lex_state = 226, .external_lex_state = 32},
  [4331] = {.lex_state = 226, .external_lex_state = 32},
  [4332] = {.lex_state = 98, .external_lex_state = 30},
  [4333] = {.lex_state = 98, .external_lex_state = 30},
  [4334] = {.lex_state = 226, .external_lex_state = 32},
  [4335] = {.lex_state = 226, .external_lex_state = 32},
  [4336] = {.lex_state = 98, .external_lex_state = 30},
  [4337] = {.lex_state = 230, .external_lex_state = 32},
  [4338] = {.lex_state = 98, .external_lex_state = 30},
  [4339] = {.lex_state = 232, .external_lex_state = 32},
  [4340] = {.lex_state = 98, .external_lex_state = 30},
  [4341] = {.lex_state = 98, .external_lex_state = 30},
  [4342] = {.lex_state = 98, .external_lex_state = 30},
  [4343] = {.lex_state = 98, .external_lex_state = 30},
  [4344] = {.lex_state = 98, .external_lex_state = 30},
  [4345] = {.lex_state = 98, .external_lex_state = 30},
  [4346] = {.lex_state = 98, .external_lex_state = 30},
  [4347] = {.lex_state = 98, .external_lex_state = 30},
  [4348] = {.lex_state = 98, .external_lex_state = 30},
  [4349] = {.lex_state = 98, .external_lex_state = 30},
  [4350] = {.lex_state = 98, .external_lex_state = 30},
  [4351] = {.lex_state = 98, .external_lex_state = 30},
  [4352] = {.lex_state = 98, .external_lex_state = 30},
  [4353] = {.lex_state = 98, .external_lex_state = 30},
  [4354] = {.lex_state = 98, .external_lex_state = 30},
  [4355] = {.lex_state = 98, .external_lex_state = 30},
  [4356] = {.lex_state = 98, .external_lex_state = 30},
  [4357] = {.lex_state = 98, .external_lex_state = 30},
  [4358] = {.lex_state = 98, .external_lex_state = 30},
  [4359] = {.lex_state = 230, .external_lex_state = 32},
  [4360] = {.lex_state = 98, .external_lex_state = 30},
  [4361] = {.lex_state = 98, .external_lex_state = 30},
  [4362] = {.lex_state = 98, .external_lex_state = 30},
  [4363] = {.lex_state = 98, .external_lex_state = 30},
  [4364] = {.lex_state = 98, .external_lex_state = 30},
  [4365] = {.lex_state = 98, .external_lex_state = 30},
  [4366] = {.lex_state = 98, .external_lex_state = 30},
  [4367] = {.lex_state = 232, .external_lex_state = 32},
  [4368] = {.lex_state = 230, .external_lex_state = 32},
  [4369] = {.lex_state = 98, .external_lex_state = 30},
  [4370] = {.lex_state = 98, .external_lex_state = 30},
  [4371] = {.lex_state = 98, .external_lex_state = 30},
  [4372] = {.lex_state = 98, .external_lex_state = 30},
  [4373] = {.lex_state = 98, .external_lex_state = 30},
  [4374] = {.lex_state = 98, .external_lex_state = 30},
  [4375] = {.lex_state = 98, .external_lex_state = 30},
  [4376] = {.lex_state = 98, .external_lex_state = 30},
  [4377] = {.lex_state = 98, .external_lex_state = 30},
  [4378] = {.lex_state = 98, .external_lex_state = 30},
  [4379] = {.lex_state = 226, .external_lex_state = 32},
  [4380] = {.lex_state = 231, .external_lex_state = 32},
  [4381] = {.lex_state = 231, .external_lex_state = 32},
  [4382] = {.lex_state = 231, .external_lex_state = 32},
  [4383] = {.lex_state = 231, .external_lex_state = 32},
  [4384] = {.lex_state = 231, .external_lex_state = 32},
  [4385] = {.lex_state = 231, .external_lex_state = 32},
  [4386] = {.lex_state = 231, .external_lex_state = 32},
  [4387] = {.lex_state = 231, .external_lex_state = 32},
  [4388] = {.lex_state = 231, .external_lex_state = 32},
  [4389] = {.lex_state = 231, .external_lex_state = 32},
  [4390] = {.lex_state = 231, .external_lex_state = 32},
  [4391] = {.lex_state = 231, .external_lex_state = 32},
  [4392] = {.lex_state = 231, .external_lex_state = 32},
  [4393] = {.lex_state = 231, .external_lex_state = 32},
  [4394] = {.lex_state = 231, .external_lex_state = 32},
  [4395] = {.lex_state = 231, .external_lex_state = 32},
  [4396] = {.lex_state = 231, .external_lex_state = 32},
  [4397] = {.lex_state = 231, .external_lex_state = 32},
  [4398] = {.lex_state = 231, .external_lex_state = 32},
  [4399] = {.lex_state = 231, .external_lex_state = 32},
  [4400] = {.lex_state = 231, .external_lex_state = 32},
  [4401] = {.lex_state = 231, .external_lex_state = 32},
  [4402] = {.lex_state = 231, .external_lex_state = 32},
  [4403] = {.lex_state = 231, .external_lex_state = 32},
  [4404] = {.lex_state = 231, .external_lex_state = 32},
  [4405] = {.lex_state = 231, .external_lex_state = 32},
  [4406] = {.lex_state = 231, .external_lex_state = 32},
  [4407] = {.lex_state = 231, .external_lex_state = 32},
  [4408] = {.lex_state = 231, .external_lex_state = 32},
  [4409] = {.lex_state = 231, .external_lex_state = 32},
  [4410] = {.lex_state = 231, .external_lex_state = 32},
  [4411] = {.lex_state = 231, .external_lex_state = 32},
  [4412] = {.lex_state = 231, .external_lex_state = 32},
  [4413] = {.lex_state = 231, .external_lex_state = 32},
  [4414] = {.lex_state = 231, .external_lex_state = 32},
  [4415] = {.lex_state = 231, .external_lex_state = 32},
  [4416] = {.lex_state = 231, .external_lex_state = 32},
  [4417] = {.lex_state = 231, .external_lex_state = 32},
  [4418] = {.lex_state = 231, .external_lex_state = 32},
  [4419] = {.lex_state = 231, .external_lex_state = 32},
  [4420] = {.lex_state = 231, .external_lex_state = 32},
  [4421] = {.lex_state = 231, .external_lex_state = 32},
  [4422] = {.lex_state = 231, .external_lex_state = 32},
  [4423] = {.lex_state = 231, .external_lex_state = 32},
  [4424] = {.lex_state = 231, .external_lex_state = 32},
  [4425] = {.lex_state = 231, .external_lex_state = 32},
  [4426] = {.lex_state = 231, .external_lex_state = 32},
  [4427] = {.lex_state = 231, .external_lex_state = 32},
  [4428] = {.lex_state = 231, .external_lex_state = 32},
  [4429] = {.lex_state = 231, .external_lex_state = 32},
  [4430] = {.lex_state = 231, .external_lex_state = 32},
  [4431] = {.lex_state = 231, .external_lex_state = 32},
  [4432] = {.lex_state = 226, .external_lex_state = 32},
  [4433] = {.lex_state = 226, .external_lex_state = 32},
  [4434] = {.lex_state = 226, .external_lex_state = 32},
  [4435] = {.lex_state = 226, .external_lex_state = 32},
  [4436] = {.lex_state = 114, .external_lex_state = 32},
  [4437] = {.lex_state = 231, .external_lex_state = 32},
  [4438] = {.lex_state = 231, .external_lex_state = 32},
  [4439] = {.lex_state = 231, .external_lex_state = 32},
  [4440] = {.lex_state = 231, .external_lex_state = 32},
  [4441] = {.lex_state = 231, .external_lex_state = 32},
  [4442] = {.lex_state = 231, .external_lex_state = 32},
  [4443] = {.lex_state = 231, .external_lex_state = 32},
  [4444] = {.lex_state = 231, .external_lex_state = 32},
  [4445] = {.lex_state = 231, .external_lex_state = 32},
  [4446] = {.lex_state = 231, .external_lex_state = 32},
  [4447] = {.lex_state = 231, .external_lex_state = 32},
  [4448] = {.lex_state = 231, .external_lex_state = 32},
  [4449] = {.lex_state = 231, .external_lex_state = 32},
  [4450] = {.lex_state = 103, .external_lex_state = 32},
  [4451] = {.lex_state = 231, .external_lex_state = 32},
  [4452] = {.lex_state = 231, .external_lex_state = 32},
  [4453] = {.lex_state = 231, .external_lex_state = 32},
  [4454] = {.lex_state = 231, .external_lex_state = 32},
  [4455] = {.lex_state = 231, .external_lex_state = 32},
  [4456] = {.lex_state = 231, .external_lex_state = 32},
  [4457] = {.lex_state = 231, .external_lex_state = 32},
  [4458] = {.lex_state = 231, .external_lex_state = 32},
  [4459] = {.lex_state = 231, .external_lex_state = 32},
  [4460] = {.lex_state = 115, .external_lex_state = 31},
  [4461] = {.lex_state = 231, .external_lex_state = 32},
  [4462] = {.lex_state = 231, .external_lex_state = 32},
  [4463] = {.lex_state = 231, .external_lex_state = 32},
  [4464] = {.lex_state = 107, .external_lex_state = 32},
  [4465] = {.lex_state = 107, .external_lex_state = 32},
  [4466] = {.lex_state = 107, .external_lex_state = 32},
  [4467] = {.lex_state = 231, .external_lex_state = 32},
  [4468] = {.lex_state = 101, .external_lex_state = 32},
  [4469] = {.lex_state = 231, .external_lex_state = 32},
  [4470] = {.lex_state = 107, .external_lex_state = 32},
  [4471] = {.lex_state = 115, .external_lex_state = 31},
  [4472] = {.lex_state = 231, .external_lex_state = 32},
  [4473] = {.lex_state = 107, .external_lex_state = 32},
  [4474] = {.lex_state = 107, .external_lex_state = 32},
  [4475] = {.lex_state = 107, .external_lex_state = 32},
  [4476] = {.lex_state = 231, .external_lex_state = 32},
  [4477] = {.lex_state = 231, .external_lex_state = 32},
  [4478] = {.lex_state = 231, .external_lex_state = 32},
  [4479] = {.lex_state = 231, .external_lex_state = 32},
  [4480] = {.lex_state = 101, .external_lex_state = 32},
  [4481] = {.lex_state = 231, .external_lex_state = 32},
  [4482] = {.lex_state = 231, .external_lex_state = 32},
  [4483] = {.lex_state = 231, .external_lex_state = 32},
  [4484] = {.lex_state = 231, .external_lex_state = 32},
  [4485] = {.lex_state = 231, .external_lex_state = 32},
  [4486] = {.lex_state = 231, .external_lex_state = 32},
  [4487] = {.lex_state = 101, .external_lex_state = 32},
  [4488] = {.lex_state = 231, .external_lex_state = 32},
  [4489] = {.lex_state = 231, .external_lex_state = 32},
  [4490] = {.lex_state = 231, .external_lex_state = 32},
  [4491] = {.lex_state = 231, .external_lex_state = 32},
  [4492] = {.lex_state = 231, .external_lex_state = 32},
  [4493] = {.lex_state = 231, .external_lex_state = 32},
  [4494] = {.lex_state = 231, .external_lex_state = 32},
  [4495] = {.lex_state = 231, .external_lex_state = 32},
  [4496] = {.lex_state = 231, .external_lex_state = 32},
  [4497] = {.lex_state = 231, .external_lex_state = 32},
  [4498] = {.lex_state = 103, .external_lex_state = 32},
  [4499] = {.lex_state = 110, .external_lex_state = 32},
  [4500] = {.lex_state = 231, .external_lex_state = 32},
  [4501] = {.lex_state = 231, .external_lex_state = 32},
  [4502] = {.lex_state = 231, .external_lex_state = 32},
  [4503] = {.lex_state = 231, .external_lex_state = 32},
  [4504] = {.lex_state = 231, .external_lex_state = 32},
  [4505] = {.lex_state = 231, .external_lex_state = 32},
  [4506] = {.lex_state = 231, .external_lex_state = 32},
  [4507] = {.lex_state = 231, .external_lex_state = 32},
  [4508] = {.lex_state = 231, .external_lex_state = 32},
  [4509] = {.lex_state = 231, .external_lex_state = 32},
  [4510] = {.lex_state = 101, .external_lex_state = 32},
  [4511] = {.lex_state = 231, .external_lex_state = 32},
  [4512] = {.lex_state = 231, .external_lex_state = 32},
  [4513] = {.lex_state = 231, .external_lex_state = 32},
  [4514] = {.lex_state = 231, .external_lex_state = 32},
  [4515] = {.lex_state = 115, .external_lex_state = 34},
  [4516] = {.lex_state = 115, .external_lex_state = 34},
  [4517] = {.lex_state = 115, .external_lex_state = 34},
  [4518] = {.lex_state = 101, .external_lex_state = 32},
  [4519] = {.lex_state = 115, .external_lex_state = 34},
  [4520] = {.lex_state = 101, .external_lex_state = 32},
  [4521] = {.lex_state = 101, .external_lex_state = 32},
  [4522] = {.lex_state = 101, .external_lex_state = 32},
  [4523] = {.lex_state = 101, .external_lex_state = 32},
  [4524] = {.lex_state = 101, .external_lex_state = 32},
  [4525] = {.lex_state = 101, .external_lex_state = 32},
  [4526] = {.lex_state = 101, .external_lex_state = 32},
  [4527] = {.lex_state = 101, .external_lex_state = 32},
  [4528] = {.lex_state = 101, .external_lex_state = 32},
  [4529] = {.lex_state = 101, .external_lex_state = 32},
  [4530] = {.lex_state = 101, .external_lex_state = 32},
  [4531] = {.lex_state = 101, .external_lex_state = 32},
  [4532] = {.lex_state = 101, .external_lex_state = 32},
  [4533] = {.lex_state = 101, .external_lex_state = 32},
  [4534] = {.lex_state = 107, .external_lex_state = 32},
  [4535] = {.lex_state = 107, .external_lex_state = 32},
  [4536] = {.lex_state = 107, .external_lex_state = 32},
  [4537] = {.lex_state = 107, .external_lex_state = 32},
  [4538] = {.lex_state = 107, .external_lex_state = 32},
  [4539] = {.lex_state = 107, .external_lex_state = 32},
  [4540] = {.lex_state = 107, .external_lex_state = 32},
  [4541] = {.lex_state = 107, .external_lex_state = 32},
  [4542] = {.lex_state = 107, .external_lex_state = 32},
  [4543] = {.lex_state = 107, .external_lex_state = 32},
  [4544] = {.lex_state = 107, .external_lex_state = 32},
  [4545] = {.lex_state = 107, .external_lex_state = 32},
  [4546] = {.lex_state = 107, .external_lex_state = 32},
  [4547] = {.lex_state = 107, .external_lex_state = 32},
  [4548] = {.lex_state = 107, .external_lex_state = 32},
  [4549] = {.lex_state = 107, .external_lex_state = 32},
  [4550] = {.lex_state = 107, .external_lex_state = 32},
  [4551] = {.lex_state = 231, .external_lex_state = 32},
  [4552] = {.lex_state = 101, .external_lex_state = 32},
  [4553] = {.lex_state = 107, .external_lex_state = 32},
  [4554] = {.lex_state = 107, .external_lex_state = 32},
  [4555] = {.lex_state = 101, .external_lex_state = 32},
  [4556] = {.lex_state = 107, .external_lex_state = 32},
  [4557] = {.lex_state = 107, .external_lex_state = 32},
  [4558] = {.lex_state = 107, .external_lex_state = 32},
  [4559] = {.lex_state = 107, .external_lex_state = 32},
  [4560] = {.lex_state = 107, .external_lex_state = 32},
  [4561] = {.lex_state = 230, .external_lex_state = 32},
  [4562] = {.lex_state = 103, .external_lex_state = 35},
  [4563] = {.lex_state = 103, .external_lex_state = 35},
  [4564] = {.lex_state = 101, .external_lex_state = 32},
  [4565] = {.lex_state = 101, .external_lex_state = 32},
  [4566] = {.lex_state = 103, .external_lex_state = 35},
  [4567] = {.lex_state = 232, .external_lex_state = 32},
  [4568] = {.lex_state = 231, .external_lex_state = 32},
  [4569] = {.lex_state = 103, .external_lex_state = 35},
  [4570] = {.lex_state = 231, .external_lex_state = 32},
  [4571] = {.lex_state = 231, .external_lex_state = 32},
  [4572] = {.lex_state = 103, .external_lex_state = 35},
  [4573] = {.lex_state = 231, .external_lex_state = 32},
  [4574] = {.lex_state = 103, .external_lex_state = 35},
  [4575] = {.lex_state = 231, .external_lex_state = 32},
  [4576] = {.lex_state = 101, .external_lex_state = 32},
  [4577] = {.lex_state = 103, .external_lex_state = 35},
  [4578] = {.lex_state = 231, .external_lex_state = 32},
  [4579] = {.lex_state = 101, .external_lex_state = 32},
  [4580] = {.lex_state = 101, .external_lex_state = 32},
  [4581] = {.lex_state = 118, .external_lex_state = 32},
  [4582] = {.lex_state = 103, .external_lex_state = 35},
  [4583] = {.lex_state = 231, .external_lex_state = 32},
  [4584] = {.lex_state = 101, .external_lex_state = 32},
  [4585] = {.lex_state = 231, .external_lex_state = 32},
  [4586] = {.lex_state = 101, .external_lex_state = 32},
  [4587] = {.lex_state = 231, .external_lex_state = 32},
  [4588] = {.lex_state = 101, .external_lex_state = 32},
  [4589] = {.lex_state = 103, .external_lex_state = 35},
  [4590] = {.lex_state = 103, .external_lex_state = 35},
  [4591] = {.lex_state = 231, .external_lex_state = 32},
  [4592] = {.lex_state = 103, .external_lex_state = 35},
  [4593] = {.lex_state = 101, .external_lex_state = 32},
  [4594] = {.lex_state = 101, .external_lex_state = 32},
  [4595] = {.lex_state = 101, .external_lex_state = 32},
  [4596] = {.lex_state = 101, .external_lex_state = 32},
  [4597] = {.lex_state = 101, .external_lex_state = 32},
  [4598] = {.lex_state = 101, .external_lex_state = 32},
  [4599] = {.lex_state = 101, .external_lex_state = 32},
  [4600] = {.lex_state = 231, .external_lex_state = 32},
  [4601] = {.lex_state = 226, .external_lex_state = 32},
  [4602] = {.lex_state = 101, .external_lex_state = 32},
  [4603] = {.lex_state = 232, .external_lex_state = 32},
  [4604] = {.lex_state = 103, .external_lex_state = 35},
  [4605] = {.lex_state = 103, .external_lex_state = 35},
  [4606] = {.lex_state = 231, .external_lex_state = 32},
  [4607] = {.lex_state = 231, .external_lex_state = 32},
  [4608] = {.lex_state = 101, .external_lex_state = 32},
  [4609] = {.lex_state = 231, .external_lex_state = 32},
  [4610] = {.lex_state = 101, .external_lex_state = 32},
  [4611] = {.lex_state = 103, .external_lex_state = 35},
  [4612] = {.lex_state = 101, .external_lex_state = 32},
  [4613] = {.lex_state = 101, .external_lex_state = 32},
  [4614] = {.lex_state = 101, .external_lex_state = 32},
  [4615] = {.lex_state = 115, .external_lex_state = 34},
  [4616] = {.lex_state = 103, .external_lex_state = 35},
  [4617] = {.lex_state = 103, .external_lex_state = 35},
  [4618] = {.lex_state = 115, .external_lex_state = 34},
  [4619] = {.lex_state = 101, .external_lex_state = 32},
  [4620] = {.lex_state = 101, .external_lex_state = 32},
  [4621] = {.lex_state = 231, .external_lex_state = 32},
  [4622] = {.lex_state = 103, .external_lex_state = 35},
  [4623] = {.lex_state = 103, .external_lex_state = 35},
  [4624] = {.lex_state = 231, .external_lex_state = 32},
  [4625] = {.lex_state = 231, .external_lex_state = 32},
  [4626] = {.lex_state = 103, .external_lex_state = 35},
  [4627] = {.lex_state = 231, .external_lex_state = 32},
  [4628] = {.lex_state = 101, .external_lex_state = 32},
  [4629] = {.lex_state = 231, .external_lex_state = 32},
  [4630] = {.lex_state = 231, .external_lex_state = 32},
  [4631] = {.lex_state = 231, .external_lex_state = 32},
  [4632] = {.lex_state = 231, .external_lex_state = 32},
  [4633] = {.lex_state = 231, .external_lex_state = 32},
  [4634] = {.lex_state = 101, .external_lex_state = 32},
  [4635] = {.lex_state = 231, .external_lex_state = 32},
  [4636] = {.lex_state = 231, .external_lex_state = 32},
  [4637] = {.lex_state = 231, .external_lex_state = 32},
  [4638] = {.lex_state = 103, .external_lex_state = 35},
  [4639] = {.lex_state = 114, .external_lex_state = 32},
  [4640] = {.lex_state = 231, .external_lex_state = 32},
  [4641] = {.lex_state = 231, .external_lex_state = 32},
  [4642] = {.lex_state = 231, .external_lex_state = 32},
  [4643] = {.lex_state = 231, .external_lex_state = 32},
  [4644] = {.lex_state = 103, .external_lex_state = 32},
  [4645] = {.lex_state = 101, .external_lex_state = 35},
  [4646] = {.lex_state = 101, .external_lex_state = 35},
  [4647] = {.lex_state = 110, .external_lex_state = 35},
  [4648] = {.lex_state = 103, .external_lex_state = 35},
  [4649] = {.lex_state = 114, .external_lex_state = 35},
  [4650] = {.lex_state = 114, .external_lex_state = 35},
  [4651] = {.lex_state = 103, .external_lex_state = 35},
  [4652] = {.lex_state = 114, .external_lex_state = 35},
  [4653] = {.lex_state = 231, .external_lex_state = 32},
  [4654] = {.lex_state = 111, .external_lex_state = 36},
  [4655] = {.lex_state = 231, .external_lex_state = 32},
  [4656] = {.lex_state = 101, .external_lex_state = 32},
  [4657] = {.lex_state = 231, .external_lex_state = 32},
  [4658] = {.lex_state = 114, .external_lex_state = 35},
  [4659] = {.lex_state = 110, .external_lex_state = 35},
  [4660] = {.lex_state = 110, .external_lex_state = 35},
  [4661] = {.lex_state = 111, .external_lex_state = 36},
  [4662] = {.lex_state = 111, .external_lex_state = 36},
  [4663] = {.lex_state = 114, .external_lex_state = 35},
  [4664] = {.lex_state = 114, .external_lex_state = 35},
  [4665] = {.lex_state = 110, .external_lex_state = 35},
  [4666] = {.lex_state = 110, .external_lex_state = 35},
  [4667] = {.lex_state = 110, .external_lex_state = 35},
  [4668] = {.lex_state = 110, .external_lex_state = 35},
  [4669] = {.lex_state = 110, .external_lex_state = 35},
  [4670] = {.lex_state = 110, .external_lex_state = 35},
  [4671] = {.lex_state = 110, .external_lex_state = 35},
  [4672] = {.lex_state = 110, .external_lex_state = 35},
  [4673] = {.lex_state = 110, .external_lex_state = 35},
  [4674] = {.lex_state = 110, .external_lex_state = 35},
  [4675] = {.lex_state = 110, .external_lex_state = 35},
  [4676] = {.lex_state = 110, .external_lex_state = 35},
  [4677] = {.lex_state = 110, .external_lex_state = 35},
  [4678] = {.lex_state = 101, .external_lex_state = 35},
  [4679] = {.lex_state = 101, .external_lex_state = 35},
  [4680] = {.lex_state = 101, .external_lex_state = 35},
  [4681] = {.lex_state = 101, .external_lex_state = 35},
  [4682] = {.lex_state = 101, .external_lex_state = 35},
  [4683] = {.lex_state = 101, .external_lex_state = 35},
  [4684] = {.lex_state = 101, .external_lex_state = 35},
  [4685] = {.lex_state = 101, .external_lex_state = 35},
  [4686] = {.lex_state = 101, .external_lex_state = 35},
  [4687] = {.lex_state = 101, .external_lex_state = 35},
  [4688] = {.lex_state = 101, .external_lex_state = 35},
  [4689] = {.lex_state = 101, .external_lex_state = 35},
  [4690] = {.lex_state = 101, .external_lex_state = 35},
  [4691] = {.lex_state = 101, .external_lex_state = 35},
  [4692] = {.lex_state = 101, .external_lex_state = 35},
  [4693] = {.lex_state = 101, .external_lex_state = 35},
  [4694] = {.lex_state = 101, .external_lex_state = 35},
  [4695] = {.lex_state = 101, .external_lex_state = 35},
  [4696] = {.lex_state = 101, .external_lex_state = 35},
  [4697] = {.lex_state = 101, .external_lex_state = 35},
  [4698] = {.lex_state = 101, .external_lex_state = 35},
  [4699] = {.lex_state = 101, .external_lex_state = 35},
  [4700] = {.lex_state = 101, .external_lex_state = 35},
  [4701] = {.lex_state = 101, .external_lex_state = 35},
  [4702] = {.lex_state = 101, .external_lex_state = 35},
  [4703] = {.lex_state = 101, .external_lex_state = 35},
  [4704] = {.lex_state = 110, .external_lex_state = 33},
  [4705] = {.lex_state = 103, .external_lex_state = 32},
  [4706] = {.lex_state = 114, .external_lex_state = 35},
  [4707] = {.lex_state = 101, .external_lex_state = 35},
  [4708] = {.lex_state = 101, .external_lex_state = 35},
  [4709] = {.lex_state = 110, .external_lex_state = 33},
  [4710] = {.lex_state = 101, .external_lex_state = 35},
  [4711] = {.lex_state = 101, .external_lex_state = 35},
  [4712] = {.lex_state = 101, .external_lex_state = 35},
  [4713] = {.lex_state = 101, .external_lex_state = 32},
  [4714] = {.lex_state = 101, .external_lex_state = 35},
  [4715] = {.lex_state = 101, .external_lex_state = 35},
  [4716] = {.lex_state = 101, .external_lex_state = 35},
  [4717] = {.lex_state = 101, .external_lex_state = 35},
  [4718] = {.lex_state = 101, .external_lex_state = 35},
  [4719] = {.lex_state = 101, .external_lex_state = 35},
  [4720] = {.lex_state = 231, .external_lex_state = 32},
  [4721] = {.lex_state = 231, .external_lex_state = 32},
  [4722] = {.lex_state = 101, .external_lex_state = 35},
  [4723] = {.lex_state = 101, .external_lex_state = 32},
  [4724] = {.lex_state = 101, .external_lex_state = 32},
  [4725] = {.lex_state = 101, .external_lex_state = 35},
  [4726] = {.lex_state = 101, .external_lex_state = 35},
  [4727] = {.lex_state = 101, .external_lex_state = 35},
  [4728] = {.lex_state = 101, .external_lex_state = 35},
  [4729] = {.lex_state = 101, .external_lex_state = 35},
  [4730] = {.lex_state = 101, .external_lex_state = 35},
  [4731] = {.lex_state = 101, .external_lex_state = 35},
  [4732] = {.lex_state = 101, .external_lex_state = 35},
  [4733] = {.lex_state = 103, .external_lex_state = 35},
  [4734] = {.lex_state = 101, .external_lex_state = 35},
  [4735] = {.lex_state = 101, .external_lex_state = 35},
  [4736] = {.lex_state = 101, .external_lex_state = 35},
  [4737] = {.lex_state = 101, .external_lex_state = 35},
  [4738] = {.lex_state = 101, .external_lex_state = 35},
  [4739] = {.lex_state = 101, .external_lex_state = 35},
  [4740] = {.lex_state = 101, .external_lex_state = 35},
  [4741] = {.lex_state = 101, .external_lex_state = 35},
  [4742] = {.lex_state = 101, .external_lex_state = 35},
  [4743] = {.lex_state = 101, .external_lex_state = 32},
  [4744] = {.lex_state = 111, .external_lex_state = 36},
  [4745] = {.lex_state = 101, .external_lex_state = 35},
  [4746] = {.lex_state = 111, .external_lex_state = 36},
  [4747] = {.lex_state = 231, .external_lex_state = 32},
  [4748] = {.lex_state = 231, .external_lex_state = 32},
  [4749] = {.lex_state = 231, .external_lex_state = 32},
  [4750] = {.lex_state = 231, .external_lex_state = 32},
  [4751] = {.lex_state = 101, .external_lex_state = 32},
  [4752] = {.lex_state = 231, .external_lex_state = 32},
  [4753] = {.lex_state = 231, .external_lex_state = 32},
  [4754] = {.lex_state = 101, .external_lex_state = 32},
  [4755] = {.lex_state = 109, .external_lex_state = 32},
  [4756] = {.lex_state = 231, .external_lex_state = 32},
  [4757] = {.lex_state = 231, .external_lex_state = 32},
  [4758] = {.lex_state = 103, .external_lex_state = 35},
  [4759] = {.lex_state = 231, .external_lex_state = 32},
  [4760] = {.lex_state = 101, .external_lex_state = 35},
  [4761] = {.lex_state = 236, .external_lex_state = 32},
  [4762] = {.lex_state = 231, .external_lex_state = 32},
  [4763] = {.lex_state = 231, .external_lex_state = 32},
  [4764] = {.lex_state = 101, .external_lex_state = 35},
  [4765] = {.lex_state = 111, .external_lex_state = 36},
  [4766] = {.lex_state = 111, .external_lex_state = 36},
  [4767] = {.lex_state = 231, .external_lex_state = 32},
  [4768] = {.lex_state = 101, .external_lex_state = 32},
  [4769] = {.lex_state = 110, .external_lex_state = 33},
  [4770] = {.lex_state = 101, .external_lex_state = 32},
  [4771] = {.lex_state = 101, .external_lex_state = 32},
  [4772] = {.lex_state = 111, .external_lex_state = 36},
  [4773] = {.lex_state = 110, .external_lex_state = 33},
  [4774] = {.lex_state = 101, .external_lex_state = 35},
  [4775] = {.lex_state = 231, .external_lex_state = 32},
  [4776] = {.lex_state = 101, .external_lex_state = 32},
  [4777] = {.lex_state = 111, .external_lex_state = 36},
  [4778] = {.lex_state = 111, .external_lex_state = 36},
  [4779] = {.lex_state = 231, .external_lex_state = 32},
  [4780] = {.lex_state = 231, .external_lex_state = 32},
  [4781] = {.lex_state = 115, .external_lex_state = 34},
  [4782] = {.lex_state = 101, .external_lex_state = 32},
  [4783] = {.lex_state = 101, .external_lex_state = 32},
  [4784] = {.lex_state = 115, .external_lex_state = 34},
  [4785] = {.lex_state = 110, .external_lex_state = 35},
  [4786] = {.lex_state = 110, .external_lex_state = 35},
  [4787] = {.lex_state = 231, .external_lex_state = 32},
  [4788] = {.lex_state = 101, .external_lex_state = 35},
  [4789] = {.lex_state = 101, .external_lex_state = 35},
  [4790] = {.lex_state = 101, .external_lex_state = 35},
  [4791] = {.lex_state = 101, .external_lex_state = 35},
  [4792] = {.lex_state = 231, .external_lex_state = 32},
  [4793] = {.lex_state = 101, .external_lex_state = 32},
  [4794] = {.lex_state = 101, .external_lex_state = 32},
  [4795] = {.lex_state = 115, .external_lex_state = 34},
  [4796] = {.lex_state = 101, .external_lex_state = 32},
  [4797] = {.lex_state = 103, .external_lex_state = 35},
  [4798] = {.lex_state = 115, .external_lex_state = 34},
  [4799] = {.lex_state = 101, .external_lex_state = 35},
  [4800] = {.lex_state = 111, .external_lex_state = 36},
  [4801] = {.lex_state = 101, .external_lex_state = 35},
  [4802] = {.lex_state = 101, .external_lex_state = 35},
  [4803] = {.lex_state = 101, .external_lex_state = 35},
  [4804] = {.lex_state = 101, .external_lex_state = 35},
  [4805] = {.lex_state = 111, .external_lex_state = 36},
  [4806] = {.lex_state = 101, .external_lex_state = 32},
  [4807] = {.lex_state = 101, .external_lex_state = 32},
  [4808] = {.lex_state = 111, .external_lex_state = 36},
  [4809] = {.lex_state = 101, .external_lex_state = 35},
  [4810] = {.lex_state = 231, .external_lex_state = 32},
  [4811] = {.lex_state = 101, .external_lex_state = 35},
  [4812] = {.lex_state = 107, .external_lex_state = 32},
  [4813] = {.lex_state = 231, .external_lex_state = 32},
  [4814] = {.lex_state = 110, .external_lex_state = 35},
  [4815] = {.lex_state = 110, .external_lex_state = 35},
  [4816] = {.lex_state = 101, .external_lex_state = 35},
  [4817] = {.lex_state = 101, .external_lex_state = 35},
  [4818] = {.lex_state = 101, .external_lex_state = 35},
  [4819] = {.lex_state = 101, .external_lex_state = 35},
  [4820] = {.lex_state = 101, .external_lex_state = 35},
  [4821] = {.lex_state = 115, .external_lex_state = 34},
  [4822] = {.lex_state = 101, .external_lex_state = 35},
  [4823] = {.lex_state = 101, .external_lex_state = 35},
  [4824] = {.lex_state = 101, .external_lex_state = 35},
  [4825] = {.lex_state = 101, .external_lex_state = 35},
  [4826] = {.lex_state = 101, .external_lex_state = 35},
  [4827] = {.lex_state = 110, .external_lex_state = 35},
  [4828] = {.lex_state = 101, .external_lex_state = 35},
  [4829] = {.lex_state = 101, .external_lex_state = 35},
  [4830] = {.lex_state = 231, .external_lex_state = 32},
  [4831] = {.lex_state = 101, .external_lex_state = 35},
  [4832] = {.lex_state = 101, .external_lex_state = 35},
  [4833] = {.lex_state = 101, .external_lex_state = 35},
  [4834] = {.lex_state = 111, .external_lex_state = 36},
  [4835] = {.lex_state = 101, .external_lex_state = 32},
  [4836] = {.lex_state = 110, .external_lex_state = 33},
  [4837] = {.lex_state = 101, .external_lex_state = 32},
  [4838] = {.lex_state = 101, .external_lex_state = 32},
  [4839] = {.lex_state = 101, .external_lex_state = 32},
  [4840] = {.lex_state = 101, .external_lex_state = 35},
  [4841] = {.lex_state = 101, .external_lex_state = 35},
  [4842] = {.lex_state = 101, .external_lex_state = 32},
  [4843] = {.lex_state = 101, .external_lex_state = 35},
  [4844] = {.lex_state = 109, .external_lex_state = 32},
  [4845] = {.lex_state = 101, .external_lex_state = 35},
  [4846] = {.lex_state = 101, .external_lex_state = 32},
  [4847] = {.lex_state = 101, .external_lex_state = 35},
  [4848] = {.lex_state = 110, .external_lex_state = 33},
  [4849] = {.lex_state = 101, .external_lex_state = 35},
  [4850] = {.lex_state = 101, .external_lex_state = 32},
  [4851] = {.lex_state = 101, .external_lex_state = 32},
  [4852] = {.lex_state = 101, .external_lex_state = 35},
  [4853] = {.lex_state = 101, .external_lex_state = 32},
  [4854] = {.lex_state = 101, .external_lex_state = 35},
  [4855] = {.lex_state = 101, .external_lex_state = 32},
  [4856] = {.lex_state = 101, .external_lex_state = 32},
  [4857] = {.lex_state = 101, .external_lex_state = 32},
  [4858] = {.lex_state = 110, .external_lex_state = 33},
  [4859] = {.lex_state = 101, .external_lex_state = 35},
  [4860] = {.lex_state = 101, .external_lex_state = 35},
  [4861] = {.lex_state = 103, .external_lex_state = 35},
  [4862] = {.lex_state = 101, .external_lex_state = 32},
  [4863] = {.lex_state = 110, .external_lex_state = 33},
  [4864] = {.lex_state = 110, .external_lex_state = 33},
  [4865] = {.lex_state = 101, .external_lex_state = 32},
  [4866] = {.lex_state = 101, .external_lex_state = 32},
  [4867] = {.lex_state = 101, .external_lex_state = 32},
  [4868] = {.lex_state = 101, .external_lex_state = 32},
  [4869] = {.lex_state = 110, .external_lex_state = 36},
  [4870] = {.lex_state = 110, .external_lex_state = 33},
  [4871] = {.lex_state = 101, .external_lex_state = 32},
  [4872] = {.lex_state = 101, .external_lex_state = 32},
  [4873] = {.lex_state = 101, .external_lex_state = 32},
  [4874] = {.lex_state = 101, .external_lex_state = 32},
  [4875] = {.lex_state = 101, .external_lex_state = 32},
  [4876] = {.lex_state = 101, .external_lex_state = 32},
  [4877] = {.lex_state = 101, .external_lex_state = 32},
  [4878] = {.lex_state = 101, .external_lex_state = 32},
  [4879] = {.lex_state = 110, .external_lex_state = 33},
  [4880] = {.lex_state = 110, .external_lex_state = 33},
  [4881] = {.lex_state = 110, .external_lex_state = 33},
  [4882] = {.lex_state = 101, .external_lex_state = 32},
  [4883] = {.lex_state = 101, .external_lex_state = 35},
  [4884] = {.lex_state = 101, .external_lex_state = 35},
  [4885] = {.lex_state = 101, .external_lex_state = 35},
  [4886] = {.lex_state = 101, .external_lex_state = 35},
  [4887] = {.lex_state = 101, .external_lex_state = 35},
  [4888] = {.lex_state = 101, .external_lex_state = 35},
  [4889] = {.lex_state = 101, .external_lex_state = 35},
  [4890] = {.lex_state = 99, .external_lex_state = 37},
  [4891] = {.lex_state = 99, .external_lex_state = 37},
  [4892] = {.lex_state = 101, .external_lex_state = 35},
  [4893] = {.lex_state = 101, .external_lex_state = 35},
  [4894] = {.lex_state = 101, .external_lex_state = 35},
  [4895] = {.lex_state = 101, .external_lex_state = 35},
  [4896] = {.lex_state = 101, .external_lex_state = 35},
  [4897] = {.lex_state = 99, .external_lex_state = 37},
  [4898] = {.lex_state = 99, .external_lex_state = 37},
  [4899] = {.lex_state = 99, .external_lex_state = 37},
  [4900] = {.lex_state = 99, .external_lex_state = 37},
  [4901] = {.lex_state = 99, .external_lex_state = 37},
  [4902] = {.lex_state = 99, .external_lex_state = 37},
  [4903] = {.lex_state = 99, .external_lex_state = 37},
  [4904] = {.lex_state = 99, .external_lex_state = 37},
  [4905] = {.lex_state = 101, .external_lex_state = 35},
  [4906] = {.lex_state = 101, .external_lex_state = 35},
  [4907] = {.lex_state = 101, .external_lex_state = 35},
  [4908] = {.lex_state = 101, .external_lex_state = 35},
  [4909] = {.lex_state = 101, .external_lex_state = 35},
  [4910] = {.lex_state = 101, .external_lex_state = 35},
  [4911] = {.lex_state = 101, .external_lex_state = 35},
  [4912] = {.lex_state = 101, .external_lex_state = 35},
  [4913] = {.lex_state = 99, .external_lex_state = 37},
  [4914] = {.lex_state = 99, .external_lex_state = 37},
  [4915] = {.lex_state = 101, .external_lex_state = 32},
  [4916] = {.lex_state = 101, .external_lex_state = 32},
  [4917] = {.lex_state = 101, .external_lex_state = 35},
  [4918] = {.lex_state = 99, .external_lex_state = 37},
  [4919] = {.lex_state = 101, .external_lex_state = 32},
  [4920] = {.lex_state = 101, .external_lex_state = 35},
  [4921] = {.lex_state = 101, .external_lex_state = 35},
  [4922] = {.lex_state = 101, .external_lex_state = 35},
  [4923] = {.lex_state = 101, .external_lex_state = 32},
  [4924] = {.lex_state = 99, .external_lex_state = 37},
  [4925] = {.lex_state = 101, .external_lex_state = 35},
  [4926] = {.lex_state = 101, .external_lex_state = 35},
  [4927] = {.lex_state = 99, .external_lex_state = 37},
  [4928] = {.lex_state = 99, .external_lex_state = 37},
  [4929] = {.lex_state = 99, .external_lex_state = 37},
  [4930] = {.lex_state = 99, .external_lex_state = 37},
  [4931] = {.lex_state = 99, .external_lex_state = 37},
  [4932] = {.lex_state = 101, .external_lex_state = 35},
  [4933] = {.lex_state = 99, .external_lex_state = 37},
  [4934] = {.lex_state = 101, .external_lex_state = 32},
  [4935] = {.lex_state = 101, .external_lex_state = 35},
  [4936] = {.lex_state = 101, .external_lex_state = 35},
  [4937] = {.lex_state = 101, .external_lex_state = 35},
  [4938] = {.lex_state = 101, .external_lex_state = 35},
  [4939] = {.lex_state = 101, .external_lex_state = 35},
  [4940] = {.lex_state = 110, .external_lex_state = 36},
  [4941] = {.lex_state = 101, .external_lex_state = 35},
  [4942] = {.lex_state = 111, .external_lex_state = 36},
  [4943] = {.lex_state = 101, .external_lex_state = 35},
  [4944] = {.lex_state = 111, .external_lex_state = 36},
  [4945] = {.lex_state = 111, .external_lex_state = 36},
  [4946] = {.lex_state = 111, .external_lex_state = 36},
  [4947] = {.lex_state = 111, .external_lex_state = 36},
  [4948] = {.lex_state = 101, .external_lex_state = 35},
  [4949] = {.lex_state = 111, .external_lex_state = 36},
  [4950] = {.lex_state = 111, .external_lex_state = 36},
  [4951] = {.lex_state = 111, .external_lex_state = 36},
  [4952] = {.lex_state = 111, .external_lex_state = 36},
  [4953] = {.lex_state = 111, .external_lex_state = 36},
  [4954] = {.lex_state = 101, .external_lex_state = 35},
  [4955] = {.lex_state = 101, .external_lex_state = 35},
  [4956] = {.lex_state = 101, .external_lex_state = 35},
  [4957] = {.lex_state = 110, .external_lex_state = 36},
  [4958] = {.lex_state = 101, .external_lex_state = 35},
  [4959] = {.lex_state = 101, .external_lex_state = 32},
  [4960] = {.lex_state = 99, .external_lex_state = 37},
  [4961] = {.lex_state = 99, .external_lex_state = 37},
  [4962] = {.lex_state = 101, .external_lex_state = 35},
  [4963] = {.lex_state = 99, .external_lex_state = 37},
  [4964] = {.lex_state = 99, .external_lex_state = 37},
  [4965] = {.lex_state = 101, .external_lex_state = 35},
  [4966] = {.lex_state = 99, .external_lex_state = 37},
  [4967] = {.lex_state = 101, .external_lex_state = 35},
  [4968] = {.lex_state = 99, .external_lex_state = 37},
  [4969] = {.lex_state = 101, .external_lex_state = 35},
  [4970] = {.lex_state = 101, .external_lex_state = 35},
  [4971] = {.lex_state = 101, .external_lex_state = 35},
  [4972] = {.lex_state = 101, .external_lex_state = 35},
  [4973] = {.lex_state = 111, .external_lex_state = 36},
  [4974] = {.lex_state = 101, .external_lex_state = 35},
  [4975] = {.lex_state = 101, .external_lex_state = 35},
  [4976] = {.lex_state = 101, .external_lex_state = 35},
  [4977] = {.lex_state = 101, .external_lex_state = 35},
  [4978] = {.lex_state = 111, .external_lex_state = 36},
  [4979] = {.lex_state = 101, .external_lex_state = 32},
  [4980] = {.lex_state = 111, .external_lex_state = 36},
  [4981] = {.lex_state = 101, .external_lex_state = 35},
  [4982] = {.lex_state = 101, .external_lex_state = 35},
  [4983] = {.lex_state = 111, .external_lex_state = 36},
  [4984] = {.lex_state = 110, .external_lex_state = 36},
  [4985] = {.lex_state = 101, .external_lex_state = 35},
  [4986] = {.lex_state = 101, .external_lex_state = 32},
  [4987] = {.lex_state = 111, .external_lex_state = 36},
  [4988] = {.lex_state = 111, .external_lex_state = 36},
  [4989] = {.lex_state = 99, .external_lex_state = 37},
  [4990] = {.lex_state = 101, .external_lex_state = 35},
  [4991] = {.lex_state = 111, .external_lex_state = 36},
  [4992] = {.lex_state = 101, .external_lex_state = 35},
  [4993] = {.lex_state = 101, .external_lex_state = 35},
  [4994] = {.lex_state = 99, .external_lex_state = 37},
  [4995] = {.lex_state = 111, .external_lex_state = 36},
  [4996] = {.lex_state = 110, .external_lex_state = 36},
  [4997] = {.lex_state = 111, .external_lex_state = 36},
  [4998] = {.lex_state = 99, .external_lex_state = 37},
  [4999] = {.lex_state = 99, .external_lex_state = 37},
  [5000] = {.lex_state = 101, .external_lex_state = 32},
  [5001] = {.lex_state = 101, .external_lex_state = 35},
  [5002] = {.lex_state = 99, .external_lex_state = 37},
  [5003] = {.lex_state = 99, .external_lex_state = 37},
  [5004] = {.lex_state = 99, .external_lex_state = 37},
  [5005] = {.lex_state = 101, .external_lex_state = 35},
  [5006] = {.lex_state = 101, .external_lex_state = 35},
  [5007] = {.lex_state = 111, .external_lex_state = 36},
  [5008] = {.lex_state = 111, .external_lex_state = 36},
  [5009] = {.lex_state = 99, .external_lex_state = 37},
  [5010] = {.lex_state = 99, .external_lex_state = 37},
  [5011] = {.lex_state = 101, .external_lex_state = 35},
  [5012] = {.lex_state = 111, .external_lex_state = 36},
  [5013] = {.lex_state = 99, .external_lex_state = 37},
  [5014] = {.lex_state = 99, .external_lex_state = 37},
  [5015] = {.lex_state = 99, .external_lex_state = 37},
  [5016] = {.lex_state = 101, .external_lex_state = 35},
  [5017] = {.lex_state = 99, .external_lex_state = 37},
  [5018] = {.lex_state = 101, .external_lex_state = 35},
  [5019] = {.lex_state = 99, .external_lex_state = 37},
  [5020] = {.lex_state = 99, .external_lex_state = 37},
  [5021] = {.lex_state = 101, .external_lex_state = 35},
  [5022] = {.lex_state = 101, .external_lex_state = 35},
  [5023] = {.lex_state = 99, .external_lex_state = 37},
  [5024] = {.lex_state = 101, .external_lex_state = 35},
  [5025] = {.lex_state = 101, .external_lex_state = 35},
  [5026] = {.lex_state = 101, .external_lex_state = 32},
  [5027] = {.lex_state = 111, .external_lex_state = 36},
  [5028] = {.lex_state = 110, .external_lex_state = 36},
  [5029] = {.lex_state = 101, .external_lex_state = 35},
  [5030] = {.lex_state = 101, .external_lex_state = 35},
  [5031] = {.lex_state = 101, .external_lex_state = 35},
  [5032] = {.lex_state = 101, .external_lex_state = 35},
  [5033] = {.lex_state = 101, .external_lex_state = 35},
  [5034] = {.lex_state = 110, .external_lex_state = 36},
  [5035] = {.lex_state = 99, .external_lex_state = 37},
  [5036] = {.lex_state = 101, .external_lex_state = 35},
  [5037] = {.lex_state = 225, .external_lex_state = 38},
  [5038] = {.lex_state = 214, .external_lex_state = 35},
  [5039] = {.lex_state = 214, .external_lex_state = 35},
  [5040] = {.lex_state = 101, .external_lex_state = 35},
  [5041] = {.lex_state = 100, .external_lex_state = 37},
  [5042] = {.lex_state = 100, .external_lex_state = 37},
  [5043] = {.lex_state = 100, .external_lex_state = 37},
  [5044] = {.lex_state = 110, .external_lex_state = 33},
  [5045] = {.lex_state = 214, .external_lex_state = 35},
  [5046] = {.lex_state = 100, .external_lex_state = 37},
  [5047] = {.lex_state = 100, .external_lex_state = 37},
  [5048] = {.lex_state = 100, .external_lex_state = 37},
  [5049] = {.lex_state = 100, .external_lex_state = 37},
  [5050] = {.lex_state = 101, .external_lex_state = 35},
  [5051] = {.lex_state = 100, .external_lex_state = 37},
  [5052] = {.lex_state = 100, .external_lex_state = 37},
  [5053] = {.lex_state = 100, .external_lex_state = 37},
  [5054] = {.lex_state = 100, .external_lex_state = 37},
  [5055] = {.lex_state = 100, .external_lex_state = 37},
  [5056] = {.lex_state = 101, .external_lex_state = 32},
  [5057] = {.lex_state = 100, .external_lex_state = 37},
  [5058] = {.lex_state = 214, .external_lex_state = 35},
  [5059] = {.lex_state = 100, .external_lex_state = 37},
  [5060] = {.lex_state = 214, .external_lex_state = 35},
  [5061] = {.lex_state = 214, .external_lex_state = 35},
  [5062] = {.lex_state = 100, .external_lex_state = 37},
  [5063] = {.lex_state = 100, .external_lex_state = 37},
  [5064] = {.lex_state = 100, .external_lex_state = 37},
  [5065] = {.lex_state = 101, .external_lex_state = 32},
  [5066] = {.lex_state = 101, .external_lex_state = 32},
  [5067] = {.lex_state = 100, .external_lex_state = 37},
  [5068] = {.lex_state = 214, .external_lex_state = 35},
  [5069] = {.lex_state = 100, .external_lex_state = 37},
  [5070] = {.lex_state = 214, .external_lex_state = 35},
  [5071] = {.lex_state = 110, .external_lex_state = 33},
  [5072] = {.lex_state = 101, .external_lex_state = 35},
  [5073] = {.lex_state = 214, .external_lex_state = 35},
  [5074] = {.lex_state = 100, .external_lex_state = 37},
  [5075] = {.lex_state = 100, .external_lex_state = 39},
  [5076] = {.lex_state = 100, .external_lex_state = 37},
  [5077] = {.lex_state = 100, .external_lex_state = 37},
  [5078] = {.lex_state = 100, .external_lex_state = 37},
  [5079] = {.lex_state = 100, .external_lex_state = 37},
  [5080] = {.lex_state = 100, .external_lex_state = 37},
  [5081] = {.lex_state = 100, .external_lex_state = 37},
  [5082] = {.lex_state = 100, .external_lex_state = 37},
  [5083] = {.lex_state = 100, .external_lex_state = 37},
  [5084] = {.lex_state = 100, .external_lex_state = 37},
  [5085] = {.lex_state = 214, .external_lex_state = 35},
  [5086] = {.lex_state = 100, .external_lex_state = 37},
  [5087] = {.lex_state = 101, .external_lex_state = 35},
  [5088] = {.lex_state = 100, .external_lex_state = 37},
  [5089] = {.lex_state = 100, .external_lex_state = 37},
  [5090] = {.lex_state = 100, .external_lex_state = 37},
  [5091] = {.lex_state = 101, .external_lex_state = 35},
  [5092] = {.lex_state = 100, .external_lex_state = 37},
  [5093] = {.lex_state = 100, .external_lex_state = 37},
  [5094] = {.lex_state = 214, .external_lex_state = 35},
  [5095] = {.lex_state = 100, .external_lex_state = 37},
  [5096] = {.lex_state = 100, .external_lex_state = 37},
  [5097] = {.lex_state = 214, .external_lex_state = 35},
  [5098] = {.lex_state = 100, .external_lex_state = 37},
  [5099] = {.lex_state = 214, .external_lex_state = 35},
  [5100] = {.lex_state = 100, .external_lex_state = 37},
  [5101] = {.lex_state = 100, .external_lex_state = 37},
  [5102] = {.lex_state = 214, .external_lex_state = 35},
  [5103] = {.lex_state = 214, .external_lex_state = 35},
  [5104] = {.lex_state = 101, .external_lex_state = 32},
  [5105] = {.lex_state = 101, .external_lex_state = 32},
  [5106] = {.lex_state = 101, .external_lex_state = 32},
  [5107] = {.lex_state = 100, .external_lex_state = 37},
  [5108] = {.lex_state = 101, .external_lex_state = 32},
  [5109] = {.lex_state = 100, .external_lex_state = 37},
  [5110] = {.lex_state = 110, .external_lex_state = 33},
  [5111] = {.lex_state = 100, .external_lex_state = 37},
  [5112] = {.lex_state = 110, .external_lex_state = 33},
  [5113] = {.lex_state = 110, .external_lex_state = 33},
  [5114] = {.lex_state = 100, .external_lex_state = 37},
  [5115] = {.lex_state = 100, .external_lex_state = 37},
  [5116] = {.lex_state = 100, .external_lex_state = 37},
  [5117] = {.lex_state = 110, .external_lex_state = 36},
  [5118] = {.lex_state = 110, .external_lex_state = 33},
  [5119] = {.lex_state = 110, .external_lex_state = 33},
  [5120] = {.lex_state = 110, .external_lex_state = 33},
  [5121] = {.lex_state = 100, .external_lex_state = 37},
  [5122] = {.lex_state = 100, .external_lex_state = 37},
  [5123] = {.lex_state = 100, .external_lex_state = 37},
  [5124] = {.lex_state = 110, .external_lex_state = 33},
  [5125] = {.lex_state = 100, .external_lex_state = 37},
  [5126] = {.lex_state = 100, .external_lex_state = 37},
  [5127] = {.lex_state = 110, .external_lex_state = 33},
  [5128] = {.lex_state = 110, .external_lex_state = 33},
  [5129] = {.lex_state = 100, .external_lex_state = 37},
  [5130] = {.lex_state = 214, .external_lex_state = 35},
  [5131] = {.lex_state = 214, .external_lex_state = 35},
  [5132] = {.lex_state = 110, .external_lex_state = 33},
  [5133] = {.lex_state = 110, .external_lex_state = 33},
  [5134] = {.lex_state = 214, .external_lex_state = 35},
  [5135] = {.lex_state = 110, .external_lex_state = 33},
  [5136] = {.lex_state = 214, .external_lex_state = 35},
  [5137] = {.lex_state = 110, .external_lex_state = 33},
  [5138] = {.lex_state = 110, .external_lex_state = 33},
  [5139] = {.lex_state = 214, .external_lex_state = 35},
  [5140] = {.lex_state = 110, .external_lex_state = 33},
  [5141] = {.lex_state = 110, .external_lex_state = 33},
  [5142] = {.lex_state = 110, .external_lex_state = 33},
  [5143] = {.lex_state = 110, .external_lex_state = 33},
  [5144] = {.lex_state = 100, .external_lex_state = 37},
  [5145] = {.lex_state = 100, .external_lex_state = 37},
  [5146] = {.lex_state = 214, .external_lex_state = 35},
  [5147] = {.lex_state = 100, .external_lex_state = 37},
  [5148] = {.lex_state = 100, .external_lex_state = 37},
  [5149] = {.lex_state = 100, .external_lex_state = 37},
  [5150] = {.lex_state = 110, .external_lex_state = 33},
  [5151] = {.lex_state = 100, .external_lex_state = 39},
  [5152] = {.lex_state = 214, .external_lex_state = 35},
  [5153] = {.lex_state = 214, .external_lex_state = 35},
  [5154] = {.lex_state = 100, .external_lex_state = 39},
  [5155] = {.lex_state = 101, .external_lex_state = 32},
  [5156] = {.lex_state = 100, .external_lex_state = 37},
  [5157] = {.lex_state = 100, .external_lex_state = 37},
  [5158] = {.lex_state = 214, .external_lex_state = 35},
  [5159] = {.lex_state = 214, .external_lex_state = 35},
  [5160] = {.lex_state = 100, .external_lex_state = 37},
  [5161] = {.lex_state = 100, .external_lex_state = 37},
  [5162] = {.lex_state = 100, .external_lex_state = 37},
  [5163] = {.lex_state = 225, .external_lex_state = 38},
  [5164] = {.lex_state = 214, .external_lex_state = 35},
  [5165] = {.lex_state = 100, .external_lex_state = 37},
  [5166] = {.lex_state = 100, .external_lex_state = 37},
  [5167] = {.lex_state = 101, .external_lex_state = 35},
  [5168] = {.lex_state = 100, .external_lex_state = 37},
  [5169] = {.lex_state = 100, .external_lex_state = 37},
  [5170] = {.lex_state = 100, .external_lex_state = 37},
  [5171] = {.lex_state = 214, .external_lex_state = 35},
  [5172] = {.lex_state = 100, .external_lex_state = 37},
  [5173] = {.lex_state = 100, .external_lex_state = 37},
  [5174] = {.lex_state = 214, .external_lex_state = 35},
  [5175] = {.lex_state = 100, .external_lex_state = 37},
  [5176] = {.lex_state = 100, .external_lex_state = 37},
  [5177] = {.lex_state = 100, .external_lex_state = 37},
  [5178] = {.lex_state = 214, .external_lex_state = 35},
  [5179] = {.lex_state = 100, .external_lex_state = 37},
  [5180] = {.lex_state = 214, .external_lex_state = 35},
  [5181] = {.lex_state = 100, .external_lex_state = 37},
  [5182] = {.lex_state = 214, .external_lex_state = 35},
  [5183] = {.lex_state = 100, .external_lex_state = 37},
  [5184] = {.lex_state = 214, .external_lex_state = 35},
  [5185] = {.lex_state = 214, .external_lex_state = 35},
  [5186] = {.lex_state = 100, .external_lex_state = 37},
  [5187] = {.lex_state = 214, .external_lex_state = 35},
  [5188] = {.lex_state = 214, .external_lex_state = 35},
  [5189] = {.lex_state = 214, .external_lex_state = 35},
  [5190] = {.lex_state = 214, .external_lex_state = 35},
  [5191] = {.lex_state = 214, .external_lex_state = 35},
  [5192] = {.lex_state = 214, .external_lex_state = 35},
  [5193] = {.lex_state = 214, .external_lex_state = 35},
  [5194] = {.lex_state = 214, .external_lex_state = 35},
  [5195] = {.lex_state = 214, .external_lex_state = 35},
  [5196] = {.lex_state = 214, .external_lex_state = 35},
  [5197] = {.lex_state = 214, .external_lex_state = 35},
  [5198] = {.lex_state = 100, .external_lex_state = 37},
  [5199] = {.lex_state = 214, .external_lex_state = 35},
  [5200] = {.lex_state = 100, .external_lex_state = 37},
  [5201] = {.lex_state = 100, .external_lex_state = 37},
  [5202] = {.lex_state = 100, .external_lex_state = 37},
  [5203] = {.lex_state = 100, .external_lex_state = 37},
  [5204] = {.lex_state = 100, .external_lex_state = 37},
  [5205] = {.lex_state = 100, .external_lex_state = 37},
  [5206] = {.lex_state = 100, .external_lex_state = 37},
  [5207] = {.lex_state = 100, .external_lex_state = 37},
  [5208] = {.lex_state = 214, .external_lex_state = 35},
  [5209] = {.lex_state = 100, .external_lex_state = 37},
  [5210] = {.lex_state = 100, .external_lex_state = 37},
  [5211] = {.lex_state = 225, .external_lex_state = 38},
  [5212] = {.lex_state = 110, .external_lex_state = 33},
  [5213] = {.lex_state = 214, .external_lex_state = 35},
  [5214] = {.lex_state = 101, .external_lex_state = 35},
  [5215] = {.lex_state = 101, .external_lex_state = 32},
  [5216] = {.lex_state = 101, .external_lex_state = 35},
  [5217] = {.lex_state = 214, .external_lex_state = 35},
  [5218] = {.lex_state = 101, .external_lex_state = 35},
  [5219] = {.lex_state = 99, .external_lex_state = 37},
  [5220] = {.lex_state = 101, .external_lex_state = 35},
  [5221] = {.lex_state = 101, .external_lex_state = 35},
  [5222] = {.lex_state = 214, .external_lex_state = 35},
  [5223] = {.lex_state = 101, .external_lex_state = 35},
  [5224] = {.lex_state = 214, .external_lex_state = 35},
  [5225] = {.lex_state = 101, .external_lex_state = 32},
  [5226] = {.lex_state = 101, .external_lex_state = 35},
  [5227] = {.lex_state = 101, .external_lex_state = 35},
  [5228] = {.lex_state = 101, .external_lex_state = 35},
  [5229] = {.lex_state = 101, .external_lex_state = 35},
  [5230] = {.lex_state = 225, .external_lex_state = 36},
  [5231] = {.lex_state = 99, .external_lex_state = 37},
  [5232] = {.lex_state = 101, .external_lex_state = 35},
  [5233] = {.lex_state = 225, .external_lex_state = 36},
  [5234] = {.lex_state = 225, .external_lex_state = 36},
  [5235] = {.lex_state = 101, .external_lex_state = 35},
  [5236] = {.lex_state = 101, .external_lex_state = 35},
  [5237] = {.lex_state = 225, .external_lex_state = 36},
  [5238] = {.lex_state = 101, .external_lex_state = 35},
  [5239] = {.lex_state = 101, .external_lex_state = 35},
  [5240] = {.lex_state = 101, .external_lex_state = 35},
  [5241] = {.lex_state = 101, .external_lex_state = 35},
  [5242] = {.lex_state = 101, .external_lex_state = 35},
  [5243] = {.lex_state = 101, .external_lex_state = 35},
  [5244] = {.lex_state = 101, .external_lex_state = 35},
  [5245] = {.lex_state = 101, .external_lex_state = 35},
  [5246] = {.lex_state = 101, .external_lex_state = 35},
  [5247] = {.lex_state = 100, .external_lex_state = 40},
  [5248] = {.lex_state = 101, .external_lex_state = 35},
  [5249] = {.lex_state = 101, .external_lex_state = 35},
  [5250] = {.lex_state = 101, .external_lex_state = 35},
  [5251] = {.lex_state = 101, .external_lex_state = 35},
  [5252] = {.lex_state = 99, .external_lex_state = 37},
  [5253] = {.lex_state = 101, .external_lex_state = 35},
  [5254] = {.lex_state = 101, .external_lex_state = 35},
  [5255] = {.lex_state = 101, .external_lex_state = 35},
  [5256] = {.lex_state = 101, .external_lex_state = 35},
  [5257] = {.lex_state = 101, .external_lex_state = 35},
  [5258] = {.lex_state = 101, .external_lex_state = 35},
  [5259] = {.lex_state = 101, .external_lex_state = 35},
  [5260] = {.lex_state = 101, .external_lex_state = 35},
  [5261] = {.lex_state = 101, .external_lex_state = 35},
  [5262] = {.lex_state = 225, .external_lex_state = 36},
  [5263] = {.lex_state = 100, .external_lex_state = 40},
  [5264] = {.lex_state = 214, .external_lex_state = 35},
  [5265] = {.lex_state = 225, .external_lex_state = 36},
  [5266] = {.lex_state = 101, .external_lex_state = 35},
  [5267] = {.lex_state = 101, .external_lex_state = 32},
  [5268] = {.lex_state = 101, .external_lex_state = 35},
  [5269] = {.lex_state = 101, .external_lex_state = 35},
  [5270] = {.lex_state = 101, .external_lex_state = 35},
  [5271] = {.lex_state = 101, .external_lex_state = 32},
  [5272] = {.lex_state = 101, .external_lex_state = 35},
  [5273] = {.lex_state = 101, .external_lex_state = 35},
  [5274] = {.lex_state = 101, .external_lex_state = 35},
  [5275] = {.lex_state = 110, .external_lex_state = 36},
  [5276] = {.lex_state = 101, .external_lex_state = 35},
  [5277] = {.lex_state = 101, .external_lex_state = 32},
  [5278] = {.lex_state = 101, .external_lex_state = 35},
  [5279] = {.lex_state = 101, .external_lex_state = 35},
  [5280] = {.lex_state = 101, .external_lex_state = 35},
  [5281] = {.lex_state = 101, .external_lex_state = 35},
  [5282] = {.lex_state = 101, .external_lex_state = 35},
  [5283] = {.lex_state = 110, .external_lex_state = 36},
  [5284] = {.lex_state = 101, .external_lex_state = 35},
  [5285] = {.lex_state = 101, .external_lex_state = 35},
  [5286] = {.lex_state = 101, .external_lex_state = 35},
  [5287] = {.lex_state = 99, .external_lex_state = 37},
  [5288] = {.lex_state = 214, .external_lex_state = 35},
  [5289] = {.lex_state = 101, .external_lex_state = 35},
  [5290] = {.lex_state = 225, .external_lex_state = 38},
  [5291] = {.lex_state = 101, .external_lex_state = 32},
  [5292] = {.lex_state = 107, .external_lex_state = 35},
  [5293] = {.lex_state = 101, .external_lex_state = 35},
  [5294] = {.lex_state = 101, .external_lex_state = 32},
  [5295] = {.lex_state = 101, .external_lex_state = 35},
  [5296] = {.lex_state = 100, .external_lex_state = 37},
  [5297] = {.lex_state = 104, .external_lex_state = 35},
  [5298] = {.lex_state = 100, .external_lex_state = 37},
  [5299] = {.lex_state = 101, .external_lex_state = 32},
  [5300] = {.lex_state = 101, .external_lex_state = 32},
  [5301] = {.lex_state = 101, .external_lex_state = 35},
  [5302] = {.lex_state = 101, .external_lex_state = 35},
  [5303] = {.lex_state = 101, .external_lex_state = 35},
  [5304] = {.lex_state = 104, .external_lex_state = 32},
  [5305] = {.lex_state = 100, .external_lex_state = 37},
  [5306] = {.lex_state = 101, .external_lex_state = 32},
  [5307] = {.lex_state = 104, .external_lex_state = 35},
  [5308] = {.lex_state = 100, .external_lex_state = 39},
  [5309] = {.lex_state = 101, .external_lex_state = 35},
  [5310] = {.lex_state = 100, .external_lex_state = 37},
  [5311] = {.lex_state = 100, .external_lex_state = 39},
  [5312] = {.lex_state = 101, .external_lex_state = 32},
  [5313] = {.lex_state = 101, .external_lex_state = 32},
  [5314] = {.lex_state = 107, .external_lex_state = 35},
  [5315] = {.lex_state = 101, .external_lex_state = 35},
  [5316] = {.lex_state = 101, .external_lex_state = 35},
  [5317] = {.lex_state = 101, .external_lex_state = 32},
  [5318] = {.lex_state = 101, .external_lex_state = 35},
  [5319] = {.lex_state = 225, .external_lex_state = 38},
  [5320] = {.lex_state = 101, .external_lex_state = 32},
  [5321] = {.lex_state = 107, .external_lex_state = 35},
  [5322] = {.lex_state = 100, .external_lex_state = 39},
  [5323] = {.lex_state = 100, .external_lex_state = 39},
  [5324] = {.lex_state = 101, .external_lex_state = 35},
  [5325] = {.lex_state = 225, .external_lex_state = 38},
  [5326] = {.lex_state = 101, .external_lex_state = 32},
  [5327] = {.lex_state = 225, .external_lex_state = 36},
  [5328] = {.lex_state = 225, .external_lex_state = 36},
  [5329] = {.lex_state = 225, .external_lex_state = 36},
  [5330] = {.lex_state = 225, .external_lex_state = 36},
  [5331] = {.lex_state = 225, .external_lex_state = 36},
  [5332] = {.lex_state = 225, .external_lex_state = 36},
  [5333] = {.lex_state = 225, .external_lex_state = 36},
  [5334] = {.lex_state = 101, .external_lex_state = 35},
  [5335] = {.lex_state = 225, .external_lex_state = 36},
  [5336] = {.lex_state = 225, .external_lex_state = 36},
  [5337] = {.lex_state = 225, .external_lex_state = 36},
  [5338] = {.lex_state = 225, .external_lex_state = 36},
  [5339] = {.lex_state = 225, .external_lex_state = 36},
  [5340] = {.lex_state = 225, .external_lex_state = 36},
  [5341] = {.lex_state = 225, .external_lex_state = 36},
  [5342] = {.lex_state = 225, .external_lex_state = 36},
  [5343] = {.lex_state = 225, .external_lex_state = 36},
  [5344] = {.lex_state = 101, .external_lex_state = 35},
  [5345] = {.lex_state = 225, .external_lex_state = 36},
  [5346] = {.lex_state = 225, .external_lex_state = 36},
  [5347] = {.lex_state = 101, .external_lex_state = 32},
  [5348] = {.lex_state = 101, .external_lex_state = 35},
  [5349] = {.lex_state = 225, .external_lex_state = 36},
  [5350] = {.lex_state = 225, .external_lex_state = 36},
  [5351] = {.lex_state = 225, .external_lex_state = 36},
  [5352] = {.lex_state = 225, .external_lex_state = 36},
  [5353] = {.lex_state = 225, .external_lex_state = 36},
  [5354] = {.lex_state = 225, .external_lex_state = 36},
  [5355] = {.lex_state = 225, .external_lex_state = 36},
  [5356] = {.lex_state = 225, .external_lex_state = 36},
  [5357] = {.lex_state = 225, .external_lex_state = 36},
  [5358] = {.lex_state = 225, .external_lex_state = 36},
  [5359] = {.lex_state = 225, .external_lex_state = 36},
  [5360] = {.lex_state = 225, .external_lex_state = 36},
  [5361] = {.lex_state = 225, .external_lex_state = 36},
  [5362] = {.lex_state = 225, .external_lex_state = 36},
  [5363] = {.lex_state = 225, .external_lex_state = 36},
  [5364] = {.lex_state = 225, .external_lex_state = 36},
  [5365] = {.lex_state = 225, .external_lex_state = 36},
  [5366] = {.lex_state = 225, .external_lex_state = 36},
  [5367] = {.lex_state = 225, .external_lex_state = 36},
  [5368] = {.lex_state = 225, .external_lex_state = 36},
  [5369] = {.lex_state = 225, .external_lex_state = 36},
  [5370] = {.lex_state = 225, .external_lex_state = 36},
  [5371] = {.lex_state = 225, .external_lex_state = 36},
  [5372] = {.lex_state = 225, .external_lex_state = 36},
  [5373] = {.lex_state = 225, .external_lex_state = 36},
  [5374] = {.lex_state = 225, .external_lex_state = 36},
  [5375] = {.lex_state = 225, .external_lex_state = 36},
  [5376] = {.lex_state = 225, .external_lex_state = 36},
  [5377] = {.lex_state = 101, .external_lex_state = 35},
  [5378] = {.lex_state = 225, .external_lex_state = 36},
  [5379] = {.lex_state = 225, .external_lex_state = 36},
  [5380] = {.lex_state = 225, .external_lex_state = 36},
  [5381] = {.lex_state = 225, .external_lex_state = 36},
  [5382] = {.lex_state = 214, .external_lex_state = 35},
  [5383] = {.lex_state = 225, .external_lex_state = 36},
  [5384] = {.lex_state = 225, .external_lex_state = 36},
  [5385] = {.lex_state = 225, .external_lex_state = 36},
  [5386] = {.lex_state = 214, .external_lex_state = 35},
  [5387] = {.lex_state = 225, .external_lex_state = 36},
  [5388] = {.lex_state = 225, .external_lex_state = 36},
  [5389] = {.lex_state = 225, .external_lex_state = 36},
  [5390] = {.lex_state = 101, .external_lex_state = 35},
  [5391] = {.lex_state = 225, .external_lex_state = 36},
  [5392] = {.lex_state = 225, .external_lex_state = 36},
  [5393] = {.lex_state = 101, .external_lex_state = 32},
  [5394] = {.lex_state = 101, .external_lex_state = 35},
  [5395] = {.lex_state = 101, .external_lex_state = 35},
  [5396] = {.lex_state = 225, .external_lex_state = 36},
  [5397] = {.lex_state = 101, .external_lex_state = 35},
  [5398] = {.lex_state = 107, .external_lex_state = 35},
  [5399] = {.lex_state = 101, .external_lex_state = 35},
  [5400] = {.lex_state = 225, .external_lex_state = 36},
  [5401] = {.lex_state = 225, .external_lex_state = 36},
  [5402] = {.lex_state = 225, .external_lex_state = 36},
  [5403] = {.lex_state = 101, .external_lex_state = 35},
  [5404] = {.lex_state = 225, .external_lex_state = 36},
  [5405] = {.lex_state = 214, .external_lex_state = 35},
  [5406] = {.lex_state = 225, .external_lex_state = 36},
  [5407] = {.lex_state = 214, .external_lex_state = 35},
  [5408] = {.lex_state = 101, .external_lex_state = 35},
  [5409] = {.lex_state = 101, .external_lex_state = 35},
  [5410] = {.lex_state = 214, .external_lex_state = 32},
  [5411] = {.lex_state = 225, .external_lex_state = 36},
  [5412] = {.lex_state = 101, .external_lex_state = 35},
  [5413] = {.lex_state = 225, .external_lex_state = 36},
  [5414] = {.lex_state = 225, .external_lex_state = 36},
  [5415] = {.lex_state = 214, .external_lex_state = 35},
  [5416] = {.lex_state = 214, .external_lex_state = 35},
  [5417] = {.lex_state = 225, .external_lex_state = 36},
  [5418] = {.lex_state = 225, .external_lex_state = 36},
  [5419] = {.lex_state = 225, .external_lex_state = 36},
  [5420] = {.lex_state = 214, .external_lex_state = 35},
  [5421] = {.lex_state = 225, .external_lex_state = 36},
  [5422] = {.lex_state = 225, .external_lex_state = 36},
  [5423] = {.lex_state = 225, .external_lex_state = 36},
  [5424] = {.lex_state = 101, .external_lex_state = 35},
  [5425] = {.lex_state = 225, .external_lex_state = 36},
  [5426] = {.lex_state = 101, .external_lex_state = 35},
  [5427] = {.lex_state = 225, .external_lex_state = 36},
  [5428] = {.lex_state = 225, .external_lex_state = 36},
  [5429] = {.lex_state = 225, .external_lex_state = 36},
  [5430] = {.lex_state = 214, .external_lex_state = 32},
  [5431] = {.lex_state = 225, .external_lex_state = 36},
  [5432] = {.lex_state = 225, .external_lex_state = 36},
  [5433] = {.lex_state = 225, .external_lex_state = 36},
  [5434] = {.lex_state = 225, .external_lex_state = 36},
  [5435] = {.lex_state = 225, .external_lex_state = 36},
  [5436] = {.lex_state = 225, .external_lex_state = 36},
  [5437] = {.lex_state = 225, .external_lex_state = 36},
  [5438] = {.lex_state = 214, .external_lex_state = 32},
  [5439] = {.lex_state = 225, .external_lex_state = 36},
  [5440] = {.lex_state = 225, .external_lex_state = 36},
  [5441] = {.lex_state = 225, .external_lex_state = 36},
  [5442] = {.lex_state = 225, .external_lex_state = 36},
  [5443] = {.lex_state = 225, .external_lex_state = 36},
  [5444] = {.lex_state = 225, .external_lex_state = 36},
  [5445] = {.lex_state = 214, .external_lex_state = 35},
  [5446] = {.lex_state = 101, .external_lex_state = 35},
  [5447] = {.lex_state = 225, .external_lex_state = 36},
  [5448] = {.lex_state = 214, .external_lex_state = 35},
  [5449] = {.lex_state = 214, .external_lex_state = 35},
  [5450] = {.lex_state = 225, .external_lex_state = 36},
  [5451] = {.lex_state = 225, .external_lex_state = 36},
  [5452] = {.lex_state = 225, .external_lex_state = 36},
  [5453] = {.lex_state = 225, .external_lex_state = 36},
  [5454] = {.lex_state = 225, .external_lex_state = 36},
  [5455] = {.lex_state = 225, .external_lex_state = 36},
  [5456] = {.lex_state = 225, .external_lex_state = 36},
  [5457] = {.lex_state = 225, .external_lex_state = 36},
  [5458] = {.lex_state = 225, .external_lex_state = 36},
  [5459] = {.lex_state = 225, .external_lex_state = 36},
  [5460] = {.lex_state = 225, .external_lex_state = 36},
  [5461] = {.lex_state = 101, .external_lex_state = 35},
  [5462] = {.lex_state = 101, .external_lex_state = 35},
  [5463] = {.lex_state = 101, .external_lex_state = 32},
  [5464] = {.lex_state = 101, .external_lex_state = 32},
  [5465] = {.lex_state = 225, .external_lex_state = 36},
  [5466] = {.lex_state = 225, .external_lex_state = 36},
  [5467] = {.lex_state = 225, .external_lex_state = 36},
  [5468] = {.lex_state = 101, .external_lex_state = 35},
  [5469] = {.lex_state = 107, .external_lex_state = 35},
  [5470] = {.lex_state = 225, .external_lex_state = 36},
  [5471] = {.lex_state = 225, .external_lex_state = 36},
  [5472] = {.lex_state = 225, .external_lex_state = 36},
  [5473] = {.lex_state = 225, .external_lex_state = 36},
  [5474] = {.lex_state = 101, .external_lex_state = 35},
  [5475] = {.lex_state = 225, .external_lex_state = 36},
  [5476] = {.lex_state = 225, .external_lex_state = 36},
  [5477] = {.lex_state = 225, .external_lex_state = 36},
  [5478] = {.lex_state = 225, .external_lex_state = 36},
  [5479] = {.lex_state = 225, .external_lex_state = 36},
  [5480] = {.lex_state = 225, .external_lex_state = 36},
  [5481] = {.lex_state = 101, .external_lex_state = 35},
  [5482] = {.lex_state = 225, .external_lex_state = 36},
  [5483] = {.lex_state = 225, .external_lex_state = 36},
  [5484] = {.lex_state = 225, .external_lex_state = 36},
  [5485] = {.lex_state = 214, .external_lex_state = 35},
  [5486] = {.lex_state = 225, .external_lex_state = 36},
  [5487] = {.lex_state = 225, .external_lex_state = 36},
  [5488] = {.lex_state = 225, .external_lex_state = 36},
  [5489] = {.lex_state = 225, .external_lex_state = 36},
  [5490] = {.lex_state = 101, .external_lex_state = 35},
  [5491] = {.lex_state = 225, .external_lex_state = 36},
  [5492] = {.lex_state = 101, .external_lex_state = 35},
  [5493] = {.lex_state = 104, .external_lex_state = 35},
  [5494] = {.lex_state = 214, .external_lex_state = 35},
  [5495] = {.lex_state = 214, .external_lex_state = 32},
  [5496] = {.lex_state = 119, .external_lex_state = 41},
  [5497] = {.lex_state = 214, .external_lex_state = 35},
  [5498] = {.lex_state = 214, .external_lex_state = 35},
  [5499] = {.lex_state = 214, .external_lex_state = 32},
  [5500] = {.lex_state = 101, .external_lex_state = 32},
  [5501] = {.lex_state = 101, .external_lex_state = 35},
  [5502] = {.lex_state = 119, .external_lex_state = 41},
  [5503] = {.lex_state = 214, .external_lex_state = 32},
  [5504] = {.lex_state = 214, .external_lex_state = 35},
  [5505] = {.lex_state = 214, .external_lex_state = 32},
  [5506] = {.lex_state = 119, .external_lex_state = 41},
  [5507] = {.lex_state = 214, .external_lex_state = 32},
  [5508] = {.lex_state = 214, .external_lex_state = 35},
  [5509] = {.lex_state = 101, .external_lex_state = 35},
  [5510] = {.lex_state = 214, .external_lex_state = 35},
  [5511] = {.lex_state = 101, .external_lex_state = 35},
  [5512] = {.lex_state = 214, .external_lex_state = 35},
  [5513] = {.lex_state = 214, .external_lex_state = 35},
  [5514] = {.lex_state = 119, .external_lex_state = 41},
  [5515] = {.lex_state = 214, .external_lex_state = 35},
  [5516] = {.lex_state = 214, .external_lex_state = 32},
  [5517] = {.lex_state = 119, .external_lex_state = 41},
  [5518] = {.lex_state = 214, .external_lex_state = 35},
  [5519] = {.lex_state = 214, .external_lex_state = 35},
  [5520] = {.lex_state = 214, .external_lex_state = 32},
  [5521] = {.lex_state = 214, .external_lex_state = 32},
  [5522] = {.lex_state = 119, .external_lex_state = 41},
  [5523] = {.lex_state = 101, .external_lex_state = 35},
  [5524] = {.lex_state = 214, .external_lex_state = 35},
  [5525] = {.lex_state = 214, .external_lex_state = 35},
  [5526] = {.lex_state = 214, .external_lex_state = 35},
  [5527] = {.lex_state = 119, .external_lex_state = 41},
  [5528] = {.lex_state = 214, .external_lex_state = 35},
  [5529] = {.lex_state = 119, .external_lex_state = 41},
  [5530] = {.lex_state = 214, .external_lex_state = 35},
  [5531] = {.lex_state = 214, .external_lex_state = 35},
  [5532] = {.lex_state = 119, .external_lex_state = 41},
  [5533] = {.lex_state = 119, .external_lex_state = 41},
  [5534] = {.lex_state = 214, .external_lex_state = 35},
  [5535] = {.lex_state = 119, .external_lex_state = 41},
  [5536] = {.lex_state = 214, .external_lex_state = 35},
  [5537] = {.lex_state = 119, .external_lex_state = 41},
  [5538] = {.lex_state = 119, .external_lex_state = 41},
  [5539] = {.lex_state = 101, .external_lex_state = 35},
  [5540] = {.lex_state = 101, .external_lex_state = 35},
  [5541] = {.lex_state = 214, .external_lex_state = 35},
  [5542] = {.lex_state = 214, .external_lex_state = 35},
  [5543] = {.lex_state = 101, .external_lex_state = 35},
  [5544] = {.lex_state = 119, .external_lex_state = 41},
  [5545] = {.lex_state = 101, .external_lex_state = 35},
  [5546] = {.lex_state = 214, .external_lex_state = 35},
  [5547] = {.lex_state = 214, .external_lex_state = 32},
  [5548] = {.lex_state = 119, .external_lex_state = 41},
  [5549] = {.lex_state = 214, .external_lex_state = 32},
  [5550] = {.lex_state = 119, .external_lex_state = 41},
  [5551] = {.lex_state = 214, .external_lex_state = 35},
  [5552] = {.lex_state = 101, .external_lex_state = 35},
  [5553] = {.lex_state = 101, .external_lex_state = 35},
  [5554] = {.lex_state = 119, .external_lex_state = 41},
  [5555] = {.lex_state = 214, .external_lex_state = 35},
  [5556] = {.lex_state = 119, .external_lex_state = 41},
  [5557] = {.lex_state = 119, .external_lex_state = 41},
  [5558] = {.lex_state = 214, .external_lex_state = 35},
  [5559] = {.lex_state = 119, .external_lex_state = 41},
  [5560] = {.lex_state = 119, .external_lex_state = 41},
  [5561] = {.lex_state = 214, .external_lex_state = 35},
  [5562] = {.lex_state = 101, .external_lex_state = 35},
  [5563] = {.lex_state = 119, .external_lex_state = 41},
  [5564] = {.lex_state = 214, .external_lex_state = 32},
  [5565] = {.lex_state = 214, .external_lex_state = 32},
  [5566] = {.lex_state = 214, .external_lex_state = 32},
  [5567] = {.lex_state = 214, .external_lex_state = 35},
  [5568] = {.lex_state = 101, .external_lex_state = 35},
  [5569] = {.lex_state = 214, .external_lex_state = 35},
  [5570] = {.lex_state = 214, .external_lex_state = 35},
  [5571] = {.lex_state = 214, .external_lex_state = 35},
  [5572] = {.lex_state = 214, .external_lex_state = 35},
  [5573] = {.lex_state = 214, .external_lex_state = 35},
  [5574] = {.lex_state = 214, .external_lex_state = 32},
  [5575] = {.lex_state = 101, .external_lex_state = 35},
  [5576] = {.lex_state = 214, .external_lex_state = 35},
  [5577] = {.lex_state = 214, .external_lex_state = 32},
  [5578] = {.lex_state = 230, .external_lex_state = 35},
  [5579] = {.lex_state = 230, .external_lex_state = 35},
  [5580] = {.lex_state = 230, .external_lex_state = 35},
  [5581] = {.lex_state = 230, .external_lex_state = 35},
  [5582] = {.lex_state = 230, .external_lex_state = 35},
  [5583] = {.lex_state = 230, .external_lex_state = 35},
  [5584] = {.lex_state = 214, .external_lex_state = 35},
  [5585] = {.lex_state = 230, .external_lex_state = 35},
  [5586] = {.lex_state = 214, .external_lex_state = 35},
  [5587] = {.lex_state = 230, .external_lex_state = 35},
  [5588] = {.lex_state = 230, .external_lex_state = 35},
  [5589] = {.lex_state = 230, .external_lex_state = 35},
  [5590] = {.lex_state = 214, .external_lex_state = 35},
  [5591] = {.lex_state = 230, .external_lex_state = 35},
  [5592] = {.lex_state = 230, .external_lex_state = 35},
  [5593] = {.lex_state = 230, .external_lex_state = 35},
  [5594] = {.lex_state = 230, .external_lex_state = 35},
  [5595] = {.lex_state = 230, .external_lex_state = 35},
  [5596] = {.lex_state = 230, .external_lex_state = 35},
  [5597] = {.lex_state = 214, .external_lex_state = 35},
  [5598] = {.lex_state = 230, .external_lex_state = 35},
  [5599] = {.lex_state = 230, .external_lex_state = 35},
  [5600] = {.lex_state = 230, .external_lex_state = 35},
  [5601] = {.lex_state = 230, .external_lex_state = 35},
  [5602] = {.lex_state = 214, .external_lex_state = 35},
  [5603] = {.lex_state = 230, .external_lex_state = 35},
  [5604] = {.lex_state = 230, .external_lex_state = 35},
  [5605] = {.lex_state = 230, .external_lex_state = 35},
  [5606] = {.lex_state = 230, .external_lex_state = 35},
  [5607] = {.lex_state = 214, .external_lex_state = 35},
  [5608] = {.lex_state = 230, .external_lex_state = 35},
  [5609] = {.lex_state = 230, .external_lex_state = 35},
  [5610] = {.lex_state = 230, .external_lex_state = 35},
  [5611] = {.lex_state = 230, .external_lex_state = 35},
  [5612] = {.lex_state = 230, .external_lex_state = 35},
  [5613] = {.lex_state = 230, .external_lex_state = 35},
  [5614] = {.lex_state = 230, .external_lex_state = 35},
  [5615] = {.lex_state = 230, .external_lex_state = 35},
  [5616] = {.lex_state = 230, .external_lex_state = 35},
  [5617] = {.lex_state = 230, .external_lex_state = 35},
  [5618] = {.lex_state = 107, .external_lex_state = 35},
  [5619] = {.lex_state = 230, .external_lex_state = 35},
  [5620] = {.lex_state = 230, .external_lex_state = 35},
  [5621] = {.lex_state = 214, .external_lex_state = 35},
  [5622] = {.lex_state = 230, .external_lex_state = 35},
  [5623] = {.lex_state = 230, .external_lex_state = 35},
  [5624] = {.lex_state = 230, .external_lex_state = 35},
  [5625] = {.lex_state = 101, .external_lex_state = 35},
  [5626] = {.lex_state = 230, .external_lex_state = 35},
  [5627] = {.lex_state = 230, .external_lex_state = 35},
  [5628] = {.lex_state = 214, .external_lex_state = 35},
  [5629] = {.lex_state = 230, .external_lex_state = 35},
  [5630] = {.lex_state = 101, .external_lex_state = 35},
  [5631] = {.lex_state = 230, .external_lex_state = 35},
  [5632] = {.lex_state = 230, .external_lex_state = 35},
  [5633] = {.lex_state = 230, .external_lex_state = 35},
  [5634] = {.lex_state = 230, .external_lex_state = 35},
  [5635] = {.lex_state = 230, .external_lex_state = 35},
  [5636] = {.lex_state = 86, .external_lex_state = 35},
  [5637] = {.lex_state = 230, .external_lex_state = 35},
  [5638] = {.lex_state = 101, .external_lex_state = 35},
  [5639] = {.lex_state = 230, .external_lex_state = 35},
  [5640] = {.lex_state = 214, .external_lex_state = 35},
  [5641] = {.lex_state = 101, .external_lex_state = 35},
  [5642] = {.lex_state = 214, .external_lex_state = 35},
  [5643] = {.lex_state = 214, .external_lex_state = 35},
  [5644] = {.lex_state = 75, .external_lex_state = 35},
  [5645] = {.lex_state = 101, .external_lex_state = 35},
  [5646] = {.lex_state = 101, .external_lex_state = 35},
  [5647] = {.lex_state = 75, .external_lex_state = 35},
  [5648] = {.lex_state = 101, .external_lex_state = 35},
  [5649] = {.lex_state = 101, .external_lex_state = 35},
  [5650] = {.lex_state = 101, .external_lex_state = 35},
  [5651] = {.lex_state = 101, .external_lex_state = 35},
  [5652] = {.lex_state = 101, .external_lex_state = 35},
  [5653] = {.lex_state = 101, .external_lex_state = 35},
  [5654] = {.lex_state = 214, .external_lex_state = 35},
  [5655] = {.lex_state = 75, .external_lex_state = 35},
  [5656] = {.lex_state = 101, .external_lex_state = 35},
  [5657] = {.lex_state = 101, .external_lex_state = 35},
  [5658] = {.lex_state = 101, .external_lex_state = 35},
  [5659] = {.lex_state = 214, .external_lex_state = 35},
  [5660] = {.lex_state = 101, .external_lex_state = 35},
  [5661] = {.lex_state = 101, .external_lex_state = 35},
  [5662] = {.lex_state = 86, .external_lex_state = 35},
  [5663] = {.lex_state = 214, .external_lex_state = 35},
  [5664] = {.lex_state = 101, .external_lex_state = 35},
  [5665] = {.lex_state = 75, .external_lex_state = 35},
  [5666] = {.lex_state = 101, .external_lex_state = 35},
  [5667] = {.lex_state = 214, .external_lex_state = 35},
  [5668] = {.lex_state = 86, .external_lex_state = 35},
  [5669] = {.lex_state = 86, .external_lex_state = 35},
  [5670] = {.lex_state = 101, .external_lex_state = 35},
  [5671] = {.lex_state = 101, .external_lex_state = 35},
  [5672] = {.lex_state = 86, .external_lex_state = 35},
  [5673] = {.lex_state = 101, .external_lex_state = 35},
  [5674] = {.lex_state = 101, .external_lex_state = 35},
  [5675] = {.lex_state = 101, .external_lex_state = 35},
  [5676] = {.lex_state = 214, .external_lex_state = 35},
  [5677] = {.lex_state = 86, .external_lex_state = 35},
  [5678] = {.lex_state = 86, .external_lex_state = 35},
  [5679] = {.lex_state = 86, .external_lex_state = 35},
  [5680] = {.lex_state = 101, .external_lex_state = 35},
  [5681] = {.lex_state = 101, .external_lex_state = 35},
  [5682] = {.lex_state = 214, .external_lex_state = 41},
  [5683] = {.lex_state = 101, .external_lex_state = 35},
  [5684] = {.lex_state = 101, .external_lex_state = 35},
  [5685] = {.lex_state = 214, .external_lex_state = 41},
  [5686] = {.lex_state = 101, .external_lex_state = 35},
  [5687] = {.lex_state = 86, .external_lex_state = 35},
  [5688] = {.lex_state = 101, .external_lex_state = 35},
  [5689] = {.lex_state = 101, .external_lex_state = 35},
  [5690] = {.lex_state = 101, .external_lex_state = 35},
  [5691] = {.lex_state = 214, .external_lex_state = 35},
  [5692] = {.lex_state = 101, .external_lex_state = 35},
  [5693] = {.lex_state = 214, .external_lex_state = 35},
  [5694] = {.lex_state = 214, .external_lex_state = 35},
  [5695] = {.lex_state = 101, .external_lex_state = 35},
  [5696] = {.lex_state = 214, .external_lex_state = 35},
  [5697] = {.lex_state = 214, .external_lex_state = 35},
  [5698] = {.lex_state = 214, .external_lex_state = 35},
  [5699] = {.lex_state = 214, .external_lex_state = 35},
  [5700] = {.lex_state = 214, .external_lex_state = 35},
  [5701] = {.lex_state = 86, .external_lex_state = 35},
  [5702] = {.lex_state = 214, .external_lex_state = 35},
  [5703] = {.lex_state = 86, .external_lex_state = 35},
  [5704] = {.lex_state = 101, .external_lex_state = 35},
  [5705] = {.lex_state = 101, .external_lex_state = 35},
  [5706] = {.lex_state = 101, .external_lex_state = 35},
  [5707] = {.lex_state = 214, .external_lex_state = 35},
  [5708] = {.lex_state = 86, .external_lex_state = 35},
  [5709] = {.lex_state = 101, .external_lex_state = 35},
  [5710] = {.lex_state = 214, .external_lex_state = 35},
  [5711] = {.lex_state = 86, .external_lex_state = 35},
  [5712] = {.lex_state = 101, .external_lex_state = 35},
  [5713] = {.lex_state = 214, .external_lex_state = 41},
  [5714] = {.lex_state = 86, .external_lex_state = 35},
  [5715] = {.lex_state = 75, .external_lex_state = 35},
  [5716] = {.lex_state = 86, .external_lex_state = 35},
  [5717] = {.lex_state = 101, .external_lex_state = 35},
  [5718] = {.lex_state = 101, .external_lex_state = 35},
  [5719] = {.lex_state = 101, .external_lex_state = 35},
  [5720] = {.lex_state = 101, .external_lex_state = 35},
  [5721] = {.lex_state = 101, .external_lex_state = 35},
  [5722] = {.lex_state = 101, .external_lex_state = 35},
  [5723] = {.lex_state = 101, .external_lex_state = 35},
  [5724] = {.lex_state = 101, .external_lex_state = 35},
  [5725] = {.lex_state = 101, .external_lex_state = 35},
  [5726] = {.lex_state = 214, .external_lex_state = 35},
  [5727] = {.lex_state = 101, .external_lex_state = 35},
  [5728] = {.lex_state = 214, .external_lex_state = 35},
  [5729] = {.lex_state = 101, .external_lex_state = 35},
  [5730] = {.lex_state = 101, .external_lex_state = 35},
  [5731] = {.lex_state = 101, .external_lex_state = 35},
  [5732] = {.lex_state = 86, .external_lex_state = 35},
  [5733] = {.lex_state = 214, .external_lex_state = 35},
  [5734] = {.lex_state = 101, .external_lex_state = 35},
  [5735] = {.lex_state = 101, .external_lex_state = 35},
  [5736] = {.lex_state = 101, .external_lex_state = 35},
  [5737] = {.lex_state = 86, .external_lex_state = 35},
  [5738] = {.lex_state = 86, .external_lex_state = 35},
  [5739] = {.lex_state = 101, .external_lex_state = 35},
  [5740] = {.lex_state = 75, .external_lex_state = 35},
  [5741] = {.lex_state = 214, .external_lex_state = 35},
  [5742] = {.lex_state = 214, .external_lex_state = 41},
  [5743] = {.lex_state = 214, .external_lex_state = 35},
  [5744] = {.lex_state = 101, .external_lex_state = 35},
  [5745] = {.lex_state = 101, .external_lex_state = 35},
  [5746] = {.lex_state = 101, .external_lex_state = 35},
  [5747] = {.lex_state = 101, .external_lex_state = 35},
  [5748] = {.lex_state = 101, .external_lex_state = 35},
  [5749] = {.lex_state = 214, .external_lex_state = 35},
  [5750] = {.lex_state = 101, .external_lex_state = 35},
  [5751] = {.lex_state = 101, .external_lex_state = 35},
  [5752] = {.lex_state = 101, .external_lex_state = 35},
  [5753] = {.lex_state = 101, .external_lex_state = 35},
  [5754] = {.lex_state = 75, .external_lex_state = 35},
  [5755] = {.lex_state = 101, .external_lex_state = 35},
  [5756] = {.lex_state = 101, .external_lex_state = 35},
  [5757] = {.lex_state = 101, .external_lex_state = 35},
  [5758] = {.lex_state = 86, .external_lex_state = 35},
  [5759] = {.lex_state = 101, .external_lex_state = 35},
  [5760] = {.lex_state = 101, .external_lex_state = 35},
  [5761] = {.lex_state = 101, .external_lex_state = 35},
  [5762] = {.lex_state = 101, .external_lex_state = 35},
  [5763] = {.lex_state = 101, .external_lex_state = 35},
  [5764] = {.lex_state = 241, .external_lex_state = 35},
  [5765] = {.lex_state = 101, .external_lex_state = 35},
  [5766] = {.lex_state = 101, .external_lex_state = 35},
  [5767] = {.lex_state = 214, .external_lex_state = 35},
  [5768] = {.lex_state = 86, .external_lex_state = 35},
  [5769] = {.lex_state = 214, .external_lex_state = 35},
  [5770] = {.lex_state = 101, .external_lex_state = 35},
  [5771] = {.lex_state = 101, .external_lex_state = 35},
  [5772] = {.lex_state = 214, .external_lex_state = 41},
  [5773] = {.lex_state = 214, .external_lex_state = 35},
  [5774] = {.lex_state = 214, .external_lex_state = 35},
  [5775] = {.lex_state = 86, .external_lex_state = 35},
  [5776] = {.lex_state = 101, .external_lex_state = 35},
  [5777] = {.lex_state = 214, .external_lex_state = 41},
  [5778] = {.lex_state = 86, .external_lex_state = 35},
  [5779] = {.lex_state = 86, .external_lex_state = 35},
  [5780] = {.lex_state = 101, .external_lex_state = 35},
  [5781] = {.lex_state = 75, .external_lex_state = 35},
  [5782] = {.lex_state = 86, .external_lex_state = 35},
  [5783] = {.lex_state = 101, .external_lex_state = 35},
  [5784] = {.lex_state = 86, .external_lex_state = 35},
  [5785] = {.lex_state = 86, .external_lex_state = 35},
  [5786] = {.lex_state = 101, .external_lex_state = 35},
  [5787] = {.lex_state = 86, .external_lex_state = 35},
  [5788] = {.lex_state = 75, .external_lex_state = 35},
  [5789] = {.lex_state = 101, .external_lex_state = 35},
  [5790] = {.lex_state = 86, .external_lex_state = 35},
  [5791] = {.lex_state = 75, .external_lex_state = 35},
  [5792] = {.lex_state = 101, .external_lex_state = 35},
  [5793] = {.lex_state = 101, .external_lex_state = 35},
  [5794] = {.lex_state = 101, .external_lex_state = 35},
  [5795] = {.lex_state = 214, .external_lex_state = 41},
  [5796] = {.lex_state = 101, .external_lex_state = 35},
  [5797] = {.lex_state = 86, .external_lex_state = 35},
  [5798] = {.lex_state = 214, .external_lex_state = 35},
  [5799] = {.lex_state = 86, .external_lex_state = 35},
  [5800] = {.lex_state = 101, .external_lex_state = 35},
  [5801] = {.lex_state = 75, .external_lex_state = 35},
  [5802] = {.lex_state = 214, .external_lex_state = 35},
  [5803] = {.lex_state = 101, .external_lex_state = 35},
  [5804] = {.lex_state = 86, .external_lex_state = 35},
  [5805] = {.lex_state = 75, .external_lex_state = 35},
  [5806] = {.lex_state = 101, .external_lex_state = 35},
  [5807] = {.lex_state = 101, .external_lex_state = 35},
  [5808] = {.lex_state = 86, .external_lex_state = 35},
  [5809] = {.lex_state = 86, .external_lex_state = 35},
  [5810] = {.lex_state = 86, .external_lex_state = 35},
  [5811] = {.lex_state = 75, .external_lex_state = 35},
  [5812] = {.lex_state = 214, .external_lex_state = 41},
  [5813] = {.lex_state = 101, .external_lex_state = 35},
  [5814] = {.lex_state = 214, .external_lex_state = 41},
  [5815] = {.lex_state = 101, .external_lex_state = 35},
  [5816] = {.lex_state = 214, .external_lex_state = 35},
  [5817] = {.lex_state = 86, .external_lex_state = 35},
  [5818] = {.lex_state = 86, .external_lex_state = 35},
  [5819] = {.lex_state = 86, .external_lex_state = 35},
  [5820] = {.lex_state = 214, .external_lex_state = 41},
  [5821] = {.lex_state = 86, .external_lex_state = 35},
  [5822] = {.lex_state = 101, .external_lex_state = 35},
  [5823] = {.lex_state = 101, .external_lex_state = 35},
  [5824] = {.lex_state = 86, .external_lex_state = 35},
  [5825] = {.lex_state = 214, .external_lex_state = 35},
  [5826] = {.lex_state = 101, .external_lex_state = 35},
  [5827] = {.lex_state = 86, .external_lex_state = 35},
  [5828] = {.lex_state = 101, .external_lex_state = 35},
  [5829] = {.lex_state = 101, .external_lex_state = 35},
  [5830] = {.lex_state = 101, .external_lex_state = 35},
  [5831] = {.lex_state = 86, .external_lex_state = 35},
  [5832] = {.lex_state = 101, .external_lex_state = 35},
  [5833] = {.lex_state = 86, .external_lex_state = 35},
  [5834] = {.lex_state = 75, .external_lex_state = 35},
  [5835] = {.lex_state = 214, .external_lex_state = 35},
  [5836] = {.lex_state = 75, .external_lex_state = 35},
  [5837] = {.lex_state = 101, .external_lex_state = 35},
  [5838] = {.lex_state = 241, .external_lex_state = 35},
  [5839] = {.lex_state = 214, .external_lex_state = 35},
  [5840] = {.lex_state = 101, .external_lex_state = 35},
  [5841] = {.lex_state = 101, .external_lex_state = 35},
  [5842] = {.lex_state = 101, .external_lex_state = 35},
  [5843] = {.lex_state = 86, .external_lex_state = 35},
  [5844] = {.lex_state = 86, .external_lex_state = 35},
  [5845] = {.lex_state = 86, .external_lex_state = 35},
  [5846] = {.lex_state = 214, .external_lex_state = 35},
  [5847] = {.lex_state = 86, .external_lex_state = 35},
  [5848] = {.lex_state = 101, .external_lex_state = 35},
  [5849] = {.lex_state = 101, .external_lex_state = 35},
  [5850] = {.lex_state = 86, .external_lex_state = 35},
  [5851] = {.lex_state = 214, .external_lex_state = 35},
  [5852] = {.lex_state = 86, .external_lex_state = 35},
  [5853] = {.lex_state = 86, .external_lex_state = 35},
  [5854] = {.lex_state = 86, .external_lex_state = 35},
  [5855] = {.lex_state = 86, .external_lex_state = 35},
  [5856] = {.lex_state = 101, .external_lex_state = 35},
  [5857] = {.lex_state = 86, .external_lex_state = 35},
  [5858] = {.lex_state = 101, .external_lex_state = 35},
  [5859] = {.lex_state = 101, .external_lex_state = 35},
  [5860] = {.lex_state = 86, .external_lex_state = 35},
  [5861] = {.lex_state = 101, .external_lex_state = 35},
  [5862] = {.lex_state = 86, .external_lex_state = 35},
  [5863] = {.lex_state = 101, .external_lex_state = 35},
  [5864] = {.lex_state = 214, .external_lex_state = 35},
  [5865] = {.lex_state = 101, .external_lex_state = 35},
  [5866] = {.lex_state = 101, .external_lex_state = 35},
  [5867] = {.lex_state = 86, .external_lex_state = 35},
  [5868] = {.lex_state = 246, .external_lex_state = 35},
  [5869] = {.lex_state = 101, .external_lex_state = 35},
  [5870] = {.lex_state = 86, .external_lex_state = 35},
  [5871] = {.lex_state = 101, .external_lex_state = 35},
  [5872] = {.lex_state = 86, .external_lex_state = 35},
  [5873] = {.lex_state = 101, .external_lex_state = 35},
  [5874] = {.lex_state = 86, .external_lex_state = 35},
  [5875] = {.lex_state = 214, .external_lex_state = 35},
  [5876] = {.lex_state = 101, .external_lex_state = 35},
  [5877] = {.lex_state = 86, .external_lex_state = 35},
  [5878] = {.lex_state = 101, .external_lex_state = 35},
  [5879] = {.lex_state = 214, .external_lex_state = 35},
  [5880] = {.lex_state = 101, .external_lex_state = 35},
  [5881] = {.lex_state = 214, .external_lex_state = 35},
  [5882] = {.lex_state = 214, .external_lex_state = 35},
  [5883] = {.lex_state = 101, .external_lex_state = 35},
  [5884] = {.lex_state = 86, .external_lex_state = 35},
  [5885] = {.lex_state = 101, .external_lex_state = 35},
  [5886] = {.lex_state = 101, .external_lex_state = 35},
  [5887] = {.lex_state = 86, .external_lex_state = 35},
  [5888] = {.lex_state = 86, .external_lex_state = 35},
  [5889] = {.lex_state = 101, .external_lex_state = 35},
  [5890] = {.lex_state = 101, .external_lex_state = 35},
  [5891] = {.lex_state = 246, .external_lex_state = 35},
  [5892] = {.lex_state = 75, .external_lex_state = 35},
  [5893] = {.lex_state = 75, .external_lex_state = 35},
  [5894] = {.lex_state = 214, .external_lex_state = 35},
  [5895] = {.lex_state = 101, .external_lex_state = 35},
  [5896] = {.lex_state = 101, .external_lex_state = 35},
  [5897] = {.lex_state = 101, .external_lex_state = 35},
  [5898] = {.lex_state = 101, .external_lex_state = 35},
  [5899] = {.lex_state = 75, .external_lex_state = 35},
  [5900] = {.lex_state = 101, .external_lex_state = 35},
  [5901] = {.lex_state = 101, .external_lex_state = 35},
  [5902] = {.lex_state = 101, .external_lex_state = 35},
  [5903] = {.lex_state = 214, .external_lex_state = 35},
  [5904] = {.lex_state = 101, .external_lex_state = 35},
  [5905] = {.lex_state = 101, .external_lex_state = 35},
  [5906] = {.lex_state = 101, .external_lex_state = 35},
  [5907] = {.lex_state = 86, .external_lex_state = 35},
  [5908] = {.lex_state = 214, .external_lex_state = 35},
  [5909] = {.lex_state = 101, .external_lex_state = 35},
  [5910] = {.lex_state = 101, .external_lex_state = 35},
  [5911] = {.lex_state = 101, .external_lex_state = 35},
  [5912] = {.lex_state = 101, .external_lex_state = 35},
  [5913] = {.lex_state = 101, .external_lex_state = 35},
  [5914] = {.lex_state = 214, .external_lex_state = 35},
  [5915] = {.lex_state = 214, .external_lex_state = 35},
  [5916] = {.lex_state = 101, .external_lex_state = 35},
  [5917] = {.lex_state = 214, .external_lex_state = 35},
  [5918] = {.lex_state = 101, .external_lex_state = 35},
  [5919] = {.lex_state = 86, .external_lex_state = 35},
  [5920] = {.lex_state = 101, .external_lex_state = 35},
  [5921] = {.lex_state = 101, .external_lex_state = 35},
  [5922] = {.lex_state = 214, .external_lex_state = 35},
  [5923] = {.lex_state = 101, .external_lex_state = 35},
  [5924] = {.lex_state = 101, .external_lex_state = 35},
  [5925] = {.lex_state = 214, .external_lex_state = 35},
  [5926] = {.lex_state = 101, .external_lex_state = 35},
  [5927] = {.lex_state = 101, .external_lex_state = 35},
  [5928] = {.lex_state = 214, .external_lex_state = 35},
  [5929] = {.lex_state = 86, .external_lex_state = 35},
  [5930] = {.lex_state = 101, .external_lex_state = 35},
  [5931] = {.lex_state = 101, .external_lex_state = 35},
  [5932] = {.lex_state = 101, .external_lex_state = 35},
  [5933] = {.lex_state = 214, .external_lex_state = 35},
  [5934] = {.lex_state = 75, .external_lex_state = 35},
  [5935] = {.lex_state = 101, .external_lex_state = 35},
  [5936] = {.lex_state = 101, .external_lex_state = 35},
  [5937] = {.lex_state = 101, .external_lex_state = 35},
  [5938] = {.lex_state = 214, .external_lex_state = 35},
  [5939] = {.lex_state = 86, .external_lex_state = 35},
  [5940] = {.lex_state = 101, .external_lex_state = 35},
  [5941] = {.lex_state = 75, .external_lex_state = 35},
  [5942] = {.lex_state = 101, .external_lex_state = 35},
  [5943] = {.lex_state = 75, .external_lex_state = 35},
  [5944] = {.lex_state = 86, .external_lex_state = 35},
  [5945] = {.lex_state = 214, .external_lex_state = 35},
  [5946] = {.lex_state = 86, .external_lex_state = 35},
  [5947] = {.lex_state = 101, .external_lex_state = 35},
  [5948] = {.lex_state = 101, .external_lex_state = 35},
  [5949] = {.lex_state = 101, .external_lex_state = 35},
  [5950] = {.lex_state = 75, .external_lex_state = 35},
  [5951] = {.lex_state = 75, .external_lex_state = 35},
  [5952] = {.lex_state = 214, .external_lex_state = 35},
  [5953] = {.lex_state = 214, .external_lex_state = 35},
  [5954] = {.lex_state = 101, .external_lex_state = 35},
  [5955] = {.lex_state = 86, .external_lex_state = 35},
  [5956] = {.lex_state = 86, .external_lex_state = 35},
  [5957] = {.lex_state = 214, .external_lex_state = 35},
  [5958] = {.lex_state = 101, .external_lex_state = 35},
  [5959] = {.lex_state = 214, .external_lex_state = 35},
  [5960] = {.lex_state = 214, .external_lex_state = 35},
  [5961] = {.lex_state = 101, .external_lex_state = 35},
  [5962] = {.lex_state = 101, .external_lex_state = 35},
  [5963] = {.lex_state = 86, .external_lex_state = 35},
  [5964] = {.lex_state = 101, .external_lex_state = 35},
  [5965] = {.lex_state = 214, .external_lex_state = 35},
  [5966] = {.lex_state = 86, .external_lex_state = 35},
  [5967] = {.lex_state = 101, .external_lex_state = 35},
  [5968] = {.lex_state = 101, .external_lex_state = 35},
  [5969] = {.lex_state = 214, .external_lex_state = 35},
  [5970] = {.lex_state = 101, .external_lex_state = 35},
  [5971] = {.lex_state = 101, .external_lex_state = 35},
  [5972] = {.lex_state = 214, .external_lex_state = 35},
  [5973] = {.lex_state = 101, .external_lex_state = 35},
  [5974] = {.lex_state = 214, .external_lex_state = 35},
  [5975] = {.lex_state = 101, .external_lex_state = 35},
  [5976] = {.lex_state = 101, .external_lex_state = 35},
  [5977] = {.lex_state = 101, .external_lex_state = 35},
  [5978] = {.lex_state = 214, .external_lex_state = 35},
  [5979] = {.lex_state = 101, .external_lex_state = 35},
  [5980] = {.lex_state = 75, .external_lex_state = 35},
  [5981] = {.lex_state = 101, .external_lex_state = 35},
  [5982] = {.lex_state = 101, .external_lex_state = 35},
  [5983] = {.lex_state = 101, .external_lex_state = 35},
  [5984] = {.lex_state = 101, .external_lex_state = 35},
  [5985] = {.lex_state = 101, .external_lex_state = 35},
  [5986] = {.lex_state = 101, .external_lex_state = 35},
  [5987] = {.lex_state = 214, .external_lex_state = 35},
  [5988] = {.lex_state = 101, .external_lex_state = 35},
  [5989] = {(TSStateId)(-1)},
  [5990] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_body] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_program_token1] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(1),
    [anon_sym_BEGIN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_rescue] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_next] = ACTIONS(1),
    [anon_sym_redo] = ACTIONS(1),
    [anon_sym_retry] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_unless] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [sym_line] = ACTIONS(1),
    [sym_file] = ACTIONS(1),
    [sym_encoding] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_ensure] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_TILDE_AT] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_EQ2] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_i] = ACTIONS(1),
    [anon_sym_ri] = ACTIONS(1),
    [anon_sym_r] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_constant] = ACTIONS(1),
    [aux_sym_constant_suffix_token1] = ACTIONS(1),
    [sym_instance_variable] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [sym_character] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [sym__line_break] = ACTIONS(1),
    [sym__no_line_break] = ACTIONS(1),
    [sym_simple_symbol] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__symbol_start] = ACTIONS(1),
    [sym__subshell_start] = ACTIONS(1),
    [sym__regex_start] = ACTIONS(1),
    [sym__string_array_start] = ACTIONS(1),
    [sym__symbol_array_start] = ACTIONS(1),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_string_content] = ACTIONS(1),
    [sym_heredoc_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_heredoc_beginning] = ACTIONS(1),
    [sym__block_ampersand] = ACTIONS(1),
    [sym__splat_star] = ACTIONS(1),
    [sym__unary_minus] = ACTIONS(1),
    [sym__unary_minus_num] = ACTIONS(1),
    [sym__binary_minus] = ACTIONS(1),
    [sym__binary_star] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1),
    [sym_hash_key_symbol] = ACTIONS(1),
    [sym__identifier_suffix] = ACTIONS(1),
    [sym__constant_suffix] = ACTIONS(1),
    [sym__hash_splat_star_star] = ACTIONS(1),
    [sym__binary_star_star] = ACTIONS(1),
    [sym__element_reference_bracket] = ACTIONS(1),
    [sym__short_interpolation] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(5710),
    [sym__statements] = STATE(5534),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4767),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4747),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2145),
    [aux_sym__statements_repeat1] = STATE(317),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [aux_sym_program_token1] = ACTIONS(11),
    [anon_sym___END__] = ACTIONS(13),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_undef] = ACTIONS(77),
    [anon_sym_alias] = ACTIONS(79),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [2] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(2),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [3] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2223),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(3),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(179),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(179),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [4] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(4),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [5] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2223),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(5),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(179),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(179),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [6] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(6),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [7] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4438),
    [sym_argument_list] = STATE(2239),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(7),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(179),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(179),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [8] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2223),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(8),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(177),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [9] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4438),
    [sym_argument_list] = STATE(2239),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(9),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(177),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [10] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(10),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [11] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(11),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [12] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(12),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [13] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2223),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(13),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(177),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [14] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2223),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(14),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [15] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(15),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [16] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4438),
    [sym_argument_list] = STATE(2239),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(16),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [17] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(17),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [18] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(18),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [19] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2223),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(19),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [20] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(20),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [21] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4859),
    [sym_argument_list] = STATE(2839),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3050),
    [sym_block] = STATE(3051),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(21),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [22] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(3152),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3050),
    [sym_block] = STATE(3051),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(22),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [23] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2223),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(23),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [24] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(24),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [25] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4438),
    [sym_argument_list] = STATE(2239),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(25),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [26] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4860),
    [sym_argument_list] = STATE(2842),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(26),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [27] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(27),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [28] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4847),
    [sym_argument_list] = STATE(3114),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(28),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [29] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4442),
    [sym_argument_list] = STATE(2223),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(29),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [30] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(30),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [31] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(31),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [32] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4438),
    [sym_argument_list] = STATE(2239),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(32),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [33] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4438),
    [sym_argument_list] = STATE(2239),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(33),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [34] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4845),
    [sym_argument_list] = STATE(3152),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3050),
    [sym_block] = STATE(3051),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(34),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [35] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4847),
    [sym_argument_list] = STATE(3114),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(35),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [36] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4859),
    [sym_argument_list] = STATE(2839),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3050),
    [sym_block] = STATE(3051),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(36),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [37] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4860),
    [sym_argument_list] = STATE(2842),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(37),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [38] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4859),
    [sym_argument_list] = STATE(2839),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3050),
    [sym_block] = STATE(3051),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(38),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [39] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4860),
    [sym_argument_list] = STATE(2842),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(39),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [40] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4860),
    [sym_argument_list] = STATE(2842),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(40),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [41] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4859),
    [sym_argument_list] = STATE(2839),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3050),
    [sym_block] = STATE(3051),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(41),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [42] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(42),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [43] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(43),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [44] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(44),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [45] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(45),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [46] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(46),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [47] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(47),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [48] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(48),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(429),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(429),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_elsif] = ACTIONS(429),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(429),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [49] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(4564),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(49),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [50] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(4564),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(50),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [51] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(4564),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(51),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [52] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(4564),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(52),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(429),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(429),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_elsif] = ACTIONS(429),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(429),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [53] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(53),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [54] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(54),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [55] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(55),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [56] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(56),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(415),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [57] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(57),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(423),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [58] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(58),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [59] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(59),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(427),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(427),
    [anon_sym___END__] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [60] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(60),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [61] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(61),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [62] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(62),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [63] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3191),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(4655),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1985),
    [sym_identifier_suffix] = STATE(1986),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2642),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(63),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [64] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(64),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [65] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4860),
    [sym_argument_list] = STATE(2842),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(65),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [66] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3191),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(4655),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1985),
    [sym_identifier_suffix] = STATE(1986),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2642),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(66),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(423),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [67] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(67),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [68] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4847),
    [sym_argument_list] = STATE(3114),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(68),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [69] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3191),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(4655),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1985),
    [sym_identifier_suffix] = STATE(1986),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2642),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(69),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(427),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(427),
    [anon_sym___END__] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [70] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3191),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(4655),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1985),
    [sym_identifier_suffix] = STATE(1986),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2642),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(70),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(415),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [71] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(71),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [72] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(72),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [73] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(73),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [74] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4847),
    [sym_argument_list] = STATE(3114),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(74),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(337),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [75] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4437),
    [sym_argument_list] = STATE(2256),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(75),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [76] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4860),
    [sym_argument_list] = STATE(2842),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(76),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [77] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4441),
    [sym_argument_list] = STATE(2241),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(77),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [78] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(78),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [79] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(79),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [80] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(5000),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(80),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [81] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(5000),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(81),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [82] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3464),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(4743),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1990),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2724),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(82),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(505),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(525),
    [sym__splat_star] = ACTIONS(527),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(533),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(535),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [83] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3464),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(4743),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1990),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2724),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(83),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(505),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(525),
    [sym__splat_star] = ACTIONS(527),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(533),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(535),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [84] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3464),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(4743),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1990),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2724),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(84),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(505),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(525),
    [sym__splat_star] = ACTIONS(527),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(533),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(535),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [85] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3464),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(4743),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1990),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2724),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(85),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(505),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(525),
    [sym__splat_star] = ACTIONS(527),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(533),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(535),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [86] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(86),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [87] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(87),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [88] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(88),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [89] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(89),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [90] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(5030),
    [sym_argument_list] = STATE(2933),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(90),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [91] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4993),
    [sym_argument_list] = STATE(3026),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(91),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [92] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4860),
    [sym_argument_list] = STATE(2842),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(92),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [93] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(5016),
    [sym_argument_list] = STATE(2925),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(93),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [94] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4939),
    [sym_argument_list] = STATE(2926),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(94),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [95] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(5000),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(95),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [96] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(5000),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(96),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [97] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3897),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(5030),
    [sym_argument_list] = STATE(2933),
    [sym__argument] = STATE(5072),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1996),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3139),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(97),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(559),
    [sym__splat_star] = ACTIONS(561),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(567),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(569),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [98] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3897),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4993),
    [sym_argument_list] = STATE(3026),
    [sym__argument] = STATE(5072),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1996),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3139),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(98),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(559),
    [sym__splat_star] = ACTIONS(561),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(567),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(569),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [99] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3897),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(5016),
    [sym_argument_list] = STATE(2925),
    [sym__argument] = STATE(5072),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1996),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3139),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(99),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(559),
    [sym__splat_star] = ACTIONS(561),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(567),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(569),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [100] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3897),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4939),
    [sym_argument_list] = STATE(2926),
    [sym__argument] = STATE(5072),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1996),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3139),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(100),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(559),
    [sym__splat_star] = ACTIONS(561),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(567),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(569),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [101] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3916),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4507),
    [sym_argument_list] = STATE(2361),
    [sym__argument] = STATE(5056),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1998),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(3157),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(101),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(571),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(571),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [102] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3916),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4477),
    [sym_argument_list] = STATE(2285),
    [sym__argument] = STATE(5056),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1998),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(3157),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(102),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(571),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(571),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [103] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3916),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4481),
    [sym_argument_list] = STATE(2343),
    [sym__argument] = STATE(5056),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1998),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(3157),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(103),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(571),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(571),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [104] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(5030),
    [sym_argument_list] = STATE(2933),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(104),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [105] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4993),
    [sym_argument_list] = STATE(3026),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(105),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [106] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3916),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4503),
    [sym_argument_list] = STATE(2431),
    [sym__argument] = STATE(5056),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1998),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(3157),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(106),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(571),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(571),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [107] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(5016),
    [sym_argument_list] = STATE(2925),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(107),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [108] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4939),
    [sym_argument_list] = STATE(2926),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(108),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [109] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4860),
    [sym_argument_list] = STATE(2842),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_do_block] = STATE(3064),
    [sym_block] = STATE(3065),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(109),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(275),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [110] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4993),
    [sym_argument_list] = STATE(3026),
    [sym__argument] = STATE(5239),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2010),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3196),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(110),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [111] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(5030),
    [sym_argument_list] = STATE(2933),
    [sym__argument] = STATE(5239),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2010),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3196),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(111),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [112] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(5016),
    [sym_argument_list] = STATE(2925),
    [sym__argument] = STATE(5239),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2010),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3196),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(112),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [113] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4939),
    [sym_argument_list] = STATE(2926),
    [sym__argument] = STATE(5239),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2010),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3196),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(113),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(281),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [114] = {
    [sym__statements] = STATE(5839),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_expr] = STATE(5607),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(3155),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5636),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2229),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2783),
    [sym_subshell] = STATE(3155),
    [sym_string_array] = STATE(3155),
    [sym_symbol_array] = STATE(3155),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(3155),
    [sym_heredoc_body] = STATE(114),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(3166),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [115] = {
    [sym__statements] = STATE(5839),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_expr] = STATE(5602),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(3155),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5636),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2229),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2783),
    [sym_subshell] = STATE(3155),
    [sym_string_array] = STATE(3155),
    [sym_symbol_array] = STATE(3155),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(3155),
    [sym_heredoc_body] = STATE(115),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(3166),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [116] = {
    [sym__statements] = STATE(5933),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_expr] = STATE(5602),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(3155),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5636),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2229),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2783),
    [sym_subshell] = STATE(3155),
    [sym_string_array] = STATE(3155),
    [sym_symbol_array] = STATE(3155),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(3155),
    [sym_heredoc_body] = STATE(116),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(3166),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [117] = {
    [sym__statements] = STATE(5933),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_expr] = STATE(5607),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(3155),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5636),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2229),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2783),
    [sym_subshell] = STATE(3155),
    [sym_string_array] = STATE(3155),
    [sym_symbol_array] = STATE(3155),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(3155),
    [sym_heredoc_body] = STATE(117),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(3166),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [118] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4954),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5728),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5749),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5835),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3747),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2612),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3358),
    [sym_subshell] = STATE(3747),
    [sym_string_array] = STATE(3747),
    [sym_symbol_array] = STATE(3747),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3747),
    [sym_heredoc_body] = STATE(118),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3756),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [119] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4954),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5728),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5749),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5945),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3747),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2612),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3358),
    [sym_subshell] = STATE(3747),
    [sym_string_array] = STATE(3747),
    [sym_symbol_array] = STATE(3747),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3747),
    [sym_heredoc_body] = STATE(119),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3756),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [120] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4954),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5667),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5697),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5835),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3747),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2612),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3358),
    [sym_subshell] = STATE(3747),
    [sym_string_array] = STATE(3747),
    [sym_symbol_array] = STATE(3747),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3747),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3756),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [121] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4954),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5728),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5749),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5835),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3747),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2612),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3358),
    [sym_subshell] = STATE(3747),
    [sym_string_array] = STATE(3747),
    [sym_symbol_array] = STATE(3747),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3747),
    [sym_heredoc_body] = STATE(121),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3756),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(729),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [122] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4954),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5667),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5697),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5945),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3747),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2612),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3358),
    [sym_subshell] = STATE(3747),
    [sym_string_array] = STATE(3747),
    [sym_symbol_array] = STATE(3747),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3747),
    [sym_heredoc_body] = STATE(122),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3756),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [123] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_superclass] = STATE(5549),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5688),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(123),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(208),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(735),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [124] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_superclass] = STATE(5507),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5832),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(124),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(229),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(755),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [125] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_superclass] = STATE(5516),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5849),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(125),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [126] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_superclass] = STATE(5516),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5849),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(126),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [127] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5900),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(127),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(212),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(759),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [128] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_superclass] = STATE(5507),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5832),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(128),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(229),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(755),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [129] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5731),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(129),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(209),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(761),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [130] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_superclass] = STATE(5549),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5688),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(130),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(208),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(735),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [131] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5935),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(131),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(231),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(763),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [132] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5731),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(132),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(209),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(761),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [133] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5900),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(133),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(212),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(759),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [134] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5935),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(134),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(231),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(763),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [135] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(135),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [136] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(136),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [137] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(137),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [138] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(188),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5730),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(138),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(189),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [139] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(139),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(779),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [140] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(140),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [141] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(191),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5859),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(141),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(169),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(783),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [142] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(142),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [143] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(143),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [144] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(194),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5653),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(144),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(195),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(789),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [145] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(145),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [146] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(146),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [147] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(5379),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5920),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(147),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(233),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(795),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [148] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(148),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [149] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(149),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [150] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(180),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5947),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(150),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(181),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(803),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [151] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(177),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5776),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(151),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(178),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(805),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [152] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(171),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5689),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(152),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(172),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(807),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [153] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(153),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [154] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(154),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [155] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(155),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [156] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(156),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [157] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(157),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [158] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(182),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5921),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(158),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(183),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(819),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [159] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(159),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [160] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(160),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [161] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(161),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [162] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(162),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [163] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(174),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5906),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(163),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(175),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(829),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [164] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(164),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [165] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(185),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5866),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(165),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(186),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(833),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [166] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(193),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5680),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(166),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(197),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [167] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(2383),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5858),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(167),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(238),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(769),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [168] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym__body_expr] = STATE(3031),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5977),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(168),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [169] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(192),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5869),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(169),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [170] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5727),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(170),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(243),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(843),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [171] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5692),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(171),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(219),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [172] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(173),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5948),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(172),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(847),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [173] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5652),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(173),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(223),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [174] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5771),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(174),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(241),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(851),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [175] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(176),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5792),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(175),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [176] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5897),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(176),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(205),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(855),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [177] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5880),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(177),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(204),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(857),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [178] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(179),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5954),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(178),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(859),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [179] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5721),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(179),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(213),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(861),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [180] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5746),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(180),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(215),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(863),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [181] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(198),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5766),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(181),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [182] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5970),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(182),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(867),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [183] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(184),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5973),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(183),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [184] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5986),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(184),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(871),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [185] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5926),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(185),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(224),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [186] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(187),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5932),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(186),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(875),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [187] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5940),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(187),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(225),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [188] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5745),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(188),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(226),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(879),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [189] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(190),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5756),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(189),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(881),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [190] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5763),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(190),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(228),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(883),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [191] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5865),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(191),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(230),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(885),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [192] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5883),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(192),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(232),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [193] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5931),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(193),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(242),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(889),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [194] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5830),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(194),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(234),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [195] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(196),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5712),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(195),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [196] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5848),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(196),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(236),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(895),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [197] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(170),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5646),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(197),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [198] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5823),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(198),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(217),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [199] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym__body_statement] = STATE(5904),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(199),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(244),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(901),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [200] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym__body_statement] = STATE(5842),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(200),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(246),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [201] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym__body_statement] = STATE(5815),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(201),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(247),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [202] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2515),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(202),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [203] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2510),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(203),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [204] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5719),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(204),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(951),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [205] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5927),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(205),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(953),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [206] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5863),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(206),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(955),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [207] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2557),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(207),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [208] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5660),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(208),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(975),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [209] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5666),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(209),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [210] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5898),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(210),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(979),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [211] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5674),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(211),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [212] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5789),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(212),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(983),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [213] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5783),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(213),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [214] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5658),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(214),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(987),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [215] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5822),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(215),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(989),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [216] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5670),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(216),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(991),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [217] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5828),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(217),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [218] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5803),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(218),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(995),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [219] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5650),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(219),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [220] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5984),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(220),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(999),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [221] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2613),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(221),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [222] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5641),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(222),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1001),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [223] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5744),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(223),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1003),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [224] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5937),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(224),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1005),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [225] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5942),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(225),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1007),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [226] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5761),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(226),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1009),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [227] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5983),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(227),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1011),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [228] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5765),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(228),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1013),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [229] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5649),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(229),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1015),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [230] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5878),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(230),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1017),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [231] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5651),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(231),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1019),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [232] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5886),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(232),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1021),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [233] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5840),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(233),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1023),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [234] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5690),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(234),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1025),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [235] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5856),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(235),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1027),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [236] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5796),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(236),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1029),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [237] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5871),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(237),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1031),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [238] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5975),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(238),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1033),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [239] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5981),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(239),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1035),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [240] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5985),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(240),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1037),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [241] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5896),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(241),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1039),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [242] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5718),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(242),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1041),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [243] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym_body_statement] = STATE(5923),
    [sym__body_statement] = STATE(5695),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(243),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1043),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [244] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym__body_statement] = STATE(5913),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(244),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1045),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [245] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2659),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(245),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [246] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym__body_statement] = STATE(5648),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(246),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1065),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [247] = {
    [sym__statements] = STATE(5033),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5492),
    [sym_begin] = STATE(2402),
    [sym_ensure] = STATE(5492),
    [sym_rescue] = STATE(5492),
    [sym__body_statement] = STATE(5794),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(247),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [aux_sym__body_statement_repeat1] = STATE(5024),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1067),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [248] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(4524),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(248),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1071),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1071),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
  },
  [249] = {
    [sym_block_body] = STATE(5659),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_hash_splat_argument] = STATE(5561),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1993),
    [sym_identifier_suffix] = STATE(1994),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2773),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(249),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(5561),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1081),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [250] = {
    [sym_block_body] = STATE(5953),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(326),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_hash_splat_argument] = STATE(5497),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1993),
    [sym_identifier_suffix] = STATE(1994),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2773),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(250),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(5497),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1081),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [251] = {
    [sym_block_body] = STATE(5659),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_hash_splat_argument] = STATE(5561),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1993),
    [sym_identifier_suffix] = STATE(1994),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2773),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(251),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(5561),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1081),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [252] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(4564),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(252),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1071),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_elsif] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1071),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [253] = {
    [sym_block_body] = STATE(5953),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(326),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_hash_splat_argument] = STATE(5497),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1993),
    [sym_identifier_suffix] = STATE(1994),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2773),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(253),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(5497),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1081),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [254] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(5026),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(254),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(254),
    [sym_identifier] = ACTIONS(1101),
    [anon_sym_BEGIN] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_END] = ACTIONS(1112),
    [anon_sym_def] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1118),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_COLON_COLON] = ACTIONS(1121),
    [anon_sym_end] = ACTIONS(1124),
    [anon_sym_rescue] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1132),
    [anon_sym_nil] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1138),
    [anon_sym_module] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1147),
    [anon_sym_break] = ACTIONS(1150),
    [anon_sym_next] = ACTIONS(1153),
    [anon_sym_redo] = ACTIONS(1156),
    [anon_sym_retry] = ACTIONS(1159),
    [anon_sym_if] = ACTIONS(1162),
    [anon_sym_unless] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1168),
    [anon_sym_until] = ACTIONS(1171),
    [anon_sym_for] = ACTIONS(1174),
    [anon_sym_in] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_when] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(1180),
    [anon_sym_DOT_DOT] = ACTIONS(1183),
    [anon_sym_elsif] = ACTIONS(1124),
    [anon_sym_else] = ACTIONS(1124),
    [anon_sym_begin] = ACTIONS(1186),
    [anon_sym_ensure] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1192),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1198),
    [anon_sym_TILDE] = ACTIONS(1198),
    [anon_sym_undef] = ACTIONS(1201),
    [anon_sym_alias] = ACTIONS(1204),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1207),
    [sym_float] = ACTIONS(1207),
    [sym_super] = ACTIONS(1101),
    [sym_self] = ACTIONS(1101),
    [sym_true] = ACTIONS(1210),
    [sym_false] = ACTIONS(1210),
    [sym_constant] = ACTIONS(1101),
    [aux_sym_constant_suffix_token1] = ACTIONS(1213),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1216),
    [sym_instance_variable] = ACTIONS(1219),
    [sym_class_variable] = ACTIONS(1219),
    [sym_global_variable] = ACTIONS(1219),
    [sym_character] = ACTIONS(1222),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [sym_simple_symbol] = ACTIONS(1228),
    [sym__string_start] = ACTIONS(1231),
    [sym__symbol_start] = ACTIONS(1234),
    [sym__subshell_start] = ACTIONS(1237),
    [sym__regex_start] = ACTIONS(1240),
    [sym__string_array_start] = ACTIONS(1243),
    [sym__symbol_array_start] = ACTIONS(1246),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1222),
    [sym__unary_minus] = ACTIONS(1249),
    [sym__unary_minus_num] = ACTIONS(1252),
    [sym__binary_minus] = ACTIONS(1255),
    [sym__identifier_suffix] = ACTIONS(1258),
    [sym__constant_suffix] = ACTIONS(1213),
  },
  [255] = {
    [sym_block_body] = STATE(5659),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_hash_splat_argument] = STATE(5561),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1993),
    [sym_identifier_suffix] = STATE(1994),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2773),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(255),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(5561),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1081),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [256] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4628),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(256),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(254),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [257] = {
    [sym_block_body] = STATE(5953),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(326),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_hash_splat_argument] = STATE(5497),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1993),
    [sym_identifier_suffix] = STATE(1994),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2773),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(257),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(5497),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1081),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [258] = {
    [sym_block_body] = STATE(5953),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(326),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_hash_splat_argument] = STATE(5497),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1993),
    [sym_identifier_suffix] = STATE(1994),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2773),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(258),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(5497),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1081),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [259] = {
    [sym_block_body] = STATE(5953),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(326),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_hash_splat_argument] = STATE(5497),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1993),
    [sym_identifier_suffix] = STATE(1994),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2773),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(259),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(5497),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1081),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [260] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(260),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [261] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2697),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(261),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [262] = {
    [sym__statements] = STATE(5087),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(262),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1287),
    [anon_sym_rescue] = ACTIONS(1287),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1287),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1287),
    [anon_sym_else] = ACTIONS(1287),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1287),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [263] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2672),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(263),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [264] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2778),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(264),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1297),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [265] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_elsif] = STATE(5673),
    [sym_else] = STATE(5673),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(265),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [266] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2718),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(266),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1317),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [267] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_elsif] = STATE(5829),
    [sym_else] = STATE(5829),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(267),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [268] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_elsif] = STATE(5706),
    [sym_else] = STATE(5706),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(268),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [269] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_elsif] = STATE(5681),
    [sym_else] = STATE(5681),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(269),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [270] = {
    [sym__statements] = STATE(5348),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(270),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [sym__terminator] = STATE(292),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1331),
    [anon_sym_rescue] = ACTIONS(1331),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1331),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [271] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_elsif] = STATE(5885),
    [sym_else] = STATE(5885),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(271),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [272] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_elsif] = STATE(5760),
    [sym_else] = STATE(5760),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(272),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [273] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_elsif] = STATE(5664),
    [sym_else] = STATE(5664),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(273),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [274] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2733),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(274),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1317),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [275] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2768),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(275),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1297),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [276] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4610),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_when] = STATE(5539),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5813),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(276),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym__terminator] = STATE(5289),
    [aux_sym_case_repeat1] = STATE(5266),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1343),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1345),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [277] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(277),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1347),
    [anon_sym_rescue] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1347),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [278] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(278),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1349),
    [anon_sym_rescue] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [279] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4619),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_when] = STATE(5539),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5748),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(279),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym__terminator] = STATE(5220),
    [aux_sym_case_repeat1] = STATE(5228),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1343),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1353),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [280] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(280),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1355),
    [anon_sym_rescue] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1355),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [281] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2791),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(281),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [282] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4620),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_when] = STATE(5539),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_else] = STATE(5826),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(282),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym__terminator] = STATE(5253),
    [aux_sym_case_repeat1] = STATE(5254),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1375),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1343),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1377),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [283] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2840),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(283),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(949),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(949),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_elsif] = ACTIONS(949),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [284] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2789),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(284),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [285] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(285),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1389),
    [anon_sym_rescue] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1389),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [286] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3307),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(286),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [287] = {
    [sym_block_body] = STATE(5914),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(330),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(287),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1429),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [288] = {
    [sym_block_body] = STATE(5825),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(332),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(288),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [289] = {
    [sym_block_body] = STATE(5953),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(326),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(289),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [290] = {
    [sym_block_body] = STATE(5726),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(322),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(290),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1435),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [291] = {
    [sym_block_body] = STATE(5851),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(320),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(291),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [292] = {
    [sym__statements] = STATE(5412),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(292),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1439),
    [anon_sym_rescue] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [293] = {
    [sym_block_body] = STATE(5987),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(331),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(293),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [294] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(294),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1443),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1443),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [295] = {
    [sym_block_body] = STATE(5659),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(327),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(295),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [296] = {
    [sym_block_body] = STATE(5798),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(321),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(296),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [297] = {
    [sym__statements] = STATE(5446),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(297),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1449),
    [anon_sym_rescue] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1449),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1449),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [298] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2856),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(298),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1461),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [299] = {
    [sym_block_body] = STATE(5846),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(328),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(299),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1469),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [300] = {
    [sym_block_body] = STATE(5922),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_block_parameters] = STATE(319),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(300),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [301] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(301),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [302] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(302),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1475),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1475),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [303] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3370),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(303),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [304] = {
    [sym__statements] = STATE(5040),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(304),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_then] = ACTIONS(1305),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [305] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3412),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(305),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [306] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3468),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(306),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [307] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3267),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(307),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [308] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3332),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(308),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [309] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3374),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(309),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [310] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2942),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(310),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [311] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(4636),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(311),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(1069),
    [anon_sym___END__] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
  },
  [312] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3356),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(312),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [313] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3054),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(313),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [314] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2903),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(314),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [315] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3417),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(315),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1581),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [316] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3543),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(316),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [317] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4775),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4747),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(317),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2145),
    [aux_sym__statements_repeat1] = STATE(318),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(9),
    [aux_sym_program_token1] = ACTIONS(1263),
    [anon_sym___END__] = ACTIONS(1265),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_undef] = ACTIONS(77),
    [anon_sym_alias] = ACTIONS(79),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [318] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4986),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(318),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2145),
    [aux_sym__statements_repeat1] = STATE(318),
    [ts_builtin_sym_end] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1101),
    [aux_sym_program_token1] = ACTIONS(1110),
    [anon_sym___END__] = ACTIONS(1124),
    [anon_sym_BEGIN] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_END] = ACTIONS(1112),
    [anon_sym_def] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1118),
    [anon_sym_COLON_COLON] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1132),
    [anon_sym_nil] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1138),
    [anon_sym_module] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1147),
    [anon_sym_break] = ACTIONS(1150),
    [anon_sym_next] = ACTIONS(1153),
    [anon_sym_redo] = ACTIONS(1156),
    [anon_sym_retry] = ACTIONS(1159),
    [anon_sym_if] = ACTIONS(1162),
    [anon_sym_unless] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1168),
    [anon_sym_until] = ACTIONS(1171),
    [anon_sym_for] = ACTIONS(1174),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1180),
    [anon_sym_DOT_DOT] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1186),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_defined_QMARK] = ACTIONS(1192),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1198),
    [anon_sym_TILDE] = ACTIONS(1198),
    [anon_sym_undef] = ACTIONS(1201),
    [anon_sym_alias] = ACTIONS(1204),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1207),
    [sym_float] = ACTIONS(1207),
    [sym_super] = ACTIONS(1101),
    [sym_self] = ACTIONS(1101),
    [sym_true] = ACTIONS(1210),
    [sym_false] = ACTIONS(1210),
    [sym_constant] = ACTIONS(1101),
    [aux_sym_constant_suffix_token1] = ACTIONS(1213),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1216),
    [sym_instance_variable] = ACTIONS(1219),
    [sym_class_variable] = ACTIONS(1219),
    [sym_global_variable] = ACTIONS(1219),
    [sym_character] = ACTIONS(1222),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [sym_simple_symbol] = ACTIONS(1228),
    [sym__string_start] = ACTIONS(1231),
    [sym__symbol_start] = ACTIONS(1234),
    [sym__subshell_start] = ACTIONS(1237),
    [sym__regex_start] = ACTIONS(1240),
    [sym__string_array_start] = ACTIONS(1243),
    [sym__symbol_array_start] = ACTIONS(1246),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1222),
    [sym__unary_minus] = ACTIONS(1249),
    [sym__unary_minus_num] = ACTIONS(1252),
    [sym__binary_minus] = ACTIONS(1255),
    [sym__identifier_suffix] = ACTIONS(1258),
    [sym__constant_suffix] = ACTIONS(1213),
  },
  [319] = {
    [sym_block_body] = STATE(5741),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(319),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1610),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [320] = {
    [sym_block_body] = STATE(5864),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(320),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1612),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [321] = {
    [sym_block_body] = STATE(5879),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(321),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1614),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [322] = {
    [sym_block_body] = STATE(5743),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(322),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1616),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [323] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3532),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(323),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [324] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3191),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(4655),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1985),
    [sym_identifier_suffix] = STATE(1986),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2642),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(324),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(1069),
    [anon_sym___END__] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1618),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
  },
  [325] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2981),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(325),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [326] = {
    [sym_block_body] = STATE(5816),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(326),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1626),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [327] = {
    [sym_block_body] = STATE(5642),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(327),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1628),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [328] = {
    [sym_block_body] = STATE(5925),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(328),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1630),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [329] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3118),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(329),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1644),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [330] = {
    [sym_block_body] = STATE(5969),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(330),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [331] = {
    [sym_block_body] = STATE(5952),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(331),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1654),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [332] = {
    [sym_block_body] = STATE(5769),
    [sym__statements] = STATE(5957),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(332),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [333] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3381),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(333),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1581),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [334] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_splat_parameter] = STATE(4528),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4533),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3591),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2489),
    [sym_identifier_suffix] = STATE(2482),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2269),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(334),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1666),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(1692),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [335] = {
    [sym__statements] = STATE(5684),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(335),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1698),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [336] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_splat_parameter] = STATE(4625),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4632),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4641),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3202),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2714),
    [sym_identifier_suffix] = STATE(2715),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2598),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(336),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(1704),
    [anon_sym_STAR_STAR] = ACTIONS(1706),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_DOT_DOT] = ACTIONS(1708),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(1712),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [337] = {
    [sym__statements] = STATE(5683),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(337),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1714),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [338] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_top_expr_body] = STATE(4974),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4970),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4028),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(3474),
    [sym_identifier_suffix] = STATE(3437),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3179),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(338),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(1724),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1730),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1744),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [339] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_top_expr_body] = STATE(4974),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4970),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4078),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(3474),
    [sym_identifier_suffix] = STATE(3437),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3179),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(339),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(1724),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1752),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1744),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [340] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(340),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
  },
  [341] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_splat_parameter] = STATE(4528),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4533),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2721),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2489),
    [sym_identifier_suffix] = STATE(2482),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2269),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(341),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1764),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_DOT_DOT] = ACTIONS(1766),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(1692),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [342] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_splat_parameter] = STATE(4625),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4632),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4641),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3442),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2714),
    [sym_identifier_suffix] = STATE(2715),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2598),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(342),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1768),
    [anon_sym_STAR] = ACTIONS(1704),
    [anon_sym_STAR_STAR] = ACTIONS(1706),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_DOT_DOT] = ACTIONS(1770),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(1712),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [343] = {
    [sym__statements] = STATE(5702),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(343),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1780),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [344] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4528),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4533),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4078),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(3132),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2262),
    [sym_constant_suffix] = STATE(3539),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2779),
    [sym_subshell] = STATE(3132),
    [sym_string_array] = STATE(3132),
    [sym_symbol_array] = STATE(3132),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(3132),
    [sym_heredoc_body] = STATE(344),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3137),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(1784),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1786),
    [anon_sym_COLON_COLON] = ACTIONS(1788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(1792),
    [anon_sym_DOT_DOT] = ACTIONS(1794),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1796),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1798),
    [sym_true] = ACTIONS(1800),
    [sym_false] = ACTIONS(1800),
    [sym_constant] = ACTIONS(1802),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1804),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(1806),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [345] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_top_expr_body] = STATE(4974),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4970),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4151),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(3474),
    [sym_identifier_suffix] = STATE(3437),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3179),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(345),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(1724),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1752),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1744),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [346] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3216),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(346),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [347] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_splat_parameter] = STATE(4776),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4768),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4770),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3949),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(3317),
    [sym_identifier_suffix] = STATE(3282),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2995),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(347),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(1812),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1814),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_DOT_DOT] = ACTIONS(1816),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(1826),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [348] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3586),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(348),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1842),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [349] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4885),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_top_expr_body] = STATE(4974),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4886),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4920),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4064),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(3348),
    [sym_identifier_suffix] = STATE(3351),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2907),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(349),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1852),
    [anon_sym_STAR] = ACTIONS(1724),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1854),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1864),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [350] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_splat_parameter] = STATE(4885),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_top_expr_body] = STATE(4974),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4886),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4920),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3946),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(3348),
    [sym_identifier_suffix] = STATE(3351),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2907),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(350),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1868),
    [anon_sym_STAR] = ACTIONS(1724),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1870),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1864),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [351] = {
    [sym__statements] = STATE(5974),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(351),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1882),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [352] = {
    [sym__statements] = STATE(5905),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(352),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [353] = {
    [sym__statements] = STATE(5881),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(353),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1886),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [354] = {
    [sym__statements] = STATE(5640),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(354),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [355] = {
    [sym__statements] = STATE(5839),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5636),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(355),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [356] = {
    [sym__statements] = STATE(5640),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5636),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(356),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [357] = {
    [sym__statements] = STATE(5676),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(357),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1890),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [358] = {
    [sym__statements] = STATE(5773),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(358),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1892),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [359] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_splat_parameter] = STATE(4776),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4768),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4770),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4119),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(3317),
    [sym_identifier_suffix] = STATE(3282),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2995),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(359),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(1812),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1894),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_DOT_DOT] = ACTIONS(1896),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(1826),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [360] = {
    [sym__statements] = STATE(5933),
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4634),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5636),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(360),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_empty_statement] = STATE(2059),
    [aux_sym__statements_repeat1] = STATE(256),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [361] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3223),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(361),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [362] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_splat_parameter] = STATE(4528),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4533),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2846),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2489),
    [sym_identifier_suffix] = STATE(2482),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2269),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(362),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_COLON_COLON] = ACTIONS(1664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1908),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_DOT_DOT] = ACTIONS(1910),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(1692),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [363] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3464),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(4743),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1990),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2724),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(363),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1071),
    [anon_sym_unless] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1071),
    [anon_sym_until] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(505),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(525),
    [sym__splat_star] = ACTIONS(527),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym_hash_key_symbol] = ACTIONS(533),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(535),
  },
  [364] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3366),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(364),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(947),
    [anon_sym___END__] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1924),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [365] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3751),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(365),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [366] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4977),
    [sym__argument] = STATE(4932),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(366),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
  },
  [367] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3753),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(367),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1954),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [368] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3662),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(368),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [369] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(4919),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(369),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
  },
  [370] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3752),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(370),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1980),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [371] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3673),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(371),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1954),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [372] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(5000),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(372),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [373] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3884),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(373),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [374] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3459),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(374),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [375] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3639),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(375),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [376] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(376),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [377] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4977),
    [sym__argument] = STATE(4992),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(377),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
  },
  [378] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3887),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(378),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [379] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3796),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(379),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [380] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3769),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(380),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [381] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4612),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(381),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(2062),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [382] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3916),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_command_argument_list] = STATE(4497),
    [sym__argument] = STATE(5056),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1998),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(3157),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(382),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(571),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(1071),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(571),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1069),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(601),
  },
  [383] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3783),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(383),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [384] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4613),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(384),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(2062),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [385] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3897),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4977),
    [sym__argument] = STATE(5072),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1996),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3139),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(385),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(559),
    [sym__splat_star] = ACTIONS(561),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym_hash_key_symbol] = ACTIONS(567),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(569),
  },
  [386] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4614),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(386),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(2062),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [387] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3879),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(387),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [388] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3624),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(388),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [389] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3666),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(389),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [390] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3432),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(390),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [391] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3794),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(391),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [392] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_command_argument_list] = STATE(4977),
    [sym__argument] = STATE(5239),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2010),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3196),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(392),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(1071),
    [anon_sym_or] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(633),
  },
  [393] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3521),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(393),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [394] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3988),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(394),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(2120),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [395] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3808),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(395),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [396] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3964),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(396),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2134),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [397] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3892),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(397),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(2120),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [398] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3890),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(398),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(909),
    [sym__element_reference_bracket] = ACTIONS(909),
  },
  [399] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3903),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(399),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [400] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4012),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(400),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_COLON_COLON] = ACTIONS(245),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_COLON_COLON2] = ACTIONS(947),
    [anon_sym_AMP_DOT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
    [sym__element_reference_bracket] = ACTIONS(947),
  },
  [401] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3998),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(401),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(949),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [402] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4853),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(402),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [403] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4838),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(403),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [404] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4089),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(404),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [405] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4868),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4855),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(405),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [406] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4116),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(406),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [407] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4857),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4855),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(407),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [408] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4872),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4855),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(408),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [409] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4882),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(409),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [410] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4877),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(410),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [411] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4865),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4855),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(411),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [412] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4856),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4855),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(412),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [413] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4866),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4855),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(413),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [414] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4875),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(414),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [415] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4876),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(415),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [416] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4104),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(416),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [417] = {
    [sym_begin_block] = STATE(4568),
    [sym_end_block] = STATE(4568),
    [sym__statement] = STATE(4851),
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_if_modifier] = STATE(4568),
    [sym_unless_modifier] = STATE(4568),
    [sym_while_modifier] = STATE(4568),
    [sym_until_modifier] = STATE(4568),
    [sym_rescue_modifier] = STATE(4568),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4602),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym_undef] = STATE(4568),
    [sym_alias] = STATE(4568),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(417),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [418] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4199),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(418),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(947),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [419] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4171),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(419),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [420] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4143),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(420),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_in] = ACTIONS(949),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [421] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4129),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(421),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [422] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5767),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(422),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2302),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [423] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5965),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(423),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2304),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [424] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5835),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(424),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2306),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [425] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4262),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(425),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__binary_star] = ACTIONS(909),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(909),
  },
  [426] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5663),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(426),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2326),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [427] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5945),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(427),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2328),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [428] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5972),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(428),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [429] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_expr] = STATE(4840),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4079),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3073),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(429),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1720),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1752),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(2336),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2338),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [430] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5938),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(430),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2340),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [431] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4243),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(431),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [432] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5707),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(432),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [433] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument] = STATE(5006),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(433),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2344),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [434] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5903),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(434),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [435] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5643),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(435),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2348),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [436] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4218),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(436),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(949),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [437] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5691),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(437),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2368),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [438] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument] = STATE(5006),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(438),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2370),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [439] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5875),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(439),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2372),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [440] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument_list_with_trailing_comma] = STATE(5917),
    [sym__argument] = STATE(5485),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(440),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2374),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [441] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_expr] = STATE(4843),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4078),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3073),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(441),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(2376),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1720),
    [anon_sym_COMMA] = ACTIONS(2376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1750),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1752),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(2336),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [442] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4298),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(442),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_COLON2] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(949),
    [anon_sym_or] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_LT_EQ_GT] = ACTIONS(947),
    [anon_sym_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_TILDE] = ACTIONS(947),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__binary_star] = ACTIONS(947),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
    [sym__binary_star_star] = ACTIONS(947),
  },
  [443] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym__argument] = STATE(5006),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1997),
    [sym_identifier_suffix] = STATE(1999),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2867),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(443),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(237),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(323),
    [sym__splat_star] = ACTIONS(325),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym_hash_key_symbol] = ACTIONS(331),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(335),
  },
  [444] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5324),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument] = STATE(5006),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2007),
    [sym_identifier_suffix] = STATE(2008),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(444),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2300),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [445] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(445),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
  },
  [446] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym__argument] = STATE(5006),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2009),
    [sym_identifier_suffix] = STATE(2010),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3196),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(446),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(633),
  },
  [447] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1984),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2528),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(447),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(185),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1551),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
  },
  [448] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(448),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [449] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym__argument] = STATE(5006),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2004),
    [sym_identifier_suffix] = STATE(2003),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2952),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(449),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(407),
  },
  [450] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2001),
    [sym_identifier_suffix] = STATE(2002),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2869),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(450),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(339),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(361),
    [sym__splat_star] = ACTIONS(363),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym_hash_key_symbol] = ACTIONS(369),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(371),
  },
  [451] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1963),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2450),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(451),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [452] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4965),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3897),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym__argument] = STATE(5006),
    [sym_forward_argument] = STATE(5005),
    [sym_splat_argument] = STATE(5005),
    [sym_hash_splat_argument] = STATE(5005),
    [sym_block_argument] = STATE(5005),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(1992),
    [sym_identifier_suffix] = STATE(1996),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3139),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(452),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5005),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__block_ampersand] = ACTIONS(559),
    [sym__splat_star] = ACTIONS(561),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym_hash_key_symbol] = ACTIONS(567),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
    [sym__hash_splat_star_star] = ACTIONS(569),
  },
  [453] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3191),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1985),
    [sym_identifier_suffix] = STATE(1986),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2642),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(453),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1618),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
  },
  [454] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1966),
    [sym_identifier_suffix] = STATE(1967),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2264),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(454),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(161),
    [sym__splat_star] = ACTIONS(163),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym_hash_key_symbol] = ACTIONS(169),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(173),
  },
  [455] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3916),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1998),
    [sym_identifier_suffix] = STATE(1989),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(3157),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(455),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(571),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(571),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(601),
  },
  [456] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4511),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3464),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym__argument] = STATE(4501),
    [sym_forward_argument] = STATE(4504),
    [sym_splat_argument] = STATE(4504),
    [sym_hash_splat_argument] = STATE(4504),
    [sym_block_argument] = STATE(4504),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1990),
    [sym_identifier_suffix] = STATE(1995),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2724),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(456),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_pair] = STATE(4504),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(505),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(525),
    [sym__splat_star] = ACTIONS(527),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym_hash_key_symbol] = ACTIONS(533),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
    [sym__hash_splat_star_star] = ACTIONS(535),
  },
  [457] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4599),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2740),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2726),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2137),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(457),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_defined_QMARK] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(2406),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [458] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4552),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2640),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2663),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(458),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2408),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [459] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4915),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3515),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3549),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(459),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2410),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [460] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4941),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5257),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3859),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3742),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(460),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [461] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4941),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5461),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3935),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(4031),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(461),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [462] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4599),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2710),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2708),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(462),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [463] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(5267),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3711),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3813),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(463),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2434),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [464] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4806),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3350),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3364),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(464),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [465] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4941),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4990),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3557),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3648),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(465),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2438),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [466] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(5105),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3874),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(466),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2434),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [467] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4642),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2889),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2896),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(467),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2440),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [468] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4941),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5390),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3968),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3941),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(468),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2442),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [469] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4720),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3134),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3135),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(469),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2444),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [470] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4846),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3309),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3284),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2211),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(470),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [471] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4752),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3134),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3135),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2176),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(471),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2444),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [472] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4599),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2710),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2708),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2137),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(472),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_defined_QMARK] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(2406),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [473] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4752),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3169),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3175),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2176),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(473),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2444),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [474] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4941),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4975),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3561),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3550),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(474),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2466),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [475] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4941),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5390),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3882),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3598),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(475),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2442),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [476] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4599),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2740),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2726),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(476),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [477] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4846),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3350),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3364),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2211),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(477),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [478] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4584),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2740),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2726),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(478),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [479] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4584),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2740),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2726),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(479),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [480] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_rescue_modifier_expression] = STATE(4941),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5260),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3882),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3598),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(480),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2442),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [481] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_rescue_modifier_expression] = STATE(4490),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4552),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2640),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2663),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(481),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2408),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [482] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2717),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(482),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2468),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2468),
    [anon_sym_else] = ACTIONS(2468),
    [anon_sym_then] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2468),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2334),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [483] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2721),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(483),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2474),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_then] = ACTIONS(2474),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2474),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [484] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_rescue_modifier_expression] = STATE(4969),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5261),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3966),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(484),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [485] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4597),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2788),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(19),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5662),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(485),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_defined_QMARK] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2486),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [486] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4916),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3553),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(486),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [487] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4763),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3231),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2176),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(487),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [488] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_rescue_modifier_expression] = STATE(4969),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4943),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3636),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(488),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [489] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(5271),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3970),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(19),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5662),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(489),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_defined_QMARK] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2486),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [490] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4643),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2984),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(490),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [491] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2672),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(491),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [492] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2674),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(492),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2490),
    [anon_sym_rescue] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_then] = ACTIONS(2490),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2490),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2488),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [493] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4850),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3546),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(493),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [494] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2732),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(494),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2494),
    [anon_sym_rescue] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_then] = ACTIONS(2494),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2494),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2492),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [495] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_rescue_modifier_expression] = STATE(4969),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5462),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4115),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5797),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(92),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(495),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_defined_QMARK] = ACTIONS(2498),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2504),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [496] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4555),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2700),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(496),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [497] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4763),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3266),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(497),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [498] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_rescue_modifier_expression] = STATE(4969),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4976),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3616),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(498),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [499] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4555),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2700),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(499),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [500] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4721),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3231),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(500),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [501] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4597),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2788),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(501),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [502] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4597),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2763),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2137),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(502),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_defined_QMARK] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2406),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [503] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_rescue_modifier_expression] = STATE(4969),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5236),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3962),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(503),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [504] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4579),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2763),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(504),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [505] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4850),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3379),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2211),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(505),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [506] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4597),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2763),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(506),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [507] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(5106),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3773),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(507),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [508] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2743),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(508),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2508),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_elsif] = ACTIONS(2508),
    [anon_sym_else] = ACTIONS(2508),
    [anon_sym_then] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [509] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4579),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2763),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(509),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [510] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2846),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(510),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2474),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_elsif] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_then] = ACTIONS(2474),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2474),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [511] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2847),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(511),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2468),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_elsif] = ACTIONS(2468),
    [anon_sym_else] = ACTIONS(2468),
    [anon_sym_then] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2468),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2334),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [512] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_rescue_modifier_expression] = STATE(4493),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4807),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3379),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(512),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [513] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_rescue_modifier_expression] = STATE(4969),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5334),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3966),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(513),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [514] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_rescue_modifier_expression] = STATE(4969),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5334),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4124),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5797),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(92),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(514),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_defined_QMARK] = ACTIONS(2498),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2504),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [515] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2837),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(515),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2508),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_elsif] = ACTIONS(2508),
    [anon_sym_else] = ACTIONS(2508),
    [anon_sym_then] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [516] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2778),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(516),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_elsif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(911),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [517] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2836),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(517),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2494),
    [anon_sym_rescue] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_elsif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_then] = ACTIONS(2494),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2494),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2492),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [518] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2774),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(518),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2490),
    [anon_sym_rescue] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_elsif] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_then] = ACTIONS(2490),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2490),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2488),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [519] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3017),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2176),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(519),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [520] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2675),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(520),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [521] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2676),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(521),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [522] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(522),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [523] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(523),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [524] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4594),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(524),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [525] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4595),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(525),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [526] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4596),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(526),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [527] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4598),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(527),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [528] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4593),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(528),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [529] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4513),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(529),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [530] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2793),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(530),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [531] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3218),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(531),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [532] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3198),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(532),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [533] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3925),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(533),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [534] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(534),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [535] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2775),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(535),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [536] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2776),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(536),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [537] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(537),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [538] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3183),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(538),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [539] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3017),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(539),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [540] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3877),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(540),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [541] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4981),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3765),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(541),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [542] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4985),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3766),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(542),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [543] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5036),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3876),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(543),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [544] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3535),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(544),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [545] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(5463),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(4054),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(545),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [546] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3340),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(546),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [547] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3758),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(547),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [548] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3466),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(548),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [549] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3439),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(549),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [550] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3440),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(550),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [551] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(551),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [552] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4033),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(552),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [553] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(4030),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(553),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [554] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(4024),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(554),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [555] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(4040),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(555),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [556] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3661),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(556),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [557] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4981),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4023),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(557),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [558] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4985),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3992),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(558),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [559] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5036),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3876),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(559),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [560] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2990),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(560),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [561] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5568),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4209),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5844),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2544),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(561),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [562] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4513),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(4054),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(562),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [563] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3877),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(34),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(377),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5818),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(74),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2448),
    [sym__variable] = STATE(35),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(563),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [564] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4749),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(564),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [565] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(5299),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(4054),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(565),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [566] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(5320),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(4054),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(566),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [567] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3535),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(567),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [568] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4211),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5844),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2544),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(568),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [569] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3499),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(569),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [570] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3501),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(570),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [571] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(571),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [572] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4759),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(572),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [573] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3925),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(573),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [574] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4981),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3932),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(574),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [575] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5817),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2140),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(575),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [576] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4985),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3939),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(576),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [577] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4862),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(577),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [578] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4867),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(578),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [579] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4871),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(579),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [580] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4873),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(580),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [581] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4874),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(581),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [582] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4513),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(32),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5687),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2201),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(582),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_defined_QMARK] = ACTIONS(2220),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2226),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [583] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4083),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5797),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(92),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(583),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_defined_QMARK] = ACTIONS(2498),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2504),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [584] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5036),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3609),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5784),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2480),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(584),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_defined_QMARK] = ACTIONS(551),
    [anon_sym_not] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(563),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [585] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5025),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4035),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(585),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [586] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4748),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(586),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [587] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2698),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(587),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [588] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4757),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(588),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [589] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4750),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(589),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [590] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4513),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(590),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [591] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4211),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5844),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2544),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(591),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [592] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4981),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4212),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5844),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2544),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(592),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [593] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4985),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4128),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5844),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2544),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(593),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [594] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5036),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3876),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5844),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2544),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(594),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [595] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3466),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5669),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2220),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(595),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_defined_QMARK] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(529),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [596] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4033),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(36),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5678),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(76),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2492),
    [sym__variable] = STATE(37),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(596),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [597] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5025),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4209),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5844),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2544),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(597),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [598] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3339),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(598),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [599] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3706),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(599),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [600] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(600),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [601] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3647),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(601),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [602] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3661),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(602),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [603] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(4030),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(23),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5946),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(75),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2483),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(603),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_defined_QMARK] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2518),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [604] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3346),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(604),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [605] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3907),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(605),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [606] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2990),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(606),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [607] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2954),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(607),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [608] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2955),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(608),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [609] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3017),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2744),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(311),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5907),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(10),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(609),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [610] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2793),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(610),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [611] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3706),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(25),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(369),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5785),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(67),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2310),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(611),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(343),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(347),
    [anon_sym_next] = ACTIONS(349),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_defined_QMARK] = ACTIONS(351),
    [anon_sym_not] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(357),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(365),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [612] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(612),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [613] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2793),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(19),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5662),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(613),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_defined_QMARK] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2486),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [614] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2698),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(614),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [615] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2832),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(615),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [616] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2850),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(616),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [617] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3907),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(617),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [618] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3972),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(618),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [619] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3974),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(619),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [620] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3661),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(29),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(382),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5711),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(62),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2481),
    [sym__variable] = STATE(31),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(620),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [621] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5562),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4209),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(392),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5844),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(109),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2544),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(621),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_defined_QMARK] = ACTIONS(2522),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2528),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [622] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3758),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(622),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [623] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4981),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3691),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(623),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [624] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4985),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3703),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(624),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [625] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5036),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3609),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3287),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(366),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5956),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(28),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(625),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(253),
    [anon_sym_yield] = ACTIONS(255),
    [anon_sym_break] = ACTIONS(257),
    [anon_sym_next] = ACTIONS(259),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(285),
    [anon_sym_not] = ACTIONS(287),
    [anon_sym_BANG] = ACTIONS(291),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(327),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [626] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5845),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(4),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(626),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [627] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4083),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5797),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(92),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(627),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_defined_QMARK] = ACTIONS(2498),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2504),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [628] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3925),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(628),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [629] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4981),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3932),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(629),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [630] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4985),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3939),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(630),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [631] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5036),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3609),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(631),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [632] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4981),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4086),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5797),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(92),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(632),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_defined_QMARK] = ACTIONS(2498),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2504),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [633] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4985),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(4087),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5797),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(92),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(633),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_defined_QMARK] = ACTIONS(2498),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2504),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [634] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(5036),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3609),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5797),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(92),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(634),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_defined_QMARK] = ACTIONS(2498),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2504),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [635] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return_command] = STATE(5031),
    [sym_yield_command] = STATE(5031),
    [sym_break_command] = STATE(5031),
    [sym_next_command] = STATE(5031),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__expression] = STATE(4982),
    [sym_match_pattern] = STATE(5031),
    [sym_test_pattern] = STATE(5031),
    [sym__arg] = STATE(3925),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3509),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(5032),
    [sym_command_call_with_block] = STATE(4827),
    [sym__chained_command_call] = STATE(385),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_command_assignment] = STATE(5031),
    [sym_operator_assignment] = STATE(3473),
    [sym_command_operator_assignment] = STATE(5031),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_command_binary] = STATE(5031),
    [sym_unary] = STATE(3473),
    [sym_command_unary] = STATE(5031),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5779),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2493),
    [sym__variable] = STATE(26),
    [sym__nonlocal_variable] = STATE(1954),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2005),
    [sym_identifier_suffix] = STATE(2006),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(635),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_next] = ACTIONS(549),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_defined_QMARK] = ACTIONS(2416),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(295),
    [sym_self] = ACTIONS(295),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(295),
    [aux_sym_constant_suffix_token1] = ACTIONS(299),
    [aux_sym_identifier_suffix_token1] = ACTIONS(301),
    [sym_instance_variable] = ACTIONS(303),
    [sym_class_variable] = ACTIONS(303),
    [sym_global_variable] = ACTIONS(303),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2422),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(333),
    [sym__constant_suffix] = ACTIONS(299),
  },
  [636] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2793),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(19),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5662),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(636),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_defined_QMARK] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2486),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [637] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2832),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(19),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5662),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(637),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_defined_QMARK] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2486),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [638] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2850),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(19),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5662),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(638),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_defined_QMARK] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2486),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [639] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(19),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5662),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2445),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(639),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_defined_QMARK] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2486),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [640] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3017),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(640),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [641] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3218),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2176),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(641),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [642] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3198),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2176),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(642),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [643] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3183),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2176),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(643),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [644] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(644),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [645] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2775),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(645),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [646] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3218),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2176),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(646),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [647] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2776),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(647),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [648] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5887),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(648),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_defined_QMARK] = ACTIONS(2426),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2432),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [649] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3218),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(13),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5919),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2175),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(649),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [650] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2698),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(650),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [651] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(651),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [652] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2675),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(652),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [653] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2676),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2495),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(7),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(248),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5775),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(653),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_defined_QMARK] = ACTIONS(145),
    [anon_sym_not] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(165),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [654] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2698),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3225),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5701),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(58),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(18),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(654),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [655] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(655),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [656] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2775),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(656),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [657] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2776),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(657),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [658] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3425),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(372),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5758),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2463),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(658),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_next] = ACTIONS(493),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(501),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(503),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [659] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2137),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(659),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_defined_QMARK] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2406),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [660] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2775),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2137),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(660),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_defined_QMARK] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2406),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [661] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2776),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2137),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(661),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_defined_QMARK] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2406),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [662] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2137),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(662),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_defined_QMARK] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2406),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [663] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3466),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2211),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(663),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [664] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4509),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3439),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2211),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(664),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [665] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4482),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3440),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2211),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(665),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [666] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2682),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2211),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(666),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [667] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2563),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(252),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5677),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2137),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(667),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_defined_QMARK] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2406),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [668] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3466),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2980),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4499),
    [sym__chained_command_call] = STATE(363),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2211),
    [sym__variable] = STATE(20),
    [sym__nonlocal_variable] = STATE(1909),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(668),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_next] = ACTIONS(515),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(153),
    [sym_self] = ACTIONS(153),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(153),
    [aux_sym_constant_suffix_token1] = ACTIONS(155),
    [aux_sym_identifier_suffix_token1] = ACTIONS(157),
    [sym_instance_variable] = ACTIONS(159),
    [sym_class_variable] = ACTIONS(159),
    [sym_global_variable] = ACTIONS(159),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(171),
    [sym__constant_suffix] = ACTIONS(155),
  },
  [669] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return_command] = STATE(4491),
    [sym_yield_command] = STATE(4491),
    [sym_break_command] = STATE(4491),
    [sym_next_command] = STATE(4491),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__expression] = STATE(4479),
    [sym_match_pattern] = STATE(4491),
    [sym_test_pattern] = STATE(4491),
    [sym__arg] = STATE(3340),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2843),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(8),
    [sym_command_call] = STATE(4488),
    [sym_command_call_with_block] = STATE(4601),
    [sym__chained_command_call] = STATE(324),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_command_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(2543),
    [sym_command_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_command_binary] = STATE(4491),
    [sym_unary] = STATE(2543),
    [sym_command_unary] = STATE(4491),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5884),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(12),
    [sym__nonlocal_variable] = STATE(1921),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(1988),
    [sym_identifier_suffix] = STATE(1987),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(669),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [670] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3202),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(670),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2472),
    [anon_sym___END__] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [671] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3203),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(671),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2334),
    [anon_sym___END__] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2334),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [672] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__hash_pattern_body] = STATE(5733),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5561),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3562),
    [sym_identifier_suffix] = STATE(3563),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3578),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(672),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5561),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [673] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__hash_pattern_body] = STATE(5733),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5497),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3562),
    [sym_identifier_suffix] = STATE(3563),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3578),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(673),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5497),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [674] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__hash_pattern_body] = STATE(5654),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5561),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3562),
    [sym_identifier_suffix] = STATE(3563),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3578),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(674),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5561),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [675] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__hash_pattern_body] = STATE(5654),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5497),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3562),
    [sym_identifier_suffix] = STATE(3563),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3578),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(675),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5497),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [676] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__hash_pattern_body] = STATE(5733),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5561),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3562),
    [sym_identifier_suffix] = STATE(3563),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3578),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(676),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5561),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2530),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [677] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3456),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(677),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2334),
    [anon_sym___END__] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2334),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [678] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2953),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(678),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2488),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2488),
    [anon_sym___END__] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2488),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [679] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3199),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(679),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2506),
    [anon_sym___END__] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [680] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_then] = STATE(5409),
    [sym_begin] = STATE(2402),
    [sym_exceptions] = STATE(5155),
    [sym_exception_variable] = STATE(5326),
    [sym__arg] = STATE(3910),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(5225),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(680),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym__terminator] = STATE(280),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(2544),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [681] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2903),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(681),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [682] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3442),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(682),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2472),
    [anon_sym___END__] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [683] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3201),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(683),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2492),
    [anon_sym___END__] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2492),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [684] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3216),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(684),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [685] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3197),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(685),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2488),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2488),
    [anon_sym___END__] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2488),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [686] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3422),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(686),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2506),
    [anon_sym___END__] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [687] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3460),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(687),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [sym_identifier] = ACTIONS(907),
    [aux_sym_program_token1] = ACTIONS(2492),
    [anon_sym___END__] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2492),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [688] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_primitive] = STATE(4826),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3888),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3747),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2612),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3419),
    [sym_subshell] = STATE(3747),
    [sym_string_array] = STATE(3747),
    [sym_symbol_array] = STATE(3747),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3747),
    [sym_heredoc_body] = STATE(688),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3756),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(2548),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [689] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3949),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(689),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_then] = ACTIONS(2474),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [690] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3951),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(690),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_then] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2334),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [691] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3548),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(691),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2334),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [692] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3591),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(692),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [693] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3946),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(693),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [694] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3950),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(694),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2338),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [695] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_primitive] = STATE(4456),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3197),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2203),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(695),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [696] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_primitive] = STATE(4826),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3864),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3073),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(696),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [697] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_primitive] = STATE(4456),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2674),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2203),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(697),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [698] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3913),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(698),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [699] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3702),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(699),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [700] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_primitive] = STATE(4456),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2774),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2203),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(700),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [701] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_primitive] = STATE(4456),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3607),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2203),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(701),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [702] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_primitive] = STATE(4826),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3888),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3073),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(702),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [703] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_primitive] = STATE(4826),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3702),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3073),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(703),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [704] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4064),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(704),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [705] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_primitive] = STATE(4826),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2833),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(3155),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2229),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2783),
    [sym_subshell] = STATE(3155),
    [sym_string_array] = STATE(3155),
    [sym_symbol_array] = STATE(3155),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(3155),
    [sym_heredoc_body] = STATE(705),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(3166),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(2552),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [706] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4028),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(706),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [707] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(707),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [708] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3891),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(708),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [709] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_primitive] = STATE(4456),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2953),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2203),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(709),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [710] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4065),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(710),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2338),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [711] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4119),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(711),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(2474),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2472),
    [sym__no_line_break] = ACTIONS(2476),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [712] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3589),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(712),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2492),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [713] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3590),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(713),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [714] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3459),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(714),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [715] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3438),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(715),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2488),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [716] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4120),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(716),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2334),
    [sym__no_line_break] = ACTIONS(2470),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [717] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3906),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(717),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_then] = ACTIONS(2494),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2492),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [718] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_primitive] = STATE(4826),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3677),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3276),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2440),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3073),
    [sym_subshell] = STATE(3276),
    [sym_string_array] = STATE(3276),
    [sym_symbol_array] = STATE(3276),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3276),
    [sym_heredoc_body] = STATE(718),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3246),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1740),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1746),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [719] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_primitive] = STATE(4456),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3971),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2203),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(719),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [720] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym__pattern_primitive] = STATE(4456),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3438),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2349),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2084),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2203),
    [sym_subshell] = STATE(2349),
    [sym_string_array] = STATE(2349),
    [sym_symbol_array] = STATE(2349),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2349),
    [sym_heredoc_body] = STATE(720),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2432),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(1688),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1694),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [721] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_primitive] = STATE(4826),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3888),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3747),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2612),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3419),
    [sym_subshell] = STATE(3747),
    [sym_string_array] = STATE(3747),
    [sym_symbol_array] = STATE(3747),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3747),
    [sym_heredoc_body] = STATE(721),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3756),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(2548),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [722] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3908),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(722),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_then] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [723] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3607),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(723),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_then] = ACTIONS(2490),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2488),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [724] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym__pattern_primitive] = STATE(4456),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3888),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(3132),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2262),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2849),
    [sym_subshell] = STATE(3132),
    [sym_string_array] = STATE(3132),
    [sym_symbol_array] = STATE(3132),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(3132),
    [sym_heredoc_body] = STATE(724),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3137),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1796),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1798),
    [sym_true] = ACTIONS(1800),
    [sym_false] = ACTIONS(1800),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1804),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(1806),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [725] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4029),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(725),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2338),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [726] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3666),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(726),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [727] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3864),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(727),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [728] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3677),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(728),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [729] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4056),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(729),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [730] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3751),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(730),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [731] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4118),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(731),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2506),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [732] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4117),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(732),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(2494),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2492),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [733] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4152),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(733),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2338),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [734] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3971),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(734),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(2490),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2488),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [735] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3995),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(735),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [736] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3892),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(736),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [737] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3808),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(737),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [738] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4095),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(738),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_rescue] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [739] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4043),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(739),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [740] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4151),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(740),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [741] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5621),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(741),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5621),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [742] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5561),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(742),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5561),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [743] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4078),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(743),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2550),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [744] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5621),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(744),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5621),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [745] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5621),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(745),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5621),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [746] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3993),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(746),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(909),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [747] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5497),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(747),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5497),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [748] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5571),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(748),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5571),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [749] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3879),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(749),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [750] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3888),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(750),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2490),
    [anon_sym_or] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [751] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4133),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(751),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2494),
    [anon_sym_or] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [752] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4134),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(752),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [753] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4079),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(753),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym__no_line_break] = ACTIONS(2338),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [754] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5621),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(754),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5621),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [755] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5621),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(755),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5621),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [756] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5621),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(756),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5621),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [757] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2885),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2894),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(757),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2574),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [758] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3488),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3601),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(758),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [759] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3125),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3213),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(759),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2578),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [760] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3236),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3200),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(760),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [761] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3555),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3598),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(761),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2442),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [762] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3618),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3813),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(762),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2434),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [763] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3560),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3742),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(763),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [764] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2708),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(764),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [765] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3493),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(765),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [766] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2713),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2726),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(766),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [767] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3180),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3135),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(767),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2444),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [768] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3558),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3648),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(768),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2438),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [769] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4125),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(4067),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(769),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2582),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [770] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3369),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3284),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(770),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [771] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3141),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3175),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(771),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2444),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [772] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2651),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2663),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(772),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2408),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [773] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2873),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2896),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(773),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2440),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [774] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2777),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2759),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(774),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [775] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4111),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(4108),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(775),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2582),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [776] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4126),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(776),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [777] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3669),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3874),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(777),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2434),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [778] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3678),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3790),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(778),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2586),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [779] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3898),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(4007),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(779),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [780] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3552),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3550),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(780),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2466),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [781] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3899),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(4031),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(781),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [782] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2527),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2536),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(782),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2590),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [783] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3210),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3208),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(783),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [784] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2780),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2781),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(784),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [785] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3757),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3657),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(785),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2594),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [786] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2854),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2857),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(786),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2574),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [787] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4055),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(4206),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(787),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2596),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [788] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2669),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2701),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(788),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2598),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [789] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3364),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(789),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [790] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3540),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3576),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(790),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2600),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [791] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3926),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3996),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(791),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [792] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3514),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3595),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(792),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [793] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2545),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2525),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(793),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2590),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [794] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4121),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(4192),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(794),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2596),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [795] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3211),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3283),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(795),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2600),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [796] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3463),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3983),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3941),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3463),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(796),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2442),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [797] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2478),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2486),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(797),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2602),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [798] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3244),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3275),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(798),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2604),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [799] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2537),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3549),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2537),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(799),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2410),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [800] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3604),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3799),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(800),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2586),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [801] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3377),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3455),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(801),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2606),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [802] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3070),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3660),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3656),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_right_assignment_list] = STATE(3070),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(802),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2594),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [803] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2297),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3300),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(3420),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_right_assignment_list] = STATE(2297),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(803),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2606),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [804] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_hash_splat_argument] = STATE(5621),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(3565),
    [sym_identifier_suffix] = STATE(3581),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3226),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(804),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_pair] = STATE(5621),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(2554),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [805] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_pattern] = STATE(5464),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4088),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(5347),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(805),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [806] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4150),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(806),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2608),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [807] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4254),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(807),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_PIPE] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [808] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_pattern] = STATE(5108),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4088),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(5347),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(808),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [809] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4168),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(809),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [810] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4169),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(810),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [811] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3741),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3428),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(811),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2442),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [812] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4163),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3428),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(812),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2582),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [813] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3265),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3029),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(813),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [814] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4256),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3428),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(814),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2596),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [815] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3229),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2530),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(815),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2444),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [816] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3787),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3029),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(816),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2594),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [817] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2908),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2530),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(817),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2440),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [818] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3764),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3428),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(818),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2438),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [819] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3355),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2364),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(819),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2578),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [820] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2530),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(820),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2404),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [821] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2514),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2364),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(821),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2602),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [822] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3529),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2364),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(822),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2606),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [823] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3836),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3428),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(823),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [824] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3759),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2364),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(824),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [825] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3365),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3029),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(825),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [826] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4026),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(5312),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(826),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [827] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2941),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2364),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(827),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2574),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [828] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4238),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(828),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(2608),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [829] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3655),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3428),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(829),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2466),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [830] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2741),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2364),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(830),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2598),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [831] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4174),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(831),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_do] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [832] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3704),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2530),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(832),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2410),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [833] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3416),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3029),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(833),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2604),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [834] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2787),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2364),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(834),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [835] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3477),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2530),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(835),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2436),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [836] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3982),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3029),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(836),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2586),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [837] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2685),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2530),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(837),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2408),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [838] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2609),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2364),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(838),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2590),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [839] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3457),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_splat_argument] = STATE(3029),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(839),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__splat_star] = ACTIONS(2600),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [840] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3900),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2530),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(840),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2434),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [841] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4110),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_splat_argument] = STATE(2530),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(841),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [842] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3667),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(842),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [843] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3547),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(843),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [844] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2577),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(844),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [845] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2677),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(845),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [846] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3248),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(846),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [847] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4141),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(847),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [848] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2522),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(848),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [849] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3843),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(849),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [850] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3484),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(850),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [851] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3975),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(851),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [852] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2985),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(852),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [853] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3559),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(853),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [854] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3430),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(854),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [855] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3772),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(855),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [856] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3728),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(856),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [857] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3522),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(857),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [858] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3185),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(858),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [859] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3861),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(859),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [860] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3611),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(860),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [861] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3268),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(861),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [862] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2564),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(862),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [863] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3475),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(863),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [864] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3625),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(864),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [865] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3868),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(865),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [866] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3682),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(866),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [867] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3325),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(867),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [868] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3214),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(868),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [869] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4080),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(869),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [870] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2770),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(870),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [871] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3627),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(871),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [872] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4122),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(872),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [873] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2868),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(873),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [874] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3305),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(874),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [875] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2647),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(875),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [876] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2895),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(876),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [877] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3676),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(877),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [878] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3791),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(878),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [879] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4112),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(879),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [880] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3057),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(880),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [881] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3605),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(881),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [882] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3158),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(882),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [883] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3583),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(883),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [884] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3188),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(884),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [885] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2641),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(885),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [886] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3434),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(886),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [887] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(5372),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4048),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(887),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [888] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3912),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(888),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [889] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3061),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(889),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [890] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2706),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(890),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [891] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4037),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(891),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [892] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2844),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(892),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [893] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3596),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(893),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [894] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2798),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(894),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [895] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4235),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(895),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [896] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4259),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(896),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [897] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3342),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(897),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [898] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2532),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3977),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(898),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [899] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3423),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4183),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(899),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [900] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3923),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(900),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [901] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3938),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(901),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [902] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2518),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(902),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [903] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3140),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(903),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [904] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3261),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(904),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [905] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3610),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(905),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [906] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3709),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(906),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [907] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2404),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2795),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(907),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [908] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_rescue_modifier_arg] = STATE(2298),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2728),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(908),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [909] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3343),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(909),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [910] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3071),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3285),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(910),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [911] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_rescue_modifier_arg] = STATE(3027),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3288),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(911),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [912] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4361),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(912),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [913] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4378),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(913),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [914] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2817),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(914),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [915] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2819),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(915),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [916] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2820),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(916),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [917] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2821),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(917),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [918] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2822),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(918),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [919] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2823),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(919),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [920] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2824),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(920),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [921] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2825),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(921),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [922] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2826),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(922),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [923] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2827),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(923),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [924] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4177),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(924),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [925] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2828),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(925),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [926] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4178),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(926),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [927] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3278),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(927),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [928] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4151),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(928),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [929] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3291),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(929),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [930] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3270),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(930),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [931] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3361),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(931),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [932] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3249),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(932),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [933] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3264),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(933),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [934] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4343),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(934),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [935] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4223),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(935),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [936] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3326),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(936),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [937] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3327),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(937),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [938] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4177),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(938),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [939] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4213),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(939),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [940] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4136),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(940),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [941] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(941),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [942] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2852),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(942),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [943] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2870),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(943),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [944] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2871),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(944),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [945] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3337),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(945),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [946] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3881),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(946),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [947] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3888),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(947),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [948] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3338),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(948),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [949] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3881),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(949),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [950] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3858),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(950),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [951] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3860),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(951),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [952] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(952),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [953] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4131),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(953),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [954] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4135),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(954),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [955] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4137),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(955),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [956] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4138),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(956),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [957] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4146),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(957),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [958] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4148),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(958),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [959] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3851),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(959),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [960] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3872),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(960),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [961] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3854),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(961),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [962] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3832),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(962),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [963] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3840),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(963),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [964] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3838),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(964),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [965] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3853),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(965),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [966] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3814),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(966),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [967] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3845),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(967),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [968] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3847),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(968),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [969] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3849),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(969),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [970] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4193),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(970),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [971] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4197),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(971),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [972] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3850),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(972),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [973] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4198),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(973),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [974] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4200),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(974),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [975] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4203),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(975),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [976] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3202),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(976),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [977] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4132),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(977),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [978] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3802),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(978),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [979] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4047),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(979),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [980] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3810),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(980),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [981] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3442),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(981),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [982] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3909),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(982),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [983] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3937),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(983),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [984] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3940),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(984),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [985] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(985),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [986] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4149),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(986),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [987] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3934),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(987),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [988] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3936),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(988),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [989] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3947),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(989),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [990] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3948),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(990),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [991] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3990),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(991),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [992] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3952),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(992),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [993] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3920),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(993),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [994] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3953),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(994),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [995] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3954),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(995),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [996] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3956),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(996),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [997] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3961),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(997),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [998] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3987),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(998),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [999] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3949),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(999),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1000] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3963),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1000),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1001] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4075),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1001),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1002] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3933),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1002),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1003] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4076),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1003),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1004] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4081),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1004),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1005] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4084),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1005),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1006] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1006),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1007] = {
    [sym_heredoc_body] = STATE(1007),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1008] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4057),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1008),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1009] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4058),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1009),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1010] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4059),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1010),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1011] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4060),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1011),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1012] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4061),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1012),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1013] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4062),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1013),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1014] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4063),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1014),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1015] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4068),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1015),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1016] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4071),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1016),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1017] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4072),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1017),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1018] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4074),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1018),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1019] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4113),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1019),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1020] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3958),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1020),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1021] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4066),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1021),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1022] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4232),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1022),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1023] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4239),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1023),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1024] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4217),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1024),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1025] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1025),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1026] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4205),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1026),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1027] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4234),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1027),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1028] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4236),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1028),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1029] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4265),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1029),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1030] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4241),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1030),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1031] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4245),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1031),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1032] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4247),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1032),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1033] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4250),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1033),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1034] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4251),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1034),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1035] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4252),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1035),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1036] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4258),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1036),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1037] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4260),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1037),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1038] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4154),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1038),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1039] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4215),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1039),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1040] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4249),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1040),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1041] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4221),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1041),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1042] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3354),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1042),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1043] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3328),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1043),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1044] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4078),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1044),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1045] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3277),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1045),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1046] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3280),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1046),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1047] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1047),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1048] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4005),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1048),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1049] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4044),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1049),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1050] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4019),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1050),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1051] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1051),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1052] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3505),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1052),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1053] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3495),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1053),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1054] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4036),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1054),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1055] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4039),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1055),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1056] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4042),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1056),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1057] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3505),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1057),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1058] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3186),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1058),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1059] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3187),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1059),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1060] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1060),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1061] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4000),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1061),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1062] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4006),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1062),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1063] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4011),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1063),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1064] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4001),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1064),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1065] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4046),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1065),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1066] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4051),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1066),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1067] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4052),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1067),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1068] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4053),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1068),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1069] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3232),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1069),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1070] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3233),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1070),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1071] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3234),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1071),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1072] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3235),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1072),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1073] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3238),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1073),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1074] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3239),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1074),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1075] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3240),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1075),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1076] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3241),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1076),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1077] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3242),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1077),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1078] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3243),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1078),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1079] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4008),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1079),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1080] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3230),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1080),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1081] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4119),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1081),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1082] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4028),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1082),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1083] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4270),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1083),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1084] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4253),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1084),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1085] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4016),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1085),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1086] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4170),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1086),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1087] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3999),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1087),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1088] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4201),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1088),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1089] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3220),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1089),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1090] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3401),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1090),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1091] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2814),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1091),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1092] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3857),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1092),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1093] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3864),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1093),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1094] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4287),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1094),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1095] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1095),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1096] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4286),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1096),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1097] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1097),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1098] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3762),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1098),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1099] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3768),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1099),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1100] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3771),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1100),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1101] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3792),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1101),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1102] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3815),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1102),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1103] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3818),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1103),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1104] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3825),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1104),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1105] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3827),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1105),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1106] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3831),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1106),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1107] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3761),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1107),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1108] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3889),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1108),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1109] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3871),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1109),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1110] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3651),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1110),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1111] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2846),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1111),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1112] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3748),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1112),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1113] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3754),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1113),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1114] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1114),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1115] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3817),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1115),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1116] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4342),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1116),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1117] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3811),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1117),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1118] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4202),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1118),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1119] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4195),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1119),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1120] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4196),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1120),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1121] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1121),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1122] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4179),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1122),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1123] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4180),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1123),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1124] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4181),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1124),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1125] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4182),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1125),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1126] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4184),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1126),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1127] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4185),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1127),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1128] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4204),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1128),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1129] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4187),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1129),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1130] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4188),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1130),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1131] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4189),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1131),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1132] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4190),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1132),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1133] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4191),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1133),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1134] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4208),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1134),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1135] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3924),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1135),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1136] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3564),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1136),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1137] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1137),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1138] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3749),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1138),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1139] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3750),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1139),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1140] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1140),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1141] = {
    [sym_heredoc_body] = STATE(1141),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1142] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3679),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1142),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1143] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3680),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1143),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1144] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3684),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1144),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1145] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3685),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1145),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1146] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3686),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1146),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1147] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3687),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1147),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1148] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3755),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1148),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1149] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3688),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1149),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1150] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3705),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1150),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1151] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3707),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1151),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1152] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3708),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1152),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1153] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3727),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1153),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1154] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3641),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1154),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1155] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4261),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1155),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1156] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3683),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1156),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1157] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3918),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1157),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1158] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3959),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1158),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1159] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3960),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1159),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1160] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1160),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1161] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3919),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1161),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1162] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3921),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1162),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1163] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3929),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1163),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1164] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3894),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1164),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1165] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3917),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1165),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1166] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3931),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1166),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1167] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3893),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1167),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1168] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3896),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1168),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1169] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3927),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1169),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1170] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3928),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1170),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1171] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3911),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1171),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1172] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3895),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1172),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1173] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3915),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1173),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1174] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4155),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1174),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1175] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3731),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1175),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1176] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3732),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1176),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1177] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3733),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1177),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1178] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3734),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1178),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1179] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3328),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1179),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1180] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2992),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1180),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1181] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2953),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1181),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1182] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2992),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1182),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1183] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3507),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1183),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1184] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3510),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1184),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1185] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1185),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1186] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3735),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1186),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1187] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3736),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1187),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1188] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3737),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1188),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1189] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3508),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1189),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1190] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3511),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1190),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1191] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3512),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1191),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1192] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3481),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1192),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1193] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3519),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1193),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1194] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3520),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1194),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1195] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3523),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1195),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1196] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3524),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1196),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1197] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3525),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1197),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1198] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3527),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1198),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1199] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3738),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1199),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1200] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3739),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1200),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1201] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3528),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1201),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1202] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3740),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1202),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1203] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4173),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1203),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1204] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4064),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1204),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1205] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3746),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1205),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1206] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3502),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1206),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1207] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3623),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1207),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1208] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3222),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1208),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1209] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3652),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1209),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1210] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4287),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1210),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1211] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4297),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1211),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1212] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4123),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1212),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1213] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3689),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1213),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1214] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3857),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1214),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1215] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3822),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1215),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1216] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3826),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1216),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1217] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1217),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1218] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4291),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1218),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1219] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4292),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1219),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1220] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4293),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1220),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1221] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4296),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1221),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1222] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4302),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1222),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1223] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4307),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1223),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1224] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4308),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1224),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1225] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4309),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1225),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1226] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4310),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1226),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1227] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4311),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1227),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1228] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4312),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1228),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1229] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4314),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1229),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1230] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2721),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1230),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1231] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4318),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1231),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1232] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4070),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1232),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1233] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3649),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1233),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1234] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3637),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1234),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1235] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3638),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1235),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1236] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1236),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1237] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3612),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1237),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1238] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3613),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1238),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1239] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3614),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1239),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1240] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3615),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1240),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1241] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3617),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1241),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1242] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3619),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1242),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1243] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3630),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1243),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1244] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3631),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1244),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1245] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3632),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1245),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1246] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3633),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1246),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1247] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3634),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1247),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1248] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3642),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1248),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1249] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4139),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1249),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1250] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3367),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1250),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1251] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3357),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1251),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1252] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3363),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1252),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1253] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1253),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1254] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3250),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1254),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1255] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3251),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1255),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1256] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3252),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1256),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1257] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3253),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1257),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1258] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3254),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1258),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1259] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3255),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1259),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1260] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3256),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1260),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1261] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3257),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1261),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1262] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3258),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1262),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1263] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3259),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1263),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1264] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3260),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1264),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1265] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3247),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1265),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1266] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3308),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1266),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1267] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1267),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1268] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3821),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1268),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1269] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3842),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1269),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1270] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1270),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1271] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3778),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1271),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1272] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3779),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1272),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1273] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3780),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1273),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1274] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3785),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1274),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1275] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1275),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1276] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3788),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1276),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1277] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3793),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1277),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1278] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3800),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1278),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1279] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3801),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1279),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1280] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3805),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1280),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1281] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3812),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1281),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1282] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3875),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1282),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1283] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3777),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1283),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1284] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4142),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1284),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1285] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4147),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1285),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1286] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4005),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1286),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1287] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2774),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1287),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1288] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2892),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1288),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1289] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2947),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1289),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1290] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2948),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1290),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1291] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1291),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1292] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4153),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1292),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1293] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1293),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1294] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3009),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1294),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1295] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2961),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1295),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1296] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2971),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1296),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1297] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3028),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1297),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1298] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3032),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1298),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1299] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3036),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1299),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1300] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3039),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1300),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1301] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3040),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1301),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1302] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3041),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1302),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1303] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3042),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1303),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1304] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3046),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1304),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1305] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3946),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1305),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1306] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4156),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1306),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1307] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4157),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1307),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1308] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4158),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1308),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1309] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4159),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1309),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1310] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4160),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1310),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1311] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4161),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1311),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1312] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4162),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1312),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1313] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2997),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1313),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1314] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3184),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1314),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1315] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3506),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5929),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2205),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1315),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_defined_QMARK] = ACTIONS(2106),
    [anon_sym_not] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2112),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2114),
    [sym__unary_minus_num] = ACTIONS(2116),
    [sym__binary_minus] = ACTIONS(2114),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1316] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4164),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1316),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1317] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4165),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1317),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1318] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3651),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1318),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1319] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3677),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5714),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1319),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1932),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_defined_QMARK] = ACTIONS(1858),
    [anon_sym_not] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1866),
    [sym__unary_minus_num] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(1866),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1320] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4227),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1320),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1321] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4228),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1321),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1322] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4229),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1322),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1323] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1323),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1324] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4240),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1324),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1325] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4219),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1325),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1326] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4216),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1326),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1327] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4244),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1327),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1328] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4166),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1328),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1329] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4257),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1329),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1330] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4220),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1330),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1331] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4237),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1331),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1332] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4246),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1332),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1333] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4255),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1333),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1334] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4263),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1334),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1335] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4226),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1335),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1336] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4167),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1336),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1337] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4222),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1337),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1338] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3427),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1338),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1339] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3579),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1339),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1340] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3584),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1340),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1341] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3585),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1341),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1342] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1342),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1343] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3566),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1343),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1344] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3567),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1344),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1345] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3568),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1345),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1346] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3569),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1346),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1347] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3570),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1347),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1348] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3571),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1348),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1349] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3602),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1349),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1350] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3573),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1350),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1351] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3574),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1351),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1352] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3575),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1352),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1353] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3577),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1353),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1354] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3588),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1354),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1355] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3533),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1355),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1356] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3701),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1356),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1357] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3620),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1357),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1358] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3622),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1358),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1359] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1359),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1360] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3663),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1360),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1361] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3664),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1361),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1362] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3665),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1362),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1363] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3668),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1363),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1364] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3670),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1364),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1365] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3694),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1365),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1366] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3696),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1366),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1367] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3697),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1367),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1368] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3698),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1368),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1369] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3699),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1369),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1370] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3743),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1370),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1371] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3635),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1371),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1372] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3659),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1372),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1373] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3909),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1373),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1374] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2674),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1374),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1375] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2765),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1375),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1376] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2898),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1376),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1377] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2855),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1377),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1378] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1378),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1379] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4145),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1379),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1380] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2747),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1380),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1381] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2748),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1381),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1382] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2749),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1382),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1383] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2750),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1383),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1384] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2751),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1384),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1385] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2752),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1385),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1386] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2753),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1386),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1387] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2754),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1387),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1388] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2755),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1388),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1389] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2756),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1389),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1390] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4172),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1390),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1391] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2757),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1391),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1392] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2771),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1392),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1393] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2801),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1393),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1394] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2998),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2171),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1394),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1559),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1557),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1557),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1395] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4076),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1395),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1396] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4077),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5833),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2516),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1396),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2200),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_defined_QMARK] = ACTIONS(2206),
    [anon_sym_not] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2214),
    [sym__unary_minus_num] = ACTIONS(2216),
    [sym__binary_minus] = ACTIONS(2214),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1397] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3865),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1397),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1398] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1398),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1399] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3782),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1399),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1400] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1400),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1401] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3873),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1401),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1402] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3767),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1402),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1403] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3774),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1403),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1404] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3775),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1404),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1405] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3797),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1405),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1406] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3804),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1406),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1407] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3784),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1407),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1408] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3816),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1408),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1409] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3820),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1409),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1410] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3824),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1410),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1411] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3829),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1411),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1412] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3839),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1412),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1413] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3881),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5944),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2444),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1413),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_defined_QMARK] = ACTIONS(1756),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1760),
    [anon_sym_TILDE] = ACTIONS(1760),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1414] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3789),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1414),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1415] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3819),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5787),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2451),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1415),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2010),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_defined_QMARK] = ACTIONS(1734),
    [anon_sym_not] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1738),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1748),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1748),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1416] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3513),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1416),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1417] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3536),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1417),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1418] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3537),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1418),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1419] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1419),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1420] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3517),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1420),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1421] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3482),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1421),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1422] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3483),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1422),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1423] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3485),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1423),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1424] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3489),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1424),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1425] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3490),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1425),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1426] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3491),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1426),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1427] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3496),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1427),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1428] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3503),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1428),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1429] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3534),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1429),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1430] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3538),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1430),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1431] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3545),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1431),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1432] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3645),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1432),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1433] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3289),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1433),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1434] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3372),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1434),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1435] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3373),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1435),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1436] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1436),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1437] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3294),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1437),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1438] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3295),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1438),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1439] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3296),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1439),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1440] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3297),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1440),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1441] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3298),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1441),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1442] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3299),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1442),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1443] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3245),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1443),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1444] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3301),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1444),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1445] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3302),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1445),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1446] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3303),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1446),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1447] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3304),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1447),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1448] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3376),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1448),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1449] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3262),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1449),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1450] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2892),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1450),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1451] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3997),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1451),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1452] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2670),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1452),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1453] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2766),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1453),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1454] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2767),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1454),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1455] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1455),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1456] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2684),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1456),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1457] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2686),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1457),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1458] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2687),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1458),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1459] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2688),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1459),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1460] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2689),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1460),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1461] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2690),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1461),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1462] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2691),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1462),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1463] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2692),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1463),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1464] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2693),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1464),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1465] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1465),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1466] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2696),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1466),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1467] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2680),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1467),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1468] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2720),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1468),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1469] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2656),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1469),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1470] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1470),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1471] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3712),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2491),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1471),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1972),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_defined_QMARK] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1984),
    [sym__unary_minus_num] = ACTIONS(1986),
    [sym__binary_minus] = ACTIONS(1984),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1472] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3382),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1472),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1473] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3411),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1473),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1474] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1474),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1475] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3385),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1475),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1476] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3386),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1476),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1477] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3398),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1477),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1478] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3399),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1478),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1479] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3400),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1479),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1480] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3402),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1480),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1481] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3403),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1481),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1482] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3404),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1482),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1483] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3405),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1483),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1484] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3406),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1484),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1485] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3407),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1485),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1486] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3414),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1486),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1487] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4319),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1487),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1488] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3880),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1488),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1489] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3883),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1489),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1490] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3886),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1490),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1491] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1491),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1492] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3795),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1492),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1493] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3798),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1493),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1494] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3803),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1494),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1495] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3806),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1495),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1496] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3807),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1496),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1497] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3828),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1497),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1498] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3834),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1498),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1499] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3835),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1499),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1500] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3837),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1500),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1501] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3846),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1501),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1502] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3848),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1502),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1503] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3878),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1503),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1504] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3776),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1504),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1505] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4202),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1505),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1506] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3971),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5668),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2477),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1506),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2066),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1898),
    [anon_sym_defined_QMARK] = ACTIONS(1900),
    [anon_sym_not] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_TILDE] = ACTIONS(1904),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1906),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1906),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1507] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2802),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1507),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1508] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2683),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1508),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1509] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2695),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1509),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1510] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1510),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1511] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2879),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1511),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1512] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2880),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1512),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1513] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2881),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1513),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1514] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2882),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1514),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1515] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2883),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1515),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1516] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2890),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1516),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1517] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2897),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1517),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1518] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2863),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1518),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1519] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2864),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1520] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2865),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1520),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1521] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2876),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1522] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3292),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1522),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1523] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2872),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1523),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1524] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2772),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1524),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1525] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3367),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1525),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1526] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3368),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5824),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2302),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1526),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_defined_QMARK] = ACTIONS(1409),
    [anon_sym_not] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1423),
    [sym__unary_minus_num] = ACTIONS(1425),
    [sym__binary_minus] = ACTIONS(1423),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1527] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3470),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1527),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1528] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3479),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1528),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1529] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3380),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1529),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1530] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1530),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1531] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3387),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1531),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1532] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3388),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1532),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1533] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3389),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1533),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1534] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3390),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1534),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1535] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3391),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1535),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1536] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3392),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1536),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1537] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3393),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1537),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1538] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3394),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1538),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1539] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3395),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1539),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1540] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3396),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1540),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1541] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3397),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1541),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1542] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3409),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1542),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1543] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1543),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1544] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3310),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1544),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1545] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3330),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1545),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1546] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3331),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1546),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1547] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1547),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1548] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3313),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1548),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1549] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3314),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1549),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1550] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3315),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1550),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1551] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3316),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1551),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1552] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3378),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1552),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1553] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3318),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1553),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1554] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3319),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1554),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1555] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3320),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1555),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1556] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1556),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1557] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3322),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1557),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1558] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3323),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1558),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1559] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3334),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1559),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1560] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3312),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1560),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1561] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2646),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1561),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1562] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2862),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2183),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1562),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_defined_QMARK] = ACTIONS(1457),
    [anon_sym_not] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1465),
    [sym__unary_minus_num] = ACTIONS(1467),
    [sym__binary_minus] = ACTIONS(1465),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1563] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3153),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1563),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1564] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2644),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1564),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1565] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2649),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1565),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1566] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1566),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1567] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2630),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1567),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1568] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2631),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1568),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1569] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2632),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1569),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1570] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2633),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1570),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1571] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2634),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1571),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1572] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2635),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1572),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1573] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2636),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1573),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1574] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2637),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1574),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1575] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2638),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1575),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1576] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2639),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1576),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1577] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2643),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1577),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1578] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2650),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1578),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1579] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2673),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1579),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1580] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3701),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1580),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1581] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3702),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5827),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2356),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1581),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1938),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_defined_QMARK] = ACTIONS(1874),
    [anon_sym_not] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(329),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1582] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4049),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1582),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1583] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4009),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1583),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1584] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4010),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1584),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1585] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1585),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1586] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4002),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1586),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1587] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4004),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1587),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1588] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4014),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1588),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1589] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4017),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1589),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1590] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4020),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1591] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4021),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1591),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1592] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4022),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1592),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1593] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4025),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1593),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1594] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4032),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1594),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1595] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4038),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1595),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1596] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4041),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1596),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1597] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3991),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1597),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1598] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4050),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1598),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1599] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3649),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1599),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1600] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4176),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5821),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2531),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1600),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_defined_QMARK] = ACTIONS(2252),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2260),
    [sym__unary_minus_num] = ACTIONS(2262),
    [sym__binary_minus] = ACTIONS(2260),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1601] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2739),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1601),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1602] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2784),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1602),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1603] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2786),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1603),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1604] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1604),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1605] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2803),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1605),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1606] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2804),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1606),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1607] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2805),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1607),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1608] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2806),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1608),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1609] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2807),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1609),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1610] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2808),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1610),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1611] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2809),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1611),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1612] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2810),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1612),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1613] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2811),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1613),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1614] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2812),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1614),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1615] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2813),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1615),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1616] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2792),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1616),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1617] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2797),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1617),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1618] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4142),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1618),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1619] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4144),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5955),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2574),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1619),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_defined_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2278),
    [sym__unary_minus_num] = ACTIONS(2280),
    [sym__binary_minus] = ACTIONS(2278),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1620] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3957),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(2996),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1620),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1621] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3901),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1621),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1622] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3902),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1622),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1623] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3068),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1623),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1624] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3969),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1624),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1625] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3973),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1625),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1626] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3976),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1626),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1627] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3978),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1627),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1628] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3979),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1628),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1629] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3980),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1629),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1630] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3981),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1630),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1631] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3984),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1631),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1632] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3985),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1632),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1633] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3986),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1633),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1634] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3989),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1634),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1635] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3905),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1635),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1636] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4224),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1636),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1637] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2802),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1637),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1638] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2628),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1638),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1639] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3119),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1639),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1640] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3143),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1640),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1641] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1641),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1642] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3159),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1642),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1643] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3160),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1643),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1644] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3161),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1644),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1645] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3163),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1645),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1646] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3164),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1646),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1647] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3174),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1647),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1648] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3178),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1648),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1649] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3181),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1649),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1650] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3107),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1650),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1651] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3111),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1651),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1652] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3112),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1652),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1653] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3151),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1653),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1654] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3130),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1654),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1655] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4232),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1655),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1656] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4233),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5810),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2573),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1656),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2352),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_defined_QMARK] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2364),
    [sym__unary_minus_num] = ACTIONS(2366),
    [sym__binary_minus] = ACTIONS(2364),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1657] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3944),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1657),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1658] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3153),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1658),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1659] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3607),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5867),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2279),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1659),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1964),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1828),
    [sym__unary_minus_num] = ACTIONS(367),
    [sym__binary_minus] = ACTIONS(1828),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1660] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2704),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1660),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1661] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2736),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1661),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1662] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1662),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1663] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2703),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1663),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1664] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2705),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1664),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1665] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2712),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1665),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1666] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2716),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1666),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1667] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2702),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1667),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1668] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2737),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1668),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1669] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2742),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1669),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1670] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2719),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1670),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1671] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2735),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1671),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1672] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2731),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1672),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1673] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2734),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1673),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1674] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2730),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1674),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1675] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2727),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1675),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1676] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3289),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1676),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1677] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3290),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5809),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2388),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1677),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1499),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_defined_QMARK] = ACTIONS(1503),
    [anon_sym_not] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1511),
    [sym__unary_minus_num] = ACTIONS(1513),
    [sym__binary_minus] = ACTIONS(1511),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1678] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2739),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1678),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1679] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2796),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5843),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2184),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1679),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1359),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_defined_QMARK] = ACTIONS(1363),
    [anon_sym_not] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1371),
    [sym__unary_minus_num] = ACTIONS(1373),
    [sym__binary_minus] = ACTIONS(1371),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1680] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2555),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1680),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1681] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2556),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1681),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1682] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1682),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1683] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2581),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1683),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1684] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2582),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1684),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1685] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2583),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1685),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1686] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2584),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1686),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1687] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2585),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1687),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1688] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2586),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1688),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1689] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2587),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1689),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1690] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2588),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1690),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1691] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2589),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1691),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1692] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2590),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1692),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1693] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2591),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1693),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1694] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2559),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1694),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1695] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2575),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1695),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1696] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3918),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1696),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1697] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3922),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5963),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2625),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1697),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2126),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_defined_QMARK] = ACTIONS(2130),
    [anon_sym_not] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2138),
    [sym__unary_minus_num] = ACTIONS(2140),
    [sym__binary_minus] = ACTIONS(2138),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1698] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3272),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1698),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1699] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2580),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1699),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1700] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3115),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5850),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2215),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1700),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_defined_QMARK] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1642),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1648),
    [sym__unary_minus_num] = ACTIONS(1650),
    [sym__binary_minus] = ACTIONS(1648),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1701] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2508),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1701),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1702] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2509),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1702),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1703] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1703),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1704] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2498),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1704),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1705] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2499),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1705),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1706] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2500),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1706),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1707] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2501),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1707),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1708] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2502),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1708),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1709] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2503),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1709),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1710] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2504),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1710),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1711] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2505),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1711),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1712] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2523),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1712),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1713] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2507),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1713),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1714] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2490),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1714),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1715] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2513),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1715),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1716] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2520),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1716),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1717] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4227),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1717),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1718] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4231),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5852),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2653),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1718),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_defined_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2322),
    [sym__unary_minus_num] = ACTIONS(2324),
    [sym__binary_minus] = ACTIONS(2322),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1719] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2497),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1719),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1720] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2725),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5857),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2170),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1720),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_defined_QMARK] = ACTIONS(1313),
    [anon_sym_not] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1321),
    [sym__unary_minus_num] = ACTIONS(1323),
    [sym__binary_minus] = ACTIONS(1321),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1721] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3518),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1721),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1722] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3279),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2185),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1722),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_defined_QMARK] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1723] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3865),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1723),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1724] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3809),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5888),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2529),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1724),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2074),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_defined_QMARK] = ACTIONS(2078),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2086),
    [sym__unary_minus_num] = ACTIONS(2088),
    [sym__binary_minus] = ACTIONS(2086),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1725] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3579),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1725),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1726] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2568),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1726),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1727] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3382),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1727),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1728] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3383),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1728),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1729] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3513),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1729),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1730] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2519),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1730),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1731] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3470),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1731),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1732] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3306),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2208),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5703),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2877),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2460),
    [sym__variable] = STATE(2210),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1732),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1571),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_defined_QMARK] = ACTIONS(1577),
    [anon_sym_not] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(1587),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1733] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3880),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1733),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1734] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3580),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5870),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2484),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1734),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_defined_QMARK] = ACTIONS(1838),
    [anon_sym_not] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1846),
    [sym__unary_minus_num] = ACTIONS(1848),
    [sym__binary_minus] = ACTIONS(1846),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1735] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4049),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1735),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1736] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4027),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5782),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2652),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1736),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2166),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_defined_QMARK] = ACTIONS(2170),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2178),
    [sym__unary_minus_num] = ACTIONS(2180),
    [sym__binary_minus] = ACTIONS(2178),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1737] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3310),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1737),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1738] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3530),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5872),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2485),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1738),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1591),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_defined_QMARK] = ACTIONS(1595),
    [anon_sym_not] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1603),
    [sym__unary_minus_num] = ACTIONS(1605),
    [sym__binary_minus] = ACTIONS(1603),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1739] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1739),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1740] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3841),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2605),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1740),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2038),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_defined_QMARK] = ACTIONS(2042),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2048),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2056),
    [sym__unary_minus_num] = ACTIONS(2058),
    [sym__binary_minus] = ACTIONS(2056),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1741] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3885),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5874),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2535),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1741),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(2014),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2018),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_defined_QMARK] = ACTIONS(2022),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_TILDE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2030),
    [sym__unary_minus_num] = ACTIONS(2032),
    [sym__binary_minus] = ACTIONS(2030),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1742] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3957),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1742),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1743] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3930),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5819),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2660),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1743),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_defined_QMARK] = ACTIONS(2150),
    [anon_sym_not] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2158),
    [sym__unary_minus_num] = ACTIONS(2160),
    [sym__binary_minus] = ACTIONS(2158),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1744] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3311),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5877),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2292),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1744),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_defined_QMARK] = ACTIONS(1521),
    [anon_sym_not] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1529),
    [sym__unary_minus_num] = ACTIONS(1531),
    [sym__binary_minus] = ACTIONS(1529),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1745] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2794),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1745),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1746] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2833),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1746),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1747] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2794),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1747),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1748] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4317),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1748),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1749] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2765),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5790),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1749),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1093),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_defined_QMARK] = ACTIONS(1293),
    [anon_sym_not] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1097),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1097),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1750] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2670),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2117),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1750),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1075),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_defined_QMARK] = ACTIONS(1279),
    [anon_sym_not] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1079),
    [sym__unary_minus_num] = ACTIONS(167),
    [sym__binary_minus] = ACTIONS(1079),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1751] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2646),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1751),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1049),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_defined_QMARK] = ACTIONS(1053),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1061),
    [sym__unary_minus_num] = ACTIONS(1063),
    [sym__binary_minus] = ACTIONS(1061),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1752] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2580),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5860),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2138),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1752),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(959),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_defined_QMARK] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(969),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(971),
    [sym__unary_minus_num] = ACTIONS(973),
    [sym__binary_minus] = ACTIONS(971),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1753] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2497),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(2399),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5862),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2114),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1753),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(923),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_defined_QMARK] = ACTIONS(927),
    [anon_sym_not] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(941),
    [sym__unary_minus_num] = ACTIONS(943),
    [sym__binary_minus] = ACTIONS(941),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1754] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4354),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1754),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1755] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4268),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1755),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1756] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4326),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1756),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1757] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4345),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1757),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1758] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4313),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1758),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1759] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4340),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1759),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1760] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4347),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1760),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1761] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4365),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1761),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1762] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4357),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1762),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1763] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4275),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1763),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1764] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4346),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1764),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1765] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4273),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1765),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1766] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4283),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1766),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1767] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4288),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1767),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1768] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4290),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1768),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1769] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4295),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1769),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1770] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4299),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1770),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1771] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4301),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1771),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1772] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4315),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1772),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1773] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4316),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1773),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1774] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4320),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1774),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1775] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4321),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1775),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1776] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4322),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1776),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1777] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4328),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1777),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1778] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4329),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1778),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1779] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4332),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1779),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1780] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4333),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1780),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1781] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4214),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1781),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1782] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4348),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1782),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1783] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3591),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1783),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1784] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4109),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1784),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1785] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4102),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1785),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1786] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4103),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1786),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1787] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1787),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1788] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4091),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1788),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1789] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4092),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1789),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1790] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4093),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1790),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1791] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4094),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1791),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1792] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4127),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1792),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1793] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4096),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1793),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1794] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4097),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1794),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1795] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4098),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1795),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1796] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4099),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1796),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1797] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4100),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1797),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1798] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4101),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1798),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1799] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4106),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1799),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1800] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3438),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1800),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1801] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4107),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1801),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1802] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3467),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1802),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1803] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3444),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1803),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1804] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3445),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1804),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1805] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3446),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1805),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1806] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3447),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1806),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1807] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3448),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1807),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1808] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3449),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1808),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1809] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3450),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1809),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1810] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3451),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1810),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1811] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3452),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1811),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1812] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3453),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1812),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1813] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3454),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1813),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1814] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3435),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1814),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1815] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3597),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1815),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1816] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3480),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1816),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1817] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3431),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1817),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1818] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1818),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1819] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3713),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1819),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1820] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3671),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1820),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1821] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3672),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1821),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1822] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1822),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1823] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3716),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1823),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1824] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3717),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1824),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1825] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3718),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1825),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1826] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3719),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1826),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1827] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3720),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1827),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1828] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3721),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1828),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1829] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3722),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1829),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1830] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3723),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1830),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1831] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3724),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1831),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1832] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3725),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1832),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1833] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3726),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1833),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1834] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3760),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1834),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1835] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3715),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1835),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1836] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3436),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1836),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1837] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4109),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1837),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1838] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1838),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1839] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4114),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5854),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2524),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1839),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2230),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_defined_QMARK] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2242),
    [sym__unary_minus_num] = ACTIONS(2244),
    [sym__binary_minus] = ACTIONS(2242),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1840] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3052),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1840),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1841] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3053),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1841),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1842] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2437),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1842),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1843] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3076),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1843),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1844] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3077),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1844),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1845] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3078),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1845),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1846] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3079),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1846),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1847] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3080),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1847),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1848] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3081),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1848),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1849] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3082),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1849),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1850] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3083),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1850),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1851] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3084),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1851),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1852] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3085),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1852),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1853] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3086),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1853),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1854] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3056),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1854),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1855] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3059),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1855),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1856] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3075),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1856),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1857] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3058),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1857),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1858] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3197),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1858),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1859] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3713),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1859),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1860] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3714),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5855),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2534),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1860),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1958),
    [sym__unary_minus_num] = ACTIONS(1960),
    [sym__binary_minus] = ACTIONS(1958),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1861] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3467),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5847),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1861),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1914),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_defined_QMARK] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1696),
    [sym__unary_minus_num] = ACTIONS(531),
    [sym__binary_minus] = ACTIONS(1696),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1862] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3075),
    [sym__unary_minus_pow] = STATE(2287),
    [sym__primary] = STATE(3023),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2042),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2346),
    [sym_operator_assignment] = STATE(2346),
    [sym_conditional] = STATE(2346),
    [sym_range] = STATE(2346),
    [sym_binary] = STATE(2346),
    [sym_unary] = STATE(2346),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5853),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2193),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2213),
    [sym__variable] = STATE(2045),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1862),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1535),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_defined_QMARK] = ACTIONS(1539),
    [anon_sym_not] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1547),
    [sym__unary_minus_num] = ACTIONS(1549),
    [sym__binary_minus] = ACTIONS(1547),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1863] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4336),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1863),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1864] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4338),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1864),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1865] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(4207),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5737),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2479),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1865),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1830),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_defined_QMARK] = ACTIONS(2188),
    [anon_sym_not] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_TILDE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2196),
    [sym__unary_minus_num] = ACTIONS(2198),
    [sym__binary_minus] = ACTIONS(2196),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1866] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4350),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1866),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1867] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4278),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1867),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1868] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4294),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1868),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1869] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4341),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1869),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1870] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4352),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1870),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1871] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4344),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1871),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1872] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4267),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1872),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1873] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4269),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1873),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1874] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4274),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1874),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1875] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4276),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1875),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1876] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4279),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1876),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1877] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4280),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1877),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1878] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4281),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1878),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1879] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4349),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5966),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2666),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(3497),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1879),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_defined_QMARK] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(2050),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2052),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(2054),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2392),
    [sym__unary_minus_num] = ACTIONS(2394),
    [sym__binary_minus] = ACTIONS(2392),
    [sym__identifier_suffix] = ACTIONS(2060),
    [sym__constant_suffix] = ACTIONS(2050),
  },
  [1880] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4285),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1880),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1881] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2397),
    [sym_left_assignment_list] = STATE(5778),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2179),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1881),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1808),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1620),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_defined_QMARK] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_TILDE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1624),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1624),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1882] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2834),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1882),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1883] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2835),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2398),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1883),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1884] = {
    [sym_method] = STATE(2402),
    [sym_singleton_method] = STATE(2402),
    [sym_class] = STATE(2402),
    [sym_singleton_class] = STATE(2402),
    [sym_module] = STATE(2402),
    [sym_return] = STATE(2402),
    [sym_yield] = STATE(2402),
    [sym_break] = STATE(2402),
    [sym_next] = STATE(2402),
    [sym_redo] = STATE(2402),
    [sym_retry] = STATE(2402),
    [sym_while] = STATE(2402),
    [sym_until] = STATE(2402),
    [sym_for] = STATE(2402),
    [sym_case] = STATE(2402),
    [sym_case_match] = STATE(2402),
    [sym_if] = STATE(2402),
    [sym_unless] = STATE(2402),
    [sym_begin] = STATE(2402),
    [sym__arg] = STATE(2542),
    [sym__unary_minus_pow] = STATE(2540),
    [sym__primary] = STATE(2476),
    [sym_parenthesized_statements] = STATE(2402),
    [sym_element_reference] = STATE(2082),
    [sym_scope_resolution] = STATE(2082),
    [sym__call] = STATE(2044),
    [sym_call] = STATE(2402),
    [sym_assignment] = STATE(2543),
    [sym_operator_assignment] = STATE(2543),
    [sym_conditional] = STATE(2543),
    [sym_range] = STATE(2543),
    [sym_binary] = STATE(2543),
    [sym_unary] = STATE(2543),
    [sym_parenthesized_unary] = STATE(2402),
    [sym_unary_literal] = STATE(2334),
    [sym__literal] = STATE(2402),
    [sym__numeric] = STATE(2293),
    [sym__simple_numeric] = STATE(2334),
    [sym_left_assignment_list] = STATE(5939),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2189),
    [sym__function_identifier_call] = STATE(2330),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(2040),
    [sym__nonlocal_variable] = STATE(2070),
    [sym__int_or_float] = STATE(5501),
    [sym_complex] = STATE(2411),
    [sym_rational] = STATE(2411),
    [sym_nil] = STATE(2082),
    [sym_constant_suffix] = STATE(2268),
    [sym_identifier_suffix] = STATE(2265),
    [sym_chained_string] = STATE(2402),
    [sym_string] = STATE(2204),
    [sym_subshell] = STATE(2402),
    [sym_string_array] = STATE(2402),
    [sym_symbol_array] = STATE(2402),
    [sym_delimited_symbol] = STATE(2293),
    [sym_regex] = STATE(2402),
    [sym_heredoc_body] = STATE(1884),
    [sym_array] = STATE(2402),
    [sym_hash] = STATE(2402),
    [sym_lambda] = STATE(2402),
    [sym_identifier] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_yield] = ACTIONS(917),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_next] = ACTIONS(921),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_defined_QMARK] = ACTIONS(1381),
    [anon_sym_not] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(907),
    [sym_self] = ACTIONS(907),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(907),
    [aux_sym_constant_suffix_token1] = ACTIONS(935),
    [aux_sym_identifier_suffix_token1] = ACTIONS(937),
    [sym_instance_variable] = ACTIONS(939),
    [sym_class_variable] = ACTIONS(939),
    [sym_global_variable] = ACTIONS(939),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(945),
    [sym__constant_suffix] = ACTIONS(935),
  },
  [1885] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4351),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1885),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1886] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4353),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1886),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1887] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4355),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1887),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1888] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4356),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1888),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1889] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4358),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1889),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1890] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4360),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1890),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1891] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4362),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1891),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1892] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4363),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1892),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1893] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4364),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1893),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1894] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4366),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1894),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1895] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4369),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1895),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1896] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4370),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1896),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1897] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4371),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1897),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1898] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4372),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1898),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1899] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4373),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1899),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1900] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4374),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1900),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1901] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4375),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1901),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1902] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4266),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1902),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1903] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4376),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1903),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1904] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(4377),
    [sym__unary_minus_pow] = STATE(3471),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3063),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3473),
    [sym_operator_assignment] = STATE(3473),
    [sym_conditional] = STATE(3473),
    [sym_range] = STATE(3473),
    [sym_binary] = STATE(3473),
    [sym_unary] = STATE(3473),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2539),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1904),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_defined_QMARK] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(2296),
    [sym__unary_minus_num] = ACTIONS(2298),
    [sym__binary_minus] = ACTIONS(2296),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1905] = {
    [sym_method] = STATE(3063),
    [sym_singleton_method] = STATE(3063),
    [sym_class] = STATE(3063),
    [sym_singleton_class] = STATE(3063),
    [sym_module] = STATE(3063),
    [sym_return] = STATE(3063),
    [sym_yield] = STATE(3063),
    [sym_break] = STATE(3063),
    [sym_next] = STATE(3063),
    [sym_redo] = STATE(3063),
    [sym_retry] = STATE(3063),
    [sym_while] = STATE(3063),
    [sym_until] = STATE(3063),
    [sym_for] = STATE(3063),
    [sym_case] = STATE(3063),
    [sym_case_match] = STATE(3063),
    [sym_if] = STATE(3063),
    [sym_unless] = STATE(3063),
    [sym_begin] = STATE(3063),
    [sym__arg] = STATE(3410),
    [sym__unary_minus_pow] = STATE(2993),
    [sym__primary] = STATE(3237),
    [sym_parenthesized_statements] = STATE(3020),
    [sym_element_reference] = STATE(2236),
    [sym_scope_resolution] = STATE(2236),
    [sym__call] = STATE(2172),
    [sym_call] = STATE(3063),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_parenthesized_unary] = STATE(3063),
    [sym_unary_literal] = STATE(3099),
    [sym__literal] = STATE(3063),
    [sym__numeric] = STATE(3062),
    [sym__simple_numeric] = STATE(3099),
    [sym_left_assignment_list] = STATE(5672),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(2729),
    [sym__function_identifier_call] = STATE(3100),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2173),
    [sym__nonlocal_variable] = STATE(2219),
    [sym__int_or_float] = STATE(5523),
    [sym_complex] = STATE(3102),
    [sym_rational] = STATE(3102),
    [sym_nil] = STATE(2236),
    [sym_constant_suffix] = STATE(2887),
    [sym_identifier_suffix] = STATE(2888),
    [sym_chained_string] = STATE(3063),
    [sym_string] = STATE(2818),
    [sym_subshell] = STATE(3063),
    [sym_string_array] = STATE(3063),
    [sym_symbol_array] = STATE(3063),
    [sym_delimited_symbol] = STATE(3062),
    [sym_regex] = STATE(3063),
    [sym_heredoc_body] = STATE(1905),
    [sym_array] = STATE(3063),
    [sym_hash] = STATE(3063),
    [sym_lambda] = STATE(3063),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_COLON_COLON] = ACTIONS(1928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(247),
    [anon_sym_class] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1399),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_next] = ACTIONS(1403),
    [anon_sym_redo] = ACTIONS(261),
    [anon_sym_retry] = ACTIONS(263),
    [anon_sym_if] = ACTIONS(265),
    [anon_sym_unless] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(269),
    [anon_sym_until] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(1481),
    [anon_sym_begin] = ACTIONS(283),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_defined_QMARK] = ACTIONS(1485),
    [anon_sym_not] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1391),
    [sym_self] = ACTIONS(1391),
    [sym_true] = ACTIONS(297),
    [sym_false] = ACTIONS(297),
    [sym_constant] = ACTIONS(1391),
    [aux_sym_constant_suffix_token1] = ACTIONS(1417),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1419),
    [sym_instance_variable] = ACTIONS(1421),
    [sym_class_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_character] = ACTIONS(305),
    [anon_sym_DASH_GT] = ACTIONS(307),
    [sym_simple_symbol] = ACTIONS(309),
    [sym__string_start] = ACTIONS(311),
    [sym__symbol_start] = ACTIONS(313),
    [sym__subshell_start] = ACTIONS(315),
    [sym__regex_start] = ACTIONS(317),
    [sym__string_array_start] = ACTIONS(319),
    [sym__symbol_array_start] = ACTIONS(321),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(305),
    [sym__unary_minus] = ACTIONS(1493),
    [sym__unary_minus_num] = ACTIONS(1495),
    [sym__binary_minus] = ACTIONS(1493),
    [sym__identifier_suffix] = ACTIONS(1427),
    [sym__constant_suffix] = ACTIONS(1417),
  },
  [1906] = {
    [sym_heredoc_body] = STATE(1906),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2622),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_unless] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_until] = ACTIONS(2622),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_when] = ACTIONS(2622),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_elsif] = ACTIONS(2622),
    [anon_sym_else] = ACTIONS(2622),
    [anon_sym_then] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_ensure] = ACTIONS(2622),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2620),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1907] = {
    [sym_heredoc_body] = STATE(1907),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_when] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_elsif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_ensure] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_PLUS_EQ] = ACTIONS(2626),
    [anon_sym_DASH_EQ] = ACTIONS(2626),
    [anon_sym_STAR_EQ] = ACTIONS(2626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2626),
    [anon_sym_SLASH_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2626),
    [anon_sym_AMP_EQ] = ACTIONS(2626),
    [anon_sym_PERCENT_EQ] = ACTIONS(2626),
    [anon_sym_GT_GT_EQ] = ACTIONS(2626),
    [anon_sym_LT_LT_EQ] = ACTIONS(2626),
    [anon_sym_CARET_EQ] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1908] = {
    [sym_heredoc_body] = STATE(1908),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_when] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_elsif] = ACTIONS(2616),
    [anon_sym_else] = ACTIONS(2616),
    [anon_sym_then] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_ensure] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_PLUS_EQ] = ACTIONS(2618),
    [anon_sym_DASH_EQ] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(2618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2618),
    [anon_sym_SLASH_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2618),
    [anon_sym_AMP_EQ] = ACTIONS(2618),
    [anon_sym_PERCENT_EQ] = ACTIONS(2618),
    [anon_sym_GT_GT_EQ] = ACTIONS(2618),
    [anon_sym_LT_LT_EQ] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_SLASH] = ACTIONS(2616),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1909] = {
    [sym_heredoc_body] = STATE(1909),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1910] = {
    [sym_heredoc_body] = STATE(1910),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2622),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_unless] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_until] = ACTIONS(2622),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2622),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_when] = ACTIONS(2622),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_elsif] = ACTIONS(2622),
    [anon_sym_else] = ACTIONS(2622),
    [anon_sym_then] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_ensure] = ACTIONS(2622),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2620),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1911] = {
    [sym_heredoc_body] = STATE(1911),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2628),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_when] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_elsif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_ensure] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_PLUS_EQ] = ACTIONS(2630),
    [anon_sym_DASH_EQ] = ACTIONS(2630),
    [anon_sym_STAR_EQ] = ACTIONS(2630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2630),
    [anon_sym_SLASH_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2630),
    [anon_sym_AMP_EQ] = ACTIONS(2630),
    [anon_sym_PERCENT_EQ] = ACTIONS(2630),
    [anon_sym_GT_GT_EQ] = ACTIONS(2630),
    [anon_sym_LT_LT_EQ] = ACTIONS(2630),
    [anon_sym_CARET_EQ] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1912] = {
    [sym_heredoc_body] = STATE(1912),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_elsif] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_then] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_ensure] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_PLUS_EQ] = ACTIONS(2634),
    [anon_sym_DASH_EQ] = ACTIONS(2634),
    [anon_sym_STAR_EQ] = ACTIONS(2634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2634),
    [anon_sym_SLASH_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2634),
    [anon_sym_AMP_EQ] = ACTIONS(2634),
    [anon_sym_PERCENT_EQ] = ACTIONS(2634),
    [anon_sym_GT_GT_EQ] = ACTIONS(2634),
    [anon_sym_LT_LT_EQ] = ACTIONS(2634),
    [anon_sym_CARET_EQ] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1913] = {
    [sym_heredoc_body] = STATE(1913),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_def] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2638),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2636),
    [anon_sym_end] = ACTIONS(2636),
    [anon_sym_rescue] = ACTIONS(2636),
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_nil] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_LT] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_next] = ACTIONS(2636),
    [anon_sym_redo] = ACTIONS(2636),
    [anon_sym_retry] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_unless] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_until] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_when] = ACTIONS(2636),
    [anon_sym_EQ_GT] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_DOT_DOT] = ACTIONS(2636),
    [anon_sym_CARET] = ACTIONS(2636),
    [anon_sym_elsif] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2636),
    [anon_sym_then] = ACTIONS(2636),
    [anon_sym_begin] = ACTIONS(2636),
    [anon_sym_ensure] = ACTIONS(2636),
    [anon_sym_COLON_COLON2] = ACTIONS(2638),
    [anon_sym_AMP_DOT] = ACTIONS(2638),
    [anon_sym_PLUS_EQ] = ACTIONS(2638),
    [anon_sym_DASH_EQ] = ACTIONS(2638),
    [anon_sym_STAR_EQ] = ACTIONS(2638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2638),
    [anon_sym_SLASH_EQ] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2638),
    [anon_sym_PIPE_EQ] = ACTIONS(2638),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2638),
    [anon_sym_AMP_EQ] = ACTIONS(2638),
    [anon_sym_PERCENT_EQ] = ACTIONS(2638),
    [anon_sym_GT_GT_EQ] = ACTIONS(2638),
    [anon_sym_LT_LT_EQ] = ACTIONS(2638),
    [anon_sym_CARET_EQ] = ACTIONS(2638),
    [anon_sym_QMARK] = ACTIONS(2636),
    [anon_sym_and] = ACTIONS(2636),
    [anon_sym_or] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2636),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_EQ] = ACTIONS(2636),
    [anon_sym_GT] = ACTIONS(2636),
    [anon_sym_GT_EQ] = ACTIONS(2638),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_PERCENT] = ACTIONS(2636),
    [anon_sym_EQ_EQ] = ACTIONS(2636),
    [anon_sym_BANG_EQ] = ACTIONS(2638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT_EQ_GT] = ACTIONS(2638),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_BANG_TILDE] = ACTIONS(2638),
    [anon_sym_defined_QMARK] = ACTIONS(2638),
    [anon_sym_not] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2638),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2636),
    [sym_float] = ACTIONS(2636),
    [sym_super] = ACTIONS(2636),
    [sym_self] = ACTIONS(2636),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [sym_constant] = ACTIONS(2636),
    [aux_sym_constant_suffix_token1] = ACTIONS(2638),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2636),
    [sym_instance_variable] = ACTIONS(2638),
    [sym_class_variable] = ACTIONS(2638),
    [sym_global_variable] = ACTIONS(2638),
    [sym_character] = ACTIONS(2638),
    [anon_sym_DASH_GT] = ACTIONS(2638),
    [sym__line_break] = ACTIONS(2638),
    [sym_simple_symbol] = ACTIONS(2638),
    [sym__string_start] = ACTIONS(2638),
    [sym__symbol_start] = ACTIONS(2638),
    [sym__subshell_start] = ACTIONS(2638),
    [sym__regex_start] = ACTIONS(2638),
    [sym__string_array_start] = ACTIONS(2638),
    [sym__symbol_array_start] = ACTIONS(2638),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2638),
    [sym__block_ampersand] = ACTIONS(2638),
    [sym__splat_star] = ACTIONS(2638),
    [sym__unary_minus] = ACTIONS(2638),
    [sym__unary_minus_num] = ACTIONS(2638),
    [sym__binary_minus] = ACTIONS(2638),
    [sym__binary_star] = ACTIONS(2638),
    [sym_hash_key_symbol] = ACTIONS(2638),
    [sym__identifier_suffix] = ACTIONS(2638),
    [sym__constant_suffix] = ACTIONS(2638),
    [sym__hash_splat_star_star] = ACTIONS(2638),
    [sym__binary_star_star] = ACTIONS(2638),
    [sym__element_reference_bracket] = ACTIONS(2638),
  },
  [1914] = {
    [sym_heredoc_body] = STATE(1914),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_end] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_EQ] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_when] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_elsif] = ACTIONS(2640),
    [anon_sym_else] = ACTIONS(2640),
    [anon_sym_then] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_ensure] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2640),
    [anon_sym_AMP_AMP] = ACTIONS(2640),
    [anon_sym_LT_LT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2640),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym__line_break] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [1915] = {
    [sym_heredoc_body] = STATE(1915),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_end] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2644),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_when] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_elsif] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_ensure] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
    [anon_sym_STAR_EQ] = ACTIONS(2646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2646),
    [anon_sym_AMP_EQ] = ACTIONS(2646),
    [anon_sym_PERCENT_EQ] = ACTIONS(2646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2646),
    [anon_sym_LT_LT_EQ] = ACTIONS(2646),
    [anon_sym_CARET_EQ] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1916] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5007),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1916),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_end] = ACTIONS(2660),
    [anon_sym_rescue] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_when] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_elsif] = ACTIONS(2660),
    [anon_sym_else] = ACTIONS(2660),
    [anon_sym_then] = ACTIONS(2660),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_ensure] = ACTIONS(2660),
    [anon_sym_and] = ACTIONS(2660),
    [anon_sym_or] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym__line_break] = ACTIONS(2652),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1917] = {
    [sym_heredoc_body] = STATE(1917),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1918] = {
    [sym_heredoc_body] = STATE(1918),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1919] = {
    [sym_heredoc_body] = STATE(1919),
    [ts_builtin_sym_end] = ACTIONS(2638),
    [sym_identifier] = ACTIONS(2636),
    [aux_sym_program_token1] = ACTIONS(2638),
    [anon_sym___END__] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_def] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2636),
    [anon_sym_rescue] = ACTIONS(2636),
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_nil] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_LT] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_next] = ACTIONS(2636),
    [anon_sym_redo] = ACTIONS(2636),
    [anon_sym_retry] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_unless] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_until] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_EQ_GT] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_DOT_DOT] = ACTIONS(2636),
    [anon_sym_CARET] = ACTIONS(2636),
    [anon_sym_begin] = ACTIONS(2636),
    [anon_sym_COLON_COLON2] = ACTIONS(2638),
    [anon_sym_AMP_DOT] = ACTIONS(2638),
    [anon_sym_PLUS_EQ] = ACTIONS(2638),
    [anon_sym_DASH_EQ] = ACTIONS(2638),
    [anon_sym_STAR_EQ] = ACTIONS(2638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2638),
    [anon_sym_SLASH_EQ] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2638),
    [anon_sym_PIPE_EQ] = ACTIONS(2638),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2638),
    [anon_sym_AMP_EQ] = ACTIONS(2638),
    [anon_sym_PERCENT_EQ] = ACTIONS(2638),
    [anon_sym_GT_GT_EQ] = ACTIONS(2638),
    [anon_sym_LT_LT_EQ] = ACTIONS(2638),
    [anon_sym_CARET_EQ] = ACTIONS(2638),
    [anon_sym_QMARK] = ACTIONS(2636),
    [anon_sym_and] = ACTIONS(2636),
    [anon_sym_or] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2636),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_EQ] = ACTIONS(2636),
    [anon_sym_GT] = ACTIONS(2636),
    [anon_sym_GT_EQ] = ACTIONS(2638),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_PERCENT] = ACTIONS(2636),
    [anon_sym_EQ_EQ] = ACTIONS(2636),
    [anon_sym_BANG_EQ] = ACTIONS(2638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT_EQ_GT] = ACTIONS(2638),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_BANG_TILDE] = ACTIONS(2638),
    [anon_sym_defined_QMARK] = ACTIONS(2638),
    [anon_sym_not] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2638),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2636),
    [sym_float] = ACTIONS(2636),
    [sym_super] = ACTIONS(2636),
    [sym_self] = ACTIONS(2636),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [sym_constant] = ACTIONS(2636),
    [aux_sym_constant_suffix_token1] = ACTIONS(2638),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2636),
    [sym_instance_variable] = ACTIONS(2638),
    [sym_class_variable] = ACTIONS(2638),
    [sym_global_variable] = ACTIONS(2638),
    [sym_character] = ACTIONS(2638),
    [anon_sym_DASH_GT] = ACTIONS(2638),
    [sym__line_break] = ACTIONS(2638),
    [sym_simple_symbol] = ACTIONS(2638),
    [sym__string_start] = ACTIONS(2638),
    [sym__symbol_start] = ACTIONS(2638),
    [sym__subshell_start] = ACTIONS(2638),
    [sym__regex_start] = ACTIONS(2638),
    [sym__string_array_start] = ACTIONS(2638),
    [sym__symbol_array_start] = ACTIONS(2638),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2638),
    [sym__block_ampersand] = ACTIONS(2638),
    [sym__splat_star] = ACTIONS(2638),
    [sym__unary_minus] = ACTIONS(2638),
    [sym__unary_minus_num] = ACTIONS(2638),
    [sym__binary_minus] = ACTIONS(2638),
    [sym__binary_star] = ACTIONS(2638),
    [sym_hash_key_symbol] = ACTIONS(2638),
    [sym__identifier_suffix] = ACTIONS(2638),
    [sym__constant_suffix] = ACTIONS(2638),
    [sym__hash_splat_star_star] = ACTIONS(2638),
    [sym__binary_star_star] = ACTIONS(2638),
    [sym__element_reference_bracket] = ACTIONS(2638),
  },
  [1920] = {
    [sym_heredoc_body] = STATE(1920),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_PLUS_EQ] = ACTIONS(2626),
    [anon_sym_DASH_EQ] = ACTIONS(2626),
    [anon_sym_STAR_EQ] = ACTIONS(2626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2626),
    [anon_sym_SLASH_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2626),
    [anon_sym_AMP_EQ] = ACTIONS(2626),
    [anon_sym_PERCENT_EQ] = ACTIONS(2626),
    [anon_sym_GT_GT_EQ] = ACTIONS(2626),
    [anon_sym_LT_LT_EQ] = ACTIONS(2626),
    [anon_sym_CARET_EQ] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1921] = {
    [sym_heredoc_body] = STATE(1921),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1922] = {
    [sym_heredoc_body] = STATE(1922),
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_program_token1] = ACTIONS(2618),
    [anon_sym___END__] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_PLUS_EQ] = ACTIONS(2618),
    [anon_sym_DASH_EQ] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(2618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2618),
    [anon_sym_SLASH_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2618),
    [anon_sym_AMP_EQ] = ACTIONS(2618),
    [anon_sym_PERCENT_EQ] = ACTIONS(2618),
    [anon_sym_GT_GT_EQ] = ACTIONS(2618),
    [anon_sym_LT_LT_EQ] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_SLASH] = ACTIONS(2616),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1923] = {
    [sym_heredoc_body] = STATE(1923),
    [ts_builtin_sym_end] = ACTIONS(2620),
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_program_token1] = ACTIONS(2620),
    [anon_sym___END__] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_unless] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_until] = ACTIONS(2622),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2620),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1924] = {
    [sym_heredoc_body] = STATE(1924),
    [ts_builtin_sym_end] = ACTIONS(2620),
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_program_token1] = ACTIONS(2620),
    [anon_sym___END__] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_unless] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_until] = ACTIONS(2622),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2622),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2620),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1925] = {
    [sym_heredoc_body] = STATE(1925),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_program_token1] = ACTIONS(2634),
    [anon_sym___END__] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_PLUS_EQ] = ACTIONS(2634),
    [anon_sym_DASH_EQ] = ACTIONS(2634),
    [anon_sym_STAR_EQ] = ACTIONS(2634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2634),
    [anon_sym_SLASH_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2634),
    [anon_sym_AMP_EQ] = ACTIONS(2634),
    [anon_sym_PERCENT_EQ] = ACTIONS(2634),
    [anon_sym_GT_GT_EQ] = ACTIONS(2634),
    [anon_sym_LT_LT_EQ] = ACTIONS(2634),
    [anon_sym_CARET_EQ] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1926] = {
    [sym_heredoc_body] = STATE(1926),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2644),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
    [anon_sym_STAR_EQ] = ACTIONS(2646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2646),
    [anon_sym_AMP_EQ] = ACTIONS(2646),
    [anon_sym_PERCENT_EQ] = ACTIONS(2646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2646),
    [anon_sym_LT_LT_EQ] = ACTIONS(2646),
    [anon_sym_CARET_EQ] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1927] = {
    [sym_heredoc_body] = STATE(1927),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2628),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_PLUS_EQ] = ACTIONS(2630),
    [anon_sym_DASH_EQ] = ACTIONS(2630),
    [anon_sym_STAR_EQ] = ACTIONS(2630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2630),
    [anon_sym_SLASH_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2630),
    [anon_sym_AMP_EQ] = ACTIONS(2630),
    [anon_sym_PERCENT_EQ] = ACTIONS(2630),
    [anon_sym_GT_GT_EQ] = ACTIONS(2630),
    [anon_sym_LT_LT_EQ] = ACTIONS(2630),
    [anon_sym_CARET_EQ] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1928] = {
    [sym_heredoc_body] = STATE(1928),
    [ts_builtin_sym_end] = ACTIONS(2642),
    [sym_identifier] = ACTIONS(2640),
    [aux_sym_program_token1] = ACTIONS(2642),
    [anon_sym___END__] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_EQ] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2640),
    [anon_sym_AMP_AMP] = ACTIONS(2640),
    [anon_sym_LT_LT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2640),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym__line_break] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [1929] = {
    [sym_heredoc_body] = STATE(1929),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LBRACK2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1930] = {
    [sym_heredoc_body] = STATE(1930),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1931] = {
    [sym_heredoc_body] = STATE(1931),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1932] = {
    [sym_heredoc_body] = STATE(1932),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1933] = {
    [sym_heredoc_body] = STATE(1933),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1934] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5007),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1934),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [ts_builtin_sym_end] = ACTIONS(2652),
    [sym_identifier] = ACTIONS(2648),
    [aux_sym_program_token1] = ACTIONS(2652),
    [anon_sym___END__] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_rescue] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_and] = ACTIONS(2660),
    [anon_sym_or] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym__line_break] = ACTIONS(2652),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1935] = {
    [sym_heredoc_body] = STATE(1935),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1936] = {
    [sym_heredoc_body] = STATE(1936),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_then] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2620),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1937] = {
    [sym_heredoc_body] = STATE(1937),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2622),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_then] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2620),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1938] = {
    [sym_heredoc_body] = STATE(1938),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1939] = {
    [sym_heredoc_body] = STATE(1939),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2750),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1940] = {
    [sym_heredoc_body] = STATE(1940),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1941] = {
    [sym_heredoc_body] = STATE(1941),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2622),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_RBRACK] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1942] = {
    [sym_heredoc_body] = STATE(1942),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1943] = {
    [sym_heredoc_body] = STATE(1943),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LBRACK2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1944] = {
    [sym_heredoc_body] = STATE(1944),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2754),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1945] = {
    [sym_heredoc_body] = STATE(1945),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_RBRACK] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1946] = {
    [sym_heredoc_body] = STATE(1946),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_PLUS_EQ] = ACTIONS(2626),
    [anon_sym_DASH_EQ] = ACTIONS(2626),
    [anon_sym_STAR_EQ] = ACTIONS(2626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2626),
    [anon_sym_SLASH_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2626),
    [anon_sym_AMP_EQ] = ACTIONS(2626),
    [anon_sym_PERCENT_EQ] = ACTIONS(2626),
    [anon_sym_GT_GT_EQ] = ACTIONS(2626),
    [anon_sym_LT_LT_EQ] = ACTIONS(2626),
    [anon_sym_CARET_EQ] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [1947] = {
    [sym_heredoc_body] = STATE(1947),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_PLUS_EQ] = ACTIONS(2634),
    [anon_sym_DASH_EQ] = ACTIONS(2634),
    [anon_sym_STAR_EQ] = ACTIONS(2634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2634),
    [anon_sym_SLASH_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2634),
    [anon_sym_AMP_EQ] = ACTIONS(2634),
    [anon_sym_PERCENT_EQ] = ACTIONS(2634),
    [anon_sym_GT_GT_EQ] = ACTIONS(2634),
    [anon_sym_LT_LT_EQ] = ACTIONS(2634),
    [anon_sym_CARET_EQ] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1948] = {
    [sym_heredoc_body] = STATE(1948),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2644),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
    [anon_sym_STAR_EQ] = ACTIONS(2646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2646),
    [anon_sym_AMP_EQ] = ACTIONS(2646),
    [anon_sym_PERCENT_EQ] = ACTIONS(2646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2646),
    [anon_sym_LT_LT_EQ] = ACTIONS(2646),
    [anon_sym_CARET_EQ] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1949] = {
    [sym_heredoc_body] = STATE(1949),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_unless] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_until] = ACTIONS(2622),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2622),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_and] = ACTIONS(2622),
    [anon_sym_or] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym__line_break] = ACTIONS(2620),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [1950] = {
    [sym_heredoc_body] = STATE(1950),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2628),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_PLUS_EQ] = ACTIONS(2630),
    [anon_sym_DASH_EQ] = ACTIONS(2630),
    [anon_sym_STAR_EQ] = ACTIONS(2630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2630),
    [anon_sym_SLASH_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2630),
    [anon_sym_AMP_EQ] = ACTIONS(2630),
    [anon_sym_PERCENT_EQ] = ACTIONS(2630),
    [anon_sym_GT_GT_EQ] = ACTIONS(2630),
    [anon_sym_LT_LT_EQ] = ACTIONS(2630),
    [anon_sym_CARET_EQ] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1951] = {
    [sym_heredoc_body] = STATE(1951),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_EQ] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_RBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2640),
    [anon_sym_AMP_AMP] = ACTIONS(2640),
    [anon_sym_LT_LT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2640),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [1952] = {
    [sym_heredoc_body] = STATE(1952),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_def] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2638),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2636),
    [anon_sym_rescue] = ACTIONS(2636),
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_nil] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_LT] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_next] = ACTIONS(2636),
    [anon_sym_redo] = ACTIONS(2636),
    [anon_sym_retry] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_unless] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_until] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_EQ_GT] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_RBRACK] = ACTIONS(2638),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_DOT_DOT] = ACTIONS(2636),
    [anon_sym_CARET] = ACTIONS(2636),
    [anon_sym_begin] = ACTIONS(2636),
    [anon_sym_COLON_COLON2] = ACTIONS(2638),
    [anon_sym_AMP_DOT] = ACTIONS(2638),
    [anon_sym_PLUS_EQ] = ACTIONS(2638),
    [anon_sym_DASH_EQ] = ACTIONS(2638),
    [anon_sym_STAR_EQ] = ACTIONS(2638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2638),
    [anon_sym_SLASH_EQ] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2638),
    [anon_sym_PIPE_EQ] = ACTIONS(2638),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2638),
    [anon_sym_AMP_EQ] = ACTIONS(2638),
    [anon_sym_PERCENT_EQ] = ACTIONS(2638),
    [anon_sym_GT_GT_EQ] = ACTIONS(2638),
    [anon_sym_LT_LT_EQ] = ACTIONS(2638),
    [anon_sym_CARET_EQ] = ACTIONS(2638),
    [anon_sym_QMARK] = ACTIONS(2636),
    [anon_sym_and] = ACTIONS(2636),
    [anon_sym_or] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2636),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_EQ] = ACTIONS(2636),
    [anon_sym_GT] = ACTIONS(2636),
    [anon_sym_GT_EQ] = ACTIONS(2638),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_PERCENT] = ACTIONS(2636),
    [anon_sym_EQ_EQ] = ACTIONS(2636),
    [anon_sym_BANG_EQ] = ACTIONS(2638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT_EQ_GT] = ACTIONS(2638),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_BANG_TILDE] = ACTIONS(2638),
    [anon_sym_defined_QMARK] = ACTIONS(2638),
    [anon_sym_not] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2638),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2636),
    [sym_float] = ACTIONS(2636),
    [sym_super] = ACTIONS(2636),
    [sym_self] = ACTIONS(2636),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [sym_constant] = ACTIONS(2636),
    [aux_sym_constant_suffix_token1] = ACTIONS(2638),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2636),
    [sym_instance_variable] = ACTIONS(2638),
    [sym_class_variable] = ACTIONS(2638),
    [sym_global_variable] = ACTIONS(2638),
    [sym_character] = ACTIONS(2638),
    [anon_sym_DASH_GT] = ACTIONS(2638),
    [sym_simple_symbol] = ACTIONS(2638),
    [sym__string_start] = ACTIONS(2638),
    [sym__symbol_start] = ACTIONS(2638),
    [sym__subshell_start] = ACTIONS(2638),
    [sym__regex_start] = ACTIONS(2638),
    [sym__string_array_start] = ACTIONS(2638),
    [sym__symbol_array_start] = ACTIONS(2638),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2638),
    [sym__block_ampersand] = ACTIONS(2638),
    [sym__splat_star] = ACTIONS(2638),
    [sym__unary_minus] = ACTIONS(2638),
    [sym__unary_minus_num] = ACTIONS(2638),
    [sym__binary_minus] = ACTIONS(2638),
    [sym__binary_star] = ACTIONS(2638),
    [sym_hash_key_symbol] = ACTIONS(2638),
    [sym__identifier_suffix] = ACTIONS(2638),
    [sym__constant_suffix] = ACTIONS(2638),
    [sym__hash_splat_star_star] = ACTIONS(2638),
    [sym__binary_star_star] = ACTIONS(2638),
    [sym__element_reference_bracket] = ACTIONS(2638),
  },
  [1953] = {
    [sym_heredoc_body] = STATE(1953),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_def] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_rescue] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2616),
    [anon_sym_nil] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_next] = ACTIONS(2616),
    [anon_sym_redo] = ACTIONS(2616),
    [anon_sym_retry] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_unless] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_until] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_RBRACK] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_PLUS_EQ] = ACTIONS(2618),
    [anon_sym_DASH_EQ] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(2618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2618),
    [anon_sym_SLASH_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2618),
    [anon_sym_AMP_EQ] = ACTIONS(2618),
    [anon_sym_PERCENT_EQ] = ACTIONS(2618),
    [anon_sym_GT_GT_EQ] = ACTIONS(2618),
    [anon_sym_LT_LT_EQ] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_and] = ACTIONS(2616),
    [anon_sym_or] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_SLASH] = ACTIONS(2616),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [anon_sym_defined_QMARK] = ACTIONS(2618),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2616),
    [sym_float] = ACTIONS(2616),
    [sym_super] = ACTIONS(2616),
    [sym_self] = ACTIONS(2616),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_constant] = ACTIONS(2616),
    [aux_sym_constant_suffix_token1] = ACTIONS(2618),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2616),
    [sym_instance_variable] = ACTIONS(2618),
    [sym_class_variable] = ACTIONS(2618),
    [sym_global_variable] = ACTIONS(2618),
    [sym_character] = ACTIONS(2618),
    [anon_sym_DASH_GT] = ACTIONS(2618),
    [sym_simple_symbol] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__symbol_start] = ACTIONS(2618),
    [sym__subshell_start] = ACTIONS(2618),
    [sym__regex_start] = ACTIONS(2618),
    [sym__string_array_start] = ACTIONS(2618),
    [sym__symbol_array_start] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2618),
    [sym__block_ampersand] = ACTIONS(2618),
    [sym__splat_star] = ACTIONS(2618),
    [sym__unary_minus] = ACTIONS(2618),
    [sym__unary_minus_num] = ACTIONS(2618),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym_hash_key_symbol] = ACTIONS(2618),
    [sym__identifier_suffix] = ACTIONS(2618),
    [sym__constant_suffix] = ACTIONS(2618),
    [sym__hash_splat_star_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [1954] = {
    [sym_heredoc_body] = STATE(1954),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1955] = {
    [sym_heredoc_body] = STATE(1955),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1956] = {
    [sym_heredoc_body] = STATE(1956),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1957] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5007),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1957),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_rescue] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_RBRACK] = ACTIONS(2652),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_and] = ACTIONS(2660),
    [anon_sym_or] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1958] = {
    [sym_heredoc_body] = STATE(1958),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1959] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym_destructured_left_assignment] = STATE(5469),
    [sym_rest_assignment] = STATE(5469),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(4980),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1959),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_RPAREN] = ACTIONS(2762),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2764),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1960] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym_destructured_left_assignment] = STATE(5469),
    [sym_rest_assignment] = STATE(5469),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(4980),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1960),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_RPAREN] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2768),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1961] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5028),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1961),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1962] = {
    [sym_heredoc_body] = STATE(1962),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_end] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_COLON] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_when] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2642),
    [anon_sym_elsif] = ACTIONS(2640),
    [anon_sym_else] = ACTIONS(2640),
    [anon_sym_then] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_ensure] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2642),
    [anon_sym_AMP_AMP] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(2642),
    [anon_sym_GT_GT] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_SLASH] = ACTIONS(2642),
    [anon_sym_PERCENT] = ACTIONS(2642),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym__line_break] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [1963] = {
    [sym_heredoc_body] = STATE(1963),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_end] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_when] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_elsif] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_ensure] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1964] = {
    [sym_heredoc_body] = STATE(1964),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_when] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_elsif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_ensure] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1965] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym_left_assignment_list] = STATE(5625),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5034),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1965),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1966] = {
    [sym_heredoc_body] = STATE(1966),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_elsif] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_then] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_ensure] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1967] = {
    [sym_heredoc_body] = STATE(1967),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_end] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_when] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_elsif] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_ensure] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1968] = {
    [sym_heredoc_body] = STATE(1968),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_elsif] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_then] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_ensure] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1969] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym_left_assignment_list] = STATE(5638),
    [sym__mlhs] = STATE(5618),
    [sym_destructured_left_assignment] = STATE(5314),
    [sym_rest_assignment] = STATE(5314),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(4957),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1969),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1970] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5007),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1970),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2662),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1971] = {
    [sym_heredoc_body] = STATE(1971),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_elsif] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_then] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_ensure] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1972] = {
    [sym_heredoc_body] = STATE(1972),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_end] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_when] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_elsif] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_ensure] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1973] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5414),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(4997),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym_destructured_left_assignment] = STATE(5469),
    [sym_rest_assignment] = STATE(5469),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(4980),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1973),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2706),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1974] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5484),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(126),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5489),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1974),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2774),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2776),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1975] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5484),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(130),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5489),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1975),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2778),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2780),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1976] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5484),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(128),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5489),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1976),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2782),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2784),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1977] = {
    [sym_heredoc_body] = STATE(1977),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1978] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5484),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(133),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5489),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1978),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2786),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1979] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5484),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(132),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5489),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1979),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2788),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1980] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5422),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(5044),
    [sym_scope_resolution] = STATE(5044),
    [sym__call] = STATE(4704),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5071),
    [sym__variable] = STATE(4709),
    [sym__nonlocal_variable] = STATE(4864),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(5044),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1980),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2790),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2792),
    [anon_sym_nil] = ACTIONS(2794),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2790),
    [sym_self] = ACTIONS(2790),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_constant] = ACTIONS(2790),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2798),
    [sym_class_variable] = ACTIONS(2798),
    [sym_global_variable] = ACTIONS(2798),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1981] = {
    [sym_heredoc_body] = STATE(1981),
    [ts_builtin_sym_end] = ACTIONS(2642),
    [sym_identifier] = ACTIONS(2640),
    [aux_sym_program_token1] = ACTIONS(2642),
    [anon_sym___END__] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_COLON] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2642),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2642),
    [anon_sym_AMP_AMP] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(2642),
    [anon_sym_GT_GT] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_SLASH] = ACTIONS(2642),
    [anon_sym_PERCENT] = ACTIONS(2642),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym__line_break] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [1982] = {
    [sym_method] = STATE(5489),
    [sym_singleton_method] = STATE(5489),
    [sym_class] = STATE(5489),
    [sym_singleton_class] = STATE(5489),
    [sym_module] = STATE(5489),
    [sym_return] = STATE(5489),
    [sym_yield] = STATE(5489),
    [sym_break] = STATE(5489),
    [sym_next] = STATE(5489),
    [sym_redo] = STATE(5489),
    [sym_retry] = STATE(5489),
    [sym_while] = STATE(5489),
    [sym_until] = STATE(5489),
    [sym_for] = STATE(5489),
    [sym_case] = STATE(5489),
    [sym_case_match] = STATE(5489),
    [sym_if] = STATE(5489),
    [sym_unless] = STATE(5489),
    [sym_begin] = STATE(5489),
    [sym__primary] = STATE(5484),
    [sym_parenthesized_statements] = STATE(5489),
    [sym_element_reference] = STATE(4997),
    [sym_scope_resolution] = STATE(134),
    [sym__call] = STATE(4661),
    [sym_call] = STATE(5489),
    [sym_parenthesized_unary] = STATE(5489),
    [sym_unary_literal] = STATE(5370),
    [sym__literal] = STATE(5489),
    [sym__numeric] = STATE(5488),
    [sym__simple_numeric] = STATE(5370),
    [sym__function_identifier] = STATE(4869),
    [sym__function_identifier_call] = STATE(5371),
    [sym__lhs] = STATE(5489),
    [sym__variable] = STATE(4662),
    [sym__nonlocal_variable] = STATE(4766),
    [sym__int_or_float] = STATE(5575),
    [sym_complex] = STATE(5374),
    [sym_rational] = STATE(5374),
    [sym_nil] = STATE(4997),
    [sym_constant_suffix] = STATE(4777),
    [sym_identifier_suffix] = STATE(4778),
    [sym_chained_string] = STATE(5489),
    [sym_string] = STATE(5211),
    [sym_subshell] = STATE(5489),
    [sym_string_array] = STATE(5489),
    [sym_symbol_array] = STATE(5489),
    [sym_delimited_symbol] = STATE(5488),
    [sym_regex] = STATE(5489),
    [sym_heredoc_body] = STATE(1982),
    [sym_array] = STATE(5489),
    [sym_hash] = STATE(5489),
    [sym_lambda] = STATE(5489),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_def] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_nil] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_next] = ACTIONS(2676),
    [anon_sym_redo] = ACTIONS(2678),
    [anon_sym_retry] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_unless] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_begin] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_defined_QMARK] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2702),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2704),
    [sym_float] = ACTIONS(2704),
    [sym_super] = ACTIONS(2706),
    [sym_self] = ACTIONS(2706),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_constant] = ACTIONS(2800),
    [aux_sym_constant_suffix_token1] = ACTIONS(2710),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2712),
    [sym_instance_variable] = ACTIONS(2714),
    [sym_class_variable] = ACTIONS(2714),
    [sym_global_variable] = ACTIONS(2714),
    [sym_character] = ACTIONS(2716),
    [anon_sym_DASH_GT] = ACTIONS(2718),
    [sym_simple_symbol] = ACTIONS(2720),
    [sym__string_start] = ACTIONS(2722),
    [sym__symbol_start] = ACTIONS(2724),
    [sym__subshell_start] = ACTIONS(2726),
    [sym__regex_start] = ACTIONS(2728),
    [sym__string_array_start] = ACTIONS(2730),
    [sym__symbol_array_start] = ACTIONS(2732),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2716),
    [sym__unary_minus_num] = ACTIONS(2698),
    [sym__identifier_suffix] = ACTIONS(2734),
    [sym__constant_suffix] = ACTIONS(2710),
  },
  [1983] = {
    [sym_heredoc_body] = STATE(1983),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1984] = {
    [sym_heredoc_body] = STATE(1984),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_program_token1] = ACTIONS(2634),
    [anon_sym___END__] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1985] = {
    [sym_heredoc_body] = STATE(1985),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_program_token1] = ACTIONS(2634),
    [anon_sym___END__] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1986] = {
    [sym_heredoc_body] = STATE(1986),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1987] = {
    [sym_heredoc_body] = STATE(1987),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1988] = {
    [sym_heredoc_body] = STATE(1988),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_program_token1] = ACTIONS(2634),
    [anon_sym___END__] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1989] = {
    [sym_heredoc_body] = STATE(1989),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1990] = {
    [sym_heredoc_body] = STATE(1990),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1991] = {
    [sym_heredoc_body] = STATE(1991),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [1992] = {
    [sym_heredoc_body] = STATE(1992),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1993] = {
    [sym_heredoc_body] = STATE(1993),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1994] = {
    [sym_heredoc_body] = STATE(1994),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1995] = {
    [sym_heredoc_body] = STATE(1995),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1996] = {
    [sym_heredoc_body] = STATE(1996),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [1997] = {
    [sym_heredoc_body] = STATE(1997),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1998] = {
    [sym_heredoc_body] = STATE(1998),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_then] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [1999] = {
    [sym_heredoc_body] = STATE(1999),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [2000] = {
    [sym_heredoc_body] = STATE(2000),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_COLON] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_RBRACK] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2642),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PIPE_PIPE] = ACTIONS(2642),
    [anon_sym_AMP_AMP] = ACTIONS(2642),
    [anon_sym_LT_LT] = ACTIONS(2642),
    [anon_sym_GT_GT] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_SLASH] = ACTIONS(2642),
    [anon_sym_PERCENT] = ACTIONS(2642),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [2001] = {
    [sym_heredoc_body] = STATE(2001),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2750),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_then] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [2002] = {
    [sym_heredoc_body] = STATE(2002),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2750),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [2003] = {
    [sym_heredoc_body] = STATE(2003),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [2004] = {
    [sym_heredoc_body] = STATE(2004),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [2005] = {
    [sym_heredoc_body] = STATE(2005),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [2006] = {
    [sym_heredoc_body] = STATE(2006),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [2007] = {
    [sym_heredoc_body] = STATE(2007),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [2008] = {
    [sym_heredoc_body] = STATE(2008),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [2009] = {
    [sym_heredoc_body] = STATE(2009),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2754),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [2010] = {
    [sym_heredoc_body] = STATE(2010),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2754),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2646),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2646),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [2011] = {
    [sym_splat_parameter] = STATE(4531),
    [sym__array_pattern_n] = STATE(4495),
    [sym__pattern_expr] = STATE(4526),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2011),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_end] = ACTIONS(2812),
    [anon_sym_rescue] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_unless] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_until] = ACTIONS(2812),
    [anon_sym_in] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_when] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_elsif] = ACTIONS(2812),
    [anon_sym_else] = ACTIONS(2812),
    [anon_sym_then] = ACTIONS(2812),
    [anon_sym_ensure] = ACTIONS(2812),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2806),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2012] = {
    [sym__pattern_expr] = STATE(4472),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2012),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_RPAREN] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_end] = ACTIONS(2848),
    [anon_sym_rescue] = ACTIONS(2848),
    [anon_sym_COMMA] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_unless] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_until] = ACTIONS(2848),
    [anon_sym_in] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_when] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_elsif] = ACTIONS(2848),
    [anon_sym_else] = ACTIONS(2848),
    [anon_sym_then] = ACTIONS(2848),
    [anon_sym_ensure] = ACTIONS(2848),
    [anon_sym_and] = ACTIONS(2848),
    [anon_sym_or] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2376),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2013] = {
    [sym__pattern_expr] = STATE(4462),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2013),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_RPAREN] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_end] = ACTIONS(2852),
    [anon_sym_rescue] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_unless] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_until] = ACTIONS(2852),
    [anon_sym_in] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_when] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_elsif] = ACTIONS(2852),
    [anon_sym_else] = ACTIONS(2852),
    [anon_sym_then] = ACTIONS(2852),
    [anon_sym_ensure] = ACTIONS(2852),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2850),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2014] = {
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5693),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5694),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5696),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_constant_suffix] = STATE(5647),
    [sym_identifier_suffix] = STATE(5647),
    [sym_string] = STATE(4758),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2014),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2870),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2015] = {
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5698),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5699),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5700),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_constant_suffix] = STATE(5647),
    [sym_identifier_suffix] = STATE(5647),
    [sym_string] = STATE(4758),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2015),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2870),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2016] = {
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5928),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5959),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5960),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_constant_suffix] = STATE(5647),
    [sym_identifier_suffix] = STATE(5647),
    [sym_string] = STATE(4758),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2016),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2017] = {
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5894),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5908),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5915),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_constant_suffix] = STATE(5647),
    [sym_identifier_suffix] = STATE(5647),
    [sym_string] = STATE(4758),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2017),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2902),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2018] = {
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym__pattern_top_expr_body] = STATE(4974),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4970),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_constant_suffix] = STATE(5647),
    [sym_identifier_suffix] = STATE(5647),
    [sym_string] = STATE(4758),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2018),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2019] = {
    [sym_splat_parameter] = STATE(4625),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4632),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4641),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_constant_suffix] = STATE(5941),
    [sym_identifier_suffix] = STATE(5941),
    [sym_string] = STATE(4567),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2019),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_STAR_STAR] = ACTIONS(1706),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2910),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2912),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2914),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2020] = {
    [sym_splat_parameter] = STATE(4528),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4533),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_constant_suffix] = STATE(5836),
    [sym_identifier_suffix] = STATE(5836),
    [sym_string] = STATE(4450),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2020),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2920),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2021] = {
    [sym_splat_parameter] = STATE(4776),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym__pattern_top_expr_body] = STATE(4494),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4768),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4770),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_constant_suffix] = STATE(5951),
    [sym_identifier_suffix] = STATE(5951),
    [sym_string] = STATE(4644),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2021),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2932),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2022] = {
    [sym_splat_parameter] = STATE(4776),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym__pattern_top_expr_body] = STATE(4502),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4768),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4770),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_constant_suffix] = STATE(5951),
    [sym_identifier_suffix] = STATE(5951),
    [sym_string] = STATE(4644),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2022),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2932),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2023] = {
    [sym_splat_parameter] = STATE(4885),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym__pattern_top_expr_body] = STATE(4962),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4886),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4920),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_constant_suffix] = STATE(5980),
    [sym_identifier_suffix] = STATE(5980),
    [sym_string] = STATE(4733),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2023),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2940),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2942),
    [sym_float] = ACTIONS(2942),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2944),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2940),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2024] = {
    [sym_splat_parameter] = STATE(4885),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym__pattern_top_expr_body] = STATE(4974),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4886),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4920),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_constant_suffix] = STATE(5980),
    [sym_identifier_suffix] = STATE(5980),
    [sym_string] = STATE(4733),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2024),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2940),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2942),
    [sym_float] = ACTIONS(2942),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2944),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2940),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2025] = {
    [sym_splat_parameter] = STATE(4528),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym__pattern_top_expr_body] = STATE(4494),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4533),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4525),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_constant_suffix] = STATE(5836),
    [sym_identifier_suffix] = STATE(5836),
    [sym_string] = STATE(4450),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2025),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2920),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2026] = {
    [sym_splat_parameter] = STATE(4625),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym__pattern_top_expr_body] = STATE(4494),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4632),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4641),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_constant_suffix] = STATE(5941),
    [sym_identifier_suffix] = STATE(5941),
    [sym_string] = STATE(4567),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2026),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_STAR_STAR] = ACTIONS(1706),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2910),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2912),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2914),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2027] = {
    [sym_splat_parameter] = STATE(4954),
    [sym_hash_splat_parameter] = STATE(4884),
    [sym_hash_splat_nil] = STATE(4884),
    [sym__pattern_top_expr_body] = STATE(4962),
    [sym__array_pattern_n] = STATE(4967),
    [sym__pattern_expr] = STATE(4970),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5018),
    [sym_find_pattern] = STATE(4816),
    [sym__hash_pattern_body] = STATE(5021),
    [sym_keyword_pattern] = STATE(4893),
    [sym__hash_pattern_any_rest] = STATE(4894),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_constant_suffix] = STATE(5647),
    [sym_identifier_suffix] = STATE(5647),
    [sym_string] = STATE(4758),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2027),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_STAR_STAR] = ACTIONS(1726),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2878),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2028] = {
    [sym_splat_parameter] = STATE(4776),
    [sym_hash_splat_parameter] = STATE(4508),
    [sym_hash_splat_nil] = STATE(4508),
    [sym__pattern_top_expr_body] = STATE(4842),
    [sym__array_pattern_n] = STATE(4514),
    [sym__pattern_expr] = STATE(4768),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym__find_pattern_body] = STATE(4492),
    [sym_find_pattern] = STATE(4443),
    [sym__hash_pattern_body] = STATE(4500),
    [sym_keyword_pattern] = STATE(4770),
    [sym__hash_pattern_any_rest] = STATE(4489),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_constant_suffix] = STATE(5951),
    [sym_identifier_suffix] = STATE(5951),
    [sym_string] = STATE(4644),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2028),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2932),
    [aux_sym_constant_suffix_token1] = ACTIONS(2880),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2882),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
    [sym__identifier_suffix] = ACTIONS(2882),
    [sym__constant_suffix] = ACTIONS(2880),
  },
  [2029] = {
    [sym_splat_parameter] = STATE(4627),
    [sym__array_pattern_n] = STATE(4495),
    [sym__pattern_expr] = STATE(4629),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2029),
    [sym_lambda] = STATE(4409),
    [ts_builtin_sym_end] = ACTIONS(2806),
    [sym_identifier] = ACTIONS(2802),
    [aux_sym_program_token1] = ACTIONS(2806),
    [anon_sym___END__] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_rescue] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_unless] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_until] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2910),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2806),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2914),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2030] = {
    [sym__pattern_expr] = STATE(4472),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2030),
    [sym_lambda] = STATE(4409),
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2802),
    [aux_sym_program_token1] = ACTIONS(2376),
    [anon_sym___END__] = ACTIONS(2848),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_rescue] = ACTIONS(2848),
    [anon_sym_COMMA] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_unless] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_until] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2910),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_and] = ACTIONS(2848),
    [anon_sym_or] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2376),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2914),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2031] = {
    [sym_heredoc_body] = STATE(2031),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_when] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_elsif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_then] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_ensure] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
  },
  [2032] = {
    [sym__pattern_expr] = STATE(4462),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2032),
    [sym_lambda] = STATE(4409),
    [ts_builtin_sym_end] = ACTIONS(2850),
    [sym_identifier] = ACTIONS(2802),
    [aux_sym_program_token1] = ACTIONS(2850),
    [anon_sym___END__] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_rescue] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_unless] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_until] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2910),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2850),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2914),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2033] = {
    [sym_heredoc_body] = STATE(2033),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_end] = ACTIONS(2644),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_when] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_elsif] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_then] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_ensure] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
  },
  [2034] = {
    [sym_heredoc_body] = STATE(2034),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_when] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_elsif] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_then] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_ensure] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
  },
  [2035] = {
    [sym_heredoc_body] = STATE(2035),
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_def] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_end] = ACTIONS(2948),
    [anon_sym_rescue] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_nil] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_next] = ACTIONS(2948),
    [anon_sym_redo] = ACTIONS(2948),
    [anon_sym_retry] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_unless] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_in] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_when] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_elsif] = ACTIONS(2948),
    [anon_sym_else] = ACTIONS(2948),
    [anon_sym_then] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2948),
    [anon_sym_ensure] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_defined_QMARK] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2948),
    [sym_float] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [sym_self] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [sym_constant] = ACTIONS(2948),
    [aux_sym_constant_suffix_token1] = ACTIONS(2950),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2948),
    [sym_instance_variable] = ACTIONS(2950),
    [sym_class_variable] = ACTIONS(2950),
    [sym_global_variable] = ACTIONS(2950),
    [sym_character] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym__line_break] = ACTIONS(2950),
    [sym_simple_symbol] = ACTIONS(2950),
    [sym__string_start] = ACTIONS(2950),
    [sym__symbol_start] = ACTIONS(2950),
    [sym__subshell_start] = ACTIONS(2950),
    [sym__regex_start] = ACTIONS(2950),
    [sym__string_array_start] = ACTIONS(2950),
    [sym__symbol_array_start] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2950),
    [sym__block_ampersand] = ACTIONS(2950),
    [sym__splat_star] = ACTIONS(2950),
    [sym__unary_minus] = ACTIONS(2950),
    [sym__unary_minus_num] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym_hash_key_symbol] = ACTIONS(2950),
    [sym__identifier_suffix] = ACTIONS(2950),
    [sym__constant_suffix] = ACTIONS(2950),
    [sym__hash_splat_star_star] = ACTIONS(2950),
  },
  [2036] = {
    [sym_heredoc_body] = STATE(2036),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2642),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_end] = ACTIONS(2640),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_when] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_elsif] = ACTIONS(2640),
    [anon_sym_else] = ACTIONS(2640),
    [anon_sym_then] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_ensure] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym__line_break] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
  },
  [2037] = {
    [sym_heredoc_body] = STATE(2037),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_when] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_elsif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_then] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_ensure] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
  },
  [2038] = {
    [sym_splat_parameter] = STATE(4794),
    [sym__array_pattern_n] = STATE(4495),
    [sym__pattern_expr] = STATE(4835),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2038),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_unless] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_then] = ACTIONS(2812),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2806),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2039] = {
    [sym_heredoc_body] = STATE(2039),
    [sym_identifier] = ACTIONS(2622),
    [anon_sym_BEGIN] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_END] = ACTIONS(2622),
    [anon_sym_def] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_end] = ACTIONS(2622),
    [anon_sym_rescue] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_nil] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2622),
    [anon_sym_return] = ACTIONS(2622),
    [anon_sym_yield] = ACTIONS(2622),
    [anon_sym_break] = ACTIONS(2622),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2622),
    [anon_sym_retry] = ACTIONS(2622),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_unless] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_until] = ACTIONS(2622),
    [anon_sym_for] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_else] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2622),
    [anon_sym_ensure] = ACTIONS(2622),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_defined_QMARK] = ACTIONS(2620),
    [anon_sym_not] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_TILDE] = ACTIONS(2620),
    [anon_sym_undef] = ACTIONS(2622),
    [anon_sym_alias] = ACTIONS(2622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2622),
    [sym_float] = ACTIONS(2622),
    [sym_super] = ACTIONS(2622),
    [sym_self] = ACTIONS(2622),
    [sym_true] = ACTIONS(2622),
    [sym_false] = ACTIONS(2622),
    [sym_constant] = ACTIONS(2622),
    [aux_sym_constant_suffix_token1] = ACTIONS(2620),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2622),
    [sym_instance_variable] = ACTIONS(2620),
    [sym_class_variable] = ACTIONS(2620),
    [sym_global_variable] = ACTIONS(2620),
    [sym_character] = ACTIONS(2620),
    [anon_sym_DASH_GT] = ACTIONS(2620),
    [sym__line_break] = ACTIONS(2620),
    [sym_simple_symbol] = ACTIONS(2620),
    [sym__string_start] = ACTIONS(2620),
    [sym__symbol_start] = ACTIONS(2620),
    [sym__subshell_start] = ACTIONS(2620),
    [sym__regex_start] = ACTIONS(2620),
    [sym__string_array_start] = ACTIONS(2620),
    [sym__symbol_array_start] = ACTIONS(2620),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2620),
    [sym__unary_minus] = ACTIONS(2620),
    [sym__unary_minus_num] = ACTIONS(2620),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__identifier_suffix] = ACTIONS(2620),
    [sym__constant_suffix] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [2040] = {
    [sym_argument_list] = STATE(2256),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_heredoc_body] = STATE(2040),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2041] = {
    [sym_splat_parameter] = STATE(4883),
    [sym__array_pattern_n] = STATE(4958),
    [sym__pattern_expr] = STATE(4895),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2041),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_rescue] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2806),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2940),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2942),
    [sym_float] = ACTIONS(2942),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2940),
  },
  [2042] = {
    [sym_argument_list] = STATE(2239),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_heredoc_body] = STATE(2042),
    [ts_builtin_sym_end] = ACTIONS(177),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(177),
    [anon_sym_rescue] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_unless] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_until] = ACTIONS(177),
    [anon_sym_in] = ACTIONS(177),
    [anon_sym_do] = ACTIONS(177),
    [anon_sym_when] = ACTIONS(177),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(177),
    [anon_sym_else] = ACTIONS(177),
    [anon_sym_then] = ACTIONS(177),
    [anon_sym_ensure] = ACTIONS(177),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_and] = ACTIONS(177),
    [anon_sym_or] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(177),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [2043] = {
    [sym_heredoc_body] = STATE(2043),
    [sym_identifier] = ACTIONS(2062),
    [anon_sym_BEGIN] = ACTIONS(2062),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_END] = ACTIONS(2062),
    [anon_sym_def] = ACTIONS(2062),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_end] = ACTIONS(2062),
    [anon_sym_rescue] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_nil] = ACTIONS(2062),
    [anon_sym_class] = ACTIONS(2062),
    [anon_sym_module] = ACTIONS(2062),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_yield] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2062),
    [anon_sym_next] = ACTIONS(2062),
    [anon_sym_redo] = ACTIONS(2062),
    [anon_sym_retry] = ACTIONS(2062),
    [anon_sym_if] = ACTIONS(2062),
    [anon_sym_unless] = ACTIONS(2062),
    [anon_sym_while] = ACTIONS(2062),
    [anon_sym_until] = ACTIONS(2062),
    [anon_sym_for] = ACTIONS(2062),
    [anon_sym_in] = ACTIONS(2062),
    [anon_sym_case] = ACTIONS(2062),
    [anon_sym_when] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2062),
    [anon_sym_elsif] = ACTIONS(2062),
    [anon_sym_else] = ACTIONS(2062),
    [anon_sym_then] = ACTIONS(2062),
    [anon_sym_begin] = ACTIONS(2062),
    [anon_sym_ensure] = ACTIONS(2062),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_defined_QMARK] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_undef] = ACTIONS(2062),
    [anon_sym_alias] = ACTIONS(2062),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2062),
    [sym_float] = ACTIONS(2062),
    [sym_super] = ACTIONS(2062),
    [sym_self] = ACTIONS(2062),
    [sym_true] = ACTIONS(2062),
    [sym_false] = ACTIONS(2062),
    [sym_constant] = ACTIONS(2062),
    [aux_sym_constant_suffix_token1] = ACTIONS(2962),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2062),
    [sym_instance_variable] = ACTIONS(2962),
    [sym_class_variable] = ACTIONS(2962),
    [sym_global_variable] = ACTIONS(2962),
    [sym_character] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2962),
    [sym_simple_symbol] = ACTIONS(2962),
    [sym__string_start] = ACTIONS(2962),
    [sym__symbol_start] = ACTIONS(2962),
    [sym__subshell_start] = ACTIONS(2962),
    [sym__regex_start] = ACTIONS(2962),
    [sym__string_array_start] = ACTIONS(2962),
    [sym__symbol_array_start] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2962),
    [sym__unary_minus] = ACTIONS(2962),
    [sym__unary_minus_num] = ACTIONS(2962),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__identifier_suffix] = ACTIONS(2962),
    [sym__constant_suffix] = ACTIONS(2962),
  },
  [2044] = {
    [sym_argument_list] = STATE(2223),
    [sym_do_block] = STATE(2290),
    [sym_block] = STATE(2291),
    [sym_heredoc_body] = STATE(2044),
    [ts_builtin_sym_end] = ACTIONS(177),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(177),
    [anon_sym_rescue] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_unless] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_until] = ACTIONS(177),
    [anon_sym_in] = ACTIONS(177),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_when] = ACTIONS(177),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(177),
    [anon_sym_else] = ACTIONS(177),
    [anon_sym_then] = ACTIONS(177),
    [anon_sym_ensure] = ACTIONS(177),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_and] = ACTIONS(177),
    [anon_sym_or] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(177),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [2045] = {
    [sym_argument_list] = STATE(2241),
    [sym_do_block] = STATE(2392),
    [sym_block] = STATE(2353),
    [sym_heredoc_body] = STATE(2045),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(143),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2046] = {
    [sym_splat_parameter] = STATE(4956),
    [sym__array_pattern_n] = STATE(4958),
    [sym__pattern_expr] = STATE(4948),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2046),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2806),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2047] = {
    [sym__pattern_expr] = STATE(4462),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2047),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_COMMA] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_unless] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_then] = ACTIONS(2852),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2850),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2048] = {
    [sym_heredoc_body] = STATE(2048),
    [ts_builtin_sym_end] = ACTIONS(2964),
    [aux_sym_program_token1] = ACTIONS(2964),
    [anon_sym___END__] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_end] = ACTIONS(2964),
    [anon_sym_rescue] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_PIPE] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LT] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_unless] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_until] = ACTIONS(2964),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_when] = ACTIONS(2964),
    [anon_sym_EQ_GT] = ACTIONS(2970),
    [anon_sym_LBRACK2] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_DOT_DOT] = ACTIONS(2966),
    [anon_sym_CARET] = ACTIONS(2966),
    [anon_sym_elsif] = ACTIONS(2964),
    [anon_sym_else] = ACTIONS(2964),
    [anon_sym_then] = ACTIONS(2964),
    [anon_sym_ensure] = ACTIONS(2964),
    [anon_sym_COLON_COLON2] = ACTIONS(2964),
    [anon_sym_AMP_DOT] = ACTIONS(2964),
    [anon_sym_PLUS_EQ] = ACTIONS(2964),
    [anon_sym_DASH_EQ] = ACTIONS(2964),
    [anon_sym_STAR_EQ] = ACTIONS(2964),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2964),
    [anon_sym_SLASH_EQ] = ACTIONS(2964),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2964),
    [anon_sym_PIPE_EQ] = ACTIONS(2964),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2964),
    [anon_sym_AMP_EQ] = ACTIONS(2964),
    [anon_sym_PERCENT_EQ] = ACTIONS(2964),
    [anon_sym_GT_GT_EQ] = ACTIONS(2964),
    [anon_sym_LT_LT_EQ] = ACTIONS(2964),
    [anon_sym_CARET_EQ] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(2964),
    [anon_sym_and] = ACTIONS(2964),
    [anon_sym_or] = ACTIONS(2964),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_LT_LT] = ACTIONS(2966),
    [anon_sym_GT_GT] = ACTIONS(2966),
    [anon_sym_LT_EQ] = ACTIONS(2966),
    [anon_sym_GT] = ACTIONS(2966),
    [anon_sym_GT_EQ] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_SLASH] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_EQ_EQ] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2964),
    [anon_sym_LT_EQ_GT] = ACTIONS(2964),
    [anon_sym_EQ_TILDE] = ACTIONS(2964),
    [anon_sym_BANG_TILDE] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2964),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2964),
    [sym__binary_star] = ACTIONS(2964),
    [sym__binary_star_star] = ACTIONS(2964),
    [sym__element_reference_bracket] = ACTIONS(2964),
  },
  [2049] = {
    [sym__pattern_expr] = STATE(4472),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2049),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_COMMA] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_unless] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_then] = ACTIONS(2848),
    [anon_sym_and] = ACTIONS(2848),
    [anon_sym_or] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym__line_break] = ACTIONS(2376),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2050] = {
    [sym_heredoc_body] = STATE(2050),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_BEGIN] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_END] = ACTIONS(2966),
    [anon_sym_def] = ACTIONS(2966),
    [anon_sym_LPAREN] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2966),
    [anon_sym_end] = ACTIONS(2966),
    [anon_sym_rescue] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_nil] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_module] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_next] = ACTIONS(2966),
    [anon_sym_redo] = ACTIONS(2966),
    [anon_sym_retry] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_unless] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_until] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_DOT_DOT] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_ensure] = ACTIONS(2966),
    [anon_sym_COLON_COLON2] = ACTIONS(2964),
    [anon_sym_AMP_DOT] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_defined_QMARK] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_undef] = ACTIONS(2966),
    [anon_sym_alias] = ACTIONS(2966),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2966),
    [sym_float] = ACTIONS(2966),
    [sym_super] = ACTIONS(2966),
    [sym_self] = ACTIONS(2966),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [sym_constant] = ACTIONS(2966),
    [aux_sym_constant_suffix_token1] = ACTIONS(2964),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2966),
    [sym_instance_variable] = ACTIONS(2964),
    [sym_class_variable] = ACTIONS(2964),
    [sym_global_variable] = ACTIONS(2964),
    [sym_character] = ACTIONS(2964),
    [anon_sym_DASH_GT] = ACTIONS(2964),
    [sym__line_break] = ACTIONS(2964),
    [sym_simple_symbol] = ACTIONS(2964),
    [sym__string_start] = ACTIONS(2964),
    [sym__symbol_start] = ACTIONS(2964),
    [sym__subshell_start] = ACTIONS(2964),
    [sym__regex_start] = ACTIONS(2964),
    [sym__string_array_start] = ACTIONS(2964),
    [sym__symbol_array_start] = ACTIONS(2964),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2964),
    [sym__unary_minus] = ACTIONS(2964),
    [sym__unary_minus_num] = ACTIONS(2964),
    [sym__binary_minus] = ACTIONS(2964),
    [sym__identifier_suffix] = ACTIONS(2964),
    [sym__constant_suffix] = ACTIONS(2964),
    [sym__element_reference_bracket] = ACTIONS(2964),
  },
  [2051] = {
    [sym_heredoc_body] = STATE(2051),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym__line_break] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
  },
  [2052] = {
    [sym_heredoc_body] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(2950),
    [sym_identifier] = ACTIONS(2948),
    [aux_sym_program_token1] = ACTIONS(2950),
    [anon_sym___END__] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_def] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_nil] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_next] = ACTIONS(2948),
    [anon_sym_redo] = ACTIONS(2948),
    [anon_sym_retry] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_unless] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_defined_QMARK] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2948),
    [sym_float] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [sym_self] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [sym_constant] = ACTIONS(2948),
    [aux_sym_constant_suffix_token1] = ACTIONS(2950),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2948),
    [sym_instance_variable] = ACTIONS(2950),
    [sym_class_variable] = ACTIONS(2950),
    [sym_global_variable] = ACTIONS(2950),
    [sym_character] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym__line_break] = ACTIONS(2950),
    [sym_simple_symbol] = ACTIONS(2950),
    [sym__string_start] = ACTIONS(2950),
    [sym__symbol_start] = ACTIONS(2950),
    [sym__subshell_start] = ACTIONS(2950),
    [sym__regex_start] = ACTIONS(2950),
    [sym__string_array_start] = ACTIONS(2950),
    [sym__symbol_array_start] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2950),
    [sym__block_ampersand] = ACTIONS(2950),
    [sym__splat_star] = ACTIONS(2950),
    [sym__unary_minus] = ACTIONS(2950),
    [sym__unary_minus_num] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym_hash_key_symbol] = ACTIONS(2950),
    [sym__identifier_suffix] = ACTIONS(2950),
    [sym__constant_suffix] = ACTIONS(2950),
    [sym__hash_splat_star_star] = ACTIONS(2950),
  },
  [2053] = {
    [sym_heredoc_body] = STATE(2053),
    [ts_builtin_sym_end] = ACTIONS(2642),
    [sym_identifier] = ACTIONS(2640),
    [aux_sym_program_token1] = ACTIONS(2642),
    [anon_sym___END__] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2642),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym__line_break] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
  },
  [2054] = {
    [sym_do_block] = STATE(2096),
    [sym_block] = STATE(2096),
    [sym_heredoc_body] = STATE(2054),
    [ts_builtin_sym_end] = ACTIONS(2972),
    [aux_sym_program_token1] = ACTIONS(2972),
    [anon_sym___END__] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_end] = ACTIONS(2972),
    [anon_sym_rescue] = ACTIONS(2972),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_unless] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_until] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_when] = ACTIONS(2972),
    [anon_sym_EQ_GT] = ACTIONS(2972),
    [anon_sym_DOT_DOT] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_elsif] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_then] = ACTIONS(2972),
    [anon_sym_ensure] = ACTIONS(2972),
    [anon_sym_COLON_COLON2] = ACTIONS(2972),
    [anon_sym_AMP_DOT] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_and] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2974),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_EQ_TILDE] = ACTIONS(2972),
    [anon_sym_BANG_TILDE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2972),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2972),
    [sym__binary_star] = ACTIONS(2972),
    [sym__binary_star_star] = ACTIONS(2972),
    [sym__element_reference_bracket] = ACTIONS(2972),
  },
  [2055] = {
    [sym_heredoc_body] = STATE(2055),
    [sym_identifier] = ACTIONS(2976),
    [anon_sym_BEGIN] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_END] = ACTIONS(2976),
    [anon_sym_def] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_RPAREN] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2978),
    [anon_sym_end] = ACTIONS(2976),
    [anon_sym_rescue] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_nil] = ACTIONS(2976),
    [anon_sym_class] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_return] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2976),
    [anon_sym_break] = ACTIONS(2976),
    [anon_sym_next] = ACTIONS(2976),
    [anon_sym_redo] = ACTIONS(2976),
    [anon_sym_retry] = ACTIONS(2976),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_unless] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_until] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2976),
    [anon_sym_in] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2976),
    [anon_sym_when] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_DOT_DOT] = ACTIONS(2976),
    [anon_sym_elsif] = ACTIONS(2976),
    [anon_sym_else] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2976),
    [anon_sym_ensure] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_defined_QMARK] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_undef] = ACTIONS(2976),
    [anon_sym_alias] = ACTIONS(2976),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2976),
    [sym_float] = ACTIONS(2976),
    [sym_super] = ACTIONS(2976),
    [sym_self] = ACTIONS(2976),
    [sym_true] = ACTIONS(2976),
    [sym_false] = ACTIONS(2976),
    [sym_constant] = ACTIONS(2976),
    [aux_sym_constant_suffix_token1] = ACTIONS(2978),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2976),
    [sym_instance_variable] = ACTIONS(2978),
    [sym_class_variable] = ACTIONS(2978),
    [sym_global_variable] = ACTIONS(2978),
    [sym_character] = ACTIONS(2978),
    [anon_sym_DASH_GT] = ACTIONS(2978),
    [sym_simple_symbol] = ACTIONS(2978),
    [sym__string_start] = ACTIONS(2978),
    [sym__symbol_start] = ACTIONS(2978),
    [sym__subshell_start] = ACTIONS(2978),
    [sym__regex_start] = ACTIONS(2978),
    [sym__string_array_start] = ACTIONS(2978),
    [sym__symbol_array_start] = ACTIONS(2978),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2978),
    [sym__unary_minus] = ACTIONS(2978),
    [sym__unary_minus_num] = ACTIONS(2978),
    [sym__binary_minus] = ACTIONS(2978),
    [sym__identifier_suffix] = ACTIONS(2978),
    [sym__constant_suffix] = ACTIONS(2978),
  },
  [2056] = {
    [sym_do_block] = STATE(2096),
    [sym_block] = STATE(2096),
    [sym_heredoc_body] = STATE(2056),
    [ts_builtin_sym_end] = ACTIONS(2972),
    [aux_sym_program_token1] = ACTIONS(2972),
    [anon_sym___END__] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_end] = ACTIONS(2972),
    [anon_sym_rescue] = ACTIONS(2972),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_unless] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_until] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_when] = ACTIONS(2972),
    [anon_sym_EQ_GT] = ACTIONS(2972),
    [anon_sym_DOT_DOT] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_elsif] = ACTIONS(2972),
    [anon_sym_else] = ACTIONS(2972),
    [anon_sym_then] = ACTIONS(2972),
    [anon_sym_ensure] = ACTIONS(2972),
    [anon_sym_COLON_COLON2] = ACTIONS(2972),
    [anon_sym_AMP_DOT] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_and] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2974),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_EQ_TILDE] = ACTIONS(2972),
    [anon_sym_BANG_TILDE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2972),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2972),
    [sym__binary_star] = ACTIONS(2972),
    [sym__binary_star_star] = ACTIONS(2972),
    [sym__element_reference_bracket] = ACTIONS(2972),
  },
  [2057] = {
    [sym_heredoc_body] = STATE(2057),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_program_token1] = ACTIONS(2634),
    [anon_sym___END__] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym__line_break] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
  },
  [2058] = {
    [sym_heredoc_body] = STATE(2058),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym__line_break] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
  },
  [2059] = {
    [sym_heredoc_body] = STATE(2059),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_BEGIN] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(2986),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_END] = ACTIONS(2984),
    [anon_sym_def] = ACTIONS(2984),
    [anon_sym_LPAREN] = ACTIONS(2986),
    [anon_sym_RPAREN] = ACTIONS(2986),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_end] = ACTIONS(2984),
    [anon_sym_rescue] = ACTIONS(2984),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(2986),
    [anon_sym_nil] = ACTIONS(2984),
    [anon_sym_class] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2984),
    [anon_sym_redo] = ACTIONS(2984),
    [anon_sym_retry] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_unless] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_until] = ACTIONS(2984),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_in] = ACTIONS(2984),
    [anon_sym_case] = ACTIONS(2984),
    [anon_sym_when] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_DOT_DOT] = ACTIONS(2984),
    [anon_sym_elsif] = ACTIONS(2984),
    [anon_sym_else] = ACTIONS(2984),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_ensure] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_defined_QMARK] = ACTIONS(2986),
    [anon_sym_not] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2986),
    [anon_sym_undef] = ACTIONS(2984),
    [anon_sym_alias] = ACTIONS(2984),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2984),
    [sym_float] = ACTIONS(2984),
    [sym_super] = ACTIONS(2984),
    [sym_self] = ACTIONS(2984),
    [sym_true] = ACTIONS(2984),
    [sym_false] = ACTIONS(2984),
    [sym_constant] = ACTIONS(2984),
    [aux_sym_constant_suffix_token1] = ACTIONS(2986),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2984),
    [sym_instance_variable] = ACTIONS(2986),
    [sym_class_variable] = ACTIONS(2986),
    [sym_global_variable] = ACTIONS(2986),
    [sym_character] = ACTIONS(2986),
    [anon_sym_DASH_GT] = ACTIONS(2986),
    [sym_simple_symbol] = ACTIONS(2986),
    [sym__string_start] = ACTIONS(2986),
    [sym__symbol_start] = ACTIONS(2986),
    [sym__subshell_start] = ACTIONS(2986),
    [sym__regex_start] = ACTIONS(2986),
    [sym__string_array_start] = ACTIONS(2986),
    [sym__symbol_array_start] = ACTIONS(2986),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2986),
    [sym__unary_minus] = ACTIONS(2986),
    [sym__unary_minus_num] = ACTIONS(2986),
    [sym__binary_minus] = ACTIONS(2986),
    [sym__identifier_suffix] = ACTIONS(2986),
    [sym__constant_suffix] = ACTIONS(2986),
  },
  [2060] = {
    [sym_heredoc_body] = STATE(2060),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym__line_break] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
  },
  [2061] = {
    [sym_do_block] = STATE(2085),
    [sym_block] = STATE(2085),
    [sym_heredoc_body] = STATE(2061),
    [ts_builtin_sym_end] = ACTIONS(2988),
    [aux_sym_program_token1] = ACTIONS(2988),
    [anon_sym___END__] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2990),
    [anon_sym_end] = ACTIONS(2988),
    [anon_sym_rescue] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_unless] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_until] = ACTIONS(2988),
    [anon_sym_in] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_when] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(2990),
    [anon_sym_CARET] = ACTIONS(2990),
    [anon_sym_elsif] = ACTIONS(2988),
    [anon_sym_else] = ACTIONS(2988),
    [anon_sym_then] = ACTIONS(2988),
    [anon_sym_ensure] = ACTIONS(2988),
    [anon_sym_COLON_COLON2] = ACTIONS(2988),
    [anon_sym_AMP_DOT] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_and] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_LT_LT] = ACTIONS(2990),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_EQ] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_SLASH] = ACTIONS(2990),
    [anon_sym_PERCENT] = ACTIONS(2990),
    [anon_sym_EQ_EQ] = ACTIONS(2990),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ_GT] = ACTIONS(2988),
    [anon_sym_EQ_TILDE] = ACTIONS(2988),
    [anon_sym_BANG_TILDE] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2988),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2988),
    [sym__binary_star] = ACTIONS(2988),
    [sym__binary_star_star] = ACTIONS(2988),
    [sym__element_reference_bracket] = ACTIONS(2988),
  },
  [2062] = {
    [sym_heredoc_body] = STATE(2062),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_BEGIN] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_END] = ACTIONS(1124),
    [anon_sym_def] = ACTIONS(1124),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_COLON_COLON] = ACTIONS(1110),
    [anon_sym_end] = ACTIONS(1124),
    [anon_sym_rescue] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_nil] = ACTIONS(1124),
    [anon_sym_class] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_yield] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_next] = ACTIONS(1124),
    [anon_sym_redo] = ACTIONS(1124),
    [anon_sym_retry] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_unless] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_until] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_in] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_when] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_DOT_DOT] = ACTIONS(1124),
    [anon_sym_elsif] = ACTIONS(1124),
    [anon_sym_else] = ACTIONS(1124),
    [anon_sym_begin] = ACTIONS(1124),
    [anon_sym_ensure] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_defined_QMARK] = ACTIONS(1110),
    [anon_sym_not] = ACTIONS(1124),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_undef] = ACTIONS(1124),
    [anon_sym_alias] = ACTIONS(1124),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1124),
    [sym_float] = ACTIONS(1124),
    [sym_super] = ACTIONS(1124),
    [sym_self] = ACTIONS(1124),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_constant] = ACTIONS(1124),
    [aux_sym_constant_suffix_token1] = ACTIONS(1110),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1124),
    [sym_instance_variable] = ACTIONS(1110),
    [sym_class_variable] = ACTIONS(1110),
    [sym_global_variable] = ACTIONS(1110),
    [sym_character] = ACTIONS(1110),
    [anon_sym_DASH_GT] = ACTIONS(1110),
    [sym_simple_symbol] = ACTIONS(1110),
    [sym__string_start] = ACTIONS(1110),
    [sym__symbol_start] = ACTIONS(1110),
    [sym__subshell_start] = ACTIONS(1110),
    [sym__regex_start] = ACTIONS(1110),
    [sym__string_array_start] = ACTIONS(1110),
    [sym__symbol_array_start] = ACTIONS(1110),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1110),
    [sym__unary_minus] = ACTIONS(1110),
    [sym__unary_minus_num] = ACTIONS(1110),
    [sym__binary_minus] = ACTIONS(1110),
    [sym__identifier_suffix] = ACTIONS(1110),
    [sym__constant_suffix] = ACTIONS(1110),
  },
  [2063] = {
    [sym_do_block] = STATE(2085),
    [sym_block] = STATE(2085),
    [sym_heredoc_body] = STATE(2063),
    [ts_builtin_sym_end] = ACTIONS(2988),
    [aux_sym_program_token1] = ACTIONS(2988),
    [anon_sym___END__] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2990),
    [anon_sym_end] = ACTIONS(2988),
    [anon_sym_rescue] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_unless] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_until] = ACTIONS(2988),
    [anon_sym_in] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_when] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(2990),
    [anon_sym_CARET] = ACTIONS(2990),
    [anon_sym_elsif] = ACTIONS(2988),
    [anon_sym_else] = ACTIONS(2988),
    [anon_sym_then] = ACTIONS(2988),
    [anon_sym_ensure] = ACTIONS(2988),
    [anon_sym_COLON_COLON2] = ACTIONS(2988),
    [anon_sym_AMP_DOT] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_and] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_LT_LT] = ACTIONS(2990),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_EQ] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_SLASH] = ACTIONS(2990),
    [anon_sym_PERCENT] = ACTIONS(2990),
    [anon_sym_EQ_EQ] = ACTIONS(2990),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ_GT] = ACTIONS(2988),
    [anon_sym_EQ_TILDE] = ACTIONS(2988),
    [anon_sym_BANG_TILDE] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2988),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2988),
    [sym__binary_star] = ACTIONS(2988),
    [sym__binary_star_star] = ACTIONS(2988),
    [sym__element_reference_bracket] = ACTIONS(2988),
  },
  [2064] = {
    [sym_heredoc_body] = STATE(2064),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [aux_sym_program_token1] = ACTIONS(2630),
    [anon_sym___END__] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2630),
    [anon_sym_rescue] = ACTIONS(2630),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2630),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2630),
    [anon_sym_until] = ACTIONS(2630),
    [anon_sym_in] = ACTIONS(2630),
    [anon_sym_do] = ACTIONS(2630),
    [anon_sym_when] = ACTIONS(2630),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_elsif] = ACTIONS(2630),
    [anon_sym_else] = ACTIONS(2630),
    [anon_sym_then] = ACTIONS(2630),
    [anon_sym_ensure] = ACTIONS(2630),
    [anon_sym_COLON_COLON2] = ACTIONS(2630),
    [anon_sym_AMP_DOT] = ACTIONS(2630),
    [anon_sym_PLUS_EQ] = ACTIONS(2630),
    [anon_sym_DASH_EQ] = ACTIONS(2630),
    [anon_sym_STAR_EQ] = ACTIONS(2630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2630),
    [anon_sym_SLASH_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_PIPE_EQ] = ACTIONS(2630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2630),
    [anon_sym_AMP_EQ] = ACTIONS(2630),
    [anon_sym_PERCENT_EQ] = ACTIONS(2630),
    [anon_sym_GT_GT_EQ] = ACTIONS(2630),
    [anon_sym_LT_LT_EQ] = ACTIONS(2630),
    [anon_sym_CARET_EQ] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2630),
    [anon_sym_and] = ACTIONS(2630),
    [anon_sym_or] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ_GT] = ACTIONS(2630),
    [anon_sym_EQ_TILDE] = ACTIONS(2630),
    [anon_sym_BANG_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2630),
    [sym__binary_star] = ACTIONS(2630),
    [sym__binary_star_star] = ACTIONS(2630),
    [sym__element_reference_bracket] = ACTIONS(2630),
  },
  [2065] = {
    [sym__pattern_expr] = STATE(4843),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2065),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_RBRACE] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_COMMA] = ACTIONS(2376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2848),
    [anon_sym_or] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2066] = {
    [sym_heredoc_body] = STATE(2066),
    [ts_builtin_sym_end] = ACTIONS(2642),
    [aux_sym_program_token1] = ACTIONS(2642),
    [anon_sym___END__] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_end] = ACTIONS(2642),
    [anon_sym_rescue] = ACTIONS(2642),
    [anon_sym_EQ] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_PIPE] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2642),
    [anon_sym_unless] = ACTIONS(2642),
    [anon_sym_while] = ACTIONS(2642),
    [anon_sym_until] = ACTIONS(2642),
    [anon_sym_in] = ACTIONS(2642),
    [anon_sym_do] = ACTIONS(2642),
    [anon_sym_when] = ACTIONS(2642),
    [anon_sym_EQ_GT] = ACTIONS(2642),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_elsif] = ACTIONS(2642),
    [anon_sym_else] = ACTIONS(2642),
    [anon_sym_then] = ACTIONS(2642),
    [anon_sym_ensure] = ACTIONS(2642),
    [anon_sym_COLON_COLON2] = ACTIONS(2642),
    [anon_sym_AMP_DOT] = ACTIONS(2642),
    [anon_sym_PLUS_EQ] = ACTIONS(2642),
    [anon_sym_DASH_EQ] = ACTIONS(2642),
    [anon_sym_STAR_EQ] = ACTIONS(2642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2642),
    [anon_sym_SLASH_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_PIPE_EQ] = ACTIONS(2642),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2642),
    [anon_sym_AMP_EQ] = ACTIONS(2642),
    [anon_sym_PERCENT_EQ] = ACTIONS(2642),
    [anon_sym_GT_GT_EQ] = ACTIONS(2642),
    [anon_sym_LT_LT_EQ] = ACTIONS(2642),
    [anon_sym_CARET_EQ] = ACTIONS(2642),
    [anon_sym_QMARK] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(2642),
    [anon_sym_or] = ACTIONS(2642),
    [anon_sym_PIPE_PIPE] = ACTIONS(2640),
    [anon_sym_AMP_AMP] = ACTIONS(2640),
    [anon_sym_LT_LT] = ACTIONS(2640),
    [anon_sym_GT_GT] = ACTIONS(2640),
    [anon_sym_LT_EQ] = ACTIONS(2640),
    [anon_sym_GT] = ACTIONS(2640),
    [anon_sym_GT_EQ] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2640),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_BANG_EQ] = ACTIONS(2642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2642),
    [anon_sym_LT_EQ_GT] = ACTIONS(2642),
    [anon_sym_EQ_TILDE] = ACTIONS(2642),
    [anon_sym_BANG_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2642),
    [sym__binary_star] = ACTIONS(2642),
    [sym__binary_star_star] = ACTIONS(2642),
    [sym__element_reference_bracket] = ACTIONS(2642),
  },
  [2067] = {
    [sym__pattern_expr] = STATE(4840),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2067),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_COMMA] = ACTIONS(2850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2068] = {
    [sym_heredoc_body] = STATE(2068),
    [ts_builtin_sym_end] = ACTIONS(2620),
    [aux_sym_program_token1] = ACTIONS(2620),
    [anon_sym___END__] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_RPAREN] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_end] = ACTIONS(2620),
    [anon_sym_rescue] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_unless] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_until] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_when] = ACTIONS(2620),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_elsif] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2620),
    [anon_sym_then] = ACTIONS(2620),
    [anon_sym_ensure] = ACTIONS(2620),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2620),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [2069] = {
    [sym_heredoc_body] = STATE(2069),
    [ts_builtin_sym_end] = ACTIONS(2638),
    [aux_sym_program_token1] = ACTIONS(2638),
    [anon_sym___END__] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(2638),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_end] = ACTIONS(2638),
    [anon_sym_rescue] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_LT] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2638),
    [anon_sym_unless] = ACTIONS(2638),
    [anon_sym_while] = ACTIONS(2638),
    [anon_sym_until] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2638),
    [anon_sym_when] = ACTIONS(2638),
    [anon_sym_EQ_GT] = ACTIONS(2638),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_DOT_DOT] = ACTIONS(2636),
    [anon_sym_CARET] = ACTIONS(2636),
    [anon_sym_elsif] = ACTIONS(2638),
    [anon_sym_else] = ACTIONS(2638),
    [anon_sym_then] = ACTIONS(2638),
    [anon_sym_ensure] = ACTIONS(2638),
    [anon_sym_COLON_COLON2] = ACTIONS(2638),
    [anon_sym_AMP_DOT] = ACTIONS(2638),
    [anon_sym_PLUS_EQ] = ACTIONS(2638),
    [anon_sym_DASH_EQ] = ACTIONS(2638),
    [anon_sym_STAR_EQ] = ACTIONS(2638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2638),
    [anon_sym_SLASH_EQ] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2638),
    [anon_sym_PIPE_EQ] = ACTIONS(2638),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2638),
    [anon_sym_AMP_EQ] = ACTIONS(2638),
    [anon_sym_PERCENT_EQ] = ACTIONS(2638),
    [anon_sym_GT_GT_EQ] = ACTIONS(2638),
    [anon_sym_LT_LT_EQ] = ACTIONS(2638),
    [anon_sym_CARET_EQ] = ACTIONS(2638),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_and] = ACTIONS(2638),
    [anon_sym_or] = ACTIONS(2638),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2636),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_EQ] = ACTIONS(2636),
    [anon_sym_GT] = ACTIONS(2636),
    [anon_sym_GT_EQ] = ACTIONS(2638),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_PERCENT] = ACTIONS(2636),
    [anon_sym_EQ_EQ] = ACTIONS(2636),
    [anon_sym_BANG_EQ] = ACTIONS(2638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT_EQ_GT] = ACTIONS(2638),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_BANG_TILDE] = ACTIONS(2638),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2638),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2638),
    [sym__binary_star] = ACTIONS(2638),
    [sym__binary_star_star] = ACTIONS(2638),
    [sym__element_reference_bracket] = ACTIONS(2638),
  },
  [2070] = {
    [sym_heredoc_body] = STATE(2070),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2071] = {
    [sym_heredoc_body] = STATE(2071),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2740),
    [anon_sym_LBRACK2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2072] = {
    [sym_heredoc_body] = STATE(2072),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [aux_sym_program_token1] = ACTIONS(2646),
    [anon_sym___END__] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_end] = ACTIONS(2646),
    [anon_sym_rescue] = ACTIONS(2646),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2646),
    [anon_sym_unless] = ACTIONS(2646),
    [anon_sym_while] = ACTIONS(2646),
    [anon_sym_until] = ACTIONS(2646),
    [anon_sym_in] = ACTIONS(2646),
    [anon_sym_do] = ACTIONS(2646),
    [anon_sym_when] = ACTIONS(2646),
    [anon_sym_EQ_GT] = ACTIONS(2646),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_elsif] = ACTIONS(2646),
    [anon_sym_else] = ACTIONS(2646),
    [anon_sym_then] = ACTIONS(2646),
    [anon_sym_ensure] = ACTIONS(2646),
    [anon_sym_COLON_COLON2] = ACTIONS(2646),
    [anon_sym_AMP_DOT] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
    [anon_sym_STAR_EQ] = ACTIONS(2646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2646),
    [anon_sym_AMP_EQ] = ACTIONS(2646),
    [anon_sym_PERCENT_EQ] = ACTIONS(2646),
    [anon_sym_GT_GT_EQ] = ACTIONS(2646),
    [anon_sym_LT_LT_EQ] = ACTIONS(2646),
    [anon_sym_CARET_EQ] = ACTIONS(2646),
    [anon_sym_QMARK] = ACTIONS(2646),
    [anon_sym_and] = ACTIONS(2646),
    [anon_sym_or] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2644),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2646),
    [anon_sym_LT_EQ_GT] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_BANG_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2646),
    [sym__binary_star] = ACTIONS(2646),
    [sym__binary_star_star] = ACTIONS(2646),
    [sym__element_reference_bracket] = ACTIONS(2646),
  },
  [2073] = {
    [sym__pattern_expr] = STATE(4843),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2073),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_rescue] = ACTIONS(2848),
    [anon_sym_COMMA] = ACTIONS(2376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2848),
    [anon_sym_or] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2940),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2942),
    [sym_float] = ACTIONS(2942),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2940),
  },
  [2074] = {
    [sym_heredoc_body] = STATE(2074),
    [ts_builtin_sym_end] = ACTIONS(2620),
    [aux_sym_program_token1] = ACTIONS(2620),
    [anon_sym___END__] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_RPAREN] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_end] = ACTIONS(2620),
    [anon_sym_rescue] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_PIPE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_AMP] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_unless] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_until] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2618),
    [anon_sym_when] = ACTIONS(2620),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2622),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_elsif] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2620),
    [anon_sym_then] = ACTIONS(2620),
    [anon_sym_ensure] = ACTIONS(2620),
    [anon_sym_COLON_COLON2] = ACTIONS(2620),
    [anon_sym_AMP_DOT] = ACTIONS(2620),
    [anon_sym_PLUS_EQ] = ACTIONS(2620),
    [anon_sym_DASH_EQ] = ACTIONS(2620),
    [anon_sym_STAR_EQ] = ACTIONS(2620),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2620),
    [anon_sym_SLASH_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_PIPE_EQ] = ACTIONS(2620),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2620),
    [anon_sym_AMP_EQ] = ACTIONS(2620),
    [anon_sym_PERCENT_EQ] = ACTIONS(2620),
    [anon_sym_GT_GT_EQ] = ACTIONS(2620),
    [anon_sym_LT_LT_EQ] = ACTIONS(2620),
    [anon_sym_CARET_EQ] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_and] = ACTIONS(2620),
    [anon_sym_or] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2620),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT_EQ_GT] = ACTIONS(2620),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_BANG_TILDE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2620),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2620),
    [sym__binary_star] = ACTIONS(2620),
    [sym__binary_star_star] = ACTIONS(2620),
    [sym__element_reference_bracket] = ACTIONS(2620),
  },
  [2075] = {
    [sym__pattern_expr] = STATE(4840),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2075),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_rescue] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2852),
    [anon_sym_or] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2940),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2942),
    [sym_float] = ACTIONS(2942),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2940),
  },
  [2076] = {
    [sym_heredoc_body] = STATE(2076),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2077] = {
    [sym_heredoc_body] = STATE(2077),
    [ts_builtin_sym_end] = ACTIONS(2626),
    [aux_sym_program_token1] = ACTIONS(2626),
    [anon_sym___END__] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2626),
    [anon_sym_rescue] = ACTIONS(2626),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2626),
    [anon_sym_unless] = ACTIONS(2626),
    [anon_sym_while] = ACTIONS(2626),
    [anon_sym_until] = ACTIONS(2626),
    [anon_sym_in] = ACTIONS(2626),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_when] = ACTIONS(2626),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_elsif] = ACTIONS(2626),
    [anon_sym_else] = ACTIONS(2626),
    [anon_sym_then] = ACTIONS(2626),
    [anon_sym_ensure] = ACTIONS(2626),
    [anon_sym_COLON_COLON2] = ACTIONS(2626),
    [anon_sym_AMP_DOT] = ACTIONS(2626),
    [anon_sym_PLUS_EQ] = ACTIONS(2626),
    [anon_sym_DASH_EQ] = ACTIONS(2626),
    [anon_sym_STAR_EQ] = ACTIONS(2626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2626),
    [anon_sym_SLASH_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_PIPE_EQ] = ACTIONS(2626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2626),
    [anon_sym_AMP_EQ] = ACTIONS(2626),
    [anon_sym_PERCENT_EQ] = ACTIONS(2626),
    [anon_sym_GT_GT_EQ] = ACTIONS(2626),
    [anon_sym_LT_LT_EQ] = ACTIONS(2626),
    [anon_sym_CARET_EQ] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2626),
    [anon_sym_and] = ACTIONS(2626),
    [anon_sym_or] = ACTIONS(2626),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ_GT] = ACTIONS(2626),
    [anon_sym_EQ_TILDE] = ACTIONS(2626),
    [anon_sym_BANG_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2626),
    [sym__binary_star] = ACTIONS(2626),
    [sym__binary_star_star] = ACTIONS(2626),
    [sym__element_reference_bracket] = ACTIONS(2626),
  },
  [2078] = {
    [sym_heredoc_body] = STATE(2078),
    [ts_builtin_sym_end] = ACTIONS(2618),
    [aux_sym_program_token1] = ACTIONS(2618),
    [anon_sym___END__] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2618),
    [anon_sym_rescue] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_unless] = ACTIONS(2618),
    [anon_sym_while] = ACTIONS(2618),
    [anon_sym_until] = ACTIONS(2618),
    [anon_sym_in] = ACTIONS(2618),
    [anon_sym_do] = ACTIONS(2618),
    [anon_sym_when] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_DOT_DOT] = ACTIONS(2616),
    [anon_sym_CARET] = ACTIONS(2616),
    [anon_sym_elsif] = ACTIONS(2618),
    [anon_sym_else] = ACTIONS(2618),
    [anon_sym_then] = ACTIONS(2618),
    [anon_sym_ensure] = ACTIONS(2618),
    [anon_sym_COLON_COLON2] = ACTIONS(2618),
    [anon_sym_AMP_DOT] = ACTIONS(2618),
    [anon_sym_PLUS_EQ] = ACTIONS(2618),
    [anon_sym_DASH_EQ] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(2618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2618),
    [anon_sym_SLASH_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_PIPE_EQ] = ACTIONS(2618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2618),
    [anon_sym_AMP_EQ] = ACTIONS(2618),
    [anon_sym_PERCENT_EQ] = ACTIONS(2618),
    [anon_sym_GT_GT_EQ] = ACTIONS(2618),
    [anon_sym_LT_LT_EQ] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2618),
    [anon_sym_and] = ACTIONS(2618),
    [anon_sym_or] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2616),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_EQ] = ACTIONS(2616),
    [anon_sym_GT] = ACTIONS(2616),
    [anon_sym_GT_EQ] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_SLASH] = ACTIONS(2616),
    [anon_sym_PERCENT] = ACTIONS(2616),
    [anon_sym_EQ_EQ] = ACTIONS(2616),
    [anon_sym_BANG_EQ] = ACTIONS(2618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT_EQ_GT] = ACTIONS(2618),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_BANG_TILDE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2618),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2618),
    [sym__binary_star] = ACTIONS(2618),
    [sym__binary_star_star] = ACTIONS(2618),
    [sym__element_reference_bracket] = ACTIONS(2618),
  },
  [2079] = {
    [sym_heredoc_body] = STATE(2079),
    [ts_builtin_sym_end] = ACTIONS(2634),
    [aux_sym_program_token1] = ACTIONS(2634),
    [anon_sym___END__] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2634),
    [anon_sym_rescue] = ACTIONS(2634),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2634),
    [anon_sym_unless] = ACTIONS(2634),
    [anon_sym_while] = ACTIONS(2634),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_in] = ACTIONS(2634),
    [anon_sym_do] = ACTIONS(2634),
    [anon_sym_when] = ACTIONS(2634),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2632),
    [anon_sym_elsif] = ACTIONS(2634),
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_then] = ACTIONS(2634),
    [anon_sym_ensure] = ACTIONS(2634),
    [anon_sym_COLON_COLON2] = ACTIONS(2634),
    [anon_sym_AMP_DOT] = ACTIONS(2634),
    [anon_sym_PLUS_EQ] = ACTIONS(2634),
    [anon_sym_DASH_EQ] = ACTIONS(2634),
    [anon_sym_STAR_EQ] = ACTIONS(2634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2634),
    [anon_sym_SLASH_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_EQ] = ACTIONS(2634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2634),
    [anon_sym_AMP_EQ] = ACTIONS(2634),
    [anon_sym_PERCENT_EQ] = ACTIONS(2634),
    [anon_sym_GT_GT_EQ] = ACTIONS(2634),
    [anon_sym_LT_LT_EQ] = ACTIONS(2634),
    [anon_sym_CARET_EQ] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2634),
    [anon_sym_and] = ACTIONS(2634),
    [anon_sym_or] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2632),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_EQ] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2632),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2634),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_BANG_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2634),
    [sym__binary_star] = ACTIONS(2634),
    [sym__binary_star_star] = ACTIONS(2634),
    [sym__element_reference_bracket] = ACTIONS(2634),
  },
  [2080] = {
    [sym_heredoc_body] = STATE(2080),
    [ts_builtin_sym_end] = ACTIONS(2998),
    [aux_sym_program_token1] = ACTIONS(2998),
    [anon_sym___END__] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(2998),
    [anon_sym_RPAREN] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(3000),
    [anon_sym_end] = ACTIONS(2998),
    [anon_sym_rescue] = ACTIONS(2998),
    [anon_sym_EQ] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_PIPE] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_LT] = ACTIONS(3000),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_when] = ACTIONS(2998),
    [anon_sym_EQ_GT] = ACTIONS(2998),
    [anon_sym_DOT_DOT] = ACTIONS(3000),
    [anon_sym_CARET] = ACTIONS(3000),
    [anon_sym_elsif] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_then] = ACTIONS(2998),
    [anon_sym_ensure] = ACTIONS(2998),
    [anon_sym_COLON_COLON2] = ACTIONS(2998),
    [anon_sym_AMP_DOT] = ACTIONS(2998),
    [anon_sym_PLUS_EQ] = ACTIONS(2998),
    [anon_sym_DASH_EQ] = ACTIONS(2998),
    [anon_sym_STAR_EQ] = ACTIONS(2998),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2998),
    [anon_sym_SLASH_EQ] = ACTIONS(2998),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2998),
    [anon_sym_PIPE_EQ] = ACTIONS(2998),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2998),
    [anon_sym_AMP_EQ] = ACTIONS(2998),
    [anon_sym_PERCENT_EQ] = ACTIONS(2998),
    [anon_sym_GT_GT_EQ] = ACTIONS(2998),
    [anon_sym_LT_LT_EQ] = ACTIONS(2998),
    [anon_sym_CARET_EQ] = ACTIONS(2998),
    [anon_sym_QMARK] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_or] = ACTIONS(2998),
    [anon_sym_PIPE_PIPE] = ACTIONS(3000),
    [anon_sym_AMP_AMP] = ACTIONS(3000),
    [anon_sym_LT_LT] = ACTIONS(3000),
    [anon_sym_GT_GT] = ACTIONS(3000),
    [anon_sym_LT_EQ] = ACTIONS(3000),
    [anon_sym_GT] = ACTIONS(3000),
    [anon_sym_GT_EQ] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_SLASH] = ACTIONS(3000),
    [anon_sym_PERCENT] = ACTIONS(3000),
    [anon_sym_EQ_EQ] = ACTIONS(3000),
    [anon_sym_BANG_EQ] = ACTIONS(2998),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2998),
    [anon_sym_LT_EQ_GT] = ACTIONS(2998),
    [anon_sym_EQ_TILDE] = ACTIONS(2998),
    [anon_sym_BANG_TILDE] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2998),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2998),
    [sym__binary_star] = ACTIONS(2998),
    [sym__binary_star_star] = ACTIONS(2998),
    [sym__element_reference_bracket] = ACTIONS(2998),
  },
  [2081] = {
    [sym_heredoc_body] = STATE(2081),
    [ts_builtin_sym_end] = ACTIONS(3002),
    [aux_sym_program_token1] = ACTIONS(3002),
    [anon_sym___END__] = ACTIONS(3004),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_end] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_when] = ACTIONS(3002),
    [anon_sym_EQ_GT] = ACTIONS(3002),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_CARET] = ACTIONS(3004),
    [anon_sym_elsif] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_then] = ACTIONS(3002),
    [anon_sym_ensure] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_PLUS_EQ] = ACTIONS(3002),
    [anon_sym_DASH_EQ] = ACTIONS(3002),
    [anon_sym_STAR_EQ] = ACTIONS(3002),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3002),
    [anon_sym_SLASH_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3002),
    [anon_sym_AMP_EQ] = ACTIONS(3002),
    [anon_sym_PERCENT_EQ] = ACTIONS(3002),
    [anon_sym_GT_GT_EQ] = ACTIONS(3002),
    [anon_sym_LT_LT_EQ] = ACTIONS(3002),
    [anon_sym_CARET_EQ] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_LT_LT] = ACTIONS(3004),
    [anon_sym_GT_GT] = ACTIONS(3004),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_PERCENT] = ACTIONS(3004),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3002),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3002),
    [sym__binary_star] = ACTIONS(3002),
    [sym__binary_star_star] = ACTIONS(3002),
    [sym__element_reference_bracket] = ACTIONS(3002),
  },
  [2082] = {
    [sym_heredoc_body] = STATE(2082),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2083] = {
    [sym_heredoc_body] = STATE(2083),
    [ts_builtin_sym_end] = ACTIONS(2964),
    [aux_sym_program_token1] = ACTIONS(2964),
    [anon_sym___END__] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_RPAREN] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_end] = ACTIONS(2964),
    [anon_sym_rescue] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_PIPE] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LT] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_unless] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_until] = ACTIONS(2964),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_when] = ACTIONS(2964),
    [anon_sym_EQ_GT] = ACTIONS(2964),
    [anon_sym_DOT_DOT] = ACTIONS(2966),
    [anon_sym_CARET] = ACTIONS(2966),
    [anon_sym_elsif] = ACTIONS(2964),
    [anon_sym_else] = ACTIONS(2964),
    [anon_sym_then] = ACTIONS(2964),
    [anon_sym_ensure] = ACTIONS(2964),
    [anon_sym_COLON_COLON2] = ACTIONS(2964),
    [anon_sym_AMP_DOT] = ACTIONS(2964),
    [anon_sym_PLUS_EQ] = ACTIONS(2964),
    [anon_sym_DASH_EQ] = ACTIONS(2964),
    [anon_sym_STAR_EQ] = ACTIONS(2964),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2964),
    [anon_sym_SLASH_EQ] = ACTIONS(2964),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2964),
    [anon_sym_PIPE_EQ] = ACTIONS(2964),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2964),
    [anon_sym_AMP_EQ] = ACTIONS(2964),
    [anon_sym_PERCENT_EQ] = ACTIONS(2964),
    [anon_sym_GT_GT_EQ] = ACTIONS(2964),
    [anon_sym_LT_LT_EQ] = ACTIONS(2964),
    [anon_sym_CARET_EQ] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(2964),
    [anon_sym_and] = ACTIONS(2964),
    [anon_sym_or] = ACTIONS(2964),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_LT_LT] = ACTIONS(2966),
    [anon_sym_GT_GT] = ACTIONS(2966),
    [anon_sym_LT_EQ] = ACTIONS(2966),
    [anon_sym_GT] = ACTIONS(2966),
    [anon_sym_GT_EQ] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_SLASH] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_EQ_EQ] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2964),
    [anon_sym_LT_EQ_GT] = ACTIONS(2964),
    [anon_sym_EQ_TILDE] = ACTIONS(2964),
    [anon_sym_BANG_TILDE] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2964),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2964),
    [sym__binary_star] = ACTIONS(2964),
    [sym__binary_star_star] = ACTIONS(2964),
    [sym__element_reference_bracket] = ACTIONS(2964),
  },
  [2084] = {
    [sym_heredoc_body] = STATE(2084),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(2996),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2085] = {
    [sym_heredoc_body] = STATE(2085),
    [ts_builtin_sym_end] = ACTIONS(3006),
    [aux_sym_program_token1] = ACTIONS(3006),
    [anon_sym___END__] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_RPAREN] = ACTIONS(3006),
    [anon_sym_DOT] = ACTIONS(3008),
    [anon_sym_end] = ACTIONS(3006),
    [anon_sym_rescue] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(3008),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_PIPE] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3006),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_LT] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3006),
    [anon_sym_unless] = ACTIONS(3006),
    [anon_sym_while] = ACTIONS(3006),
    [anon_sym_until] = ACTIONS(3006),
    [anon_sym_in] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_when] = ACTIONS(3006),
    [anon_sym_EQ_GT] = ACTIONS(3006),
    [anon_sym_DOT_DOT] = ACTIONS(3008),
    [anon_sym_CARET] = ACTIONS(3008),
    [anon_sym_elsif] = ACTIONS(3006),
    [anon_sym_else] = ACTIONS(3006),
    [anon_sym_then] = ACTIONS(3006),
    [anon_sym_ensure] = ACTIONS(3006),
    [anon_sym_COLON_COLON2] = ACTIONS(3006),
    [anon_sym_AMP_DOT] = ACTIONS(3006),
    [anon_sym_PLUS_EQ] = ACTIONS(3006),
    [anon_sym_DASH_EQ] = ACTIONS(3006),
    [anon_sym_STAR_EQ] = ACTIONS(3006),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3006),
    [anon_sym_SLASH_EQ] = ACTIONS(3006),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3006),
    [anon_sym_PIPE_EQ] = ACTIONS(3006),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3006),
    [anon_sym_AMP_EQ] = ACTIONS(3006),
    [anon_sym_PERCENT_EQ] = ACTIONS(3006),
    [anon_sym_GT_GT_EQ] = ACTIONS(3006),
    [anon_sym_LT_LT_EQ] = ACTIONS(3006),
    [anon_sym_CARET_EQ] = ACTIONS(3006),
    [anon_sym_QMARK] = ACTIONS(3006),
    [anon_sym_and] = ACTIONS(3006),
    [anon_sym_or] = ACTIONS(3006),
    [anon_sym_PIPE_PIPE] = ACTIONS(3008),
    [anon_sym_AMP_AMP] = ACTIONS(3008),
    [anon_sym_LT_LT] = ACTIONS(3008),
    [anon_sym_GT_GT] = ACTIONS(3008),
    [anon_sym_LT_EQ] = ACTIONS(3008),
    [anon_sym_GT] = ACTIONS(3008),
    [anon_sym_GT_EQ] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_PERCENT] = ACTIONS(3008),
    [anon_sym_EQ_EQ] = ACTIONS(3008),
    [anon_sym_BANG_EQ] = ACTIONS(3006),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3006),
    [anon_sym_LT_EQ_GT] = ACTIONS(3006),
    [anon_sym_EQ_TILDE] = ACTIONS(3006),
    [anon_sym_BANG_TILDE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3006),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3006),
    [sym__binary_star] = ACTIONS(3006),
    [sym__binary_star_star] = ACTIONS(3006),
    [sym__element_reference_bracket] = ACTIONS(3006),
  },
  [2086] = {
    [sym_heredoc_body] = STATE(2086),
    [ts_builtin_sym_end] = ACTIONS(3010),
    [aux_sym_program_token1] = ACTIONS(3010),
    [anon_sym___END__] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_RPAREN] = ACTIONS(3010),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_end] = ACTIONS(3010),
    [anon_sym_rescue] = ACTIONS(3010),
    [anon_sym_EQ] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3010),
    [anon_sym_unless] = ACTIONS(3010),
    [anon_sym_while] = ACTIONS(3010),
    [anon_sym_until] = ACTIONS(3010),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_do] = ACTIONS(3010),
    [anon_sym_when] = ACTIONS(3010),
    [anon_sym_EQ_GT] = ACTIONS(3010),
    [anon_sym_DOT_DOT] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3012),
    [anon_sym_elsif] = ACTIONS(3010),
    [anon_sym_else] = ACTIONS(3010),
    [anon_sym_then] = ACTIONS(3010),
    [anon_sym_ensure] = ACTIONS(3010),
    [anon_sym_COLON_COLON2] = ACTIONS(3010),
    [anon_sym_AMP_DOT] = ACTIONS(3010),
    [anon_sym_PLUS_EQ] = ACTIONS(3010),
    [anon_sym_DASH_EQ] = ACTIONS(3010),
    [anon_sym_STAR_EQ] = ACTIONS(3010),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3010),
    [anon_sym_SLASH_EQ] = ACTIONS(3010),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3010),
    [anon_sym_PIPE_EQ] = ACTIONS(3010),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3010),
    [anon_sym_AMP_EQ] = ACTIONS(3010),
    [anon_sym_PERCENT_EQ] = ACTIONS(3010),
    [anon_sym_GT_GT_EQ] = ACTIONS(3010),
    [anon_sym_LT_LT_EQ] = ACTIONS(3010),
    [anon_sym_CARET_EQ] = ACTIONS(3010),
    [anon_sym_QMARK] = ACTIONS(3010),
    [anon_sym_and] = ACTIONS(3010),
    [anon_sym_or] = ACTIONS(3010),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_GT_EQ] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3010),
    [anon_sym_LT_EQ_GT] = ACTIONS(3010),
    [anon_sym_EQ_TILDE] = ACTIONS(3010),
    [anon_sym_BANG_TILDE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3010),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3010),
    [sym__binary_star] = ACTIONS(3010),
    [sym__binary_star_star] = ACTIONS(3010),
    [sym__element_reference_bracket] = ACTIONS(3010),
  },
  [2087] = {
    [sym_heredoc_body] = STATE(2087),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [aux_sym_program_token1] = ACTIONS(3014),
    [anon_sym___END__] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3016),
    [anon_sym_end] = ACTIONS(3014),
    [anon_sym_rescue] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_LT] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_unless] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_until] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_when] = ACTIONS(3014),
    [anon_sym_EQ_GT] = ACTIONS(3014),
    [anon_sym_DOT_DOT] = ACTIONS(3016),
    [anon_sym_CARET] = ACTIONS(3016),
    [anon_sym_elsif] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_then] = ACTIONS(3014),
    [anon_sym_ensure] = ACTIONS(3014),
    [anon_sym_COLON_COLON2] = ACTIONS(3014),
    [anon_sym_AMP_DOT] = ACTIONS(3014),
    [anon_sym_PLUS_EQ] = ACTIONS(3014),
    [anon_sym_DASH_EQ] = ACTIONS(3014),
    [anon_sym_STAR_EQ] = ACTIONS(3014),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3014),
    [anon_sym_SLASH_EQ] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3014),
    [anon_sym_PIPE_EQ] = ACTIONS(3014),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3014),
    [anon_sym_AMP_EQ] = ACTIONS(3014),
    [anon_sym_PERCENT_EQ] = ACTIONS(3014),
    [anon_sym_GT_GT_EQ] = ACTIONS(3014),
    [anon_sym_LT_LT_EQ] = ACTIONS(3014),
    [anon_sym_CARET_EQ] = ACTIONS(3014),
    [anon_sym_QMARK] = ACTIONS(3014),
    [anon_sym_and] = ACTIONS(3014),
    [anon_sym_or] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_LT_LT] = ACTIONS(3016),
    [anon_sym_GT_GT] = ACTIONS(3016),
    [anon_sym_LT_EQ] = ACTIONS(3016),
    [anon_sym_GT] = ACTIONS(3016),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_BANG_EQ] = ACTIONS(3014),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3014),
    [anon_sym_LT_EQ_GT] = ACTIONS(3014),
    [anon_sym_EQ_TILDE] = ACTIONS(3014),
    [anon_sym_BANG_TILDE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3014),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3014),
    [sym__binary_star_star] = ACTIONS(3014),
    [sym__element_reference_bracket] = ACTIONS(3014),
  },
  [2088] = {
    [sym_heredoc_body] = STATE(2088),
    [ts_builtin_sym_end] = ACTIONS(3018),
    [aux_sym_program_token1] = ACTIONS(3018),
    [anon_sym___END__] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_DOT] = ACTIONS(3020),
    [anon_sym_end] = ACTIONS(3018),
    [anon_sym_rescue] = ACTIONS(3018),
    [anon_sym_EQ] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_PIPE] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_unless] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_until] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_when] = ACTIONS(3018),
    [anon_sym_EQ_GT] = ACTIONS(3018),
    [anon_sym_DOT_DOT] = ACTIONS(3020),
    [anon_sym_CARET] = ACTIONS(3020),
    [anon_sym_elsif] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_then] = ACTIONS(3018),
    [anon_sym_ensure] = ACTIONS(3018),
    [anon_sym_COLON_COLON2] = ACTIONS(3018),
    [anon_sym_AMP_DOT] = ACTIONS(3018),
    [anon_sym_PLUS_EQ] = ACTIONS(3018),
    [anon_sym_DASH_EQ] = ACTIONS(3018),
    [anon_sym_STAR_EQ] = ACTIONS(3018),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3018),
    [anon_sym_SLASH_EQ] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3018),
    [anon_sym_PIPE_EQ] = ACTIONS(3018),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3018),
    [anon_sym_AMP_EQ] = ACTIONS(3018),
    [anon_sym_PERCENT_EQ] = ACTIONS(3018),
    [anon_sym_GT_GT_EQ] = ACTIONS(3018),
    [anon_sym_LT_LT_EQ] = ACTIONS(3018),
    [anon_sym_CARET_EQ] = ACTIONS(3018),
    [anon_sym_QMARK] = ACTIONS(3018),
    [anon_sym_and] = ACTIONS(3018),
    [anon_sym_or] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_LT_LT] = ACTIONS(3020),
    [anon_sym_GT_GT] = ACTIONS(3020),
    [anon_sym_LT_EQ] = ACTIONS(3020),
    [anon_sym_GT] = ACTIONS(3020),
    [anon_sym_GT_EQ] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_PERCENT] = ACTIONS(3020),
    [anon_sym_EQ_EQ] = ACTIONS(3020),
    [anon_sym_BANG_EQ] = ACTIONS(3018),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3018),
    [anon_sym_LT_EQ_GT] = ACTIONS(3018),
    [anon_sym_EQ_TILDE] = ACTIONS(3018),
    [anon_sym_BANG_TILDE] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3018),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3018),
    [sym__binary_star] = ACTIONS(3018),
    [sym__binary_star_star] = ACTIONS(3018),
    [sym__element_reference_bracket] = ACTIONS(3018),
  },
  [2089] = {
    [sym_heredoc_body] = STATE(2089),
    [ts_builtin_sym_end] = ACTIONS(3022),
    [aux_sym_program_token1] = ACTIONS(3022),
    [anon_sym___END__] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_RPAREN] = ACTIONS(3022),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_end] = ACTIONS(3022),
    [anon_sym_rescue] = ACTIONS(3022),
    [anon_sym_EQ] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_PIPE] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_LT] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_unless] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_until] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_when] = ACTIONS(3022),
    [anon_sym_EQ_GT] = ACTIONS(3022),
    [anon_sym_DOT_DOT] = ACTIONS(3024),
    [anon_sym_CARET] = ACTIONS(3024),
    [anon_sym_elsif] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_then] = ACTIONS(3022),
    [anon_sym_ensure] = ACTIONS(3022),
    [anon_sym_COLON_COLON2] = ACTIONS(3022),
    [anon_sym_AMP_DOT] = ACTIONS(3022),
    [anon_sym_PLUS_EQ] = ACTIONS(3022),
    [anon_sym_DASH_EQ] = ACTIONS(3022),
    [anon_sym_STAR_EQ] = ACTIONS(3022),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3022),
    [anon_sym_SLASH_EQ] = ACTIONS(3022),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3022),
    [anon_sym_PIPE_EQ] = ACTIONS(3022),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3022),
    [anon_sym_AMP_EQ] = ACTIONS(3022),
    [anon_sym_PERCENT_EQ] = ACTIONS(3022),
    [anon_sym_GT_GT_EQ] = ACTIONS(3022),
    [anon_sym_LT_LT_EQ] = ACTIONS(3022),
    [anon_sym_CARET_EQ] = ACTIONS(3022),
    [anon_sym_QMARK] = ACTIONS(3022),
    [anon_sym_and] = ACTIONS(3022),
    [anon_sym_or] = ACTIONS(3022),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_LT_LT] = ACTIONS(3024),
    [anon_sym_GT_GT] = ACTIONS(3024),
    [anon_sym_LT_EQ] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3024),
    [anon_sym_GT_EQ] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_EQ_EQ] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3022),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3022),
    [anon_sym_LT_EQ_GT] = ACTIONS(3022),
    [anon_sym_EQ_TILDE] = ACTIONS(3022),
    [anon_sym_BANG_TILDE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3022),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3022),
    [sym__binary_star] = ACTIONS(3022),
    [sym__binary_star_star] = ACTIONS(3022),
    [sym__element_reference_bracket] = ACTIONS(3022),
  },
  [2090] = {
    [sym_splat_parameter] = STATE(4954),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5667),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5697),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2090),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(3026),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2091] = {
    [sym_heredoc_body] = STATE(2091),
    [ts_builtin_sym_end] = ACTIONS(3028),
    [aux_sym_program_token1] = ACTIONS(3028),
    [anon_sym___END__] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_RPAREN] = ACTIONS(3028),
    [anon_sym_DOT] = ACTIONS(3030),
    [anon_sym_end] = ACTIONS(3028),
    [anon_sym_rescue] = ACTIONS(3028),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COMMA] = ACTIONS(3028),
    [anon_sym_PIPE] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_unless] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_until] = ACTIONS(3028),
    [anon_sym_in] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_when] = ACTIONS(3028),
    [anon_sym_EQ_GT] = ACTIONS(3028),
    [anon_sym_DOT_DOT] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_elsif] = ACTIONS(3028),
    [anon_sym_else] = ACTIONS(3028),
    [anon_sym_then] = ACTIONS(3028),
    [anon_sym_ensure] = ACTIONS(3028),
    [anon_sym_COLON_COLON2] = ACTIONS(3028),
    [anon_sym_AMP_DOT] = ACTIONS(3028),
    [anon_sym_PLUS_EQ] = ACTIONS(3028),
    [anon_sym_DASH_EQ] = ACTIONS(3028),
    [anon_sym_STAR_EQ] = ACTIONS(3028),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3028),
    [anon_sym_SLASH_EQ] = ACTIONS(3028),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3028),
    [anon_sym_PIPE_EQ] = ACTIONS(3028),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3028),
    [anon_sym_AMP_EQ] = ACTIONS(3028),
    [anon_sym_PERCENT_EQ] = ACTIONS(3028),
    [anon_sym_GT_GT_EQ] = ACTIONS(3028),
    [anon_sym_LT_LT_EQ] = ACTIONS(3028),
    [anon_sym_CARET_EQ] = ACTIONS(3028),
    [anon_sym_QMARK] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3028),
    [anon_sym_or] = ACTIONS(3028),
    [anon_sym_PIPE_PIPE] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3030),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_LT_EQ] = ACTIONS(3030),
    [anon_sym_GT] = ACTIONS(3030),
    [anon_sym_GT_EQ] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3030),
    [anon_sym_BANG_EQ] = ACTIONS(3028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3028),
    [anon_sym_LT_EQ_GT] = ACTIONS(3028),
    [anon_sym_EQ_TILDE] = ACTIONS(3028),
    [anon_sym_BANG_TILDE] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3028),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3028),
    [sym__binary_star] = ACTIONS(3028),
    [sym__binary_star_star] = ACTIONS(3028),
    [sym__element_reference_bracket] = ACTIONS(3028),
  },
  [2092] = {
    [sym_heredoc_body] = STATE(2092),
    [ts_builtin_sym_end] = ACTIONS(3032),
    [aux_sym_program_token1] = ACTIONS(3032),
    [anon_sym___END__] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3034),
    [anon_sym_end] = ACTIONS(3032),
    [anon_sym_rescue] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3034),
    [anon_sym_COMMA] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_LT] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_unless] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_until] = ACTIONS(3032),
    [anon_sym_in] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_when] = ACTIONS(3032),
    [anon_sym_EQ_GT] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3034),
    [anon_sym_CARET] = ACTIONS(3034),
    [anon_sym_elsif] = ACTIONS(3032),
    [anon_sym_else] = ACTIONS(3032),
    [anon_sym_then] = ACTIONS(3032),
    [anon_sym_ensure] = ACTIONS(3032),
    [anon_sym_COLON_COLON2] = ACTIONS(3032),
    [anon_sym_AMP_DOT] = ACTIONS(3032),
    [anon_sym_PLUS_EQ] = ACTIONS(3032),
    [anon_sym_DASH_EQ] = ACTIONS(3032),
    [anon_sym_STAR_EQ] = ACTIONS(3032),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3032),
    [anon_sym_SLASH_EQ] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3032),
    [anon_sym_PIPE_EQ] = ACTIONS(3032),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3032),
    [anon_sym_AMP_EQ] = ACTIONS(3032),
    [anon_sym_PERCENT_EQ] = ACTIONS(3032),
    [anon_sym_GT_GT_EQ] = ACTIONS(3032),
    [anon_sym_LT_LT_EQ] = ACTIONS(3032),
    [anon_sym_CARET_EQ] = ACTIONS(3032),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_and] = ACTIONS(3032),
    [anon_sym_or] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3034),
    [anon_sym_AMP_AMP] = ACTIONS(3034),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_LT_EQ] = ACTIONS(3034),
    [anon_sym_GT] = ACTIONS(3034),
    [anon_sym_GT_EQ] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_SLASH] = ACTIONS(3034),
    [anon_sym_PERCENT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3034),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3032),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3032),
    [sym__binary_star] = ACTIONS(3032),
    [sym__binary_star_star] = ACTIONS(3032),
    [sym__element_reference_bracket] = ACTIONS(3032),
  },
  [2093] = {
    [sym_heredoc_body] = STATE(2093),
    [ts_builtin_sym_end] = ACTIONS(3036),
    [aux_sym_program_token1] = ACTIONS(3036),
    [anon_sym___END__] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_DOT] = ACTIONS(3038),
    [anon_sym_end] = ACTIONS(3036),
    [anon_sym_rescue] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(3038),
    [anon_sym_COMMA] = ACTIONS(3036),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_unless] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_until] = ACTIONS(3036),
    [anon_sym_in] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_when] = ACTIONS(3036),
    [anon_sym_EQ_GT] = ACTIONS(3036),
    [anon_sym_DOT_DOT] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3038),
    [anon_sym_elsif] = ACTIONS(3036),
    [anon_sym_else] = ACTIONS(3036),
    [anon_sym_then] = ACTIONS(3036),
    [anon_sym_ensure] = ACTIONS(3036),
    [anon_sym_COLON_COLON2] = ACTIONS(3036),
    [anon_sym_AMP_DOT] = ACTIONS(3036),
    [anon_sym_PLUS_EQ] = ACTIONS(3036),
    [anon_sym_DASH_EQ] = ACTIONS(3036),
    [anon_sym_STAR_EQ] = ACTIONS(3036),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3036),
    [anon_sym_SLASH_EQ] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3036),
    [anon_sym_PIPE_EQ] = ACTIONS(3036),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3036),
    [anon_sym_AMP_EQ] = ACTIONS(3036),
    [anon_sym_PERCENT_EQ] = ACTIONS(3036),
    [anon_sym_GT_GT_EQ] = ACTIONS(3036),
    [anon_sym_LT_LT_EQ] = ACTIONS(3036),
    [anon_sym_CARET_EQ] = ACTIONS(3036),
    [anon_sym_QMARK] = ACTIONS(3036),
    [anon_sym_and] = ACTIONS(3036),
    [anon_sym_or] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3038),
    [anon_sym_LT_EQ] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_EQ] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_SLASH] = ACTIONS(3038),
    [anon_sym_PERCENT] = ACTIONS(3038),
    [anon_sym_EQ_EQ] = ACTIONS(3038),
    [anon_sym_BANG_EQ] = ACTIONS(3036),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3036),
    [anon_sym_LT_EQ_GT] = ACTIONS(3036),
    [anon_sym_EQ_TILDE] = ACTIONS(3036),
    [anon_sym_BANG_TILDE] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3036),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3036),
    [sym__binary_star] = ACTIONS(3036),
    [sym__binary_star_star] = ACTIONS(3036),
    [sym__element_reference_bracket] = ACTIONS(3036),
  },
  [2094] = {
    [sym_heredoc_body] = STATE(2094),
    [ts_builtin_sym_end] = ACTIONS(3040),
    [aux_sym_program_token1] = ACTIONS(3040),
    [anon_sym___END__] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3042),
    [anon_sym_end] = ACTIONS(3040),
    [anon_sym_rescue] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_unless] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_until] = ACTIONS(3040),
    [anon_sym_in] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_when] = ACTIONS(3040),
    [anon_sym_EQ_GT] = ACTIONS(3040),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_elsif] = ACTIONS(3040),
    [anon_sym_else] = ACTIONS(3040),
    [anon_sym_then] = ACTIONS(3040),
    [anon_sym_ensure] = ACTIONS(3040),
    [anon_sym_COLON_COLON2] = ACTIONS(3040),
    [anon_sym_AMP_DOT] = ACTIONS(3040),
    [anon_sym_PLUS_EQ] = ACTIONS(3040),
    [anon_sym_DASH_EQ] = ACTIONS(3040),
    [anon_sym_STAR_EQ] = ACTIONS(3040),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3040),
    [anon_sym_SLASH_EQ] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3040),
    [anon_sym_PIPE_EQ] = ACTIONS(3040),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3040),
    [anon_sym_AMP_EQ] = ACTIONS(3040),
    [anon_sym_PERCENT_EQ] = ACTIONS(3040),
    [anon_sym_GT_GT_EQ] = ACTIONS(3040),
    [anon_sym_LT_LT_EQ] = ACTIONS(3040),
    [anon_sym_CARET_EQ] = ACTIONS(3040),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_and] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3042),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3040),
    [anon_sym_LT_EQ_GT] = ACTIONS(3040),
    [anon_sym_EQ_TILDE] = ACTIONS(3040),
    [anon_sym_BANG_TILDE] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3040),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3040),
    [sym__binary_star] = ACTIONS(3040),
    [sym__binary_star_star] = ACTIONS(3040),
    [sym__element_reference_bracket] = ACTIONS(3040),
  },
  [2095] = {
    [sym_heredoc_body] = STATE(2095),
    [ts_builtin_sym_end] = ACTIONS(3044),
    [aux_sym_program_token1] = ACTIONS(3044),
    [anon_sym___END__] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_DOT] = ACTIONS(3046),
    [anon_sym_end] = ACTIONS(3044),
    [anon_sym_rescue] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3046),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_PIPE] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_LT] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_unless] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_until] = ACTIONS(3044),
    [anon_sym_in] = ACTIONS(3044),
    [anon_sym_do] = ACTIONS(3044),
    [anon_sym_when] = ACTIONS(3044),
    [anon_sym_EQ_GT] = ACTIONS(3044),
    [anon_sym_DOT_DOT] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3046),
    [anon_sym_elsif] = ACTIONS(3044),
    [anon_sym_else] = ACTIONS(3044),
    [anon_sym_then] = ACTIONS(3044),
    [anon_sym_ensure] = ACTIONS(3044),
    [anon_sym_COLON_COLON2] = ACTIONS(3044),
    [anon_sym_AMP_DOT] = ACTIONS(3044),
    [anon_sym_PLUS_EQ] = ACTIONS(3044),
    [anon_sym_DASH_EQ] = ACTIONS(3044),
    [anon_sym_STAR_EQ] = ACTIONS(3044),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3044),
    [anon_sym_SLASH_EQ] = ACTIONS(3044),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3044),
    [anon_sym_PIPE_EQ] = ACTIONS(3044),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3044),
    [anon_sym_AMP_EQ] = ACTIONS(3044),
    [anon_sym_PERCENT_EQ] = ACTIONS(3044),
    [anon_sym_GT_GT_EQ] = ACTIONS(3044),
    [anon_sym_LT_LT_EQ] = ACTIONS(3044),
    [anon_sym_CARET_EQ] = ACTIONS(3044),
    [anon_sym_QMARK] = ACTIONS(3044),
    [anon_sym_and] = ACTIONS(3044),
    [anon_sym_or] = ACTIONS(3044),
    [anon_sym_PIPE_PIPE] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_LT_LT] = ACTIONS(3046),
    [anon_sym_GT_GT] = ACTIONS(3046),
    [anon_sym_LT_EQ] = ACTIONS(3046),
    [anon_sym_GT] = ACTIONS(3046),
    [anon_sym_GT_EQ] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3046),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [anon_sym_EQ_EQ] = ACTIONS(3046),
    [anon_sym_BANG_EQ] = ACTIONS(3044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3044),
    [anon_sym_LT_EQ_GT] = ACTIONS(3044),
    [anon_sym_EQ_TILDE] = ACTIONS(3044),
    [anon_sym_BANG_TILDE] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3044),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3044),
    [sym__binary_star] = ACTIONS(3044),
    [sym__binary_star_star] = ACTIONS(3044),
    [sym__element_reference_bracket] = ACTIONS(3044),
  },
  [2096] = {
    [sym_heredoc_body] = STATE(2096),
    [ts_builtin_sym_end] = ACTIONS(3048),
    [aux_sym_program_token1] = ACTIONS(3048),
    [anon_sym___END__] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3048),
    [anon_sym_DOT] = ACTIONS(3050),
    [anon_sym_end] = ACTIONS(3048),
    [anon_sym_rescue] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3050),
    [anon_sym_COMMA] = ACTIONS(3048),
    [anon_sym_PIPE] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_LT] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_unless] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_until] = ACTIONS(3048),
    [anon_sym_in] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_when] = ACTIONS(3048),
    [anon_sym_EQ_GT] = ACTIONS(3048),
    [anon_sym_DOT_DOT] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3050),
    [anon_sym_elsif] = ACTIONS(3048),
    [anon_sym_else] = ACTIONS(3048),
    [anon_sym_then] = ACTIONS(3048),
    [anon_sym_ensure] = ACTIONS(3048),
    [anon_sym_COLON_COLON2] = ACTIONS(3048),
    [anon_sym_AMP_DOT] = ACTIONS(3048),
    [anon_sym_PLUS_EQ] = ACTIONS(3048),
    [anon_sym_DASH_EQ] = ACTIONS(3048),
    [anon_sym_STAR_EQ] = ACTIONS(3048),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3048),
    [anon_sym_SLASH_EQ] = ACTIONS(3048),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3048),
    [anon_sym_PIPE_EQ] = ACTIONS(3048),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3048),
    [anon_sym_AMP_EQ] = ACTIONS(3048),
    [anon_sym_PERCENT_EQ] = ACTIONS(3048),
    [anon_sym_GT_GT_EQ] = ACTIONS(3048),
    [anon_sym_LT_LT_EQ] = ACTIONS(3048),
    [anon_sym_CARET_EQ] = ACTIONS(3048),
    [anon_sym_QMARK] = ACTIONS(3048),
    [anon_sym_and] = ACTIONS(3048),
    [anon_sym_or] = ACTIONS(3048),
    [anon_sym_PIPE_PIPE] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_LT_LT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3050),
    [anon_sym_LT_EQ] = ACTIONS(3050),
    [anon_sym_GT] = ACTIONS(3050),
    [anon_sym_GT_EQ] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_SLASH] = ACTIONS(3050),
    [anon_sym_PERCENT] = ACTIONS(3050),
    [anon_sym_EQ_EQ] = ACTIONS(3050),
    [anon_sym_BANG_EQ] = ACTIONS(3048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3048),
    [anon_sym_LT_EQ_GT] = ACTIONS(3048),
    [anon_sym_EQ_TILDE] = ACTIONS(3048),
    [anon_sym_BANG_TILDE] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3048),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3048),
    [sym__binary_star] = ACTIONS(3048),
    [sym__binary_star_star] = ACTIONS(3048),
    [sym__element_reference_bracket] = ACTIONS(3048),
  },
  [2097] = {
    [sym_heredoc_body] = STATE(2097),
    [ts_builtin_sym_end] = ACTIONS(3052),
    [aux_sym_program_token1] = ACTIONS(3052),
    [anon_sym___END__] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3054),
    [anon_sym_end] = ACTIONS(3052),
    [anon_sym_rescue] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3054),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_unless] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_until] = ACTIONS(3052),
    [anon_sym_in] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_when] = ACTIONS(3052),
    [anon_sym_EQ_GT] = ACTIONS(3052),
    [anon_sym_DOT_DOT] = ACTIONS(3054),
    [anon_sym_CARET] = ACTIONS(3054),
    [anon_sym_elsif] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3052),
    [anon_sym_then] = ACTIONS(3052),
    [anon_sym_ensure] = ACTIONS(3052),
    [anon_sym_COLON_COLON2] = ACTIONS(3052),
    [anon_sym_AMP_DOT] = ACTIONS(3052),
    [anon_sym_PLUS_EQ] = ACTIONS(3052),
    [anon_sym_DASH_EQ] = ACTIONS(3052),
    [anon_sym_STAR_EQ] = ACTIONS(3052),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3052),
    [anon_sym_SLASH_EQ] = ACTIONS(3052),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3052),
    [anon_sym_PIPE_EQ] = ACTIONS(3052),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3052),
    [anon_sym_AMP_EQ] = ACTIONS(3052),
    [anon_sym_PERCENT_EQ] = ACTIONS(3052),
    [anon_sym_GT_GT_EQ] = ACTIONS(3052),
    [anon_sym_LT_LT_EQ] = ACTIONS(3052),
    [anon_sym_CARET_EQ] = ACTIONS(3052),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_and] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3052),
    [anon_sym_PIPE_PIPE] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(3054),
    [anon_sym_GT_GT] = ACTIONS(3054),
    [anon_sym_LT_EQ] = ACTIONS(3054),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_SLASH] = ACTIONS(3054),
    [anon_sym_PERCENT] = ACTIONS(3054),
    [anon_sym_EQ_EQ] = ACTIONS(3054),
    [anon_sym_BANG_EQ] = ACTIONS(3052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3052),
    [anon_sym_LT_EQ_GT] = ACTIONS(3052),
    [anon_sym_EQ_TILDE] = ACTIONS(3052),
    [anon_sym_BANG_TILDE] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3052),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3052),
    [sym__binary_star] = ACTIONS(3052),
    [sym__binary_star_star] = ACTIONS(3052),
    [sym__element_reference_bracket] = ACTIONS(3052),
  },
  [2098] = {
    [sym_splat_parameter] = STATE(4954),
    [sym__array_pattern_n] = STATE(5628),
    [sym__pattern_expr] = STATE(5382),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym__array_pattern_body] = STATE(5728),
    [sym_array_pattern] = STATE(4816),
    [sym__find_pattern_body] = STATE(5749),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2098),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2099] = {
    [sym_heredoc_body] = STATE(2099),
    [ts_builtin_sym_end] = ACTIONS(3058),
    [aux_sym_program_token1] = ACTIONS(3058),
    [anon_sym___END__] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_RPAREN] = ACTIONS(3058),
    [anon_sym_DOT] = ACTIONS(3060),
    [anon_sym_end] = ACTIONS(3058),
    [anon_sym_rescue] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3060),
    [anon_sym_COMMA] = ACTIONS(3058),
    [anon_sym_PIPE] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_LT] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_unless] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_until] = ACTIONS(3058),
    [anon_sym_in] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_when] = ACTIONS(3058),
    [anon_sym_EQ_GT] = ACTIONS(3058),
    [anon_sym_DOT_DOT] = ACTIONS(3060),
    [anon_sym_CARET] = ACTIONS(3060),
    [anon_sym_elsif] = ACTIONS(3058),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_then] = ACTIONS(3058),
    [anon_sym_ensure] = ACTIONS(3058),
    [anon_sym_COLON_COLON2] = ACTIONS(3058),
    [anon_sym_AMP_DOT] = ACTIONS(3058),
    [anon_sym_PLUS_EQ] = ACTIONS(3058),
    [anon_sym_DASH_EQ] = ACTIONS(3058),
    [anon_sym_STAR_EQ] = ACTIONS(3058),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3058),
    [anon_sym_SLASH_EQ] = ACTIONS(3058),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3058),
    [anon_sym_PIPE_EQ] = ACTIONS(3058),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3058),
    [anon_sym_AMP_EQ] = ACTIONS(3058),
    [anon_sym_PERCENT_EQ] = ACTIONS(3058),
    [anon_sym_GT_GT_EQ] = ACTIONS(3058),
    [anon_sym_LT_LT_EQ] = ACTIONS(3058),
    [anon_sym_CARET_EQ] = ACTIONS(3058),
    [anon_sym_QMARK] = ACTIONS(3058),
    [anon_sym_and] = ACTIONS(3058),
    [anon_sym_or] = ACTIONS(3058),
    [anon_sym_PIPE_PIPE] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_LT_LT] = ACTIONS(3060),
    [anon_sym_GT_GT] = ACTIONS(3060),
    [anon_sym_LT_EQ] = ACTIONS(3060),
    [anon_sym_GT] = ACTIONS(3060),
    [anon_sym_GT_EQ] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_SLASH] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3060),
    [anon_sym_EQ_EQ] = ACTIONS(3060),
    [anon_sym_BANG_EQ] = ACTIONS(3058),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3058),
    [anon_sym_LT_EQ_GT] = ACTIONS(3058),
    [anon_sym_EQ_TILDE] = ACTIONS(3058),
    [anon_sym_BANG_TILDE] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3058),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3058),
    [sym__binary_star] = ACTIONS(3058),
    [sym__binary_star_star] = ACTIONS(3058),
    [sym__element_reference_bracket] = ACTIONS(3058),
  },
  [2100] = {
    [sym_heredoc_body] = STATE(2100),
    [ts_builtin_sym_end] = ACTIONS(3062),
    [aux_sym_program_token1] = ACTIONS(3062),
    [anon_sym___END__] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [anon_sym_DOT] = ACTIONS(3064),
    [anon_sym_end] = ACTIONS(3062),
    [anon_sym_rescue] = ACTIONS(3062),
    [anon_sym_EQ] = ACTIONS(3064),
    [anon_sym_COMMA] = ACTIONS(3062),
    [anon_sym_PIPE] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3062),
    [anon_sym_unless] = ACTIONS(3062),
    [anon_sym_while] = ACTIONS(3062),
    [anon_sym_until] = ACTIONS(3062),
    [anon_sym_in] = ACTIONS(3062),
    [anon_sym_do] = ACTIONS(3062),
    [anon_sym_when] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(3062),
    [anon_sym_DOT_DOT] = ACTIONS(3064),
    [anon_sym_CARET] = ACTIONS(3064),
    [anon_sym_elsif] = ACTIONS(3062),
    [anon_sym_else] = ACTIONS(3062),
    [anon_sym_then] = ACTIONS(3062),
    [anon_sym_ensure] = ACTIONS(3062),
    [anon_sym_COLON_COLON2] = ACTIONS(3062),
    [anon_sym_AMP_DOT] = ACTIONS(3062),
    [anon_sym_PLUS_EQ] = ACTIONS(3062),
    [anon_sym_DASH_EQ] = ACTIONS(3062),
    [anon_sym_STAR_EQ] = ACTIONS(3062),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3062),
    [anon_sym_SLASH_EQ] = ACTIONS(3062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3062),
    [anon_sym_PIPE_EQ] = ACTIONS(3062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3062),
    [anon_sym_AMP_EQ] = ACTIONS(3062),
    [anon_sym_PERCENT_EQ] = ACTIONS(3062),
    [anon_sym_GT_GT_EQ] = ACTIONS(3062),
    [anon_sym_LT_LT_EQ] = ACTIONS(3062),
    [anon_sym_CARET_EQ] = ACTIONS(3062),
    [anon_sym_QMARK] = ACTIONS(3062),
    [anon_sym_and] = ACTIONS(3062),
    [anon_sym_or] = ACTIONS(3062),
    [anon_sym_PIPE_PIPE] = ACTIONS(3064),
    [anon_sym_AMP_AMP] = ACTIONS(3064),
    [anon_sym_LT_LT] = ACTIONS(3064),
    [anon_sym_GT_GT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(3064),
    [anon_sym_GT] = ACTIONS(3064),
    [anon_sym_GT_EQ] = ACTIONS(3062),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_SLASH] = ACTIONS(3064),
    [anon_sym_PERCENT] = ACTIONS(3064),
    [anon_sym_EQ_EQ] = ACTIONS(3064),
    [anon_sym_BANG_EQ] = ACTIONS(3062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3062),
    [anon_sym_LT_EQ_GT] = ACTIONS(3062),
    [anon_sym_EQ_TILDE] = ACTIONS(3062),
    [anon_sym_BANG_TILDE] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3062),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3062),
    [sym__binary_star] = ACTIONS(3062),
    [sym__binary_star_star] = ACTIONS(3062),
    [sym__element_reference_bracket] = ACTIONS(3062),
  },
  [2101] = {
    [sym_heredoc_body] = STATE(2101),
    [ts_builtin_sym_end] = ACTIONS(3066),
    [aux_sym_program_token1] = ACTIONS(3066),
    [anon_sym___END__] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_DOT] = ACTIONS(3068),
    [anon_sym_end] = ACTIONS(3066),
    [anon_sym_rescue] = ACTIONS(3066),
    [anon_sym_EQ] = ACTIONS(3068),
    [anon_sym_COMMA] = ACTIONS(3066),
    [anon_sym_PIPE] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_unless] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_until] = ACTIONS(3066),
    [anon_sym_in] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_when] = ACTIONS(3066),
    [anon_sym_EQ_GT] = ACTIONS(3066),
    [anon_sym_DOT_DOT] = ACTIONS(3068),
    [anon_sym_CARET] = ACTIONS(3068),
    [anon_sym_elsif] = ACTIONS(3066),
    [anon_sym_else] = ACTIONS(3066),
    [anon_sym_then] = ACTIONS(3066),
    [anon_sym_ensure] = ACTIONS(3066),
    [anon_sym_COLON_COLON2] = ACTIONS(3066),
    [anon_sym_AMP_DOT] = ACTIONS(3066),
    [anon_sym_PLUS_EQ] = ACTIONS(3066),
    [anon_sym_DASH_EQ] = ACTIONS(3066),
    [anon_sym_STAR_EQ] = ACTIONS(3066),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3066),
    [anon_sym_SLASH_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_PIPE_EQ] = ACTIONS(3066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3066),
    [anon_sym_AMP_EQ] = ACTIONS(3066),
    [anon_sym_PERCENT_EQ] = ACTIONS(3066),
    [anon_sym_GT_GT_EQ] = ACTIONS(3066),
    [anon_sym_LT_LT_EQ] = ACTIONS(3066),
    [anon_sym_CARET_EQ] = ACTIONS(3066),
    [anon_sym_QMARK] = ACTIONS(3066),
    [anon_sym_and] = ACTIONS(3066),
    [anon_sym_or] = ACTIONS(3066),
    [anon_sym_PIPE_PIPE] = ACTIONS(3068),
    [anon_sym_AMP_AMP] = ACTIONS(3068),
    [anon_sym_LT_LT] = ACTIONS(3068),
    [anon_sym_GT_GT] = ACTIONS(3068),
    [anon_sym_LT_EQ] = ACTIONS(3068),
    [anon_sym_GT] = ACTIONS(3068),
    [anon_sym_GT_EQ] = ACTIONS(3066),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_SLASH] = ACTIONS(3068),
    [anon_sym_PERCENT] = ACTIONS(3068),
    [anon_sym_EQ_EQ] = ACTIONS(3068),
    [anon_sym_BANG_EQ] = ACTIONS(3066),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3066),
    [anon_sym_LT_EQ_GT] = ACTIONS(3066),
    [anon_sym_EQ_TILDE] = ACTIONS(3066),
    [anon_sym_BANG_TILDE] = ACTIONS(3066),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3066),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3066),
    [sym__binary_star] = ACTIONS(3066),
    [sym__binary_star_star] = ACTIONS(3066),
    [sym__element_reference_bracket] = ACTIONS(3066),
  },
  [2102] = {
    [sym_heredoc_body] = STATE(2102),
    [ts_builtin_sym_end] = ACTIONS(3070),
    [aux_sym_program_token1] = ACTIONS(3070),
    [anon_sym___END__] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_RPAREN] = ACTIONS(3070),
    [anon_sym_DOT] = ACTIONS(3072),
    [anon_sym_end] = ACTIONS(3070),
    [anon_sym_rescue] = ACTIONS(3070),
    [anon_sym_EQ] = ACTIONS(3072),
    [anon_sym_COMMA] = ACTIONS(3070),
    [anon_sym_PIPE] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_LT] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_unless] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_until] = ACTIONS(3070),
    [anon_sym_in] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_when] = ACTIONS(3070),
    [anon_sym_EQ_GT] = ACTIONS(3070),
    [anon_sym_DOT_DOT] = ACTIONS(3072),
    [anon_sym_CARET] = ACTIONS(3072),
    [anon_sym_elsif] = ACTIONS(3070),
    [anon_sym_else] = ACTIONS(3070),
    [anon_sym_then] = ACTIONS(3070),
    [anon_sym_ensure] = ACTIONS(3070),
    [anon_sym_COLON_COLON2] = ACTIONS(3070),
    [anon_sym_AMP_DOT] = ACTIONS(3070),
    [anon_sym_PLUS_EQ] = ACTIONS(3070),
    [anon_sym_DASH_EQ] = ACTIONS(3070),
    [anon_sym_STAR_EQ] = ACTIONS(3070),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3070),
    [anon_sym_SLASH_EQ] = ACTIONS(3070),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3070),
    [anon_sym_PIPE_EQ] = ACTIONS(3070),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3070),
    [anon_sym_AMP_EQ] = ACTIONS(3070),
    [anon_sym_PERCENT_EQ] = ACTIONS(3070),
    [anon_sym_GT_GT_EQ] = ACTIONS(3070),
    [anon_sym_LT_LT_EQ] = ACTIONS(3070),
    [anon_sym_CARET_EQ] = ACTIONS(3070),
    [anon_sym_QMARK] = ACTIONS(3070),
    [anon_sym_and] = ACTIONS(3070),
    [anon_sym_or] = ACTIONS(3070),
    [anon_sym_PIPE_PIPE] = ACTIONS(3072),
    [anon_sym_AMP_AMP] = ACTIONS(3072),
    [anon_sym_LT_LT] = ACTIONS(3072),
    [anon_sym_GT_GT] = ACTIONS(3072),
    [anon_sym_LT_EQ] = ACTIONS(3072),
    [anon_sym_GT] = ACTIONS(3072),
    [anon_sym_GT_EQ] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [anon_sym_EQ_EQ] = ACTIONS(3072),
    [anon_sym_BANG_EQ] = ACTIONS(3070),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3070),
    [anon_sym_LT_EQ_GT] = ACTIONS(3070),
    [anon_sym_EQ_TILDE] = ACTIONS(3070),
    [anon_sym_BANG_TILDE] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3070),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3070),
    [sym__binary_star] = ACTIONS(3070),
    [sym__binary_star_star] = ACTIONS(3070),
    [sym__element_reference_bracket] = ACTIONS(3070),
  },
  [2103] = {
    [sym_heredoc_body] = STATE(2103),
    [ts_builtin_sym_end] = ACTIONS(3074),
    [aux_sym_program_token1] = ACTIONS(3074),
    [anon_sym___END__] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_RPAREN] = ACTIONS(3074),
    [anon_sym_DOT] = ACTIONS(3076),
    [anon_sym_end] = ACTIONS(3074),
    [anon_sym_rescue] = ACTIONS(3074),
    [anon_sym_EQ] = ACTIONS(3076),
    [anon_sym_COMMA] = ACTIONS(3074),
    [anon_sym_PIPE] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_unless] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_until] = ACTIONS(3074),
    [anon_sym_in] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_when] = ACTIONS(3074),
    [anon_sym_EQ_GT] = ACTIONS(3074),
    [anon_sym_DOT_DOT] = ACTIONS(3076),
    [anon_sym_CARET] = ACTIONS(3076),
    [anon_sym_elsif] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_then] = ACTIONS(3074),
    [anon_sym_ensure] = ACTIONS(3074),
    [anon_sym_COLON_COLON2] = ACTIONS(3074),
    [anon_sym_AMP_DOT] = ACTIONS(3074),
    [anon_sym_PLUS_EQ] = ACTIONS(3074),
    [anon_sym_DASH_EQ] = ACTIONS(3074),
    [anon_sym_STAR_EQ] = ACTIONS(3074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3074),
    [anon_sym_SLASH_EQ] = ACTIONS(3074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3074),
    [anon_sym_PIPE_EQ] = ACTIONS(3074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3074),
    [anon_sym_AMP_EQ] = ACTIONS(3074),
    [anon_sym_PERCENT_EQ] = ACTIONS(3074),
    [anon_sym_GT_GT_EQ] = ACTIONS(3074),
    [anon_sym_LT_LT_EQ] = ACTIONS(3074),
    [anon_sym_CARET_EQ] = ACTIONS(3074),
    [anon_sym_QMARK] = ACTIONS(3074),
    [anon_sym_and] = ACTIONS(3074),
    [anon_sym_or] = ACTIONS(3074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3076),
    [anon_sym_AMP_AMP] = ACTIONS(3076),
    [anon_sym_LT_LT] = ACTIONS(3076),
    [anon_sym_GT_GT] = ACTIONS(3076),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3074),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_SLASH] = ACTIONS(3076),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_EQ_EQ] = ACTIONS(3076),
    [anon_sym_BANG_EQ] = ACTIONS(3074),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3074),
    [anon_sym_LT_EQ_GT] = ACTIONS(3074),
    [anon_sym_EQ_TILDE] = ACTIONS(3074),
    [anon_sym_BANG_TILDE] = ACTIONS(3074),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3074),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3074),
    [sym__binary_star] = ACTIONS(3074),
    [sym__binary_star_star] = ACTIONS(3074),
    [sym__element_reference_bracket] = ACTIONS(3074),
  },
  [2104] = {
    [sym_heredoc_body] = STATE(2104),
    [sym_identifier] = ACTIONS(3078),
    [anon_sym_BEGIN] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_END] = ACTIONS(3078),
    [anon_sym_def] = ACTIONS(3078),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_end] = ACTIONS(3078),
    [anon_sym_rescue] = ACTIONS(3078),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_nil] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_module] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_yield] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_next] = ACTIONS(3078),
    [anon_sym_redo] = ACTIONS(3078),
    [anon_sym_retry] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_unless] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_until] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [anon_sym_DOT_DOT] = ACTIONS(3078),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_begin] = ACTIONS(3078),
    [anon_sym_ensure] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3080),
    [anon_sym_defined_QMARK] = ACTIONS(3080),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_undef] = ACTIONS(3078),
    [anon_sym_alias] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3078),
    [sym_float] = ACTIONS(3078),
    [sym_super] = ACTIONS(3078),
    [sym_self] = ACTIONS(3078),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [sym_constant] = ACTIONS(3078),
    [aux_sym_constant_suffix_token1] = ACTIONS(3080),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3078),
    [sym_instance_variable] = ACTIONS(3080),
    [sym_class_variable] = ACTIONS(3080),
    [sym_global_variable] = ACTIONS(3080),
    [sym_character] = ACTIONS(3080),
    [anon_sym_DASH_GT] = ACTIONS(3080),
    [sym__line_break] = ACTIONS(3080),
    [sym_simple_symbol] = ACTIONS(3080),
    [sym__string_start] = ACTIONS(3080),
    [sym__symbol_start] = ACTIONS(3080),
    [sym__subshell_start] = ACTIONS(3080),
    [sym__regex_start] = ACTIONS(3080),
    [sym__string_array_start] = ACTIONS(3080),
    [sym__symbol_array_start] = ACTIONS(3080),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3080),
    [sym__unary_minus] = ACTIONS(3080),
    [sym__unary_minus_num] = ACTIONS(3080),
    [sym__binary_minus] = ACTIONS(3080),
    [sym__identifier_suffix] = ACTIONS(3080),
    [sym__constant_suffix] = ACTIONS(3080),
  },
  [2105] = {
    [sym_heredoc_body] = STATE(2105),
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_def] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_rescue] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_nil] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_next] = ACTIONS(2644),
    [anon_sym_redo] = ACTIONS(2644),
    [anon_sym_retry] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_unless] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_until] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_DOT_DOT] = ACTIONS(2644),
    [anon_sym_begin] = ACTIONS(2644),
    [anon_sym_and] = ACTIONS(2644),
    [anon_sym_or] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2644),
    [sym_float] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [sym_self] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [sym_constant] = ACTIONS(2644),
    [aux_sym_constant_suffix_token1] = ACTIONS(2646),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2644),
    [sym_instance_variable] = ACTIONS(2646),
    [sym_class_variable] = ACTIONS(2646),
    [sym_global_variable] = ACTIONS(2646),
    [sym_character] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_simple_symbol] = ACTIONS(2646),
    [sym__string_start] = ACTIONS(2646),
    [sym__symbol_start] = ACTIONS(2646),
    [sym__subshell_start] = ACTIONS(2646),
    [sym__regex_start] = ACTIONS(2646),
    [sym__string_array_start] = ACTIONS(2646),
    [sym__symbol_array_start] = ACTIONS(2646),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2646),
    [sym__block_ampersand] = ACTIONS(2646),
    [sym__splat_star] = ACTIONS(2646),
    [sym__unary_minus] = ACTIONS(2646),
    [sym__unary_minus_num] = ACTIONS(2646),
    [sym__binary_minus] = ACTIONS(2646),
    [sym_hash_key_symbol] = ACTIONS(2646),
    [sym__identifier_suffix] = ACTIONS(2646),
    [sym__constant_suffix] = ACTIONS(2646),
    [sym__hash_splat_star_star] = ACTIONS(2646),
  },
  [2106] = {
    [sym_heredoc_body] = STATE(2106),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_def] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_rescue] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_nil] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_next] = ACTIONS(2628),
    [anon_sym_redo] = ACTIONS(2628),
    [anon_sym_retry] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_until] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_DOT_DOT] = ACTIONS(2628),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_and] = ACTIONS(2628),
    [anon_sym_or] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_defined_QMARK] = ACTIONS(2630),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2628),
    [sym_float] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_self] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_constant] = ACTIONS(2628),
    [aux_sym_constant_suffix_token1] = ACTIONS(2630),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2628),
    [sym_instance_variable] = ACTIONS(2630),
    [sym_class_variable] = ACTIONS(2630),
    [sym_global_variable] = ACTIONS(2630),
    [sym_character] = ACTIONS(2630),
    [anon_sym_DASH_GT] = ACTIONS(2630),
    [sym_simple_symbol] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__symbol_start] = ACTIONS(2630),
    [sym__subshell_start] = ACTIONS(2630),
    [sym__regex_start] = ACTIONS(2630),
    [sym__string_array_start] = ACTIONS(2630),
    [sym__symbol_array_start] = ACTIONS(2630),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2630),
    [sym__block_ampersand] = ACTIONS(2630),
    [sym__splat_star] = ACTIONS(2630),
    [sym__unary_minus] = ACTIONS(2630),
    [sym__unary_minus_num] = ACTIONS(2630),
    [sym__binary_minus] = ACTIONS(2630),
    [sym_hash_key_symbol] = ACTIONS(2630),
    [sym__identifier_suffix] = ACTIONS(2630),
    [sym__constant_suffix] = ACTIONS(2630),
    [sym__hash_splat_star_star] = ACTIONS(2630),
  },
  [2107] = {
    [sym_heredoc_body] = STATE(2107),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_def] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_rescue] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_nil] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_next] = ACTIONS(2624),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_unless] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_until] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_DOT_DOT] = ACTIONS(2624),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_and] = ACTIONS(2624),
    [anon_sym_or] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_defined_QMARK] = ACTIONS(2626),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2624),
    [sym_float] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_self] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_constant] = ACTIONS(2624),
    [aux_sym_constant_suffix_token1] = ACTIONS(2626),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2624),
    [sym_instance_variable] = ACTIONS(2626),
    [sym_class_variable] = ACTIONS(2626),
    [sym_global_variable] = ACTIONS(2626),
    [sym_character] = ACTIONS(2626),
    [anon_sym_DASH_GT] = ACTIONS(2626),
    [sym_simple_symbol] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__symbol_start] = ACTIONS(2626),
    [sym__subshell_start] = ACTIONS(2626),
    [sym__regex_start] = ACTIONS(2626),
    [sym__string_array_start] = ACTIONS(2626),
    [sym__symbol_array_start] = ACTIONS(2626),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2626),
    [sym__block_ampersand] = ACTIONS(2626),
    [sym__splat_star] = ACTIONS(2626),
    [sym__unary_minus] = ACTIONS(2626),
    [sym__unary_minus_num] = ACTIONS(2626),
    [sym__binary_minus] = ACTIONS(2626),
    [sym_hash_key_symbol] = ACTIONS(2626),
    [sym__identifier_suffix] = ACTIONS(2626),
    [sym__constant_suffix] = ACTIONS(2626),
    [sym__hash_splat_star_star] = ACTIONS(2626),
  },
  [2108] = {
    [sym_heredoc_body] = STATE(2108),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2109] = {
    [sym_heredoc_body] = STATE(2109),
    [sym_identifier] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_def] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2642),
    [anon_sym_RPAREN] = ACTIONS(2642),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_rescue] = ACTIONS(2640),
    [anon_sym_COMMA] = ACTIONS(2642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2642),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_nil] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_next] = ACTIONS(2640),
    [anon_sym_redo] = ACTIONS(2640),
    [anon_sym_retry] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_unless] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_until] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2642),
    [anon_sym_RBRACK] = ACTIONS(2642),
    [anon_sym_DOT_DOT] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2640),
    [anon_sym_and] = ACTIONS(2640),
    [anon_sym_or] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_defined_QMARK] = ACTIONS(2642),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_TILDE] = ACTIONS(2642),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2640),
    [sym_float] = ACTIONS(2640),
    [sym_super] = ACTIONS(2640),
    [sym_self] = ACTIONS(2640),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [sym_constant] = ACTIONS(2640),
    [aux_sym_constant_suffix_token1] = ACTIONS(2642),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2640),
    [sym_instance_variable] = ACTIONS(2642),
    [sym_class_variable] = ACTIONS(2642),
    [sym_global_variable] = ACTIONS(2642),
    [sym_character] = ACTIONS(2642),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [sym_simple_symbol] = ACTIONS(2642),
    [sym__string_start] = ACTIONS(2642),
    [sym__symbol_start] = ACTIONS(2642),
    [sym__subshell_start] = ACTIONS(2642),
    [sym__regex_start] = ACTIONS(2642),
    [sym__string_array_start] = ACTIONS(2642),
    [sym__symbol_array_start] = ACTIONS(2642),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2642),
    [sym__block_ampersand] = ACTIONS(2642),
    [sym__splat_star] = ACTIONS(2642),
    [sym__unary_minus] = ACTIONS(2642),
    [sym__unary_minus_num] = ACTIONS(2642),
    [sym__binary_minus] = ACTIONS(2642),
    [sym_hash_key_symbol] = ACTIONS(2642),
    [sym__identifier_suffix] = ACTIONS(2642),
    [sym__constant_suffix] = ACTIONS(2642),
    [sym__hash_splat_star_star] = ACTIONS(2642),
  },
  [2110] = {
    [sym_heredoc_body] = STATE(2110),
    [sym_identifier] = ACTIONS(3084),
    [anon_sym_BEGIN] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_END] = ACTIONS(3084),
    [anon_sym_def] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3086),
    [anon_sym_end] = ACTIONS(3084),
    [anon_sym_rescue] = ACTIONS(3084),
    [anon_sym_EQ] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_nil] = ACTIONS(3084),
    [anon_sym_class] = ACTIONS(3084),
    [anon_sym_module] = ACTIONS(3084),
    [anon_sym_return] = ACTIONS(3084),
    [anon_sym_yield] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3084),
    [anon_sym_next] = ACTIONS(3084),
    [anon_sym_redo] = ACTIONS(3084),
    [anon_sym_retry] = ACTIONS(3084),
    [anon_sym_if] = ACTIONS(3084),
    [anon_sym_unless] = ACTIONS(3084),
    [anon_sym_while] = ACTIONS(3084),
    [anon_sym_until] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_DOT_DOT] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3084),
    [anon_sym_begin] = ACTIONS(3084),
    [anon_sym_ensure] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_defined_QMARK] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3086),
    [anon_sym_undef] = ACTIONS(3084),
    [anon_sym_alias] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3084),
    [sym_float] = ACTIONS(3084),
    [sym_super] = ACTIONS(3084),
    [sym_self] = ACTIONS(3084),
    [sym_true] = ACTIONS(3084),
    [sym_false] = ACTIONS(3084),
    [sym_constant] = ACTIONS(3084),
    [aux_sym_constant_suffix_token1] = ACTIONS(3086),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3084),
    [sym_instance_variable] = ACTIONS(3086),
    [sym_class_variable] = ACTIONS(3086),
    [sym_global_variable] = ACTIONS(3086),
    [sym_character] = ACTIONS(3086),
    [anon_sym_DASH_GT] = ACTIONS(3086),
    [sym__line_break] = ACTIONS(3086),
    [sym_simple_symbol] = ACTIONS(3086),
    [sym__string_start] = ACTIONS(3086),
    [sym__symbol_start] = ACTIONS(3086),
    [sym__subshell_start] = ACTIONS(3086),
    [sym__regex_start] = ACTIONS(3086),
    [sym__string_array_start] = ACTIONS(3086),
    [sym__symbol_array_start] = ACTIONS(3086),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3086),
    [sym__unary_minus] = ACTIONS(3086),
    [sym__unary_minus_num] = ACTIONS(3086),
    [sym__binary_minus] = ACTIONS(3086),
    [sym__identifier_suffix] = ACTIONS(3086),
    [sym__constant_suffix] = ACTIONS(3086),
  },
  [2111] = {
    [sym_heredoc_body] = STATE(2111),
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_def] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_nil] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_next] = ACTIONS(2948),
    [anon_sym_redo] = ACTIONS(2948),
    [anon_sym_retry] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_unless] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_defined_QMARK] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2948),
    [sym_float] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [sym_self] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [sym_constant] = ACTIONS(2948),
    [aux_sym_constant_suffix_token1] = ACTIONS(2950),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2948),
    [sym_instance_variable] = ACTIONS(2950),
    [sym_class_variable] = ACTIONS(2950),
    [sym_global_variable] = ACTIONS(2950),
    [sym_character] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym_simple_symbol] = ACTIONS(2950),
    [sym__string_start] = ACTIONS(2950),
    [sym__symbol_start] = ACTIONS(2950),
    [sym__subshell_start] = ACTIONS(2950),
    [sym__regex_start] = ACTIONS(2950),
    [sym__string_array_start] = ACTIONS(2950),
    [sym__symbol_array_start] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2950),
    [sym__block_ampersand] = ACTIONS(2950),
    [sym__splat_star] = ACTIONS(2950),
    [sym__unary_minus] = ACTIONS(2950),
    [sym__unary_minus_num] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym_hash_key_symbol] = ACTIONS(2950),
    [sym__identifier_suffix] = ACTIONS(2950),
    [sym__constant_suffix] = ACTIONS(2950),
    [sym__hash_splat_star_star] = ACTIONS(2950),
  },
  [2112] = {
    [sym_heredoc_body] = STATE(2112),
    [sym_identifier] = ACTIONS(3088),
    [anon_sym_BEGIN] = ACTIONS(3088),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_END] = ACTIONS(3088),
    [anon_sym_def] = ACTIONS(3088),
    [anon_sym_LPAREN] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_end] = ACTIONS(3088),
    [anon_sym_rescue] = ACTIONS(3088),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3090),
    [anon_sym_nil] = ACTIONS(3088),
    [anon_sym_class] = ACTIONS(3088),
    [anon_sym_module] = ACTIONS(3088),
    [anon_sym_return] = ACTIONS(3088),
    [anon_sym_yield] = ACTIONS(3088),
    [anon_sym_break] = ACTIONS(3088),
    [anon_sym_next] = ACTIONS(3088),
    [anon_sym_redo] = ACTIONS(3088),
    [anon_sym_retry] = ACTIONS(3088),
    [anon_sym_if] = ACTIONS(3088),
    [anon_sym_unless] = ACTIONS(3088),
    [anon_sym_while] = ACTIONS(3088),
    [anon_sym_until] = ACTIONS(3088),
    [anon_sym_for] = ACTIONS(3088),
    [anon_sym_case] = ACTIONS(3088),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_DOT_DOT] = ACTIONS(3088),
    [anon_sym_else] = ACTIONS(3088),
    [anon_sym_begin] = ACTIONS(3088),
    [anon_sym_ensure] = ACTIONS(3088),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_defined_QMARK] = ACTIONS(3090),
    [anon_sym_not] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3090),
    [anon_sym_undef] = ACTIONS(3088),
    [anon_sym_alias] = ACTIONS(3088),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3088),
    [sym_float] = ACTIONS(3088),
    [sym_super] = ACTIONS(3088),
    [sym_self] = ACTIONS(3088),
    [sym_true] = ACTIONS(3088),
    [sym_false] = ACTIONS(3088),
    [sym_constant] = ACTIONS(3088),
    [aux_sym_constant_suffix_token1] = ACTIONS(3090),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3088),
    [sym_instance_variable] = ACTIONS(3090),
    [sym_class_variable] = ACTIONS(3090),
    [sym_global_variable] = ACTIONS(3090),
    [sym_character] = ACTIONS(3090),
    [anon_sym_DASH_GT] = ACTIONS(3090),
    [sym__line_break] = ACTIONS(3090),
    [sym_simple_symbol] = ACTIONS(3090),
    [sym__string_start] = ACTIONS(3090),
    [sym__symbol_start] = ACTIONS(3090),
    [sym__subshell_start] = ACTIONS(3090),
    [sym__regex_start] = ACTIONS(3090),
    [sym__string_array_start] = ACTIONS(3090),
    [sym__symbol_array_start] = ACTIONS(3090),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3090),
    [sym__unary_minus] = ACTIONS(3090),
    [sym__unary_minus_num] = ACTIONS(3090),
    [sym__binary_minus] = ACTIONS(3090),
    [sym__identifier_suffix] = ACTIONS(3090),
    [sym__constant_suffix] = ACTIONS(3090),
  },
  [2113] = {
    [sym_heredoc_body] = STATE(2113),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_def] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_rescue] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_nil] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_next] = ACTIONS(2632),
    [anon_sym_redo] = ACTIONS(2632),
    [anon_sym_retry] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_unless] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_DOT_DOT] = ACTIONS(2632),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_and] = ACTIONS(2632),
    [anon_sym_or] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_defined_QMARK] = ACTIONS(2634),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2632),
    [sym_float] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_self] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_constant] = ACTIONS(2632),
    [aux_sym_constant_suffix_token1] = ACTIONS(2634),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2632),
    [sym_instance_variable] = ACTIONS(2634),
    [sym_class_variable] = ACTIONS(2634),
    [sym_global_variable] = ACTIONS(2634),
    [sym_character] = ACTIONS(2634),
    [anon_sym_DASH_GT] = ACTIONS(2634),
    [sym_simple_symbol] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__symbol_start] = ACTIONS(2634),
    [sym__subshell_start] = ACTIONS(2634),
    [sym__regex_start] = ACTIONS(2634),
    [sym__string_array_start] = ACTIONS(2634),
    [sym__symbol_array_start] = ACTIONS(2634),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2634),
    [sym__block_ampersand] = ACTIONS(2634),
    [sym__splat_star] = ACTIONS(2634),
    [sym__unary_minus] = ACTIONS(2634),
    [sym__unary_minus_num] = ACTIONS(2634),
    [sym__binary_minus] = ACTIONS(2634),
    [sym_hash_key_symbol] = ACTIONS(2634),
    [sym__identifier_suffix] = ACTIONS(2634),
    [sym__constant_suffix] = ACTIONS(2634),
    [sym__hash_splat_star_star] = ACTIONS(2634),
  },
  [2114] = {
    [sym_heredoc_body] = STATE(2114),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3096),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3098),
    [anon_sym_DASH_EQ] = ACTIONS(3098),
    [anon_sym_STAR_EQ] = ACTIONS(3098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3098),
    [anon_sym_SLASH_EQ] = ACTIONS(3098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3098),
    [anon_sym_PIPE_EQ] = ACTIONS(3098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3098),
    [anon_sym_AMP_EQ] = ACTIONS(3098),
    [anon_sym_PERCENT_EQ] = ACTIONS(3098),
    [anon_sym_GT_GT_EQ] = ACTIONS(3098),
    [anon_sym_LT_LT_EQ] = ACTIONS(3098),
    [anon_sym_CARET_EQ] = ACTIONS(3098),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2115] = {
    [sym_heredoc_body] = STATE(2115),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_BEGIN] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_END] = ACTIONS(3100),
    [anon_sym_def] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_end] = ACTIONS(3100),
    [anon_sym_rescue] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_nil] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_yield] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_next] = ACTIONS(3100),
    [anon_sym_redo] = ACTIONS(3100),
    [anon_sym_retry] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_unless] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_until] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(3100),
    [anon_sym_else] = ACTIONS(3100),
    [anon_sym_begin] = ACTIONS(3100),
    [anon_sym_ensure] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_undef] = ACTIONS(3100),
    [anon_sym_alias] = ACTIONS(3100),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3100),
    [sym_float] = ACTIONS(3100),
    [sym_super] = ACTIONS(3100),
    [sym_self] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_constant] = ACTIONS(3100),
    [aux_sym_constant_suffix_token1] = ACTIONS(3102),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3100),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [sym_character] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
    [sym__line_break] = ACTIONS(3102),
    [sym_simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [sym__unary_minus_num] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__identifier_suffix] = ACTIONS(3102),
    [sym__constant_suffix] = ACTIONS(3102),
  },
  [2116] = {
    [sym_heredoc_body] = STATE(2116),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_BEGIN] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_END] = ACTIONS(3104),
    [anon_sym_def] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3106),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_end] = ACTIONS(3104),
    [anon_sym_rescue] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_nil] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_module] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_yield] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_next] = ACTIONS(3104),
    [anon_sym_redo] = ACTIONS(3104),
    [anon_sym_retry] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3106),
    [anon_sym_DOT_DOT] = ACTIONS(3104),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_begin] = ACTIONS(3104),
    [anon_sym_ensure] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_defined_QMARK] = ACTIONS(3106),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_undef] = ACTIONS(3104),
    [anon_sym_alias] = ACTIONS(3104),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3104),
    [sym_float] = ACTIONS(3104),
    [sym_super] = ACTIONS(3104),
    [sym_self] = ACTIONS(3104),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_constant] = ACTIONS(3104),
    [aux_sym_constant_suffix_token1] = ACTIONS(3106),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3104),
    [sym_instance_variable] = ACTIONS(3106),
    [sym_class_variable] = ACTIONS(3106),
    [sym_global_variable] = ACTIONS(3106),
    [sym_character] = ACTIONS(3106),
    [anon_sym_DASH_GT] = ACTIONS(3106),
    [sym__line_break] = ACTIONS(3106),
    [sym_simple_symbol] = ACTIONS(3106),
    [sym__string_start] = ACTIONS(3106),
    [sym__symbol_start] = ACTIONS(3106),
    [sym__subshell_start] = ACTIONS(3106),
    [sym__regex_start] = ACTIONS(3106),
    [sym__string_array_start] = ACTIONS(3106),
    [sym__symbol_array_start] = ACTIONS(3106),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3106),
    [sym__unary_minus] = ACTIONS(3106),
    [sym__unary_minus_num] = ACTIONS(3106),
    [sym__binary_minus] = ACTIONS(3106),
    [sym__identifier_suffix] = ACTIONS(3106),
    [sym__constant_suffix] = ACTIONS(3106),
  },
  [2117] = {
    [sym_heredoc_body] = STATE(2117),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3108),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3110),
    [anon_sym_DASH_EQ] = ACTIONS(3110),
    [anon_sym_STAR_EQ] = ACTIONS(3110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3110),
    [anon_sym_SLASH_EQ] = ACTIONS(3110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3110),
    [anon_sym_PIPE_EQ] = ACTIONS(3110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3110),
    [anon_sym_AMP_EQ] = ACTIONS(3110),
    [anon_sym_PERCENT_EQ] = ACTIONS(3110),
    [anon_sym_GT_GT_EQ] = ACTIONS(3110),
    [anon_sym_LT_LT_EQ] = ACTIONS(3110),
    [anon_sym_CARET_EQ] = ACTIONS(3110),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2118] = {
    [sym_heredoc_body] = STATE(2118),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3112),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3114),
    [anon_sym_DASH_EQ] = ACTIONS(3114),
    [anon_sym_STAR_EQ] = ACTIONS(3114),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3114),
    [anon_sym_SLASH_EQ] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3114),
    [anon_sym_PIPE_EQ] = ACTIONS(3114),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3114),
    [anon_sym_AMP_EQ] = ACTIONS(3114),
    [anon_sym_PERCENT_EQ] = ACTIONS(3114),
    [anon_sym_GT_GT_EQ] = ACTIONS(3114),
    [anon_sym_LT_LT_EQ] = ACTIONS(3114),
    [anon_sym_CARET_EQ] = ACTIONS(3114),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2119] = {
    [sym_heredoc_body] = STATE(2119),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_BEGIN] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3118),
    [anon_sym_END] = ACTIONS(3116),
    [anon_sym_def] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3118),
    [anon_sym_COLON_COLON] = ACTIONS(3118),
    [anon_sym_end] = ACTIONS(3116),
    [anon_sym_rescue] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3118),
    [anon_sym_STAR] = ACTIONS(3118),
    [anon_sym_nil] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_next] = ACTIONS(3116),
    [anon_sym_redo] = ACTIONS(3116),
    [anon_sym_retry] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_unless] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_until] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_case] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3118),
    [anon_sym_DOT_DOT] = ACTIONS(3116),
    [anon_sym_else] = ACTIONS(3116),
    [anon_sym_begin] = ACTIONS(3116),
    [anon_sym_ensure] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_defined_QMARK] = ACTIONS(3118),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3118),
    [anon_sym_undef] = ACTIONS(3116),
    [anon_sym_alias] = ACTIONS(3116),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3116),
    [sym_float] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_self] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_constant] = ACTIONS(3116),
    [aux_sym_constant_suffix_token1] = ACTIONS(3118),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3116),
    [sym_instance_variable] = ACTIONS(3118),
    [sym_class_variable] = ACTIONS(3118),
    [sym_global_variable] = ACTIONS(3118),
    [sym_character] = ACTIONS(3118),
    [anon_sym_DASH_GT] = ACTIONS(3118),
    [sym__line_break] = ACTIONS(3118),
    [sym_simple_symbol] = ACTIONS(3118),
    [sym__string_start] = ACTIONS(3118),
    [sym__symbol_start] = ACTIONS(3118),
    [sym__subshell_start] = ACTIONS(3118),
    [sym__regex_start] = ACTIONS(3118),
    [sym__string_array_start] = ACTIONS(3118),
    [sym__symbol_array_start] = ACTIONS(3118),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3118),
    [sym__unary_minus] = ACTIONS(3118),
    [sym__unary_minus_num] = ACTIONS(3118),
    [sym__binary_minus] = ACTIONS(3118),
    [sym__identifier_suffix] = ACTIONS(3118),
    [sym__constant_suffix] = ACTIONS(3118),
  },
  [2120] = {
    [sym_heredoc_body] = STATE(2120),
    [sym_identifier] = ACTIONS(3120),
    [anon_sym_BEGIN] = ACTIONS(3120),
    [anon_sym_LBRACE] = ACTIONS(3122),
    [anon_sym_END] = ACTIONS(3120),
    [anon_sym_def] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3122),
    [anon_sym_end] = ACTIONS(3120),
    [anon_sym_rescue] = ACTIONS(3120),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3122),
    [anon_sym_nil] = ACTIONS(3120),
    [anon_sym_class] = ACTIONS(3120),
    [anon_sym_module] = ACTIONS(3120),
    [anon_sym_return] = ACTIONS(3120),
    [anon_sym_yield] = ACTIONS(3120),
    [anon_sym_break] = ACTIONS(3120),
    [anon_sym_next] = ACTIONS(3120),
    [anon_sym_redo] = ACTIONS(3120),
    [anon_sym_retry] = ACTIONS(3120),
    [anon_sym_if] = ACTIONS(3120),
    [anon_sym_unless] = ACTIONS(3120),
    [anon_sym_while] = ACTIONS(3120),
    [anon_sym_until] = ACTIONS(3120),
    [anon_sym_for] = ACTIONS(3120),
    [anon_sym_case] = ACTIONS(3120),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_DOT_DOT] = ACTIONS(3120),
    [anon_sym_else] = ACTIONS(3120),
    [anon_sym_begin] = ACTIONS(3120),
    [anon_sym_ensure] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_defined_QMARK] = ACTIONS(3122),
    [anon_sym_not] = ACTIONS(3120),
    [anon_sym_BANG] = ACTIONS(3122),
    [anon_sym_TILDE] = ACTIONS(3122),
    [anon_sym_undef] = ACTIONS(3120),
    [anon_sym_alias] = ACTIONS(3120),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3120),
    [sym_float] = ACTIONS(3120),
    [sym_super] = ACTIONS(3120),
    [sym_self] = ACTIONS(3120),
    [sym_true] = ACTIONS(3120),
    [sym_false] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3120),
    [aux_sym_constant_suffix_token1] = ACTIONS(3122),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3120),
    [sym_instance_variable] = ACTIONS(3122),
    [sym_class_variable] = ACTIONS(3122),
    [sym_global_variable] = ACTIONS(3122),
    [sym_character] = ACTIONS(3122),
    [anon_sym_DASH_GT] = ACTIONS(3122),
    [sym__line_break] = ACTIONS(3122),
    [sym_simple_symbol] = ACTIONS(3122),
    [sym__string_start] = ACTIONS(3122),
    [sym__symbol_start] = ACTIONS(3122),
    [sym__subshell_start] = ACTIONS(3122),
    [sym__regex_start] = ACTIONS(3122),
    [sym__string_array_start] = ACTIONS(3122),
    [sym__symbol_array_start] = ACTIONS(3122),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3122),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__unary_minus_num] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(3122),
    [sym__identifier_suffix] = ACTIONS(3122),
    [sym__constant_suffix] = ACTIONS(3122),
  },
  [2121] = {
    [sym_heredoc_body] = STATE(2121),
    [sym_identifier] = ACTIONS(3124),
    [anon_sym_BEGIN] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_END] = ACTIONS(3124),
    [anon_sym_def] = ACTIONS(3124),
    [anon_sym_LPAREN] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_end] = ACTIONS(3124),
    [anon_sym_rescue] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_module] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_yield] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_next] = ACTIONS(3124),
    [anon_sym_redo] = ACTIONS(3124),
    [anon_sym_retry] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_unless] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_until] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_DOT_DOT] = ACTIONS(3124),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_begin] = ACTIONS(3124),
    [anon_sym_ensure] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_defined_QMARK] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_undef] = ACTIONS(3124),
    [anon_sym_alias] = ACTIONS(3124),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3124),
    [sym_float] = ACTIONS(3124),
    [sym_super] = ACTIONS(3124),
    [sym_self] = ACTIONS(3124),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [sym_constant] = ACTIONS(3124),
    [aux_sym_constant_suffix_token1] = ACTIONS(3126),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3124),
    [sym_instance_variable] = ACTIONS(3126),
    [sym_class_variable] = ACTIONS(3126),
    [sym_global_variable] = ACTIONS(3126),
    [sym_character] = ACTIONS(3126),
    [anon_sym_DASH_GT] = ACTIONS(3126),
    [sym__line_break] = ACTIONS(3126),
    [sym_simple_symbol] = ACTIONS(3126),
    [sym__string_start] = ACTIONS(3126),
    [sym__symbol_start] = ACTIONS(3126),
    [sym__subshell_start] = ACTIONS(3126),
    [sym__regex_start] = ACTIONS(3126),
    [sym__string_array_start] = ACTIONS(3126),
    [sym__symbol_array_start] = ACTIONS(3126),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3126),
    [sym__unary_minus] = ACTIONS(3126),
    [sym__unary_minus_num] = ACTIONS(3126),
    [sym__binary_minus] = ACTIONS(3126),
    [sym__identifier_suffix] = ACTIONS(3126),
    [sym__constant_suffix] = ACTIONS(3126),
  },
  [2122] = {
    [sym_heredoc_body] = STATE(2122),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_BEGIN] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_END] = ACTIONS(3128),
    [anon_sym_def] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_end] = ACTIONS(3128),
    [anon_sym_rescue] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_nil] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_next] = ACTIONS(3128),
    [anon_sym_redo] = ACTIONS(3128),
    [anon_sym_retry] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_unless] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_until] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_DOT_DOT] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_begin] = ACTIONS(3128),
    [anon_sym_ensure] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3130),
    [anon_sym_defined_QMARK] = ACTIONS(3130),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_undef] = ACTIONS(3128),
    [anon_sym_alias] = ACTIONS(3128),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3128),
    [sym_float] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [sym_self] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_constant] = ACTIONS(3128),
    [aux_sym_constant_suffix_token1] = ACTIONS(3130),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3128),
    [sym_instance_variable] = ACTIONS(3130),
    [sym_class_variable] = ACTIONS(3130),
    [sym_global_variable] = ACTIONS(3130),
    [sym_character] = ACTIONS(3130),
    [anon_sym_DASH_GT] = ACTIONS(3130),
    [sym__line_break] = ACTIONS(3130),
    [sym_simple_symbol] = ACTIONS(3130),
    [sym__string_start] = ACTIONS(3130),
    [sym__symbol_start] = ACTIONS(3130),
    [sym__subshell_start] = ACTIONS(3130),
    [sym__regex_start] = ACTIONS(3130),
    [sym__string_array_start] = ACTIONS(3130),
    [sym__symbol_array_start] = ACTIONS(3130),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3130),
    [sym__unary_minus] = ACTIONS(3130),
    [sym__unary_minus_num] = ACTIONS(3130),
    [sym__binary_minus] = ACTIONS(3130),
    [sym__identifier_suffix] = ACTIONS(3130),
    [sym__constant_suffix] = ACTIONS(3130),
  },
  [2123] = {
    [sym_heredoc_body] = STATE(2123),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_BEGIN] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_END] = ACTIONS(3132),
    [anon_sym_def] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_end] = ACTIONS(3132),
    [anon_sym_rescue] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_nil] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_module] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_yield] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_next] = ACTIONS(3132),
    [anon_sym_redo] = ACTIONS(3132),
    [anon_sym_retry] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_unless] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_until] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_DOT_DOT] = ACTIONS(3132),
    [anon_sym_else] = ACTIONS(3132),
    [anon_sym_begin] = ACTIONS(3132),
    [anon_sym_ensure] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_undef] = ACTIONS(3132),
    [anon_sym_alias] = ACTIONS(3132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3132),
    [sym_float] = ACTIONS(3132),
    [sym_super] = ACTIONS(3132),
    [sym_self] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_constant] = ACTIONS(3132),
    [aux_sym_constant_suffix_token1] = ACTIONS(3134),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3132),
    [sym_instance_variable] = ACTIONS(3134),
    [sym_class_variable] = ACTIONS(3134),
    [sym_global_variable] = ACTIONS(3134),
    [sym_character] = ACTIONS(3134),
    [anon_sym_DASH_GT] = ACTIONS(3134),
    [sym__line_break] = ACTIONS(3134),
    [sym_simple_symbol] = ACTIONS(3134),
    [sym__string_start] = ACTIONS(3134),
    [sym__symbol_start] = ACTIONS(3134),
    [sym__subshell_start] = ACTIONS(3134),
    [sym__regex_start] = ACTIONS(3134),
    [sym__string_array_start] = ACTIONS(3134),
    [sym__symbol_array_start] = ACTIONS(3134),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3134),
    [sym__unary_minus] = ACTIONS(3134),
    [sym__unary_minus_num] = ACTIONS(3134),
    [sym__binary_minus] = ACTIONS(3134),
    [sym__identifier_suffix] = ACTIONS(3134),
    [sym__constant_suffix] = ACTIONS(3134),
  },
  [2124] = {
    [sym_heredoc_body] = STATE(2124),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_BEGIN] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_END] = ACTIONS(3136),
    [anon_sym_def] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3138),
    [anon_sym_end] = ACTIONS(3136),
    [anon_sym_rescue] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3138),
    [anon_sym_nil] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_module] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_yield] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_next] = ACTIONS(3136),
    [anon_sym_redo] = ACTIONS(3136),
    [anon_sym_retry] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_unless] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_until] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_DOT_DOT] = ACTIONS(3136),
    [anon_sym_else] = ACTIONS(3136),
    [anon_sym_begin] = ACTIONS(3136),
    [anon_sym_ensure] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_defined_QMARK] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_undef] = ACTIONS(3136),
    [anon_sym_alias] = ACTIONS(3136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3136),
    [sym_float] = ACTIONS(3136),
    [sym_super] = ACTIONS(3136),
    [sym_self] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_constant] = ACTIONS(3136),
    [aux_sym_constant_suffix_token1] = ACTIONS(3138),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3136),
    [sym_instance_variable] = ACTIONS(3138),
    [sym_class_variable] = ACTIONS(3138),
    [sym_global_variable] = ACTIONS(3138),
    [sym_character] = ACTIONS(3138),
    [anon_sym_DASH_GT] = ACTIONS(3138),
    [sym__line_break] = ACTIONS(3138),
    [sym_simple_symbol] = ACTIONS(3138),
    [sym__string_start] = ACTIONS(3138),
    [sym__symbol_start] = ACTIONS(3138),
    [sym__subshell_start] = ACTIONS(3138),
    [sym__regex_start] = ACTIONS(3138),
    [sym__string_array_start] = ACTIONS(3138),
    [sym__symbol_array_start] = ACTIONS(3138),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3138),
    [sym__unary_minus] = ACTIONS(3138),
    [sym__unary_minus_num] = ACTIONS(3138),
    [sym__binary_minus] = ACTIONS(3138),
    [sym__identifier_suffix] = ACTIONS(3138),
    [sym__constant_suffix] = ACTIONS(3138),
  },
  [2125] = {
    [sym_heredoc_body] = STATE(2125),
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_BEGIN] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_END] = ACTIONS(3140),
    [anon_sym_def] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3142),
    [anon_sym_end] = ACTIONS(3140),
    [anon_sym_rescue] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3142),
    [anon_sym_nil] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_next] = ACTIONS(3140),
    [anon_sym_redo] = ACTIONS(3140),
    [anon_sym_retry] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_unless] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_until] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_case] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_DOT_DOT] = ACTIONS(3140),
    [anon_sym_else] = ACTIONS(3140),
    [anon_sym_begin] = ACTIONS(3140),
    [anon_sym_ensure] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_defined_QMARK] = ACTIONS(3142),
    [anon_sym_not] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_undef] = ACTIONS(3140),
    [anon_sym_alias] = ACTIONS(3140),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3140),
    [sym_float] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [sym_self] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3140),
    [aux_sym_constant_suffix_token1] = ACTIONS(3142),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3140),
    [sym_instance_variable] = ACTIONS(3142),
    [sym_class_variable] = ACTIONS(3142),
    [sym_global_variable] = ACTIONS(3142),
    [sym_character] = ACTIONS(3142),
    [anon_sym_DASH_GT] = ACTIONS(3142),
    [sym__line_break] = ACTIONS(3142),
    [sym_simple_symbol] = ACTIONS(3142),
    [sym__string_start] = ACTIONS(3142),
    [sym__symbol_start] = ACTIONS(3142),
    [sym__subshell_start] = ACTIONS(3142),
    [sym__regex_start] = ACTIONS(3142),
    [sym__string_array_start] = ACTIONS(3142),
    [sym__symbol_array_start] = ACTIONS(3142),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3142),
    [sym__unary_minus] = ACTIONS(3142),
    [sym__unary_minus_num] = ACTIONS(3142),
    [sym__binary_minus] = ACTIONS(3142),
    [sym__identifier_suffix] = ACTIONS(3142),
    [sym__constant_suffix] = ACTIONS(3142),
  },
  [2126] = {
    [sym_heredoc_body] = STATE(2126),
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_BEGIN] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_END] = ACTIONS(3144),
    [anon_sym_def] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_end] = ACTIONS(3144),
    [anon_sym_rescue] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_next] = ACTIONS(3144),
    [anon_sym_redo] = ACTIONS(3144),
    [anon_sym_retry] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_unless] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_until] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_DOT_DOT] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_begin] = ACTIONS(3144),
    [anon_sym_ensure] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_defined_QMARK] = ACTIONS(3146),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_undef] = ACTIONS(3144),
    [anon_sym_alias] = ACTIONS(3144),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3144),
    [sym_float] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [sym_self] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_constant] = ACTIONS(3144),
    [aux_sym_constant_suffix_token1] = ACTIONS(3146),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3144),
    [sym_instance_variable] = ACTIONS(3146),
    [sym_class_variable] = ACTIONS(3146),
    [sym_global_variable] = ACTIONS(3146),
    [sym_character] = ACTIONS(3146),
    [anon_sym_DASH_GT] = ACTIONS(3146),
    [sym__line_break] = ACTIONS(3146),
    [sym_simple_symbol] = ACTIONS(3146),
    [sym__string_start] = ACTIONS(3146),
    [sym__symbol_start] = ACTIONS(3146),
    [sym__subshell_start] = ACTIONS(3146),
    [sym__regex_start] = ACTIONS(3146),
    [sym__string_array_start] = ACTIONS(3146),
    [sym__symbol_array_start] = ACTIONS(3146),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3146),
    [sym__unary_minus] = ACTIONS(3146),
    [sym__unary_minus_num] = ACTIONS(3146),
    [sym__binary_minus] = ACTIONS(3146),
    [sym__identifier_suffix] = ACTIONS(3146),
    [sym__constant_suffix] = ACTIONS(3146),
  },
  [2127] = {
    [sym_heredoc_body] = STATE(2127),
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_BEGIN] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_END] = ACTIONS(3148),
    [anon_sym_def] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_nil] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_module] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_yield] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_next] = ACTIONS(3148),
    [anon_sym_redo] = ACTIONS(3148),
    [anon_sym_retry] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_DOT_DOT] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_begin] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_defined_QMARK] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_undef] = ACTIONS(3148),
    [anon_sym_alias] = ACTIONS(3148),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3148),
    [sym_float] = ACTIONS(3148),
    [sym_super] = ACTIONS(3148),
    [sym_self] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_constant] = ACTIONS(3148),
    [aux_sym_constant_suffix_token1] = ACTIONS(3150),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3148),
    [sym_instance_variable] = ACTIONS(3150),
    [sym_class_variable] = ACTIONS(3150),
    [sym_global_variable] = ACTIONS(3150),
    [sym_character] = ACTIONS(3150),
    [anon_sym_DASH_GT] = ACTIONS(3150),
    [sym__line_break] = ACTIONS(3150),
    [sym_simple_symbol] = ACTIONS(3150),
    [sym__string_start] = ACTIONS(3150),
    [sym__symbol_start] = ACTIONS(3150),
    [sym__subshell_start] = ACTIONS(3150),
    [sym__regex_start] = ACTIONS(3150),
    [sym__string_array_start] = ACTIONS(3150),
    [sym__symbol_array_start] = ACTIONS(3150),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3150),
    [sym__unary_minus] = ACTIONS(3150),
    [sym__unary_minus_num] = ACTIONS(3150),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__identifier_suffix] = ACTIONS(3150),
    [sym__constant_suffix] = ACTIONS(3150),
  },
  [2128] = {
    [sym_heredoc_body] = STATE(2128),
    [sym_identifier] = ACTIONS(2062),
    [anon_sym_BEGIN] = ACTIONS(2062),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_END] = ACTIONS(2062),
    [anon_sym_def] = ACTIONS(2062),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_end] = ACTIONS(2062),
    [anon_sym_rescue] = ACTIONS(2062),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_nil] = ACTIONS(2062),
    [anon_sym_class] = ACTIONS(2062),
    [anon_sym_module] = ACTIONS(2062),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_yield] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2062),
    [anon_sym_next] = ACTIONS(2062),
    [anon_sym_redo] = ACTIONS(2062),
    [anon_sym_retry] = ACTIONS(2062),
    [anon_sym_if] = ACTIONS(2062),
    [anon_sym_unless] = ACTIONS(2062),
    [anon_sym_while] = ACTIONS(2062),
    [anon_sym_until] = ACTIONS(2062),
    [anon_sym_for] = ACTIONS(2062),
    [anon_sym_case] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2062),
    [anon_sym_else] = ACTIONS(2062),
    [anon_sym_begin] = ACTIONS(2062),
    [anon_sym_ensure] = ACTIONS(2062),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_defined_QMARK] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_undef] = ACTIONS(2062),
    [anon_sym_alias] = ACTIONS(2062),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2062),
    [sym_float] = ACTIONS(2062),
    [sym_super] = ACTIONS(2062),
    [sym_self] = ACTIONS(2062),
    [sym_true] = ACTIONS(2062),
    [sym_false] = ACTIONS(2062),
    [sym_constant] = ACTIONS(2062),
    [aux_sym_constant_suffix_token1] = ACTIONS(2962),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2062),
    [sym_instance_variable] = ACTIONS(2962),
    [sym_class_variable] = ACTIONS(2962),
    [sym_global_variable] = ACTIONS(2962),
    [sym_character] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2962),
    [sym_simple_symbol] = ACTIONS(2962),
    [sym__string_start] = ACTIONS(2962),
    [sym__symbol_start] = ACTIONS(2962),
    [sym__subshell_start] = ACTIONS(2962),
    [sym__regex_start] = ACTIONS(2962),
    [sym__string_array_start] = ACTIONS(2962),
    [sym__symbol_array_start] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2962),
    [sym__unary_minus] = ACTIONS(2962),
    [sym__unary_minus_num] = ACTIONS(2962),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__identifier_suffix] = ACTIONS(2962),
    [sym__constant_suffix] = ACTIONS(2962),
  },
  [2129] = {
    [sym_heredoc_body] = STATE(2129),
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_BEGIN] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_END] = ACTIONS(3152),
    [anon_sym_def] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_end] = ACTIONS(3152),
    [anon_sym_rescue] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_nil] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_module] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_yield] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_next] = ACTIONS(3152),
    [anon_sym_redo] = ACTIONS(3152),
    [anon_sym_retry] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_unless] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_until] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_DOT_DOT] = ACTIONS(3152),
    [anon_sym_else] = ACTIONS(3152),
    [anon_sym_begin] = ACTIONS(3152),
    [anon_sym_ensure] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_defined_QMARK] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_undef] = ACTIONS(3152),
    [anon_sym_alias] = ACTIONS(3152),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3152),
    [sym_float] = ACTIONS(3152),
    [sym_super] = ACTIONS(3152),
    [sym_self] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_constant] = ACTIONS(3152),
    [aux_sym_constant_suffix_token1] = ACTIONS(3154),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3152),
    [sym_instance_variable] = ACTIONS(3154),
    [sym_class_variable] = ACTIONS(3154),
    [sym_global_variable] = ACTIONS(3154),
    [sym_character] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3154),
    [sym__line_break] = ACTIONS(3154),
    [sym_simple_symbol] = ACTIONS(3154),
    [sym__string_start] = ACTIONS(3154),
    [sym__symbol_start] = ACTIONS(3154),
    [sym__subshell_start] = ACTIONS(3154),
    [sym__regex_start] = ACTIONS(3154),
    [sym__string_array_start] = ACTIONS(3154),
    [sym__symbol_array_start] = ACTIONS(3154),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3154),
    [sym__unary_minus] = ACTIONS(3154),
    [sym__unary_minus_num] = ACTIONS(3154),
    [sym__binary_minus] = ACTIONS(3154),
    [sym__identifier_suffix] = ACTIONS(3154),
    [sym__constant_suffix] = ACTIONS(3154),
  },
  [2130] = {
    [sym_heredoc_body] = STATE(2130),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3160),
    [anon_sym_DASH_EQ] = ACTIONS(3160),
    [anon_sym_STAR_EQ] = ACTIONS(3160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3160),
    [anon_sym_SLASH_EQ] = ACTIONS(3160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3160),
    [anon_sym_PIPE_EQ] = ACTIONS(3160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3160),
    [anon_sym_AMP_EQ] = ACTIONS(3160),
    [anon_sym_PERCENT_EQ] = ACTIONS(3160),
    [anon_sym_GT_GT_EQ] = ACTIONS(3160),
    [anon_sym_LT_LT_EQ] = ACTIONS(3160),
    [anon_sym_CARET_EQ] = ACTIONS(3160),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2131] = {
    [sym_heredoc_body] = STATE(2131),
    [ts_builtin_sym_end] = ACTIONS(2978),
    [sym_identifier] = ACTIONS(2976),
    [aux_sym_program_token1] = ACTIONS(2978),
    [anon_sym___END__] = ACTIONS(2976),
    [anon_sym_BEGIN] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_END] = ACTIONS(2976),
    [anon_sym_def] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_nil] = ACTIONS(2976),
    [anon_sym_class] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_return] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2976),
    [anon_sym_break] = ACTIONS(2976),
    [anon_sym_next] = ACTIONS(2976),
    [anon_sym_redo] = ACTIONS(2976),
    [anon_sym_retry] = ACTIONS(2976),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_unless] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_until] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_DOT_DOT] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_defined_QMARK] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_undef] = ACTIONS(2976),
    [anon_sym_alias] = ACTIONS(2976),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2976),
    [sym_float] = ACTIONS(2976),
    [sym_super] = ACTIONS(2976),
    [sym_self] = ACTIONS(2976),
    [sym_true] = ACTIONS(2976),
    [sym_false] = ACTIONS(2976),
    [sym_constant] = ACTIONS(2976),
    [aux_sym_constant_suffix_token1] = ACTIONS(2978),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2976),
    [sym_instance_variable] = ACTIONS(2978),
    [sym_class_variable] = ACTIONS(2978),
    [sym_global_variable] = ACTIONS(2978),
    [sym_character] = ACTIONS(2978),
    [anon_sym_DASH_GT] = ACTIONS(2978),
    [sym_simple_symbol] = ACTIONS(2978),
    [sym__string_start] = ACTIONS(2978),
    [sym__symbol_start] = ACTIONS(2978),
    [sym__subshell_start] = ACTIONS(2978),
    [sym__regex_start] = ACTIONS(2978),
    [sym__string_array_start] = ACTIONS(2978),
    [sym__symbol_array_start] = ACTIONS(2978),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2978),
    [sym__unary_minus] = ACTIONS(2978),
    [sym__unary_minus_num] = ACTIONS(2978),
    [sym__binary_minus] = ACTIONS(2978),
    [sym__identifier_suffix] = ACTIONS(2978),
    [sym__constant_suffix] = ACTIONS(2978),
  },
  [2132] = {
    [sym_heredoc_body] = STATE(2132),
    [ts_builtin_sym_end] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1124),
    [aux_sym_program_token1] = ACTIONS(1110),
    [anon_sym___END__] = ACTIONS(1124),
    [anon_sym_BEGIN] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_END] = ACTIONS(1124),
    [anon_sym_def] = ACTIONS(1124),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_COLON_COLON] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_nil] = ACTIONS(1124),
    [anon_sym_class] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_yield] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_next] = ACTIONS(1124),
    [anon_sym_redo] = ACTIONS(1124),
    [anon_sym_retry] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_unless] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_until] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_DOT_DOT] = ACTIONS(1124),
    [anon_sym_begin] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_defined_QMARK] = ACTIONS(1110),
    [anon_sym_not] = ACTIONS(1124),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_undef] = ACTIONS(1124),
    [anon_sym_alias] = ACTIONS(1124),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1124),
    [sym_float] = ACTIONS(1124),
    [sym_super] = ACTIONS(1124),
    [sym_self] = ACTIONS(1124),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_constant] = ACTIONS(1124),
    [aux_sym_constant_suffix_token1] = ACTIONS(1110),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1124),
    [sym_instance_variable] = ACTIONS(1110),
    [sym_class_variable] = ACTIONS(1110),
    [sym_global_variable] = ACTIONS(1110),
    [sym_character] = ACTIONS(1110),
    [anon_sym_DASH_GT] = ACTIONS(1110),
    [sym_simple_symbol] = ACTIONS(1110),
    [sym__string_start] = ACTIONS(1110),
    [sym__symbol_start] = ACTIONS(1110),
    [sym__subshell_start] = ACTIONS(1110),
    [sym__regex_start] = ACTIONS(1110),
    [sym__string_array_start] = ACTIONS(1110),
    [sym__symbol_array_start] = ACTIONS(1110),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1110),
    [sym__unary_minus] = ACTIONS(1110),
    [sym__unary_minus_num] = ACTIONS(1110),
    [sym__binary_minus] = ACTIONS(1110),
    [sym__identifier_suffix] = ACTIONS(1110),
    [sym__constant_suffix] = ACTIONS(1110),
  },
  [2133] = {
    [sym_heredoc_body] = STATE(2133),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3162),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3164),
    [anon_sym_DASH_EQ] = ACTIONS(3164),
    [anon_sym_STAR_EQ] = ACTIONS(3164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3164),
    [anon_sym_SLASH_EQ] = ACTIONS(3164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3164),
    [anon_sym_PIPE_EQ] = ACTIONS(3164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3164),
    [anon_sym_AMP_EQ] = ACTIONS(3164),
    [anon_sym_PERCENT_EQ] = ACTIONS(3164),
    [anon_sym_GT_GT_EQ] = ACTIONS(3164),
    [anon_sym_LT_LT_EQ] = ACTIONS(3164),
    [anon_sym_CARET_EQ] = ACTIONS(3164),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2134] = {
    [sym_splat_parameter] = STATE(4485),
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2134),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2135] = {
    [sym_heredoc_body] = STATE(2135),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3166),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3168),
    [anon_sym_DASH_EQ] = ACTIONS(3168),
    [anon_sym_STAR_EQ] = ACTIONS(3168),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3168),
    [anon_sym_SLASH_EQ] = ACTIONS(3168),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3168),
    [anon_sym_PIPE_EQ] = ACTIONS(3168),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3168),
    [anon_sym_AMP_EQ] = ACTIONS(3168),
    [anon_sym_PERCENT_EQ] = ACTIONS(3168),
    [anon_sym_GT_GT_EQ] = ACTIONS(3168),
    [anon_sym_LT_LT_EQ] = ACTIONS(3168),
    [anon_sym_CARET_EQ] = ACTIONS(3168),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2136] = {
    [sym_splat_parameter] = STATE(4971),
    [sym__pattern_expr] = STATE(4937),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2136),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2137] = {
    [sym_heredoc_body] = STATE(2137),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3170),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3172),
    [anon_sym_DASH_EQ] = ACTIONS(3172),
    [anon_sym_STAR_EQ] = ACTIONS(3172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3172),
    [anon_sym_SLASH_EQ] = ACTIONS(3172),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3172),
    [anon_sym_PIPE_EQ] = ACTIONS(3172),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3172),
    [anon_sym_AMP_EQ] = ACTIONS(3172),
    [anon_sym_PERCENT_EQ] = ACTIONS(3172),
    [anon_sym_GT_GT_EQ] = ACTIONS(3172),
    [anon_sym_LT_LT_EQ] = ACTIONS(3172),
    [anon_sym_CARET_EQ] = ACTIONS(3172),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2138] = {
    [sym_heredoc_body] = STATE(2138),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3174),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3176),
    [anon_sym_DASH_EQ] = ACTIONS(3176),
    [anon_sym_STAR_EQ] = ACTIONS(3176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3176),
    [anon_sym_SLASH_EQ] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3176),
    [anon_sym_PIPE_EQ] = ACTIONS(3176),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3176),
    [anon_sym_AMP_EQ] = ACTIONS(3176),
    [anon_sym_PERCENT_EQ] = ACTIONS(3176),
    [anon_sym_GT_GT_EQ] = ACTIONS(3176),
    [anon_sym_LT_LT_EQ] = ACTIONS(3176),
    [anon_sym_CARET_EQ] = ACTIONS(3176),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2139] = {
    [sym_splat_parameter] = STATE(4485),
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2139),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2910),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2914),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2140] = {
    [sym_heredoc_body] = STATE(2140),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3180),
    [anon_sym_DASH_EQ] = ACTIONS(3180),
    [anon_sym_STAR_EQ] = ACTIONS(3180),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3180),
    [anon_sym_SLASH_EQ] = ACTIONS(3180),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3180),
    [anon_sym_PIPE_EQ] = ACTIONS(3180),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3180),
    [anon_sym_AMP_EQ] = ACTIONS(3180),
    [anon_sym_PERCENT_EQ] = ACTIONS(3180),
    [anon_sym_GT_GT_EQ] = ACTIONS(3180),
    [anon_sym_LT_LT_EQ] = ACTIONS(3180),
    [anon_sym_CARET_EQ] = ACTIONS(3180),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2141] = {
    [sym_splat_parameter] = STATE(4971),
    [sym__pattern_expr] = STATE(4937),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2141),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2940),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2942),
    [sym_float] = ACTIONS(2942),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2940),
  },
  [2142] = {
    [sym_heredoc_body] = STATE(2142),
    [ts_builtin_sym_end] = ACTIONS(2962),
    [sym_identifier] = ACTIONS(2062),
    [aux_sym_program_token1] = ACTIONS(2962),
    [anon_sym___END__] = ACTIONS(2062),
    [anon_sym_BEGIN] = ACTIONS(2062),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_END] = ACTIONS(2062),
    [anon_sym_def] = ACTIONS(2062),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_nil] = ACTIONS(2062),
    [anon_sym_class] = ACTIONS(2062),
    [anon_sym_module] = ACTIONS(2062),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_yield] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2062),
    [anon_sym_next] = ACTIONS(2062),
    [anon_sym_redo] = ACTIONS(2062),
    [anon_sym_retry] = ACTIONS(2062),
    [anon_sym_if] = ACTIONS(2062),
    [anon_sym_unless] = ACTIONS(2062),
    [anon_sym_while] = ACTIONS(2062),
    [anon_sym_until] = ACTIONS(2062),
    [anon_sym_for] = ACTIONS(2062),
    [anon_sym_case] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2062),
    [anon_sym_begin] = ACTIONS(2062),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_defined_QMARK] = ACTIONS(2962),
    [anon_sym_not] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_undef] = ACTIONS(2062),
    [anon_sym_alias] = ACTIONS(2062),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2062),
    [sym_float] = ACTIONS(2062),
    [sym_super] = ACTIONS(2062),
    [sym_self] = ACTIONS(2062),
    [sym_true] = ACTIONS(2062),
    [sym_false] = ACTIONS(2062),
    [sym_constant] = ACTIONS(2062),
    [aux_sym_constant_suffix_token1] = ACTIONS(2962),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2062),
    [sym_instance_variable] = ACTIONS(2962),
    [sym_class_variable] = ACTIONS(2962),
    [sym_global_variable] = ACTIONS(2962),
    [sym_character] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2962),
    [sym_simple_symbol] = ACTIONS(2962),
    [sym__string_start] = ACTIONS(2962),
    [sym__symbol_start] = ACTIONS(2962),
    [sym__subshell_start] = ACTIONS(2962),
    [sym__regex_start] = ACTIONS(2962),
    [sym__string_array_start] = ACTIONS(2962),
    [sym__symbol_array_start] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2962),
    [sym__unary_minus] = ACTIONS(2962),
    [sym__unary_minus_num] = ACTIONS(2962),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__identifier_suffix] = ACTIONS(2962),
    [sym__constant_suffix] = ACTIONS(2962),
  },
  [2143] = {
    [sym_heredoc_body] = STATE(2143),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_end] = ACTIONS(3092),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3182),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_when] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_elsif] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3092),
    [anon_sym_then] = ACTIONS(3092),
    [anon_sym_ensure] = ACTIONS(3092),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3184),
    [anon_sym_DASH_EQ] = ACTIONS(3184),
    [anon_sym_STAR_EQ] = ACTIONS(3184),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3184),
    [anon_sym_SLASH_EQ] = ACTIONS(3184),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3184),
    [anon_sym_PIPE_EQ] = ACTIONS(3184),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3184),
    [anon_sym_AMP_EQ] = ACTIONS(3184),
    [anon_sym_PERCENT_EQ] = ACTIONS(3184),
    [anon_sym_GT_GT_EQ] = ACTIONS(3184),
    [anon_sym_LT_LT_EQ] = ACTIONS(3184),
    [anon_sym_CARET_EQ] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2144] = {
    [sym_splat_parameter] = STATE(4485),
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2144),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2145] = {
    [sym_heredoc_body] = STATE(2145),
    [ts_builtin_sym_end] = ACTIONS(2986),
    [sym_identifier] = ACTIONS(2984),
    [aux_sym_program_token1] = ACTIONS(2986),
    [anon_sym___END__] = ACTIONS(2984),
    [anon_sym_BEGIN] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(2986),
    [anon_sym_END] = ACTIONS(2984),
    [anon_sym_def] = ACTIONS(2984),
    [anon_sym_LPAREN] = ACTIONS(2986),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(2986),
    [anon_sym_nil] = ACTIONS(2984),
    [anon_sym_class] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2984),
    [anon_sym_redo] = ACTIONS(2984),
    [anon_sym_retry] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_unless] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_until] = ACTIONS(2984),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_case] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_DOT_DOT] = ACTIONS(2984),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_defined_QMARK] = ACTIONS(2986),
    [anon_sym_not] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2986),
    [anon_sym_undef] = ACTIONS(2984),
    [anon_sym_alias] = ACTIONS(2984),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2984),
    [sym_float] = ACTIONS(2984),
    [sym_super] = ACTIONS(2984),
    [sym_self] = ACTIONS(2984),
    [sym_true] = ACTIONS(2984),
    [sym_false] = ACTIONS(2984),
    [sym_constant] = ACTIONS(2984),
    [aux_sym_constant_suffix_token1] = ACTIONS(2986),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2984),
    [sym_instance_variable] = ACTIONS(2986),
    [sym_class_variable] = ACTIONS(2986),
    [sym_global_variable] = ACTIONS(2986),
    [sym_character] = ACTIONS(2986),
    [anon_sym_DASH_GT] = ACTIONS(2986),
    [sym_simple_symbol] = ACTIONS(2986),
    [sym__string_start] = ACTIONS(2986),
    [sym__symbol_start] = ACTIONS(2986),
    [sym__subshell_start] = ACTIONS(2986),
    [sym__regex_start] = ACTIONS(2986),
    [sym__string_array_start] = ACTIONS(2986),
    [sym__symbol_array_start] = ACTIONS(2986),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2986),
    [sym__unary_minus] = ACTIONS(2986),
    [sym__unary_minus_num] = ACTIONS(2986),
    [sym__binary_minus] = ACTIONS(2986),
    [sym__identifier_suffix] = ACTIONS(2986),
    [sym__constant_suffix] = ACTIONS(2986),
  },
  [2146] = {
    [sym_heredoc_body] = STATE(2146),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(3186),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2740),
    [anon_sym_LBRACK2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2147] = {
    [sym_heredoc_body] = STATE(2147),
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_BEGIN] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_END] = ACTIONS(3148),
    [anon_sym_def] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_nil] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_module] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_yield] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_next] = ACTIONS(3148),
    [anon_sym_redo] = ACTIONS(3148),
    [anon_sym_retry] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_DOT_DOT] = ACTIONS(3148),
    [anon_sym_begin] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_defined_QMARK] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_undef] = ACTIONS(3148),
    [anon_sym_alias] = ACTIONS(3148),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3148),
    [sym_float] = ACTIONS(3148),
    [sym_super] = ACTIONS(3148),
    [sym_self] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_constant] = ACTIONS(3148),
    [aux_sym_constant_suffix_token1] = ACTIONS(3150),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3148),
    [sym_instance_variable] = ACTIONS(3150),
    [sym_class_variable] = ACTIONS(3150),
    [sym_global_variable] = ACTIONS(3150),
    [sym_character] = ACTIONS(3150),
    [anon_sym_DASH_GT] = ACTIONS(3150),
    [sym_simple_symbol] = ACTIONS(3150),
    [sym__string_start] = ACTIONS(3150),
    [sym__symbol_start] = ACTIONS(3150),
    [sym__subshell_start] = ACTIONS(3150),
    [sym__regex_start] = ACTIONS(3150),
    [sym__string_array_start] = ACTIONS(3150),
    [sym__symbol_array_start] = ACTIONS(3150),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3150),
    [sym__unary_minus] = ACTIONS(3150),
    [sym__unary_minus_num] = ACTIONS(3150),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__identifier_suffix] = ACTIONS(3150),
    [sym__constant_suffix] = ACTIONS(3150),
  },
  [2148] = {
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4591),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4583),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2148),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2910),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2914),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2149] = {
    [sym_heredoc_body] = STATE(2149),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_BEGIN] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_END] = ACTIONS(3132),
    [anon_sym_def] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_nil] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_module] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_yield] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_next] = ACTIONS(3132),
    [anon_sym_redo] = ACTIONS(3132),
    [anon_sym_retry] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_unless] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_until] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_DOT_DOT] = ACTIONS(3132),
    [anon_sym_begin] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_undef] = ACTIONS(3132),
    [anon_sym_alias] = ACTIONS(3132),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3132),
    [sym_float] = ACTIONS(3132),
    [sym_super] = ACTIONS(3132),
    [sym_self] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_constant] = ACTIONS(3132),
    [aux_sym_constant_suffix_token1] = ACTIONS(3134),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3132),
    [sym_instance_variable] = ACTIONS(3134),
    [sym_class_variable] = ACTIONS(3134),
    [sym_global_variable] = ACTIONS(3134),
    [sym_character] = ACTIONS(3134),
    [anon_sym_DASH_GT] = ACTIONS(3134),
    [sym_simple_symbol] = ACTIONS(3134),
    [sym__string_start] = ACTIONS(3134),
    [sym__symbol_start] = ACTIONS(3134),
    [sym__subshell_start] = ACTIONS(3134),
    [sym__regex_start] = ACTIONS(3134),
    [sym__string_array_start] = ACTIONS(3134),
    [sym__symbol_array_start] = ACTIONS(3134),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3134),
    [sym__unary_minus] = ACTIONS(3134),
    [sym__unary_minus_num] = ACTIONS(3134),
    [sym__binary_minus] = ACTIONS(3134),
    [sym__identifier_suffix] = ACTIONS(3134),
    [sym__constant_suffix] = ACTIONS(3134),
  },
  [2150] = {
    [sym_heredoc_body] = STATE(2150),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_BEGIN] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_END] = ACTIONS(3100),
    [anon_sym_def] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_nil] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_yield] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_next] = ACTIONS(3100),
    [anon_sym_redo] = ACTIONS(3100),
    [anon_sym_retry] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_unless] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_until] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(3100),
    [anon_sym_begin] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_undef] = ACTIONS(3100),
    [anon_sym_alias] = ACTIONS(3100),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3100),
    [sym_float] = ACTIONS(3100),
    [sym_super] = ACTIONS(3100),
    [sym_self] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_constant] = ACTIONS(3100),
    [aux_sym_constant_suffix_token1] = ACTIONS(3102),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3100),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [sym_character] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
    [sym_simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [sym__unary_minus_num] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__identifier_suffix] = ACTIONS(3102),
    [sym__constant_suffix] = ACTIONS(3102),
  },
  [2151] = {
    [sym_heredoc_body] = STATE(2151),
    [sym_identifier] = ACTIONS(3120),
    [anon_sym_BEGIN] = ACTIONS(3120),
    [anon_sym_LBRACE] = ACTIONS(3122),
    [anon_sym_RBRACE] = ACTIONS(3122),
    [anon_sym_END] = ACTIONS(3120),
    [anon_sym_def] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3122),
    [anon_sym_nil] = ACTIONS(3120),
    [anon_sym_class] = ACTIONS(3120),
    [anon_sym_module] = ACTIONS(3120),
    [anon_sym_return] = ACTIONS(3120),
    [anon_sym_yield] = ACTIONS(3120),
    [anon_sym_break] = ACTIONS(3120),
    [anon_sym_next] = ACTIONS(3120),
    [anon_sym_redo] = ACTIONS(3120),
    [anon_sym_retry] = ACTIONS(3120),
    [anon_sym_if] = ACTIONS(3120),
    [anon_sym_unless] = ACTIONS(3120),
    [anon_sym_while] = ACTIONS(3120),
    [anon_sym_until] = ACTIONS(3120),
    [anon_sym_for] = ACTIONS(3120),
    [anon_sym_case] = ACTIONS(3120),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_DOT_DOT] = ACTIONS(3120),
    [anon_sym_begin] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_defined_QMARK] = ACTIONS(3122),
    [anon_sym_not] = ACTIONS(3120),
    [anon_sym_BANG] = ACTIONS(3122),
    [anon_sym_TILDE] = ACTIONS(3122),
    [anon_sym_undef] = ACTIONS(3120),
    [anon_sym_alias] = ACTIONS(3120),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3120),
    [sym_float] = ACTIONS(3120),
    [sym_super] = ACTIONS(3120),
    [sym_self] = ACTIONS(3120),
    [sym_true] = ACTIONS(3120),
    [sym_false] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3120),
    [aux_sym_constant_suffix_token1] = ACTIONS(3122),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3120),
    [sym_instance_variable] = ACTIONS(3122),
    [sym_class_variable] = ACTIONS(3122),
    [sym_global_variable] = ACTIONS(3122),
    [sym_character] = ACTIONS(3122),
    [anon_sym_DASH_GT] = ACTIONS(3122),
    [sym_simple_symbol] = ACTIONS(3122),
    [sym__string_start] = ACTIONS(3122),
    [sym__symbol_start] = ACTIONS(3122),
    [sym__subshell_start] = ACTIONS(3122),
    [sym__regex_start] = ACTIONS(3122),
    [sym__string_array_start] = ACTIONS(3122),
    [sym__symbol_array_start] = ACTIONS(3122),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3122),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__unary_minus_num] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(3122),
    [sym__identifier_suffix] = ACTIONS(3122),
    [sym__constant_suffix] = ACTIONS(3122),
  },
  [2152] = {
    [sym_heredoc_body] = STATE(2152),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_BEGIN] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_END] = ACTIONS(3136),
    [anon_sym_def] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3138),
    [anon_sym_nil] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_module] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_yield] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_next] = ACTIONS(3136),
    [anon_sym_redo] = ACTIONS(3136),
    [anon_sym_retry] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_unless] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_until] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_DOT_DOT] = ACTIONS(3136),
    [anon_sym_begin] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_defined_QMARK] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_undef] = ACTIONS(3136),
    [anon_sym_alias] = ACTIONS(3136),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3136),
    [sym_float] = ACTIONS(3136),
    [sym_super] = ACTIONS(3136),
    [sym_self] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_constant] = ACTIONS(3136),
    [aux_sym_constant_suffix_token1] = ACTIONS(3138),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3136),
    [sym_instance_variable] = ACTIONS(3138),
    [sym_class_variable] = ACTIONS(3138),
    [sym_global_variable] = ACTIONS(3138),
    [sym_character] = ACTIONS(3138),
    [anon_sym_DASH_GT] = ACTIONS(3138),
    [sym_simple_symbol] = ACTIONS(3138),
    [sym__string_start] = ACTIONS(3138),
    [sym__symbol_start] = ACTIONS(3138),
    [sym__subshell_start] = ACTIONS(3138),
    [sym__regex_start] = ACTIONS(3138),
    [sym__string_array_start] = ACTIONS(3138),
    [sym__symbol_array_start] = ACTIONS(3138),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3138),
    [sym__unary_minus] = ACTIONS(3138),
    [sym__unary_minus_num] = ACTIONS(3138),
    [sym__binary_minus] = ACTIONS(3138),
    [sym__identifier_suffix] = ACTIONS(3138),
    [sym__constant_suffix] = ACTIONS(3138),
  },
  [2153] = {
    [sym_heredoc_body] = STATE(2153),
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_BEGIN] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_END] = ACTIONS(3140),
    [anon_sym_def] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3142),
    [anon_sym_nil] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_next] = ACTIONS(3140),
    [anon_sym_redo] = ACTIONS(3140),
    [anon_sym_retry] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_unless] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_until] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_case] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_DOT_DOT] = ACTIONS(3140),
    [anon_sym_begin] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_defined_QMARK] = ACTIONS(3142),
    [anon_sym_not] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_undef] = ACTIONS(3140),
    [anon_sym_alias] = ACTIONS(3140),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3140),
    [sym_float] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [sym_self] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3140),
    [aux_sym_constant_suffix_token1] = ACTIONS(3142),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3140),
    [sym_instance_variable] = ACTIONS(3142),
    [sym_class_variable] = ACTIONS(3142),
    [sym_global_variable] = ACTIONS(3142),
    [sym_character] = ACTIONS(3142),
    [anon_sym_DASH_GT] = ACTIONS(3142),
    [sym_simple_symbol] = ACTIONS(3142),
    [sym__string_start] = ACTIONS(3142),
    [sym__symbol_start] = ACTIONS(3142),
    [sym__subshell_start] = ACTIONS(3142),
    [sym__regex_start] = ACTIONS(3142),
    [sym__string_array_start] = ACTIONS(3142),
    [sym__symbol_array_start] = ACTIONS(3142),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3142),
    [sym__unary_minus] = ACTIONS(3142),
    [sym__unary_minus_num] = ACTIONS(3142),
    [sym__binary_minus] = ACTIONS(3142),
    [sym__identifier_suffix] = ACTIONS(3142),
    [sym__constant_suffix] = ACTIONS(3142),
  },
  [2154] = {
    [sym_heredoc_body] = STATE(2154),
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_BEGIN] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_RBRACE] = ACTIONS(3106),
    [anon_sym_END] = ACTIONS(3104),
    [anon_sym_def] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3106),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_nil] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_module] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_yield] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_next] = ACTIONS(3104),
    [anon_sym_redo] = ACTIONS(3104),
    [anon_sym_retry] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_unless] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_until] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3106),
    [anon_sym_DOT_DOT] = ACTIONS(3104),
    [anon_sym_begin] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_defined_QMARK] = ACTIONS(3106),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_undef] = ACTIONS(3104),
    [anon_sym_alias] = ACTIONS(3104),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3104),
    [sym_float] = ACTIONS(3104),
    [sym_super] = ACTIONS(3104),
    [sym_self] = ACTIONS(3104),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [sym_constant] = ACTIONS(3104),
    [aux_sym_constant_suffix_token1] = ACTIONS(3106),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3104),
    [sym_instance_variable] = ACTIONS(3106),
    [sym_class_variable] = ACTIONS(3106),
    [sym_global_variable] = ACTIONS(3106),
    [sym_character] = ACTIONS(3106),
    [anon_sym_DASH_GT] = ACTIONS(3106),
    [sym_simple_symbol] = ACTIONS(3106),
    [sym__string_start] = ACTIONS(3106),
    [sym__symbol_start] = ACTIONS(3106),
    [sym__subshell_start] = ACTIONS(3106),
    [sym__regex_start] = ACTIONS(3106),
    [sym__string_array_start] = ACTIONS(3106),
    [sym__symbol_array_start] = ACTIONS(3106),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3106),
    [sym__unary_minus] = ACTIONS(3106),
    [sym__unary_minus_num] = ACTIONS(3106),
    [sym__binary_minus] = ACTIONS(3106),
    [sym__identifier_suffix] = ACTIONS(3106),
    [sym__constant_suffix] = ACTIONS(3106),
  },
  [2155] = {
    [sym_heredoc_body] = STATE(2155),
    [sym_identifier] = ACTIONS(3124),
    [anon_sym_BEGIN] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_RBRACE] = ACTIONS(3126),
    [anon_sym_END] = ACTIONS(3124),
    [anon_sym_def] = ACTIONS(3124),
    [anon_sym_LPAREN] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(3124),
    [anon_sym_class] = ACTIONS(3124),
    [anon_sym_module] = ACTIONS(3124),
    [anon_sym_return] = ACTIONS(3124),
    [anon_sym_yield] = ACTIONS(3124),
    [anon_sym_break] = ACTIONS(3124),
    [anon_sym_next] = ACTIONS(3124),
    [anon_sym_redo] = ACTIONS(3124),
    [anon_sym_retry] = ACTIONS(3124),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_unless] = ACTIONS(3124),
    [anon_sym_while] = ACTIONS(3124),
    [anon_sym_until] = ACTIONS(3124),
    [anon_sym_for] = ACTIONS(3124),
    [anon_sym_case] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_DOT_DOT] = ACTIONS(3124),
    [anon_sym_begin] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_defined_QMARK] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_TILDE] = ACTIONS(3126),
    [anon_sym_undef] = ACTIONS(3124),
    [anon_sym_alias] = ACTIONS(3124),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3124),
    [sym_float] = ACTIONS(3124),
    [sym_super] = ACTIONS(3124),
    [sym_self] = ACTIONS(3124),
    [sym_true] = ACTIONS(3124),
    [sym_false] = ACTIONS(3124),
    [sym_constant] = ACTIONS(3124),
    [aux_sym_constant_suffix_token1] = ACTIONS(3126),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3124),
    [sym_instance_variable] = ACTIONS(3126),
    [sym_class_variable] = ACTIONS(3126),
    [sym_global_variable] = ACTIONS(3126),
    [sym_character] = ACTIONS(3126),
    [anon_sym_DASH_GT] = ACTIONS(3126),
    [sym_simple_symbol] = ACTIONS(3126),
    [sym__string_start] = ACTIONS(3126),
    [sym__symbol_start] = ACTIONS(3126),
    [sym__subshell_start] = ACTIONS(3126),
    [sym__regex_start] = ACTIONS(3126),
    [sym__string_array_start] = ACTIONS(3126),
    [sym__symbol_array_start] = ACTIONS(3126),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3126),
    [sym__unary_minus] = ACTIONS(3126),
    [sym__unary_minus_num] = ACTIONS(3126),
    [sym__binary_minus] = ACTIONS(3126),
    [sym__identifier_suffix] = ACTIONS(3126),
    [sym__constant_suffix] = ACTIONS(3126),
  },
  [2156] = {
    [sym_heredoc_body] = STATE(2156),
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_BEGIN] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_END] = ACTIONS(3144),
    [anon_sym_def] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_next] = ACTIONS(3144),
    [anon_sym_redo] = ACTIONS(3144),
    [anon_sym_retry] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_unless] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_until] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_DOT_DOT] = ACTIONS(3144),
    [anon_sym_begin] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_defined_QMARK] = ACTIONS(3146),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_undef] = ACTIONS(3144),
    [anon_sym_alias] = ACTIONS(3144),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3144),
    [sym_float] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [sym_self] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_constant] = ACTIONS(3144),
    [aux_sym_constant_suffix_token1] = ACTIONS(3146),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3144),
    [sym_instance_variable] = ACTIONS(3146),
    [sym_class_variable] = ACTIONS(3146),
    [sym_global_variable] = ACTIONS(3146),
    [sym_character] = ACTIONS(3146),
    [anon_sym_DASH_GT] = ACTIONS(3146),
    [sym_simple_symbol] = ACTIONS(3146),
    [sym__string_start] = ACTIONS(3146),
    [sym__symbol_start] = ACTIONS(3146),
    [sym__subshell_start] = ACTIONS(3146),
    [sym__regex_start] = ACTIONS(3146),
    [sym__string_array_start] = ACTIONS(3146),
    [sym__symbol_array_start] = ACTIONS(3146),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3146),
    [sym__unary_minus] = ACTIONS(3146),
    [sym__unary_minus_num] = ACTIONS(3146),
    [sym__binary_minus] = ACTIONS(3146),
    [sym__identifier_suffix] = ACTIONS(3146),
    [sym__constant_suffix] = ACTIONS(3146),
  },
  [2157] = {
    [sym_heredoc_body] = STATE(2157),
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_BEGIN] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_END] = ACTIONS(3152),
    [anon_sym_def] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_nil] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_module] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_yield] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_next] = ACTIONS(3152),
    [anon_sym_redo] = ACTIONS(3152),
    [anon_sym_retry] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_unless] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_until] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_DOT_DOT] = ACTIONS(3152),
    [anon_sym_begin] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_defined_QMARK] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_undef] = ACTIONS(3152),
    [anon_sym_alias] = ACTIONS(3152),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3152),
    [sym_float] = ACTIONS(3152),
    [sym_super] = ACTIONS(3152),
    [sym_self] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_constant] = ACTIONS(3152),
    [aux_sym_constant_suffix_token1] = ACTIONS(3154),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3152),
    [sym_instance_variable] = ACTIONS(3154),
    [sym_class_variable] = ACTIONS(3154),
    [sym_global_variable] = ACTIONS(3154),
    [sym_character] = ACTIONS(3154),
    [anon_sym_DASH_GT] = ACTIONS(3154),
    [sym_simple_symbol] = ACTIONS(3154),
    [sym__string_start] = ACTIONS(3154),
    [sym__symbol_start] = ACTIONS(3154),
    [sym__subshell_start] = ACTIONS(3154),
    [sym__regex_start] = ACTIONS(3154),
    [sym__string_array_start] = ACTIONS(3154),
    [sym__symbol_array_start] = ACTIONS(3154),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3154),
    [sym__unary_minus] = ACTIONS(3154),
    [sym__unary_minus_num] = ACTIONS(3154),
    [sym__binary_minus] = ACTIONS(3154),
    [sym__identifier_suffix] = ACTIONS(3154),
    [sym__constant_suffix] = ACTIONS(3154),
  },
  [2158] = {
    [sym__pattern_expr] = STATE(4937),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2158),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2159] = {
    [sym_heredoc_body] = STATE(2159),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_BEGIN] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3118),
    [anon_sym_RBRACE] = ACTIONS(3118),
    [anon_sym_END] = ACTIONS(3116),
    [anon_sym_def] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3118),
    [anon_sym_COLON_COLON] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3118),
    [anon_sym_STAR] = ACTIONS(3118),
    [anon_sym_nil] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_next] = ACTIONS(3116),
    [anon_sym_redo] = ACTIONS(3116),
    [anon_sym_retry] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_unless] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_until] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_case] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3118),
    [anon_sym_DOT_DOT] = ACTIONS(3116),
    [anon_sym_begin] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_defined_QMARK] = ACTIONS(3118),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3118),
    [anon_sym_undef] = ACTIONS(3116),
    [anon_sym_alias] = ACTIONS(3116),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3116),
    [sym_float] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_self] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_constant] = ACTIONS(3116),
    [aux_sym_constant_suffix_token1] = ACTIONS(3118),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3116),
    [sym_instance_variable] = ACTIONS(3118),
    [sym_class_variable] = ACTIONS(3118),
    [sym_global_variable] = ACTIONS(3118),
    [sym_character] = ACTIONS(3118),
    [anon_sym_DASH_GT] = ACTIONS(3118),
    [sym_simple_symbol] = ACTIONS(3118),
    [sym__string_start] = ACTIONS(3118),
    [sym__symbol_start] = ACTIONS(3118),
    [sym__subshell_start] = ACTIONS(3118),
    [sym__regex_start] = ACTIONS(3118),
    [sym__string_array_start] = ACTIONS(3118),
    [sym__symbol_array_start] = ACTIONS(3118),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3118),
    [sym__unary_minus] = ACTIONS(3118),
    [sym__unary_minus_num] = ACTIONS(3118),
    [sym__binary_minus] = ACTIONS(3118),
    [sym__identifier_suffix] = ACTIONS(3118),
    [sym__constant_suffix] = ACTIONS(3118),
  },
  [2160] = {
    [sym__pattern_expr] = STATE(4937),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4799),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4745),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2160),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2938),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2940),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2942),
    [sym_float] = ACTIONS(2942),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2940),
  },
  [2161] = {
    [sym__pattern_expr] = STATE(5607),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2161),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2162] = {
    [sym__pattern_expr] = STATE(5602),
    [sym_as_pattern] = STATE(4854),
    [sym__pattern_expr_alt] = STATE(4854),
    [sym_alternative_pattern] = STATE(4841),
    [sym_array_pattern] = STATE(4816),
    [sym_find_pattern] = STATE(4816),
    [sym_hash_pattern] = STATE(4816),
    [sym__pattern_expr_basic] = STATE(4817),
    [sym_parenthesized_pattern] = STATE(4816),
    [sym__pattern_value] = STATE(4816),
    [sym__pattern_range] = STATE(4819),
    [sym__pattern_primitive] = STATE(4760),
    [sym__pattern_lambda] = STATE(4691),
    [sym__pattern_literal] = STATE(4691),
    [sym__keyword_variable] = STATE(4738),
    [sym_variable_reference_pattern] = STATE(4831),
    [sym_expression_reference_pattern] = STATE(4831),
    [sym__pattern_constant] = STATE(4658),
    [sym__pattern_constant_resolution] = STATE(4650),
    [sym_unary_literal] = STATE(4697),
    [sym__literal] = STATE(4738),
    [sym__numeric] = STATE(4694),
    [sym__simple_numeric] = STATE(4697),
    [sym__int_or_float] = STATE(5509),
    [sym_complex] = STATE(4698),
    [sym_rational] = STATE(4698),
    [sym_nil] = STATE(4692),
    [sym_string] = STATE(4738),
    [sym_subshell] = STATE(4738),
    [sym_string_array] = STATE(4738),
    [sym_symbol_array] = STATE(4738),
    [sym_delimited_symbol] = STATE(4694),
    [sym_regex] = STATE(4738),
    [sym_heredoc_body] = STATE(2162),
    [sym_lambda] = STATE(4699),
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_COLON_COLON] = ACTIONS(2860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2862),
    [anon_sym_nil] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2874),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2884),
    [sym_simple_symbol] = ACTIONS(2886),
    [sym__string_start] = ACTIONS(2888),
    [sym__symbol_start] = ACTIONS(2890),
    [sym__subshell_start] = ACTIONS(2892),
    [sym__regex_start] = ACTIONS(2894),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2898),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2900),
    [sym__unary_minus_num] = ACTIONS(2874),
  },
  [2163] = {
    [sym_heredoc_body] = STATE(2163),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_BEGIN] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_END] = ACTIONS(3128),
    [anon_sym_def] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_nil] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_next] = ACTIONS(3128),
    [anon_sym_redo] = ACTIONS(3128),
    [anon_sym_retry] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_unless] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_until] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_DOT_DOT] = ACTIONS(3128),
    [anon_sym_begin] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3130),
    [anon_sym_defined_QMARK] = ACTIONS(3130),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_undef] = ACTIONS(3128),
    [anon_sym_alias] = ACTIONS(3128),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3128),
    [sym_float] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [sym_self] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_constant] = ACTIONS(3128),
    [aux_sym_constant_suffix_token1] = ACTIONS(3130),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3128),
    [sym_instance_variable] = ACTIONS(3130),
    [sym_class_variable] = ACTIONS(3130),
    [sym_global_variable] = ACTIONS(3130),
    [sym_character] = ACTIONS(3130),
    [anon_sym_DASH_GT] = ACTIONS(3130),
    [sym_simple_symbol] = ACTIONS(3130),
    [sym__string_start] = ACTIONS(3130),
    [sym__symbol_start] = ACTIONS(3130),
    [sym__subshell_start] = ACTIONS(3130),
    [sym__regex_start] = ACTIONS(3130),
    [sym__string_array_start] = ACTIONS(3130),
    [sym__symbol_array_start] = ACTIONS(3130),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3130),
    [sym__unary_minus] = ACTIONS(3130),
    [sym__unary_minus_num] = ACTIONS(3130),
    [sym__binary_minus] = ACTIONS(3130),
    [sym__identifier_suffix] = ACTIONS(3130),
    [sym__constant_suffix] = ACTIONS(3130),
  },
  [2164] = {
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4713),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4656),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2164),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2928),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2928),
  },
  [2165] = {
    [sym__pattern_expr] = STATE(4463),
    [sym_as_pattern] = STATE(4467),
    [sym__pattern_expr_alt] = STATE(4467),
    [sym_alternative_pattern] = STATE(4461),
    [sym_array_pattern] = STATE(4443),
    [sym_find_pattern] = STATE(4443),
    [sym_hash_pattern] = STATE(4443),
    [sym__pattern_expr_basic] = STATE(4480),
    [sym_parenthesized_pattern] = STATE(4443),
    [sym__pattern_value] = STATE(4443),
    [sym__pattern_range] = STATE(4451),
    [sym__pattern_primitive] = STATE(4468),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_variable_reference_pattern] = STATE(4446),
    [sym_expression_reference_pattern] = STATE(4446),
    [sym__pattern_constant] = STATE(4359),
    [sym__pattern_constant_resolution] = STATE(4368),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2165),
    [sym_lambda] = STATE(4409),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2808),
    [anon_sym_COLON_COLON] = ACTIONS(2810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2814),
    [anon_sym_nil] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_DOT_DOT] = ACTIONS(2822),
    [sym_line] = ACTIONS(1676),
    [sym_file] = ACTIONS(1676),
    [sym_encoding] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(1676),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_constant] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2166] = {
    [sym__pattern_primitive] = STATE(4445),
    [sym__pattern_lambda] = STATE(4414),
    [sym__pattern_literal] = STATE(4414),
    [sym__keyword_variable] = STATE(4399),
    [sym_unary_literal] = STATE(4411),
    [sym__literal] = STATE(4399),
    [sym__numeric] = STATE(4402),
    [sym__simple_numeric] = STATE(4411),
    [sym__int_or_float] = STATE(5540),
    [sym_complex] = STATE(4397),
    [sym_rational] = STATE(4397),
    [sym_nil] = STATE(4401),
    [sym_string] = STATE(4399),
    [sym_subshell] = STATE(4399),
    [sym_string_array] = STATE(4399),
    [sym_symbol_array] = STATE(4399),
    [sym_delimited_symbol] = STATE(4402),
    [sym_regex] = STATE(4399),
    [sym_heredoc_body] = STATE(2166),
    [sym_lambda] = STATE(4409),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_RPAREN] = ACTIONS(3188),
    [anon_sym_end] = ACTIONS(3188),
    [anon_sym_rescue] = ACTIONS(3188),
    [anon_sym_COMMA] = ACTIONS(3188),
    [anon_sym_PIPE] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_nil] = ACTIONS(3190),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_unless] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_until] = ACTIONS(3188),
    [anon_sym_in] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_when] = ACTIONS(3188),
    [anon_sym_EQ_GT] = ACTIONS(3188),
    [sym_line] = ACTIONS(3192),
    [sym_file] = ACTIONS(3192),
    [sym_encoding] = ACTIONS(3192),
    [anon_sym_elsif] = ACTIONS(3188),
    [anon_sym_else] = ACTIONS(3188),
    [anon_sym_then] = ACTIONS(3188),
    [anon_sym_ensure] = ACTIONS(3188),
    [anon_sym_and] = ACTIONS(3188),
    [anon_sym_or] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(2824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2826),
    [sym_float] = ACTIONS(2826),
    [sym_self] = ACTIONS(3192),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [anon_sym_DASH_GT] = ACTIONS(3194),
    [sym__line_break] = ACTIONS(3188),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2824),
  },
  [2167] = {
    [sym_heredoc_body] = STATE(2167),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [ts_builtin_sym_end] = ACTIONS(3092),
    [aux_sym_program_token1] = ACTIONS(3092),
    [anon_sym___END__] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3196),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3198),
    [anon_sym_DASH_EQ] = ACTIONS(3198),
    [anon_sym_STAR_EQ] = ACTIONS(3198),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3198),
    [anon_sym_SLASH_EQ] = ACTIONS(3198),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3198),
    [anon_sym_PIPE_EQ] = ACTIONS(3198),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3198),
    [anon_sym_AMP_EQ] = ACTIONS(3198),
    [anon_sym_PERCENT_EQ] = ACTIONS(3198),
    [anon_sym_GT_GT_EQ] = ACTIONS(3198),
    [anon_sym_LT_LT_EQ] = ACTIONS(3198),
    [anon_sym_CARET_EQ] = ACTIONS(3198),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2168] = {
    [sym_heredoc_body] = STATE(2168),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(3186),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2169] = {
    [sym_heredoc_body] = STATE(2169),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_rescue] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(2740),
    [anon_sym_unless] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_until] = ACTIONS(2740),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2740),
    [anon_sym_LBRACK2] = ACTIONS(2740),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2740),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2170] = {
    [sym_heredoc_body] = STATE(2170),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [ts_builtin_sym_end] = ACTIONS(3092),
    [aux_sym_program_token1] = ACTIONS(3092),
    [anon_sym___END__] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3200),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3202),
    [anon_sym_DASH_EQ] = ACTIONS(3202),
    [anon_sym_STAR_EQ] = ACTIONS(3202),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3202),
    [anon_sym_SLASH_EQ] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3202),
    [anon_sym_PIPE_EQ] = ACTIONS(3202),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3202),
    [anon_sym_AMP_EQ] = ACTIONS(3202),
    [anon_sym_PERCENT_EQ] = ACTIONS(3202),
    [anon_sym_GT_GT_EQ] = ACTIONS(3202),
    [anon_sym_LT_LT_EQ] = ACTIONS(3202),
    [anon_sym_CARET_EQ] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
  [2171] = {
    [sym_heredoc_body] = STATE(2171),
    [aux_sym__mlhs_repeat1] = STATE(5321),
    [ts_builtin_sym_end] = ACTIONS(3092),
    [aux_sym_program_token1] = ACTIONS(3092),
    [anon_sym___END__] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_rescue] = ACTIONS(3092),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_unless] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_until] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3092),
    [anon_sym_do] = ACTIONS(3092),
    [anon_sym_EQ_GT] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_COLON_COLON2] = ACTIONS(3092),
    [anon_sym_AMP_DOT] = ACTIONS(3092),
    [anon_sym_PLUS_EQ] = ACTIONS(3206),
    [anon_sym_DASH_EQ] = ACTIONS(3206),
    [anon_sym_STAR_EQ] = ACTIONS(3206),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3206),
    [anon_sym_SLASH_EQ] = ACTIONS(3206),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3206),
    [anon_sym_PIPE_EQ] = ACTIONS(3206),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3206),
    [anon_sym_AMP_EQ] = ACTIONS(3206),
    [anon_sym_PERCENT_EQ] = ACTIONS(3206),
    [anon_sym_GT_GT_EQ] = ACTIONS(3206),
    [anon_sym_LT_LT_EQ] = ACTIONS(3206),
    [anon_sym_CARET_EQ] = ACTIONS(3206),
    [anon_sym_QMARK] = ACTIONS(3092),
    [anon_sym_and] = ACTIONS(3092),
    [anon_sym_or] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_LT_LT] = ACTIONS(3094),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_LT_EQ] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3094),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_LT_EQ_GT] = ACTIONS(3092),
    [anon_sym_EQ_TILDE] = ACTIONS(3092),
    [anon_sym_BANG_TILDE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(3092),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(3092),
    [sym__binary_star] = ACTIONS(3092),
    [sym__binary_star_star] = ACTIONS(3092),
    [sym__element_reference_bracket] = ACTIONS(3092),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2172), 1,
      sym_heredoc_body,
    STATE(2839), 1,
      sym_argument_list,
    STATE(3050), 1,
      sym_do_block,
    STATE(3051), 1,
      sym_block,
    ACTIONS(179), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(177), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2173), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym_argument_list,
    STATE(3064), 1,
      sym_do_block,
    STATE(3065), 1,
      sym_block,
    ACTIONS(129), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [174] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(2174), 1,
      sym_heredoc_body,
    ACTIONS(3082), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [252] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3212), 1,
      anon_sym_EQ,
    STATE(2175), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3214), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [332] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3216), 1,
      anon_sym_EQ,
    STATE(2176), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3218), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2177), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [486] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3220), 1,
      anon_sym_EQ,
    STATE(2178), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3222), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [568] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3224), 1,
      anon_sym_EQ,
    STATE(2179), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3226), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [648] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2980), 1,
      anon_sym_LBRACE,
    STATE(2180), 1,
      sym_heredoc_body,
    STATE(2096), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2974), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2972), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [726] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2980), 1,
      anon_sym_LBRACE,
    STATE(2181), 1,
      sym_heredoc_body,
    STATE(2085), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2990), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2988), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [804] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2968), 1,
      anon_sym_COLON_COLON,
    STATE(2182), 1,
      sym_heredoc_body,
    ACTIONS(2970), 2,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2966), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2964), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [882] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3228), 1,
      anon_sym_EQ,
    STATE(2183), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3230), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [964] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3232), 1,
      anon_sym_EQ,
    STATE(2184), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3234), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1044] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3236), 1,
      anon_sym_EQ,
    STATE(2185), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3238), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2186), 1,
      sym_heredoc_body,
    ACTIONS(2996), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2187), 1,
      sym_heredoc_body,
    ACTIONS(2618), 2,
      anon_sym_LBRACE,
      anon_sym_LPAREN2,
    ACTIONS(2622), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2620), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1276] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_CARET,
    ACTIONS(2802), 1,
      sym_identifier,
    ACTIONS(2804), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2818), 1,
      anon_sym_nil,
    ACTIONS(2820), 1,
      anon_sym_LBRACK,
    ACTIONS(2828), 1,
      sym_constant,
    ACTIONS(2830), 1,
      anon_sym_DASH_GT,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2926), 1,
      anon_sym_DOT_DOT,
    STATE(2188), 1,
      sym_heredoc_body,
    STATE(4359), 1,
      sym__pattern_constant,
    STATE(4368), 1,
      sym__pattern_constant_resolution,
    STATE(4401), 1,
      sym_nil,
    STATE(4409), 1,
      sym_lambda,
    STATE(4451), 1,
      sym__pattern_range,
    STATE(4458), 1,
      sym__pattern_expr_basic,
    STATE(4656), 1,
      sym__pattern_primitive,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2928), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2930), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
    STATE(4402), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4411), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4414), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4446), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4443), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1676), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4399), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1419] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2954), 1,
      anon_sym_do,
    STATE(2189), 1,
      sym_heredoc_body,
    STATE(2256), 1,
      sym_argument_list,
    STATE(2353), 1,
      sym_block,
    STATE(2392), 1,
      sym_do_block,
    ACTIONS(413), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1504] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_CARET,
    ACTIONS(2802), 1,
      sym_identifier,
    ACTIONS(2804), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2814), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2818), 1,
      anon_sym_nil,
    ACTIONS(2820), 1,
      anon_sym_LBRACK,
    ACTIONS(2822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2828), 1,
      sym_constant,
    ACTIONS(2830), 1,
      anon_sym_DASH_GT,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    STATE(2190), 1,
      sym_heredoc_body,
    STATE(4359), 1,
      sym__pattern_constant,
    STATE(4368), 1,
      sym__pattern_constant_resolution,
    STATE(4401), 1,
      sym_nil,
    STATE(4409), 1,
      sym_lambda,
    STATE(4451), 1,
      sym__pattern_range,
    STATE(4458), 1,
      sym__pattern_expr_basic,
    STATE(4468), 1,
      sym__pattern_primitive,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
    STATE(4402), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4411), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4414), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4446), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4443), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1676), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4399), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1647] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      anon_sym_LPAREN,
    ACTIONS(2860), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2862), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2866), 1,
      anon_sym_nil,
    ACTIONS(2868), 1,
      anon_sym_LBRACK,
    ACTIONS(2872), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2884), 1,
      anon_sym_DASH_GT,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(2956), 1,
      sym_identifier,
    ACTIONS(2960), 1,
      sym_constant,
    STATE(2191), 1,
      sym_heredoc_body,
    STATE(4650), 1,
      sym__pattern_constant_resolution,
    STATE(4658), 1,
      sym__pattern_constant,
    STATE(4692), 1,
      sym_nil,
    STATE(4699), 1,
      sym_lambda,
    STATE(4760), 1,
      sym__pattern_primitive,
    STATE(4801), 1,
      sym__pattern_expr_basic,
    STATE(4819), 1,
      sym__pattern_range,
    STATE(5509), 1,
      sym__int_or_float,
    ACTIONS(2874), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      sym_integer,
      sym_float,
    STATE(4691), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4694), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4697), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4698), 2,
      sym_complex,
      sym_rational,
    STATE(4831), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4816), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(655), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4738), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3240), 1,
      anon_sym_LBRACE,
    ACTIONS(3242), 1,
      anon_sym_do,
    STATE(2192), 1,
      sym_heredoc_body,
    STATE(2245), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2974), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2972), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1869] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_heredoc_body,
    STATE(2241), 1,
      sym_argument_list,
    STATE(2353), 1,
      sym_block,
    STATE(2392), 1,
      sym_do_block,
    ACTIONS(413), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1952] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3240), 1,
      anon_sym_LBRACE,
    ACTIONS(3242), 1,
      anon_sym_do,
    STATE(2194), 1,
      sym_heredoc_body,
    STATE(2255), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2990), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2988), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2031] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_CARET,
    ACTIONS(2856), 1,
      anon_sym_LBRACE,
    ACTIONS(2858), 1,
      anon_sym_LPAREN,
    ACTIONS(2860), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2866), 1,
      anon_sym_nil,
    ACTIONS(2868), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_DASH_GT,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(2936), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2938), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2956), 1,
      sym_identifier,
    ACTIONS(2960), 1,
      sym_constant,
    STATE(2195), 1,
      sym_heredoc_body,
    STATE(4650), 1,
      sym__pattern_constant_resolution,
    STATE(4658), 1,
      sym__pattern_constant,
    STATE(4692), 1,
      sym_nil,
    STATE(4699), 1,
      sym_lambda,
    STATE(4745), 1,
      sym__pattern_primitive,
    STATE(4801), 1,
      sym__pattern_expr_basic,
    STATE(4819), 1,
      sym__pattern_range,
    STATE(5509), 1,
      sym__int_or_float,
    ACTIONS(2940), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      sym_integer,
      sym_float,
    STATE(4691), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4694), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4697), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4698), 2,
      sym_complex,
      sym_rational,
    STATE(4831), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4816), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(655), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4738), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [2174] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_CARET,
    ACTIONS(2802), 1,
      sym_identifier,
    ACTIONS(2804), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2810), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2818), 1,
      anon_sym_nil,
    ACTIONS(2820), 1,
      anon_sym_LBRACK,
    ACTIONS(2828), 1,
      sym_constant,
    ACTIONS(2830), 1,
      anon_sym_DASH_GT,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2906), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2914), 1,
      sym__symbol_start,
    STATE(2196), 1,
      sym_heredoc_body,
    STATE(4359), 1,
      sym__pattern_constant,
    STATE(4368), 1,
      sym__pattern_constant_resolution,
    STATE(4401), 1,
      sym_nil,
    STATE(4409), 1,
      sym_lambda,
    STATE(4451), 1,
      sym__pattern_range,
    STATE(4458), 1,
      sym__pattern_expr_basic,
    STATE(4583), 1,
      sym__pattern_primitive,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
    STATE(4402), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4411), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4414), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4446), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4443), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1676), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4399), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [2317] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2968), 1,
      anon_sym_COLON_COLON,
    STATE(2197), 1,
      sym_heredoc_body,
    ACTIONS(2970), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2966), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2964), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2394] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2198), 1,
      sym_heredoc_body,
    STATE(2207), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    ACTIONS(3246), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3244), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2472] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2199), 1,
      sym_heredoc_body,
    ACTIONS(2616), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2618), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2200), 1,
      sym_heredoc_body,
    ACTIONS(2636), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2638), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2616] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3248), 1,
      anon_sym_EQ,
    STATE(2201), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3250), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2202), 1,
      sym_heredoc_body,
    ACTIONS(2618), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2622), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2620), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2770] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_heredoc_body,
    STATE(2267), 1,
      sym_string,
    ACTIONS(3094), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2850] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2204), 1,
      sym_heredoc_body,
    STATE(2267), 1,
      sym_string,
    ACTIONS(3094), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2928] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3254), 1,
      anon_sym_EQ,
    STATE(2205), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3256), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2206), 1,
      sym_heredoc_body,
    ACTIONS(2624), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2626), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3080] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3262), 1,
      sym__string_start,
    STATE(2267), 1,
      sym_string,
    STATE(2207), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3260), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3258), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3156] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2208), 1,
      sym_heredoc_body,
    STATE(3050), 1,
      sym_do_block,
    STATE(3051), 1,
      sym_block,
    STATE(3152), 1,
      sym_argument_list,
    ACTIONS(179), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(177), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3238] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2209), 1,
      sym_heredoc_body,
    ACTIONS(2632), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3310] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2210), 1,
      sym_heredoc_body,
    STATE(3064), 1,
      sym_do_block,
    STATE(3065), 1,
      sym_block,
    STATE(3114), 1,
      sym_argument_list,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3392] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3265), 1,
      anon_sym_EQ,
    STATE(2211), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3267), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3470] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3269), 1,
      anon_sym_EQ,
    STATE(2212), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3271), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3548] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3273), 1,
      anon_sym_EQ,
    STATE(2213), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3275), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2214), 1,
      sym_heredoc_body,
    ACTIONS(2644), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3698] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3277), 1,
      anon_sym_EQ,
    STATE(2215), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3279), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2216), 1,
      sym_heredoc_body,
    ACTIONS(2628), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2217), 1,
      sym_heredoc_body,
    ACTIONS(2640), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2642), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3922] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3287), 1,
      anon_sym_ri,
    STATE(2218), 1,
      sym_heredoc_body,
    ACTIONS(3285), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3283), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3281), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2219), 1,
      sym_heredoc_body,
    ACTIONS(733), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4070] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3289), 1,
      anon_sym_EQ,
    STATE(2220), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3291), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4148] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    STATE(2221), 1,
      sym_heredoc_body,
    STATE(2418), 1,
      sym_do_block,
    STATE(2425), 1,
      sym_block,
    ACTIONS(3295), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3293), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4225] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(2222), 1,
      sym_heredoc_body,
    STATE(2343), 1,
      sym_argument_list,
    ACTIONS(429), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(427), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4300] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2954), 1,
      anon_sym_do,
    STATE(2223), 1,
      sym_heredoc_body,
    STATE(2275), 1,
      sym_block,
    STATE(2433), 1,
      sym_do_block,
    ACTIONS(3299), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3297), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4379] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2224), 1,
      sym_heredoc_body,
    ACTIONS(2640), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2642), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4450] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2992), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3301), 1,
      anon_sym_COLON,
    STATE(2225), 1,
      sym_heredoc_body,
    ACTIONS(2740), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4527] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2226), 1,
      sym_heredoc_body,
    ACTIONS(3305), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2227), 1,
      sym_heredoc_body,
    ACTIONS(3042), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3040), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2228), 1,
      sym_heredoc_body,
    ACTIONS(3046), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3044), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2229), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2230), 1,
      sym_heredoc_body,
    ACTIONS(3054), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3052), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4882] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2954), 1,
      anon_sym_do,
    STATE(2231), 1,
      sym_heredoc_body,
    STATE(2418), 1,
      sym_do_block,
    STATE(2425), 1,
      sym_block,
    ACTIONS(3295), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3293), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2232), 1,
      sym_heredoc_body,
    ACTIONS(3060), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3058), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2233), 1,
      sym_heredoc_body,
    ACTIONS(3064), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3062), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2234), 1,
      sym_heredoc_body,
    ACTIONS(2966), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2964), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5174] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(2235), 1,
      sym_heredoc_body,
    STATE(2313), 1,
      sym_argument_list,
    ACTIONS(3309), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3307), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2236), 1,
      sym_heredoc_body,
    ACTIONS(129), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2237), 1,
      sym_heredoc_body,
    ACTIONS(3024), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3022), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2238), 1,
      sym_heredoc_body,
    ACTIONS(3012), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3010), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5462] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    STATE(2239), 1,
      sym_heredoc_body,
    STATE(2275), 1,
      sym_block,
    STATE(2433), 1,
      sym_do_block,
    ACTIONS(3299), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3297), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5539] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2240), 1,
      sym_heredoc_body,
    ACTIONS(3313), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3311), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5610] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    STATE(2241), 1,
      sym_heredoc_body,
    STATE(2277), 1,
      sym_block,
    STATE(2340), 1,
      sym_do_block,
    ACTIONS(3317), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3315), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5687] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(2242), 1,
      sym_heredoc_body,
    STATE(2350), 1,
      sym_argument_list,
    ACTIONS(3321), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3319), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2243), 1,
      sym_heredoc_body,
    ACTIONS(3030), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3028), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2244), 1,
      sym_heredoc_body,
    ACTIONS(3034), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3032), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2245), 1,
      sym_heredoc_body,
    ACTIONS(3050), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3048), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5975] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(2246), 1,
      sym_heredoc_body,
    STATE(2431), 1,
      sym_argument_list,
    ACTIONS(417), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(415), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6050] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(2247), 1,
      sym_heredoc_body,
    STATE(2361), 1,
      sym_argument_list,
    ACTIONS(421), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(419), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2248), 1,
      sym_heredoc_body,
    ACTIONS(3068), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3066), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2249), 1,
      sym_heredoc_body,
    ACTIONS(3072), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3070), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6267] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2992), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3323), 1,
      anon_sym_COLON,
    STATE(2250), 1,
      sym_heredoc_body,
    ACTIONS(2740), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2251), 1,
      sym_heredoc_body,
    ACTIONS(3038), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3036), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2252), 1,
      sym_heredoc_body,
    ACTIONS(3016), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6486] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(2253), 1,
      sym_heredoc_body,
    STATE(2285), 1,
      sym_argument_list,
    ACTIONS(425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(423), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2254), 1,
      sym_heredoc_body,
    ACTIONS(3004), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3002), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2255), 1,
      sym_heredoc_body,
    ACTIONS(3008), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3006), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6703] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2954), 1,
      anon_sym_do,
    STATE(2256), 1,
      sym_heredoc_body,
    STATE(2277), 1,
      sym_block,
    STATE(2340), 1,
      sym_do_block,
    ACTIONS(3317), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3315), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6782] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2257), 1,
      sym_heredoc_body,
    ACTIONS(3020), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3018), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2258), 1,
      sym_heredoc_body,
    ACTIONS(3000), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2998), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6924] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2259), 1,
      sym_heredoc_body,
    ACTIONS(2628), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2968), 1,
      anon_sym_COLON_COLON,
    STATE(2260), 1,
      sym_heredoc_body,
    ACTIONS(2970), 3,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2966), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2964), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2261), 1,
      sym_heredoc_body,
    ACTIONS(3076), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3074), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2262), 1,
      sym_heredoc_body,
    ACTIONS(2996), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3325), 1,
      anon_sym_EQ,
    STATE(2263), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3327), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7289] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3329), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2264), 1,
      sym_heredoc_body,
    STATE(2267), 1,
      sym_string,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7367] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2265), 1,
      sym_heredoc_body,
    ACTIONS(2644), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7437] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2992), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3331), 1,
      anon_sym_COLON,
    STATE(2266), 1,
      sym_heredoc_body,
    ACTIONS(2740), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7513] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2267), 1,
      sym_heredoc_body,
    ACTIONS(3335), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3333), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7583] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2268), 1,
      sym_heredoc_body,
    ACTIONS(2632), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7653] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    ACTIONS(3337), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2269), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7733] = 27,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2914), 1,
      sym__symbol_start,
    ACTIONS(3190), 1,
      anon_sym_nil,
    ACTIONS(3194), 1,
      anon_sym_DASH_GT,
    ACTIONS(3339), 1,
      anon_sym___END__,
    STATE(2270), 1,
      sym_heredoc_body,
    STATE(4401), 1,
      sym_nil,
    STATE(4409), 1,
      sym_lambda,
    STATE(4445), 1,
      sym__pattern_primitive,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
    STATE(4402), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4411), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4414), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(3192), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4399), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3188), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [7847] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2271), 1,
      sym_heredoc_body,
    STATE(2245), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2974), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2972), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7919] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2272), 1,
      sym_heredoc_body,
    STATE(2255), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2990), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2988), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7991] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2273), 1,
      sym_heredoc_body,
    ACTIONS(3343), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3341), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8060] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2274), 1,
      sym_heredoc_body,
    ACTIONS(3347), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3345), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8129] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2275), 1,
      sym_heredoc_body,
    ACTIONS(3351), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8198] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2276), 1,
      sym_heredoc_body,
    ACTIONS(3355), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3353), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8267] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2277), 1,
      sym_heredoc_body,
    ACTIONS(3359), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3357), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8336] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2278), 1,
      sym_heredoc_body,
    ACTIONS(3363), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3361), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8405] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3365), 1,
      anon_sym_EQ,
    STATE(2279), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3367), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8480] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2280), 1,
      sym_heredoc_body,
    ACTIONS(3371), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3369), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8549] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2281), 1,
      sym_heredoc_body,
    ACTIONS(3375), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3373), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8618] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2996), 1,
      anon_sym_EQ_GT,
    STATE(2282), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8689] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2283), 1,
      sym_heredoc_body,
    ACTIONS(3379), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3377), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8758] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2284), 1,
      sym_heredoc_body,
    ACTIONS(3383), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3381), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8827] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2285), 1,
      sym_heredoc_body,
    ACTIONS(3387), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3385), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8896] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2286), 1,
      sym_heredoc_body,
    ACTIONS(3391), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3389), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8965] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2287), 1,
      sym_heredoc_body,
    ACTIONS(3395), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3393), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9034] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2288), 1,
      sym_heredoc_body,
    ACTIONS(3399), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3397), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9103] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2289), 1,
      sym_heredoc_body,
    ACTIONS(3403), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3401), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9172] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2290), 1,
      sym_heredoc_body,
    ACTIONS(3407), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3405), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9241] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2291), 1,
      sym_heredoc_body,
    ACTIONS(3407), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3405), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3409), 1,
      anon_sym_EQ,
    STATE(2292), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3411), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9385] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2293), 1,
      sym_heredoc_body,
    ACTIONS(3415), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3413), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9454] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2294), 1,
      sym_heredoc_body,
    ACTIONS(3419), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3417), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9523] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2295), 1,
      sym_heredoc_body,
    ACTIONS(3423), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3421), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9592] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2296), 1,
      sym_heredoc_body,
    ACTIONS(3427), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3425), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9661] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2297), 1,
      sym_heredoc_body,
    ACTIONS(3431), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9730] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2298), 1,
      sym_heredoc_body,
    ACTIONS(3435), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3433), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9799] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2299), 1,
      sym_heredoc_body,
    ACTIONS(3439), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3437), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9868] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2300), 1,
      sym_heredoc_body,
    ACTIONS(3443), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3441), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9937] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2301), 1,
      sym_heredoc_body,
    ACTIONS(3042), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3040), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10006] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3445), 1,
      anon_sym_EQ,
    STATE(2302), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3447), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10081] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2303), 1,
      sym_heredoc_body,
    ACTIONS(3024), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3022), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10150] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym_heredoc_body,
    ACTIONS(3451), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3449), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10219] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2305), 1,
      sym_heredoc_body,
    ACTIONS(3455), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3453), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10288] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2306), 1,
      sym_heredoc_body,
    ACTIONS(3459), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3457), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10357] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2307), 1,
      sym_heredoc_body,
    ACTIONS(3463), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3461), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10426] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2308), 1,
      sym_heredoc_body,
    ACTIONS(3467), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3465), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10495] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2309), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10564] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3473), 1,
      anon_sym_EQ,
    STATE(2310), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3475), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10639] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2311), 1,
      sym_heredoc_body,
    ACTIONS(3477), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3016), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10710] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2312), 1,
      sym_heredoc_body,
    ACTIONS(3481), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3479), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10779] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2313), 1,
      sym_heredoc_body,
    ACTIONS(3485), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3483), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10848] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2314), 1,
      sym_heredoc_body,
    ACTIONS(3489), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3487), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10917] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2315), 1,
      sym_heredoc_body,
    ACTIONS(3493), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3491), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10986] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2316), 1,
      sym_heredoc_body,
    ACTIONS(3497), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3495), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11055] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2317), 1,
      sym_heredoc_body,
    ACTIONS(3501), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3499), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11124] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2318), 1,
      sym_heredoc_body,
    ACTIONS(3505), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3503), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11193] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2319), 1,
      sym_heredoc_body,
    ACTIONS(3509), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3507), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11262] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2320), 1,
      sym_heredoc_body,
    ACTIONS(3513), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3511), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11331] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3082), 1,
      anon_sym_EQ_GT,
    ACTIONS(3301), 1,
      anon_sym_COLON,
    STATE(2321), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11404] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2322), 1,
      sym_heredoc_body,
    ACTIONS(3517), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3515), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11473] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2323), 1,
      sym_heredoc_body,
    ACTIONS(3521), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3519), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11542] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2324), 1,
      sym_heredoc_body,
    ACTIONS(3525), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3523), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11611] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2325), 1,
      sym_heredoc_body,
    ACTIONS(3529), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3527), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11680] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2326), 1,
      sym_heredoc_body,
    ACTIONS(3533), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3531), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11749] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2327), 1,
      sym_heredoc_body,
    ACTIONS(3537), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3535), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11818] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2328), 1,
      sym_heredoc_body,
    ACTIONS(3541), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3539), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2329), 1,
      sym_heredoc_body,
    ACTIONS(3545), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3543), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11956] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2330), 1,
      sym_heredoc_body,
    ACTIONS(3549), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3547), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12025] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2331), 1,
      sym_heredoc_body,
    ACTIONS(3553), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3551), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12094] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2332), 1,
      sym_heredoc_body,
    ACTIONS(3557), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3555), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12163] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2333), 1,
      sym_heredoc_body,
    ACTIONS(3561), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3559), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12232] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2334), 1,
      sym_heredoc_body,
    ACTIONS(3565), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3563), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12301] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2335), 1,
      sym_heredoc_body,
    ACTIONS(3569), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3567), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12370] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2336), 1,
      sym_heredoc_body,
    ACTIONS(3573), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3571), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12439] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2337), 1,
      sym_heredoc_body,
    ACTIONS(3577), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3575), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12508] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_EQ_GT,
    STATE(2338), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3477), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12579] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2339), 1,
      sym_heredoc_body,
    ACTIONS(3585), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3583), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12648] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2340), 1,
      sym_heredoc_body,
    ACTIONS(3359), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3357), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12717] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2341), 1,
      sym_heredoc_body,
    ACTIONS(3076), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3074), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12786] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2342), 1,
      sym_heredoc_body,
    ACTIONS(3589), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3587), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12855] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2343), 1,
      sym_heredoc_body,
    ACTIONS(3593), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3591), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12924] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2344), 1,
      sym_heredoc_body,
    ACTIONS(3597), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3595), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12993] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2345), 1,
      sym_heredoc_body,
    ACTIONS(3601), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3599), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13062] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2346), 1,
      sym_heredoc_body,
    ACTIONS(3605), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13131] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2347), 1,
      sym_heredoc_body,
    ACTIONS(3609), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3607), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13200] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2348), 1,
      sym_heredoc_body,
    ACTIONS(3613), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3611), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13269] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    STATE(2349), 1,
      sym_heredoc_body,
    ACTIONS(3094), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13340] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2350), 1,
      sym_heredoc_body,
    ACTIONS(3617), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3615), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13409] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2351), 1,
      sym_heredoc_body,
    ACTIONS(3621), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3619), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13478] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2352), 1,
      sym_heredoc_body,
    ACTIONS(3625), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3623), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13547] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2353), 1,
      sym_heredoc_body,
    ACTIONS(3629), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3627), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13616] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2354), 1,
      sym_heredoc_body,
    ACTIONS(3068), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3066), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13685] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym_heredoc_body,
    ACTIONS(3633), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3631), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13754] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3635), 1,
      anon_sym_EQ,
    STATE(2356), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3637), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13829] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2357), 1,
      sym_heredoc_body,
    ACTIONS(3030), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3028), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13898] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2358), 1,
      sym_heredoc_body,
    ACTIONS(3641), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3639), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13967] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2359), 1,
      sym_heredoc_body,
    ACTIONS(3645), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3643), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14036] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3651), 1,
      anon_sym_EQ_GT,
    STATE(2360), 1,
      sym_heredoc_body,
    ACTIONS(3649), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3647), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14107] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2361), 1,
      sym_heredoc_body,
    ACTIONS(3655), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3653), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14176] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2362), 1,
      sym_heredoc_body,
    ACTIONS(3034), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3032), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14245] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2363), 1,
      sym_heredoc_body,
    ACTIONS(3659), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3657), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14314] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2364), 1,
      sym_heredoc_body,
    ACTIONS(3663), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14383] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2365), 1,
      sym_heredoc_body,
    ACTIONS(3667), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3665), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14452] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2366), 1,
      sym_heredoc_body,
    ACTIONS(3671), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3669), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14521] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2367), 1,
      sym_heredoc_body,
    ACTIONS(3675), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3673), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14590] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2368), 1,
      sym_heredoc_body,
    ACTIONS(3679), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3677), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14659] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2369), 1,
      sym_heredoc_body,
    ACTIONS(3683), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3681), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14728] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2370), 1,
      sym_heredoc_body,
    ACTIONS(3687), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3685), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14797] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2371), 1,
      sym_heredoc_body,
    ACTIONS(3691), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3689), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14866] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2372), 1,
      sym_heredoc_body,
    ACTIONS(3695), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14935] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2373), 1,
      sym_heredoc_body,
    ACTIONS(3699), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3697), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15004] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2374), 1,
      sym_heredoc_body,
    ACTIONS(3703), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3701), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15073] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2375), 1,
      sym_heredoc_body,
    ACTIONS(3707), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3705), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15142] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2376), 1,
      sym_heredoc_body,
    ACTIONS(3711), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3709), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15211] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2377), 1,
      sym_heredoc_body,
    ACTIONS(3715), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3713), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15280] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2378), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15349] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2379), 1,
      sym_heredoc_body,
    ACTIONS(3723), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3721), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15418] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2380), 1,
      sym_heredoc_body,
    ACTIONS(3727), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3725), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15487] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2381), 1,
      sym_heredoc_body,
    ACTIONS(3072), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3070), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15556] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2382), 1,
      sym_heredoc_body,
    ACTIONS(3731), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3729), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15625] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2383), 1,
      sym_heredoc_body,
    ACTIONS(3735), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3733), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15694] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2384), 1,
      sym_heredoc_body,
    ACTIONS(3739), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3737), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15763] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2385), 1,
      sym_heredoc_body,
    ACTIONS(3743), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3741), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15832] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2386), 1,
      sym_heredoc_body,
    ACTIONS(3747), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3745), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15901] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2387), 1,
      sym_heredoc_body,
    ACTIONS(3751), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3749), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15970] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3753), 1,
      anon_sym_EQ,
    STATE(2388), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3755), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16045] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2389), 1,
      sym_heredoc_body,
    ACTIONS(3759), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3757), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16114] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2390), 1,
      sym_heredoc_body,
    ACTIONS(3016), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16183] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2391), 1,
      sym_heredoc_body,
    ACTIONS(3763), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3761), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16252] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2392), 1,
      sym_heredoc_body,
    ACTIONS(3629), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3627), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16321] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2393), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3477), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16390] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2394), 1,
      sym_heredoc_body,
    ACTIONS(3767), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3765), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16459] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2395), 1,
      sym_heredoc_body,
    ACTIONS(3038), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3036), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16528] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2396), 1,
      sym_heredoc_body,
    ACTIONS(3771), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3769), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16597] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2397), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16666] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2398), 1,
      sym_heredoc_body,
    ACTIONS(3779), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3777), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16735] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3781), 1,
      anon_sym_DOT,
    ACTIONS(3783), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(3785), 1,
      anon_sym_AMP_DOT,
    ACTIONS(3787), 1,
      sym__element_reference_bracket,
    STATE(2399), 1,
      sym_heredoc_body,
    ACTIONS(3605), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16812] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3082), 1,
      anon_sym_EQ_GT,
    ACTIONS(3323), 1,
      anon_sym_COLON,
    STATE(2400), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16885] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2401), 1,
      sym_heredoc_body,
    ACTIONS(3004), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3002), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16954] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2402), 1,
      sym_heredoc_body,
    ACTIONS(3094), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17023] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2403), 1,
      sym_heredoc_body,
    ACTIONS(3016), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17092] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2404), 1,
      sym_heredoc_body,
    ACTIONS(3791), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3789), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17161] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2405), 1,
      sym_heredoc_body,
    ACTIONS(3795), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3793), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17230] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2406), 1,
      sym_heredoc_body,
    ACTIONS(3020), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3018), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17299] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2407), 1,
      sym_heredoc_body,
    ACTIONS(3799), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3797), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17368] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2408), 1,
      sym_heredoc_body,
    ACTIONS(3803), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3801), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17437] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2409), 1,
      sym_heredoc_body,
    ACTIONS(3807), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3805), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17506] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3809), 1,
      anon_sym_EQ,
    STATE(2410), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3811), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17581] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2411), 1,
      sym_heredoc_body,
    ACTIONS(3283), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3281), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17650] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2412), 1,
      sym_heredoc_body,
    ACTIONS(3000), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2998), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17719] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2413), 1,
      sym_heredoc_body,
    ACTIONS(3815), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3813), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17788] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2414), 1,
      sym_heredoc_body,
    ACTIONS(3819), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3817), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17857] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2415), 1,
      sym_heredoc_body,
    ACTIONS(3477), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(3016), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17928] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2416), 1,
      sym_heredoc_body,
    ACTIONS(3823), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3821), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17997] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2618), 1,
      anon_sym_LPAREN2,
    STATE(2417), 1,
      sym_heredoc_body,
    ACTIONS(2622), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2620), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18068] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2418), 1,
      sym_heredoc_body,
    ACTIONS(3827), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3825), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18137] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2419), 1,
      sym_heredoc_body,
    ACTIONS(3831), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3829), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18206] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2420), 1,
      sym_heredoc_body,
    ACTIONS(3835), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3833), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18275] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2421), 1,
      sym_heredoc_body,
    ACTIONS(3839), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3837), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18344] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2422), 1,
      sym_heredoc_body,
    ACTIONS(3843), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3841), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18413] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2423), 1,
      sym_heredoc_body,
    ACTIONS(3847), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3845), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18482] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2424), 1,
      sym_heredoc_body,
    ACTIONS(3851), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3849), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18551] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2425), 1,
      sym_heredoc_body,
    ACTIONS(3827), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3825), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18620] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2426), 1,
      sym_heredoc_body,
    ACTIONS(3855), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3853), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18689] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2427), 1,
      sym_heredoc_body,
    ACTIONS(3046), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3044), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18758] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2428), 1,
      sym_heredoc_body,
    ACTIONS(3054), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3052), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18827] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2429), 1,
      sym_heredoc_body,
    ACTIONS(3060), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3058), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18896] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2430), 1,
      sym_heredoc_body,
    ACTIONS(3064), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3062), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18965] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2431), 1,
      sym_heredoc_body,
    ACTIONS(3859), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3857), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19034] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3861), 1,
      anon_sym_EQ_GT,
    STATE(2432), 1,
      sym_heredoc_body,
    ACTIONS(3094), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19105] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2433), 1,
      sym_heredoc_body,
    ACTIONS(3351), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19174] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2434), 1,
      sym_heredoc_body,
    ACTIONS(3649), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3647), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19243] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2435), 1,
      sym_heredoc_body,
    ACTIONS(3865), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3863), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19312] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3867), 1,
      anon_sym_EQ,
    STATE(2436), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3869), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19387] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2437), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19456] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2438), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4556), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5603), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [19556] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3895), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2439), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4542), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5591), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [19656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2996), 1,
      anon_sym_EQ_GT,
    STATE(2440), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19726] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3082), 1,
      anon_sym_EQ_GT,
    ACTIONS(3331), 1,
      anon_sym_COLON,
    STATE(2441), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19798] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3897), 1,
      anon_sym_LPAREN,
    STATE(2442), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4554), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5447), 1,
      sym__method_rest,
    STATE(5614), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [19898] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2992), 1,
      anon_sym_COLON_COLON,
    STATE(2443), 1,
      sym_heredoc_body,
    ACTIONS(2740), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19970] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3899), 1,
      anon_sym_EQ,
    STATE(2444), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3901), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20044] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3903), 1,
      anon_sym_EQ,
    STATE(2445), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3905), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20120] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3907), 1,
      anon_sym_EQ,
    STATE(2446), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3909), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20194] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3911), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2447), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4553), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5623), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20294] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    STATE(2448), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3915), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20368] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3917), 1,
      anon_sym_LPAREN,
    STATE(2449), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4541), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5632), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20468] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3919), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2450), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20544] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    STATE(2451), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3923), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20618] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
    STATE(2452), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4550), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5634), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20718] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3927), 1,
      anon_sym_LPAREN,
    STATE(2453), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4540), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5631), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20818] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3929), 1,
      anon_sym_LPAREN,
    STATE(2454), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4547), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5579), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20918] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3931), 1,
      anon_sym_LPAREN,
    STATE(2455), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4549), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5624), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21018] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3933), 1,
      anon_sym_LPAREN,
    STATE(2456), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4546), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5596), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21118] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3935), 1,
      anon_sym_LPAREN,
    STATE(2457), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4538), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5612), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21218] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3937), 1,
      anon_sym_EQ,
    STATE(2458), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3939), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21292] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3941), 1,
      anon_sym_LPAREN,
    STATE(2459), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4560), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5627), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21392] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3943), 1,
      anon_sym_EQ,
    STATE(2460), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3945), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21466] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3947), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2461), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4536), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5620), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21566] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3949), 1,
      anon_sym_LPAREN,
    STATE(2462), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4543), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5595), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21666] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3951), 1,
      anon_sym_EQ,
    STATE(2463), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3953), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21740] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3955), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2464), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4545), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5629), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21840] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2465), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4534), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5615), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21940] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3959), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2466), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4537), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5588), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22040] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3961), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2467), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4544), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5599), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22140] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3963), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2468), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4539), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5610), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22240] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3965), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2469), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4535), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5626), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22340] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3967), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2470), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4548), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5605), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22440] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3969), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2471), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4559), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5583), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22540] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3971), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym__method_rest,
    STATE(2472), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4557), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5587), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22640] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3875), 1,
      sym_identifier,
    ACTIONS(3885), 1,
      sym_constant,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    STATE(2473), 1,
      sym_heredoc_body,
    STATE(2905), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4558), 1,
      sym__method_name,
    STATE(4812), 1,
      sym__nonlocal_variable,
    STATE(5611), 1,
      sym__variable,
    ACTIONS(3883), 2,
      sym_super,
      sym_self,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2968), 1,
      anon_sym_COLON_COLON,
    STATE(2474), 1,
      sym_heredoc_body,
    ACTIONS(2970), 2,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2966), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2964), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2475), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22878] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3975), 1,
      anon_sym_DOT,
    ACTIONS(3977), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(3979), 1,
      anon_sym_AMP_DOT,
    ACTIONS(3981), 1,
      sym__element_reference_bracket,
    STATE(2476), 1,
      sym_heredoc_body,
    ACTIONS(3605), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22953] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3983), 1,
      anon_sym_EQ,
    STATE(2477), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3985), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23026] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(3987), 1,
      anon_sym_rescue,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2478), 1,
      sym_heredoc_body,
    STATE(2487), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [23129] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4021), 1,
      anon_sym_EQ,
    STATE(2479), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4023), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23204] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4025), 1,
      anon_sym_EQ,
    STATE(2480), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4027), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23277] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    STATE(2481), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4031), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23350] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(2482), 1,
      sym_heredoc_body,
    ACTIONS(2644), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23419] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4033), 1,
      anon_sym_EQ,
    STATE(2483), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4035), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23494] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4037), 1,
      anon_sym_EQ,
    STATE(2484), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4039), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23569] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4041), 1,
      anon_sym_EQ,
    STATE(2485), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4043), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23642] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2486), 1,
      sym_heredoc_body,
    STATE(2487), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23711] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4049), 1,
      anon_sym_COMMA,
    STATE(2487), 1,
      sym_heredoc_body,
    STATE(2488), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23782] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4051), 1,
      anon_sym_COMMA,
    STATE(2488), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23851] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(2489), 1,
      sym_heredoc_body,
    ACTIONS(2632), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23920] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2490), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23988] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4058), 1,
      anon_sym_EQ,
    STATE(2491), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4060), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24062] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4062), 1,
      anon_sym_EQ,
    STATE(2492), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4064), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 21,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24134] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4066), 1,
      anon_sym_EQ,
    STATE(2493), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4068), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 21,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24206] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4070), 1,
      anon_sym_EQ,
    STATE(2494), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4072), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24280] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3787), 1,
      sym__element_reference_bracket,
    ACTIONS(4074), 1,
      anon_sym_DOT,
    ACTIONS(4076), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4078), 1,
      anon_sym_AMP_DOT,
    STATE(2495), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24354] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4080), 1,
      sym__binary_star_star,
    STATE(2496), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24422] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2497), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24490] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2498), 1,
      sym_heredoc_body,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 40,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24560] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2499), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24628] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2500), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24696] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2501), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24772] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2502), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24846] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2503), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 35,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24926] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2504), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [25016] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2505), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [25104] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4086), 1,
      anon_sym_COLON,
    STATE(2506), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25172] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2507), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [25260] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2508), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25358] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2509), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25456] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    STATE(2510), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [25552] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    STATE(2511), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25650] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4092), 1,
      sym__binary_star_star,
    STATE(2512), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25718] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    STATE(2513), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25816] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2514), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25914] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    STATE(2515), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [26012] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4102), 1,
      anon_sym_EQ,
    STATE(2516), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4104), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26086] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3082), 1,
      anon_sym_EQ_GT,
    STATE(2517), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26154] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(3987), 1,
      anon_sym_rescue,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2518), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [26254] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    STATE(2519), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [26350] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    STATE(2520), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [26448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2742), 1,
      anon_sym_COLON,
    STATE(2521), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26516] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(3987), 1,
      anon_sym_rescue,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2522), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [26616] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    STATE(2523), 1,
      sym_heredoc_body,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 38,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26688] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4114), 1,
      anon_sym_EQ,
    STATE(2524), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4116), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 20,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26759] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2525), 1,
      sym_heredoc_body,
    STATE(2538), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26826] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(3190), 1,
      anon_sym_nil,
    ACTIONS(3194), 1,
      anon_sym_DASH_GT,
    STATE(2526), 1,
      sym_heredoc_body,
    STATE(4401), 1,
      sym_nil,
    STATE(4409), 1,
      sym_lambda,
    STATE(4445), 1,
      sym__pattern_primitive,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2928), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2930), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
    STATE(4402), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4411), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4414), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(3192), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4399), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3188), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [26933] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4118), 1,
      anon_sym_rescue,
    ACTIONS(4120), 1,
      anon_sym_COMMA,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2527), 1,
      sym_heredoc_body,
    STATE(2538), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [27036] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4154), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2528), 1,
      sym_heredoc_body,
    ACTIONS(3094), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27109] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4156), 1,
      anon_sym_EQ,
    STATE(2529), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4158), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27182] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2530), 1,
      sym_heredoc_body,
    ACTIONS(3663), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27247] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4160), 1,
      anon_sym_EQ,
    STATE(2531), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4162), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27320] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2532), 1,
      sym_heredoc_body,
    ACTIONS(3435), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3433), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27385] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4164), 1,
      anon_sym_COMMA,
    STATE(2533), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27452] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    STATE(2534), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4169), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 20,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4171), 1,
      anon_sym_EQ,
    STATE(2535), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4173), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27596] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4120), 1,
      anon_sym_COMMA,
    STATE(2536), 1,
      sym_heredoc_body,
    STATE(2538), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27665] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2537), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27730] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4120), 1,
      anon_sym_COMMA,
    STATE(2533), 1,
      aux_sym_exceptions_repeat1,
    STATE(2538), 1,
      sym_heredoc_body,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27799] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4175), 1,
      anon_sym_EQ,
    STATE(2539), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4177), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27872] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2540), 1,
      sym_heredoc_body,
    ACTIONS(3395), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3393), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27937] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym_heredoc_body,
    ACTIONS(3633), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3631), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28002] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2542), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28067] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2543), 1,
      sym_heredoc_body,
    ACTIONS(3605), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28132] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4179), 1,
      anon_sym_EQ,
    STATE(2544), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4181), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28205] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    ACTIONS(4183), 1,
      anon_sym_rescue,
    STATE(2538), 1,
      aux_sym_exceptions_repeat1,
    STATE(2545), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28306] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2546), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4534), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28394] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2547), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4553), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28482] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2548), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4538), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28570] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2549), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4538), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28658] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2550), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4560), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28746] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2551), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4560), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28834] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2552), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4553), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [28922] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2553), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4536), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29010] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2554), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4536), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29098] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2555), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29194] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2556), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29290] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2557), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [29384] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2558), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29480] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2559), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29576] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2560), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4541), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29664] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2561), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4543), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29752] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2562), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4543), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29840] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3981), 1,
      sym__element_reference_bracket,
    ACTIONS(4189), 1,
      anon_sym_DOT,
    ACTIONS(4191), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4193), 1,
      anon_sym_AMP_DOT,
    STATE(2563), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29912] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    ACTIONS(4183), 1,
      anon_sym_rescue,
    STATE(2564), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [30010] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2565), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4545), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [30098] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2566), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4545), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [30186] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2567), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4541), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [30274] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2568), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [30368] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2569), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4537), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [30456] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2570), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4537), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [30544] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2571), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4544), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [30632] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2572), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4544), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [30720] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    STATE(2573), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4197), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3092), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3094), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [30792] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4199), 1,
      anon_sym_EQ,
    STATE(2574), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4201), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 18,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30862] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2575), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [30958] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4203), 1,
      sym__binary_star_star,
    STATE(2576), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31024] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    ACTIONS(4183), 1,
      anon_sym_rescue,
    STATE(2577), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [31122] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2578), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4539), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31210] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2579), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4539), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31298] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2580), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31364] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2581), 1,
      sym_heredoc_body,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 38,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31432] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2582), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31498] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2583), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31564] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2584), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31638] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2585), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31710] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2586), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31788] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2587), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [31876] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2588), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [31962] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2589), 1,
      sym_heredoc_body,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32032] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2590), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [32118] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2591), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32184] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2592), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4548), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32272] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2593), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4548), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32360] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2594), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4558), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32448] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2595), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4550), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32536] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2596), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4554), 1,
      sym__method_name,
    STATE(5369), 1,
      sym__method_rest,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32624] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2597), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4550), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32712] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    ACTIONS(4205), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2598), 1,
      sym_heredoc_body,
    ACTIONS(3094), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [32786] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2599), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4559), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32874] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2600), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4559), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32962] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2601), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4557), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33050] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2602), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4557), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33138] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2603), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4554), 1,
      sym__method_name,
    STATE(5354), 1,
      sym__method_rest,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33226] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2604), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4558), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33314] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4207), 1,
      anon_sym_EQ,
    STATE(2605), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4209), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3094), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 18,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33384] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2606), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4540), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33472] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4211), 1,
      sym__binary_star_star,
    STATE(2607), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33538] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2608), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4540), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33626] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2609), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [33722] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2610), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4556), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33810] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2611), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4556), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2612), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33962] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    STATE(2613), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [34058] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2614), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4547), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34146] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2615), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4535), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34234] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2616), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4535), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34322] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2331), 1,
      sym__method_rest,
    STATE(2617), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4542), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34410] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2618), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4542), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34498] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2394), 1,
      sym__method_rest,
    STATE(2619), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4534), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34586] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2620), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4547), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34674] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2621), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4549), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34762] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2622), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4549), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34850] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2623), 1,
      sym_heredoc_body,
    STATE(3025), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4546), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34938] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4185), 1,
      sym_identifier,
    ACTIONS(4187), 1,
      sym_constant,
    STATE(2624), 1,
      sym_heredoc_body,
    STATE(3002), 1,
      sym__method_rest,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4546), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35026] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4213), 1,
      anon_sym_EQ,
    STATE(2625), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4215), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3092), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3094), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [35098] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4187), 1,
      sym_constant,
    ACTIONS(4217), 1,
      sym_identifier,
    STATE(2626), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4570), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35183] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(4219), 1,
      anon_sym_nil,
    ACTIONS(4223), 1,
      anon_sym_DASH_GT,
    STATE(2627), 1,
      sym_heredoc_body,
    STATE(4692), 1,
      sym_nil,
    STATE(4699), 1,
      sym_lambda,
    STATE(4803), 1,
      sym__pattern_primitive,
    STATE(5509), 1,
      sym__int_or_float,
    ACTIONS(2940), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      sym_integer,
      sym_float,
    STATE(4691), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4694), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4697), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4698), 2,
      sym_complex,
      sym_rational,
    ACTIONS(4221), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4738), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3188), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [35288] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2628), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [35381] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4255), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      sym_constant,
    ACTIONS(4269), 1,
      sym_simple_symbol,
    ACTIONS(4271), 1,
      sym__symbol_start,
    STATE(2629), 1,
      sym_heredoc_body,
    STATE(2658), 1,
      sym__method_name,
    STATE(3193), 1,
      sym_constant_suffix,
    STATE(3194), 1,
      sym_identifier_suffix,
    ACTIONS(4263), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4265), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4267), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(3204), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4259), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4257), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35466] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2630), 1,
      sym_heredoc_body,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 37,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35533] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2631), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35598] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2632), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35663] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2633), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35736] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2634), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35807] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2635), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 32,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35884] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2636), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [35971] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2637), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [36056] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2638), 1,
      sym_heredoc_body,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 35,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36125] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2639), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [36210] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_rescue,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2640), 1,
      sym_heredoc_body,
    STATE(2664), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 19,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [36311] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4118), 1,
      anon_sym_rescue,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [36408] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4313), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2642), 1,
      sym_heredoc_body,
    ACTIONS(3094), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36479] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2643), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36544] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    STATE(2644), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [36639] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2914), 1,
      sym__symbol_start,
    ACTIONS(4315), 1,
      sym_identifier,
    ACTIONS(4321), 1,
      sym_constant,
    ACTIONS(4329), 1,
      sym_simple_symbol,
    STATE(2645), 1,
      sym_heredoc_body,
    STATE(4551), 1,
      sym__method_name,
    STATE(4813), 1,
      sym_constant_suffix,
    STATE(4830), 1,
      sym_identifier_suffix,
    ACTIONS(4323), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4325), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4327), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4787), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4319), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4317), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36724] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2646), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36789] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4118), 1,
      anon_sym_rescue,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    STATE(2647), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [36886] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4255), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      sym_constant,
    ACTIONS(4269), 1,
      sym_simple_symbol,
    ACTIONS(4271), 1,
      sym__symbol_start,
    STATE(2626), 1,
      sym__method_name,
    STATE(2648), 1,
      sym_heredoc_body,
    STATE(3193), 1,
      sym_constant_suffix,
    STATE(3194), 1,
      sym_identifier_suffix,
    ACTIONS(4263), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4265), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4267), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(3204), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4259), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4257), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36971] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    STATE(2649), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [37066] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    STATE(2650), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [37161] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_rescue,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2651), 1,
      sym_heredoc_body,
    STATE(2664), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [37258] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4331), 1,
      anon_sym_EQ,
    STATE(2652), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4333), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3092), 16,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3094), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [37329] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4335), 1,
      anon_sym_EQ,
    STATE(2653), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4337), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3092), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3094), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [37398] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4339), 1,
      sym__binary_star_star,
    STATE(2654), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37463] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4187), 1,
      sym_constant,
    ACTIONS(4217), 1,
      sym_identifier,
    STATE(2655), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4580), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37548] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    STATE(2656), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [37643] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4341), 1,
      sym__binary_star_star,
    STATE(2657), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37708] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2914), 1,
      sym__symbol_start,
    ACTIONS(4315), 1,
      sym_identifier,
    ACTIONS(4321), 1,
      sym_constant,
    ACTIONS(4329), 1,
      sym_simple_symbol,
    STATE(2658), 1,
      sym_heredoc_body,
    STATE(4570), 1,
      sym__method_name,
    STATE(4813), 1,
      sym_constant_suffix,
    STATE(4830), 1,
      sym_identifier_suffix,
    ACTIONS(4323), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4325), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4327), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4787), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4319), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4317), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37793] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    STATE(2659), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [37886] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4343), 1,
      anon_sym_EQ,
    STATE(2660), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4345), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3092), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3094), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [37955] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    STATE(2661), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [38050] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4347), 1,
      anon_sym_COMMA,
    STATE(2662), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38115] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2663), 1,
      sym_heredoc_body,
    STATE(2664), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38180] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4350), 1,
      anon_sym_COMMA,
    STATE(2662), 1,
      aux_sym_exceptions_repeat1,
    STATE(2664), 1,
      sym_heredoc_body,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38247] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(3893), 1,
      sym_simple_symbol,
    ACTIONS(4187), 1,
      sym_constant,
    ACTIONS(4217), 1,
      sym_identifier,
    STATE(2665), 1,
      sym_heredoc_body,
    STATE(4465), 1,
      sym_constant_suffix,
    STATE(4470), 1,
      sym_identifier_suffix,
    STATE(4551), 1,
      sym__method_name,
    ACTIONS(3887), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3889), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4475), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3881), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3879), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [38332] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(4352), 1,
      anon_sym_EQ,
    STATE(2666), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4354), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(3092), 16,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3094), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [38403] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2914), 1,
      sym__symbol_start,
    ACTIONS(4315), 1,
      sym_identifier,
    ACTIONS(4321), 1,
      sym_constant,
    ACTIONS(4329), 1,
      sym_simple_symbol,
    STATE(2667), 1,
      sym_heredoc_body,
    STATE(4762), 1,
      sym__method_name,
    STATE(4813), 1,
      sym_constant_suffix,
    STATE(4830), 1,
      sym_identifier_suffix,
    ACTIONS(4323), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4325), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4327), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4787), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4319), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4317), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [38488] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(4219), 1,
      anon_sym_nil,
    ACTIONS(4223), 1,
      anon_sym_DASH_GT,
    STATE(2668), 1,
      sym_heredoc_body,
    STATE(4692), 1,
      sym_nil,
    STATE(4699), 1,
      sym_lambda,
    STATE(4803), 1,
      sym__pattern_primitive,
    STATE(5509), 1,
      sym__int_or_float,
    ACTIONS(2874), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      sym_integer,
      sym_float,
    STATE(4691), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4694), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4697), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4698), 2,
      sym_complex,
      sym_rational,
    ACTIONS(4221), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4738), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3188), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [38593] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4356), 1,
      anon_sym_rescue,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2669), 1,
      sym_heredoc_body,
    STATE(2671), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [38691] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2670), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38755] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4390), 1,
      anon_sym_COMMA,
    STATE(2671), 1,
      sym_heredoc_body,
    STATE(2678), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38821] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2672), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [38913] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2673), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39005] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2674), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [39095] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2675), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39191] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2676), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39287] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_rescue,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2677), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39381] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_COMMA,
    STATE(2678), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39445] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    ACTIONS(4397), 1,
      anon_sym_EQ_GT,
    STATE(2679), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39541] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2680), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39633] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2681), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39729] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    STATE(2682), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39795] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2683), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39887] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2684), 1,
      sym_heredoc_body,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 37,
      sym__line_break,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39953] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2685), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [40045] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2686), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40109] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2687), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40173] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2688), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 33,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40245] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2689), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 33,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40315] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2690), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 32,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40391] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2691), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 25,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [40477] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2692), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [40561] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2693), 1,
      sym_heredoc_body,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 35,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40629] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2694), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [40713] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2695), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [40805] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2696), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40869] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2697), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [40959] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2698), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41027] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2699), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [41119] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_rescue,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2700), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 19,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [41217] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2671), 1,
      aux_sym_exceptions_repeat1,
    STATE(2701), 1,
      sym_heredoc_body,
    ACTIONS(3431), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41281] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2702), 1,
      sym_heredoc_body,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41350] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2703), 1,
      sym_heredoc_body,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41415] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2704), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [41508] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2705), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41571] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4356), 1,
      anon_sym_rescue,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2706), 1,
      sym_heredoc_body,
    ACTIONS(3791), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [41666] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4399), 1,
      anon_sym_rescue,
    ACTIONS(4401), 1,
      anon_sym_COMMA,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2707), 1,
      sym_heredoc_body,
    STATE(2709), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [41763] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_COMMA,
    STATE(2708), 1,
      sym_heredoc_body,
    STATE(2709), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41828] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_COMMA,
    STATE(2709), 1,
      sym_heredoc_body,
    STATE(2711), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41893] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4399), 1,
      anon_sym_rescue,
    ACTIONS(4401), 1,
      anon_sym_COMMA,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2709), 1,
      aux_sym_exceptions_repeat1,
    STATE(2710), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [41994] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_COMMA,
    STATE(2711), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42057] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2712), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42120] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4438), 1,
      anon_sym_rescue,
    STATE(2709), 1,
      aux_sym_exceptions_repeat1,
    STATE(2713), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42215] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_COLON,
    STATE(2714), 1,
      sym_heredoc_body,
    ACTIONS(2632), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42278] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_COLON,
    STATE(2715), 1,
      sym_heredoc_body,
    ACTIONS(2644), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42341] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2716), 1,
      sym_heredoc_body,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42412] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2717), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42503] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2718), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [42596] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2719), 1,
      sym_heredoc_body,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [42679] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2720), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42770] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2721), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42861] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4446), 1,
      sym__binary_star_star,
    STATE(2722), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42924] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4448), 1,
      sym__binary_star_star,
    STATE(2723), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42987] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4450), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2724), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43056] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2725), 1,
      sym_heredoc_body,
    ACTIONS(4108), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [43147] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2709), 1,
      aux_sym_exceptions_repeat1,
    STATE(2726), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43210] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2727), 1,
      sym_heredoc_body,
    ACTIONS(4112), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [43303] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4356), 1,
      anon_sym_rescue,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2728), 1,
      sym_heredoc_body,
    ACTIONS(3435), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [43398] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2729), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym_argument_list,
    STATE(3064), 1,
      sym_do_block,
    STATE(3065), 1,
      sym_block,
    ACTIONS(413), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43471] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2730), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [43564] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2731), 1,
      sym_heredoc_body,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [43647] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2732), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43738] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2733), 1,
      sym_heredoc_body,
    ACTIONS(4090), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [43829] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2734), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43892] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2735), 1,
      sym_heredoc_body,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 32,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43959] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2736), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44052] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2737), 1,
      sym_heredoc_body,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 29,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44127] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2738), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44220] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2739), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44283] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4438), 1,
      anon_sym_rescue,
    STATE(2709), 1,
      aux_sym_exceptions_repeat1,
    STATE(2740), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44382] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4360), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4366), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4370), 1,
      anon_sym_QMARK,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2741), 1,
      sym_heredoc_body,
    ACTIONS(3663), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44475] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_PIPE,
    ACTIONS(4362), 1,
      anon_sym_AMP,
    ACTIONS(4368), 1,
      anon_sym_CARET,
    ACTIONS(4374), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4378), 1,
      anon_sym_GT_EQ,
    ACTIONS(4384), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4388), 1,
      sym__binary_star_star,
    STATE(2742), 1,
      sym_heredoc_body,
    ACTIONS(4376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4380), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4364), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4382), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4386), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 22,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [44560] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    STATE(2743), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44651] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3787), 1,
      sym__element_reference_bracket,
    ACTIONS(4456), 1,
      anon_sym_DOT,
    ACTIONS(4458), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4460), 1,
      anon_sym_AMP_DOT,
    STATE(2744), 1,
      sym_heredoc_body,
    ACTIONS(3605), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44720] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2745), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44810] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4462), 1,
      anon_sym_EQ_GT,
    STATE(2746), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44904] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2747), 1,
      sym_heredoc_body,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 35,
      sym__line_break,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44968] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2748), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45030] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2749), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45092] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2750), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45162] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2751), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45230] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2752), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45304] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2753), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [45388] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2754), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 24,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45470] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2755), 1,
      sym_heredoc_body,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 33,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45536] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2756), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 24,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45618] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2757), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45680] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4464), 1,
      anon_sym_COMMA,
    STATE(2758), 1,
      sym_heredoc_body,
    STATE(2762), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45744] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4464), 1,
      anon_sym_COMMA,
    STATE(2758), 1,
      aux_sym_exceptions_repeat1,
    STATE(2759), 1,
      sym_heredoc_body,
    ACTIONS(3431), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45808] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3287), 1,
      anon_sym_ri,
    STATE(2760), 1,
      sym_heredoc_body,
    ACTIONS(3285), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3283), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3281), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45872] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2761), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [45966] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_COMMA,
    STATE(2762), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46028] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4438), 1,
      anon_sym_rescue,
    STATE(2763), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46124] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2764), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46190] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2765), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46252] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2766), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46342] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2767), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46432] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2768), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 21,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [46520] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2769), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46610] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(4438), 1,
      anon_sym_rescue,
    STATE(2770), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46702] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2771), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46792] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2772), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46882] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4469), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2773), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46950] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2774), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 21,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [47038] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2775), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47132] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2776), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47226] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4464), 1,
      anon_sym_COMMA,
    ACTIONS(4471), 1,
      anon_sym_rescue,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2758), 1,
      aux_sym_exceptions_repeat1,
    STATE(2777), 1,
      sym_heredoc_body,
    ACTIONS(3431), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [47324] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2778), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47414] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(3337), 1,
      anon_sym_COLON,
    STATE(2779), 1,
      sym_heredoc_body,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3252), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3092), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47484] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    ACTIONS(4505), 1,
      anon_sym_rescue,
    STATE(2758), 1,
      aux_sym_exceptions_repeat1,
    STATE(2780), 1,
      sym_heredoc_body,
    ACTIONS(3431), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [47580] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2758), 1,
      aux_sym_exceptions_repeat1,
    STATE(2781), 1,
      sym_heredoc_body,
    ACTIONS(3431), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47642] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(2782), 1,
      sym_heredoc_body,
    STATE(2946), 1,
      sym_argument_list,
    ACTIONS(3321), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3319), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47705] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2783), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47770] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2784), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [47861] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2785), 1,
      sym_heredoc_body,
    STATE(2927), 1,
      sym_do_block,
    STATE(2928), 1,
      sym_block,
    ACTIONS(3295), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3293), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47928] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2786), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [48019] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2787), 1,
      sym_heredoc_body,
    ACTIONS(3663), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [48110] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4399), 1,
      anon_sym_rescue,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2788), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [48205] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2789), 1,
      sym_heredoc_body,
    ACTIONS(4090), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [48294] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2790), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [48385] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2791), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [48476] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2792), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [48567] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2793), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48632] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2794), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48693] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    ACTIONS(4505), 1,
      anon_sym_rescue,
    STATE(2795), 1,
      sym_heredoc_body,
    ACTIONS(3791), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [48786] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2796), 1,
      sym_heredoc_body,
    ACTIONS(4108), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [48875] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2797), 1,
      sym_heredoc_body,
    ACTIONS(4112), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [48966] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4475), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4481), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4485), 1,
      anon_sym_QMARK,
    ACTIONS(4487), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    ACTIONS(4505), 1,
      anon_sym_rescue,
    STATE(2798), 1,
      sym_heredoc_body,
    ACTIONS(3435), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [49059] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4539), 1,
      sym__binary_star_star,
    STATE(2799), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49120] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4541), 1,
      sym__string_start,
    STATE(2891), 1,
      sym_string,
    STATE(2800), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3260), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3258), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49183] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2801), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [49272] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2802), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49333] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2803), 1,
      sym_heredoc_body,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 32,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49396] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2804), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49457] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2805), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49518] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2806), 1,
      sym_heredoc_body,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49587] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2807), 1,
      sym_heredoc_body,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49654] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2808), 1,
      sym_heredoc_body,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49727] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4489), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2809), 1,
      sym_heredoc_body,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [49810] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2810), 1,
      sym_heredoc_body,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 21,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [49891] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2811), 1,
      sym_heredoc_body,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49956] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    ACTIONS(4477), 1,
      anon_sym_AMP,
    ACTIONS(4483), 1,
      anon_sym_CARET,
    ACTIONS(4493), 1,
      anon_sym_GT_EQ,
    ACTIONS(4499), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2812), 1,
      sym_heredoc_body,
    ACTIONS(4491), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4495), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4479), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4497), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4501), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 21,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [50037] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4503), 1,
      sym__binary_star_star,
    STATE(2813), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50098] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2814), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [50187] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(2815), 1,
      sym_heredoc_body,
    STATE(3026), 1,
      sym_argument_list,
    ACTIONS(421), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(419), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50250] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2816), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [50343] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2817), 1,
      sym_heredoc_body,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50406] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    STATE(2818), 1,
      sym_heredoc_body,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50471] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2819), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50532] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2820), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50593] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2821), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50662] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2822), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50729] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2823), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 29,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50802] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2824), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 22,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [50885] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2825), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [50966] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2826), 1,
      sym_heredoc_body,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 32,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51031] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2827), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [51112] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2828), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51173] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(2829), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym_argument_list,
    ACTIONS(425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(423), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51236] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4544), 1,
      sym__binary_star_star,
    STATE(2830), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51297] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(2831), 1,
      sym_heredoc_body,
    STATE(2926), 1,
      sym_argument_list,
    ACTIONS(429), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(427), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51360] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2832), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [51453] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2833), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [51540] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2834), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [51629] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2835), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [51718] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2836), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [51807] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2837), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [51896] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(2838), 1,
      sym_heredoc_body,
    STATE(2933), 1,
      sym_argument_list,
    ACTIONS(417), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(415), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51959] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2839), 1,
      sym_heredoc_body,
    STATE(2914), 1,
      sym_do_block,
    STATE(2917), 1,
      sym_block,
    ACTIONS(3299), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3297), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52026] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2840), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [52113] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2841), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [52202] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(2842), 1,
      sym_heredoc_body,
    STATE(2935), 1,
      sym_do_block,
    STATE(2944), 1,
      sym_block,
    ACTIONS(3317), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3315), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52269] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3981), 1,
      sym__element_reference_bracket,
    ACTIONS(4546), 1,
      anon_sym_DOT,
    ACTIONS(4548), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4550), 1,
      anon_sym_AMP_DOT,
    STATE(2843), 1,
      sym_heredoc_body,
    ACTIONS(3605), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52336] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4399), 1,
      anon_sym_rescue,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2844), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [52427] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(2845), 1,
      sym_heredoc_body,
    STATE(2950), 1,
      sym_argument_list,
    ACTIONS(3309), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3307), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52490] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2846), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [52579] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    STATE(2847), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [52668] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    STATE(2800), 1,
      aux_sym_chained_string_repeat1,
    STATE(2848), 1,
      sym_heredoc_body,
    STATE(2891), 1,
      sym_string,
    ACTIONS(3246), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3244), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52733] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2849), 1,
      sym_heredoc_body,
    STATE(2891), 1,
      sym_string,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3252), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3092), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52800] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2850), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [52893] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3287), 1,
      anon_sym_ri,
    STATE(2851), 1,
      sym_heredoc_body,
    ACTIONS(3285), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3283), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3281), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52956] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2852), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [53045] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3477), 1,
      anon_sym_LBRACE,
    STATE(2853), 1,
      sym_heredoc_body,
    ACTIONS(3016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53105] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4552), 1,
      anon_sym_rescue,
    ACTIONS(4554), 1,
      anon_sym_COMMA,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2854), 1,
      sym_heredoc_body,
    STATE(2875), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53201] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_QMARK,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2855), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53291] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2856), 1,
      sym_heredoc_body,
    ACTIONS(4090), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [53379] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_COMMA,
    STATE(2857), 1,
      sym_heredoc_body,
    STATE(2875), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53441] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4620), 1,
      sym__binary_star_star,
    STATE(2858), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53501] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_QMARK,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2859), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53591] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4622), 1,
      anon_sym_COMMA,
    STATE(2860), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53651] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COMMA,
    STATE(2861), 1,
      sym_heredoc_body,
    STATE(2878), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53713] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2862), 1,
      sym_heredoc_body,
    ACTIONS(4108), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [53801] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2863), 1,
      sym_heredoc_body,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [53881] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2864), 1,
      sym_heredoc_body,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 29,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53945] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2865), 1,
      sym_heredoc_body,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [54025] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4627), 1,
      sym__binary_star_star,
    STATE(2866), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54085] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(4629), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2867), 1,
      sym_heredoc_body,
    STATE(2891), 1,
      sym_string,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54151] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_rescue,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_QMARK,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2868), 1,
      sym_heredoc_body,
    ACTIONS(3791), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [54243] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4631), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2869), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54309] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    STATE(2870), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [54397] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_QMARK,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2871), 1,
      sym_heredoc_body,
    ACTIONS(4112), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [54487] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_QMARK,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2872), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [54577] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym___END__,
    ACTIONS(4633), 1,
      anon_sym_rescue,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2861), 1,
      aux_sym_exceptions_repeat1,
    STATE(2873), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [54671] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2874), 1,
      sym_heredoc_body,
    ACTIONS(2640), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2642), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54729] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_COMMA,
    STATE(2860), 1,
      aux_sym_exceptions_repeat1,
    STATE(2875), 1,
      sym_heredoc_body,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54791] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2876), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54851] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2877), 1,
      sym_heredoc_body,
    STATE(3064), 1,
      sym_do_block,
    STATE(3065), 1,
      sym_block,
    STATE(3114), 1,
      sym_argument_list,
    ACTIONS(413), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54919] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4667), 1,
      anon_sym_COMMA,
    STATE(2878), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54979] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2879), 1,
      sym_heredoc_body,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55041] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2880), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55101] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2881), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55161] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2882), 1,
      sym_heredoc_body,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55229] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2883), 1,
      sym_heredoc_body,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55295] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2884), 1,
      sym_heredoc_body,
    ACTIONS(3477), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    ACTIONS(3016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55355] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(4670), 1,
      anon_sym_rescue,
    STATE(2875), 1,
      aux_sym_exceptions_repeat1,
    STATE(2885), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [55449] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2886), 1,
      sym_heredoc_body,
    ACTIONS(3313), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3311), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55507] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2887), 1,
      sym_heredoc_body,
    ACTIONS(2632), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55565] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2888), 1,
      sym_heredoc_body,
    ACTIONS(2644), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55623] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym___END__,
    ACTIONS(4633), 1,
      anon_sym_rescue,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    STATE(2861), 1,
      aux_sym_exceptions_repeat1,
    STATE(2889), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [55721] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2890), 1,
      sym_heredoc_body,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55793] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2891), 1,
      sym_heredoc_body,
    ACTIONS(3335), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3333), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55851] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2892), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55911] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2893), 1,
      sym_heredoc_body,
    ACTIONS(3305), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55969] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2875), 1,
      aux_sym_exceptions_repeat1,
    STATE(2894), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56029] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_rescue,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_QMARK,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2895), 1,
      sym_heredoc_body,
    ACTIONS(3435), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [56121] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2861), 1,
      aux_sym_exceptions_repeat1,
    STATE(2896), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56181] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2897), 1,
      sym_heredoc_body,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [56263] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_PIPE,
    ACTIONS(4590), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4598), 1,
      anon_sym_CARET,
    ACTIONS(4600), 1,
      anon_sym_QMARK,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4604), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4608), 1,
      anon_sym_GT_EQ,
    ACTIONS(4614), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2898), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4606), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4610), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4594), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4612), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4616), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [56353] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2899), 1,
      sym_heredoc_body,
    ACTIONS(2628), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56411] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2900), 1,
      sym_heredoc_body,
    ACTIONS(3046), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3044), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56468] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2901), 1,
      sym_heredoc_body,
    ACTIONS(3807), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3805), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56525] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2902), 1,
      sym_heredoc_body,
    ACTIONS(3819), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3817), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56582] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2903), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [56671] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2904), 1,
      sym_heredoc_body,
    ACTIONS(3621), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3619), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56728] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2905), 1,
      sym_heredoc_body,
    ACTIONS(3609), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3607), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56785] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2906), 1,
      sym_heredoc_body,
    ACTIONS(3625), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3623), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56842] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    ACTIONS(4676), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(2907), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56909] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2908), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [56998] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2909), 1,
      sym_heredoc_body,
    ACTIONS(3363), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3361), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57055] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2910), 1,
      sym_heredoc_body,
    ACTIONS(3641), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3639), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57112] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2911), 1,
      sym_heredoc_body,
    ACTIONS(3645), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3643), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57169] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2912), 1,
      sym_heredoc_body,
    ACTIONS(3459), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3457), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57226] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2913), 1,
      sym_heredoc_body,
    ACTIONS(3577), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3575), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57283] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2914), 1,
      sym_heredoc_body,
    ACTIONS(3351), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57340] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2915), 1,
      sym_heredoc_body,
    ACTIONS(3541), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3539), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57397] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2916), 1,
      sym_heredoc_body,
    ACTIONS(3343), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3341), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57454] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2917), 1,
      sym_heredoc_body,
    ACTIONS(3351), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3349), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57511] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2918), 1,
      sym_heredoc_body,
    ACTIONS(3557), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3555), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57568] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2919), 1,
      sym_heredoc_body,
    ACTIONS(3865), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3863), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57625] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2920), 1,
      sym_heredoc_body,
    ACTIONS(3024), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3022), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57682] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2921), 1,
      sym_heredoc_body,
    ACTIONS(3030), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3028), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57739] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2922), 1,
      sym_heredoc_body,
    ACTIONS(3034), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3032), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57796] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2923), 1,
      sym_heredoc_body,
    ACTIONS(3038), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3036), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57853] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2924), 1,
      sym_heredoc_body,
    ACTIONS(3042), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3040), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57910] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2925), 1,
      sym_heredoc_body,
    ACTIONS(3387), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3385), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57967] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2926), 1,
      sym_heredoc_body,
    ACTIONS(3593), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3591), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58024] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2927), 1,
      sym_heredoc_body,
    ACTIONS(3827), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3825), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58081] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2928), 1,
      sym_heredoc_body,
    ACTIONS(3827), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3825), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58138] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2929), 1,
      sym_heredoc_body,
    ACTIONS(3419), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3417), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58195] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2930), 1,
      sym_heredoc_body,
    ACTIONS(3423), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3421), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58252] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2931), 1,
      sym_heredoc_body,
    ACTIONS(3439), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3437), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58309] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2932), 1,
      sym_heredoc_body,
    ACTIONS(3463), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3461), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58366] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2933), 1,
      sym_heredoc_body,
    ACTIONS(3859), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3857), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58423] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2934), 1,
      sym_heredoc_body,
    ACTIONS(3467), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3465), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58480] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2935), 1,
      sym_heredoc_body,
    ACTIONS(3359), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3357), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58537] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2936), 1,
      sym_heredoc_body,
    ACTIONS(3489), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3487), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58594] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2937), 1,
      sym_heredoc_body,
    ACTIONS(3505), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3503), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58651] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2938), 1,
      sym_heredoc_body,
    ACTIONS(3509), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3507), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58708] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2939), 1,
      sym_heredoc_body,
    ACTIONS(3525), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3523), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58765] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2940), 1,
      sym_heredoc_body,
    ACTIONS(3529), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3527), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58822] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2941), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [58911] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2942), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [59000] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2943), 1,
      sym_heredoc_body,
    ACTIONS(3569), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3567), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59057] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2944), 1,
      sym_heredoc_body,
    ACTIONS(3359), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3357), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59114] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2945), 1,
      sym_heredoc_body,
    ACTIONS(3573), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3571), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59171] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2946), 1,
      sym_heredoc_body,
    ACTIONS(3617), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3615), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59228] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2947), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [59317] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2948), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [59406] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4678), 1,
      anon_sym___END__,
    STATE(2949), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [59499] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2950), 1,
      sym_heredoc_body,
    ACTIONS(3485), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3483), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59556] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2951), 1,
      sym_heredoc_body,
    ACTIONS(3659), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3657), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59613] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(4680), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(2952), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59678] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2953), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [59765] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    STATE(2954), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [59858] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    STATE(2955), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [59951] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2956), 1,
      sym_heredoc_body,
    ACTIONS(3561), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3559), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60008] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2957), 1,
      sym_heredoc_body,
    ACTIONS(3675), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3673), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60065] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2958), 1,
      sym_heredoc_body,
    ACTIONS(3695), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60122] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2959), 1,
      sym_heredoc_body,
    ACTIONS(3703), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3701), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60179] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2960), 1,
      sym_heredoc_body,
    ACTIONS(3727), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3725), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60236] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2961), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60295] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2962), 1,
      sym_heredoc_body,
    ACTIONS(3537), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3535), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60352] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2963), 1,
      sym_heredoc_body,
    ACTIONS(3731), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3729), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60409] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2964), 1,
      sym_heredoc_body,
    ACTIONS(3481), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3479), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60466] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2965), 1,
      sym_heredoc_body,
    ACTIONS(3771), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3769), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60523] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2966), 1,
      sym_heredoc_body,
    ACTIONS(3831), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3829), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60580] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2967), 1,
      sym_heredoc_body,
    ACTIONS(3835), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3833), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60637] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2968), 1,
      sym_heredoc_body,
    ACTIONS(3839), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3837), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60694] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2969), 1,
      sym_heredoc_body,
    ACTIONS(3501), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3499), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60751] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2970), 1,
      sym_heredoc_body,
    ACTIONS(3585), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3583), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60808] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2971), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60867] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2972), 1,
      sym_heredoc_body,
    ACTIONS(3545), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3543), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60924] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2973), 1,
      sym_heredoc_body,
    ACTIONS(3513), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3511), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60981] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2974), 1,
      sym_heredoc_body,
    ACTIONS(3687), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3685), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61038] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2975), 1,
      sym_heredoc_body,
    ACTIONS(3371), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3369), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61095] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2976), 1,
      sym_heredoc_body,
    ACTIONS(3383), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3381), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61152] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2977), 1,
      sym_heredoc_body,
    ACTIONS(3843), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3841), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61209] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2978), 1,
      sym_heredoc_body,
    ACTIONS(3649), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3647), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61266] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2979), 1,
      sym_heredoc_body,
    ACTIONS(3391), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3389), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61323] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      anon_sym_DOT,
    ACTIONS(4078), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4682), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4684), 1,
      sym__element_reference_bracket,
    STATE(2980), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61388] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2981), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [61475] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3287), 1,
      anon_sym_ri,
    STATE(2982), 1,
      sym_heredoc_body,
    ACTIONS(3285), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3283), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3281), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61536] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2983), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [61625] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym___END__,
    ACTIONS(4633), 1,
      anon_sym_rescue,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    STATE(2984), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [61720] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym___END__,
    ACTIONS(4633), 1,
      anon_sym_rescue,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2985), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [61811] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2986), 1,
      sym_heredoc_body,
    ACTIONS(3739), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3737), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61868] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2987), 1,
      sym_heredoc_body,
    ACTIONS(3667), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3665), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61925] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2988), 1,
      sym_heredoc_body,
    ACTIONS(3054), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3052), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61982] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2989), 1,
      sym_heredoc_body,
    ACTIONS(3060), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3058), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62039] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    STATE(2990), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62102] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2991), 1,
      sym_heredoc_body,
    ACTIONS(3064), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3062), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62159] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2992), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62218] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2993), 1,
      sym_heredoc_body,
    ACTIONS(3395), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3393), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62275] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2994), 1,
      sym_heredoc_body,
    ACTIONS(3068), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3066), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62332] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    ACTIONS(4686), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(2995), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62399] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2996), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62456] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2997), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [62545] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym___END__,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(2998), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [62634] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2999), 1,
      sym_heredoc_body,
    ACTIONS(3533), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3531), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62691] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3000), 1,
      sym_heredoc_body,
    ACTIONS(3711), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3709), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62748] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3001), 1,
      sym_heredoc_body,
    ACTIONS(3715), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3713), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62805] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3002), 1,
      sym_heredoc_body,
    ACTIONS(3767), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3765), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62862] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3003), 1,
      sym_heredoc_body,
    ACTIONS(3823), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3821), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62919] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3004), 1,
      sym_heredoc_body,
    ACTIONS(3347), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3345), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62976] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3005), 1,
      sym_heredoc_body,
    ACTIONS(3427), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3425), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63033] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3006), 1,
      sym_heredoc_body,
    ACTIONS(3597), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3595), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63090] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3007), 1,
      sym_heredoc_body,
    ACTIONS(3601), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3599), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63147] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3008), 1,
      sym_heredoc_body,
    ACTIONS(3671), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3669), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63204] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3009), 1,
      sym_heredoc_body,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63265] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3010), 1,
      sym_heredoc_body,
    ACTIONS(3691), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3689), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63322] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3011), 1,
      sym_heredoc_body,
    ACTIONS(3605), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63379] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3012), 1,
      sym_heredoc_body,
    ACTIONS(3072), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3070), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63436] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3013), 1,
      sym_heredoc_body,
    ACTIONS(3004), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3002), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63493] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3014), 1,
      sym_heredoc_body,
    ACTIONS(3020), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3018), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63550] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3015), 1,
      sym_heredoc_body,
    ACTIONS(3799), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3797), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63607] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3016), 1,
      sym_heredoc_body,
    ACTIONS(3803), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3801), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63664] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    STATE(3017), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63725] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3018), 1,
      sym_heredoc_body,
    ACTIONS(3000), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2998), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63782] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3019), 1,
      sym_heredoc_body,
    ACTIONS(3707), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3705), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63839] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3020), 1,
      sym_heredoc_body,
    ACTIONS(3779), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3777), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63896] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3021), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63953] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym_heredoc_body,
    ACTIONS(3633), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3631), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64010] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3781), 1,
      anon_sym_DOT,
    ACTIONS(3785), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4684), 1,
      sym__element_reference_bracket,
    ACTIONS(4688), 1,
      anon_sym_COLON_COLON2,
    STATE(3023), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64075] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3024), 1,
      sym_heredoc_body,
    ACTIONS(3747), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64132] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3025), 1,
      sym_heredoc_body,
    ACTIONS(3553), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3551), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64189] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3026), 1,
      sym_heredoc_body,
    ACTIONS(3655), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3653), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64246] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3027), 1,
      sym_heredoc_body,
    ACTIONS(3791), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3789), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64303] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3028), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64370] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3029), 1,
      sym_heredoc_body,
    ACTIONS(3663), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64427] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3030), 1,
      sym_heredoc_body,
    ACTIONS(3723), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3721), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64484] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3031), 1,
      sym_heredoc_body,
    ACTIONS(3735), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3733), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64541] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3032), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64606] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3033), 1,
      sym_heredoc_body,
    ACTIONS(3443), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3441), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64663] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3034), 1,
      sym_heredoc_body,
    ACTIONS(3471), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3469), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64720] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3035), 1,
      sym_heredoc_body,
    ACTIONS(3493), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3491), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64777] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3036), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64848] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3037), 1,
      sym_heredoc_body,
    ACTIONS(3847), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3845), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64905] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3038), 1,
      sym_heredoc_body,
    ACTIONS(3497), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3495), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64962] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3039), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [65043] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3040), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [65122] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3041), 1,
      sym_heredoc_body,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 29,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65185] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3042), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [65264] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3043), 1,
      sym_heredoc_body,
    ACTIONS(3517), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3515), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65321] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3044), 1,
      sym_heredoc_body,
    ACTIONS(3521), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3519), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65378] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3045), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3477), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65435] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    STATE(3046), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65494] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3047), 1,
      sym_heredoc_body,
    ACTIONS(3851), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3849), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65551] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3048), 1,
      sym_heredoc_body,
    ACTIONS(3451), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3449), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65608] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3049), 1,
      sym_heredoc_body,
    ACTIONS(3589), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3587), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65665] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3050), 1,
      sym_heredoc_body,
    ACTIONS(3407), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3405), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65722] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3051), 1,
      sym_heredoc_body,
    ACTIONS(3407), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3405), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65779] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3052), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [65868] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3053), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [65957] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3054), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [66044] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3055), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [66133] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3056), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [66222] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(4670), 1,
      anon_sym_rescue,
    STATE(3057), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [66313] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3058), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [66400] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3059), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [66489] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3060), 1,
      sym_heredoc_body,
    ACTIONS(3613), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3611), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66546] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(4670), 1,
      anon_sym_rescue,
    STATE(3061), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [66637] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3062), 1,
      sym_heredoc_body,
    ACTIONS(3415), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3413), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66694] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3063), 1,
      sym_heredoc_body,
    ACTIONS(3094), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66751] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3064), 1,
      sym_heredoc_body,
    ACTIONS(3629), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3627), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66808] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3065), 1,
      sym_heredoc_body,
    ACTIONS(3629), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3627), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66865] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3066), 1,
      sym_heredoc_body,
    ACTIONS(3743), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3741), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66922] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3067), 1,
      sym_heredoc_body,
    ACTIONS(3759), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3757), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66979] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3068), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67036] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3069), 1,
      sym_heredoc_body,
    ACTIONS(3763), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3761), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67093] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3070), 1,
      sym_heredoc_body,
    ACTIONS(3431), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67150] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3071), 1,
      sym_heredoc_body,
    ACTIONS(3435), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3433), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67207] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3072), 1,
      sym_heredoc_body,
    ACTIONS(3016), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67264] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(3073), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67329] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4690), 1,
      sym__binary_star_star,
    STATE(3074), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67388] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3075), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67447] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3076), 1,
      sym_heredoc_body,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67508] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3077), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67567] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3078), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67626] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3079), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67693] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3080), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67758] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3081), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67829] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3082), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [67910] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3083), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [67989] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3084), 1,
      sym_heredoc_body,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68052] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3085), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [68131] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(3086), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68190] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4692), 1,
      sym__binary_star_star,
    STATE(3087), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68249] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3088), 1,
      sym_heredoc_body,
    ACTIONS(3076), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3074), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68306] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3089), 1,
      sym_heredoc_body,
    ACTIONS(3699), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3697), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68363] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3090), 1,
      sym_heredoc_body,
    ACTIONS(3355), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3353), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68420] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3091), 1,
      sym_heredoc_body,
    ACTIONS(3379), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3377), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68477] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3092), 1,
      sym_heredoc_body,
    ACTIONS(3683), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3681), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68534] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4678), 1,
      anon_sym___END__,
    ACTIONS(4694), 1,
      anon_sym_EQ_GT,
    STATE(3093), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [68627] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3094), 1,
      sym_heredoc_body,
    ACTIONS(3375), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3373), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68684] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3095), 1,
      sym_heredoc_body,
    ACTIONS(3399), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3397), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68741] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3096), 1,
      sym_heredoc_body,
    ACTIONS(3403), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3401), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68798] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3097), 1,
      sym_heredoc_body,
    ACTIONS(3815), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3813), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68855] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3098), 1,
      sym_heredoc_body,
    ACTIONS(3751), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3749), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68912] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3099), 1,
      sym_heredoc_body,
    ACTIONS(3565), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3563), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68969] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3100), 1,
      sym_heredoc_body,
    ACTIONS(3549), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3547), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69026] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3101), 1,
      sym_heredoc_body,
    ACTIONS(3795), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3793), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69083] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3102), 1,
      sym_heredoc_body,
    ACTIONS(3283), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3281), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69140] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3103), 1,
      sym_heredoc_body,
    ACTIONS(3455), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3453), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69197] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3104), 1,
      sym_heredoc_body,
    ACTIONS(3855), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3853), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69254] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3105), 1,
      sym_heredoc_body,
    ACTIONS(3679), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3677), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69311] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(1925), 1,
      sym_constant_suffix,
    STATE(1926), 1,
      sym_identifier_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3106), 1,
      sym_heredoc_body,
    ACTIONS(4696), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4702), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4704), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1922), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4700), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4698), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [69383] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    STATE(3107), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69445] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4712), 1,
      sym_identifier,
    ACTIONS(4718), 1,
      sym_constant,
    STATE(2072), 1,
      sym_identifier_suffix,
    STATE(2079), 1,
      sym_constant_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3108), 1,
      sym_heredoc_body,
    ACTIONS(4720), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4722), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4716), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4714), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [69519] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4724), 1,
      sym_identifier,
    ACTIONS(4730), 1,
      sym_constant,
    STATE(1912), 1,
      sym_constant_suffix,
    STATE(1915), 1,
      sym_identifier_suffix,
    STATE(2231), 1,
      sym_argument_list,
    STATE(3109), 1,
      sym_heredoc_body,
    ACTIONS(4732), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1908), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4728), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4726), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [69593] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4742), 1,
      sym_constant,
    STATE(2209), 1,
      sym_constant_suffix,
    STATE(2214), 1,
      sym_identifier_suffix,
    STATE(3110), 1,
      sym_heredoc_body,
    STATE(3117), 1,
      sym_argument_list,
    ACTIONS(4744), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4746), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2199), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4740), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4738), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [69667] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    STATE(3111), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [69745] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    STATE(3112), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69803] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4764), 1,
      anon_sym_COMMA,
    STATE(3113), 1,
      sym_heredoc_body,
    STATE(3127), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69863] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2935), 1,
      sym_do_block,
    STATE(2944), 1,
      sym_block,
    STATE(3114), 1,
      sym_heredoc_body,
    ACTIONS(3317), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3315), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69925] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    STATE(3115), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [70011] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4696), 1,
      sym_identifier,
    ACTIONS(4774), 1,
      sym_constant,
    STATE(1925), 1,
      sym_constant_suffix,
    STATE(1926), 1,
      sym_identifier_suffix,
    STATE(2231), 1,
      sym_argument_list,
    STATE(3116), 1,
      sym_heredoc_body,
    ACTIONS(4702), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4704), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1922), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4700), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4698), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [70085] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2927), 1,
      sym_do_block,
    STATE(2928), 1,
      sym_block,
    STATE(3117), 1,
      sym_heredoc_body,
    ACTIONS(3295), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3293), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70147] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    STATE(3118), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [70233] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    STATE(3119), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [70321] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3120), 1,
      sym_heredoc_body,
    ACTIONS(3649), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3647), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70377] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(2209), 1,
      sym_constant_suffix,
    STATE(2214), 1,
      sym_identifier_suffix,
    STATE(2785), 1,
      sym_argument_list,
    STATE(3121), 1,
      sym_heredoc_body,
    ACTIONS(4736), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4744), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4746), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2199), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4740), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4738), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [70449] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(2072), 1,
      sym_identifier_suffix,
    STATE(2079), 1,
      sym_constant_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3122), 1,
      sym_heredoc_body,
    ACTIONS(4712), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4720), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4722), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4716), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4714), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [70521] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4696), 1,
      sym_identifier,
    ACTIONS(4778), 1,
      sym_constant,
    STATE(1925), 1,
      sym_constant_suffix,
    STATE(1926), 1,
      sym_identifier_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3123), 1,
      sym_heredoc_body,
    ACTIONS(4702), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4704), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1922), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4700), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4698), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [70595] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(1912), 1,
      sym_constant_suffix,
    STATE(1915), 1,
      sym_identifier_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3124), 1,
      sym_heredoc_body,
    ACTIONS(4724), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4732), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1908), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4728), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4726), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [70667] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4780), 1,
      anon_sym_rescue,
    STATE(3125), 1,
      sym_heredoc_body,
    STATE(3227), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [70759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4786), 1,
      anon_sym_EQ2,
    STATE(3126), 1,
      sym_heredoc_body,
    ACTIONS(4782), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(4784), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [70817] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_COMMA,
    STATE(3127), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70875] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4791), 1,
      sym_identifier,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    ACTIONS(4799), 1,
      sym_constant,
    STATE(3128), 1,
      sym_heredoc_body,
    STATE(4879), 1,
      sym_constant_suffix,
    STATE(4880), 1,
      sym_identifier_suffix,
    STATE(4996), 1,
      sym_argument_list,
    ACTIONS(4801), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4803), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4836), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4795), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4793), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [70949] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3129), 1,
      sym_heredoc_body,
    ACTIONS(3579), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3477), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71005] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    STATE(3130), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [71093] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    ACTIONS(4805), 1,
      sym_identifier,
    ACTIONS(4811), 1,
      sym_constant,
    STATE(3131), 1,
      sym_heredoc_body,
    STATE(4777), 1,
      sym_constant_suffix,
    STATE(4778), 1,
      sym_identifier_suffix,
    STATE(4996), 1,
      sym_argument_list,
    ACTIONS(2710), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4805), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4809), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4807), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71167] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3132), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3252), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3092), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71225] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4724), 1,
      sym_identifier,
    ACTIONS(4813), 1,
      sym_constant,
    STATE(1912), 1,
      sym_constant_suffix,
    STATE(1915), 1,
      sym_identifier_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3133), 1,
      sym_heredoc_body,
    ACTIONS(4732), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1908), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4728), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4726), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71299] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym___END__,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4815), 1,
      anon_sym_rescue,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3113), 1,
      aux_sym_exceptions_repeat1,
    STATE(3134), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [71395] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3113), 1,
      aux_sym_exceptions_repeat1,
    STATE(3135), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71453] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(4736), 1,
      sym_identifier,
    ACTIONS(4849), 1,
      sym_constant,
    STATE(2209), 1,
      sym_constant_suffix,
    STATE(2214), 1,
      sym_identifier_suffix,
    STATE(2785), 1,
      sym_argument_list,
    STATE(3136), 1,
      sym_heredoc_body,
    ACTIONS(4744), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4746), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2199), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4740), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4738), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71527] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3137), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3861), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3092), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71585] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4851), 1,
      sym__binary_star_star,
    STATE(3138), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71643] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(4853), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(3139), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71707] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4552), 1,
      anon_sym_rescue,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    STATE(3140), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [71797] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym___END__,
    ACTIONS(4764), 1,
      anon_sym_COMMA,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    ACTIONS(4855), 1,
      anon_sym_rescue,
    STATE(3113), 1,
      aux_sym_exceptions_repeat1,
    STATE(3141), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [71891] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3142), 1,
      sym_heredoc_body,
    ACTIONS(3579), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3581), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3477), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71949] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    STATE(3143), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72037] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3144), 1,
      sym_heredoc_body,
    ACTIONS(3649), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3651), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3647), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72095] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    STATE(3145), 1,
      sym_heredoc_body,
    STATE(4879), 1,
      sym_constant_suffix,
    STATE(4880), 1,
      sym_identifier_suffix,
    STATE(4996), 1,
      sym_argument_list,
    ACTIONS(4791), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4801), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4803), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4836), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4795), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4793), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72167] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(4857), 1,
      sym_identifier,
    ACTIONS(4863), 1,
      sym_constant,
    STATE(1947), 1,
      sym_constant_suffix,
    STATE(1948), 1,
      sym_identifier_suffix,
    STATE(3117), 1,
      sym_argument_list,
    STATE(3146), 1,
      sym_heredoc_body,
    ACTIONS(4865), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4867), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1953), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4861), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4859), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72241] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(1947), 1,
      sym_constant_suffix,
    STATE(1948), 1,
      sym_identifier_suffix,
    STATE(3117), 1,
      sym_argument_list,
    STATE(3147), 1,
      sym_heredoc_body,
    ACTIONS(4857), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4865), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4867), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1953), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4861), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4859), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72313] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4724), 1,
      sym_identifier,
    ACTIONS(4869), 1,
      sym_constant,
    STATE(1912), 1,
      sym_constant_suffix,
    STATE(1915), 1,
      sym_identifier_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3148), 1,
      sym_heredoc_body,
    ACTIONS(4732), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1908), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4728), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4726), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72387] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    ACTIONS(4857), 1,
      sym_identifier,
    ACTIONS(4871), 1,
      sym_constant,
    STATE(1947), 1,
      sym_constant_suffix,
    STATE(1948), 1,
      sym_identifier_suffix,
    STATE(2785), 1,
      sym_argument_list,
    STATE(3149), 1,
      sym_heredoc_body,
    ACTIONS(4865), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4867), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1953), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4861), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4859), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72461] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    STATE(3150), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72549] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    STATE(3151), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72637] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    STATE(2914), 1,
      sym_do_block,
    STATE(2917), 1,
      sym_block,
    STATE(3152), 1,
      sym_heredoc_body,
    ACTIONS(3299), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3297), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72699] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    STATE(3153), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72757] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(1947), 1,
      sym_constant_suffix,
    STATE(1948), 1,
      sym_identifier_suffix,
    STATE(2785), 1,
      sym_argument_list,
    STATE(3154), 1,
      sym_heredoc_body,
    ACTIONS(4857), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4865), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4867), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1953), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4861), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4859), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72829] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3155), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72885] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4724), 1,
      sym_identifier,
    ACTIONS(4873), 1,
      sym_constant,
    STATE(1912), 1,
      sym_constant_suffix,
    STATE(1915), 1,
      sym_identifier_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3156), 1,
      sym_heredoc_body,
    ACTIONS(4732), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1908), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4728), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4726), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72959] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4875), 1,
      anon_sym_COLON,
    STATE(2198), 1,
      aux_sym_chained_string_repeat1,
    STATE(2267), 1,
      sym_string,
    STATE(3157), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73023] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4552), 1,
      anon_sym_rescue,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    STATE(3158), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [73113] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    STATE(3159), 1,
      sym_heredoc_body,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73173] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    STATE(3160), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73231] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    STATE(3161), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73289] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(2072), 1,
      sym_identifier_suffix,
    STATE(2079), 1,
      sym_constant_suffix,
    STATE(2231), 1,
      sym_argument_list,
    STATE(3162), 1,
      sym_heredoc_body,
    ACTIONS(4712), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4720), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4722), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4716), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4714), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73361] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    STATE(3163), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73427] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    STATE(3164), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73491] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4712), 1,
      sym_identifier,
    ACTIONS(4877), 1,
      sym_constant,
    STATE(2072), 1,
      sym_identifier_suffix,
    STATE(2079), 1,
      sym_constant_suffix,
    STATE(2231), 1,
      sym_argument_list,
    STATE(3165), 1,
      sym_heredoc_body,
    ACTIONS(4720), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4722), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4716), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4714), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73565] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3166), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73621] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(1912), 1,
      sym_constant_suffix,
    STATE(1915), 1,
      sym_identifier_suffix,
    STATE(2231), 1,
      sym_argument_list,
    STATE(3167), 1,
      sym_heredoc_body,
    ACTIONS(4724), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4732), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1908), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4728), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4726), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73693] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4724), 1,
      sym_identifier,
    ACTIONS(4879), 1,
      sym_constant,
    STATE(1912), 1,
      sym_constant_suffix,
    STATE(1915), 1,
      sym_identifier_suffix,
    STATE(2231), 1,
      sym_argument_list,
    STATE(3168), 1,
      sym_heredoc_body,
    ACTIONS(4732), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1908), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4728), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4726), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73767] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym___END__,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4764), 1,
      anon_sym_COMMA,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    ACTIONS(4855), 1,
      anon_sym_rescue,
    STATE(3113), 1,
      aux_sym_exceptions_repeat1,
    STATE(3169), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [73865] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_LPAREN2,
    STATE(2209), 1,
      sym_constant_suffix,
    STATE(2214), 1,
      sym_identifier_suffix,
    STATE(3117), 1,
      sym_argument_list,
    STATE(3170), 1,
      sym_heredoc_body,
    ACTIONS(4736), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4744), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4746), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2199), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4740), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4738), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73937] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    ACTIONS(4712), 1,
      sym_identifier,
    ACTIONS(4881), 1,
      sym_constant,
    STATE(2072), 1,
      sym_identifier_suffix,
    STATE(2079), 1,
      sym_constant_suffix,
    STATE(2221), 1,
      sym_argument_list,
    STATE(3171), 1,
      sym_heredoc_body,
    ACTIONS(4720), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4722), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2078), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4716), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4714), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74011] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4883), 1,
      sym__binary_star_star,
    STATE(3172), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74069] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    STATE(3173), 1,
      sym_heredoc_body,
    STATE(4777), 1,
      sym_constant_suffix,
    STATE(4778), 1,
      sym_identifier_suffix,
    STATE(4996), 1,
      sym_argument_list,
    ACTIONS(2710), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4805), 2,
      sym_constant,
      sym_identifier,
    STATE(4805), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4809), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4807), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74141] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    STATE(3174), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74211] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4764), 1,
      anon_sym_COMMA,
    STATE(3113), 1,
      aux_sym_exceptions_repeat1,
    STATE(3175), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74271] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    ACTIONS(4805), 1,
      sym_identifier,
    ACTIONS(4885), 1,
      sym_constant,
    STATE(3176), 1,
      sym_heredoc_body,
    STATE(4777), 1,
      sym_constant_suffix,
    STATE(4778), 1,
      sym_identifier_suffix,
    STATE(4996), 1,
      sym_argument_list,
    ACTIONS(2710), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2734), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4805), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4809), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4807), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74345] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_LPAREN2,
    STATE(1925), 1,
      sym_constant_suffix,
    STATE(1926), 1,
      sym_identifier_suffix,
    STATE(2231), 1,
      sym_argument_list,
    STATE(3177), 1,
      sym_heredoc_body,
    ACTIONS(4696), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4702), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4704), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1922), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4700), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4698), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74417] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    STATE(3178), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 18,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [74497] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    ACTIONS(4887), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(3179), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74563] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym___END__,
    ACTIONS(4815), 1,
      anon_sym_rescue,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3113), 1,
      aux_sym_exceptions_repeat1,
    STATE(3180), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [74655] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    STATE(3181), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [74733] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4889), 1,
      sym__binary_star_star,
    STATE(3182), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74791] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3183), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [74882] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4891), 1,
      anon_sym___END__,
    STATE(3184), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [74969] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym___END__,
    ACTIONS(4815), 1,
      anon_sym_rescue,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3185), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75058] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3186), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75145] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3187), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75232] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4780), 1,
      anon_sym_rescue,
    STATE(3188), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [75321] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4893), 1,
      anon_sym_COMMA,
    STATE(3189), 1,
      sym_heredoc_body,
    STATE(3206), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [75380] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3190), 1,
      sym_heredoc_body,
    ACTIONS(3455), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(3453), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [75435] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4678), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    ACTIONS(4895), 1,
      anon_sym_EQ_GT,
    STATE(3191), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [75526] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3192), 1,
      sym_heredoc_body,
    ACTIONS(3699), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(3697), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [75581] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3193), 1,
      sym_heredoc_body,
    ACTIONS(2632), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2634), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [75636] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3194), 1,
      sym_heredoc_body,
    ACTIONS(2644), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2646), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [75691] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4678), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3195), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [75782] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(4897), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(3196), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [75845] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3197), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [75930] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3198), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [76021] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4899), 1,
      anon_sym___END__,
    STATE(3199), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76108] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3189), 1,
      aux_sym_exceptions_repeat1,
    STATE(3200), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76165] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4901), 1,
      anon_sym___END__,
    STATE(3201), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76252] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4903), 1,
      anon_sym___END__,
    STATE(3202), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76339] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_PIPE,
    ACTIONS(4637), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4639), 1,
      anon_sym_AMP,
    ACTIONS(4643), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4645), 1,
      anon_sym_CARET,
    ACTIONS(4647), 1,
      anon_sym_QMARK,
    ACTIONS(4649), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4651), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4655), 1,
      anon_sym_GT_EQ,
    ACTIONS(4661), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4665), 1,
      sym__binary_star_star,
    ACTIONS(4905), 1,
      anon_sym___END__,
    STATE(3203), 1,
      sym_heredoc_body,
    ACTIONS(4653), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4657), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4641), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4659), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4663), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76426] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3204), 1,
      sym_heredoc_body,
    ACTIONS(4782), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(4784), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [76481] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3205), 1,
      sym_heredoc_body,
    ACTIONS(2624), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2626), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [76536] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4907), 1,
      anon_sym_COMMA,
    STATE(3206), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76593] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COMMA,
    STATE(3207), 1,
      sym_heredoc_body,
    STATE(3209), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76652] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3207), 1,
      aux_sym_exceptions_repeat1,
    STATE(3208), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76709] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_COMMA,
    STATE(3209), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76766] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4915), 1,
      anon_sym_rescue,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3207), 1,
      aux_sym_exceptions_repeat1,
    STATE(3210), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [76857] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4949), 1,
      anon_sym_rescue,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3211), 1,
      sym_heredoc_body,
    STATE(3274), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [76948] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3212), 1,
      sym_heredoc_body,
    ACTIONS(2628), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2630), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [77003] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3213), 1,
      sym_heredoc_body,
    STATE(3227), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77060] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(3989), 1,
      anon_sym_PIPE,
    ACTIONS(3991), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3999), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_QMARK,
    ACTIONS(4003), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4005), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4009), 1,
      anon_sym_GT_EQ,
    ACTIONS(4015), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4019), 1,
      sym__binary_star_star,
    ACTIONS(4780), 1,
      anon_sym_rescue,
    STATE(3214), 1,
      sym_heredoc_body,
    ACTIONS(4007), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4011), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3995), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4013), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4017), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [77149] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3215), 1,
      sym_heredoc_body,
    ACTIONS(2640), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2642), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [77204] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3216), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [77291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3217), 1,
      sym_heredoc_body,
    ACTIONS(2636), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2638), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [77346] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3218), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77407] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3219), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77464] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3220), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [77551] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3221), 1,
      sym_heredoc_body,
    ACTIONS(4983), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(4985), 29,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [77606] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3222), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [77693] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3223), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [77778] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3224), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [77865] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3787), 1,
      sym__element_reference_bracket,
    ACTIONS(4074), 1,
      anon_sym_DOT,
    ACTIONS(4078), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4987), 1,
      anon_sym_COLON_COLON2,
    STATE(3225), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77928] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(4469), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(3226), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77991] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_COMMA,
    STATE(3227), 1,
      sym_heredoc_body,
    STATE(3228), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78050] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4991), 1,
      anon_sym_COMMA,
    STATE(3228), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78107] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym___END__,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3229), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [78194] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3230), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78251] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym___END__,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4815), 1,
      anon_sym_rescue,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3231), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [78344] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3232), 1,
      sym_heredoc_body,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 29,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78403] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3233), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78460] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3234), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78517] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3235), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78582] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    ACTIONS(4994), 1,
      anon_sym_rescue,
    STATE(3189), 1,
      aux_sym_exceptions_repeat1,
    STATE(3236), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [78673] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4996), 1,
      anon_sym_DOT,
    ACTIONS(4998), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5000), 1,
      anon_sym_AMP_DOT,
    ACTIONS(5002), 1,
      sym__element_reference_bracket,
    STATE(3237), 1,
      sym_heredoc_body,
    ACTIONS(3605), 8,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78736] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3238), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78799] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3239), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78868] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3240), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [78947] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3241), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 18,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [79024] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3242), 1,
      sym_heredoc_body,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79085] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    STATE(3243), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 18,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [79162] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    ACTIONS(5004), 1,
      anon_sym_rescue,
    STATE(3244), 1,
      sym_heredoc_body,
    STATE(3263), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [79253] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3245), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [79331] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3861), 1,
      anon_sym_EQ_GT,
    STATE(3246), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79387] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3247), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [79473] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    ACTIONS(5004), 1,
      anon_sym_rescue,
    STATE(3248), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [79561] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    STATE(3249), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79623] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3250), 1,
      sym_heredoc_body,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79681] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3251), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79737] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3252), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79793] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3253), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79857] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3254), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79919] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3255), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79987] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3256), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [80065] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3257), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [80141] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3258), 1,
      sym_heredoc_body,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80201] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3259), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [80277] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3260), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80333] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    ACTIONS(4994), 1,
      anon_sym_rescue,
    STATE(3261), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80421] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3262), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80507] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5014), 1,
      anon_sym_COMMA,
    STATE(3263), 1,
      sym_heredoc_body,
    STATE(3269), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80565] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    STATE(3264), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80633] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3265), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80719] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym___END__,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4855), 1,
      anon_sym_rescue,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3266), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [80811] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3267), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80897] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym___END__,
    ACTIONS(4855), 1,
      anon_sym_rescue,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3268), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [80985] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5040), 1,
      anon_sym_COMMA,
    STATE(3269), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81041] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    STATE(3270), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81097] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5043), 1,
      sym__binary_star_star,
    STATE(3271), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81153] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3272), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [81239] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3273), 1,
      sym_heredoc_body,
    ACTIONS(3016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81293] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5045), 1,
      anon_sym_COMMA,
    STATE(3274), 1,
      sym_heredoc_body,
    STATE(3349), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81351] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3263), 1,
      aux_sym_exceptions_repeat1,
    STATE(3275), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81407] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3252), 1,
      anon_sym_EQ_GT,
    STATE(3276), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81463] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3277), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [81549] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    STATE(3278), 1,
      sym_heredoc_body,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81607] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3279), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [81693] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3280), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [81779] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5047), 1,
      sym__binary_star_star,
    STATE(3281), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81835] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_COLON,
    STATE(3282), 1,
      sym_heredoc_body,
    ACTIONS(2644), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81891] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3274), 1,
      aux_sym_exceptions_repeat1,
    STATE(3283), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81947] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5049), 1,
      anon_sym_COMMA,
    STATE(3284), 1,
      sym_heredoc_body,
    STATE(3286), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82005] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4949), 1,
      anon_sym_rescue,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3285), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [82093] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5049), 1,
      anon_sym_COMMA,
    STATE(3286), 1,
      sym_heredoc_body,
    STATE(3329), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82151] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5051), 1,
      anon_sym_DOT,
    ACTIONS(5053), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5055), 1,
      anon_sym_AMP_DOT,
    ACTIONS(5057), 1,
      sym__element_reference_bracket,
    STATE(3287), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82213] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    ACTIONS(5004), 1,
      anon_sym_rescue,
    STATE(3288), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [82301] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3289), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82357] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3290), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 14,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [82441] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    STATE(3291), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82497] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3292), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [82581] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(4678), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3293), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [82671] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3294), 1,
      sym_heredoc_body,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82729] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3295), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82785] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3296), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82841] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3297), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82905] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3298), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82967] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3299), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83035] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    ACTIONS(5059), 1,
      anon_sym_rescue,
    STATE(3300), 1,
      sym_heredoc_body,
    STATE(3429), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83125] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3301), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [83201] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3302), 1,
      sym_heredoc_body,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83261] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3303), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [83337] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3304), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83393] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4915), 1,
      anon_sym_rescue,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3305), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83481] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5057), 1,
      sym__element_reference_bracket,
    ACTIONS(5061), 1,
      anon_sym_DOT,
    ACTIONS(5063), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5065), 1,
      anon_sym_AMP_DOT,
    STATE(3306), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83543] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3307), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83629] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3308), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83715] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5049), 1,
      anon_sym_COMMA,
    ACTIONS(5067), 1,
      anon_sym_rescue,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3286), 1,
      aux_sym_exceptions_repeat1,
    STATE(3309), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [83809] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    STATE(3310), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83865] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    STATE(3311), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [83949] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5131), 1,
      anon_sym_QMARK,
    STATE(3312), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [84035] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    STATE(3313), 1,
      sym_heredoc_body,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84093] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    STATE(3314), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84149] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    STATE(3315), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84205] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    STATE(3316), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84269] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_COLON,
    STATE(3317), 1,
      sym_heredoc_body,
    ACTIONS(2632), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84325] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    STATE(3318), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84393] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    STATE(3319), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [84471] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    STATE(3320), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [84547] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    STATE(3321), 1,
      sym_heredoc_body,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84607] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    STATE(3322), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [84683] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    STATE(3323), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84739] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3324), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [84825] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    ACTIONS(4994), 1,
      anon_sym_rescue,
    STATE(3325), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [84913] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3326), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [84991] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3327), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [85067] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    STATE(3328), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85123] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5133), 1,
      anon_sym_COMMA,
    STATE(3329), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85179] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5131), 1,
      anon_sym_QMARK,
    STATE(3330), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85265] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5131), 1,
      anon_sym_QMARK,
    STATE(3331), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85351] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    STATE(3332), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [85435] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5131), 1,
      anon_sym_QMARK,
    STATE(3333), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85521] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5131), 1,
      anon_sym_QMARK,
    STATE(3334), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85607] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2033), 1,
      sym_identifier_suffix,
    STATE(2034), 1,
      sym_constant_suffix,
    STATE(3335), 1,
      sym_heredoc_body,
    ACTIONS(5136), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5142), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5144), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2035), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5140), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5138), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [85673] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5146), 1,
      sym__binary_star_star,
    STATE(3336), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85729] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    STATE(3337), 1,
      sym_heredoc_body,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85789] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3338), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [85865] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3339), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [85955] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    STATE(3340), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86015] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5148), 1,
      sym__binary_star_star,
    STATE(3341), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86071] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4949), 1,
      anon_sym_rescue,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3342), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86159] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4915), 1,
      anon_sym_rescue,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3343), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86247] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_EQ_GT,
    STATE(3344), 1,
      sym_heredoc_body,
    ACTIONS(3579), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3477), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86303] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2105), 1,
      sym_identifier_suffix,
    STATE(2113), 1,
      sym_constant_suffix,
    STATE(3345), 1,
      sym_heredoc_body,
    ACTIONS(5150), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5156), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5158), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2111), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5154), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5152), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [86369] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym___END__,
    ACTIONS(4672), 1,
      anon_sym_in,
    ACTIONS(4674), 1,
      anon_sym_EQ_GT,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3346), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [86459] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3651), 1,
      anon_sym_EQ_GT,
    STATE(3347), 1,
      sym_heredoc_body,
    ACTIONS(3649), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3647), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86515] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_COLON,
    STATE(3348), 1,
      sym_heredoc_body,
    ACTIONS(2632), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86571] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5160), 1,
      anon_sym_COMMA,
    STATE(3349), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86627] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    ACTIONS(5163), 1,
      anon_sym_rescue,
    STATE(3286), 1,
      aux_sym_exceptions_repeat1,
    STATE(3350), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [86719] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_COLON,
    STATE(3351), 1,
      sym_heredoc_body,
    ACTIONS(2644), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86775] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5165), 1,
      sym__binary_star_star,
    STATE(3352), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86831] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    ACTIONS(5163), 1,
      anon_sym_rescue,
    STATE(3286), 1,
      aux_sym_exceptions_repeat1,
    STATE(3353), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [86919] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    STATE(3354), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86975] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5131), 1,
      anon_sym_QMARK,
    STATE(3355), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87061] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    ACTIONS(5103), 1,
      anon_sym_PIPE,
    ACTIONS(5105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5107), 1,
      anon_sym_AMP,
    ACTIONS(5111), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5113), 1,
      anon_sym_CARET,
    ACTIONS(5115), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5121), 1,
      anon_sym_GT_EQ,
    ACTIONS(5127), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5131), 1,
      anon_sym_QMARK,
    STATE(3356), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5109), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5129), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87147] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3357), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87233] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(4469), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(3358), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87295] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2057), 1,
      sym_constant_suffix,
    STATE(2058), 1,
      sym_identifier_suffix,
    STATE(3359), 1,
      sym_heredoc_body,
    ACTIONS(5167), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5173), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5175), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2052), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5171), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5169), 20,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [87361] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5177), 1,
      sym__binary_star_star,
    STATE(3360), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87417] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    STATE(3361), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87481] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3362), 1,
      sym_heredoc_body,
    ACTIONS(3477), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87537] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3363), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87623] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3286), 1,
      aux_sym_exceptions_repeat1,
    STATE(3364), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87679] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3365), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87765] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3366), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [87849] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3367), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87905] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3368), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 14,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [87989] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5049), 1,
      anon_sym_COMMA,
    ACTIONS(5067), 1,
      anon_sym_rescue,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3286), 1,
      aux_sym_exceptions_repeat1,
    STATE(3369), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [88079] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3370), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 14,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [88163] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    STATE(3371), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88249] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3372), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88335] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3373), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88421] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3374), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 14,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [88505] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3375), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88591] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_PIPE,
    ACTIONS(4919), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4921), 1,
      anon_sym_AMP,
    ACTIONS(4925), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4927), 1,
      anon_sym_CARET,
    ACTIONS(4929), 1,
      anon_sym_QMARK,
    ACTIONS(4931), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4933), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4937), 1,
      anon_sym_GT_EQ,
    ACTIONS(4943), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4947), 1,
      sym__binary_star_star,
    STATE(3376), 1,
      sym_heredoc_body,
    ACTIONS(4935), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4939), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4923), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4941), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4945), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88677] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    ACTIONS(5179), 1,
      anon_sym_rescue,
    ACTIONS(5181), 1,
      anon_sym_COMMA,
    STATE(3377), 1,
      sym_heredoc_body,
    STATE(3429), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88769] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5101), 1,
      sym__binary_star_star,
    STATE(3378), 1,
      sym_heredoc_body,
    ACTIONS(5119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5123), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5125), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88831] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    ACTIONS(5163), 1,
      anon_sym_rescue,
    STATE(3379), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [88920] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5195), 1,
      anon_sym_QMARK,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3380), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [89005] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3381), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [89088] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3382), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89143] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    STATE(3383), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [89226] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym_heredoc_body,
    ACTIONS(3633), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3631), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89279] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3385), 1,
      sym_heredoc_body,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89336] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3386), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89391] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3387), 1,
      sym_heredoc_body,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89448] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3388), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89503] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3389), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89558] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3390), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89621] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3391), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89682] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3392), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89749] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3393), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 15,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [89826] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3394), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [89901] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3395), 1,
      sym_heredoc_body,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89960] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3396), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [90035] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3397), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90090] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3398), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90145] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    STATE(3399), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90208] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3400), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90269] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    ACTIONS(4891), 1,
      anon_sym___END__,
    STATE(3401), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [90354] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    STATE(3402), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90421] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    STATE(3403), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 15,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [90498] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    STATE(3404), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [90573] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3405), 1,
      sym_heredoc_body,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90632] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    STATE(3406), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [90707] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    STATE(3407), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90762] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5195), 1,
      anon_sym_QMARK,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3408), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [90847] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5195), 1,
      anon_sym_QMARK,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3409), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [90932] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(3410), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91017] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(3411), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91102] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    STATE(3412), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [91185] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(3413), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91270] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(3414), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91355] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(3190), 1,
      anon_sym_nil,
    ACTIONS(3194), 1,
      anon_sym_DASH_GT,
    STATE(3415), 1,
      sym_heredoc_body,
    STATE(4401), 1,
      sym_nil,
    STATE(4409), 1,
      sym_lambda,
    STATE(4456), 1,
      sym__pattern_primitive,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2928), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2930), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
    STATE(4402), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4411), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4414), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(3192), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4399), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [91448] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5195), 1,
      anon_sym_QMARK,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3416), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91533] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5195), 1,
      anon_sym_QMARK,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3417), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [91618] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2914), 1,
      sym__symbol_start,
    ACTIONS(3190), 1,
      anon_sym_nil,
    ACTIONS(3194), 1,
      anon_sym_DASH_GT,
    STATE(3418), 1,
      sym_heredoc_body,
    STATE(4401), 1,
      sym_nil,
    STATE(4409), 1,
      sym_lambda,
    STATE(4456), 1,
      sym__pattern_primitive,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
    STATE(4402), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4411), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4414), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(3192), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4399), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [91711] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(3419), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91770] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3420), 1,
      sym_heredoc_body,
    STATE(3429), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91825] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5247), 1,
      sym__binary_star_star,
    STATE(3421), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91880] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    ACTIONS(4899), 1,
      anon_sym___END__,
    STATE(3422), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [91965] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3423), 1,
      sym_heredoc_body,
    ACTIONS(3435), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3433), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92018] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym__binary_star_star,
    STATE(3424), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92073] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3981), 1,
      sym__element_reference_bracket,
    ACTIONS(4189), 1,
      anon_sym_DOT,
    ACTIONS(4193), 1,
      anon_sym_AMP_DOT,
    ACTIONS(5251), 1,
      anon_sym_COLON_COLON2,
    STATE(3425), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92134] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(4219), 1,
      anon_sym_nil,
    ACTIONS(4223), 1,
      anon_sym_DASH_GT,
    STATE(3426), 1,
      sym_heredoc_body,
    STATE(4692), 1,
      sym_nil,
    STATE(4699), 1,
      sym_lambda,
    STATE(4826), 1,
      sym__pattern_primitive,
    STATE(5509), 1,
      sym__int_or_float,
    ACTIONS(2874), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2876), 2,
      sym_integer,
      sym_float,
    STATE(4691), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4694), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4697), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4698), 2,
      sym_complex,
      sym_rational,
    ACTIONS(4221), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4738), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [92227] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(3427), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [92312] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3428), 1,
      sym_heredoc_body,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92365] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5181), 1,
      anon_sym_COMMA,
    STATE(3429), 1,
      sym_heredoc_body,
    STATE(3458), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92422] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    ACTIONS(5059), 1,
      anon_sym_rescue,
    STATE(3430), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [92509] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3431), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [92592] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3432), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 14,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [92673] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3433), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [92756] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    ACTIONS(5163), 1,
      anon_sym_rescue,
    STATE(3434), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [92841] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3435), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [92924] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3436), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [93007] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_COLON,
    STATE(3437), 1,
      sym_heredoc_body,
    ACTIONS(2644), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93062] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3438), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 14,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [93143] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3439), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [93230] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3440), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [93317] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3441), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93370] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    ACTIONS(4903), 1,
      anon_sym___END__,
    STATE(3442), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [93455] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3443), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [93542] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3444), 1,
      sym_heredoc_body,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93599] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3445), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93654] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3446), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93709] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3447), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93772] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3448), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93833] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3449), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93900] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3450), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [93977] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3451), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [94052] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3452), 1,
      sym_heredoc_body,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94111] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3453), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 17,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [94186] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3454), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94241] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5181), 1,
      anon_sym_COMMA,
    STATE(3429), 1,
      aux_sym_exceptions_repeat1,
    STATE(3455), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94298] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    ACTIONS(4905), 1,
      anon_sym___END__,
    STATE(3456), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [94383] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(3457), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [94468] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5253), 1,
      anon_sym_COMMA,
    STATE(3458), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94523] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3459), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [94606] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_PIPE,
    ACTIONS(4819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4821), 1,
      anon_sym_AMP,
    ACTIONS(4825), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4827), 1,
      anon_sym_CARET,
    ACTIONS(4829), 1,
      anon_sym_QMARK,
    ACTIONS(4831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4837), 1,
      anon_sym_GT_EQ,
    ACTIONS(4843), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4847), 1,
      sym__binary_star_star,
    ACTIONS(4901), 1,
      anon_sym___END__,
    STATE(3460), 1,
      sym_heredoc_body,
    ACTIONS(4835), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4839), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4823), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4841), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4845), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [94691] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(3190), 1,
      anon_sym_nil,
    ACTIONS(3194), 1,
      anon_sym_DASH_GT,
    STATE(3461), 1,
      sym_heredoc_body,
    STATE(4401), 1,
      sym_nil,
    STATE(4409), 1,
      sym_lambda,
    STATE(4456), 1,
      sym__pattern_primitive,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2824), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
    STATE(4402), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4411), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4414), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(3192), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4399), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [94784] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5256), 1,
      sym__binary_star_star,
    STATE(3462), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94839] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3463), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94892] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    ACTIONS(5258), 1,
      anon_sym_EQ_GT,
    STATE(3464), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [94979] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4889), 1,
      sym__binary_star_star,
    STATE(3465), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95034] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3466), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95093] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3467), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95148] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      sym__binary_star_star,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    ACTIONS(5219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5221), 1,
      anon_sym_AMP,
    ACTIONS(5225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5227), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5235), 1,
      anon_sym_GT_EQ,
    ACTIONS(5241), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(3468), 1,
      sym_heredoc_body,
    ACTIONS(5233), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5237), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5239), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5243), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95233] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3469), 1,
      sym_heredoc_body,
    ACTIONS(3477), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(3016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3014), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95288] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3470), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95343] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3471), 1,
      sym_heredoc_body,
    ACTIONS(3395), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3393), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95396] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3472), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [95479] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3473), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95532] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_COLON,
    STATE(3474), 1,
      sym_heredoc_body,
    ACTIONS(2632), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95587] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4122), 1,
      anon_sym_PIPE,
    ACTIONS(4124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4126), 1,
      anon_sym_AMP,
    ACTIONS(4130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4132), 1,
      anon_sym_CARET,
    ACTIONS(4134), 1,
      anon_sym_QMARK,
    ACTIONS(4136), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4138), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_GT_EQ,
    ACTIONS(4148), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4152), 1,
      sym__binary_star_star,
    ACTIONS(5059), 1,
      anon_sym_rescue,
    STATE(3475), 1,
      sym_heredoc_body,
    ACTIONS(4140), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4144), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4128), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4146), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4150), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95674] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5195), 1,
      anon_sym_QMARK,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3476), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95759] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3477), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [95842] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2886), 1,
      sym_simple_symbol,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(2890), 1,
      sym__symbol_start,
    ACTIONS(2892), 1,
      sym__subshell_start,
    ACTIONS(2894), 1,
      sym__regex_start,
    ACTIONS(2896), 1,
      sym__string_array_start,
    ACTIONS(2898), 1,
      sym__symbol_array_start,
    ACTIONS(2900), 1,
      sym_heredoc_beginning,
    ACTIONS(4219), 1,
      anon_sym_nil,
    ACTIONS(4223), 1,
      anon_sym_DASH_GT,
    STATE(3478), 1,
      sym_heredoc_body,
    STATE(4692), 1,
      sym_nil,
    STATE(4699), 1,
      sym_lambda,
    STATE(4826), 1,
      sym__pattern_primitive,
    STATE(5509), 1,
      sym__int_or_float,
    ACTIONS(2940), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2942), 2,
      sym_integer,
      sym_float,
    STATE(4691), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4694), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4697), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4698), 2,
      sym_complex,
      sym_rational,
    ACTIONS(4221), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4738), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [95935] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5183), 1,
      anon_sym_PIPE,
    ACTIONS(5185), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5187), 1,
      anon_sym_AMP,
    ACTIONS(5191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5193), 1,
      anon_sym_CARET,
    ACTIONS(5195), 1,
      anon_sym_QMARK,
    ACTIONS(5197), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_GT_EQ,
    ACTIONS(5209), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5213), 1,
      sym__binary_star_star,
    STATE(3479), 1,
      sym_heredoc_body,
    ACTIONS(5201), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5205), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5207), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [96020] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3480), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [96103] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3481), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96165] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    STATE(3482), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96219] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    STATE(3483), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96273] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_rescue,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3484), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [96357] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    STATE(3485), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96419] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3486), 1,
      sym_heredoc_body,
    ACTIONS(2628), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2630), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96471] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3487), 1,
      sym_heredoc_body,
    ACTIONS(2640), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2642), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96523] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(5302), 1,
      anon_sym_rescue,
    ACTIONS(5304), 1,
      anon_sym_COMMA,
    STATE(3488), 1,
      sym_heredoc_body,
    STATE(3594), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [96613] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    STATE(3489), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96673] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    STATE(3490), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96739] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    STATE(3491), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [96815] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3492), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [96901] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4893), 1,
      anon_sym_COMMA,
    STATE(3189), 1,
      aux_sym_exceptions_repeat1,
    STATE(3493), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96957] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5320), 1,
      sym__binary_star_star,
    STATE(3494), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97011] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3495), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [97091] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    STATE(3496), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [97165] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym__string_start,
    STATE(2891), 1,
      sym_string,
    STATE(3497), 1,
      sym_heredoc_body,
    STATE(3541), 1,
      aux_sym_chained_string_repeat1,
    ACTIONS(3094), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97223] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    ACTIONS(5322), 1,
      anon_sym_EQ_GT,
    STATE(3498), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [97309] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3499), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [97395] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4893), 1,
      anon_sym_COMMA,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    ACTIONS(5324), 1,
      anon_sym_rescue,
    STATE(3189), 1,
      aux_sym_exceptions_repeat1,
    STATE(3500), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [97485] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3501), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [97571] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3502), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [97653] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    STATE(3503), 1,
      sym_heredoc_body,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97711] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(3504), 1,
      sym_heredoc_body,
    ACTIONS(2644), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97765] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3505), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97819] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3506), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [97901] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3507), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [97983] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3508), 1,
      sym_heredoc_body,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98039] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5002), 1,
      sym__element_reference_bracket,
    ACTIONS(5326), 1,
      anon_sym_DOT,
    ACTIONS(5328), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5330), 1,
      anon_sym_AMP_DOT,
    STATE(3509), 1,
      sym_heredoc_body,
    ACTIONS(3605), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3603), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98099] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3510), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [98181] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3511), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98235] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3512), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98289] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    STATE(3513), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98343] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(5332), 1,
      anon_sym_rescue,
    STATE(3514), 1,
      sym_heredoc_body,
    STATE(3594), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98431] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    ACTIONS(5334), 1,
      anon_sym_rescue,
    STATE(3515), 1,
      sym_heredoc_body,
    STATE(3592), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [98521] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5336), 1,
      sym__string_start,
    STATE(2891), 1,
      sym_string,
    STATE(3516), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3260), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3258), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98577] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    STATE(3517), 1,
      sym_heredoc_body,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98633] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4891), 1,
      anon_sym___END__,
    ACTIONS(5012), 1,
      sym__binary_star_star,
    ACTIONS(5016), 1,
      anon_sym_PIPE,
    ACTIONS(5018), 1,
      anon_sym_AMP,
    ACTIONS(5020), 1,
      anon_sym_CARET,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    ACTIONS(5030), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5034), 1,
      anon_sym_GT_EQ,
    ACTIONS(5036), 1,
      anon_sym_EQ_EQ,
    STATE(3518), 1,
      sym_heredoc_body,
    ACTIONS(5006), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5008), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5010), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5024), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5038), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [98717] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3519), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98777] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    STATE(3520), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98843] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3521), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [98923] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    ACTIONS(5179), 1,
      anon_sym_rescue,
    STATE(3522), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [99009] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3523), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 15,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [99085] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3524), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [99159] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3525), 1,
      sym_heredoc_body,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99217] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3526), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [99299] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3527), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [99373] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3528), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99427] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3529), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [99511] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3530), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [99593] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5347), 1,
      sym__binary_star_star,
    STATE(3531), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99647] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3532), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [99731] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3533), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [99815] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    STATE(3534), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [99889] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    STATE(3535), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99947] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3536), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [100031] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3537), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [100115] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    STATE(3538), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100169] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(3539), 1,
      sym_heredoc_body,
    ACTIONS(2632), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100223] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    ACTIONS(4951), 1,
      anon_sym_PIPE,
    ACTIONS(4953), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4955), 1,
      anon_sym_AMP,
    ACTIONS(4959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4961), 1,
      anon_sym_CARET,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    ACTIONS(4965), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4971), 1,
      anon_sym_GT_EQ,
    ACTIONS(4977), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4981), 1,
      sym__binary_star_star,
    ACTIONS(5045), 1,
      anon_sym_COMMA,
    ACTIONS(5349), 1,
      anon_sym_rescue,
    STATE(3274), 1,
      aux_sym_exceptions_repeat1,
    STATE(3540), 1,
      sym_heredoc_body,
    ACTIONS(4969), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4973), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4957), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4975), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4979), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [100313] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym__string_start,
    STATE(2891), 1,
      sym_string,
    STATE(3516), 1,
      aux_sym_chained_string_repeat1,
    STATE(3541), 1,
      sym_heredoc_body,
    ACTIONS(3246), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3244), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100371] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    ACTIONS(5334), 1,
      anon_sym_rescue,
    STATE(3542), 1,
      sym_heredoc_body,
    STATE(3592), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [100457] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3543), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [100539] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3544), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [100623] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      sym__binary_star_star,
    ACTIONS(5294), 1,
      anon_sym_AMP,
    ACTIONS(5306), 1,
      anon_sym_PIPE,
    ACTIONS(5308), 1,
      anon_sym_CARET,
    ACTIONS(5312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5314), 1,
      anon_sym_GT_EQ,
    ACTIONS(5316), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5339), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5341), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    ACTIONS(5345), 1,
      anon_sym_PIPE_PIPE,
    STATE(3545), 1,
      sym_heredoc_body,
    ACTIONS(5296), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5298), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5300), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5310), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5318), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [100707] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(5067), 1,
      anon_sym_rescue,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3546), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [100795] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4227), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4229), 1,
      anon_sym_AMP,
    ACTIONS(4233), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4235), 1,
      anon_sym_CARET,
    ACTIONS(4237), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4239), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4243), 1,
      anon_sym_GT_EQ,
    ACTIONS(4249), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4253), 1,
      sym__binary_star_star,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    ACTIONS(5179), 1,
      anon_sym_rescue,
    STATE(3547), 1,
      sym_heredoc_body,
    ACTIONS(4241), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4245), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4231), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4247), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4251), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [100881] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3548), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [100962] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3549), 1,
      sym_heredoc_body,
    STATE(3592), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101015] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3550), 1,
      sym_heredoc_body,
    STATE(3554), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101068] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5351), 1,
      anon_sym_COMMA,
    STATE(3551), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101121] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5354), 1,
      anon_sym_rescue,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3552), 1,
      sym_heredoc_body,
    STATE(3554), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101206] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    ACTIONS(5334), 1,
      anon_sym_rescue,
    STATE(3553), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [101293] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5388), 1,
      anon_sym_COMMA,
    STATE(3551), 1,
      aux_sym_exceptions_repeat1,
    STATE(3554), 1,
      sym_heredoc_body,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101348] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_rescue,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3555), 1,
      sym_heredoc_body,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101433] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5424), 1,
      sym__binary_star_star,
    STATE(3556), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101486] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5426), 1,
      anon_sym_rescue,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3557), 1,
      sym_heredoc_body,
    STATE(3621), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101575] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5426), 1,
      anon_sym_rescue,
    STATE(3558), 1,
      sym_heredoc_body,
    STATE(3621), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101660] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4279), 1,
      anon_sym_AMP,
    ACTIONS(4287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4289), 1,
      anon_sym_CARET,
    ACTIONS(4291), 1,
      anon_sym_QMARK,
    ACTIONS(4293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4299), 1,
      anon_sym_GT_EQ,
    ACTIONS(4305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4309), 1,
      sym__binary_star_star,
    ACTIONS(5334), 1,
      anon_sym_rescue,
    STATE(3559), 1,
      sym_heredoc_body,
    ACTIONS(4297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4281), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [101743] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5432), 1,
      anon_sym_rescue,
    STATE(3560), 1,
      sym_heredoc_body,
    STATE(3654), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101828] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5354), 1,
      anon_sym_rescue,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3554), 1,
      aux_sym_exceptions_repeat1,
    STATE(3561), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101917] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_COLON,
    STATE(3562), 1,
      sym_heredoc_body,
    ACTIONS(2632), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101970] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_COLON,
    STATE(3563), 1,
      sym_heredoc_body,
    ACTIONS(2644), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102023] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5442), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_QMARK,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3564), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [102106] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_COLON,
    STATE(3565), 1,
      sym_heredoc_body,
    ACTIONS(2632), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2634), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102159] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3566), 1,
      sym_heredoc_body,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102214] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3567), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102267] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3568), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102320] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3569), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102381] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3570), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102440] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3571), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102505] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5466), 1,
      anon_sym_COMMA,
    STATE(3572), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102558] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3573), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [102631] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3574), 1,
      sym_heredoc_body,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102688] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3575), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [102761] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5045), 1,
      anon_sym_COMMA,
    STATE(3274), 1,
      aux_sym_exceptions_repeat1,
    STATE(3576), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102816] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3577), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102869] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(311), 1,
      sym__string_start,
    ACTIONS(5469), 1,
      anon_sym_COLON,
    STATE(2848), 1,
      aux_sym_chained_string_repeat1,
    STATE(2891), 1,
      sym_string,
    STATE(3578), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102928] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3579), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102981] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5442), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3580), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [103062] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_COLON,
    STATE(3581), 1,
      sym_heredoc_body,
    ACTIONS(2644), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2646), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103115] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5471), 1,
      anon_sym_COMMA,
    STATE(3582), 1,
      sym_heredoc_body,
    STATE(3599), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103170] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(5332), 1,
      anon_sym_rescue,
    STATE(3583), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [103255] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5442), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_QMARK,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3584), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [103338] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5442), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_QMARK,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3585), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [103421] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5442), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3586), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [103502] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5442), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_QMARK,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3587), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [103585] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5436), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5442), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_QMARK,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3588), 1,
      sym_heredoc_body,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [103668] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3589), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [103749] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3590), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [103830] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3591), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [103911] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_COMMA,
    STATE(3592), 1,
      sym_heredoc_body,
    STATE(3593), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103966] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5475), 1,
      anon_sym_COMMA,
    STATE(3593), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104019] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5304), 1,
      anon_sym_COMMA,
    STATE(3572), 1,
      aux_sym_exceptions_repeat1,
    STATE(3594), 1,
      sym_heredoc_body,
    ACTIONS(4047), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104074] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3594), 1,
      aux_sym_exceptions_repeat1,
    STATE(3595), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104127] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(5332), 1,
      anon_sym_rescue,
    STATE(3596), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [104212] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    STATE(3597), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [104293] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3598), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104346] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5478), 1,
      anon_sym_COMMA,
    STATE(3599), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104399] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5481), 1,
      sym__binary_star_star,
    STATE(3600), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104452] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5304), 1,
      anon_sym_COMMA,
    STATE(3594), 1,
      aux_sym_exceptions_repeat1,
    STATE(3601), 1,
      sym_heredoc_body,
    ACTIONS(3431), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104507] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5434), 1,
      anon_sym_PIPE,
    ACTIONS(5438), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5454), 1,
      anon_sym_GT_EQ,
    ACTIONS(5460), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5464), 1,
      sym__binary_star_star,
    STATE(3602), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5452), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5456), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5440), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5458), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5462), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [104582] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5483), 1,
      anon_sym_COMMA,
    STATE(3603), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104634] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5486), 1,
      anon_sym_rescue,
    ACTIONS(5488), 1,
      anon_sym_COMMA,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3604), 1,
      sym_heredoc_body,
    STATE(3844), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104722] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(5324), 1,
      anon_sym_rescue,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3605), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [104806] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5554), 1,
      anon_sym_rescue,
    STATE(3606), 1,
      sym_heredoc_body,
    STATE(3830), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [104894] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3607), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [104972] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3608), 1,
      sym_heredoc_body,
    ACTIONS(3649), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3647), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105022] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3609), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105076] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_rescue,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3610), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [105160] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5432), 1,
      anon_sym_rescue,
    STATE(3611), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105242] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3612), 1,
      sym_heredoc_body,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__line_break,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105296] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3613), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105348] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3614), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105400] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3615), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105460] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5354), 1,
      anon_sym_rescue,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3616), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105546] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3617), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105604] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5586), 1,
      anon_sym_rescue,
    ACTIONS(5588), 1,
      anon_sym_COMMA,
    STATE(3618), 1,
      sym_heredoc_body,
    STATE(3830), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [105690] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3619), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105754] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3620), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105834] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5590), 1,
      anon_sym_COMMA,
    STATE(3621), 1,
      sym_heredoc_body,
    STATE(3693), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105888] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3622), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105968] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    STATE(3623), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [106048] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3624), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [106126] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5354), 1,
      anon_sym_rescue,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3625), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106208] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3626), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106288] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(5349), 1,
      anon_sym_rescue,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3627), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [106372] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3628), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [106456] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5598), 1,
      sym__binary_star_star,
    STATE(3629), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106508] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3630), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [106582] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3631), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [106654] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3632), 1,
      sym_heredoc_body,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106710] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3633), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [106782] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3634), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106834] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3635), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106914] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5426), 1,
      anon_sym_rescue,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3636), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [107000] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3637), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107080] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3638), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107160] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3639), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [107238] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3640), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107318] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3641), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [107400] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3642), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107480] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3643), 1,
      sym_heredoc_body,
    ACTIONS(3313), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3311), 27,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107530] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3644), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107614] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3645), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107694] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3646), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [107774] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3647), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107858] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3621), 1,
      aux_sym_exceptions_repeat1,
    STATE(3648), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107910] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    STATE(3649), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107962] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    ACTIONS(5600), 1,
      anon_sym_EQ_GT,
    STATE(3650), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [108046] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3651), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108098] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3652), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [108178] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(3653), 1,
      sym_heredoc_body,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4486), 1,
      sym__hash_pattern_any_rest,
    STATE(5801), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5602), 2,
      sym_constant,
      sym_identifier,
    STATE(4508), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5836), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5604), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5606), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [108248] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_COMMA,
    STATE(3654), 1,
      sym_heredoc_body,
    STATE(3658), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108302] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3655), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [108382] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3656), 1,
      sym_heredoc_body,
    STATE(3730), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108434] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5610), 1,
      anon_sym_COMMA,
    STATE(3657), 1,
      sym_heredoc_body,
    STATE(3730), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108488] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5612), 1,
      anon_sym_COMMA,
    STATE(3658), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108540] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3659), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [108620] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    ACTIONS(5615), 1,
      anon_sym_rescue,
    STATE(3660), 1,
      sym_heredoc_body,
    STATE(3730), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [108706] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    STATE(3661), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108760] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3662), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [108838] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3663), 1,
      sym_heredoc_body,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108892] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3664), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108944] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3665), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108996] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3666), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [109076] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5426), 1,
      anon_sym_rescue,
    STATE(3667), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [109158] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3668), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109218] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5554), 1,
      anon_sym_rescue,
    STATE(3669), 1,
      sym_heredoc_body,
    STATE(3830), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [109302] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3670), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109360] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_QMARK,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3671), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109442] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_QMARK,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3672), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109524] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3673), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [109604] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_QMARK,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3674), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109686] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5649), 1,
      sym__binary_star_star,
    STATE(3675), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109738] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_rescue,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3676), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [109820] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3677), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [109898] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    ACTIONS(5651), 1,
      anon_sym_rescue,
    STATE(3678), 1,
      sym_heredoc_body,
    STATE(3844), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109984] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3679), 1,
      sym_heredoc_body,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110038] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3680), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110090] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3681), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110142] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    ACTIONS(5302), 1,
      anon_sym_rescue,
    STATE(3682), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [110226] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3683), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [110308] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3684), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110360] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3685), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110420] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3686), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110478] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3687), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110542] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3688), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [110616] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3689), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [110696] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5653), 1,
      anon_sym_EQ_GT,
    STATE(3690), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [110780] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3691), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [110864] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5655), 1,
      sym__binary_star_star,
    STATE(3692), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110916] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5657), 1,
      anon_sym_COMMA,
    STATE(3693), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110968] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3694), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111032] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3695), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [111112] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3696), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [111186] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3697), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [111258] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3698), 1,
      sym_heredoc_body,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111314] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3699), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [111386] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5660), 1,
      sym__binary_star_star,
    STATE(3700), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111438] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3701), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111490] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3702), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [111568] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3703), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [111652] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3704), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [111732] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3705), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [111804] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    STATE(3706), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111860] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3707), 1,
      sym_heredoc_body,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111916] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3708), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [111988] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(4710), 1,
      sym__binary_star_star,
    ACTIONS(4748), 1,
      anon_sym_PIPE,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4758), 1,
      anon_sym_GT_EQ,
    ACTIONS(4760), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4770), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4772), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4776), 1,
      anon_sym_QMARK,
    ACTIONS(5302), 1,
      anon_sym_rescue,
    STATE(3709), 1,
      sym_heredoc_body,
    ACTIONS(4706), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4708), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4762), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112072] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3710), 1,
      sym_heredoc_body,
    ACTIONS(3579), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3477), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112122] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5586), 1,
      anon_sym_rescue,
    ACTIONS(5588), 1,
      anon_sym_COMMA,
    STATE(3711), 1,
      sym_heredoc_body,
    STATE(3830), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112212] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3712), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 10,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [112292] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3713), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112344] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3714), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [112424] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_QMARK,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3715), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112506] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3716), 1,
      sym_heredoc_body,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112560] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3717), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112612] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3718), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112664] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3719), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112724] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3720), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112782] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3721), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112846] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3722), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [112920] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3723), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [112992] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3724), 1,
      sym_heredoc_body,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113048] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3725), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [113120] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3726), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113172] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3727), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113224] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(5324), 1,
      anon_sym_rescue,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3728), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [113308] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(3729), 1,
      sym_heredoc_body,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4496), 1,
      sym__hash_pattern_any_rest,
    STATE(5801), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5602), 2,
      sym_constant,
      sym_identifier,
    STATE(4508), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5836), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5662), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5664), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [113378] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5610), 1,
      anon_sym_COMMA,
    STATE(3603), 1,
      aux_sym_exceptions_repeat1,
    STATE(3730), 1,
      sym_heredoc_body,
    ACTIONS(4047), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113432] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3731), 1,
      sym_heredoc_body,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113486] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3732), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113538] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3733), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113590] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3734), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113650] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3735), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113708] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3736), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113772] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3737), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [113846] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3738), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [113918] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3739), 1,
      sym_heredoc_body,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113974] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3740), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 14,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [114046] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3741), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114126] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3654), 1,
      aux_sym_exceptions_repeat1,
    STATE(3742), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114178] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3743), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114230] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3744), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114314] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3745), 1,
      sym_heredoc_body,
    ACTIONS(3305), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 27,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114364] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3746), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114416] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3747), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114466] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3748), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114546] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3749), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [114628] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3750), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [114710] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3751), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114790] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3752), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 10,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [114870] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_QMARK,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3753), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [114952] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(3754), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [115032] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    STATE(3755), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [115114] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3756), 1,
      sym_heredoc_body,
    ACTIONS(3094), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3092), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115164] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    ACTIONS(5610), 1,
      anon_sym_COMMA,
    ACTIONS(5666), 1,
      anon_sym_rescue,
    STATE(3730), 1,
      aux_sym_exceptions_repeat1,
    STATE(3757), 1,
      sym_heredoc_body,
    ACTIONS(3431), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115252] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3758), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115308] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_QMARK,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3759), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [115390] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5617), 1,
      anon_sym_PIPE,
    ACTIONS(5619), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5621), 1,
      anon_sym_AMP,
    ACTIONS(5625), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5627), 1,
      anon_sym_CARET,
    ACTIONS(5629), 1,
      anon_sym_QMARK,
    ACTIONS(5631), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5637), 1,
      anon_sym_GT_EQ,
    ACTIONS(5643), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5647), 1,
      sym__binary_star_star,
    STATE(3760), 1,
      sym_heredoc_body,
    ACTIONS(5635), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5639), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5623), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5641), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5645), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [115472] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    STATE(3761), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115527] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    STATE(3762), 1,
      sym_heredoc_body,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115580] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5674), 1,
      sym__binary_star_star,
    STATE(3763), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115631] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3764), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [115710] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    STATE(3765), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [115793] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    STATE(3766), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [115876] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    STATE(3767), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115927] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    STATE(3768), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115978] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3769), 1,
      sym_heredoc_body,
    ACTIONS(4090), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 8,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [116057] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3770), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116108] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    STATE(3771), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116159] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    ACTIONS(5615), 1,
      anon_sym_rescue,
    STATE(3772), 1,
      sym_heredoc_body,
    ACTIONS(3435), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116242] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5554), 1,
      anon_sym_rescue,
    STATE(3773), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [116327] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    STATE(3774), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116378] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    STATE(3775), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116437] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5720), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5726), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5730), 1,
      anon_sym_QMARK,
    ACTIONS(5732), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5734), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3776), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116518] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3777), 1,
      sym_heredoc_body,
    ACTIONS(4112), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116599] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3778), 1,
      sym_heredoc_body,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116652] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3779), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116703] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3780), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116754] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5752), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5760), 1,
      anon_sym_QMARK,
    ACTIONS(5762), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3781), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116835] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5752), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5760), 1,
      anon_sym_QMARK,
    ACTIONS(5762), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3782), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116916] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5752), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5762), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3783), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [116995] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5752), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5760), 1,
      anon_sym_QMARK,
    ACTIONS(5762), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3784), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [117076] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3785), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117135] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3786), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117192] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3787), 1,
      sym_heredoc_body,
    ACTIONS(3663), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [117273] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3788), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117336] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5752), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5760), 1,
      anon_sym_QMARK,
    ACTIONS(5762), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3789), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [117417] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3790), 1,
      sym_heredoc_body,
    STATE(3844), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117468] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4403), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4407), 1,
      anon_sym_AMP,
    ACTIONS(4411), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4413), 1,
      anon_sym_CARET,
    ACTIONS(4415), 1,
      anon_sym_QMARK,
    ACTIONS(4417), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4419), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4423), 1,
      anon_sym_GT_EQ,
    ACTIONS(4429), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4433), 1,
      sym__binary_star_star,
    ACTIONS(5554), 1,
      anon_sym_rescue,
    STATE(3791), 1,
      sym_heredoc_body,
    ACTIONS(4421), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4425), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4409), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4427), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4431), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [117549] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    STATE(3792), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117608] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3793), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [117681] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3794), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [117758] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3795), 1,
      sym_heredoc_body,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117811] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3796), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [117892] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    STATE(3797), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117949] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3798), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118000] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5488), 1,
      anon_sym_COMMA,
    STATE(3799), 1,
      sym_heredoc_body,
    STATE(3844), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118053] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3800), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 11,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [118124] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3801), 1,
      sym_heredoc_body,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118179] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3802), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [118258] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3803), 1,
      sym_heredoc_body,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118309] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    STATE(3804), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118372] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3805), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 11,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [118443] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3806), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118502] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3807), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118559] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3808), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [118638] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5752), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5762), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3809), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [118717] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3810), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [118796] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5752), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5760), 1,
      anon_sym_QMARK,
    ACTIONS(5762), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3811), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118877] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3812), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118928] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_COMMA,
    STATE(3813), 1,
      sym_heredoc_body,
    STATE(3830), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118981] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3814), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [119054] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    STATE(3815), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119111] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3816), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 11,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [119184] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3817), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119263] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    STATE(3818), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119326] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3819), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119405] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3820), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [119476] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3821), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119557] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3822), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119636] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5804), 1,
      sym__binary_star_star,
    STATE(3823), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119687] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    STATE(3824), 1,
      sym_heredoc_body,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119742] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3825), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119821] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3826), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [119900] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3827), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [119973] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3828), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120036] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(3829), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [120107] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5588), 1,
      anon_sym_COMMA,
    STATE(3830), 1,
      sym_heredoc_body,
    STATE(3870), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120160] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3831), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [120231] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3832), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120290] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5806), 1,
      sym__binary_star_star,
    STATE(3833), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120341] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5734), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3834), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [120414] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3835), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [120485] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3836), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [120564] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3837), 1,
      sym_heredoc_body,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120619] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3838), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120682] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    STATE(3839), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120733] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3840), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120790] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3841), 1,
      sym_heredoc_body,
    ACTIONS(4108), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 8,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [120869] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3842), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [120950] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    ACTIONS(5615), 1,
      anon_sym_rescue,
    STATE(3843), 1,
      sym_heredoc_body,
    ACTIONS(3791), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [121033] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5488), 1,
      anon_sym_COMMA,
    STATE(3844), 1,
      sym_heredoc_body,
    STATE(3866), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121086] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3845), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [121157] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3846), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [121228] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3847), 1,
      sym_heredoc_body,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121283] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3848), 1,
      sym_heredoc_body,
    ACTIONS(4056), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121334] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3849), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [121405] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3850), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121456] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3851), 1,
      sym_heredoc_body,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121509] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5720), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5726), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5730), 1,
      anon_sym_QMARK,
    ACTIONS(5732), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5734), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3852), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [121590] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3853), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [121669] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3854), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121720] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3855), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [121801] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3856), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121852] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    STATE(3857), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121903] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3858), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [121982] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(5432), 1,
      anon_sym_rescue,
    STATE(3654), 1,
      aux_sym_exceptions_repeat1,
    STATE(3859), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122069] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3860), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [122148] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    ACTIONS(5651), 1,
      anon_sym_rescue,
    STATE(3861), 1,
      sym_heredoc_body,
    ACTIONS(3435), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [122231] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5808), 1,
      sym__binary_star_star,
    STATE(3862), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122282] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    STATE(3863), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [122365] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3864), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [122442] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    STATE(3865), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122493] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5810), 1,
      anon_sym_COMMA,
    STATE(3866), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122544] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5813), 1,
      anon_sym_EQ_GT,
    STATE(3867), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [122627] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    ACTIONS(5651), 1,
      anon_sym_rescue,
    STATE(3868), 1,
      sym_heredoc_body,
    ACTIONS(3791), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3789), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [122710] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5815), 1,
      sym__binary_star_star,
    STATE(3869), 1,
      sym_heredoc_body,
    ACTIONS(3775), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122761] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5817), 1,
      anon_sym_COMMA,
    STATE(3870), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122812] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    STATE(3871), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122863] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3872), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122914] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    STATE(3873), 1,
      sym_heredoc_body,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122967] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3830), 1,
      aux_sym_exceptions_repeat1,
    STATE(3874), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123018] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3875), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [123099] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    STATE(3876), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123152] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    STATE(3877), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123207] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_DOT,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5720), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5726), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5730), 1,
      anon_sym_QMARK,
    ACTIONS(5732), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5734), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3878), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [123288] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3879), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [123367] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3880), 1,
      sym_heredoc_body,
    ACTIONS(3873), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123418] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3881), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123469] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_rescue,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3882), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123556] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5720), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5726), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5730), 1,
      anon_sym_QMARK,
    ACTIONS(5732), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5734), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3883), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [123637] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3884), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [123714] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_DOT,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5720), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5726), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5732), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5734), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3885), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [123793] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_DOT,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5720), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5726), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5730), 1,
      anon_sym_QMARK,
    ACTIONS(5732), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5734), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3886), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [123874] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_DOT,
    ACTIONS(5718), 1,
      anon_sym_PIPE,
    ACTIONS(5720), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5722), 1,
      anon_sym_AMP,
    ACTIONS(5726), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5728), 1,
      anon_sym_CARET,
    ACTIONS(5732), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5734), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5738), 1,
      anon_sym_GT_EQ,
    ACTIONS(5744), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5748), 1,
      sym__binary_star_star,
    STATE(3887), 1,
      sym_heredoc_body,
    ACTIONS(5736), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5740), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5724), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5742), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5746), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [123953] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3888), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [124030] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3889), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [124101] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3890), 1,
      sym_heredoc_body,
    ACTIONS(4100), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [124181] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3891), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [124259] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3892), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124337] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3893), 1,
      sym_heredoc_body,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [124409] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3894), 1,
      sym_heredoc_body,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124467] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3895), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [124547] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3896), 1,
      sym_heredoc_body,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [124617] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5916), 1,
      anon_sym_EQ_GT,
    STATE(3897), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [124699] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    ACTIONS(5918), 1,
      anon_sym_rescue,
    ACTIONS(5920), 1,
      anon_sym_COMMA,
    STATE(3898), 1,
      sym_heredoc_body,
    STATE(4045), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124783] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5608), 1,
      anon_sym_COMMA,
    ACTIONS(5922), 1,
      anon_sym_rescue,
    STATE(3654), 1,
      aux_sym_exceptions_repeat1,
    STATE(3899), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124867] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3900), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124945] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3901), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [125025] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3902), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [125105] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3903), 1,
      sym_heredoc_body,
    ACTIONS(4090), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 7,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [125183] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3904), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [125263] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3905), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [125343] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3906), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [125421] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3907), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125475] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3908), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [125553] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3909), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125603] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    ACTIONS(5924), 1,
      anon_sym_COMMA,
    STATE(3910), 1,
      sym_heredoc_body,
    STATE(5215), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5928), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5926), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125687] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3911), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125737] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_rescue,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3912), 1,
      sym_heredoc_body,
    ACTIONS(3435), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3433), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125819] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3913), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [125897] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3914), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [125979] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3915), 1,
      sym_heredoc_body,
    ACTIONS(4112), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [126059] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    ACTIONS(5930), 1,
      anon_sym_EQ_GT,
    STATE(3916), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [126141] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3917), 1,
      sym_heredoc_body,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126197] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3918), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126247] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3919), 1,
      sym_heredoc_body,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126299] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3920), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [126377] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3921), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126427] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3922), 1,
      sym_heredoc_body,
    ACTIONS(4108), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [126505] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_rescue,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3923), 1,
      sym_heredoc_body,
    ACTIONS(3791), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126587] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3924), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [126665] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3925), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126719] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    ACTIONS(5932), 1,
      anon_sym_rescue,
    STATE(3926), 1,
      sym_heredoc_body,
    STATE(4045), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3429), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [126801] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3927), 1,
      sym_heredoc_body,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126855] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3928), 1,
      sym_heredoc_body,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [126925] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3929), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126975] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3930), 1,
      sym_heredoc_body,
    ACTIONS(4108), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 7,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [127053] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    STATE(3931), 1,
      sym_heredoc_body,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127115] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3932), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [127197] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3933), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [127275] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3934), 1,
      sym_heredoc_body,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127327] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(5608), 1,
      anon_sym_COMMA,
    ACTIONS(5922), 1,
      anon_sym_rescue,
    STATE(3654), 1,
      aux_sym_exceptions_repeat1,
    STATE(3935), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3429), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127415] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3936), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127465] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3937), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [127543] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5486), 1,
      anon_sym_rescue,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3938), 1,
      sym_heredoc_body,
    ACTIONS(3791), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3789), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127625] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3939), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [127707] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3940), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [127785] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5471), 1,
      anon_sym_COMMA,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3941), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127837] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5934), 1,
      sym__binary_star_star,
    STATE(3942), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127887] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5936), 1,
      sym__binary_star_star,
    STATE(3943), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127937] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3944), 1,
      sym_heredoc_body,
    ACTIONS(4112), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [128017] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5938), 1,
      sym__binary_star_star,
    STATE(3945), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128067] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3946), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [128145] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3947), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128195] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3948), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128253] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3949), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [128331] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3950), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [128409] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_PIPE,
    ACTIONS(5558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5560), 1,
      anon_sym_AMP,
    ACTIONS(5564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5566), 1,
      anon_sym_CARET,
    ACTIONS(5568), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5574), 1,
      anon_sym_GT_EQ,
    ACTIONS(5580), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5584), 1,
      sym__binary_star_star,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(3951), 1,
      sym_heredoc_body,
    ACTIONS(5572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5576), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5578), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5582), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [128487] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3952), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128549] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3953), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 11,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [128621] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3954), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [128691] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5940), 1,
      sym__binary_star_star,
    STATE(3955), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128741] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3956), 1,
      sym_heredoc_body,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128795] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3957), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128845] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_PIPE,
    ACTIONS(5358), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5360), 1,
      anon_sym_AMP,
    ACTIONS(5364), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5366), 1,
      anon_sym_CARET,
    ACTIONS(5368), 1,
      anon_sym_QMARK,
    ACTIONS(5370), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5372), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5376), 1,
      anon_sym_GT_EQ,
    ACTIONS(5382), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5386), 1,
      sym__binary_star_star,
    STATE(3958), 1,
      sym_heredoc_body,
    ACTIONS(5374), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5378), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5362), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5380), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5384), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [128923] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3959), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [129003] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3960), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [129083] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3961), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [129153] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(5432), 1,
      anon_sym_rescue,
    STATE(3962), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3433), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129237] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3963), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [129315] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3964), 1,
      sym_heredoc_body,
    ACTIONS(4090), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [129393] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3965), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [129473] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_rescue,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    STATE(3966), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3433), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129557] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3967), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4395), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [129639] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(5471), 1,
      anon_sym_COMMA,
    ACTIONS(5942), 1,
      anon_sym_rescue,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3968), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3429), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129727] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3969), 1,
      sym_heredoc_body,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129779] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_in,
    ACTIONS(4285), 1,
      anon_sym_EQ_GT,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    ACTIONS(5586), 1,
      anon_sym_rescue,
    STATE(3970), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3433), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129863] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3971), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [129939] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3972), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [130021] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3973), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130071] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3974), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [130153] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5486), 1,
      anon_sym_rescue,
    ACTIONS(5884), 1,
      anon_sym_PIPE,
    ACTIONS(5886), 1,
      anon_sym_AMP,
    ACTIONS(5890), 1,
      anon_sym_CARET,
    ACTIONS(5892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5896), 1,
      anon_sym_GT_EQ,
    ACTIONS(5902), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5906), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_QMARK,
    ACTIONS(5914), 1,
      anon_sym_PIPE_PIPE,
    STATE(3975), 1,
      sym_heredoc_body,
    ACTIONS(3435), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5894), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5898), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5888), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5900), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3433), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5904), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130235] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3976), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130285] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_PIPE,
    ACTIONS(4509), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4511), 1,
      anon_sym_AMP,
    ACTIONS(4515), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4517), 1,
      anon_sym_CARET,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    ACTIONS(4521), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4523), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4527), 1,
      anon_sym_GT_EQ,
    ACTIONS(4533), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4537), 1,
      sym__binary_star_star,
    ACTIONS(5586), 1,
      anon_sym_rescue,
    STATE(3977), 1,
      sym_heredoc_body,
    ACTIONS(4525), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4529), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4513), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4531), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4535), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [130365] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3978), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130423] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3979), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130479] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3980), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130541] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3981), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [130613] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5822), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5828), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_QMARK,
    ACTIONS(5834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5836), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3982), 1,
      sym_heredoc_body,
    ACTIONS(3663), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [130693] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    ACTIONS(5471), 1,
      anon_sym_COMMA,
    ACTIONS(5942), 1,
      anon_sym_rescue,
    STATE(3582), 1,
      aux_sym_exceptions_repeat1,
    STATE(3983), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130777] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3984), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [130847] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3985), 1,
      sym_heredoc_body,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130901] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_PIPE,
    ACTIONS(5824), 1,
      anon_sym_AMP,
    ACTIONS(5830), 1,
      anon_sym_CARET,
    ACTIONS(5840), 1,
      anon_sym_GT_EQ,
    ACTIONS(5846), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3986), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5842), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5826), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5844), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5848), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [130971] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3987), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131021] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3988), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [131097] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym__binary_star_star,
    STATE(3989), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131147] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3990), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131203] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(3991), 1,
      sym_heredoc_body,
    ACTIONS(4096), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4094), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131282] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(3992), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131363] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(3993), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5928), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4098), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131442] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5976), 1,
      sym__binary_star_star,
    STATE(3994), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131491] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(3995), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [131568] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3996), 1,
      sym_heredoc_body,
    STATE(4045), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131617] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(3997), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [131692] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(3998), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [131767] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(3999), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [131844] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4000), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131901] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(4001), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [131978] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4002), 1,
      sym_heredoc_body,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132029] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6010), 1,
      sym__binary_star_star,
    STATE(4003), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132078] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4004), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132127] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4005), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132176] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4006), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132231] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5920), 1,
      anon_sym_COMMA,
    STATE(4007), 1,
      sym_heredoc_body,
    STATE(4045), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132282] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4008), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132331] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4009), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132410] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4010), 1,
      sym_heredoc_body,
    ACTIONS(3873), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132489] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4011), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132550] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4012), 1,
      sym_heredoc_body,
    ACTIONS(4090), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 6,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [132627] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4013), 1,
      sym_heredoc_body,
    ACTIONS(4084), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4082), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132706] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4014), 1,
      sym_heredoc_body,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132755] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    ACTIONS(6012), 1,
      anon_sym_EQ_GT,
    STATE(4015), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132836] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(4016), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [132913] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4017), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132970] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6014), 1,
      anon_sym_COMMA,
    STATE(4018), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133019] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(4019), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [133096] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4020), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133151] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4021), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 15,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133212] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4022), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [133283] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4023), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133364] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(4024), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133445] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4025), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [133514] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4026), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5928), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3661), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133593] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4027), 1,
      sym_heredoc_body,
    ACTIONS(4108), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 6,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [133670] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(4028), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [133747] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(4029), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [133824] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4030), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133877] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_COMMA,
    STATE(3654), 1,
      aux_sym_exceptions_repeat1,
    STATE(4031), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133928] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4032), 1,
      sym_heredoc_body,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133981] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4033), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134034] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    ACTIONS(6017), 1,
      anon_sym_EQ_GT,
    STATE(4034), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134115] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4035), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134196] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4036), 1,
      sym_heredoc_body,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134247] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5069), 1,
      anon_sym_PIPE,
    ACTIONS(5071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5073), 1,
      anon_sym_AMP,
    ACTIONS(5077), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_QMARK,
    ACTIONS(5083), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5085), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5089), 1,
      anon_sym_GT_EQ,
    ACTIONS(5095), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5099), 1,
      sym__binary_star_star,
    ACTIONS(5932), 1,
      anon_sym_rescue,
    STATE(4037), 1,
      sym_heredoc_body,
    ACTIONS(5087), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5091), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5075), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5093), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5097), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3433), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [134326] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4038), 1,
      sym_heredoc_body,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4084), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [134395] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4039), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134444] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(4040), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134525] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4041), 1,
      sym_heredoc_body,
    ACTIONS(4056), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134574] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4042), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134623] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(4043), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [134700] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(4044), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [134777] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5920), 1,
      anon_sym_COMMA,
    STATE(4018), 1,
      aux_sym_exceptions_repeat1,
    STATE(4045), 1,
      sym_heredoc_body,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134828] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4046), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [134899] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(4047), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [134976] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT,
    ACTIONS(5522), 1,
      anon_sym_PIPE,
    ACTIONS(5524), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5526), 1,
      anon_sym_AMP,
    ACTIONS(5530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5532), 1,
      anon_sym_CARET,
    ACTIONS(5534), 1,
      anon_sym_QMARK,
    ACTIONS(5536), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5542), 1,
      anon_sym_GT_EQ,
    ACTIONS(5548), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5552), 1,
      sym__binary_star_star,
    ACTIONS(6019), 1,
      anon_sym_rescue,
    STATE(4048), 1,
      sym_heredoc_body,
    ACTIONS(5540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5544), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6021), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3789), 3,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(5528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5546), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5550), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135059] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4049), 1,
      sym_heredoc_body,
    ACTIONS(3873), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135108] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_PIPE,
    ACTIONS(5946), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5948), 1,
      anon_sym_AMP,
    ACTIONS(5952), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5954), 1,
      anon_sym_CARET,
    ACTIONS(5956), 1,
      anon_sym_QMARK,
    ACTIONS(5958), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5964), 1,
      anon_sym_GT_EQ,
    ACTIONS(5970), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5974), 1,
      sym__binary_star_star,
    STATE(4050), 1,
      sym_heredoc_body,
    ACTIONS(4112), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5962), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5966), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5950), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5968), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4110), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5972), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135187] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4051), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [135256] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4052), 1,
      sym_heredoc_body,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135309] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    STATE(4053), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [135378] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_in,
    ACTIONS(5594), 1,
      anon_sym_EQ_GT,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(4054), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4395), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135459] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6023), 1,
      anon_sym_rescue,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4055), 1,
      sym_heredoc_body,
    STATE(4186), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135539] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(4056), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [135615] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    STATE(4057), 1,
      sym_heredoc_body,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135665] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    STATE(4058), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135713] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    STATE(4059), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135761] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    STATE(4060), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135817] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    STATE(4061), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135871] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    STATE(4062), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135931] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    STATE(4063), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [136001] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(4064), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [136077] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(4065), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [136153] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4066), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [136229] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4067), 1,
      sym_heredoc_body,
    STATE(4069), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136277] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    STATE(4068), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [136345] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6089), 1,
      anon_sym_COMMA,
    STATE(4069), 1,
      sym_heredoc_body,
    STATE(4085), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136395] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_DOT,
    ACTIONS(5706), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_AMP,
    ACTIONS(5750), 1,
      anon_sym_PIPE,
    ACTIONS(5752), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5758), 1,
      anon_sym_CARET,
    ACTIONS(5760), 1,
      anon_sym_QMARK,
    ACTIONS(5762), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5768), 1,
      anon_sym_EQ_EQ,
    STATE(4070), 1,
      sym_heredoc_body,
    ACTIONS(5712), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5714), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6091), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4110), 3,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(5716), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5754), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136475] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    STATE(4071), 1,
      sym_heredoc_body,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136527] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    STATE(4072), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [136595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4073), 1,
      sym_heredoc_body,
    ACTIONS(2638), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(2636), 19,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [136641] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    STATE(4074), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136689] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4075), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [136765] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    STATE(4076), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136813] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4077), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [136887] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4078), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4444), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136965] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4079), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4440), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137043] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5922), 1,
      anon_sym_rescue,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4080), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3433), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137121] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4081), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [137197] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4082), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4395), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137277] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    STATE(4083), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137329] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4084), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [137405] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_COMMA,
    STATE(4085), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137453] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4086), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3871), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137533] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4087), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3871), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137613] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4088), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5928), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6098), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137691] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4089), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [137765] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4090), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [137841] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    STATE(4091), 1,
      sym_heredoc_body,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137891] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    STATE(4092), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137939] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    STATE(4093), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137987] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    STATE(4094), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138043] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(4095), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [138119] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    STATE(4096), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138179] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    STATE(4097), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [138249] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    STATE(4098), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [138317] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    STATE(4099), 1,
      sym_heredoc_body,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138369] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    STATE(4100), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [138437] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    STATE(4101), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138485] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6128), 1,
      anon_sym_QMARK,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4102), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [138561] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6128), 1,
      anon_sym_QMARK,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4103), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3871), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [138637] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4104), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [138711] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6128), 1,
      anon_sym_QMARK,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4105), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [138787] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6128), 1,
      anon_sym_QMARK,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4106), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [138863] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6128), 1,
      anon_sym_QMARK,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4107), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4110), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [138939] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6089), 1,
      anon_sym_COMMA,
    STATE(4069), 1,
      aux_sym_exceptions_repeat1,
    STATE(4108), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138989] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    STATE(4109), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139037] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6128), 1,
      anon_sym_QMARK,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4110), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3661), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [139113] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    ACTIONS(6089), 1,
      anon_sym_COMMA,
    ACTIONS(6132), 1,
      anon_sym_rescue,
    STATE(4069), 1,
      aux_sym_exceptions_repeat1,
    STATE(4111), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3429), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139195] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_rescue,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4112), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3433), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139273] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4113), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4094), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [139349] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4114), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [139423] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(5922), 1,
      anon_sym_rescue,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4115), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3433), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139505] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    ACTIONS(6104), 1,
      anon_sym_AMP,
    ACTIONS(6110), 1,
      anon_sym_PIPE,
    ACTIONS(6112), 1,
      anon_sym_CARET,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_GT_EQ,
    ACTIONS(6120), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6124), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6126), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6128), 1,
      anon_sym_QMARK,
    ACTIONS(6130), 1,
      anon_sym_PIPE_PIPE,
    STATE(4116), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6114), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6122), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4098), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [139581] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4117), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4452), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [139657] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4118), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4454), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [139733] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4119), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4444), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [139809] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4120), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4440), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [139885] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    ACTIONS(6134), 1,
      anon_sym_rescue,
    ACTIONS(6136), 1,
      anon_sym_COMMA,
    STATE(4121), 1,
      sym_heredoc_body,
    STATE(4186), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3429), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139967] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_AMP,
    ACTIONS(5268), 1,
      sym__binary_star_star,
    ACTIONS(5272), 1,
      anon_sym_PIPE,
    ACTIONS(5274), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5278), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5280), 1,
      anon_sym_CARET,
    ACTIONS(5282), 1,
      anon_sym_QMARK,
    ACTIONS(5284), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5288), 1,
      anon_sym_GT_EQ,
    ACTIONS(5290), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5918), 1,
      anon_sym_rescue,
    STATE(4122), 1,
      sym_heredoc_body,
    ACTIONS(5262), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5264), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5266), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5276), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3433), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5292), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140045] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_PIPE,
    ACTIONS(5394), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5396), 1,
      anon_sym_AMP,
    ACTIONS(5400), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5402), 1,
      anon_sym_CARET,
    ACTIONS(5404), 1,
      anon_sym_QMARK,
    ACTIONS(5406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5408), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5412), 1,
      anon_sym_GT_EQ,
    ACTIONS(5418), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5422), 1,
      sym__binary_star_star,
    STATE(4123), 1,
      sym_heredoc_body,
    ACTIONS(5410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5414), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5398), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5416), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4442), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [140121] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_in,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(5942), 1,
      anon_sym_rescue,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4124), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3433), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140203] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    ACTIONS(6138), 1,
      anon_sym_rescue,
    STATE(4069), 1,
      aux_sym_exceptions_repeat1,
    STATE(4125), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3429), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140283] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4126), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4452), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140361] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__binary_star_star,
    STATE(4127), 1,
      sym_heredoc_body,
    ACTIONS(6106), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140415] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4128), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3871), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140494] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4129), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 6,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
  [140567] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4130), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4082), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140642] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4131), 1,
      sym_heredoc_body,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140691] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4132), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140738] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4133), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4452), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140813] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4134), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4454), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140888] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4135), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140935] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4136), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141010] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4137), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141057] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4138), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141112] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4139), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4110), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4140), 1,
      sym_heredoc_body,
    ACTIONS(3697), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(3699), 19,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [141232] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    ACTIONS(6138), 1,
      anon_sym_rescue,
    STATE(4141), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3433), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141309] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4142), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141356] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4143), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 6,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [141429] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4144), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 6,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
  [141502] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4145), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4094), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141577] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4146), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141630] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4147), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141705] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4148), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 15,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141764] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4149), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5928), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6204), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141841] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_PIPE,
    ACTIONS(5854), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5856), 1,
      anon_sym_AMP,
    ACTIONS(5860), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5862), 1,
      anon_sym_CARET,
    ACTIONS(5864), 1,
      anon_sym_QMARK,
    ACTIONS(5866), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5872), 1,
      anon_sym_GT_EQ,
    ACTIONS(5878), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5882), 1,
      sym__binary_star_star,
    STATE(4150), 1,
      sym_heredoc_body,
    ACTIONS(5870), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5874), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5928), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5858), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5876), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6206), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5880), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141918] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4151), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4444), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141993] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4152), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4440), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142068] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4153), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142143] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4154), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4442), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142218] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(239), 1,
      sym__terminator,
    STATE(4155), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6208), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142297] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4156), 1,
      sym_heredoc_body,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142346] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4157), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142393] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4158), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142440] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4159), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142495] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4160), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142548] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4161), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 15,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142607] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4162), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [142676] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4163), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3661), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142751] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4164), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [142818] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4165), 1,
      sym_heredoc_body,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142869] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4166), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [142936] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4167), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142983] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4168), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4454), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143060] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4169), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4098), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143137] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(4170), 1,
      sym_heredoc_body,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4442), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143212] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4171), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4098), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143287] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4172), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4110), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143362] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(4173), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6210), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6204), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143439] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5672), 1,
      sym__binary_star_star,
    ACTIONS(5676), 1,
      anon_sym_PIPE,
    ACTIONS(5678), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5680), 1,
      anon_sym_AMP,
    ACTIONS(5684), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5686), 1,
      anon_sym_CARET,
    ACTIONS(5688), 1,
      anon_sym_QMARK,
    ACTIONS(5690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 1,
      anon_sym_GT_EQ,
    ACTIONS(5698), 1,
      anon_sym_EQ_EQ,
    STATE(4174), 1,
      sym_heredoc_body,
    ACTIONS(5668), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5694), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6210), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5670), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5682), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6206), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(5700), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143516] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3287), 1,
      anon_sym_ri,
    STATE(4175), 1,
      sym_heredoc_body,
    ACTIONS(3283), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3285), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3281), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [143565] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4176), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 6,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [143638] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4177), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143685] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4178), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4106), 6,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [143758] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4179), 1,
      sym_heredoc_body,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 20,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143807] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4180), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143854] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4181), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143901] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4182), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143956] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6023), 1,
      anon_sym_rescue,
    ACTIONS(6025), 1,
      anon_sym_PIPE,
    ACTIONS(6027), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6029), 1,
      anon_sym_AMP,
    ACTIONS(6033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6035), 1,
      anon_sym_CARET,
    ACTIONS(6037), 1,
      anon_sym_QMARK,
    ACTIONS(6039), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6041), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6045), 1,
      anon_sym_GT_EQ,
    ACTIONS(6051), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6055), 1,
      sym__binary_star_star,
    STATE(4183), 1,
      sym_heredoc_body,
    ACTIONS(6043), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6047), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6031), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6049), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3433), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6053), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144033] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4184), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144086] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4185), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144145] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym_COMMA,
    STATE(4186), 1,
      sym_heredoc_body,
    STATE(4210), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4047), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4045), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144194] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4187), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [144263] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4188), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [144330] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4189), 1,
      sym_heredoc_body,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144381] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4190), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [144448] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4191), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144495] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym_COMMA,
    STATE(4186), 1,
      aux_sym_exceptions_repeat1,
    STATE(4192), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144544] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4193), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4082), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4194), 1,
      sym_heredoc_body,
    ACTIONS(3453), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(3455), 19,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [144664] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4195), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144739] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4196), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144814] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4197), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [144883] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4198), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [144950] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4199), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4088), 6,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [145023] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4200), 1,
      sym_heredoc_body,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145074] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4201), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6214), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6212), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145151] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4202), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145198] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4203), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 9,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [145265] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4204), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4082), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145340] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4205), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4094), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145415] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4186), 1,
      aux_sym_exceptions_repeat1,
    STATE(4206), 1,
      sym_heredoc_body,
    ACTIONS(3431), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3429), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145462] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(235), 1,
      sym__terminator,
    STATE(4207), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6208), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145541] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6172), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6176), 1,
      anon_sym_AMP,
    ACTIONS(6180), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6182), 1,
      anon_sym_CARET,
    ACTIONS(6184), 1,
      anon_sym_QMARK,
    ACTIONS(6186), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6188), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6192), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6202), 1,
      sym__binary_star_star,
    STATE(4208), 1,
      sym_heredoc_body,
    ACTIONS(6190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6194), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6178), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6196), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4094), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6200), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145616] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4209), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4395), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145695] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6216), 1,
      anon_sym_COMMA,
    STATE(4210), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3663), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145742] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4211), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145793] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_in,
    ACTIONS(5704), 1,
      anon_sym_EQ_GT,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4212), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3871), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145872] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4213), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145947] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5978), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5982), 1,
      anon_sym_AMP,
    ACTIONS(5986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5988), 1,
      anon_sym_CARET,
    ACTIONS(5990), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5996), 1,
      anon_sym_GT_EQ,
    ACTIONS(6002), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6006), 1,
      sym__binary_star_star,
    ACTIONS(6008), 1,
      anon_sym_QMARK,
    STATE(216), 1,
      sym__terminator,
    STATE(4214), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5994), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5998), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6208), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5984), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6000), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6004), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146026] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4215), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4110), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146101] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    STATE(4216), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146147] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4217), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146221] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4218), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4088), 5,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146293] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    STATE(4219), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146339] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    STATE(4220), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 14,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146397] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4221), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4110), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146471] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6271), 1,
      anon_sym_QMARK,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4222), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4094), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146545] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4223), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6204), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146621] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6271), 1,
      anon_sym_QMARK,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4224), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4110), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146695] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4225), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4082), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146769] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    STATE(4226), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146815] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    STATE(4227), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146861] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6271), 1,
      anon_sym_QMARK,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4228), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3871), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146935] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6271), 1,
      anon_sym_QMARK,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4229), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3871), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147009] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4230), 1,
      sym_heredoc_body,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4486), 1,
      sym__hash_pattern_any_rest,
    STATE(5754), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6283), 2,
      sym_constant,
      sym_identifier,
    STATE(4508), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5941), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5604), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5606), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [147073] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4231), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4106), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147145] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4232), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147191] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4233), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4106), 5,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147263] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4234), 1,
      sym_heredoc_body,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147311] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6132), 1,
      anon_sym_rescue,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4235), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3433), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147387] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4236), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147433] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4237), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 7,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [147501] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_PIPE,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    STATE(4238), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6206), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147577] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4239), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3871), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147651] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    STATE(4240), 1,
      sym_heredoc_body,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 19,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147699] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4241), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 15,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147753] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4242), 1,
      sym_heredoc_body,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4496), 1,
      sym__hash_pattern_any_rest,
    STATE(5754), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6283), 2,
      sym_constant,
      sym_identifier,
    STATE(4508), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5941), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5662), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5664), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [147817] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4243), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4088), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147889] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 15,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147943] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4245), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 15,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147995] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4246), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [148061] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4247), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 14,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148119] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6271), 1,
      anon_sym_QMARK,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4248), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4082), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148193] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4249), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4094), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148267] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4250), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 7,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [148335] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4251), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [148401] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4252), 1,
      sym_heredoc_body,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148451] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    ACTIONS(6285), 1,
      anon_sym_PIPE,
    STATE(4253), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6204), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148527] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5776), 1,
      anon_sym_AMP,
    ACTIONS(5780), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5782), 1,
      anon_sym_CARET,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    ACTIONS(5786), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5788), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5792), 1,
      anon_sym_GT_EQ,
    ACTIONS(5798), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5802), 1,
      sym__binary_star_star,
    ACTIONS(6287), 1,
      anon_sym_PIPE,
    STATE(4254), 1,
      sym_heredoc_body,
    ACTIONS(5790), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5794), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6093), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6206), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5778), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5796), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5800), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148603] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    STATE(4255), 1,
      sym_heredoc_body,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 17,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148653] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6271), 1,
      anon_sym_QMARK,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4256), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3661), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148727] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    STATE(4257), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 15,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148779] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4258), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [148845] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6134), 1,
      anon_sym_rescue,
    ACTIONS(6221), 1,
      anon_sym_PIPE,
    ACTIONS(6223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6225), 1,
      anon_sym_AMP,
    ACTIONS(6229), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6231), 1,
      anon_sym_CARET,
    ACTIONS(6233), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4259), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3433), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6227), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148921] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4260), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148967] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym__binary_star_star,
    ACTIONS(6061), 1,
      anon_sym_AMP,
    ACTIONS(6067), 1,
      anon_sym_PIPE,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6075), 1,
      anon_sym_GT_EQ,
    ACTIONS(6077), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6085), 1,
      anon_sym_QMARK,
    ACTIONS(6087), 1,
      anon_sym_PIPE_PIPE,
    STATE(4261), 1,
      sym_heredoc_body,
    ACTIONS(6063), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6065), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6057), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6071), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4442), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6079), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149041] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6265), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6269), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6271), 1,
      anon_sym_QMARK,
    ACTIONS(6273), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4262), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4098), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149115] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6219), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 1,
      anon_sym_AMP,
    ACTIONS(6257), 1,
      anon_sym_CARET,
    ACTIONS(6277), 1,
      anon_sym_GT_EQ,
    ACTIONS(6279), 1,
      anon_sym_EQ_EQ,
    STATE(4263), 1,
      sym_heredoc_body,
    ACTIONS(6259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6261), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6263), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6267), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6281), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 8,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [149181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6291), 1,
      anon_sym___END__,
    STATE(4264), 1,
      sym_heredoc_body,
    ACTIONS(745), 9,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6289), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [149227] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4265), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149273] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6293), 1,
      anon_sym_RPAREN,
    STATE(4266), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149348] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6311), 1,
      anon_sym_COLON2,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4267), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149423] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6333), 1,
      anon_sym_COLON2,
    STATE(4268), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149498] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6335), 1,
      anon_sym_COLON2,
    STATE(4269), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149573] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6337), 1,
      anon_sym_RPAREN,
    STATE(4270), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149648] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym___END__,
    STATE(4271), 1,
      sym_heredoc_body,
    ACTIONS(3014), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [149691] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym___END__,
    STATE(4272), 1,
      sym_heredoc_body,
    ACTIONS(3074), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [149734] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6339), 1,
      anon_sym_COLON2,
    STATE(4273), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149809] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6341), 1,
      anon_sym_COLON2,
    STATE(4274), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149884] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6343), 1,
      anon_sym_COLON2,
    STATE(4275), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149959] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6345), 1,
      anon_sym_COLON2,
    STATE(4276), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150034] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym___END__,
    STATE(4277), 1,
      sym_heredoc_body,
    ACTIONS(6347), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [150077] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6351), 1,
      anon_sym_COLON2,
    STATE(4278), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150152] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6353), 1,
      anon_sym_COLON2,
    STATE(4279), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150227] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6355), 1,
      anon_sym_COLON2,
    STATE(4280), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150302] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6357), 1,
      anon_sym_COLON2,
    STATE(4281), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150377] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4282), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3871), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150450] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6359), 1,
      anon_sym_COLON2,
    STATE(4283), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150525] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6361), 1,
      anon_sym_EQ_GT,
    STATE(4284), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150600] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6363), 1,
      anon_sym_RPAREN,
    STATE(4285), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150675] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4286), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3871), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150748] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4287), 1,
      sym_heredoc_body,
    ACTIONS(3873), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3871), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150793] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6365), 1,
      anon_sym_COLON2,
    STATE(4288), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150868] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym___END__,
    STATE(4289), 1,
      sym_heredoc_body,
    ACTIONS(2740), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [150911] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6367), 1,
      anon_sym_COLON2,
    STATE(4290), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150986] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4291), 1,
      sym_heredoc_body,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 18,
      sym__binary_minus,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151033] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4292), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151078] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4293), 1,
      sym_heredoc_body,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151123] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6369), 1,
      anon_sym_COLON2,
    STATE(4294), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151198] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6371), 1,
      anon_sym_COLON2,
    STATE(4295), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151273] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4296), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151326] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4297), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4106), 4,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151397] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4298), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4088), 4,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151468] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6373), 1,
      anon_sym_COLON2,
    STATE(4299), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151543] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym___END__,
    STATE(4300), 1,
      sym_heredoc_body,
    ACTIONS(3022), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [151586] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6375), 1,
      anon_sym_COLON2,
    STATE(4301), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151661] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4302), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151712] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3030), 1,
      anon_sym___END__,
    STATE(4303), 1,
      sym_heredoc_body,
    ACTIONS(3028), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [151755] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym___END__,
    STATE(4304), 1,
      sym_heredoc_body,
    ACTIONS(3032), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [151798] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym___END__,
    STATE(4305), 1,
      sym_heredoc_body,
    ACTIONS(3036), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [151841] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3042), 1,
      anon_sym___END__,
    STATE(4306), 1,
      sym_heredoc_body,
    ACTIONS(3040), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [151884] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4307), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151941] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4308), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4082), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152014] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4309), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [152081] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4310), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [152146] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4311), 1,
      sym_heredoc_body,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4084), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4082), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152195] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4312), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4082), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [152260] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6377), 1,
      anon_sym_COLON2,
    STATE(4313), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152335] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4314), 1,
      sym_heredoc_body,
    ACTIONS(4056), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4054), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152380] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6379), 1,
      anon_sym_COLON2,
    STATE(4315), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152455] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6381), 1,
      anon_sym_COLON2,
    STATE(4316), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152530] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6383), 1,
      anon_sym_COLON2,
    STATE(4317), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152605] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4318), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4094), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152678] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    STATE(4319), 1,
      sym_heredoc_body,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4110), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152751] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6385), 1,
      anon_sym_COLON2,
    STATE(4320), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152826] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6387), 1,
      anon_sym_COLON2,
    STATE(4321), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152901] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6389), 1,
      anon_sym_COLON2,
    STATE(4322), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152976] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym___END__,
    STATE(4323), 1,
      sym_heredoc_body,
    ACTIONS(3044), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153019] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym___END__,
    STATE(4324), 1,
      sym_heredoc_body,
    ACTIONS(3052), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153062] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3060), 1,
      anon_sym___END__,
    STATE(4325), 1,
      sym_heredoc_body,
    ACTIONS(3058), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153105] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6391), 1,
      anon_sym_COLON2,
    STATE(4326), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153180] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym___END__,
    STATE(4327), 1,
      sym_heredoc_body,
    ACTIONS(3066), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153223] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6393), 1,
      anon_sym_COLON2,
    STATE(4328), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153298] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6395), 1,
      anon_sym_COLON2,
    STATE(4329), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153373] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym___END__,
    STATE(4330), 1,
      sym_heredoc_body,
    ACTIONS(3070), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153416] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3004), 1,
      anon_sym___END__,
    STATE(4331), 1,
      sym_heredoc_body,
    ACTIONS(3002), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153459] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6397), 1,
      anon_sym_COLON2,
    STATE(4332), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153534] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6399), 1,
      anon_sym_COLON2,
    STATE(4333), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153609] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3020), 1,
      anon_sym___END__,
    STATE(4334), 1,
      sym_heredoc_body,
    ACTIONS(3018), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153652] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym___END__,
    STATE(4335), 1,
      sym_heredoc_body,
    ACTIONS(2998), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [153695] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6401), 1,
      anon_sym_COLON2,
    STATE(4336), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153770] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2968), 1,
      anon_sym___END__,
    STATE(4337), 1,
      sym_heredoc_body,
    ACTIONS(2970), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [153813] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6403), 1,
      anon_sym_COLON2,
    STATE(4338), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153888] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4339), 1,
      sym_heredoc_body,
    ACTIONS(3313), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3311), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [153931] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6405), 1,
      anon_sym_COLON2,
    STATE(4340), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154006] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6407), 1,
      anon_sym_COLON2,
    STATE(4341), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154081] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    STATE(4342), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4442), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154154] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6409), 1,
      anon_sym_COLON2,
    STATE(4343), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154229] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6411), 1,
      anon_sym_COLON2,
    STATE(4344), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154304] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6413), 1,
      anon_sym_COLON2,
    STATE(4345), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154379] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6415), 1,
      anon_sym_COLON2,
    STATE(4346), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154454] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6417), 1,
      anon_sym_COLON2,
    STATE(4347), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154529] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6419), 1,
      anon_sym_COLON2,
    STATE(4348), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154604] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6421), 1,
      anon_sym_COLON2,
    STATE(4349), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154679] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6423), 1,
      anon_sym_COLON2,
    STATE(4350), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154754] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6425), 1,
      anon_sym_RPAREN,
    STATE(4351), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154829] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6427), 1,
      anon_sym_COLON2,
    STATE(4352), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154904] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6429), 1,
      anon_sym_RPAREN,
    STATE(4353), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154979] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6431), 1,
      anon_sym_COLON2,
    STATE(4354), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155054] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6433), 1,
      anon_sym_RPAREN,
    STATE(4355), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155129] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6435), 1,
      anon_sym_RPAREN,
    STATE(4356), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155204] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6437), 1,
      anon_sym_COLON2,
    STATE(4357), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155279] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6439), 1,
      anon_sym_RPAREN,
    STATE(4358), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155354] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6443), 1,
      anon_sym___END__,
    ACTIONS(6445), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6447), 1,
      anon_sym_LBRACK2,
    ACTIONS(6449), 1,
      anon_sym_LPAREN2,
    STATE(4359), 1,
      sym_heredoc_body,
    ACTIONS(6441), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155403] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6451), 1,
      anon_sym_RPAREN,
    STATE(4360), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155478] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6453), 1,
      anon_sym_RPAREN,
    STATE(4361), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155553] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6455), 1,
      anon_sym_RPAREN,
    STATE(4362), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155628] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6457), 1,
      anon_sym_RPAREN,
    STATE(4363), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155703] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6459), 1,
      anon_sym_RPAREN,
    STATE(4364), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155778] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6297), 1,
      anon_sym_PIPE,
    ACTIONS(6299), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6301), 1,
      anon_sym_AMP,
    ACTIONS(6305), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6307), 1,
      anon_sym_CARET,
    ACTIONS(6309), 1,
      anon_sym_QMARK,
    ACTIONS(6315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6321), 1,
      anon_sym_GT_EQ,
    ACTIONS(6327), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6331), 1,
      sym__binary_star_star,
    ACTIONS(6461), 1,
      anon_sym_COLON2,
    STATE(4365), 1,
      sym_heredoc_body,
    ACTIONS(6313), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6319), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6323), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6303), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6325), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6329), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155853] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6463), 1,
      anon_sym_RPAREN,
    STATE(4366), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155928] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4367), 1,
      sym_heredoc_body,
    ACTIONS(3305), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155971] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6467), 1,
      anon_sym___END__,
    STATE(4368), 1,
      sym_heredoc_body,
    ACTIONS(6465), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156014] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6469), 1,
      anon_sym_RPAREN,
    STATE(4369), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156089] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6471), 1,
      anon_sym_RPAREN,
    STATE(4370), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156164] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6473), 1,
      anon_sym_RPAREN,
    STATE(4371), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156239] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6475), 1,
      anon_sym_RPAREN,
    STATE(4372), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156314] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6477), 1,
      anon_sym_RPAREN,
    STATE(4373), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156389] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6479), 1,
      anon_sym_RPAREN,
    STATE(4374), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156464] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6481), 1,
      anon_sym_RPAREN,
    STATE(4375), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156539] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6483), 1,
      anon_sym_RPAREN,
    STATE(4376), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156614] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6485), 1,
      anon_sym_RPAREN,
    STATE(4377), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156689] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6144), 1,
      anon_sym_AMP,
    ACTIONS(6148), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6150), 1,
      anon_sym_CARET,
    ACTIONS(6152), 1,
      anon_sym_QMARK,
    ACTIONS(6154), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6160), 1,
      anon_sym_GT_EQ,
    ACTIONS(6166), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6170), 1,
      sym__binary_star_star,
    ACTIONS(6487), 1,
      anon_sym_RPAREN,
    STATE(4378), 1,
      sym_heredoc_body,
    ACTIONS(6158), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6162), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6295), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6146), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6164), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6168), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [156764] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym___END__,
    STATE(4379), 1,
      sym_heredoc_body,
    ACTIONS(3062), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [156807] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4380), 1,
      sym_heredoc_body,
    ACTIONS(3016), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3014), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156849] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4381), 1,
      sym_heredoc_body,
    ACTIONS(3072), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3070), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156891] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4382), 1,
      sym_heredoc_body,
    ACTIONS(3683), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3681), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156933] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4383), 1,
      sym_heredoc_body,
    ACTIONS(3419), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3417), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156975] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4384), 1,
      sym_heredoc_body,
    ACTIONS(3423), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3421), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157017] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4385), 1,
      sym_heredoc_body,
    ACTIONS(3439), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3437), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157059] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4386), 1,
      sym_heredoc_body,
    ACTIONS(3463), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3461), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157101] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4387), 1,
      sym_heredoc_body,
    ACTIONS(3054), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3052), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157143] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4388), 1,
      sym_heredoc_body,
    ACTIONS(3481), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3479), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157185] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4389), 1,
      sym_heredoc_body,
    ACTIONS(3501), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3499), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157227] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4390), 1,
      sym_heredoc_body,
    ACTIONS(3711), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3709), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157269] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4391), 1,
      sym_heredoc_body,
    ACTIONS(3715), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3713), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157311] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4392), 1,
      sym_heredoc_body,
    ACTIONS(3775), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3773), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157353] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4393), 1,
      sym_heredoc_body,
    ACTIONS(3024), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3022), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157395] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4394), 1,
      sym_heredoc_body,
    ACTIONS(3513), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3511), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157437] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4395), 1,
      sym_heredoc_body,
    ACTIONS(3687), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3685), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157479] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4396), 1,
      sym_heredoc_body,
    ACTIONS(3707), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3705), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157521] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4397), 1,
      sym_heredoc_body,
    ACTIONS(3283), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3281), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157563] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4398), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3717), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157605] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4399), 1,
      sym_heredoc_body,
    ACTIONS(6489), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3252), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157647] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4400), 1,
      sym_heredoc_body,
    ACTIONS(3855), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3853), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157689] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4401), 1,
      sym_heredoc_body,
    ACTIONS(6491), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(2996), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157731] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4402), 1,
      sym_heredoc_body,
    ACTIONS(3415), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3413), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157773] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4403), 1,
      sym_heredoc_body,
    ACTIONS(3815), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3813), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157815] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4404), 1,
      sym_heredoc_body,
    ACTIONS(3751), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3749), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157857] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4405), 1,
      sym_heredoc_body,
    ACTIONS(3739), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3737), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157899] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4406), 1,
      sym_heredoc_body,
    ACTIONS(3004), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3002), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157941] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4407), 1,
      sym_heredoc_body,
    ACTIONS(3020), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3018), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157983] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4408), 1,
      sym_heredoc_body,
    ACTIONS(3000), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(2998), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158025] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4409), 1,
      sym_heredoc_body,
    ACTIONS(6493), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3861), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158067] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4410), 1,
      sym_heredoc_body,
    ACTIONS(3379), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3377), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158109] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4411), 1,
      sym_heredoc_body,
    ACTIONS(3565), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3563), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158151] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4412), 1,
      sym_heredoc_body,
    ACTIONS(3034), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3032), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158193] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4413), 1,
      sym_heredoc_body,
    ACTIONS(3038), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3036), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158235] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4414), 1,
      sym_heredoc_body,
    ACTIONS(6497), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(6495), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158277] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4415), 1,
      sym_heredoc_body,
    ACTIONS(3042), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3040), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158319] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4416), 1,
      sym_heredoc_body,
    ACTIONS(3030), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3028), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158361] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4417), 1,
      sym_heredoc_body,
    ACTIONS(3060), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3058), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158403] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4418), 1,
      sym_heredoc_body,
    ACTIONS(3076), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3074), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158445] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4419), 1,
      sym_heredoc_body,
    ACTIONS(3847), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3845), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158487] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4420), 1,
      sym_heredoc_body,
    ACTIONS(3375), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3373), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158529] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4421), 1,
      sym_heredoc_body,
    ACTIONS(3012), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3010), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158571] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4422), 1,
      sym_heredoc_body,
    ACTIONS(3355), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3353), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158613] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4423), 1,
      sym_heredoc_body,
    ACTIONS(3743), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3741), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158655] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4424), 1,
      sym_heredoc_body,
    ACTIONS(3046), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3044), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158697] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4425), 1,
      sym_heredoc_body,
    ACTIONS(3064), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3062), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158739] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4426), 1,
      sym_heredoc_body,
    ACTIONS(3399), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3397), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158781] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4427), 1,
      sym_heredoc_body,
    ACTIONS(3068), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3066), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158823] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4428), 1,
      sym_heredoc_body,
    ACTIONS(3759), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3757), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158865] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4429), 1,
      sym_heredoc_body,
    ACTIONS(3403), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3401), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158907] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4430), 1,
      sym_heredoc_body,
    ACTIONS(3763), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3761), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158949] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4431), 1,
      sym_heredoc_body,
    ACTIONS(3585), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3583), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158991] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6501), 1,
      anon_sym___END__,
    STATE(4432), 1,
      sym_heredoc_body,
    ACTIONS(6499), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [159032] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6501), 1,
      anon_sym___END__,
    STATE(4433), 1,
      sym_heredoc_body,
    ACTIONS(6499), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [159073] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym___END__,
    STATE(4434), 1,
      sym_heredoc_body,
    ACTIONS(6503), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [159114] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym___END__,
    STATE(4435), 1,
      sym_heredoc_body,
    ACTIONS(6503), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [159155] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_COLON,
    STATE(4436), 1,
      sym_heredoc_body,
    ACTIONS(2740), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159196] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6509), 1,
      anon_sym___END__,
    ACTIONS(6511), 1,
      anon_sym_LBRACE,
    ACTIONS(6513), 1,
      anon_sym_do,
    STATE(4432), 1,
      sym_block,
    STATE(4433), 1,
      sym_do_block,
    STATE(4437), 1,
      sym_heredoc_body,
    ACTIONS(6507), 21,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159244] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6511), 1,
      anon_sym_LBRACE,
    ACTIONS(6517), 1,
      anon_sym___END__,
    STATE(4434), 1,
      sym_do_block,
    STATE(4435), 1,
      sym_block,
    STATE(4438), 1,
      sym_heredoc_body,
    ACTIONS(6515), 22,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159290] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6521), 1,
      anon_sym___END__,
    STATE(4439), 1,
      sym_heredoc_body,
    ACTIONS(6519), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159330] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym___END__,
    STATE(4440), 1,
      sym_heredoc_body,
    ACTIONS(6523), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159370] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6509), 1,
      anon_sym___END__,
    ACTIONS(6511), 1,
      anon_sym_LBRACE,
    STATE(4432), 1,
      sym_block,
    STATE(4433), 1,
      sym_do_block,
    STATE(4441), 1,
      sym_heredoc_body,
    ACTIONS(6507), 22,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159416] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6511), 1,
      anon_sym_LBRACE,
    ACTIONS(6513), 1,
      anon_sym_do,
    ACTIONS(6517), 1,
      anon_sym___END__,
    STATE(4434), 1,
      sym_do_block,
    STATE(4435), 1,
      sym_block,
    STATE(4442), 1,
      sym_heredoc_body,
    ACTIONS(6515), 21,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159464] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6527), 1,
      anon_sym___END__,
    STATE(4443), 1,
      sym_heredoc_body,
    ACTIONS(3082), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159504] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6531), 1,
      anon_sym___END__,
    STATE(4444), 1,
      sym_heredoc_body,
    ACTIONS(6529), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159544] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6535), 1,
      anon_sym___END__,
    STATE(4445), 1,
      sym_heredoc_body,
    ACTIONS(6533), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159584] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6443), 1,
      anon_sym___END__,
    STATE(4446), 1,
      sym_heredoc_body,
    ACTIONS(6441), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159624] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6539), 1,
      anon_sym___END__,
    STATE(4447), 1,
      sym_heredoc_body,
    ACTIONS(6537), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159664] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6543), 1,
      anon_sym___END__,
    STATE(4448), 1,
      sym_heredoc_body,
    ACTIONS(6541), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159704] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6547), 1,
      anon_sym___END__,
    STATE(4449), 1,
      sym_heredoc_body,
    ACTIONS(6545), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159744] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6549), 1,
      anon_sym_COLON,
    STATE(4450), 1,
      sym_heredoc_body,
    ACTIONS(3252), 24,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159786] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6553), 1,
      anon_sym___END__,
    STATE(4451), 1,
      sym_heredoc_body,
    ACTIONS(6551), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159826] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6557), 1,
      anon_sym___END__,
    STATE(4452), 1,
      sym_heredoc_body,
    ACTIONS(6555), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159866] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6561), 1,
      anon_sym___END__,
    STATE(4453), 1,
      sym_heredoc_body,
    ACTIONS(6559), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159906] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym___END__,
    STATE(4454), 1,
      sym_heredoc_body,
    ACTIONS(3581), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159946] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6567), 1,
      anon_sym___END__,
    STATE(4455), 1,
      sym_heredoc_body,
    ACTIONS(6565), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159986] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6571), 1,
      anon_sym___END__,
    STATE(4456), 1,
      sym_heredoc_body,
    ACTIONS(6569), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160026] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6573), 1,
      anon_sym___END__,
    STATE(4457), 1,
      sym_heredoc_body,
    ACTIONS(3651), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160066] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6577), 1,
      anon_sym___END__,
    STATE(4458), 1,
      sym_heredoc_body,
    ACTIONS(6575), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160106] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6581), 1,
      anon_sym___END__,
    STATE(4459), 1,
      sym_heredoc_body,
    ACTIONS(6579), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160146] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4460), 1,
      sym_heredoc_body,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4486), 1,
      sym__hash_pattern_any_rest,
    STATE(5644), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6583), 2,
      sym_constant,
      sym_identifier,
    STATE(4508), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5951), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5604), 4,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5606), 6,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [160205] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6587), 1,
      anon_sym___END__,
    STATE(4461), 1,
      sym_heredoc_body,
    ACTIONS(6585), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160244] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym___END__,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    STATE(4462), 1,
      sym_heredoc_body,
    ACTIONS(6589), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160285] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    ACTIONS(6597), 1,
      anon_sym___END__,
    STATE(4463), 1,
      sym_heredoc_body,
    ACTIONS(6595), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4464), 1,
      sym_heredoc_body,
    ACTIONS(2626), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2624), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160365] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4465), 1,
      sym_heredoc_body,
    ACTIONS(2634), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2632), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4466), 1,
      sym_heredoc_body,
    ACTIONS(2630), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2628), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160443] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___END__,
    STATE(4467), 1,
      sym_heredoc_body,
    ACTIONS(6599), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160482] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6603), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6605), 1,
      anon_sym_DOT_DOT,
    STATE(4468), 1,
      sym_heredoc_body,
    ACTIONS(6441), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160523] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6609), 1,
      anon_sym___END__,
    STATE(4469), 1,
      sym_heredoc_body,
    ACTIONS(6607), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4470), 1,
      sym_heredoc_body,
    ACTIONS(2646), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2644), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160601] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4471), 1,
      sym_heredoc_body,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4496), 1,
      sym__hash_pattern_any_rest,
    STATE(5644), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6583), 2,
      sym_constant,
      sym_identifier,
    STATE(4508), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5951), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5662), 4,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5664), 6,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [160660] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    ACTIONS(6613), 1,
      anon_sym___END__,
    STATE(4472), 1,
      sym_heredoc_body,
    ACTIONS(6611), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4473), 1,
      sym_heredoc_body,
    ACTIONS(2642), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2640), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4474), 1,
      sym_heredoc_body,
    ACTIONS(4985), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(4983), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4475), 1,
      sym_heredoc_body,
    ACTIONS(4784), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(4782), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [160818] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6617), 1,
      anon_sym___END__,
    STATE(4476), 1,
      sym_heredoc_body,
    ACTIONS(6615), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160856] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym___END__,
    STATE(4477), 1,
      sym_heredoc_body,
    ACTIONS(6619), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160894] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym___END__,
    STATE(4478), 1,
      sym_heredoc_body,
    ACTIONS(6623), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160932] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym___END__,
    STATE(4479), 1,
      sym_heredoc_body,
    ACTIONS(6627), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160970] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6631), 1,
      anon_sym_PIPE,
    STATE(4480), 1,
      sym_heredoc_body,
    STATE(4510), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6585), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161010] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6635), 1,
      anon_sym___END__,
    STATE(4481), 1,
      sym_heredoc_body,
    ACTIONS(6633), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161048] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym___END__,
    STATE(4482), 1,
      sym_heredoc_body,
    ACTIONS(6627), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161086] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6639), 1,
      anon_sym___END__,
    STATE(4483), 1,
      sym_heredoc_body,
    ACTIONS(6637), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161124] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6643), 1,
      anon_sym___END__,
    STATE(4484), 1,
      sym_heredoc_body,
    ACTIONS(6641), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161162] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym___END__,
    STATE(4485), 1,
      sym_heredoc_body,
    ACTIONS(6645), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161200] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5664), 1,
      anon_sym___END__,
    STATE(4486), 1,
      sym_heredoc_body,
    ACTIONS(5662), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161238] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6651), 1,
      anon_sym_PIPE,
    STATE(4487), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6649), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161276] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6656), 1,
      anon_sym___END__,
    STATE(4488), 1,
      sym_heredoc_body,
    ACTIONS(6654), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161314] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym___END__,
    STATE(4489), 1,
      sym_heredoc_body,
    ACTIONS(6658), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161352] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6664), 1,
      anon_sym___END__,
    STATE(4490), 1,
      sym_heredoc_body,
    ACTIONS(6662), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161390] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym___END__,
    STATE(4491), 1,
      sym_heredoc_body,
    ACTIONS(4395), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161428] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6668), 1,
      anon_sym___END__,
    STATE(4492), 1,
      sym_heredoc_body,
    ACTIONS(6666), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161466] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6672), 1,
      anon_sym___END__,
    STATE(4493), 1,
      sym_heredoc_body,
    ACTIONS(6670), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161504] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6676), 1,
      anon_sym___END__,
    STATE(4494), 1,
      sym_heredoc_body,
    ACTIONS(6674), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161542] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6680), 1,
      anon_sym___END__,
    STATE(4495), 1,
      sym_heredoc_body,
    ACTIONS(6678), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161580] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6684), 1,
      anon_sym___END__,
    STATE(4496), 1,
      sym_heredoc_body,
    ACTIONS(6682), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161618] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym___END__,
    STATE(4497), 1,
      sym_heredoc_body,
    ACTIONS(6515), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161656] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6686), 1,
      anon_sym_COLON,
    STATE(4498), 1,
      sym_heredoc_body,
    ACTIONS(3082), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161694] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4499), 1,
      sym_heredoc_body,
    ACTIONS(6688), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6654), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161732] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6692), 1,
      anon_sym___END__,
    STATE(4500), 1,
      sym_heredoc_body,
    ACTIONS(6690), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161770] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6696), 1,
      anon_sym___END__,
    STATE(4501), 1,
      sym_heredoc_body,
    ACTIONS(6694), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161808] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6700), 1,
      anon_sym___END__,
    STATE(4502), 1,
      sym_heredoc_body,
    ACTIONS(6698), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161846] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6704), 1,
      anon_sym___END__,
    STATE(4503), 1,
      sym_heredoc_body,
    ACTIONS(6702), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161884] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6708), 1,
      anon_sym___END__,
    STATE(4504), 1,
      sym_heredoc_body,
    ACTIONS(6706), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161922] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6712), 1,
      anon_sym___END__,
    STATE(4505), 1,
      sym_heredoc_body,
    ACTIONS(6710), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161960] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6291), 1,
      anon_sym___END__,
    STATE(4506), 1,
      sym_heredoc_body,
    ACTIONS(6289), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161998] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6716), 1,
      anon_sym___END__,
    STATE(4507), 1,
      sym_heredoc_body,
    ACTIONS(6714), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162036] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym___END__,
    STATE(4508), 1,
      sym_heredoc_body,
    ACTIONS(6718), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162074] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym___END__,
    STATE(4509), 1,
      sym_heredoc_body,
    ACTIONS(6627), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162112] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6631), 1,
      anon_sym_PIPE,
    STATE(4487), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4510), 1,
      sym_heredoc_body,
    ACTIONS(6722), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162152] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6708), 1,
      anon_sym___END__,
    STATE(4511), 1,
      sym_heredoc_body,
    ACTIONS(6706), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162190] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym___END__,
    STATE(4512), 1,
      sym_heredoc_body,
    ACTIONS(6627), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162228] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6726), 1,
      anon_sym___END__,
    STATE(4513), 1,
      sym_heredoc_body,
    ACTIONS(6724), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162266] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym___END__,
    STATE(4514), 1,
      sym_heredoc_body,
    ACTIONS(6728), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162304] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4515), 1,
      sym_heredoc_body,
    STATE(4908), 1,
      sym_keyword_pattern,
    STATE(4910), 1,
      sym__hash_pattern_any_rest,
    STATE(5791), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6732), 2,
      sym_constant,
      sym_identifier,
    STATE(4884), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5980), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5604), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5606), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [162361] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4516), 1,
      sym_heredoc_body,
    STATE(4908), 1,
      sym_keyword_pattern,
    STATE(4917), 1,
      sym__hash_pattern_any_rest,
    STATE(5655), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6734), 2,
      sym_constant,
      sym_identifier,
    STATE(4884), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5647), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5664), 3,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5662), 5,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [162418] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4517), 1,
      sym_heredoc_body,
    STATE(4908), 1,
      sym_keyword_pattern,
    STATE(4917), 1,
      sym__hash_pattern_any_rest,
    STATE(5791), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6732), 2,
      sym_constant,
      sym_identifier,
    STATE(4884), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5980), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5662), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5664), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [162475] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6736), 1,
      sym_identifier,
    ACTIONS(6742), 1,
      anon_sym_nil,
    STATE(4518), 1,
      sym_heredoc_body,
    ACTIONS(6738), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6740), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162516] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4519), 1,
      sym_heredoc_body,
    STATE(4908), 1,
      sym_keyword_pattern,
    STATE(4910), 1,
      sym__hash_pattern_any_rest,
    STATE(5655), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6734), 2,
      sym_constant,
      sym_identifier,
    STATE(4884), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5647), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5606), 3,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5604), 5,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [162573] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6746), 1,
      anon_sym_COMMA,
    STATE(4520), 1,
      sym_heredoc_body,
    STATE(4522), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162611] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6748), 1,
      anon_sym_COMMA,
    STATE(4521), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6637), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162647] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6751), 1,
      anon_sym_COMMA,
    STATE(4522), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6595), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162683] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6754), 1,
      anon_sym_COMMA,
    STATE(4522), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4523), 1,
      sym_heredoc_body,
    ACTIONS(6744), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162721] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6758), 1,
      anon_sym_COMMA,
    STATE(4524), 1,
      sym_heredoc_body,
    STATE(4527), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162759] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6760), 1,
      anon_sym_COMMA,
    STATE(4525), 1,
      sym_heredoc_body,
    STATE(4530), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6658), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162797] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    ACTIONS(6762), 1,
      anon_sym_COMMA,
    STATE(4526), 1,
      sym_heredoc_body,
    ACTIONS(6678), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162835] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6758), 1,
      anon_sym_COMMA,
    STATE(4527), 1,
      sym_heredoc_body,
    STATE(4532), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162873] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6746), 1,
      anon_sym_COMMA,
    STATE(4523), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4528), 1,
      sym_heredoc_body,
    ACTIONS(6766), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162911] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6768), 1,
      sym_identifier,
    STATE(4529), 1,
      sym_heredoc_body,
    ACTIONS(2652), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2660), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162949] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6770), 1,
      anon_sym_COMMA,
    STATE(4521), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4530), 1,
      sym_heredoc_body,
    ACTIONS(5604), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [162987] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6746), 1,
      anon_sym_COMMA,
    STATE(4520), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4531), 1,
      sym_heredoc_body,
    ACTIONS(6766), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163025] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6772), 1,
      anon_sym_COMMA,
    STATE(4532), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163061] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    ACTIONS(6762), 1,
      anon_sym_COMMA,
    STATE(4533), 1,
      sym_heredoc_body,
    ACTIONS(6775), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163099] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(827), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(162), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4534), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163158] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(837), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(167), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4535), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163217] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(809), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(153), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4536), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163276] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(785), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(142), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4537), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163335] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(767), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(135), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4538), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163394] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(821), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(159), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4539), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163453] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(817), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(157), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4540), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163512] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(787), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(143), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4541), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163571] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(811), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(154), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4542), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163630] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(839), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(168), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4543), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163689] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(813), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(155), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4544), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163748] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(831), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(164), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4545), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163807] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(781), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(140), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4546), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163866] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(823), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(160), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4547), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163925] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(771), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(136), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4548), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163984] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(773), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(137), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4549), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164043] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(799), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(148), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4550), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164102] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6787), 1,
      anon_sym___END__,
    STATE(4551), 1,
      sym_heredoc_body,
    ACTIONS(6785), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164137] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_rescue,
    STATE(4552), 1,
      sym_heredoc_body,
    ACTIONS(6662), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [164172] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(815), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(156), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4553), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164231] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(797), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(147), 1,
      sym_parameters,
    STATE(227), 1,
      sym__terminator,
    STATE(4554), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5471), 1,
      sym__body_expr,
    STATE(5503), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164290] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_rescue,
    STATE(4555), 1,
      sym_heredoc_body,
    ACTIONS(6670), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [164325] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(801), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(149), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4556), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164384] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(779), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(139), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4557), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164443] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(793), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(146), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4558), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164502] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(825), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(161), 1,
      sym_parameters,
    STATE(206), 1,
      sym__terminator,
    STATE(2424), 1,
      sym__body_expr,
    STATE(4559), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5547), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164561] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(791), 1,
      anon_sym_EQ,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6779), 1,
      anon_sym_LPAREN,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    STATE(145), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(3047), 1,
      sym__body_expr,
    STATE(4560), 1,
      sym_heredoc_body,
    STATE(5438), 1,
      sym__simple_formal_parameter,
    STATE(5566), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164620] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym___END__,
    ACTIONS(3186), 1,
      anon_sym_COLON,
    STATE(4561), 1,
      sym_heredoc_body,
    ACTIONS(2740), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [164657] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6801), 1,
      anon_sym_do,
    STATE(4562), 1,
      sym_heredoc_body,
    STATE(5408), 1,
      sym__simple_formal_parameter,
    STATE(4419), 2,
      sym_do_block,
      sym_block,
    STATE(5403), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164711] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6803), 1,
      anon_sym_LBRACE,
    ACTIONS(6805), 1,
      anon_sym_do,
    STATE(4563), 1,
      sym_heredoc_body,
    STATE(5408), 1,
      sym__simple_formal_parameter,
    STATE(4707), 2,
      sym_do_block,
      sym_block,
    STATE(5344), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164765] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_COMMA,
    STATE(4564), 1,
      sym_heredoc_body,
    STATE(4565), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [164801] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_COMMA,
    STATE(4565), 1,
      sym_heredoc_body,
    STATE(4576), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [164837] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(181), 1,
      anon_sym_do,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    STATE(4566), 1,
      sym_heredoc_body,
    STATE(5408), 1,
      sym__simple_formal_parameter,
    STATE(2423), 2,
      sym_do_block,
      sym_block,
    STATE(5395), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164891] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_COLON,
    STATE(4567), 1,
      sym_heredoc_body,
    ACTIONS(6489), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3252), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [164927] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym___END__,
    STATE(4568), 1,
      sym_heredoc_body,
    ACTIONS(6811), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164961] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(6817), 1,
      anon_sym_do,
    STATE(4569), 1,
      sym_heredoc_body,
    STATE(5408), 1,
      sym__simple_formal_parameter,
    STATE(5397), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5400), 2,
      sym_do_block,
      sym_block,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165015] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6821), 1,
      anon_sym___END__,
    STATE(4570), 1,
      sym_heredoc_body,
    ACTIONS(6819), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165049] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6825), 1,
      anon_sym___END__,
    STATE(4571), 1,
      sym_heredoc_body,
    ACTIONS(6823), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165083] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6511), 1,
      anon_sym_LBRACE,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6827), 1,
      anon_sym_do,
    STATE(4572), 1,
      sym_heredoc_body,
    STATE(5408), 1,
      sym__simple_formal_parameter,
    STATE(4419), 2,
      sym_do_block,
      sym_block,
    STATE(5394), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165137] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6831), 1,
      anon_sym___END__,
    STATE(4573), 1,
      sym_heredoc_body,
    ACTIONS(6829), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165171] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6833), 1,
      anon_sym_LBRACE,
    ACTIONS(6835), 1,
      anon_sym_do,
    STATE(4574), 1,
      sym_heredoc_body,
    STATE(5408), 1,
      sym__simple_formal_parameter,
    STATE(4707), 2,
      sym_do_block,
      sym_block,
    STATE(5468), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165225] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6839), 1,
      anon_sym___END__,
    STATE(4575), 1,
      sym_heredoc_body,
    ACTIONS(6837), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165259] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6841), 1,
      anon_sym_COMMA,
    STATE(4576), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [165293] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(275), 1,
      anon_sym_do,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(6791), 1,
      sym_identifier,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    STATE(4577), 1,
      sym_heredoc_body,
    STATE(5408), 1,
      sym__simple_formal_parameter,
    STATE(3037), 2,
      sym_do_block,
      sym_block,
    STATE(5481), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165347] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6846), 1,
      anon_sym___END__,
    STATE(4578), 1,
      sym_heredoc_body,
    ACTIONS(6844), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165381] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6848), 1,
      anon_sym_rescue,
    STATE(4579), 1,
      sym_heredoc_body,
    ACTIONS(6670), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [165414] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6852), 1,
      anon_sym_COMMA,
    STATE(4580), 1,
      sym_heredoc_body,
    STATE(4586), 1,
      aux_sym_undef_repeat1,
    ACTIONS(6850), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6854), 1,
      anon_sym_EQ2,
    STATE(4581), 1,
      sym_heredoc_body,
    ACTIONS(4784), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165482] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6858), 1,
      anon_sym_COMMA,
    ACTIONS(6860), 1,
      anon_sym_PIPE,
    ACTIONS(6862), 1,
      anon_sym_SEMI,
    STATE(4582), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5448), 1,
      sym__formal_parameter,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165537] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6443), 1,
      anon_sym___END__,
    ACTIONS(6864), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6866), 1,
      anon_sym_DOT_DOT,
    STATE(4583), 1,
      sym_heredoc_body,
    ACTIONS(6441), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165574] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6848), 1,
      anon_sym_rescue,
    STATE(4584), 1,
      sym_heredoc_body,
    ACTIONS(6662), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [165607] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4585), 1,
      sym_heredoc_body,
    ACTIONS(3699), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3697), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165640] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6852), 1,
      anon_sym_COMMA,
    STATE(4586), 1,
      sym_heredoc_body,
    STATE(4588), 1,
      aux_sym_undef_repeat1,
    ACTIONS(6868), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165675] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4587), 1,
      sym_heredoc_body,
    ACTIONS(3455), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3453), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165708] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6870), 1,
      anon_sym_COMMA,
    STATE(4588), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(6785), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165741] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6873), 1,
      anon_sym_COMMA,
    ACTIONS(6875), 1,
      anon_sym_PIPE,
    ACTIONS(6877), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5415), 1,
      sym__formal_parameter,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165796] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6879), 1,
      anon_sym_PIPE,
    ACTIONS(6881), 1,
      anon_sym_SEMI,
    STATE(4590), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5259), 1,
      sym__formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165848] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6587), 1,
      anon_sym___END__,
    ACTIONS(6883), 1,
      anon_sym_PIPE,
    STATE(4591), 1,
      sym_heredoc_body,
    STATE(4606), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6585), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [165884] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6885), 1,
      anon_sym_PIPE,
    ACTIONS(6887), 1,
      anon_sym_SEMI,
    STATE(4592), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5259), 1,
      sym__formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165936] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4593), 1,
      sym_heredoc_body,
    ACTIONS(6891), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6889), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [165968] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4594), 1,
      sym_heredoc_body,
    ACTIONS(6891), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6893), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166000] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4595), 1,
      sym_heredoc_body,
    ACTIONS(6891), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6895), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166032] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4596), 1,
      sym_heredoc_body,
    ACTIONS(6891), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6897), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166064] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6899), 1,
      anon_sym_rescue,
    STATE(4597), 1,
      sym_heredoc_body,
    ACTIONS(6670), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [166096] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4598), 1,
      sym_heredoc_body,
    ACTIONS(6891), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6901), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166128] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6899), 1,
      anon_sym_rescue,
    STATE(4599), 1,
      sym_heredoc_body,
    ACTIONS(6662), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [166160] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___END__,
    ACTIONS(6905), 1,
      anon_sym_PIPE,
    STATE(4600), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6649), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [166194] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6656), 1,
      anon_sym___END__,
    STATE(4601), 1,
      sym_heredoc_body,
    ACTIONS(6908), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6654), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [166228] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4602), 1,
      sym_heredoc_body,
    ACTIONS(6891), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6811), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [166260] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6527), 1,
      anon_sym___END__,
    ACTIONS(6910), 1,
      anon_sym_COLON,
    STATE(4603), 1,
      sym_heredoc_body,
    ACTIONS(3082), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [166294] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6912), 1,
      anon_sym_PIPE,
    ACTIONS(6914), 1,
      anon_sym_SEMI,
    STATE(4604), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5259), 1,
      sym__formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166346] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6916), 1,
      anon_sym_PIPE,
    ACTIONS(6918), 1,
      anon_sym_SEMI,
    STATE(4605), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5259), 1,
      sym__formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166398] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6883), 1,
      anon_sym_PIPE,
    ACTIONS(6920), 1,
      anon_sym___END__,
    STATE(4600), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4606), 1,
      sym_heredoc_body,
    ACTIONS(6722), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [166434] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6736), 1,
      sym_identifier,
    ACTIONS(6742), 1,
      anon_sym_nil,
    STATE(4607), 1,
      sym_heredoc_body,
    ACTIONS(6738), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6740), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [166469] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3283), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3287), 1,
      anon_sym_ri,
    STATE(4608), 1,
      sym_heredoc_body,
    ACTIONS(3285), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3281), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [166504] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2636), 1,
      anon_sym___END__,
    STATE(4609), 1,
      sym_heredoc_body,
    ACTIONS(2638), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [166535] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6922), 1,
      anon_sym_end,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    STATE(4610), 1,
      sym_heredoc_body,
    STATE(4896), 1,
      sym__terminator,
    STATE(5270), 1,
      aux_sym_case_repeat1,
    STATE(5273), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5762), 1,
      sym_else,
    ACTIONS(1341), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166594] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6940), 1,
      sym_identifier,
    ACTIONS(6942), 1,
      anon_sym_RPAREN,
    STATE(4611), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5498), 1,
      sym__formal_parameter,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166643] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(6944), 1,
      anon_sym_end,
    STATE(4612), 1,
      sym_heredoc_body,
    STATE(4909), 1,
      sym__terminator,
    STATE(5238), 1,
      aux_sym_case_repeat1,
    STATE(5268), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5912), 1,
      sym_else,
    ACTIONS(1341), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166702] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(6946), 1,
      anon_sym_end,
    STATE(4613), 1,
      sym_heredoc_body,
    STATE(4906), 1,
      sym__terminator,
    STATE(5279), 1,
      aux_sym_case_repeat1,
    STATE(5280), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5686), 1,
      sym_else,
    ACTIONS(1341), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166761] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(6948), 1,
      anon_sym_end,
    STATE(4614), 1,
      sym_heredoc_body,
    STATE(4887), 1,
      sym__terminator,
    STATE(5269), 1,
      aux_sym_case_repeat1,
    STATE(5278), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5962), 1,
      sym_else,
    ACTIONS(1341), 2,
      sym__line_break,
      anon_sym_SEMI,
  [166820] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(6950), 1,
      anon_sym_RBRACE,
    STATE(4615), 1,
      sym_heredoc_body,
    STATE(4893), 1,
      sym_keyword_pattern,
    STATE(4894), 1,
      sym__hash_pattern_any_rest,
    STATE(5654), 1,
      sym__hash_pattern_body,
    STATE(5655), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6734), 2,
      sym_constant,
      sym_identifier,
    STATE(4884), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5647), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [166871] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6940), 1,
      sym_identifier,
    ACTIONS(6952), 1,
      anon_sym_RPAREN,
    STATE(4616), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5546), 1,
      sym__formal_parameter,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166920] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6940), 1,
      sym_identifier,
    ACTIONS(6954), 1,
      anon_sym_RPAREN,
    STATE(4617), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5572), 1,
      sym__formal_parameter,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166969] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2888), 1,
      sym__string_start,
    ACTIONS(6956), 1,
      anon_sym_RBRACE,
    STATE(4618), 1,
      sym_heredoc_body,
    STATE(4893), 1,
      sym_keyword_pattern,
    STATE(4894), 1,
      sym__hash_pattern_any_rest,
    STATE(5655), 1,
      sym_string,
    STATE(5733), 1,
      sym__hash_pattern_body,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6734), 2,
      sym_constant,
      sym_identifier,
    STATE(4884), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5647), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [167020] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(6958), 1,
      anon_sym_end,
    STATE(4619), 1,
      sym_heredoc_body,
    STATE(4926), 1,
      sym__terminator,
    STATE(5216), 1,
      aux_sym_case_match_repeat1,
    STATE(5258), 1,
      aux_sym_case_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5717), 1,
      sym_else,
    ACTIONS(1341), 2,
      sym__line_break,
      anon_sym_SEMI,
  [167079] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(6960), 1,
      anon_sym_end,
    STATE(4620), 1,
      sym_heredoc_body,
    STATE(4925), 1,
      sym__terminator,
    STATE(5240), 1,
      aux_sym_case_repeat1,
    STATE(5242), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5958), 1,
      sym_else,
    ACTIONS(1341), 2,
      sym__line_break,
      anon_sym_SEMI,
  [167138] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5606), 1,
      anon_sym___END__,
    ACTIONS(6962), 1,
      anon_sym_COMMA,
    STATE(4621), 1,
      sym_heredoc_body,
    STATE(4630), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5604), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167172] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6940), 1,
      sym_identifier,
    STATE(4622), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5259), 1,
      sym__formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [167218] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6856), 1,
      sym_identifier,
    STATE(4623), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5259), 1,
      sym__formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [167264] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym___END__,
    ACTIONS(6964), 1,
      anon_sym_COMMA,
    STATE(4624), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6595), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167296] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym___END__,
    ACTIONS(6969), 1,
      anon_sym_COMMA,
    STATE(4625), 1,
      sym_heredoc_body,
    STATE(4637), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6766), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167330] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(6777), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6783), 1,
      anon_sym_AMP,
    ACTIONS(6971), 1,
      anon_sym_LPAREN,
    STATE(4626), 1,
      sym_heredoc_body,
    STATE(5499), 1,
      sym__formal_parameter,
    STATE(5565), 1,
      sym_parameters,
    STATE(5574), 1,
      sym__simple_formal_parameter,
    STATE(5564), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [167376] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym___END__,
    ACTIONS(6969), 1,
      anon_sym_COMMA,
    STATE(4627), 1,
      sym_heredoc_body,
    STATE(4633), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6766), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167410] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    STATE(2062), 1,
      sym__terminator,
    STATE(4628), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(6973), 8,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [167452] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    ACTIONS(6680), 1,
      anon_sym___END__,
    ACTIONS(6975), 1,
      anon_sym_COMMA,
    STATE(4629), 1,
      sym_heredoc_body,
    ACTIONS(6678), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167486] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6639), 1,
      anon_sym___END__,
    ACTIONS(6977), 1,
      anon_sym_COMMA,
    STATE(4630), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6637), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167518] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6768), 1,
      sym_identifier,
    STATE(4631), 1,
      sym_heredoc_body,
    ACTIONS(2652), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2660), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167550] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    ACTIONS(6975), 1,
      anon_sym_COMMA,
    ACTIONS(6980), 1,
      anon_sym___END__,
    STATE(4632), 1,
      sym_heredoc_body,
    ACTIONS(6775), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167584] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6969), 1,
      anon_sym_COMMA,
    ACTIONS(6982), 1,
      anon_sym___END__,
    STATE(4624), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4633), 1,
      sym_heredoc_body,
    ACTIONS(6744), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167618] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    STATE(2062), 1,
      sym__terminator,
    STATE(4634), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(1263), 8,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [167660] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6696), 1,
      anon_sym___END__,
    ACTIONS(6984), 1,
      anon_sym_COMMA,
    STATE(4635), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167692] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6987), 1,
      anon_sym___END__,
    ACTIONS(6989), 1,
      anon_sym_COMMA,
    STATE(4636), 1,
      sym_heredoc_body,
    STATE(4640), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167726] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6982), 1,
      anon_sym___END__,
    ACTIONS(6991), 1,
      anon_sym_COMMA,
    STATE(4624), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4637), 1,
      sym_heredoc_body,
    ACTIONS(6744), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167760] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2864), 1,
      anon_sym_STAR,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    ACTIONS(6797), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6799), 1,
      anon_sym_AMP,
    ACTIONS(6993), 1,
      sym_identifier,
    STATE(4638), 1,
      sym_heredoc_body,
    STATE(5243), 1,
      sym__simple_formal_parameter,
    STATE(5259), 1,
      sym__formal_parameter,
    STATE(5286), 1,
      sym_parameters,
    STATE(5227), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [167806] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_COLON,
    STATE(4639), 1,
      sym_heredoc_body,
    ACTIONS(2740), 15,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [167836] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6989), 1,
      anon_sym_COMMA,
    ACTIONS(6995), 1,
      anon_sym___END__,
    STATE(4635), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4640), 1,
      sym_heredoc_body,
    ACTIONS(6764), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167870] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym___END__,
    ACTIONS(6997), 1,
      anon_sym_COMMA,
    STATE(4621), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4641), 1,
      sym_heredoc_body,
    ACTIONS(6658), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167904] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6664), 1,
      anon_sym___END__,
    ACTIONS(6999), 1,
      anon_sym_rescue,
    STATE(4642), 1,
      sym_heredoc_body,
    ACTIONS(6662), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167935] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6672), 1,
      anon_sym___END__,
    ACTIONS(6999), 1,
      anon_sym_rescue,
    STATE(4643), 1,
      sym_heredoc_body,
    ACTIONS(6670), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [167966] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7001), 1,
      anon_sym_COLON,
    STATE(4644), 1,
      sym_heredoc_body,
    ACTIONS(3252), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [167997] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3283), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3285), 1,
      anon_sym_r,
    STATE(4645), 1,
      sym_heredoc_body,
    ACTIONS(3287), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3281), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168030] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3283), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3285), 1,
      anon_sym_r,
    STATE(4646), 1,
      sym_heredoc_body,
    ACTIONS(3287), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3281), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168063] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4647), 1,
      sym_heredoc_body,
    ACTIONS(3022), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168089] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT_DOT,
    STATE(4648), 1,
      sym_heredoc_body,
    ACTIONS(3311), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168117] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4649), 1,
      sym_heredoc_body,
    ACTIONS(6347), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168143] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4650), 1,
      sym_heredoc_body,
    ACTIONS(6465), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168169] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_DOT_DOT,
    STATE(4651), 1,
      sym_heredoc_body,
    ACTIONS(3303), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168197] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4652), 1,
      sym_heredoc_body,
    ACTIONS(2970), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168223] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6995), 1,
      anon_sym___END__,
    ACTIONS(7003), 1,
      anon_sym_COMMA,
    STATE(4653), 1,
      sym_heredoc_body,
    STATE(4657), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [168255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4654), 1,
      sym_heredoc_body,
    ACTIONS(6289), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(745), 9,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168283] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6987), 1,
      anon_sym___END__,
    ACTIONS(7003), 1,
      anon_sym_COMMA,
    STATE(4653), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4655), 1,
      sym_heredoc_body,
    ACTIONS(6756), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [168315] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7005), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7007), 1,
      anon_sym_DOT_DOT,
    STATE(4656), 1,
      sym_heredoc_body,
    ACTIONS(6441), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [168345] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6696), 1,
      anon_sym___END__,
    ACTIONS(7009), 1,
      anon_sym_COMMA,
    STATE(4657), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [168375] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7012), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7014), 1,
      anon_sym_LBRACK2,
    ACTIONS(7016), 1,
      anon_sym_LPAREN2,
    STATE(4658), 1,
      sym_heredoc_body,
    ACTIONS(6441), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168407] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4659), 1,
      sym_heredoc_body,
    ACTIONS(3014), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168433] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4660), 1,
      sym_heredoc_body,
    ACTIONS(3074), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168459] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4661), 1,
      sym_heredoc_body,
    STATE(4940), 1,
      sym_argument_list,
    STATE(5366), 1,
      sym_do_block,
    STATE(5376), 1,
      sym_block,
    ACTIONS(177), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168497] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4662), 1,
      sym_heredoc_body,
    STATE(4984), 1,
      sym_argument_list,
    STATE(5330), 1,
      sym_do_block,
    STATE(5332), 1,
      sym_block,
    ACTIONS(123), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168535] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4663), 1,
      sym_heredoc_body,
    ACTIONS(2740), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168561] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_COLON,
    STATE(4664), 1,
      sym_heredoc_body,
    ACTIONS(2740), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168589] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4665), 1,
      sym_heredoc_body,
    ACTIONS(3018), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168615] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4666), 1,
      sym_heredoc_body,
    ACTIONS(3028), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168641] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4667), 1,
      sym_heredoc_body,
    ACTIONS(3032), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168667] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4668), 1,
      sym_heredoc_body,
    ACTIONS(3036), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168693] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4669), 1,
      sym_heredoc_body,
    ACTIONS(3040), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168719] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4670), 1,
      sym_heredoc_body,
    ACTIONS(2998), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168745] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4671), 1,
      sym_heredoc_body,
    ACTIONS(3044), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168771] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4672), 1,
      sym_heredoc_body,
    ACTIONS(3052), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168797] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4673), 1,
      sym_heredoc_body,
    ACTIONS(3058), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168823] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4674), 1,
      sym_heredoc_body,
    ACTIONS(3062), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168849] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4675), 1,
      sym_heredoc_body,
    ACTIONS(3066), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168875] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4676), 1,
      sym_heredoc_body,
    ACTIONS(3070), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168901] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4677), 1,
      sym_heredoc_body,
    ACTIONS(3002), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [168927] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3463), 1,
      anon_sym_DOT_DOT,
    STATE(4678), 1,
      sym_heredoc_body,
    ACTIONS(3461), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168954] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3030), 1,
      anon_sym_DOT_DOT,
    STATE(4679), 1,
      sym_heredoc_body,
    ACTIONS(3028), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168981] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_DOT_DOT,
    STATE(4680), 1,
      sym_heredoc_body,
    ACTIONS(3032), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169008] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3042), 1,
      anon_sym_DOT_DOT,
    STATE(4681), 1,
      sym_heredoc_body,
    ACTIONS(3040), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169035] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_DOT_DOT,
    STATE(4682), 1,
      sym_heredoc_body,
    ACTIONS(3044), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169062] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_DOT_DOT,
    STATE(4683), 1,
      sym_heredoc_body,
    ACTIONS(3052), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169089] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3060), 1,
      anon_sym_DOT_DOT,
    STATE(4684), 1,
      sym_heredoc_body,
    ACTIONS(3058), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169116] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_DOT_DOT,
    STATE(4685), 1,
      sym_heredoc_body,
    ACTIONS(3062), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169143] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3068), 1,
      anon_sym_DOT_DOT,
    STATE(4686), 1,
      sym_heredoc_body,
    ACTIONS(3066), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169170] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_DOT_DOT,
    STATE(4687), 1,
      sym_heredoc_body,
    ACTIONS(3070), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169197] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3004), 1,
      anon_sym_DOT_DOT,
    STATE(4688), 1,
      sym_heredoc_body,
    ACTIONS(3002), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169224] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3020), 1,
      anon_sym_DOT_DOT,
    STATE(4689), 1,
      sym_heredoc_body,
    ACTIONS(3018), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169251] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_DOT_DOT,
    STATE(4690), 1,
      sym_heredoc_body,
    ACTIONS(2998), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169278] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_DOT_DOT,
    STATE(4691), 1,
      sym_heredoc_body,
    ACTIONS(6495), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169305] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6491), 1,
      anon_sym_DOT_DOT,
    STATE(4692), 1,
      sym_heredoc_body,
    ACTIONS(2996), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169332] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3455), 1,
      anon_sym_DOT_DOT,
    STATE(4693), 1,
      sym_heredoc_body,
    ACTIONS(3453), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169359] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3415), 1,
      anon_sym_DOT_DOT,
    STATE(4694), 1,
      sym_heredoc_body,
    ACTIONS(3413), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169386] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym_DOT_DOT,
    STATE(4695), 1,
      sym_heredoc_body,
    ACTIONS(3010), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169413] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3699), 1,
      anon_sym_DOT_DOT,
    STATE(4696), 1,
      sym_heredoc_body,
    ACTIONS(3697), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169440] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_DOT_DOT,
    STATE(4697), 1,
      sym_heredoc_body,
    ACTIONS(3563), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169467] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3283), 1,
      anon_sym_DOT_DOT,
    STATE(4698), 1,
      sym_heredoc_body,
    ACTIONS(3281), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169494] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_DOT_DOT,
    STATE(4699), 1,
      sym_heredoc_body,
    ACTIONS(3861), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169521] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3855), 1,
      anon_sym_DOT_DOT,
    STATE(4700), 1,
      sym_heredoc_body,
    ACTIONS(3853), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169548] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_DOT_DOT,
    STATE(4701), 1,
      sym_heredoc_body,
    ACTIONS(3813), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169575] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_DOT_DOT,
    STATE(4702), 1,
      sym_heredoc_body,
    ACTIONS(3583), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169602] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3739), 1,
      anon_sym_DOT_DOT,
    STATE(4703), 1,
      sym_heredoc_body,
    ACTIONS(3737), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169629] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4704), 1,
      sym_heredoc_body,
    STATE(4940), 1,
      sym_argument_list,
    STATE(5366), 1,
      sym_do_block,
    STATE(5376), 1,
      sym_block,
    ACTIONS(177), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [169666] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COLON,
    STATE(4705), 1,
      sym_heredoc_body,
    ACTIONS(3082), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [169693] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_COLON,
    STATE(4706), 1,
      sym_heredoc_body,
    ACTIONS(2740), 12,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [169720] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_DOT_DOT,
    STATE(4707), 1,
      sym_heredoc_body,
    ACTIONS(3845), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169747] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7022), 1,
      sym_identifier,
    ACTIONS(7024), 1,
      anon_sym_nil,
    STATE(4708), 1,
      sym_heredoc_body,
    ACTIONS(6740), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6738), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [169778] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4709), 1,
      sym_heredoc_body,
    STATE(4984), 1,
      sym_argument_list,
    STATE(5330), 1,
      sym_do_block,
    STATE(5332), 1,
      sym_block,
    ACTIONS(123), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [169815] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3743), 1,
      anon_sym_DOT_DOT,
    STATE(4710), 1,
      sym_heredoc_body,
    ACTIONS(3741), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169842] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3759), 1,
      anon_sym_DOT_DOT,
    STATE(4711), 1,
      sym_heredoc_body,
    ACTIONS(3757), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169869] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_DOT_DOT,
    STATE(4712), 1,
      sym_heredoc_body,
    ACTIONS(3761), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169896] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_PIPE,
    STATE(4713), 1,
      sym_heredoc_body,
    STATE(4723), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6585), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [169925] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_DOT_DOT,
    STATE(4714), 1,
      sym_heredoc_body,
    ACTIONS(3353), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169952] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3379), 1,
      anon_sym_DOT_DOT,
    STATE(4715), 1,
      sym_heredoc_body,
    ACTIONS(3377), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169979] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_DOT_DOT,
    STATE(4716), 1,
      sym_heredoc_body,
    ACTIONS(3373), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170006] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOT_DOT,
    STATE(4717), 1,
      sym_heredoc_body,
    ACTIONS(3397), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170033] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_DOT_DOT,
    STATE(4718), 1,
      sym_heredoc_body,
    ACTIONS(3401), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170060] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3751), 1,
      anon_sym_DOT_DOT,
    STATE(4719), 1,
      sym_heredoc_body,
    ACTIONS(3749), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170087] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6664), 1,
      anon_sym___END__,
    ACTIONS(7028), 1,
      anon_sym_rescue,
    STATE(4720), 1,
      sym_heredoc_body,
    ACTIONS(6662), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [170116] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6672), 1,
      anon_sym___END__,
    ACTIONS(7028), 1,
      anon_sym_rescue,
    STATE(4721), 1,
      sym_heredoc_body,
    ACTIONS(6670), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [170145] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_DOT_DOT,
    STATE(4722), 1,
      sym_heredoc_body,
    ACTIONS(3681), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170172] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_PIPE,
    STATE(4723), 1,
      sym_heredoc_body,
    STATE(4724), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6722), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170201] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7030), 1,
      anon_sym_PIPE,
    STATE(4724), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6649), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170228] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_DOT_DOT,
    STATE(4725), 1,
      sym_heredoc_body,
    ACTIONS(3479), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170255] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_DOT_DOT,
    STATE(4726), 1,
      sym_heredoc_body,
    ACTIONS(3499), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170282] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3513), 1,
      anon_sym_DOT_DOT,
    STATE(4727), 1,
      sym_heredoc_body,
    ACTIONS(3511), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170309] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3687), 1,
      anon_sym_DOT_DOT,
    STATE(4728), 1,
      sym_heredoc_body,
    ACTIONS(3685), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170336] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3707), 1,
      anon_sym_DOT_DOT,
    STATE(4729), 1,
      sym_heredoc_body,
    ACTIONS(3705), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170363] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT_DOT,
    STATE(4730), 1,
      sym_heredoc_body,
    ACTIONS(3717), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170390] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_DOT_DOT,
    STATE(4731), 1,
      sym_heredoc_body,
    ACTIONS(3014), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170417] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_DOT_DOT,
    STATE(4732), 1,
      sym_heredoc_body,
    ACTIONS(3074), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170444] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7033), 1,
      anon_sym_COLON,
    STATE(4733), 1,
      sym_heredoc_body,
    ACTIONS(3252), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170473] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3775), 1,
      anon_sym_DOT_DOT,
    STATE(4734), 1,
      sym_heredoc_body,
    ACTIONS(3773), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170500] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT,
    STATE(4735), 1,
      sym_heredoc_body,
    ACTIONS(3417), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170527] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3423), 1,
      anon_sym_DOT_DOT,
    STATE(4736), 1,
      sym_heredoc_body,
    ACTIONS(3421), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170554] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_DOT_DOT,
    STATE(4737), 1,
      sym_heredoc_body,
    ACTIONS(3437), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170581] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_DOT_DOT,
    STATE(4738), 1,
      sym_heredoc_body,
    ACTIONS(3252), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170608] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_DOT_DOT,
    STATE(4739), 1,
      sym_heredoc_body,
    ACTIONS(3709), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170635] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3715), 1,
      anon_sym_DOT_DOT,
    STATE(4740), 1,
      sym_heredoc_body,
    ACTIONS(3713), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170662] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_DOT_DOT,
    STATE(4741), 1,
      sym_heredoc_body,
    ACTIONS(3022), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170689] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_DOT_DOT,
    STATE(4742), 1,
      sym_heredoc_body,
    ACTIONS(3036), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170716] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7035), 1,
      anon_sym_COMMA,
    STATE(4743), 1,
      sym_heredoc_body,
    STATE(4751), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [170744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4744), 1,
      sym_heredoc_body,
    STATE(4949), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2988), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [170774] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7039), 1,
      anon_sym_DOT_DOT,
    STATE(4745), 1,
      sym_heredoc_body,
    ACTIONS(6441), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4746), 1,
      sym_heredoc_body,
    STATE(5012), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2972), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [170832] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym___END__,
    STATE(4747), 1,
      sym_heredoc_body,
    ACTIONS(7041), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6811), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170860] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym___END__,
    STATE(4748), 1,
      sym_heredoc_body,
    ACTIONS(7041), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6897), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170888] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7045), 1,
      anon_sym___END__,
    STATE(4749), 1,
      sym_heredoc_body,
    ACTIONS(7041), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6893), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170916] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7047), 1,
      anon_sym___END__,
    STATE(4750), 1,
      sym_heredoc_body,
    ACTIONS(7041), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6889), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170944] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7035), 1,
      anon_sym_COMMA,
    STATE(4751), 1,
      sym_heredoc_body,
    STATE(4754), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [170972] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6664), 1,
      anon_sym___END__,
    ACTIONS(7049), 1,
      anon_sym_rescue,
    STATE(4752), 1,
      sym_heredoc_body,
    ACTIONS(6662), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [171000] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7051), 1,
      anon_sym___END__,
    ACTIONS(7053), 1,
      anon_sym_COMMA,
    STATE(4753), 1,
      sym_heredoc_body,
    STATE(4756), 1,
      aux_sym_undef_repeat1,
    ACTIONS(6868), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171030] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7055), 1,
      anon_sym_COMMA,
    STATE(4754), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [171056] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(733), 1,
      anon_sym_DOT,
    ACTIONS(745), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6854), 1,
      anon_sym_EQ2,
    STATE(4755), 1,
      sym_heredoc_body,
    ACTIONS(4782), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(4784), 7,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [171088] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6787), 1,
      anon_sym___END__,
    ACTIONS(7058), 1,
      anon_sym_COMMA,
    STATE(4756), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(6785), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171116] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7061), 1,
      anon_sym___END__,
    STATE(4757), 1,
      sym_heredoc_body,
    ACTIONS(7041), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6901), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171144] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7063), 1,
      anon_sym_COLON,
    STATE(4758), 1,
      sym_heredoc_body,
    ACTIONS(3252), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171172] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym___END__,
    STATE(4759), 1,
      sym_heredoc_body,
    ACTIONS(7041), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6895), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171200] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7069), 1,
      anon_sym_DOT_DOT,
    STATE(4760), 1,
      sym_heredoc_body,
    ACTIONS(6441), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171228] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4782), 1,
      anon_sym___END__,
    ACTIONS(7071), 1,
      anon_sym_EQ2,
    STATE(4761), 1,
      sym_heredoc_body,
    ACTIONS(4784), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171256] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7053), 1,
      anon_sym_COMMA,
    ACTIONS(7073), 1,
      anon_sym___END__,
    STATE(4753), 1,
      aux_sym_undef_repeat1,
    STATE(4762), 1,
      sym_heredoc_body,
    ACTIONS(6850), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171286] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6672), 1,
      anon_sym___END__,
    ACTIONS(7049), 1,
      anon_sym_rescue,
    STATE(4763), 1,
      sym_heredoc_body,
    ACTIONS(6670), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [171314] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4764), 1,
      sym_heredoc_body,
    ACTIONS(6559), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4765), 1,
      sym_heredoc_body,
    ACTIONS(2642), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4766), 1,
      sym_heredoc_body,
    ACTIONS(745), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171383] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1265), 1,
      anon_sym___END__,
    ACTIONS(7075), 1,
      anon_sym_rescue,
    ACTIONS(7079), 1,
      anon_sym_if,
    ACTIONS(7081), 1,
      anon_sym_unless,
    ACTIONS(7083), 1,
      anon_sym_while,
    ACTIONS(7085), 1,
      anon_sym_until,
    STATE(2132), 1,
      sym__terminator,
    STATE(4767), 1,
      sym_heredoc_body,
    ACTIONS(1263), 2,
      ts_builtin_sym_end,
      aux_sym_program_token1,
    ACTIONS(7077), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171422] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    ACTIONS(7087), 1,
      anon_sym_COMMA,
    STATE(4768), 1,
      sym_heredoc_body,
    ACTIONS(6775), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171449] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7089), 1,
      anon_sym_LBRACE,
    ACTIONS(7091), 1,
      anon_sym_do,
    STATE(4769), 1,
      sym_heredoc_body,
    STATE(5110), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2972), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171478] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7093), 1,
      anon_sym_COMMA,
    STATE(4770), 1,
      sym_heredoc_body,
    STATE(4771), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6658), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171505] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7095), 1,
      anon_sym_COMMA,
    STATE(4771), 1,
      sym_heredoc_body,
    STATE(4783), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5604), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4772), 1,
      sym_heredoc_body,
    ACTIONS(2626), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171555] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7089), 1,
      anon_sym_LBRACE,
    ACTIONS(7091), 1,
      anon_sym_do,
    STATE(4773), 1,
      sym_heredoc_body,
    STATE(5124), 2,
      sym_do_block,
      sym_block,
    ACTIONS(2988), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171584] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7097), 1,
      sym_identifier,
    STATE(4774), 1,
      sym_heredoc_body,
    ACTIONS(2660), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2652), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [171611] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7075), 1,
      anon_sym_rescue,
    ACTIONS(7079), 1,
      anon_sym_if,
    ACTIONS(7081), 1,
      anon_sym_unless,
    ACTIONS(7083), 1,
      anon_sym_while,
    ACTIONS(7085), 1,
      anon_sym_until,
    ACTIONS(7099), 1,
      anon_sym___END__,
    STATE(2132), 1,
      sym__terminator,
    STATE(4775), 1,
      sym_heredoc_body,
    ACTIONS(6973), 2,
      ts_builtin_sym_end,
      aux_sym_program_token1,
    ACTIONS(7077), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171650] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7101), 1,
      anon_sym_COMMA,
    STATE(4776), 1,
      sym_heredoc_body,
    STATE(4782), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6766), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4777), 1,
      sym_heredoc_body,
    ACTIONS(2634), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4778), 1,
      sym_heredoc_body,
    ACTIONS(2646), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171723] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4983), 1,
      anon_sym___END__,
    STATE(4779), 1,
      sym_heredoc_body,
    ACTIONS(4985), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171748] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym___END__,
    STATE(4780), 1,
      sym_heredoc_body,
    ACTIONS(2630), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171773] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4781), 1,
      sym_heredoc_body,
    STATE(5754), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6283), 2,
      sym_constant,
      sym_identifier,
    STATE(5941), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [171808] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7103), 1,
      anon_sym_COMMA,
    STATE(4782), 1,
      sym_heredoc_body,
    STATE(4793), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171835] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7105), 1,
      anon_sym_COMMA,
    STATE(4783), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6637), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171860] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4784), 1,
      sym_heredoc_body,
    STATE(4908), 1,
      sym_keyword_pattern,
    STATE(5791), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6732), 2,
      sym_constant,
      sym_identifier,
    STATE(5980), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [171895] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4785), 1,
      sym_heredoc_body,
    ACTIONS(6503), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [171918] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4786), 1,
      sym_heredoc_body,
    ACTIONS(6503), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [171941] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4782), 1,
      anon_sym___END__,
    STATE(4787), 1,
      sym_heredoc_body,
    ACTIONS(4784), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171966] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4788), 1,
      sym_heredoc_body,
    ACTIONS(6537), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171989] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4789), 1,
      sym_heredoc_body,
    ACTIONS(6541), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172012] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4790), 1,
      sym_heredoc_body,
    ACTIONS(6545), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172035] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4791), 1,
      sym_heredoc_body,
    ACTIONS(6555), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172058] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym___END__,
    STATE(4792), 1,
      sym_heredoc_body,
    ACTIONS(2642), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172083] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7108), 1,
      anon_sym_COMMA,
    STATE(4793), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6595), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172108] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7101), 1,
      anon_sym_COMMA,
    STATE(4794), 1,
      sym_heredoc_body,
    STATE(4796), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6766), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172135] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4795), 1,
      sym_heredoc_body,
    STATE(4908), 1,
      sym_keyword_pattern,
    STATE(5655), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6734), 2,
      sym_constant,
      sym_identifier,
    STATE(5647), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [172170] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7101), 1,
      anon_sym_COMMA,
    STATE(4793), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4796), 1,
      sym_heredoc_body,
    ACTIONS(6744), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172197] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7111), 1,
      anon_sym_COLON,
    STATE(4797), 1,
      sym_heredoc_body,
    ACTIONS(3082), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172222] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4798), 1,
      sym_heredoc_body,
    STATE(5644), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6583), 2,
      sym_constant,
      sym_identifier,
    STATE(5951), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [172257] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7113), 1,
      anon_sym_PIPE,
    STATE(4799), 1,
      sym_heredoc_body,
    STATE(4823), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6585), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4800), 1,
      sym_heredoc_body,
    ACTIONS(2638), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172307] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4801), 1,
      sym_heredoc_body,
    ACTIONS(6575), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172330] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7115), 1,
      anon_sym_PIPE,
    STATE(4802), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6649), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172355] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4803), 1,
      sym_heredoc_body,
    ACTIONS(6533), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172378] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    STATE(4804), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6649), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4805), 1,
      sym_heredoc_body,
    ACTIONS(2618), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172426] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7121), 1,
      anon_sym_rescue,
    STATE(4806), 1,
      sym_heredoc_body,
    ACTIONS(6662), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [172451] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7121), 1,
      anon_sym_rescue,
    STATE(4807), 1,
      sym_heredoc_body,
    ACTIONS(6670), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [172476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4808), 1,
      sym_heredoc_body,
    ACTIONS(2618), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2620), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172501] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4809), 1,
      sym_heredoc_body,
    ACTIONS(6529), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172524] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym___END__,
    STATE(4810), 1,
      sym_heredoc_body,
    ACTIONS(2626), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172549] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4811), 1,
      sym_heredoc_body,
    ACTIONS(6623), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172572] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(733), 1,
      anon_sym_DOT,
    ACTIONS(745), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4782), 1,
      anon_sym_STAR,
    STATE(4812), 1,
      sym_heredoc_body,
    ACTIONS(4784), 8,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [172601] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym___END__,
    STATE(4813), 1,
      sym_heredoc_body,
    ACTIONS(2634), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [172626] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4814), 1,
      sym_heredoc_body,
    ACTIONS(6499), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [172649] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4815), 1,
      sym_heredoc_body,
    ACTIONS(6499), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [172672] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4816), 1,
      sym_heredoc_body,
    ACTIONS(3082), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172695] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7123), 1,
      anon_sym_PIPE,
    STATE(4817), 1,
      sym_heredoc_body,
    STATE(4833), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6585), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172722] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4818), 1,
      sym_heredoc_body,
    ACTIONS(6523), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172745] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4819), 1,
      sym_heredoc_body,
    ACTIONS(6551), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172768] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4820), 1,
      sym_heredoc_body,
    ACTIONS(2638), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172791] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2888), 1,
      sym__string_start,
    STATE(4483), 1,
      sym_keyword_pattern,
    STATE(4821), 1,
      sym_heredoc_body,
    STATE(5801), 1,
      sym_string,
    ACTIONS(2880), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2882), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5602), 2,
      sym_constant,
      sym_identifier,
    STATE(5836), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [172826] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4822), 1,
      sym_heredoc_body,
    ACTIONS(6615), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172849] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7113), 1,
      anon_sym_PIPE,
    STATE(4804), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4823), 1,
      sym_heredoc_body,
    ACTIONS(6722), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172876] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4824), 1,
      sym_heredoc_body,
    ACTIONS(6565), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172899] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4825), 1,
      sym_heredoc_body,
    ACTIONS(6579), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172922] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4826), 1,
      sym_heredoc_body,
    ACTIONS(6569), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172945] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4827), 1,
      sym_heredoc_body,
    ACTIONS(7125), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6654), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172970] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4828), 1,
      sym_heredoc_body,
    ACTIONS(3651), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172993] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4829), 1,
      sym_heredoc_body,
    ACTIONS(6519), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173016] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym___END__,
    STATE(4830), 1,
      sym_heredoc_body,
    ACTIONS(2646), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [173041] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4831), 1,
      sym_heredoc_body,
    ACTIONS(6441), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173064] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4832), 1,
      sym_heredoc_body,
    ACTIONS(3581), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173087] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7123), 1,
      anon_sym_PIPE,
    STATE(4802), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4833), 1,
      sym_heredoc_body,
    ACTIONS(6722), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4834), 1,
      sym_heredoc_body,
    ACTIONS(2630), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173137] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_EQ_GT,
    ACTIONS(7087), 1,
      anon_sym_COMMA,
    STATE(4835), 1,
      sym_heredoc_body,
    ACTIONS(6678), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [173164] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4836), 1,
      sym_heredoc_body,
    ACTIONS(2618), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173186] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7127), 1,
      anon_sym_COMMA,
    STATE(4837), 1,
      sym_heredoc_body,
    STATE(4839), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [173212] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(265), 1,
      sym__terminator,
    STATE(4838), 1,
      sym_heredoc_body,
    STATE(5301), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173250] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7131), 1,
      anon_sym_COMMA,
    STATE(4839), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [173274] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    STATE(4840), 1,
      sym_heredoc_body,
    ACTIONS(6589), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173298] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4841), 1,
      sym_heredoc_body,
    ACTIONS(6585), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173320] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_then,
    ACTIONS(7136), 1,
      anon_sym_if,
    ACTIONS(7138), 1,
      anon_sym_unless,
    STATE(302), 1,
      sym__terminator,
    STATE(4842), 1,
      sym_heredoc_body,
    STATE(5294), 1,
      sym__guard,
    STATE(5553), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5500), 2,
      sym_if_guard,
      sym_unless_guard,
  [173356] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    STATE(4843), 1,
      sym_heredoc_body,
    ACTIONS(6611), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6854), 1,
      anon_sym_EQ2,
    STATE(4844), 1,
      sym_heredoc_body,
    ACTIONS(4782), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(4784), 7,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [173406] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym_LBRACE,
    STATE(4785), 1,
      sym_do_block,
    STATE(4786), 1,
      sym_block,
    STATE(4845), 1,
      sym_heredoc_body,
    ACTIONS(6515), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173434] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_rescue,
    STATE(4846), 1,
      sym_heredoc_body,
    ACTIONS(6662), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [173458] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym_LBRACE,
    STATE(4814), 1,
      sym_do_block,
    STATE(4815), 1,
      sym_block,
    STATE(4847), 1,
      sym_heredoc_body,
    ACTIONS(6507), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173486] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4848), 1,
      sym_heredoc_body,
    ACTIONS(2626), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173508] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4849), 1,
      sym_heredoc_body,
    ACTIONS(6289), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173530] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_rescue,
    STATE(4850), 1,
      sym_heredoc_body,
    ACTIONS(6670), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [173554] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(267), 1,
      sym__terminator,
    STATE(4851), 1,
      sym_heredoc_body,
    STATE(5309), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173592] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4852), 1,
      sym_heredoc_body,
    ACTIONS(6607), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173614] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(269), 1,
      sym__terminator,
    STATE(4853), 1,
      sym_heredoc_body,
    STATE(5316), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173652] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4854), 1,
      sym_heredoc_body,
    ACTIONS(6599), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173674] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4855), 1,
      sym_heredoc_body,
    ACTIONS(7142), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6811), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [173698] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_rescue,
    ACTIONS(7146), 1,
      anon_sym_if,
    ACTIONS(7148), 1,
      anon_sym_unless,
    ACTIONS(7150), 1,
      anon_sym_while,
    ACTIONS(7152), 1,
      anon_sym_until,
    ACTIONS(7154), 1,
      anon_sym_do,
    STATE(335), 1,
      sym__terminator,
    STATE(4856), 1,
      sym_heredoc_body,
    STATE(5406), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173736] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_rescue,
    ACTIONS(7146), 1,
      anon_sym_if,
    ACTIONS(7148), 1,
      anon_sym_unless,
    ACTIONS(7150), 1,
      anon_sym_while,
    ACTIONS(7152), 1,
      anon_sym_until,
    ACTIONS(7156), 1,
      anon_sym_do,
    STATE(352), 1,
      sym__terminator,
    STATE(2327), 1,
      sym_do,
    STATE(4857), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173774] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4858), 1,
      sym_heredoc_body,
    ACTIONS(2642), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173796] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym_LBRACE,
    ACTIONS(7158), 1,
      anon_sym_do,
    STATE(4785), 1,
      sym_do_block,
    STATE(4786), 1,
      sym_block,
    STATE(4859), 1,
      sym_heredoc_body,
    ACTIONS(6515), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173826] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym_LBRACE,
    ACTIONS(7158), 1,
      anon_sym_do,
    STATE(4814), 1,
      sym_do_block,
    STATE(4815), 1,
      sym_block,
    STATE(4860), 1,
      sym_heredoc_body,
    ACTIONS(6507), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173856] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_COLON,
    STATE(4861), 1,
      sym_heredoc_body,
    ACTIONS(3082), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173880] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4862), 1,
      sym_heredoc_body,
    ACTIONS(7142), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6893), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [173904] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4863), 1,
      sym_heredoc_body,
    ACTIONS(2638), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173926] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4864), 1,
      sym_heredoc_body,
    ACTIONS(745), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [173948] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_rescue,
    ACTIONS(7146), 1,
      anon_sym_if,
    ACTIONS(7148), 1,
      anon_sym_unless,
    ACTIONS(7150), 1,
      anon_sym_while,
    ACTIONS(7152), 1,
      anon_sym_until,
    ACTIONS(7156), 1,
      anon_sym_do,
    STATE(352), 1,
      sym__terminator,
    STATE(2329), 1,
      sym_do,
    STATE(4865), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [173986] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_rescue,
    ACTIONS(7146), 1,
      anon_sym_if,
    ACTIONS(7148), 1,
      anon_sym_unless,
    ACTIONS(7150), 1,
      anon_sym_while,
    ACTIONS(7152), 1,
      anon_sym_until,
    ACTIONS(7154), 1,
      anon_sym_do,
    STATE(335), 1,
      sym__terminator,
    STATE(4866), 1,
      sym_heredoc_body,
    STATE(5439), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174024] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4867), 1,
      sym_heredoc_body,
    ACTIONS(7142), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6895), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [174048] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_rescue,
    ACTIONS(7146), 1,
      anon_sym_if,
    ACTIONS(7148), 1,
      anon_sym_unless,
    ACTIONS(7150), 1,
      anon_sym_while,
    ACTIONS(7152), 1,
      anon_sym_until,
    ACTIONS(7162), 1,
      anon_sym_do,
    STATE(337), 1,
      sym__terminator,
    STATE(2962), 1,
      sym_do,
    STATE(4868), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174086] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4869), 1,
      sym_heredoc_body,
    STATE(4984), 1,
      sym_argument_list,
    STATE(5330), 1,
      sym_do_block,
    STATE(5332), 1,
      sym_block,
    ACTIONS(411), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174120] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4870), 1,
      sym_heredoc_body,
    ACTIONS(2618), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2620), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174144] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4871), 1,
      sym_heredoc_body,
    ACTIONS(7142), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6897), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [174168] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_rescue,
    ACTIONS(7146), 1,
      anon_sym_if,
    ACTIONS(7148), 1,
      anon_sym_unless,
    ACTIONS(7150), 1,
      anon_sym_while,
    ACTIONS(7152), 1,
      anon_sym_until,
    ACTIONS(7162), 1,
      anon_sym_do,
    STATE(337), 1,
      sym__terminator,
    STATE(2972), 1,
      sym_do,
    STATE(4872), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174206] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4873), 1,
      sym_heredoc_body,
    ACTIONS(7142), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6901), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [174230] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4874), 1,
      sym_heredoc_body,
    ACTIONS(7142), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6889), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [174254] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(272), 1,
      sym__terminator,
    STATE(4875), 1,
      sym_heredoc_body,
    STATE(5318), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174292] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(273), 1,
      sym__terminator,
    STATE(4876), 1,
      sym_heredoc_body,
    STATE(5293), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174330] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(268), 1,
      sym__terminator,
    STATE(4877), 1,
      sym_heredoc_body,
    STATE(5295), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174368] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7127), 1,
      anon_sym_COMMA,
    STATE(4837), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4878), 1,
      sym_heredoc_body,
    ACTIONS(6756), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [174394] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4879), 1,
      sym_heredoc_body,
    ACTIONS(2634), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174416] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4880), 1,
      sym_heredoc_body,
    ACTIONS(2646), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174438] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4881), 1,
      sym_heredoc_body,
    ACTIONS(2630), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174460] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(271), 1,
      sym__terminator,
    STATE(4882), 1,
      sym_heredoc_body,
    STATE(5315), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [174498] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7164), 1,
      anon_sym_COMMA,
    STATE(4883), 1,
      sym_heredoc_body,
    STATE(4905), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6766), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174523] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4884), 1,
      sym_heredoc_body,
    ACTIONS(6718), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174544] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7164), 1,
      anon_sym_COMMA,
    STATE(4885), 1,
      sym_heredoc_body,
    STATE(4888), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6766), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174569] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_COMMA,
    STATE(4886), 1,
      sym_heredoc_body,
    ACTIONS(6775), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174594] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7168), 1,
      anon_sym_end,
    STATE(4887), 1,
      sym_heredoc_body,
    STATE(5214), 1,
      aux_sym_case_repeat1,
    STATE(5223), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5837), 1,
      sym_else,
  [174631] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7170), 1,
      anon_sym_COMMA,
    STATE(4888), 1,
      sym_heredoc_body,
    STATE(4936), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174656] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7172), 1,
      anon_sym_COMMA,
    STATE(4889), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6637), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174679] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7177), 1,
      aux_sym_string_array_token1,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7183), 1,
      sym__string_end,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    STATE(4890), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5556), 1,
      aux_sym_string_array_repeat1,
  [174716] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7187), 1,
      aux_sym_string_array_token1,
    ACTIONS(7189), 1,
      sym__string_end,
    STATE(4891), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5517), 1,
      aux_sym_symbol_array_repeat1,
  [174753] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4892), 1,
      sym_heredoc_body,
    ACTIONS(6641), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174774] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(4893), 1,
      sym_heredoc_body,
    STATE(4935), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6658), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174799] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4894), 1,
      sym_heredoc_body,
    ACTIONS(6658), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174820] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    ACTIONS(7166), 1,
      anon_sym_COMMA,
    STATE(4895), 1,
      sym_heredoc_body,
    ACTIONS(6678), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174845] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7193), 1,
      anon_sym_end,
    STATE(4896), 1,
      sym_heredoc_body,
    STATE(5281), 1,
      aux_sym_case_repeat1,
    STATE(5282), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5724), 1,
      sym_else,
  [174882] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7195), 1,
      aux_sym_string_array_token1,
    ACTIONS(7197), 1,
      sym__string_end,
    STATE(4897), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5529), 1,
      aux_sym_string_array_repeat1,
  [174919] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7199), 1,
      aux_sym_string_array_token1,
    ACTIONS(7201), 1,
      sym__string_end,
    STATE(4898), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5548), 1,
      aux_sym_symbol_array_repeat1,
  [174956] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7203), 1,
      aux_sym_string_array_token1,
    ACTIONS(7205), 1,
      sym__string_end,
    STATE(4899), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5514), 1,
      aux_sym_string_array_repeat1,
  [174993] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7207), 1,
      aux_sym_string_array_token1,
    ACTIONS(7209), 1,
      sym__string_end,
    STATE(4900), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5522), 1,
      aux_sym_string_array_repeat1,
  [175030] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7211), 1,
      aux_sym_string_array_token1,
    ACTIONS(7213), 1,
      sym__string_end,
    STATE(4901), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5533), 1,
      aux_sym_symbol_array_repeat1,
  [175067] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7215), 1,
      aux_sym_string_array_token1,
    ACTIONS(7217), 1,
      sym__string_end,
    STATE(4902), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5537), 1,
      aux_sym_symbol_array_repeat1,
  [175104] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7219), 1,
      aux_sym_string_array_token1,
    ACTIONS(7221), 1,
      sym__string_end,
    STATE(4903), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5502), 1,
      aux_sym_string_array_repeat1,
  [175141] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7223), 1,
      aux_sym_string_array_token1,
    ACTIONS(7225), 1,
      sym__string_end,
    STATE(4904), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5535), 1,
      aux_sym_symbol_array_repeat1,
  [175178] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7164), 1,
      anon_sym_COMMA,
    STATE(4905), 1,
      sym_heredoc_body,
    STATE(4936), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6744), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175203] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7227), 1,
      anon_sym_end,
    STATE(4906), 1,
      sym_heredoc_body,
    STATE(5235), 1,
      aux_sym_case_repeat1,
    STATE(5251), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5873), 1,
      sym_else,
  [175240] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7229), 1,
      anon_sym_COMMA,
    STATE(4907), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175263] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4908), 1,
      sym_heredoc_body,
    ACTIONS(6637), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175284] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7232), 1,
      anon_sym_end,
    STATE(4909), 1,
      sym_heredoc_body,
    STATE(5229), 1,
      aux_sym_case_repeat1,
    STATE(5232), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5806), 1,
      sym_else,
  [175321] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4910), 1,
      sym_heredoc_body,
    ACTIONS(5662), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175342] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7234), 1,
      anon_sym_COMMA,
    STATE(4911), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6637), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175365] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4912), 1,
      sym_heredoc_body,
    ACTIONS(6710), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175386] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7237), 1,
      aux_sym_string_array_token1,
    ACTIONS(7239), 1,
      sym__string_end,
    STATE(4913), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5538), 1,
      aux_sym_symbol_array_repeat1,
  [175423] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7241), 1,
      aux_sym_string_array_token1,
    ACTIONS(7243), 1,
      sym__string_end,
    STATE(4914), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5554), 1,
      aux_sym_string_array_repeat1,
  [175460] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7245), 1,
      anon_sym_rescue,
    STATE(4915), 1,
      sym_heredoc_body,
    ACTIONS(6662), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [175483] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7245), 1,
      anon_sym_rescue,
    STATE(4916), 1,
      sym_heredoc_body,
    ACTIONS(6670), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [175506] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4917), 1,
      sym_heredoc_body,
    ACTIONS(6682), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175527] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7247), 1,
      aux_sym_string_array_token1,
    ACTIONS(7249), 1,
      sym__string_end,
    STATE(4918), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5557), 1,
      aux_sym_symbol_array_repeat1,
  [175564] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7251), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      sym_heredoc_body,
    STATE(4934), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [175589] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7253), 1,
      anon_sym_COMMA,
    STATE(4920), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6658), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175614] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_COMMA,
    STATE(4889), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4921), 1,
      sym_heredoc_body,
    ACTIONS(5604), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175639] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7257), 1,
      anon_sym_COMMA,
    STATE(4907), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4922), 1,
      sym_heredoc_body,
    ACTIONS(6764), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175664] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7259), 1,
      anon_sym_COMMA,
    STATE(4923), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [175687] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7262), 1,
      aux_sym_string_array_token1,
    ACTIONS(7264), 1,
      sym__string_end,
    STATE(4924), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5560), 1,
      aux_sym_string_array_repeat1,
  [175724] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7266), 1,
      anon_sym_end,
    STATE(4925), 1,
      sym_heredoc_body,
    STATE(5255), 1,
      aux_sym_case_repeat1,
    STATE(5256), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5709), 1,
      sym_else,
  [175761] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7268), 1,
      anon_sym_end,
    STATE(4926), 1,
      sym_heredoc_body,
    STATE(5246), 1,
      aux_sym_case_repeat1,
    STATE(5250), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5539), 1,
      sym_when,
    STATE(5645), 1,
      sym_else,
  [175798] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7270), 1,
      aux_sym_string_array_token1,
    ACTIONS(7272), 1,
      sym__string_end,
    STATE(4927), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5544), 1,
      aux_sym_string_array_repeat1,
  [175835] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7274), 1,
      aux_sym_string_array_token1,
    ACTIONS(7276), 1,
      sym__string_end,
    STATE(4928), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5532), 1,
      aux_sym_string_array_repeat1,
  [175872] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7278), 1,
      aux_sym_string_array_token1,
    ACTIONS(7280), 1,
      sym__string_end,
    STATE(4929), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5496), 1,
      aux_sym_symbol_array_repeat1,
  [175909] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7282), 1,
      aux_sym_string_array_token1,
    ACTIONS(7284), 1,
      sym__string_end,
    STATE(4930), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5563), 1,
      aux_sym_symbol_array_repeat1,
  [175946] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7286), 1,
      aux_sym_string_array_token1,
    ACTIONS(7288), 1,
      sym__string_end,
    STATE(4931), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5527), 1,
      aux_sym_string_array_repeat1,
  [175983] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7257), 1,
      anon_sym_COMMA,
    STATE(4922), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4932), 1,
      sym_heredoc_body,
    ACTIONS(6756), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176008] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7290), 1,
      aux_sym_string_array_token1,
    ACTIONS(7292), 1,
      sym__string_end,
    STATE(4933), 1,
      sym_heredoc_body,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5287), 1,
      sym_interpolation,
    STATE(5550), 1,
      aux_sym_symbol_array_repeat1,
  [176045] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7251), 1,
      anon_sym_COMMA,
    STATE(4923), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4934), 1,
      sym_heredoc_body,
    ACTIONS(6764), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [176070] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7294), 1,
      anon_sym_COMMA,
    STATE(4911), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4935), 1,
      sym_heredoc_body,
    ACTIONS(5604), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176095] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_COMMA,
    STATE(4936), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6595), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176118] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    STATE(4937), 1,
      sym_heredoc_body,
    ACTIONS(6595), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176141] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7299), 1,
      anon_sym_COMMA,
    STATE(4938), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176163] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4939), 1,
      sym_heredoc_body,
    ACTIONS(6633), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176183] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4940), 1,
      sym_heredoc_body,
    STATE(5418), 1,
      sym_do_block,
    STATE(5419), 1,
      sym_block,
    ACTIONS(3297), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176211] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4941), 1,
      sym_heredoc_body,
    ACTIONS(6662), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4942), 1,
      sym_heredoc_body,
    ACTIONS(3044), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176251] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_rescue,
    STATE(4943), 1,
      sym_heredoc_body,
    ACTIONS(6670), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4944), 1,
      sym_heredoc_body,
    ACTIONS(3052), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4945), 1,
      sym_heredoc_body,
    ACTIONS(3058), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4946), 1,
      sym_heredoc_body,
    ACTIONS(3062), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4947), 1,
      sym_heredoc_body,
    ACTIONS(3066), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176353] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    ACTIONS(7304), 1,
      anon_sym_COMMA,
    STATE(4948), 1,
      sym_heredoc_body,
    ACTIONS(6678), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4949), 1,
      sym_heredoc_body,
    ACTIONS(3006), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4950), 1,
      sym_heredoc_body,
    ACTIONS(3070), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4951), 1,
      sym_heredoc_body,
    ACTIONS(3002), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4952), 1,
      sym_heredoc_body,
    ACTIONS(3018), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4953), 1,
      sym_heredoc_body,
    ACTIONS(2998), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176477] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7306), 1,
      anon_sym_COMMA,
    STATE(4954), 1,
      sym_heredoc_body,
    STATE(5001), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6766), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176501] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7308), 1,
      anon_sym_COMMA,
    STATE(4955), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6595), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176523] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7306), 1,
      anon_sym_COMMA,
    STATE(4956), 1,
      sym_heredoc_body,
    STATE(4972), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6766), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176547] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(7311), 1,
      anon_sym_in,
    STATE(4957), 1,
      sym_heredoc_body,
    STATE(5300), 1,
      sym_in,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3092), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176575] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4958), 1,
      sym_heredoc_body,
    ACTIONS(6678), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176595] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_COMMA,
    STATE(4959), 1,
      sym_heredoc_body,
    STATE(4979), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [176619] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7315), 1,
      aux_sym_string_array_token1,
    ACTIONS(7317), 1,
      sym__string_end,
    STATE(4931), 1,
      aux_sym__literal_contents,
    STATE(4960), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [176653] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7319), 1,
      aux_sym_string_array_token1,
    ACTIONS(7321), 1,
      sym__string_end,
    STATE(4933), 1,
      aux_sym__literal_contents,
    STATE(4961), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [176687] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4962), 1,
      sym_heredoc_body,
    ACTIONS(6674), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176707] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7323), 1,
      aux_sym_string_array_token1,
    ACTIONS(7325), 1,
      sym__string_end,
    STATE(4897), 1,
      aux_sym__literal_contents,
    STATE(4963), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [176741] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7327), 1,
      aux_sym_string_array_token1,
    ACTIONS(7329), 1,
      sym__string_end,
    STATE(4898), 1,
      aux_sym__literal_contents,
    STATE(4964), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [176775] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4965), 1,
      sym_heredoc_body,
    ACTIONS(6706), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176795] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7331), 1,
      aux_sym_string_array_token1,
    ACTIONS(7333), 1,
      sym__string_end,
    STATE(4900), 1,
      aux_sym__literal_contents,
    STATE(4966), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [176829] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4967), 1,
      sym_heredoc_body,
    ACTIONS(6728), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176849] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7335), 1,
      aux_sym_string_array_token1,
    ACTIONS(7337), 1,
      sym__string_end,
    STATE(4901), 1,
      aux_sym__literal_contents,
    STATE(4968), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [176883] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4969), 1,
      sym_heredoc_body,
    ACTIONS(6670), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176903] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    ACTIONS(7304), 1,
      anon_sym_COMMA,
    STATE(4970), 1,
      sym_heredoc_body,
    ACTIONS(6775), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176927] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4971), 1,
      sym_heredoc_body,
    ACTIONS(6645), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176947] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7306), 1,
      anon_sym_COMMA,
    STATE(4955), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4972), 1,
      sym_heredoc_body,
    ACTIONS(6744), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4973), 1,
      sym_heredoc_body,
    ACTIONS(3014), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176991] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4974), 1,
      sym_heredoc_body,
    ACTIONS(6698), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177011] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7339), 1,
      anon_sym_rescue,
    STATE(4975), 1,
      sym_heredoc_body,
    ACTIONS(6662), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177033] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7339), 1,
      anon_sym_rescue,
    STATE(4976), 1,
      sym_heredoc_body,
    ACTIONS(6670), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177055] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4977), 1,
      sym_heredoc_body,
    ACTIONS(6515), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4978), 1,
      sym_heredoc_body,
    ACTIONS(3022), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177095] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_COMMA,
    STATE(4979), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [177117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4980), 1,
      sym_heredoc_body,
    ACTIONS(3092), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(7344), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [177139] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4981), 1,
      sym_heredoc_body,
    ACTIONS(6627), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177159] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4982), 1,
      sym_heredoc_body,
    ACTIONS(6627), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4983), 1,
      sym_heredoc_body,
    ACTIONS(3010), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177199] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4984), 1,
      sym_heredoc_body,
    STATE(5425), 1,
      sym_do_block,
    STATE(5433), 1,
      sym_block,
    ACTIONS(3315), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177227] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4985), 1,
      sym_heredoc_body,
    ACTIONS(6627), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177247] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    STATE(2132), 1,
      sym__terminator,
    STATE(4986), 1,
      sym_heredoc_body,
    ACTIONS(7077), 2,
      sym__line_break,
      anon_sym_SEMI,
  [177279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4987), 1,
      sym_heredoc_body,
    ACTIONS(3028), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4988), 1,
      sym_heredoc_body,
    ACTIONS(3032), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177319] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7346), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7349), 1,
      aux_sym_string_array_token1,
    ACTIONS(7351), 1,
      sym_escape_sequence,
    ACTIONS(7354), 1,
      sym_string_content,
    ACTIONS(7357), 1,
      sym__string_end,
    ACTIONS(7359), 1,
      sym__short_interpolation,
    STATE(5287), 1,
      sym_interpolation,
    STATE(4989), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [177351] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_rescue,
    STATE(4990), 1,
      sym_heredoc_body,
    ACTIONS(6662), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4991), 1,
      sym_heredoc_body,
    ACTIONS(3036), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177393] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7362), 1,
      anon_sym_COMMA,
    STATE(4992), 1,
      sym_heredoc_body,
    STATE(5011), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177417] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4993), 1,
      sym_heredoc_body,
    ACTIONS(6714), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177437] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7364), 1,
      aux_sym_string_array_token1,
    ACTIONS(7366), 1,
      sym__string_end,
    STATE(4927), 1,
      aux_sym__literal_contents,
    STATE(4994), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4995), 1,
      sym_heredoc_body,
    ACTIONS(3040), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177491] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(4996), 1,
      sym_heredoc_body,
    STATE(5391), 1,
      sym_do_block,
    STATE(5392), 1,
      sym_block,
    ACTIONS(3293), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4997), 1,
      sym_heredoc_body,
    ACTIONS(123), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177539] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7368), 1,
      aux_sym_string_array_token1,
    ACTIONS(7370), 1,
      sym__string_end,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(4998), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177573] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7372), 1,
      aux_sym_string_array_token1,
    ACTIONS(7374), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(4999), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177607] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_COMMA,
    STATE(4959), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5000), 1,
      sym_heredoc_body,
    ACTIONS(6756), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [177631] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7376), 1,
      anon_sym_COMMA,
    STATE(4955), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(5001), 1,
      sym_heredoc_body,
    ACTIONS(6744), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177655] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7378), 1,
      aux_sym_string_array_token1,
    ACTIONS(7380), 1,
      sym__string_end,
    STATE(4913), 1,
      aux_sym__literal_contents,
    STATE(5002), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177689] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7382), 1,
      aux_sym_string_array_token1,
    ACTIONS(7384), 1,
      sym__string_end,
    STATE(4929), 1,
      aux_sym__literal_contents,
    STATE(5003), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177723] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7386), 1,
      aux_sym_string_array_token1,
    ACTIONS(7388), 1,
      sym__string_end,
    STATE(4904), 1,
      aux_sym__literal_contents,
    STATE(5004), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177757] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5005), 1,
      sym_heredoc_body,
    ACTIONS(6706), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177777] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5006), 1,
      sym_heredoc_body,
    ACTIONS(6694), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5007), 1,
      sym_heredoc_body,
    ACTIONS(3092), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(7390), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [177819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5008), 1,
      sym_heredoc_body,
    ACTIONS(3074), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177839] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7392), 1,
      aux_sym_string_array_token1,
    ACTIONS(7394), 1,
      sym__string_end,
    STATE(4924), 1,
      aux_sym__literal_contents,
    STATE(5009), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177873] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7396), 1,
      aux_sym_string_array_token1,
    ACTIONS(7398), 1,
      sym__string_end,
    STATE(4899), 1,
      aux_sym__literal_contents,
    STATE(5010), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177907] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7362), 1,
      anon_sym_COMMA,
    STATE(4938), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5011), 1,
      sym_heredoc_body,
    ACTIONS(6764), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5012), 1,
      sym_heredoc_body,
    ACTIONS(3048), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177951] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7400), 1,
      aux_sym_string_array_token1,
    ACTIONS(7402), 1,
      sym__string_end,
    STATE(4914), 1,
      aux_sym__literal_contents,
    STATE(5013), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [177985] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7404), 1,
      aux_sym_string_array_token1,
    ACTIONS(7406), 1,
      sym__string_end,
    STATE(4989), 1,
      aux_sym__literal_contents,
    STATE(5014), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [178019] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7408), 1,
      aux_sym_string_array_token1,
    ACTIONS(7410), 1,
      sym__string_end,
    STATE(4902), 1,
      aux_sym__literal_contents,
    STATE(5015), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [178053] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5016), 1,
      sym_heredoc_body,
    ACTIONS(6619), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178073] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7412), 1,
      aux_sym_string_array_token1,
    ACTIONS(7414), 1,
      sym__string_end,
    STATE(4890), 1,
      aux_sym__literal_contents,
    STATE(5017), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [178107] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5018), 1,
      sym_heredoc_body,
    ACTIONS(6666), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178127] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7416), 1,
      aux_sym_string_array_token1,
    ACTIONS(7418), 1,
      sym__string_end,
    STATE(4918), 1,
      aux_sym__literal_contents,
    STATE(5019), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [178161] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7420), 1,
      aux_sym_string_array_token1,
    ACTIONS(7422), 1,
      sym__string_end,
    STATE(4891), 1,
      aux_sym__literal_contents,
    STATE(5020), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [178195] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5021), 1,
      sym_heredoc_body,
    ACTIONS(6690), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178215] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7424), 1,
      anon_sym_end,
    ACTIONS(7426), 1,
      anon_sym_rescue,
    ACTIONS(7428), 1,
      anon_sym_ensure,
    STATE(5022), 1,
      sym_heredoc_body,
    STATE(5029), 1,
      aux_sym__body_statement_repeat1,
    STATE(5492), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [178245] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7430), 1,
      aux_sym_string_array_token1,
    ACTIONS(7432), 1,
      sym__string_end,
    STATE(4928), 1,
      aux_sym__literal_contents,
    STATE(5023), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [178279] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7426), 1,
      anon_sym_rescue,
    ACTIONS(7428), 1,
      anon_sym_ensure,
    ACTIONS(7434), 1,
      anon_sym_end,
    STATE(5024), 1,
      sym_heredoc_body,
    STATE(5029), 1,
      aux_sym__body_statement_repeat1,
    STATE(5492), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [178309] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5025), 1,
      sym_heredoc_body,
    ACTIONS(6724), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178329] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_rescue,
    ACTIONS(6926), 1,
      anon_sym_if,
    ACTIONS(6928), 1,
      anon_sym_unless,
    ACTIONS(6930), 1,
      anon_sym_while,
    ACTIONS(6932), 1,
      anon_sym_until,
    STATE(2062), 1,
      sym__terminator,
    STATE(5026), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [178361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5027), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178381] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(7311), 1,
      anon_sym_in,
    STATE(5028), 1,
      sym_heredoc_body,
    STATE(5306), 1,
      sym_in,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3092), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178409] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7436), 1,
      anon_sym_end,
    ACTIONS(7438), 1,
      anon_sym_rescue,
    ACTIONS(7441), 1,
      anon_sym_else,
    ACTIONS(7444), 1,
      anon_sym_ensure,
    STATE(5029), 2,
      sym_heredoc_body,
      aux_sym__body_statement_repeat1,
    STATE(5492), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [178437] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5030), 1,
      sym_heredoc_body,
    ACTIONS(6702), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178457] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5031), 1,
      sym_heredoc_body,
    ACTIONS(4395), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178477] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5032), 1,
      sym_heredoc_body,
    ACTIONS(6654), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178497] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7426), 1,
      anon_sym_rescue,
    ACTIONS(7428), 1,
      anon_sym_ensure,
    ACTIONS(7434), 1,
      anon_sym_end,
    STATE(5022), 1,
      aux_sym__body_statement_repeat1,
    STATE(5033), 1,
      sym_heredoc_body,
    STATE(5492), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [178527] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(7311), 1,
      anon_sym_in,
    STATE(5034), 1,
      sym_heredoc_body,
    STATE(5313), 1,
      sym_in,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3092), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178555] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7179), 1,
      sym_escape_sequence,
    ACTIONS(7181), 1,
      sym_string_content,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7447), 1,
      aux_sym_string_array_token1,
    ACTIONS(7449), 1,
      sym__string_end,
    STATE(4930), 1,
      aux_sym__literal_contents,
    STATE(5035), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
  [178589] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5036), 1,
      sym_heredoc_body,
    ACTIONS(6627), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178609] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7451), 1,
      sym__string_start,
    STATE(5325), 1,
      sym_string,
    STATE(5037), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3258), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178632] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(3556), 1,
      sym__simple_numeric,
    STATE(5038), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [178659] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym__pow,
    STATE(3462), 1,
      sym__simple_numeric,
    STATE(5039), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [178686] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5040), 1,
      sym_heredoc_body,
    ACTIONS(7454), 7,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [178705] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7460), 1,
      sym__string_end,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    STATE(5041), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [178734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7464), 1,
      sym__string_end,
    STATE(5042), 1,
      sym_heredoc_body,
    STATE(5048), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [178763] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7466), 1,
      sym__string_end,
    STATE(5043), 1,
      sym_heredoc_body,
    STATE(5051), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [178792] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5044), 1,
      sym_heredoc_body,
    ACTIONS(123), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178811] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym__pow,
    STATE(3629), 1,
      sym__simple_numeric,
    STATE(5045), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [178838] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7468), 1,
      sym__string_end,
    STATE(5046), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [178867] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7470), 1,
      sym__string_end,
    STATE(5047), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [178896] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7472), 1,
      sym__string_end,
    STATE(5048), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [178925] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7474), 1,
      sym__string_end,
    STATE(5049), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [178954] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7476), 1,
      anon_sym_COMMA,
    STATE(5050), 1,
      sym_heredoc_body,
    STATE(5091), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178977] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7478), 1,
      sym__string_end,
    STATE(5051), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179006] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7480), 1,
      sym__string_end,
    STATE(5052), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179035] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7482), 1,
      sym__string_end,
    STATE(5053), 1,
      sym_heredoc_body,
    STATE(5129), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179064] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7484), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5054), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7486), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5055), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179122] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7488), 1,
      anon_sym_COMMA,
    STATE(5056), 1,
      sym_heredoc_body,
    STATE(5066), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [179145] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7490), 1,
      sym__string_end,
    STATE(5057), 1,
      sym_heredoc_body,
    STATE(5177), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179174] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(3494), 1,
      sym__simple_numeric,
    STATE(5058), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [179201] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7492), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5059), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179230] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym__pow,
    STATE(4003), 1,
      sym__simple_numeric,
    STATE(5060), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [179257] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym__pow,
    STATE(3942), 1,
      sym__simple_numeric,
    STATE(5061), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [179284] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7494), 1,
      sym__string_end,
    STATE(5062), 1,
      sym_heredoc_body,
    STATE(5169), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179313] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7496), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5063), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179342] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7498), 1,
      sym__string_end,
    STATE(5064), 1,
      sym_heredoc_body,
    STATE(5115), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179371] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_then,
    ACTIONS(7500), 1,
      anon_sym_COMMA,
    STATE(304), 1,
      sym__terminator,
    STATE(5065), 1,
      sym_heredoc_body,
    STATE(5291), 1,
      aux_sym_when_repeat1,
    STATE(5543), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [179400] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7488), 1,
      anon_sym_COMMA,
    STATE(5066), 1,
      sym_heredoc_body,
    STATE(5104), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [179423] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7502), 1,
      sym__string_end,
    STATE(5067), 1,
      sym_heredoc_body,
    STATE(5172), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179452] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym__pow,
    STATE(3945), 1,
      sym__simple_numeric,
    STATE(5068), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [179479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7504), 1,
      sym__string_end,
    STATE(5069), 1,
      sym_heredoc_body,
    STATE(5107), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179508] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym__pow,
    STATE(3869), 1,
      sym__simple_numeric,
    STATE(5070), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [179535] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5071), 1,
      sym_heredoc_body,
    ACTIONS(7506), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(3092), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179556] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7476), 1,
      anon_sym_COMMA,
    STATE(5050), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5072), 1,
      sym_heredoc_body,
    ACTIONS(6756), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [179579] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(2866), 1,
      sym__simple_numeric,
    STATE(5073), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [179606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7508), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5074), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179635] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7510), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7514), 1,
      sym_heredoc_end,
    ACTIONS(7516), 1,
      sym__short_interpolation,
    STATE(5075), 1,
      sym_heredoc_body,
    STATE(5154), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(5323), 1,
      sym_interpolation,
    ACTIONS(7512), 2,
      sym_heredoc_content,
      sym_escape_sequence,
  [179664] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7518), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5076), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179693] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7520), 1,
      sym__string_end,
    STATE(5077), 1,
      sym_heredoc_body,
    STATE(5147), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179722] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7522), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5078), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179751] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7524), 1,
      sym__string_end,
    STATE(5079), 1,
      sym_heredoc_body,
    STATE(5148), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179780] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7526), 1,
      sym__string_end,
    STATE(5080), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179809] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7528), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5081), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179838] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7530), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5082), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179867] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7532), 1,
      sym__string_end,
    STATE(5083), 1,
      sym_heredoc_body,
    STATE(5088), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [179896] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7534), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5084), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179925] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(2858), 1,
      sym__simple_numeric,
    STATE(5085), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [179952] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7536), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5086), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [179981] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5087), 1,
      sym_heredoc_body,
    ACTIONS(7538), 7,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [180000] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7540), 1,
      sym__string_end,
    STATE(5088), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180029] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7542), 1,
      sym__string_end,
    STATE(5089), 1,
      sym_heredoc_body,
    STATE(5209), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180058] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7544), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5090), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180087] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7546), 1,
      anon_sym_COMMA,
    STATE(5091), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [180108] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7549), 1,
      sym__string_end,
    STATE(5080), 1,
      aux_sym__literal_contents,
    STATE(5092), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180137] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7551), 1,
      sym__string_end,
    STATE(5052), 1,
      aux_sym__literal_contents,
    STATE(5093), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180166] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3360), 1,
      sym__simple_numeric,
    STATE(3384), 1,
      sym__pow,
    STATE(5094), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [180193] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7553), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5095), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180222] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7555), 1,
      sym__string_end,
    STATE(5096), 1,
      sym_heredoc_body,
    STATE(5149), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180251] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3182), 1,
      sym__simple_numeric,
    STATE(3384), 1,
      sym__pow,
    STATE(5097), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [180278] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7557), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5098), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180307] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym__pow,
    STATE(3465), 1,
      sym__simple_numeric,
    STATE(5099), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [180334] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7559), 1,
      sym__string_end,
    STATE(5100), 1,
      sym_heredoc_body,
    STATE(5176), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180363] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7561), 1,
      sym__string_end,
    STATE(5101), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180392] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3271), 1,
      sym__simple_numeric,
    STATE(5102), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [180419] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(2657), 1,
      sym__simple_numeric,
    STATE(5103), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [180446] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7563), 1,
      anon_sym_COMMA,
    STATE(5104), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [180467] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7566), 1,
      anon_sym_rescue,
    STATE(5105), 1,
      sym_heredoc_body,
    ACTIONS(6662), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [180488] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7566), 1,
      anon_sym_rescue,
    STATE(5106), 1,
      sym_heredoc_body,
    ACTIONS(6670), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [180509] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7568), 1,
      sym__string_end,
    STATE(5107), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180538] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_then,
    ACTIONS(7500), 1,
      anon_sym_COMMA,
    STATE(301), 1,
      sym__terminator,
    STATE(5065), 1,
      aux_sym_when_repeat1,
    STATE(5108), 1,
      sym_heredoc_body,
    STATE(5545), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [180567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7570), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5109), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180596] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5110), 1,
      sym_heredoc_body,
    ACTIONS(3048), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180615] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7572), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5111), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180644] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5112), 1,
      sym_heredoc_body,
    ACTIONS(3014), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180663] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5113), 1,
      sym_heredoc_body,
    ACTIONS(3074), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180682] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7574), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5114), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180711] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7576), 1,
      sym__string_end,
    STATE(5115), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [180740] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7578), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5116), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180769] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3285), 1,
      anon_sym_r,
    STATE(5117), 1,
      sym_heredoc_body,
    ACTIONS(3287), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3281), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180792] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5118), 1,
      sym_heredoc_body,
    ACTIONS(3022), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180811] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5119), 1,
      sym_heredoc_body,
    ACTIONS(3028), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180830] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5120), 1,
      sym_heredoc_body,
    ACTIONS(3032), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180849] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7580), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5121), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180878] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7582), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5122), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180907] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7584), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5123), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180936] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5124), 1,
      sym_heredoc_body,
    ACTIONS(3006), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180955] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7586), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5125), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [180984] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7588), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5126), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [181013] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5127), 1,
      sym_heredoc_body,
    ACTIONS(3036), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181032] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5128), 1,
      sym_heredoc_body,
    ACTIONS(3040), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181051] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7590), 1,
      sym__string_end,
    STATE(5129), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [181080] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3955), 1,
      sym__simple_numeric,
    STATE(5130), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [181107] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3352), 1,
      sym__simple_numeric,
    STATE(3384), 1,
      sym__pow,
    STATE(5131), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [181134] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5132), 1,
      sym_heredoc_body,
    ACTIONS(3044), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181153] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5133), 1,
      sym_heredoc_body,
    ACTIONS(3052), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181172] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(3763), 1,
      sym__simple_numeric,
    STATE(5134), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [181199] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5135), 1,
      sym_heredoc_body,
    ACTIONS(3058), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181218] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3341), 1,
      sym__simple_numeric,
    STATE(5136), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [181245] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5137), 1,
      sym_heredoc_body,
    ACTIONS(3062), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181264] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5138), 1,
      sym_heredoc_body,
    ACTIONS(3066), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181283] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(2654), 1,
      sym__simple_numeric,
    STATE(5139), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [181310] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5140), 1,
      sym_heredoc_body,
    ACTIONS(3070), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181329] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5141), 1,
      sym_heredoc_body,
    ACTIONS(3002), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181348] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5142), 1,
      sym_heredoc_body,
    ACTIONS(3018), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181367] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5143), 1,
      sym_heredoc_body,
    ACTIONS(2998), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181386] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7592), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5144), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [181415] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7594), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5145), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [181444] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3770), 1,
      sym__simple_numeric,
    STATE(5146), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [181471] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7596), 1,
      sym__string_end,
    STATE(5147), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [181500] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7598), 1,
      sym__string_end,
    STATE(5148), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [181529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7600), 1,
      sym__string_end,
    STATE(5149), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [181558] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5150), 1,
      sym_heredoc_body,
    ACTIONS(2964), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181577] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7602), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7608), 1,
      sym_heredoc_end,
    ACTIONS(7610), 1,
      sym__short_interpolation,
    STATE(5323), 1,
      sym_interpolation,
    ACTIONS(7605), 2,
      sym_heredoc_content,
      sym_escape_sequence,
    STATE(5151), 2,
      sym_heredoc_body,
      aux_sym_heredoc_body_repeat1,
  [181604] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(3675), 1,
      sym__simple_numeric,
    STATE(5152), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [181631] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(3600), 1,
      sym__simple_numeric,
    STATE(5153), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [181658] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7510), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7516), 1,
      sym__short_interpolation,
    ACTIONS(7613), 1,
      sym_heredoc_end,
    STATE(5151), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(5154), 1,
      sym_heredoc_body,
    STATE(5323), 1,
      sym_interpolation,
    ACTIONS(7512), 2,
      sym_heredoc_content,
      sym_escape_sequence,
  [181687] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_EQ_GT,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(285), 1,
      sym__terminator,
    STATE(5155), 1,
      sym_heredoc_body,
    STATE(5317), 1,
      sym_exception_variable,
    STATE(5424), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [181716] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7615), 1,
      sym__string_end,
    STATE(5156), 1,
      sym_heredoc_body,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [181745] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7357), 1,
      sym__string_end,
    ACTIONS(7617), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7623), 1,
      sym__short_interpolation,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7620), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(5157), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [181772] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3421), 1,
      sym__simple_numeric,
    STATE(5158), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [181799] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(3692), 1,
      sym__simple_numeric,
    STATE(5159), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [181826] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7626), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5160), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [181855] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7628), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5161), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [181884] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7630), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5162), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [181913] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2722), 1,
      sym__string_start,
    STATE(5037), 1,
      aux_sym_chained_string_repeat1,
    STATE(5163), 1,
      sym_heredoc_body,
    STATE(5325), 1,
      sym_string,
    ACTIONS(3244), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181938] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(3531), 1,
      sym__simple_numeric,
    STATE(5164), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [181965] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7632), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5165), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [181994] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7634), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5166), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [182023] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7636), 1,
      sym_identifier,
    ACTIONS(7640), 1,
      anon_sym_do,
    STATE(5167), 1,
      sym_heredoc_body,
    ACTIONS(7638), 5,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [182046] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7642), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5168), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [182075] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7644), 1,
      sym__string_end,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5169), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182104] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7646), 1,
      sym__string_end,
    STATE(5170), 1,
      sym_heredoc_body,
    STATE(5198), 1,
      aux_sym__literal_contents,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182133] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3823), 1,
      sym__simple_numeric,
    STATE(5171), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [182160] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7648), 1,
      sym__string_end,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5172), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182189] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7650), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5173), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [182218] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3700), 1,
      sym__simple_numeric,
    STATE(5174), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [182245] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7652), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5175), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [182274] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7654), 1,
      sym__string_end,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5176), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182303] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7656), 1,
      sym__string_end,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5177), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182332] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(3862), 1,
      sym__simple_numeric,
    STATE(5178), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182359] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7658), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5179), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [182388] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(3281), 1,
      sym__simple_numeric,
    STATE(5180), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182415] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7660), 1,
      sym__string_end,
    STATE(5156), 1,
      aux_sym__literal_contents,
    STATE(5181), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182444] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(2799), 1,
      sym__simple_numeric,
    STATE(5182), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182471] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7662), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5183), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [182500] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(2830), 1,
      sym__simple_numeric,
    STATE(5184), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182527] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3424), 1,
      sym__simple_numeric,
    STATE(5185), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [182554] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7664), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5186), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [182583] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(3138), 1,
      sym__simple_numeric,
    STATE(5187), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182610] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(3172), 1,
      sym__simple_numeric,
    STATE(5188), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182637] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3994), 1,
      sym__simple_numeric,
    STATE(5189), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [182664] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(2723), 1,
      sym__simple_numeric,
    STATE(5190), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182691] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(2722), 1,
      sym__simple_numeric,
    STATE(5191), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182718] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym__pow,
    STATE(3943), 1,
      sym__simple_numeric,
    STATE(5192), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [182745] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(2576), 1,
      sym__simple_numeric,
    STATE(5193), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182772] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(2607), 1,
      sym__simple_numeric,
    STATE(5194), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182799] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2496), 1,
      sym__simple_numeric,
    STATE(2541), 1,
      sym__pow,
    STATE(5195), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182826] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(2512), 1,
      sym__simple_numeric,
    STATE(5196), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182853] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(3074), 1,
      sym__simple_numeric,
    STATE(5197), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182880] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7666), 1,
      sym__string_end,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5198), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182909] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym__pow,
    STATE(3087), 1,
      sym__simple_numeric,
    STATE(5199), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [182936] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7668), 1,
      sym__string_end,
    STATE(5041), 1,
      aux_sym__literal_contents,
    STATE(5200), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182965] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7670), 1,
      sym__string_end,
    STATE(5046), 1,
      aux_sym__literal_contents,
    STATE(5201), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [182994] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7672), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5202), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [183023] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7674), 1,
      sym__string_end,
    STATE(5047), 1,
      aux_sym__literal_contents,
    STATE(5203), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [183052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7676), 1,
      sym__string_end,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5204), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [183081] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7678), 1,
      sym__string_end,
    STATE(5049), 1,
      aux_sym__literal_contents,
    STATE(5205), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [183110] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7680), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5206), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [183139] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    ACTIONS(7682), 1,
      sym__string_end,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5207), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [183168] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2541), 1,
      sym__pow,
    STATE(3336), 1,
      sym__simple_numeric,
    STATE(5208), 1,
      sym_heredoc_body,
    STATE(5501), 1,
      sym__int_or_float,
    ACTIONS(359), 2,
      sym_integer,
      sym_float,
    STATE(2411), 2,
      sym_complex,
      sym_rational,
  [183195] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7684), 1,
      sym__string_end,
    STATE(5157), 1,
      aux_sym__literal_contents,
    STATE(5209), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [183224] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7456), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7462), 1,
      sym__short_interpolation,
    ACTIONS(7686), 1,
      sym__string_end,
    STATE(5101), 1,
      aux_sym__literal_contents,
    STATE(5210), 1,
      sym_heredoc_body,
    STATE(5298), 1,
      sym_interpolation,
    ACTIONS(7458), 2,
      sym_string_content,
      sym_escape_sequence,
  [183253] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2722), 1,
      sym__string_start,
    STATE(5163), 1,
      aux_sym_chained_string_repeat1,
    STATE(5211), 1,
      sym_heredoc_body,
    STATE(5325), 1,
      sym_string,
    ACTIONS(3092), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183278] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5212), 1,
      sym_heredoc_body,
    ACTIONS(3010), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183297] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3384), 1,
      sym__pow,
    STATE(3833), 1,
      sym__simple_numeric,
    STATE(5213), 1,
      sym_heredoc_body,
    STATE(5523), 1,
      sym__int_or_float,
    ACTIONS(293), 2,
      sym_integer,
      sym_float,
    STATE(3102), 2,
      sym_complex,
      sym_rational,
  [183324] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7688), 1,
      anon_sym_end,
    STATE(5214), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5723), 1,
      sym_else,
  [183352] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5924), 1,
      anon_sym_COMMA,
    STATE(5215), 1,
      sym_heredoc_body,
    STATE(5277), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(7690), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [183374] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7692), 1,
      anon_sym_end,
    STATE(5216), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5657), 1,
      sym_else,
  [183402] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4734), 1,
      sym__simple_numeric,
    STATE(5217), 1,
      sym_heredoc_body,
    STATE(5509), 1,
      sym__int_or_float,
    ACTIONS(2942), 2,
      sym_integer,
      sym_float,
    STATE(4698), 2,
      sym_complex,
      sym_rational,
  [183426] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7694), 1,
      anon_sym_end,
    STATE(5218), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5661), 1,
      sym_else,
  [183454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5219), 1,
      sym_heredoc_body,
    ACTIONS(2636), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(2638), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [183474] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7696), 1,
      anon_sym_end,
    STATE(5218), 1,
      aux_sym_case_repeat1,
    STATE(5220), 1,
      sym_heredoc_body,
    STATE(5539), 1,
      sym_when,
    STATE(5739), 1,
      sym_else,
  [183502] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5221), 1,
      sym_heredoc_body,
    ACTIONS(7698), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [183520] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5222), 1,
      sym_heredoc_body,
    STATE(5402), 1,
      sym__simple_numeric,
    STATE(5575), 1,
      sym__int_or_float,
    ACTIONS(2704), 2,
      sym_integer,
      sym_float,
    STATE(5374), 2,
      sym_complex,
      sym_rational,
  [183544] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7700), 1,
      anon_sym_end,
    STATE(5223), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5729), 1,
      sym_else,
  [183572] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4392), 1,
      sym__simple_numeric,
    STATE(5224), 1,
      sym_heredoc_body,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2826), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
  [183596] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5924), 1,
      anon_sym_COMMA,
    STATE(5215), 1,
      aux_sym_exceptions_repeat1,
    STATE(5225), 1,
      sym_heredoc_body,
    ACTIONS(5926), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [183618] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7702), 1,
      sym_identifier,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    STATE(4829), 1,
      sym__nonlocal_variable,
    STATE(5226), 1,
      sym_heredoc_body,
    ACTIONS(7706), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [183642] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5227), 1,
      sym_heredoc_body,
    ACTIONS(7708), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [183660] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7696), 1,
      anon_sym_end,
    STATE(5228), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5739), 1,
      sym_else,
  [183688] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7710), 1,
      anon_sym_end,
    STATE(5229), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5936), 1,
      sym_else,
  [183716] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    STATE(5230), 1,
      sym_heredoc_body,
    STATE(5465), 1,
      sym_argument_list,
    ACTIONS(415), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5231), 1,
      sym_heredoc_body,
    ACTIONS(7712), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7714), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [183758] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7716), 1,
      anon_sym_end,
    STATE(5232), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5780), 1,
      sym_else,
  [183786] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    STATE(5233), 1,
      sym_heredoc_body,
    STATE(5473), 1,
      sym_argument_list,
    ACTIONS(419), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183808] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    STATE(5234), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym_argument_list,
    ACTIONS(423), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183830] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7718), 1,
      anon_sym_end,
    STATE(5235), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5911), 1,
      sym_else,
  [183858] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym_rescue,
    STATE(5236), 1,
      sym_heredoc_body,
    ACTIONS(6670), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [183878] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    STATE(5237), 1,
      sym_heredoc_body,
    STATE(5486), 1,
      sym_argument_list,
    ACTIONS(427), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183900] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7232), 1,
      anon_sym_end,
    STATE(5238), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5806), 1,
      sym_else,
  [183928] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7722), 1,
      anon_sym_COMMA,
    STATE(5239), 1,
      sym_heredoc_body,
    STATE(5241), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6756), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [183950] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7266), 1,
      anon_sym_end,
    STATE(5240), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5709), 1,
      sym_else,
  [183978] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7722), 1,
      anon_sym_COMMA,
    STATE(5241), 1,
      sym_heredoc_body,
    STATE(5285), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6764), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [184000] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7724), 1,
      anon_sym_end,
    STATE(5242), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5747), 1,
      sym_else,
  [184028] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5243), 1,
      sym_heredoc_body,
    ACTIONS(7726), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184046] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5244), 1,
      sym_heredoc_body,
    ACTIONS(3090), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184064] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5245), 1,
      sym_heredoc_body,
    ACTIONS(7728), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184082] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7730), 1,
      anon_sym_end,
    STATE(5246), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5930), 1,
      sym_else,
  [184110] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    STATE(4998), 1,
      aux_sym__literal_contents,
    STATE(5247), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [184136] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7732), 1,
      sym_identifier,
    ACTIONS(7734), 1,
      anon_sym_LPAREN,
    STATE(4439), 1,
      sym__nonlocal_variable,
    STATE(5248), 1,
      sym_heredoc_body,
    ACTIONS(3891), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [184160] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7736), 1,
      anon_sym_end,
    STATE(5249), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5755), 1,
      sym_else,
  [184188] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7738), 1,
      anon_sym_end,
    STATE(5250), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5979), 1,
      sym_else,
  [184216] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7740), 1,
      anon_sym_end,
    STATE(5251), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5924), 1,
      sym_else,
  [184244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5252), 1,
      sym_heredoc_body,
    ACTIONS(7742), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7744), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [184264] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7746), 1,
      anon_sym_end,
    STATE(5249), 1,
      aux_sym_case_repeat1,
    STATE(5253), 1,
      sym_heredoc_body,
    STATE(5539), 1,
      sym_when,
    STATE(5976), 1,
      sym_else,
  [184292] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7746), 1,
      anon_sym_end,
    STATE(5254), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5976), 1,
      sym_else,
  [184320] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7748), 1,
      anon_sym_end,
    STATE(5255), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5949), 1,
      sym_else,
  [184348] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7750), 1,
      anon_sym_end,
    STATE(5256), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5967), 1,
      sym_else,
  [184376] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym_rescue,
    STATE(5257), 1,
      sym_heredoc_body,
    ACTIONS(6662), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [184396] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7268), 1,
      anon_sym_end,
    STATE(5258), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5645), 1,
      sym_else,
  [184424] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5259), 1,
      sym_heredoc_body,
    ACTIONS(7752), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184442] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7754), 1,
      anon_sym_rescue,
    STATE(5260), 1,
      sym_heredoc_body,
    ACTIONS(6662), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [184462] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7754), 1,
      anon_sym_rescue,
    STATE(5261), 1,
      sym_heredoc_body,
    ACTIONS(6670), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [184482] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    STATE(5262), 1,
      sym_heredoc_body,
    STATE(5443), 1,
      sym_argument_list,
    ACTIONS(3319), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184504] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7175), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7185), 1,
      sym__short_interpolation,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5263), 1,
      sym_heredoc_body,
    STATE(5287), 1,
      sym_interpolation,
    ACTIONS(7181), 2,
      sym_string_content,
      sym_escape_sequence,
  [184530] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4392), 1,
      sym__simple_numeric,
    STATE(5264), 1,
      sym_heredoc_body,
    STATE(5540), 1,
      sym__int_or_float,
    ACTIONS(2930), 2,
      sym_integer,
      sym_float,
    STATE(4397), 2,
      sym_complex,
      sym_rational,
  [184554] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LPAREN2,
    STATE(5265), 1,
      sym_heredoc_body,
    STATE(5451), 1,
      sym_argument_list,
    ACTIONS(3307), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184576] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7756), 1,
      anon_sym_end,
    STATE(5266), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5786), 1,
      sym_else,
  [184604] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym_rescue,
    STATE(5267), 1,
      sym_heredoc_body,
    ACTIONS(6662), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [184624] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7760), 1,
      anon_sym_end,
    STATE(5268), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5988), 1,
      sym_else,
  [184652] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7168), 1,
      anon_sym_end,
    STATE(5269), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5837), 1,
      sym_else,
  [184680] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7193), 1,
      anon_sym_end,
    STATE(5270), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5724), 1,
      sym_else,
  [184708] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7758), 1,
      anon_sym_rescue,
    STATE(5271), 1,
      sym_heredoc_body,
    ACTIONS(6670), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [184728] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7732), 1,
      sym_identifier,
    ACTIONS(7734), 1,
      anon_sym_LPAREN,
    STATE(4439), 1,
      sym__nonlocal_variable,
    STATE(5272), 1,
      sym_heredoc_body,
    ACTIONS(4327), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [184752] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7762), 1,
      anon_sym_end,
    STATE(5273), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5751), 1,
      sym_else,
  [184780] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7764), 1,
      anon_sym_end,
    STATE(5274), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5752), 1,
      sym_else,
  [184808] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5275), 1,
      sym_heredoc_body,
    ACTIONS(3519), 6,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184826] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5276), 1,
      sym_heredoc_body,
    ACTIONS(3086), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [184844] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_COMMA,
    STATE(5277), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3661), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [184864] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7769), 1,
      anon_sym_end,
    STATE(5278), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5909), 1,
      sym_else,
  [184892] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7227), 1,
      anon_sym_end,
    STATE(5279), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5873), 1,
      sym_else,
  [184920] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7771), 1,
      anon_sym_end,
    STATE(5280), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5889), 1,
      sym_else,
  [184948] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7773), 1,
      anon_sym_end,
    STATE(5281), 1,
      sym_heredoc_body,
    STATE(5302), 1,
      aux_sym_case_repeat1,
    STATE(5539), 1,
      sym_when,
    STATE(5890), 1,
      sym_else,
  [184976] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6934), 1,
      anon_sym_in,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7775), 1,
      anon_sym_end,
    STATE(5282), 1,
      sym_heredoc_body,
    STATE(5303), 1,
      aux_sym_case_match_repeat1,
    STATE(5511), 1,
      sym_in_clause,
    STATE(5895), 1,
      sym_else,
  [185004] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5283), 1,
      sym_heredoc_body,
    ACTIONS(3575), 6,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185022] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5284), 1,
      sym_heredoc_body,
    ACTIONS(3080), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [185040] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_COMMA,
    STATE(5285), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6694), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [185060] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5286), 1,
      sym_heredoc_body,
    ACTIONS(7780), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [185078] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5287), 1,
      sym_heredoc_body,
    ACTIONS(7782), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7784), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [185098] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4734), 1,
      sym__simple_numeric,
    STATE(5288), 1,
      sym_heredoc_body,
    STATE(5509), 1,
      sym__int_or_float,
    ACTIONS(2876), 2,
      sym_integer,
      sym_float,
    STATE(4698), 2,
      sym_complex,
      sym_rational,
  [185122] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6936), 1,
      anon_sym_when,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7756), 1,
      anon_sym_end,
    STATE(5274), 1,
      aux_sym_case_repeat1,
    STATE(5289), 1,
      sym_heredoc_body,
    STATE(5539), 1,
      sym_when,
    STATE(5786), 1,
      sym_else,
  [185150] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5290), 1,
      sym_heredoc_body,
    ACTIONS(3311), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185167] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7786), 1,
      anon_sym_COMMA,
    STATE(5291), 2,
      sym_heredoc_body,
      aux_sym_when_repeat1,
    ACTIONS(7789), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [185186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7791), 1,
      anon_sym_COMMA,
    STATE(5292), 2,
      sym_heredoc_body,
      aux_sym__mlhs_repeat1,
    ACTIONS(7344), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [185205] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7794), 1,
      anon_sym_end,
    ACTIONS(7796), 1,
      anon_sym_elsif,
    STATE(5293), 1,
      sym_heredoc_body,
    STATE(5971), 2,
      sym_elsif,
      sym_else,
  [185228] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(294), 1,
      sym__terminator,
    STATE(5294), 1,
      sym_heredoc_body,
    STATE(5552), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185251] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7796), 1,
      anon_sym_elsif,
    ACTIONS(7798), 1,
      anon_sym_end,
    STATE(5295), 1,
      sym_heredoc_body,
    STATE(5705), 2,
      sym_elsif,
      sym_else,
  [185274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7742), 1,
      anon_sym_POUND_LBRACE,
    STATE(5296), 1,
      sym_heredoc_body,
    ACTIONS(7744), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7800), 1,
      anon_sym_EQ,
    ACTIONS(7802), 1,
      anon_sym_COLON,
    STATE(5297), 1,
      sym_heredoc_body,
    ACTIONS(7708), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
  [185314] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7782), 1,
      anon_sym_POUND_LBRACE,
    STATE(5298), 1,
      sym_heredoc_body,
    ACTIONS(7784), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185333] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5299), 1,
      sym_heredoc_body,
    ACTIONS(7806), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7804), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [185352] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7156), 1,
      anon_sym_do,
    STATE(352), 1,
      sym__terminator,
    STATE(2359), 1,
      sym_do,
    STATE(5300), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185375] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7796), 1,
      anon_sym_elsif,
    ACTIONS(7808), 1,
      anon_sym_end,
    STATE(5301), 1,
      sym_heredoc_body,
    STATE(5671), 2,
      sym_elsif,
      sym_else,
  [185398] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7812), 1,
      anon_sym_when,
    STATE(5539), 1,
      sym_when,
    ACTIONS(7810), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(5302), 2,
      sym_heredoc_body,
      aux_sym_case_repeat1,
  [185419] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7817), 1,
      anon_sym_in,
    STATE(5511), 1,
      sym_in_clause,
    ACTIONS(7815), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(5303), 2,
      sym_heredoc_body,
      aux_sym_case_match_repeat1,
  [185440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7820), 1,
      anon_sym_EQ,
    ACTIONS(7822), 1,
      anon_sym_COLON,
    STATE(5304), 1,
      sym_heredoc_body,
    ACTIONS(7708), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7712), 1,
      anon_sym_POUND_LBRACE,
    STATE(5305), 1,
      sym_heredoc_body,
    ACTIONS(7714), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185480] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7154), 1,
      anon_sym_do,
    STATE(335), 1,
      sym__terminator,
    STATE(5306), 1,
      sym_heredoc_body,
    STATE(5343), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185503] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7824), 1,
      anon_sym_EQ,
    ACTIONS(7826), 1,
      anon_sym_COLON,
    STATE(5307), 1,
      sym_heredoc_body,
    ACTIONS(7708), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [185524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7712), 1,
      anon_sym_POUND_LBRACE,
    STATE(5308), 1,
      sym_heredoc_body,
    ACTIONS(7714), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185543] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7796), 1,
      anon_sym_elsif,
    ACTIONS(7828), 1,
      anon_sym_end,
    STATE(5309), 1,
      sym_heredoc_body,
    STATE(5793), 2,
      sym_elsif,
      sym_else,
  [185566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2636), 1,
      anon_sym_POUND_LBRACE,
    STATE(5310), 1,
      sym_heredoc_body,
    ACTIONS(2638), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2636), 1,
      anon_sym_POUND_LBRACE,
    STATE(5311), 1,
      sym_heredoc_body,
    ACTIONS(2638), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185604] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5312), 1,
      sym_heredoc_body,
    ACTIONS(3661), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [185621] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_do,
    STATE(337), 1,
      sym__terminator,
    STATE(2911), 1,
      sym_do,
    STATE(5313), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    STATE(5314), 1,
      sym_heredoc_body,
    STATE(5321), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(7830), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [185665] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7796), 1,
      anon_sym_elsif,
    ACTIONS(7832), 1,
      anon_sym_end,
    STATE(5315), 1,
      sym_heredoc_body,
    STATE(5876), 2,
      sym_elsif,
      sym_else,
  [185688] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7796), 1,
      anon_sym_elsif,
    ACTIONS(7834), 1,
      anon_sym_end,
    STATE(5316), 1,
      sym_heredoc_body,
    STATE(5675), 2,
      sym_elsif,
      sym_else,
  [185711] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(277), 1,
      sym__terminator,
    STATE(5317), 1,
      sym_heredoc_body,
    STATE(5474), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185734] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6938), 1,
      anon_sym_else,
    ACTIONS(7796), 1,
      anon_sym_elsif,
    ACTIONS(7836), 1,
      anon_sym_end,
    STATE(5318), 1,
      sym_heredoc_body,
    STATE(5800), 2,
      sym_elsif,
      sym_else,
  [185757] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5319), 1,
      sym_heredoc_body,
    ACTIONS(3303), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185774] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5320), 1,
      sym_heredoc_body,
    ACTIONS(7806), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7838), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [185793] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7840), 1,
      anon_sym_COMMA,
    STATE(5292), 1,
      aux_sym__mlhs_repeat1,
    STATE(5321), 1,
      sym_heredoc_body,
    ACTIONS(2766), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [185814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7742), 1,
      anon_sym_POUND_LBRACE,
    STATE(5322), 1,
      sym_heredoc_body,
    ACTIONS(7744), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7842), 1,
      anon_sym_POUND_LBRACE,
    STATE(5323), 1,
      sym_heredoc_body,
    ACTIONS(7844), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [185852] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5324), 1,
      sym_heredoc_body,
    ACTIONS(7846), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6706), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [185871] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5325), 1,
      sym_heredoc_body,
    ACTIONS(3333), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185888] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_then,
    STATE(278), 1,
      sym__terminator,
    STATE(5326), 1,
      sym_heredoc_body,
    STATE(5426), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185911] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5327), 1,
      sym_heredoc_body,
    ACTIONS(3705), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185927] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5328), 1,
      sym_heredoc_body,
    ACTIONS(3829), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185943] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5329), 1,
      sym_heredoc_body,
    ACTIONS(3833), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185959] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5330), 1,
      sym_heredoc_body,
    ACTIONS(3627), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185975] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5331), 1,
      sym_heredoc_body,
    ACTIONS(3837), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185991] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5332), 1,
      sym_heredoc_body,
    ACTIONS(3627), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186007] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5333), 1,
      sym_heredoc_body,
    ACTIONS(3841), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186023] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7848), 1,
      anon_sym_rescue,
    STATE(5334), 1,
      sym_heredoc_body,
    ACTIONS(6670), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [186041] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5335), 1,
      sym_heredoc_body,
    ACTIONS(3805), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186057] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5336), 1,
      sym_heredoc_body,
    ACTIONS(3817), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186073] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5337), 1,
      sym_heredoc_body,
    ACTIONS(3619), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186089] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5338), 1,
      sym_heredoc_body,
    ACTIONS(3381), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186105] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5339), 1,
      sym_heredoc_body,
    ACTIONS(3623), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186121] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5340), 1,
      sym_heredoc_body,
    ACTIONS(3389), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186137] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5341), 1,
      sym_heredoc_body,
    ACTIONS(3531), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186153] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5342), 1,
      sym_heredoc_body,
    ACTIONS(3639), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186169] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5343), 1,
      sym_heredoc_body,
    ACTIONS(3643), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186185] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_LBRACE,
    ACTIONS(7850), 1,
      anon_sym_do,
    STATE(5344), 1,
      sym_heredoc_body,
    STATE(4722), 2,
      sym_do_block,
      sym_block,
  [186205] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5345), 1,
      sym_heredoc_body,
    ACTIONS(3457), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186221] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5346), 1,
      sym_heredoc_body,
    ACTIONS(3539), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186237] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5347), 1,
      sym_heredoc_body,
    ACTIONS(6098), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [186253] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5348), 1,
      sym_heredoc_body,
    ACTIONS(7852), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [186269] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5349), 1,
      sym_heredoc_body,
    ACTIONS(3341), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186285] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5350), 1,
      sym_heredoc_body,
    ACTIONS(3555), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186301] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5351), 1,
      sym_heredoc_body,
    ACTIONS(3863), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186317] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5352), 1,
      sym_heredoc_body,
    ACTIONS(3709), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186333] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5353), 1,
      sym_heredoc_body,
    ACTIONS(3713), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186349] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5354), 1,
      sym_heredoc_body,
    ACTIONS(3765), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186365] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5355), 1,
      sym_heredoc_body,
    ACTIONS(3821), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186381] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5356), 1,
      sym_heredoc_body,
    ACTIONS(3345), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186397] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5357), 1,
      sym_heredoc_body,
    ACTIONS(3425), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186413] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5358), 1,
      sym_heredoc_body,
    ACTIONS(3595), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186429] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5359), 1,
      sym_heredoc_body,
    ACTIONS(3599), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186445] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5360), 1,
      sym_heredoc_body,
    ACTIONS(3669), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186461] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5361), 1,
      sym_heredoc_body,
    ACTIONS(3677), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186477] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5362), 1,
      sym_heredoc_body,
    ACTIONS(3689), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186493] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5363), 1,
      sym_heredoc_body,
    ACTIONS(3717), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186509] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5364), 1,
      sym_heredoc_body,
    ACTIONS(3797), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186525] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5365), 1,
      sym_heredoc_body,
    ACTIONS(3801), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186541] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5366), 1,
      sym_heredoc_body,
    ACTIONS(3405), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186557] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5367), 1,
      sym_heredoc_body,
    ACTIONS(3681), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186573] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5368), 1,
      sym_heredoc_body,
    ACTIONS(3745), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186589] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5369), 1,
      sym_heredoc_body,
    ACTIONS(3551), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186605] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5370), 1,
      sym_heredoc_body,
    ACTIONS(3563), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186621] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5371), 1,
      sym_heredoc_body,
    ACTIONS(3547), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186637] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5372), 1,
      sym_heredoc_body,
    ACTIONS(3789), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186653] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5373), 1,
      sym_heredoc_body,
    ACTIONS(3721), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186669] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5374), 1,
      sym_heredoc_body,
    ACTIONS(3281), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186685] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5375), 1,
      sym_heredoc_body,
    ACTIONS(3741), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186701] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5376), 1,
      sym_heredoc_body,
    ACTIONS(3405), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186717] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7854), 1,
      anon_sym_COMMA,
    ACTIONS(7752), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    STATE(5377), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [186735] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5378), 1,
      sym_heredoc_body,
    ACTIONS(3757), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186751] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5379), 1,
      sym_heredoc_body,
    ACTIONS(3733), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186767] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5380), 1,
      sym_heredoc_body,
    ACTIONS(3853), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186783] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5381), 1,
      sym_heredoc_body,
    ACTIONS(3441), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186799] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    ACTIONS(7304), 1,
      anon_sym_COMMA,
    STATE(5382), 1,
      sym_heredoc_body,
    ACTIONS(7857), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [186819] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5383), 1,
      sym_heredoc_body,
    ACTIONS(3813), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186835] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5384), 1,
      sym_heredoc_body,
    ACTIONS(3761), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186851] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5385), 1,
      sym_heredoc_body,
    ACTIONS(3469), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186867] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6885), 1,
      anon_sym_PIPE,
    ACTIONS(6887), 1,
      anon_sym_SEMI,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    STATE(5386), 1,
      sym_heredoc_body,
    STATE(5445), 1,
      aux_sym_parameters_repeat1,
  [186889] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5387), 1,
      sym_heredoc_body,
    ACTIONS(3491), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186905] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5388), 1,
      sym_heredoc_body,
    ACTIONS(3495), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186921] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5389), 1,
      sym_heredoc_body,
    ACTIONS(3515), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186937] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7848), 1,
      anon_sym_rescue,
    STATE(5390), 1,
      sym_heredoc_body,
    ACTIONS(6662), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [186955] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5391), 1,
      sym_heredoc_body,
    ACTIONS(3825), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186971] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5392), 1,
      sym_heredoc_body,
    ACTIONS(3825), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186987] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7861), 1,
      sym_identifier,
    STATE(5393), 1,
      sym_heredoc_body,
    ACTIONS(7638), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187005] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6511), 1,
      anon_sym_LBRACE,
    ACTIONS(6513), 1,
      anon_sym_do,
    STATE(5394), 1,
      sym_heredoc_body,
    STATE(4382), 2,
      sym_do_block,
      sym_block,
  [187025] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACE,
    ACTIONS(2954), 1,
      anon_sym_do,
    STATE(5395), 1,
      sym_heredoc_body,
    STATE(2369), 2,
      sym_do_block,
      sym_block,
  [187045] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5396), 1,
      sym_heredoc_body,
    ACTIONS(3453), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187061] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6815), 1,
      anon_sym_LBRACE,
    ACTIONS(7018), 1,
      anon_sym_do,
    STATE(5397), 1,
      sym_heredoc_body,
    STATE(5367), 2,
      sym_do_block,
      sym_block,
  [187081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5398), 1,
      sym_heredoc_body,
    ACTIONS(7863), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [187097] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5399), 1,
      sym_heredoc_body,
    ACTIONS(2962), 4,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_else,
  [187113] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5400), 1,
      sym_heredoc_body,
    ACTIONS(3845), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187129] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5401), 1,
      sym_heredoc_body,
    ACTIONS(3559), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187145] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5402), 1,
      sym_heredoc_body,
    ACTIONS(3773), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187161] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_LBRACE,
    ACTIONS(7865), 1,
      anon_sym_do,
    STATE(5403), 1,
      sym_heredoc_body,
    STATE(4382), 2,
      sym_do_block,
      sym_block,
  [187181] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5404), 1,
      sym_heredoc_body,
    ACTIONS(3777), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187197] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5308), 1,
      sym__nonlocal_variable,
    STATE(5405), 1,
      sym_heredoc_body,
    ACTIONS(7867), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [187215] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5406), 1,
      sym_heredoc_body,
    ACTIONS(3535), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187231] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_COMMA,
    STATE(5407), 1,
      sym_heredoc_body,
    STATE(5420), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(2370), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [187251] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7873), 1,
      anon_sym_COMMA,
    STATE(5408), 1,
      sym_heredoc_body,
    STATE(5490), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(7871), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [187271] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5409), 1,
      sym_heredoc_body,
    ACTIONS(7875), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [187287] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7877), 1,
      anon_sym_COMMA,
    STATE(5410), 1,
      sym_heredoc_body,
    STATE(5430), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(7879), 2,
      sym__line_break,
      anon_sym_SEMI,
  [187307] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5411), 1,
      sym_heredoc_body,
    ACTIONS(3647), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187323] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5412), 1,
      sym_heredoc_body,
    ACTIONS(7881), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [187339] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5413), 1,
      sym_heredoc_body,
    ACTIONS(3583), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187355] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(7887), 1,
      sym__element_reference_bracket,
    STATE(5414), 1,
      sym_heredoc_body,
    ACTIONS(7883), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [187375] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym_COMMA,
    ACTIONS(7891), 1,
      anon_sym_PIPE,
    ACTIONS(7893), 1,
      anon_sym_SEMI,
    STATE(5415), 1,
      sym_heredoc_body,
    STATE(5416), 1,
      aux_sym_parameters_repeat1,
  [187397] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6912), 1,
      anon_sym_PIPE,
    ACTIONS(6914), 1,
      anon_sym_SEMI,
    ACTIONS(7895), 1,
      anon_sym_COMMA,
    STATE(5416), 1,
      sym_heredoc_body,
    STATE(5445), 1,
      aux_sym_parameters_repeat1,
  [187419] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5417), 1,
      sym_heredoc_body,
    ACTIONS(3737), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187435] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5418), 1,
      sym_heredoc_body,
    ACTIONS(3349), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187451] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5419), 1,
      sym_heredoc_body,
    ACTIONS(3349), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187467] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7897), 1,
      anon_sym_COMMA,
    ACTIONS(6694), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(5420), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
  [187485] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5421), 1,
      sym_heredoc_body,
    ACTIONS(3417), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187501] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7902), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(7904), 1,
      sym__element_reference_bracket,
    STATE(5422), 1,
      sym_heredoc_body,
    ACTIONS(7900), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [187521] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5423), 1,
      sym_heredoc_body,
    ACTIONS(3665), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187537] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5424), 1,
      sym_heredoc_body,
    ACTIONS(7906), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [187553] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5425), 1,
      sym_heredoc_body,
    ACTIONS(3357), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187569] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5426), 1,
      sym_heredoc_body,
    ACTIONS(7908), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [187585] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5427), 1,
      sym_heredoc_body,
    ACTIONS(3421), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187601] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5428), 1,
      sym_heredoc_body,
    ACTIONS(3437), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187617] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5429), 1,
      sym_heredoc_body,
    ACTIONS(3697), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187633] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7910), 1,
      anon_sym_COMMA,
    ACTIONS(7752), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5430), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [187651] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5431), 1,
      sym_heredoc_body,
    ACTIONS(3461), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187667] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5432), 1,
      sym_heredoc_body,
    ACTIONS(3353), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187683] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5433), 1,
      sym_heredoc_body,
    ACTIONS(3357), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187699] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5434), 1,
      sym_heredoc_body,
    ACTIONS(3377), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187715] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5435), 1,
      sym_heredoc_body,
    ACTIONS(3373), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187731] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5436), 1,
      sym_heredoc_body,
    ACTIONS(3465), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187747] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5437), 1,
      sym_heredoc_body,
    ACTIONS(3477), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187763] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7877), 1,
      anon_sym_COMMA,
    STATE(5410), 1,
      aux_sym_parameters_repeat1,
    STATE(5438), 1,
      sym_heredoc_body,
    ACTIONS(7871), 2,
      sym__line_break,
      anon_sym_SEMI,
  [187783] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5439), 1,
      sym_heredoc_body,
    ACTIONS(3543), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187799] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5440), 1,
      sym_heredoc_body,
    ACTIONS(3369), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187815] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5441), 1,
      sym_heredoc_body,
    ACTIONS(3397), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187831] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5442), 1,
      sym_heredoc_body,
    ACTIONS(3401), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187847] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5443), 1,
      sym_heredoc_body,
    ACTIONS(3615), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187863] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5444), 1,
      sym_heredoc_body,
    ACTIONS(3749), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187879] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7913), 1,
      anon_sym_COMMA,
    ACTIONS(7752), 2,
      anon_sym_PIPE,
      anon_sym_SEMI,
    STATE(5445), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [187897] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5446), 1,
      sym_heredoc_body,
    ACTIONS(7916), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [187913] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5447), 1,
      sym_heredoc_body,
    ACTIONS(3607), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187929] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7918), 1,
      anon_sym_COMMA,
    ACTIONS(7920), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_SEMI,
    STATE(5386), 1,
      aux_sym_parameters_repeat1,
    STATE(5448), 1,
      sym_heredoc_body,
  [187951] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5305), 1,
      sym__nonlocal_variable,
    STATE(5449), 1,
      sym_heredoc_body,
    ACTIONS(7924), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [187969] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5450), 1,
      sym_heredoc_body,
    ACTIONS(3361), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [187985] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5451), 1,
      sym_heredoc_body,
    ACTIONS(3483), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188001] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5452), 1,
      sym_heredoc_body,
    ACTIONS(3479), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188017] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5453), 1,
      sym_heredoc_body,
    ACTIONS(3487), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188033] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5454), 1,
      sym_heredoc_body,
    ACTIONS(3503), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188049] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5455), 1,
      sym_heredoc_body,
    ACTIONS(3507), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188065] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5456), 1,
      sym_heredoc_body,
    ACTIONS(3523), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188081] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5457), 1,
      sym_heredoc_body,
    ACTIONS(3499), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188097] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5458), 1,
      sym_heredoc_body,
    ACTIONS(3527), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188113] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5459), 1,
      sym_heredoc_body,
    ACTIONS(3567), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188129] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5460), 1,
      sym_heredoc_body,
    ACTIONS(3571), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188145] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7926), 1,
      anon_sym_rescue,
    STATE(5461), 1,
      sym_heredoc_body,
    ACTIONS(6662), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [188163] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7926), 1,
      anon_sym_rescue,
    STATE(5462), 1,
      sym_heredoc_body,
    ACTIONS(6670), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [188181] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5463), 1,
      sym_heredoc_body,
    ACTIONS(7806), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7928), 2,
      sym__line_break,
      anon_sym_SEMI,
  [188199] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5464), 1,
      sym_heredoc_body,
    ACTIONS(7930), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [188215] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5465), 1,
      sym_heredoc_body,
    ACTIONS(3857), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188231] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5466), 1,
      sym_heredoc_body,
    ACTIONS(3793), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188247] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5467), 1,
      sym_heredoc_body,
    ACTIONS(3511), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188263] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym_LBRACE,
    ACTIONS(7158), 1,
      anon_sym_do,
    STATE(5468), 1,
      sym_heredoc_body,
    STATE(4722), 2,
      sym_do_block,
      sym_block,
  [188283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5469), 1,
      sym_heredoc_body,
    ACTIONS(7344), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [188299] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5470), 1,
      sym_heredoc_body,
    ACTIONS(3685), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188315] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5471), 1,
      sym_heredoc_body,
    ACTIONS(3849), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188331] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5472), 1,
      sym_heredoc_body,
    ACTIONS(3449), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188347] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5473), 1,
      sym_heredoc_body,
    ACTIONS(3653), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188363] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5474), 1,
      sym_heredoc_body,
    ACTIONS(7932), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [188379] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5475), 1,
      sym_heredoc_body,
    ACTIONS(3587), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188395] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5476), 1,
      sym_heredoc_body,
    ACTIONS(3657), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188411] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5477), 1,
      sym_heredoc_body,
    ACTIONS(3673), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188427] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5478), 1,
      sym_heredoc_body,
    ACTIONS(3611), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188443] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5479), 1,
      sym_heredoc_body,
    ACTIONS(3693), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188459] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5480), 1,
      sym_heredoc_body,
    ACTIONS(3385), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188475] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_do,
    STATE(5481), 1,
      sym_heredoc_body,
    STATE(3092), 2,
      sym_do_block,
      sym_block,
  [188495] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5482), 1,
      sym_heredoc_body,
    ACTIONS(3701), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188511] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5483), 1,
      sym_heredoc_body,
    ACTIONS(3725), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188527] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7887), 1,
      sym__element_reference_bracket,
    ACTIONS(7934), 1,
      anon_sym_COLON_COLON2,
    STATE(5484), 1,
      sym_heredoc_body,
    ACTIONS(7883), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [188547] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7938), 1,
      anon_sym_COMMA,
    STATE(5407), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5485), 1,
      sym_heredoc_body,
    ACTIONS(7936), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [188567] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5486), 1,
      sym_heredoc_body,
    ACTIONS(3591), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188583] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5487), 1,
      sym_heredoc_body,
    ACTIONS(3729), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188599] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5488), 1,
      sym_heredoc_body,
    ACTIONS(3413), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188615] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5489), 1,
      sym_heredoc_body,
    ACTIONS(3092), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188631] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7873), 1,
      anon_sym_COMMA,
    STATE(5377), 1,
      aux_sym_parameters_repeat1,
    STATE(5490), 1,
      sym_heredoc_body,
    ACTIONS(7879), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [188651] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5491), 1,
      sym_heredoc_body,
    ACTIONS(3769), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [188667] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5492), 1,
      sym_heredoc_body,
    ACTIONS(7940), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [188683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7942), 1,
      anon_sym_EQ,
    ACTIONS(7944), 1,
      anon_sym_COLON,
    STATE(5493), 1,
      sym_heredoc_body,
    ACTIONS(7708), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [188703] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5231), 1,
      sym__nonlocal_variable,
    STATE(5494), 1,
      sym_heredoc_body,
    ACTIONS(7946), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [188721] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5495), 1,
      sym_heredoc_body,
    ACTIONS(3080), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188736] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7634), 1,
      sym__string_end,
    ACTIONS(7948), 1,
      aux_sym_string_array_token1,
    STATE(5496), 1,
      sym_heredoc_body,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
  [188755] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7950), 1,
      anon_sym_RBRACE,
    ACTIONS(7952), 1,
      anon_sym_COMMA,
    STATE(5497), 1,
      sym_heredoc_body,
    STATE(5576), 1,
      aux_sym_hash_repeat1,
  [188774] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7954), 1,
      anon_sym_RPAREN,
    ACTIONS(7956), 1,
      anon_sym_COMMA,
    STATE(5498), 1,
      sym_heredoc_body,
    STATE(5551), 1,
      aux_sym_parameters_repeat1,
  [188793] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5499), 1,
      sym_heredoc_body,
    ACTIONS(7752), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188808] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5500), 1,
      sym_heredoc_body,
    ACTIONS(7958), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [188823] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7960), 1,
      anon_sym_i,
    ACTIONS(7962), 1,
      anon_sym_ri,
    ACTIONS(7964), 1,
      anon_sym_r,
    STATE(5501), 1,
      sym_heredoc_body,
  [188842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7518), 1,
      sym__string_end,
    ACTIONS(7966), 1,
      aux_sym_string_array_token1,
    STATE(5502), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [188861] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(233), 1,
      sym__terminator,
    STATE(5503), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [188878] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7752), 1,
      anon_sym_RPAREN,
    ACTIONS(7968), 1,
      anon_sym_COMMA,
    STATE(5504), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [188895] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5505), 1,
      sym_heredoc_body,
    ACTIONS(3090), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7971), 1,
      aux_sym_string_array_token1,
    ACTIONS(7974), 1,
      sym__string_end,
    STATE(5506), 2,
      sym_heredoc_body,
      aux_sym_symbol_array_repeat1,
  [188927] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(237), 1,
      sym__terminator,
    STATE(5507), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [188944] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(7978), 1,
      anon_sym_PIPE,
    STATE(5508), 1,
      sym_heredoc_body,
    STATE(5518), 1,
      aux_sym_block_parameters_repeat1,
  [188963] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7980), 1,
      anon_sym_i,
    ACTIONS(7982), 1,
      anon_sym_ri,
    ACTIONS(7984), 1,
      anon_sym_r,
    STATE(5509), 1,
      sym_heredoc_body,
  [188982] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(7986), 1,
      anon_sym_PIPE,
    STATE(5510), 1,
      sym_heredoc_body,
    STATE(5512), 1,
      aux_sym_block_parameters_repeat1,
  [189001] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5511), 1,
      sym_heredoc_body,
    ACTIONS(7988), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [189016] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7990), 1,
      anon_sym_COMMA,
    ACTIONS(7993), 1,
      anon_sym_PIPE,
    STATE(5512), 2,
      sym_heredoc_body,
      aux_sym_block_parameters_repeat1,
  [189033] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    STATE(5513), 1,
      sym_heredoc_body,
    STATE(5530), 1,
      aux_sym_block_parameters_repeat1,
  [189052] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7522), 1,
      sym__string_end,
    ACTIONS(7997), 1,
      aux_sym_string_array_token1,
    STATE(5514), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [189071] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(7999), 1,
      anon_sym_PIPE,
    STATE(5512), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5515), 1,
      sym_heredoc_body,
  [189090] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(218), 1,
      sym__terminator,
    STATE(5516), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [189107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7586), 1,
      sym__string_end,
    ACTIONS(8001), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5517), 1,
      sym_heredoc_body,
  [189126] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8003), 1,
      anon_sym_PIPE,
    STATE(5512), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5518), 1,
      sym_heredoc_body,
  [189145] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8005), 1,
      anon_sym_PIPE,
    STATE(5519), 1,
      sym_heredoc_body,
    STATE(5524), 1,
      aux_sym_block_parameters_repeat1,
  [189164] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5520), 1,
      sym_heredoc_body,
    ACTIONS(7698), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189179] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5521), 1,
      sym_heredoc_body,
    ACTIONS(3086), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7570), 1,
      sym__string_end,
    ACTIONS(8007), 1,
      aux_sym_string_array_token1,
    STATE(5522), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [189213] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8009), 1,
      anon_sym_i,
    ACTIONS(8011), 1,
      anon_sym_ri,
    ACTIONS(8013), 1,
      anon_sym_r,
    STATE(5523), 1,
      sym_heredoc_body,
  [189232] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8015), 1,
      anon_sym_PIPE,
    STATE(5512), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5524), 1,
      sym_heredoc_body,
  [189251] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8017), 1,
      anon_sym_PIPE,
    STATE(5525), 1,
      sym_heredoc_body,
    STATE(5528), 1,
      aux_sym_block_parameters_repeat1,
  [189270] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8019), 1,
      anon_sym_PIPE,
    STATE(5526), 1,
      sym_heredoc_body,
    STATE(5573), 1,
      aux_sym_block_parameters_repeat1,
  [189289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7492), 1,
      sym__string_end,
    ACTIONS(8021), 1,
      aux_sym_string_array_token1,
    STATE(5527), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [189308] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8023), 1,
      anon_sym_PIPE,
    STATE(5512), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5528), 1,
      sym_heredoc_body,
  [189327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7536), 1,
      sym__string_end,
    ACTIONS(8025), 1,
      aux_sym_string_array_token1,
    STATE(5529), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [189346] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    STATE(5512), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5530), 1,
      sym_heredoc_body,
  [189365] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8029), 1,
      anon_sym_PIPE,
    STATE(5531), 1,
      sym_heredoc_body,
    STATE(5536), 1,
      aux_sym_block_parameters_repeat1,
  [189384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7496), 1,
      sym__string_end,
    ACTIONS(8031), 1,
      aux_sym_string_array_token1,
    STATE(5532), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [189403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7574), 1,
      sym__string_end,
    ACTIONS(8033), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5533), 1,
      sym_heredoc_body,
  [189422] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8035), 1,
      ts_builtin_sym_end,
    ACTIONS(8037), 1,
      aux_sym_program_token1,
    ACTIONS(8039), 1,
      anon_sym___END__,
    STATE(5534), 1,
      sym_heredoc_body,
  [189441] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7534), 1,
      sym__string_end,
    ACTIONS(8041), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5535), 1,
      sym_heredoc_body,
  [189460] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8043), 1,
      anon_sym_PIPE,
    STATE(5512), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5536), 1,
      sym_heredoc_body,
  [189479] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7530), 1,
      sym__string_end,
    ACTIONS(8045), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5537), 1,
      sym_heredoc_body,
  [189498] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7664), 1,
      sym__string_end,
    ACTIONS(8047), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5538), 1,
      sym_heredoc_body,
  [189517] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5539), 1,
      sym_heredoc_body,
    ACTIONS(8049), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [189532] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8051), 1,
      anon_sym_i,
    ACTIONS(8053), 1,
      anon_sym_ri,
    ACTIONS(8055), 1,
      anon_sym_r,
    STATE(5540), 1,
      sym_heredoc_body,
  [189551] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_RBRACE,
    ACTIONS(8057), 1,
      anon_sym_COMMA,
    STATE(5541), 1,
      sym_heredoc_body,
    STATE(5569), 1,
      aux_sym_hash_repeat1,
  [189570] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8059), 1,
      anon_sym_PIPE,
    STATE(5515), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5542), 1,
      sym_heredoc_body,
  [189589] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5543), 1,
      sym_heredoc_body,
    ACTIONS(8061), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [189604] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7584), 1,
      sym__string_end,
    ACTIONS(8063), 1,
      aux_sym_string_array_token1,
    STATE(5544), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [189623] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5545), 1,
      sym_heredoc_body,
    ACTIONS(8065), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [189638] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7956), 1,
      anon_sym_COMMA,
    ACTIONS(8067), 1,
      anon_sym_RPAREN,
    STATE(5546), 1,
      sym_heredoc_body,
    STATE(5567), 1,
      aux_sym_parameters_repeat1,
  [189657] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(238), 1,
      sym__terminator,
    STATE(5547), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [189674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7544), 1,
      sym__string_end,
    ACTIONS(8069), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5548), 1,
      sym_heredoc_body,
  [189693] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(240), 1,
      sym__terminator,
    STATE(5549), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [189710] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7508), 1,
      sym__string_end,
    ACTIONS(8071), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5550), 1,
      sym_heredoc_body,
  [189729] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7956), 1,
      anon_sym_COMMA,
    ACTIONS(8073), 1,
      anon_sym_RPAREN,
    STATE(5504), 1,
      aux_sym_parameters_repeat1,
    STATE(5551), 1,
      sym_heredoc_body,
  [189748] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5552), 1,
      sym_heredoc_body,
    ACTIONS(8075), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [189763] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5553), 1,
      sym_heredoc_body,
    ACTIONS(8077), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [189778] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7672), 1,
      sym__string_end,
    ACTIONS(8079), 1,
      aux_sym_string_array_token1,
    STATE(5554), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [189797] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    STATE(5510), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5555), 1,
      sym_heredoc_body,
  [189816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7580), 1,
      sym__string_end,
    ACTIONS(8083), 1,
      aux_sym_string_array_token1,
    STATE(5556), 1,
      sym_heredoc_body,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
  [189835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7680), 1,
      sym__string_end,
    ACTIONS(8085), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5557), 1,
      sym_heredoc_body,
  [189854] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2556), 1,
      anon_sym_RBRACE,
    ACTIONS(8087), 1,
      anon_sym_COMMA,
    STATE(5558), 1,
      sym_heredoc_body,
    STATE(5569), 1,
      aux_sym_hash_repeat1,
  [189873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8089), 1,
      aux_sym_string_array_token1,
    ACTIONS(8092), 1,
      sym__string_end,
    STATE(5559), 2,
      sym_heredoc_body,
      aux_sym_string_array_repeat1,
  [189890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7630), 1,
      sym__string_end,
    ACTIONS(8094), 1,
      aux_sym_string_array_token1,
    STATE(5559), 1,
      aux_sym_string_array_repeat1,
    STATE(5560), 1,
      sym_heredoc_body,
  [189909] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8096), 1,
      anon_sym_RBRACE,
    ACTIONS(8098), 1,
      anon_sym_COMMA,
    STATE(5558), 1,
      aux_sym_hash_repeat1,
    STATE(5561), 1,
      sym_heredoc_body,
  [189928] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8100), 1,
      anon_sym_RPAREN,
    STATE(5562), 1,
      sym_heredoc_body,
    ACTIONS(8102), 2,
      anon_sym_and,
      anon_sym_or,
  [189945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7553), 1,
      sym__string_end,
    ACTIONS(8104), 1,
      aux_sym_string_array_token1,
    STATE(5506), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5563), 1,
      sym_heredoc_body,
  [189964] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5564), 1,
      sym_heredoc_body,
    ACTIONS(7708), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189979] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5565), 1,
      sym_heredoc_body,
    ACTIONS(7780), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189994] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(214), 1,
      sym__terminator,
    STATE(5566), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [190011] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7956), 1,
      anon_sym_COMMA,
    ACTIONS(8106), 1,
      anon_sym_RPAREN,
    STATE(5504), 1,
      aux_sym_parameters_repeat1,
    STATE(5567), 1,
      sym_heredoc_body,
  [190030] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8108), 1,
      anon_sym_RPAREN,
    STATE(5568), 1,
      sym_heredoc_body,
    ACTIONS(8102), 2,
      anon_sym_and,
      anon_sym_or,
  [190047] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8110), 1,
      anon_sym_RBRACE,
    ACTIONS(8112), 1,
      anon_sym_COMMA,
    STATE(5569), 2,
      sym_heredoc_body,
      aux_sym_hash_repeat1,
  [190064] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7956), 1,
      anon_sym_COMMA,
    ACTIONS(8115), 1,
      anon_sym_RPAREN,
    STATE(5504), 1,
      aux_sym_parameters_repeat1,
    STATE(5570), 1,
      sym_heredoc_body,
  [190083] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8117), 1,
      anon_sym_RBRACE,
    ACTIONS(8119), 1,
      anon_sym_COMMA,
    STATE(5541), 1,
      aux_sym_hash_repeat1,
    STATE(5571), 1,
      sym_heredoc_body,
  [190102] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7956), 1,
      anon_sym_COMMA,
    ACTIONS(8121), 1,
      anon_sym_RPAREN,
    STATE(5570), 1,
      aux_sym_parameters_repeat1,
    STATE(5572), 1,
      sym_heredoc_body,
  [190121] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COMMA,
    ACTIONS(8123), 1,
      anon_sym_PIPE,
    STATE(5512), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5573), 1,
      sym_heredoc_body,
  [190140] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5574), 1,
      sym_heredoc_body,
    ACTIONS(7726), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190155] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8125), 1,
      anon_sym_i,
    ACTIONS(8127), 1,
      anon_sym_ri,
    ACTIONS(8129), 1,
      anon_sym_r,
    STATE(5575), 1,
      sym_heredoc_body,
  [190174] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2568), 1,
      anon_sym_RBRACE,
    ACTIONS(8131), 1,
      anon_sym_COMMA,
    STATE(5569), 1,
      aux_sym_hash_repeat1,
    STATE(5576), 1,
      sym_heredoc_body,
  [190193] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5577), 1,
      sym_heredoc_body,
    ACTIONS(7728), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190208] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5578), 1,
      sym_heredoc_body,
    ACTIONS(8133), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190222] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5579), 1,
      sym_heredoc_body,
    ACTIONS(8135), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190236] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5580), 1,
      sym_heredoc_body,
    ACTIONS(8137), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190250] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5581), 1,
      sym_heredoc_body,
    ACTIONS(8139), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190264] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5582), 1,
      sym_heredoc_body,
    ACTIONS(8141), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190278] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5583), 1,
      sym_heredoc_body,
    ACTIONS(8143), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190292] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5584), 1,
      sym_heredoc_body,
    ACTIONS(8145), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [190306] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5585), 1,
      sym_heredoc_body,
    ACTIONS(8147), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190320] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_PIPE,
    ACTIONS(7893), 1,
      anon_sym_SEMI,
    STATE(5586), 1,
      sym_heredoc_body,
  [190336] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5587), 1,
      sym_heredoc_body,
    ACTIONS(8149), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190350] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5588), 1,
      sym_heredoc_body,
    ACTIONS(8151), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190364] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5589), 1,
      sym_heredoc_body,
    ACTIONS(8153), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190378] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LPAREN,
    STATE(5404), 1,
      sym_parenthesized_statements,
    STATE(5590), 1,
      sym_heredoc_body,
  [190394] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5591), 1,
      sym_heredoc_body,
    ACTIONS(8155), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190408] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5592), 1,
      sym_heredoc_body,
    ACTIONS(8157), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190422] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5593), 1,
      sym_heredoc_body,
    ACTIONS(8159), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190436] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5594), 1,
      sym_heredoc_body,
    ACTIONS(8161), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190450] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5595), 1,
      sym_heredoc_body,
    ACTIONS(8163), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190464] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5596), 1,
      sym_heredoc_body,
    ACTIONS(8165), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190478] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7920), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_SEMI,
    STATE(5597), 1,
      sym_heredoc_body,
  [190494] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5598), 1,
      sym_heredoc_body,
    ACTIONS(8167), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190508] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5599), 1,
      sym_heredoc_body,
    ACTIONS(8169), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190522] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5600), 1,
      sym_heredoc_body,
    ACTIONS(8171), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190536] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5601), 1,
      sym_heredoc_body,
    ACTIONS(8173), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190550] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    ACTIONS(8175), 1,
      anon_sym_RPAREN,
    STATE(5602), 1,
      sym_heredoc_body,
  [190566] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5603), 1,
      sym_heredoc_body,
    ACTIONS(8177), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190580] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5604), 1,
      sym_heredoc_body,
    ACTIONS(8179), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190594] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5605), 1,
      sym_heredoc_body,
    ACTIONS(8181), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190608] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5606), 1,
      sym_heredoc_body,
    ACTIONS(745), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190622] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7134), 1,
      anon_sym_EQ_GT,
    ACTIONS(8183), 1,
      anon_sym_RPAREN,
    STATE(5607), 1,
      sym_heredoc_body,
  [190638] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5608), 1,
      sym_heredoc_body,
    ACTIONS(8185), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190652] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5609), 1,
      sym_heredoc_body,
    ACTIONS(8187), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190666] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5610), 1,
      sym_heredoc_body,
    ACTIONS(8189), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190680] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5611), 1,
      sym_heredoc_body,
    ACTIONS(8191), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190694] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5612), 1,
      sym_heredoc_body,
    ACTIONS(8193), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190708] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5613), 1,
      sym_heredoc_body,
    ACTIONS(8195), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190722] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5614), 1,
      sym_heredoc_body,
    ACTIONS(8197), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190736] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5615), 1,
      sym_heredoc_body,
    ACTIONS(8199), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190750] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5616), 1,
      sym_heredoc_body,
    ACTIONS(8201), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190764] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5617), 1,
      sym_heredoc_body,
    ACTIONS(8203), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5618), 1,
      sym_heredoc_body,
    ACTIONS(8205), 2,
      anon_sym_EQ,
      anon_sym_in,
  [190792] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5619), 1,
      sym_heredoc_body,
    ACTIONS(8207), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190806] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5620), 1,
      sym_heredoc_body,
    ACTIONS(8209), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190820] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5621), 1,
      sym_heredoc_body,
    ACTIONS(8110), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [190834] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5622), 1,
      sym_heredoc_body,
    ACTIONS(8211), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190848] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5623), 1,
      sym_heredoc_body,
    ACTIONS(8213), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190862] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5624), 1,
      sym_heredoc_body,
    ACTIONS(8215), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190876] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7311), 1,
      anon_sym_in,
    STATE(5313), 1,
      sym_in,
    STATE(5625), 1,
      sym_heredoc_body,
  [190892] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5626), 1,
      sym_heredoc_body,
    ACTIONS(8217), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190906] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5627), 1,
      sym_heredoc_body,
    ACTIONS(8219), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190920] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5628), 1,
      sym_heredoc_body,
    ACTIONS(7857), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [190934] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5629), 1,
      sym_heredoc_body,
    ACTIONS(8221), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190948] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7311), 1,
      anon_sym_in,
    STATE(5306), 1,
      sym_in,
    STATE(5630), 1,
      sym_heredoc_body,
  [190964] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5631), 1,
      sym_heredoc_body,
    ACTIONS(8223), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190978] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5632), 1,
      sym_heredoc_body,
    ACTIONS(8225), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [190992] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5633), 1,
      sym_heredoc_body,
    ACTIONS(8227), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [191006] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5634), 1,
      sym_heredoc_body,
    ACTIONS(8229), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [191020] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5635), 1,
      sym_heredoc_body,
    ACTIONS(8231), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [191034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8205), 1,
      anon_sym_EQ,
    ACTIONS(8233), 1,
      anon_sym_RPAREN,
    STATE(5636), 1,
      sym_heredoc_body,
  [191050] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5637), 1,
      sym_heredoc_body,
    ACTIONS(8235), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [191064] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7311), 1,
      anon_sym_in,
    STATE(5300), 1,
      sym_in,
    STATE(5638), 1,
      sym_heredoc_body,
  [191080] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5639), 1,
      sym_heredoc_body,
    ACTIONS(8237), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [191094] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8239), 1,
      anon_sym_RPAREN,
    STATE(5640), 1,
      sym_heredoc_body,
  [191107] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8241), 1,
      anon_sym_end,
    STATE(5641), 1,
      sym_heredoc_body,
  [191120] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_RBRACE,
    STATE(5642), 1,
      sym_heredoc_body,
  [191133] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_RBRACK,
    STATE(5643), 1,
      sym_heredoc_body,
  [191146] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7001), 1,
      anon_sym_COLON,
    STATE(5644), 1,
      sym_heredoc_body,
  [191159] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7730), 1,
      anon_sym_end,
    STATE(5645), 1,
      sym_heredoc_body,
  [191172] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8247), 1,
      anon_sym_end,
    STATE(5646), 1,
      sym_heredoc_body,
  [191185] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7160), 1,
      anon_sym_COLON,
    STATE(5647), 1,
      sym_heredoc_body,
  [191198] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8249), 1,
      anon_sym_end,
    STATE(5648), 1,
      sym_heredoc_body,
  [191211] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_end,
    STATE(5649), 1,
      sym_heredoc_body,
  [191224] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8253), 1,
      anon_sym_end,
    STATE(5650), 1,
      sym_heredoc_body,
  [191237] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8255), 1,
      anon_sym_end,
    STATE(5651), 1,
      sym_heredoc_body,
  [191250] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8257), 1,
      anon_sym_end,
    STATE(5652), 1,
      sym_heredoc_body,
  [191263] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8259), 1,
      anon_sym_end,
    STATE(5653), 1,
      sym_heredoc_body,
  [191276] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8261), 1,
      anon_sym_RBRACE,
    STATE(5654), 1,
      sym_heredoc_body,
  [191289] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7063), 1,
      anon_sym_COLON,
    STATE(5655), 1,
      sym_heredoc_body,
  [191302] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8263), 1,
      sym_constant,
    STATE(5656), 1,
      sym_heredoc_body,
  [191315] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8265), 1,
      anon_sym_end,
    STATE(5657), 1,
      sym_heredoc_body,
  [191328] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8267), 1,
      anon_sym_end,
    STATE(5658), 1,
      sym_heredoc_body,
  [191341] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8269), 1,
      anon_sym_RBRACE,
    STATE(5659), 1,
      sym_heredoc_body,
  [191354] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8271), 1,
      anon_sym_end,
    STATE(5660), 1,
      sym_heredoc_body,
  [191367] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8273), 1,
      anon_sym_end,
    STATE(5661), 1,
      sym_heredoc_body,
  [191380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8275), 1,
      anon_sym_EQ,
    STATE(5662), 1,
      sym_heredoc_body,
  [191393] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8277), 1,
      anon_sym_RBRACK,
    STATE(5663), 1,
      sym_heredoc_body,
  [191406] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8279), 1,
      anon_sym_end,
    STATE(5664), 1,
      sym_heredoc_body,
  [191419] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8281), 1,
      anon_sym_COLON,
    STATE(5665), 1,
      sym_heredoc_body,
  [191432] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8283), 1,
      anon_sym_end,
    STATE(5666), 1,
      sym_heredoc_body,
  [191445] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8285), 1,
      anon_sym_RBRACK,
    STATE(5667), 1,
      sym_heredoc_body,
  [191458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8287), 1,
      anon_sym_EQ,
    STATE(5668), 1,
      sym_heredoc_body,
  [191471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8289), 1,
      anon_sym_EQ,
    STATE(5669), 1,
      sym_heredoc_body,
  [191484] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8291), 1,
      anon_sym_end,
    STATE(5670), 1,
      sym_heredoc_body,
  [191497] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_end,
    STATE(5671), 1,
      sym_heredoc_body,
  [191510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8295), 1,
      anon_sym_EQ,
    STATE(5672), 1,
      sym_heredoc_body,
  [191523] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8297), 1,
      anon_sym_end,
    STATE(5673), 1,
      sym_heredoc_body,
  [191536] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8299), 1,
      anon_sym_end,
    STATE(5674), 1,
      sym_heredoc_body,
  [191549] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8301), 1,
      anon_sym_end,
    STATE(5675), 1,
      sym_heredoc_body,
  [191562] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8303), 1,
      anon_sym_RBRACE,
    STATE(5676), 1,
      sym_heredoc_body,
  [191575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8305), 1,
      anon_sym_EQ,
    STATE(5677), 1,
      sym_heredoc_body,
  [191588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8307), 1,
      anon_sym_EQ,
    STATE(5678), 1,
      sym_heredoc_body,
  [191601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8309), 1,
      anon_sym_EQ,
    STATE(5679), 1,
      sym_heredoc_body,
  [191614] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8311), 1,
      anon_sym_end,
    STATE(5680), 1,
      sym_heredoc_body,
  [191627] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8313), 1,
      anon_sym_end,
    STATE(5681), 1,
      sym_heredoc_body,
  [191640] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8315), 1,
      sym__string_end,
    STATE(5682), 1,
      sym_heredoc_body,
  [191653] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8317), 1,
      anon_sym_end,
    STATE(5683), 1,
      sym_heredoc_body,
  [191666] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8319), 1,
      anon_sym_end,
    STATE(5684), 1,
      sym_heredoc_body,
  [191679] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8321), 1,
      sym__string_end,
    STATE(5685), 1,
      sym_heredoc_body,
  [191692] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7227), 1,
      anon_sym_end,
    STATE(5686), 1,
      sym_heredoc_body,
  [191705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8323), 1,
      anon_sym_EQ,
    STATE(5687), 1,
      sym_heredoc_body,
  [191718] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8325), 1,
      anon_sym_end,
    STATE(5688), 1,
      sym_heredoc_body,
  [191731] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8327), 1,
      anon_sym_end,
    STATE(5689), 1,
      sym_heredoc_body,
  [191744] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8329), 1,
      anon_sym_end,
    STATE(5690), 1,
      sym_heredoc_body,
  [191757] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8331), 1,
      anon_sym_RBRACK,
    STATE(5691), 1,
      sym_heredoc_body,
  [191770] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8333), 1,
      anon_sym_end,
    STATE(5692), 1,
      sym_heredoc_body,
  [191783] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8335), 1,
      anon_sym_RBRACK,
    STATE(5693), 1,
      sym_heredoc_body,
  [191796] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8337), 1,
      anon_sym_RBRACK,
    STATE(5694), 1,
      sym_heredoc_body,
  [191809] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8339), 1,
      anon_sym_end,
    STATE(5695), 1,
      sym_heredoc_body,
  [191822] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8341), 1,
      anon_sym_RBRACK,
    STATE(5696), 1,
      sym_heredoc_body,
  [191835] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8343), 1,
      anon_sym_RBRACK,
    STATE(5697), 1,
      sym_heredoc_body,
  [191848] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8335), 1,
      anon_sym_RPAREN,
    STATE(5698), 1,
      sym_heredoc_body,
  [191861] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8337), 1,
      anon_sym_RPAREN,
    STATE(5699), 1,
      sym_heredoc_body,
  [191874] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8341), 1,
      anon_sym_RPAREN,
    STATE(5700), 1,
      sym_heredoc_body,
  [191887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8345), 1,
      anon_sym_EQ,
    STATE(5701), 1,
      sym_heredoc_body,
  [191900] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8347), 1,
      anon_sym_RBRACE,
    STATE(5702), 1,
      sym_heredoc_body,
  [191913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8349), 1,
      anon_sym_EQ,
    STATE(5703), 1,
      sym_heredoc_body,
  [191926] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8351), 1,
      sym_constant,
    STATE(5704), 1,
      sym_heredoc_body,
  [191939] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8353), 1,
      anon_sym_end,
    STATE(5705), 1,
      sym_heredoc_body,
  [191952] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8355), 1,
      anon_sym_end,
    STATE(5706), 1,
      sym_heredoc_body,
  [191965] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8357), 1,
      anon_sym_RPAREN,
    STATE(5707), 1,
      sym_heredoc_body,
  [191978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8359), 1,
      anon_sym_EQ,
    STATE(5708), 1,
      sym_heredoc_body,
  [191991] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7748), 1,
      anon_sym_end,
    STATE(5709), 1,
      sym_heredoc_body,
  [192004] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8361), 1,
      ts_builtin_sym_end,
    STATE(5710), 1,
      sym_heredoc_body,
  [192017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8363), 1,
      anon_sym_EQ,
    STATE(5711), 1,
      sym_heredoc_body,
  [192030] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8365), 1,
      anon_sym_end,
    STATE(5712), 1,
      sym_heredoc_body,
  [192043] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8367), 1,
      sym__string_end,
    STATE(5713), 1,
      sym_heredoc_body,
  [192056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8369), 1,
      anon_sym_EQ,
    STATE(5714), 1,
      sym_heredoc_body,
  [192069] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8371), 1,
      anon_sym_COLON,
    STATE(5715), 1,
      sym_heredoc_body,
  [192082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8373), 1,
      anon_sym_EQ,
    STATE(5716), 1,
      sym_heredoc_body,
  [192095] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7268), 1,
      anon_sym_end,
    STATE(5717), 1,
      sym_heredoc_body,
  [192108] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8375), 1,
      anon_sym_end,
    STATE(5718), 1,
      sym_heredoc_body,
  [192121] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8377), 1,
      anon_sym_end,
    STATE(5719), 1,
      sym_heredoc_body,
  [192134] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8379), 1,
      sym_identifier,
    STATE(5720), 1,
      sym_heredoc_body,
  [192147] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_end,
    STATE(5721), 1,
      sym_heredoc_body,
  [192160] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8383), 1,
      sym_identifier,
    STATE(5722), 1,
      sym_heredoc_body,
  [192173] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_end,
    STATE(5723), 1,
      sym_heredoc_body,
  [192186] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7773), 1,
      anon_sym_end,
    STATE(5724), 1,
      sym_heredoc_body,
  [192199] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8387), 1,
      sym_identifier,
    STATE(5725), 1,
      sym_heredoc_body,
  [192212] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8389), 1,
      anon_sym_RBRACE,
    STATE(5726), 1,
      sym_heredoc_body,
  [192225] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8391), 1,
      anon_sym_end,
    STATE(5727), 1,
      sym_heredoc_body,
  [192238] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8393), 1,
      anon_sym_RBRACK,
    STATE(5728), 1,
      sym_heredoc_body,
  [192251] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8395), 1,
      anon_sym_end,
    STATE(5729), 1,
      sym_heredoc_body,
  [192264] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8397), 1,
      anon_sym_end,
    STATE(5730), 1,
      sym_heredoc_body,
  [192277] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8399), 1,
      anon_sym_end,
    STATE(5731), 1,
      sym_heredoc_body,
  [192290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8401), 1,
      anon_sym_EQ,
    STATE(5732), 1,
      sym_heredoc_body,
  [192303] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8403), 1,
      anon_sym_RBRACE,
    STATE(5733), 1,
      sym_heredoc_body,
  [192316] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8405), 1,
      sym_constant,
    STATE(5734), 1,
      sym_heredoc_body,
  [192329] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8407), 1,
      sym_constant,
    STATE(5735), 1,
      sym_heredoc_body,
  [192342] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8409), 1,
      sym_identifier,
    STATE(5736), 1,
      sym_heredoc_body,
  [192355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8411), 1,
      anon_sym_EQ,
    STATE(5737), 1,
      sym_heredoc_body,
  [192368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8413), 1,
      anon_sym_EQ,
    STATE(5738), 1,
      sym_heredoc_body,
  [192381] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7694), 1,
      anon_sym_end,
    STATE(5739), 1,
      sym_heredoc_body,
  [192394] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8415), 1,
      anon_sym_COLON,
    STATE(5740), 1,
      sym_heredoc_body,
  [192407] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_RBRACE,
    STATE(5741), 1,
      sym_heredoc_body,
  [192420] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8419), 1,
      sym__string_end,
    STATE(5742), 1,
      sym_heredoc_body,
  [192433] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8421), 1,
      anon_sym_RBRACE,
    STATE(5743), 1,
      sym_heredoc_body,
  [192446] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8423), 1,
      anon_sym_end,
    STATE(5744), 1,
      sym_heredoc_body,
  [192459] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_end,
    STATE(5745), 1,
      sym_heredoc_body,
  [192472] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8427), 1,
      anon_sym_end,
    STATE(5746), 1,
      sym_heredoc_body,
  [192485] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8429), 1,
      anon_sym_end,
    STATE(5747), 1,
      sym_heredoc_body,
  [192498] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_end,
    STATE(5748), 1,
      sym_heredoc_body,
  [192511] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8431), 1,
      anon_sym_RBRACK,
    STATE(5749), 1,
      sym_heredoc_body,
  [192524] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8433), 1,
      sym_constant,
    STATE(5750), 1,
      sym_heredoc_body,
  [192537] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8435), 1,
      anon_sym_end,
    STATE(5751), 1,
      sym_heredoc_body,
  [192550] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8437), 1,
      anon_sym_end,
    STATE(5752), 1,
      sym_heredoc_body,
  [192563] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8439), 1,
      sym_identifier,
    STATE(5753), 1,
      sym_heredoc_body,
  [192576] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_COLON,
    STATE(5754), 1,
      sym_heredoc_body,
  [192589] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8441), 1,
      anon_sym_end,
    STATE(5755), 1,
      sym_heredoc_body,
  [192602] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8443), 1,
      anon_sym_end,
    STATE(5756), 1,
      sym_heredoc_body,
  [192615] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8445), 1,
      sym_constant,
    STATE(5757), 1,
      sym_heredoc_body,
  [192628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8447), 1,
      anon_sym_EQ,
    STATE(5758), 1,
      sym_heredoc_body,
  [192641] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8449), 1,
      sym_identifier,
    STATE(5759), 1,
      sym_heredoc_body,
  [192654] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8451), 1,
      anon_sym_end,
    STATE(5760), 1,
      sym_heredoc_body,
  [192667] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8453), 1,
      anon_sym_end,
    STATE(5761), 1,
      sym_heredoc_body,
  [192680] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7193), 1,
      anon_sym_end,
    STATE(5762), 1,
      sym_heredoc_body,
  [192693] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8455), 1,
      anon_sym_end,
    STATE(5763), 1,
      sym_heredoc_body,
  [192706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8457), 1,
      anon_sym_,
    STATE(5764), 1,
      sym_heredoc_body,
  [192719] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8459), 1,
      anon_sym_end,
    STATE(5765), 1,
      sym_heredoc_body,
  [192732] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8461), 1,
      anon_sym_end,
    STATE(5766), 1,
      sym_heredoc_body,
  [192745] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8463), 1,
      anon_sym_RBRACK,
    STATE(5767), 1,
      sym_heredoc_body,
  [192758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8465), 1,
      anon_sym_EQ,
    STATE(5768), 1,
      sym_heredoc_body,
  [192771] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8467), 1,
      anon_sym_RBRACE,
    STATE(5769), 1,
      sym_heredoc_body,
  [192784] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8469), 1,
      sym_constant,
    STATE(5770), 1,
      sym_heredoc_body,
  [192797] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8471), 1,
      anon_sym_end,
    STATE(5771), 1,
      sym_heredoc_body,
  [192810] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8473), 1,
      sym__string_end,
    STATE(5772), 1,
      sym_heredoc_body,
  [192823] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8475), 1,
      anon_sym_RBRACE,
    STATE(5773), 1,
      sym_heredoc_body,
  [192836] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8477), 1,
      anon_sym_LBRACE,
    STATE(5774), 1,
      sym_heredoc_body,
  [192849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8479), 1,
      anon_sym_EQ,
    STATE(5775), 1,
      sym_heredoc_body,
  [192862] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym_end,
    STATE(5776), 1,
      sym_heredoc_body,
  [192875] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8483), 1,
      sym__string_end,
    STATE(5777), 1,
      sym_heredoc_body,
  [192888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8485), 1,
      anon_sym_EQ,
    STATE(5778), 1,
      sym_heredoc_body,
  [192901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8487), 1,
      anon_sym_EQ,
    STATE(5779), 1,
      sym_heredoc_body,
  [192914] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8489), 1,
      anon_sym_end,
    STATE(5780), 1,
      sym_heredoc_body,
  [192927] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8491), 1,
      anon_sym_COLON,
    STATE(5781), 1,
      sym_heredoc_body,
  [192940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8493), 1,
      anon_sym_EQ,
    STATE(5782), 1,
      sym_heredoc_body,
  [192953] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8495), 1,
      anon_sym_end,
    STATE(5783), 1,
      sym_heredoc_body,
  [192966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8497), 1,
      anon_sym_EQ,
    STATE(5784), 1,
      sym_heredoc_body,
  [192979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8499), 1,
      anon_sym_EQ,
    STATE(5785), 1,
      sym_heredoc_body,
  [192992] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7764), 1,
      anon_sym_end,
    STATE(5786), 1,
      sym_heredoc_body,
  [193005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8501), 1,
      anon_sym_EQ,
    STATE(5787), 1,
      sym_heredoc_body,
  [193018] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8503), 1,
      anon_sym_COLON,
    STATE(5788), 1,
      sym_heredoc_body,
  [193031] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8505), 1,
      anon_sym_end,
    STATE(5789), 1,
      sym_heredoc_body,
  [193044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8507), 1,
      anon_sym_EQ,
    STATE(5790), 1,
      sym_heredoc_body,
  [193057] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7033), 1,
      anon_sym_COLON,
    STATE(5791), 1,
      sym_heredoc_body,
  [193070] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8509), 1,
      anon_sym_end,
    STATE(5792), 1,
      sym_heredoc_body,
  [193083] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8511), 1,
      anon_sym_end,
    STATE(5793), 1,
      sym_heredoc_body,
  [193096] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8513), 1,
      anon_sym_end,
    STATE(5794), 1,
      sym_heredoc_body,
  [193109] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8515), 1,
      sym__string_end,
    STATE(5795), 1,
      sym_heredoc_body,
  [193122] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8517), 1,
      anon_sym_end,
    STATE(5796), 1,
      sym_heredoc_body,
  [193135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8519), 1,
      anon_sym_EQ,
    STATE(5797), 1,
      sym_heredoc_body,
  [193148] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8521), 1,
      anon_sym_RBRACE,
    STATE(5798), 1,
      sym_heredoc_body,
  [193161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8523), 1,
      anon_sym_EQ,
    STATE(5799), 1,
      sym_heredoc_body,
  [193174] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8525), 1,
      anon_sym_end,
    STATE(5800), 1,
      sym_heredoc_body,
  [193187] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_COLON,
    STATE(5801), 1,
      sym_heredoc_body,
  [193200] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8527), 1,
      ts_builtin_sym_end,
    STATE(5802), 1,
      sym_heredoc_body,
  [193213] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8529), 1,
      anon_sym_end,
    STATE(5803), 1,
      sym_heredoc_body,
  [193226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8531), 1,
      anon_sym_EQ,
    STATE(5804), 1,
      sym_heredoc_body,
  [193239] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8533), 1,
      anon_sym_COLON,
    STATE(5805), 1,
      sym_heredoc_body,
  [193252] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7710), 1,
      anon_sym_end,
    STATE(5806), 1,
      sym_heredoc_body,
  [193265] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8535), 1,
      sym_identifier,
    STATE(5807), 1,
      sym_heredoc_body,
  [193278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8537), 1,
      anon_sym_EQ,
    STATE(5808), 1,
      sym_heredoc_body,
  [193291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8539), 1,
      anon_sym_EQ,
    STATE(5809), 1,
      sym_heredoc_body,
  [193304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8541), 1,
      anon_sym_EQ,
    STATE(5810), 1,
      sym_heredoc_body,
  [193317] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8543), 1,
      anon_sym_COLON,
    STATE(5811), 1,
      sym_heredoc_body,
  [193330] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8545), 1,
      sym__string_end,
    STATE(5812), 1,
      sym_heredoc_body,
  [193343] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7756), 1,
      anon_sym_end,
    STATE(5813), 1,
      sym_heredoc_body,
  [193356] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8547), 1,
      sym__string_end,
    STATE(5814), 1,
      sym_heredoc_body,
  [193369] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8549), 1,
      anon_sym_end,
    STATE(5815), 1,
      sym_heredoc_body,
  [193382] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8551), 1,
      anon_sym_RBRACE,
    STATE(5816), 1,
      sym_heredoc_body,
  [193395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8553), 1,
      anon_sym_EQ,
    STATE(5817), 1,
      sym_heredoc_body,
  [193408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8555), 1,
      anon_sym_EQ,
    STATE(5818), 1,
      sym_heredoc_body,
  [193421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8557), 1,
      anon_sym_EQ,
    STATE(5819), 1,
      sym_heredoc_body,
  [193434] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8559), 1,
      sym__string_end,
    STATE(5820), 1,
      sym_heredoc_body,
  [193447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8561), 1,
      anon_sym_EQ,
    STATE(5821), 1,
      sym_heredoc_body,
  [193460] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8563), 1,
      anon_sym_end,
    STATE(5822), 1,
      sym_heredoc_body,
  [193473] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8565), 1,
      anon_sym_end,
    STATE(5823), 1,
      sym_heredoc_body,
  [193486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8567), 1,
      anon_sym_EQ,
    STATE(5824), 1,
      sym_heredoc_body,
  [193499] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8569), 1,
      anon_sym_RBRACE,
    STATE(5825), 1,
      sym_heredoc_body,
  [193512] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_end,
    STATE(5826), 1,
      sym_heredoc_body,
  [193525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8571), 1,
      anon_sym_EQ,
    STATE(5827), 1,
      sym_heredoc_body,
  [193538] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8573), 1,
      anon_sym_end,
    STATE(5828), 1,
      sym_heredoc_body,
  [193551] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8575), 1,
      anon_sym_end,
    STATE(5829), 1,
      sym_heredoc_body,
  [193564] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8577), 1,
      anon_sym_end,
    STATE(5830), 1,
      sym_heredoc_body,
  [193577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8579), 1,
      anon_sym_EQ,
    STATE(5831), 1,
      sym_heredoc_body,
  [193590] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8581), 1,
      anon_sym_end,
    STATE(5832), 1,
      sym_heredoc_body,
  [193603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8583), 1,
      anon_sym_EQ,
    STATE(5833), 1,
      sym_heredoc_body,
  [193616] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8585), 1,
      anon_sym_COLON,
    STATE(5834), 1,
      sym_heredoc_body,
  [193629] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8587), 1,
      anon_sym_RBRACK,
    STATE(5835), 1,
      sym_heredoc_body,
  [193642] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6686), 1,
      anon_sym_COLON,
    STATE(5836), 1,
      sym_heredoc_body,
  [193655] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7688), 1,
      anon_sym_end,
    STATE(5837), 1,
      sym_heredoc_body,
  [193668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8589), 1,
      anon_sym_,
    STATE(5838), 1,
      sym_heredoc_body,
  [193681] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8591), 1,
      anon_sym_RPAREN,
    STATE(5839), 1,
      sym_heredoc_body,
  [193694] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8593), 1,
      anon_sym_end,
    STATE(5840), 1,
      sym_heredoc_body,
  [193707] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8595), 1,
      sym_constant,
    STATE(5841), 1,
      sym_heredoc_body,
  [193720] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8597), 1,
      anon_sym_end,
    STATE(5842), 1,
      sym_heredoc_body,
  [193733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8599), 1,
      anon_sym_EQ,
    STATE(5843), 1,
      sym_heredoc_body,
  [193746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8601), 1,
      anon_sym_EQ,
    STATE(5844), 1,
      sym_heredoc_body,
  [193759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8603), 1,
      anon_sym_EQ,
    STATE(5845), 1,
      sym_heredoc_body,
  [193772] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8605), 1,
      anon_sym_RBRACE,
    STATE(5846), 1,
      sym_heredoc_body,
  [193785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8607), 1,
      anon_sym_EQ,
    STATE(5847), 1,
      sym_heredoc_body,
  [193798] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8609), 1,
      anon_sym_end,
    STATE(5848), 1,
      sym_heredoc_body,
  [193811] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_end,
    STATE(5849), 1,
      sym_heredoc_body,
  [193824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8613), 1,
      anon_sym_EQ,
    STATE(5850), 1,
      sym_heredoc_body,
  [193837] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8615), 1,
      anon_sym_RBRACE,
    STATE(5851), 1,
      sym_heredoc_body,
  [193850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8617), 1,
      anon_sym_EQ,
    STATE(5852), 1,
      sym_heredoc_body,
  [193863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8619), 1,
      anon_sym_EQ,
    STATE(5853), 1,
      sym_heredoc_body,
  [193876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8621), 1,
      anon_sym_EQ,
    STATE(5854), 1,
      sym_heredoc_body,
  [193889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8623), 1,
      anon_sym_EQ,
    STATE(5855), 1,
      sym_heredoc_body,
  [193902] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8625), 1,
      anon_sym_end,
    STATE(5856), 1,
      sym_heredoc_body,
  [193915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8627), 1,
      anon_sym_EQ,
    STATE(5857), 1,
      sym_heredoc_body,
  [193928] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8629), 1,
      anon_sym_end,
    STATE(5858), 1,
      sym_heredoc_body,
  [193941] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8631), 1,
      anon_sym_end,
    STATE(5859), 1,
      sym_heredoc_body,
  [193954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8633), 1,
      anon_sym_EQ,
    STATE(5860), 1,
      sym_heredoc_body,
  [193967] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8635), 1,
      sym_constant,
    STATE(5861), 1,
      sym_heredoc_body,
  [193980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8637), 1,
      anon_sym_EQ,
    STATE(5862), 1,
      sym_heredoc_body,
  [193993] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8639), 1,
      anon_sym_end,
    STATE(5863), 1,
      sym_heredoc_body,
  [194006] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8641), 1,
      anon_sym_RBRACE,
    STATE(5864), 1,
      sym_heredoc_body,
  [194019] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8643), 1,
      anon_sym_end,
    STATE(5865), 1,
      sym_heredoc_body,
  [194032] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8645), 1,
      anon_sym_end,
    STATE(5866), 1,
      sym_heredoc_body,
  [194045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8647), 1,
      anon_sym_EQ,
    STATE(5867), 1,
      sym_heredoc_body,
  [194058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8457), 1,
      sym_uninterpreted,
    STATE(5868), 1,
      sym_heredoc_body,
  [194071] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8649), 1,
      anon_sym_end,
    STATE(5869), 1,
      sym_heredoc_body,
  [194084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8651), 1,
      anon_sym_EQ,
    STATE(5870), 1,
      sym_heredoc_body,
  [194097] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8653), 1,
      anon_sym_end,
    STATE(5871), 1,
      sym_heredoc_body,
  [194110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8655), 1,
      anon_sym_EQ,
    STATE(5872), 1,
      sym_heredoc_body,
  [194123] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_end,
    STATE(5873), 1,
      sym_heredoc_body,
  [194136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8657), 1,
      anon_sym_EQ,
    STATE(5874), 1,
      sym_heredoc_body,
  [194149] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8659), 1,
      anon_sym_RBRACK,
    STATE(5875), 1,
      sym_heredoc_body,
  [194162] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8661), 1,
      anon_sym_end,
    STATE(5876), 1,
      sym_heredoc_body,
  [194175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8663), 1,
      anon_sym_EQ,
    STATE(5877), 1,
      sym_heredoc_body,
  [194188] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8665), 1,
      anon_sym_end,
    STATE(5878), 1,
      sym_heredoc_body,
  [194201] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8667), 1,
      anon_sym_RBRACE,
    STATE(5879), 1,
      sym_heredoc_body,
  [194214] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8669), 1,
      anon_sym_end,
    STATE(5880), 1,
      sym_heredoc_body,
  [194227] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8671), 1,
      anon_sym_RBRACE,
    STATE(5881), 1,
      sym_heredoc_body,
  [194240] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8673), 1,
      ts_builtin_sym_end,
    STATE(5882), 1,
      sym_heredoc_body,
  [194253] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8675), 1,
      anon_sym_end,
    STATE(5883), 1,
      sym_heredoc_body,
  [194266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8677), 1,
      anon_sym_EQ,
    STATE(5884), 1,
      sym_heredoc_body,
  [194279] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8679), 1,
      anon_sym_end,
    STATE(5885), 1,
      sym_heredoc_body,
  [194292] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_end,
    STATE(5886), 1,
      sym_heredoc_body,
  [194305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8683), 1,
      anon_sym_EQ,
    STATE(5887), 1,
      sym_heredoc_body,
  [194318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8685), 1,
      anon_sym_EQ,
    STATE(5888), 1,
      sym_heredoc_body,
  [194331] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8687), 1,
      anon_sym_end,
    STATE(5889), 1,
      sym_heredoc_body,
  [194344] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8689), 1,
      anon_sym_end,
    STATE(5890), 1,
      sym_heredoc_body,
  [194357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8589), 1,
      sym_uninterpreted,
    STATE(5891), 1,
      sym_heredoc_body,
  [194370] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_COLON,
    STATE(5892), 1,
      sym_heredoc_body,
  [194383] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2642), 1,
      anon_sym_COLON,
    STATE(5893), 1,
      sym_heredoc_body,
  [194396] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8691), 1,
      anon_sym_RBRACK,
    STATE(5894), 1,
      sym_heredoc_body,
  [194409] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8693), 1,
      anon_sym_end,
    STATE(5895), 1,
      sym_heredoc_body,
  [194422] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8695), 1,
      anon_sym_end,
    STATE(5896), 1,
      sym_heredoc_body,
  [194435] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym_end,
    STATE(5897), 1,
      sym_heredoc_body,
  [194448] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8699), 1,
      anon_sym_end,
    STATE(5898), 1,
      sym_heredoc_body,
  [194461] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8701), 1,
      anon_sym_COLON,
    STATE(5899), 1,
      sym_heredoc_body,
  [194474] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8703), 1,
      anon_sym_end,
    STATE(5900), 1,
      sym_heredoc_body,
  [194487] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8705), 1,
      sym_constant,
    STATE(5901), 1,
      sym_heredoc_body,
  [194500] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8707), 1,
      sym_constant,
    STATE(5902), 1,
      sym_heredoc_body,
  [194513] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8709), 1,
      anon_sym_RPAREN,
    STATE(5903), 1,
      sym_heredoc_body,
  [194526] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8711), 1,
      anon_sym_end,
    STATE(5904), 1,
      sym_heredoc_body,
  [194539] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8713), 1,
      anon_sym_end,
    STATE(5905), 1,
      sym_heredoc_body,
  [194552] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8715), 1,
      anon_sym_end,
    STATE(5906), 1,
      sym_heredoc_body,
  [194565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8717), 1,
      anon_sym_EQ,
    STATE(5907), 1,
      sym_heredoc_body,
  [194578] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8719), 1,
      anon_sym_RBRACK,
    STATE(5908), 1,
      sym_heredoc_body,
  [194591] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8721), 1,
      anon_sym_end,
    STATE(5909), 1,
      sym_heredoc_body,
  [194604] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8723), 1,
      sym_identifier,
    STATE(5910), 1,
      sym_heredoc_body,
  [194617] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8725), 1,
      anon_sym_end,
    STATE(5911), 1,
      sym_heredoc_body,
  [194630] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7232), 1,
      anon_sym_end,
    STATE(5912), 1,
      sym_heredoc_body,
  [194643] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8727), 1,
      anon_sym_end,
    STATE(5913), 1,
      sym_heredoc_body,
  [194656] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8729), 1,
      anon_sym_RBRACE,
    STATE(5914), 1,
      sym_heredoc_body,
  [194669] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8731), 1,
      anon_sym_RBRACK,
    STATE(5915), 1,
      sym_heredoc_body,
  [194682] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8733), 1,
      sym_identifier,
    STATE(5916), 1,
      sym_heredoc_body,
  [194695] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8735), 1,
      anon_sym_RBRACK,
    STATE(5917), 1,
      sym_heredoc_body,
  [194708] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8737), 1,
      sym_constant,
    STATE(5918), 1,
      sym_heredoc_body,
  [194721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8739), 1,
      anon_sym_EQ,
    STATE(5919), 1,
      sym_heredoc_body,
  [194734] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8741), 1,
      anon_sym_end,
    STATE(5920), 1,
      sym_heredoc_body,
  [194747] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8743), 1,
      anon_sym_end,
    STATE(5921), 1,
      sym_heredoc_body,
  [194760] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8745), 1,
      anon_sym_RBRACE,
    STATE(5922), 1,
      sym_heredoc_body,
  [194773] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8747), 1,
      anon_sym_end,
    STATE(5923), 1,
      sym_heredoc_body,
  [194786] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8749), 1,
      anon_sym_end,
    STATE(5924), 1,
      sym_heredoc_body,
  [194799] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_RBRACE,
    STATE(5925), 1,
      sym_heredoc_body,
  [194812] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8753), 1,
      anon_sym_end,
    STATE(5926), 1,
      sym_heredoc_body,
  [194825] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8755), 1,
      anon_sym_end,
    STATE(5927), 1,
      sym_heredoc_body,
  [194838] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8691), 1,
      anon_sym_RPAREN,
    STATE(5928), 1,
      sym_heredoc_body,
  [194851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8757), 1,
      anon_sym_EQ,
    STATE(5929), 1,
      sym_heredoc_body,
  [194864] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_end,
    STATE(5930), 1,
      sym_heredoc_body,
  [194877] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8761), 1,
      anon_sym_end,
    STATE(5931), 1,
      sym_heredoc_body,
  [194890] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8763), 1,
      anon_sym_end,
    STATE(5932), 1,
      sym_heredoc_body,
  [194903] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8765), 1,
      anon_sym_RPAREN,
    STATE(5933), 1,
      sym_heredoc_body,
  [194916] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8767), 1,
      anon_sym_COLON,
    STATE(5934), 1,
      sym_heredoc_body,
  [194929] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8769), 1,
      anon_sym_end,
    STATE(5935), 1,
      sym_heredoc_body,
  [194942] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8771), 1,
      anon_sym_end,
    STATE(5936), 1,
      sym_heredoc_body,
  [194955] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8773), 1,
      anon_sym_end,
    STATE(5937), 1,
      sym_heredoc_body,
  [194968] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8775), 1,
      anon_sym_RBRACK,
    STATE(5938), 1,
      sym_heredoc_body,
  [194981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8777), 1,
      anon_sym_EQ,
    STATE(5939), 1,
      sym_heredoc_body,
  [194994] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8779), 1,
      anon_sym_end,
    STATE(5940), 1,
      sym_heredoc_body,
  [195007] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_COLON,
    STATE(5941), 1,
      sym_heredoc_body,
  [195020] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8781), 1,
      anon_sym_end,
    STATE(5942), 1,
      sym_heredoc_body,
  [195033] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8783), 1,
      anon_sym_COLON,
    STATE(5943), 1,
      sym_heredoc_body,
  [195046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8785), 1,
      anon_sym_EQ,
    STATE(5944), 1,
      sym_heredoc_body,
  [195059] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8787), 1,
      anon_sym_RBRACK,
    STATE(5945), 1,
      sym_heredoc_body,
  [195072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8789), 1,
      anon_sym_EQ,
    STATE(5946), 1,
      sym_heredoc_body,
  [195085] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8791), 1,
      anon_sym_end,
    STATE(5947), 1,
      sym_heredoc_body,
  [195098] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8793), 1,
      anon_sym_end,
    STATE(5948), 1,
      sym_heredoc_body,
  [195111] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8795), 1,
      anon_sym_end,
    STATE(5949), 1,
      sym_heredoc_body,
  [195124] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_COLON,
    STATE(5950), 1,
      sym_heredoc_body,
  [195137] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COLON,
    STATE(5951), 1,
      sym_heredoc_body,
  [195150] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8799), 1,
      anon_sym_RBRACE,
    STATE(5952), 1,
      sym_heredoc_body,
  [195163] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8801), 1,
      anon_sym_RBRACE,
    STATE(5953), 1,
      sym_heredoc_body,
  [195176] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8803), 1,
      anon_sym_end,
    STATE(5954), 1,
      sym_heredoc_body,
  [195189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8805), 1,
      anon_sym_EQ,
    STATE(5955), 1,
      sym_heredoc_body,
  [195202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8807), 1,
      anon_sym_EQ,
    STATE(5956), 1,
      sym_heredoc_body,
  [195215] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_RBRACE,
    STATE(5957), 1,
      sym_heredoc_body,
  [195228] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7266), 1,
      anon_sym_end,
    STATE(5958), 1,
      sym_heredoc_body,
  [195241] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8719), 1,
      anon_sym_RPAREN,
    STATE(5959), 1,
      sym_heredoc_body,
  [195254] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8731), 1,
      anon_sym_RPAREN,
    STATE(5960), 1,
      sym_heredoc_body,
  [195267] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8811), 1,
      sym_constant,
    STATE(5961), 1,
      sym_heredoc_body,
  [195280] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7168), 1,
      anon_sym_end,
    STATE(5962), 1,
      sym_heredoc_body,
  [195293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8813), 1,
      anon_sym_EQ,
    STATE(5963), 1,
      sym_heredoc_body,
  [195306] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8815), 1,
      sym_identifier,
    STATE(5964), 1,
      sym_heredoc_body,
  [195319] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8817), 1,
      anon_sym_RBRACK,
    STATE(5965), 1,
      sym_heredoc_body,
  [195332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8819), 1,
      anon_sym_EQ,
    STATE(5966), 1,
      sym_heredoc_body,
  [195345] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8821), 1,
      anon_sym_end,
    STATE(5967), 1,
      sym_heredoc_body,
  [195358] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8823), 1,
      sym_identifier,
    STATE(5968), 1,
      sym_heredoc_body,
  [195371] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8825), 1,
      anon_sym_RBRACE,
    STATE(5969), 1,
      sym_heredoc_body,
  [195384] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8827), 1,
      anon_sym_end,
    STATE(5970), 1,
      sym_heredoc_body,
  [195397] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8829), 1,
      anon_sym_end,
    STATE(5971), 1,
      sym_heredoc_body,
  [195410] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8831), 1,
      anon_sym_RPAREN,
    STATE(5972), 1,
      sym_heredoc_body,
  [195423] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8833), 1,
      anon_sym_end,
    STATE(5973), 1,
      sym_heredoc_body,
  [195436] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8835), 1,
      anon_sym_RBRACE,
    STATE(5974), 1,
      sym_heredoc_body,
  [195449] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8837), 1,
      anon_sym_end,
    STATE(5975), 1,
      sym_heredoc_body,
  [195462] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7736), 1,
      anon_sym_end,
    STATE(5976), 1,
      sym_heredoc_body,
  [195475] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8839), 1,
      anon_sym_end,
    STATE(5977), 1,
      sym_heredoc_body,
  [195488] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8841), 1,
      anon_sym_LBRACE,
    STATE(5978), 1,
      sym_heredoc_body,
  [195501] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8843), 1,
      anon_sym_end,
    STATE(5979), 1,
      sym_heredoc_body,
  [195514] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7111), 1,
      anon_sym_COLON,
    STATE(5980), 1,
      sym_heredoc_body,
  [195527] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8845), 1,
      anon_sym_end,
    STATE(5981), 1,
      sym_heredoc_body,
  [195540] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8847), 1,
      sym_constant,
    STATE(5982), 1,
      sym_heredoc_body,
  [195553] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8849), 1,
      anon_sym_end,
    STATE(5983), 1,
      sym_heredoc_body,
  [195566] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8851), 1,
      anon_sym_end,
    STATE(5984), 1,
      sym_heredoc_body,
  [195579] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8853), 1,
      anon_sym_end,
    STATE(5985), 1,
      sym_heredoc_body,
  [195592] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8855), 1,
      anon_sym_end,
    STATE(5986), 1,
      sym_heredoc_body,
  [195605] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8857), 1,
      anon_sym_RBRACE,
    STATE(5987), 1,
      sym_heredoc_body,
  [195618] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8859), 1,
      anon_sym_end,
    STATE(5988), 1,
      sym_heredoc_body,
  [195631] = 1,
    ACTIONS(8861), 1,
      ts_builtin_sym_end,
  [195635] = 1,
    ACTIONS(8863), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2172)] = 0,
  [SMALL_STATE(2173)] = 87,
  [SMALL_STATE(2174)] = 174,
  [SMALL_STATE(2175)] = 252,
  [SMALL_STATE(2176)] = 332,
  [SMALL_STATE(2177)] = 412,
  [SMALL_STATE(2178)] = 486,
  [SMALL_STATE(2179)] = 568,
  [SMALL_STATE(2180)] = 648,
  [SMALL_STATE(2181)] = 726,
  [SMALL_STATE(2182)] = 804,
  [SMALL_STATE(2183)] = 882,
  [SMALL_STATE(2184)] = 964,
  [SMALL_STATE(2185)] = 1044,
  [SMALL_STATE(2186)] = 1126,
  [SMALL_STATE(2187)] = 1201,
  [SMALL_STATE(2188)] = 1276,
  [SMALL_STATE(2189)] = 1419,
  [SMALL_STATE(2190)] = 1504,
  [SMALL_STATE(2191)] = 1647,
  [SMALL_STATE(2192)] = 1790,
  [SMALL_STATE(2193)] = 1869,
  [SMALL_STATE(2194)] = 1952,
  [SMALL_STATE(2195)] = 2031,
  [SMALL_STATE(2196)] = 2174,
  [SMALL_STATE(2197)] = 2317,
  [SMALL_STATE(2198)] = 2394,
  [SMALL_STATE(2199)] = 2472,
  [SMALL_STATE(2200)] = 2544,
  [SMALL_STATE(2201)] = 2616,
  [SMALL_STATE(2202)] = 2696,
  [SMALL_STATE(2203)] = 2770,
  [SMALL_STATE(2204)] = 2850,
  [SMALL_STATE(2205)] = 2928,
  [SMALL_STATE(2206)] = 3008,
  [SMALL_STATE(2207)] = 3080,
  [SMALL_STATE(2208)] = 3156,
  [SMALL_STATE(2209)] = 3238,
  [SMALL_STATE(2210)] = 3310,
  [SMALL_STATE(2211)] = 3392,
  [SMALL_STATE(2212)] = 3470,
  [SMALL_STATE(2213)] = 3548,
  [SMALL_STATE(2214)] = 3626,
  [SMALL_STATE(2215)] = 3698,
  [SMALL_STATE(2216)] = 3778,
  [SMALL_STATE(2217)] = 3850,
  [SMALL_STATE(2218)] = 3922,
  [SMALL_STATE(2219)] = 3998,
  [SMALL_STATE(2220)] = 4070,
  [SMALL_STATE(2221)] = 4148,
  [SMALL_STATE(2222)] = 4225,
  [SMALL_STATE(2223)] = 4300,
  [SMALL_STATE(2224)] = 4379,
  [SMALL_STATE(2225)] = 4450,
  [SMALL_STATE(2226)] = 4527,
  [SMALL_STATE(2227)] = 4598,
  [SMALL_STATE(2228)] = 4669,
  [SMALL_STATE(2229)] = 4740,
  [SMALL_STATE(2230)] = 4811,
  [SMALL_STATE(2231)] = 4882,
  [SMALL_STATE(2232)] = 4961,
  [SMALL_STATE(2233)] = 5032,
  [SMALL_STATE(2234)] = 5103,
  [SMALL_STATE(2235)] = 5174,
  [SMALL_STATE(2236)] = 5249,
  [SMALL_STATE(2237)] = 5320,
  [SMALL_STATE(2238)] = 5391,
  [SMALL_STATE(2239)] = 5462,
  [SMALL_STATE(2240)] = 5539,
  [SMALL_STATE(2241)] = 5610,
  [SMALL_STATE(2242)] = 5687,
  [SMALL_STATE(2243)] = 5762,
  [SMALL_STATE(2244)] = 5833,
  [SMALL_STATE(2245)] = 5904,
  [SMALL_STATE(2246)] = 5975,
  [SMALL_STATE(2247)] = 6050,
  [SMALL_STATE(2248)] = 6125,
  [SMALL_STATE(2249)] = 6196,
  [SMALL_STATE(2250)] = 6267,
  [SMALL_STATE(2251)] = 6344,
  [SMALL_STATE(2252)] = 6415,
  [SMALL_STATE(2253)] = 6486,
  [SMALL_STATE(2254)] = 6561,
  [SMALL_STATE(2255)] = 6632,
  [SMALL_STATE(2256)] = 6703,
  [SMALL_STATE(2257)] = 6782,
  [SMALL_STATE(2258)] = 6853,
  [SMALL_STATE(2259)] = 6924,
  [SMALL_STATE(2260)] = 6995,
  [SMALL_STATE(2261)] = 7070,
  [SMALL_STATE(2262)] = 7141,
  [SMALL_STATE(2263)] = 7213,
  [SMALL_STATE(2264)] = 7289,
  [SMALL_STATE(2265)] = 7367,
  [SMALL_STATE(2266)] = 7437,
  [SMALL_STATE(2267)] = 7513,
  [SMALL_STATE(2268)] = 7583,
  [SMALL_STATE(2269)] = 7653,
  [SMALL_STATE(2270)] = 7733,
  [SMALL_STATE(2271)] = 7847,
  [SMALL_STATE(2272)] = 7919,
  [SMALL_STATE(2273)] = 7991,
  [SMALL_STATE(2274)] = 8060,
  [SMALL_STATE(2275)] = 8129,
  [SMALL_STATE(2276)] = 8198,
  [SMALL_STATE(2277)] = 8267,
  [SMALL_STATE(2278)] = 8336,
  [SMALL_STATE(2279)] = 8405,
  [SMALL_STATE(2280)] = 8480,
  [SMALL_STATE(2281)] = 8549,
  [SMALL_STATE(2282)] = 8618,
  [SMALL_STATE(2283)] = 8689,
  [SMALL_STATE(2284)] = 8758,
  [SMALL_STATE(2285)] = 8827,
  [SMALL_STATE(2286)] = 8896,
  [SMALL_STATE(2287)] = 8965,
  [SMALL_STATE(2288)] = 9034,
  [SMALL_STATE(2289)] = 9103,
  [SMALL_STATE(2290)] = 9172,
  [SMALL_STATE(2291)] = 9241,
  [SMALL_STATE(2292)] = 9310,
  [SMALL_STATE(2293)] = 9385,
  [SMALL_STATE(2294)] = 9454,
  [SMALL_STATE(2295)] = 9523,
  [SMALL_STATE(2296)] = 9592,
  [SMALL_STATE(2297)] = 9661,
  [SMALL_STATE(2298)] = 9730,
  [SMALL_STATE(2299)] = 9799,
  [SMALL_STATE(2300)] = 9868,
  [SMALL_STATE(2301)] = 9937,
  [SMALL_STATE(2302)] = 10006,
  [SMALL_STATE(2303)] = 10081,
  [SMALL_STATE(2304)] = 10150,
  [SMALL_STATE(2305)] = 10219,
  [SMALL_STATE(2306)] = 10288,
  [SMALL_STATE(2307)] = 10357,
  [SMALL_STATE(2308)] = 10426,
  [SMALL_STATE(2309)] = 10495,
  [SMALL_STATE(2310)] = 10564,
  [SMALL_STATE(2311)] = 10639,
  [SMALL_STATE(2312)] = 10710,
  [SMALL_STATE(2313)] = 10779,
  [SMALL_STATE(2314)] = 10848,
  [SMALL_STATE(2315)] = 10917,
  [SMALL_STATE(2316)] = 10986,
  [SMALL_STATE(2317)] = 11055,
  [SMALL_STATE(2318)] = 11124,
  [SMALL_STATE(2319)] = 11193,
  [SMALL_STATE(2320)] = 11262,
  [SMALL_STATE(2321)] = 11331,
  [SMALL_STATE(2322)] = 11404,
  [SMALL_STATE(2323)] = 11473,
  [SMALL_STATE(2324)] = 11542,
  [SMALL_STATE(2325)] = 11611,
  [SMALL_STATE(2326)] = 11680,
  [SMALL_STATE(2327)] = 11749,
  [SMALL_STATE(2328)] = 11818,
  [SMALL_STATE(2329)] = 11887,
  [SMALL_STATE(2330)] = 11956,
  [SMALL_STATE(2331)] = 12025,
  [SMALL_STATE(2332)] = 12094,
  [SMALL_STATE(2333)] = 12163,
  [SMALL_STATE(2334)] = 12232,
  [SMALL_STATE(2335)] = 12301,
  [SMALL_STATE(2336)] = 12370,
  [SMALL_STATE(2337)] = 12439,
  [SMALL_STATE(2338)] = 12508,
  [SMALL_STATE(2339)] = 12579,
  [SMALL_STATE(2340)] = 12648,
  [SMALL_STATE(2341)] = 12717,
  [SMALL_STATE(2342)] = 12786,
  [SMALL_STATE(2343)] = 12855,
  [SMALL_STATE(2344)] = 12924,
  [SMALL_STATE(2345)] = 12993,
  [SMALL_STATE(2346)] = 13062,
  [SMALL_STATE(2347)] = 13131,
  [SMALL_STATE(2348)] = 13200,
  [SMALL_STATE(2349)] = 13269,
  [SMALL_STATE(2350)] = 13340,
  [SMALL_STATE(2351)] = 13409,
  [SMALL_STATE(2352)] = 13478,
  [SMALL_STATE(2353)] = 13547,
  [SMALL_STATE(2354)] = 13616,
  [SMALL_STATE(2355)] = 13685,
  [SMALL_STATE(2356)] = 13754,
  [SMALL_STATE(2357)] = 13829,
  [SMALL_STATE(2358)] = 13898,
  [SMALL_STATE(2359)] = 13967,
  [SMALL_STATE(2360)] = 14036,
  [SMALL_STATE(2361)] = 14107,
  [SMALL_STATE(2362)] = 14176,
  [SMALL_STATE(2363)] = 14245,
  [SMALL_STATE(2364)] = 14314,
  [SMALL_STATE(2365)] = 14383,
  [SMALL_STATE(2366)] = 14452,
  [SMALL_STATE(2367)] = 14521,
  [SMALL_STATE(2368)] = 14590,
  [SMALL_STATE(2369)] = 14659,
  [SMALL_STATE(2370)] = 14728,
  [SMALL_STATE(2371)] = 14797,
  [SMALL_STATE(2372)] = 14866,
  [SMALL_STATE(2373)] = 14935,
  [SMALL_STATE(2374)] = 15004,
  [SMALL_STATE(2375)] = 15073,
  [SMALL_STATE(2376)] = 15142,
  [SMALL_STATE(2377)] = 15211,
  [SMALL_STATE(2378)] = 15280,
  [SMALL_STATE(2379)] = 15349,
  [SMALL_STATE(2380)] = 15418,
  [SMALL_STATE(2381)] = 15487,
  [SMALL_STATE(2382)] = 15556,
  [SMALL_STATE(2383)] = 15625,
  [SMALL_STATE(2384)] = 15694,
  [SMALL_STATE(2385)] = 15763,
  [SMALL_STATE(2386)] = 15832,
  [SMALL_STATE(2387)] = 15901,
  [SMALL_STATE(2388)] = 15970,
  [SMALL_STATE(2389)] = 16045,
  [SMALL_STATE(2390)] = 16114,
  [SMALL_STATE(2391)] = 16183,
  [SMALL_STATE(2392)] = 16252,
  [SMALL_STATE(2393)] = 16321,
  [SMALL_STATE(2394)] = 16390,
  [SMALL_STATE(2395)] = 16459,
  [SMALL_STATE(2396)] = 16528,
  [SMALL_STATE(2397)] = 16597,
  [SMALL_STATE(2398)] = 16666,
  [SMALL_STATE(2399)] = 16735,
  [SMALL_STATE(2400)] = 16812,
  [SMALL_STATE(2401)] = 16885,
  [SMALL_STATE(2402)] = 16954,
  [SMALL_STATE(2403)] = 17023,
  [SMALL_STATE(2404)] = 17092,
  [SMALL_STATE(2405)] = 17161,
  [SMALL_STATE(2406)] = 17230,
  [SMALL_STATE(2407)] = 17299,
  [SMALL_STATE(2408)] = 17368,
  [SMALL_STATE(2409)] = 17437,
  [SMALL_STATE(2410)] = 17506,
  [SMALL_STATE(2411)] = 17581,
  [SMALL_STATE(2412)] = 17650,
  [SMALL_STATE(2413)] = 17719,
  [SMALL_STATE(2414)] = 17788,
  [SMALL_STATE(2415)] = 17857,
  [SMALL_STATE(2416)] = 17928,
  [SMALL_STATE(2417)] = 17997,
  [SMALL_STATE(2418)] = 18068,
  [SMALL_STATE(2419)] = 18137,
  [SMALL_STATE(2420)] = 18206,
  [SMALL_STATE(2421)] = 18275,
  [SMALL_STATE(2422)] = 18344,
  [SMALL_STATE(2423)] = 18413,
  [SMALL_STATE(2424)] = 18482,
  [SMALL_STATE(2425)] = 18551,
  [SMALL_STATE(2426)] = 18620,
  [SMALL_STATE(2427)] = 18689,
  [SMALL_STATE(2428)] = 18758,
  [SMALL_STATE(2429)] = 18827,
  [SMALL_STATE(2430)] = 18896,
  [SMALL_STATE(2431)] = 18965,
  [SMALL_STATE(2432)] = 19034,
  [SMALL_STATE(2433)] = 19105,
  [SMALL_STATE(2434)] = 19174,
  [SMALL_STATE(2435)] = 19243,
  [SMALL_STATE(2436)] = 19312,
  [SMALL_STATE(2437)] = 19387,
  [SMALL_STATE(2438)] = 19456,
  [SMALL_STATE(2439)] = 19556,
  [SMALL_STATE(2440)] = 19656,
  [SMALL_STATE(2441)] = 19726,
  [SMALL_STATE(2442)] = 19798,
  [SMALL_STATE(2443)] = 19898,
  [SMALL_STATE(2444)] = 19970,
  [SMALL_STATE(2445)] = 20044,
  [SMALL_STATE(2446)] = 20120,
  [SMALL_STATE(2447)] = 20194,
  [SMALL_STATE(2448)] = 20294,
  [SMALL_STATE(2449)] = 20368,
  [SMALL_STATE(2450)] = 20468,
  [SMALL_STATE(2451)] = 20544,
  [SMALL_STATE(2452)] = 20618,
  [SMALL_STATE(2453)] = 20718,
  [SMALL_STATE(2454)] = 20818,
  [SMALL_STATE(2455)] = 20918,
  [SMALL_STATE(2456)] = 21018,
  [SMALL_STATE(2457)] = 21118,
  [SMALL_STATE(2458)] = 21218,
  [SMALL_STATE(2459)] = 21292,
  [SMALL_STATE(2460)] = 21392,
  [SMALL_STATE(2461)] = 21466,
  [SMALL_STATE(2462)] = 21566,
  [SMALL_STATE(2463)] = 21666,
  [SMALL_STATE(2464)] = 21740,
  [SMALL_STATE(2465)] = 21840,
  [SMALL_STATE(2466)] = 21940,
  [SMALL_STATE(2467)] = 22040,
  [SMALL_STATE(2468)] = 22140,
  [SMALL_STATE(2469)] = 22240,
  [SMALL_STATE(2470)] = 22340,
  [SMALL_STATE(2471)] = 22440,
  [SMALL_STATE(2472)] = 22540,
  [SMALL_STATE(2473)] = 22640,
  [SMALL_STATE(2474)] = 22740,
  [SMALL_STATE(2475)] = 22811,
  [SMALL_STATE(2476)] = 22878,
  [SMALL_STATE(2477)] = 22953,
  [SMALL_STATE(2478)] = 23026,
  [SMALL_STATE(2479)] = 23129,
  [SMALL_STATE(2480)] = 23204,
  [SMALL_STATE(2481)] = 23277,
  [SMALL_STATE(2482)] = 23350,
  [SMALL_STATE(2483)] = 23419,
  [SMALL_STATE(2484)] = 23494,
  [SMALL_STATE(2485)] = 23569,
  [SMALL_STATE(2486)] = 23642,
  [SMALL_STATE(2487)] = 23711,
  [SMALL_STATE(2488)] = 23782,
  [SMALL_STATE(2489)] = 23851,
  [SMALL_STATE(2490)] = 23920,
  [SMALL_STATE(2491)] = 23988,
  [SMALL_STATE(2492)] = 24062,
  [SMALL_STATE(2493)] = 24134,
  [SMALL_STATE(2494)] = 24206,
  [SMALL_STATE(2495)] = 24280,
  [SMALL_STATE(2496)] = 24354,
  [SMALL_STATE(2497)] = 24422,
  [SMALL_STATE(2498)] = 24490,
  [SMALL_STATE(2499)] = 24560,
  [SMALL_STATE(2500)] = 24628,
  [SMALL_STATE(2501)] = 24696,
  [SMALL_STATE(2502)] = 24772,
  [SMALL_STATE(2503)] = 24846,
  [SMALL_STATE(2504)] = 24926,
  [SMALL_STATE(2505)] = 25016,
  [SMALL_STATE(2506)] = 25104,
  [SMALL_STATE(2507)] = 25172,
  [SMALL_STATE(2508)] = 25260,
  [SMALL_STATE(2509)] = 25358,
  [SMALL_STATE(2510)] = 25456,
  [SMALL_STATE(2511)] = 25552,
  [SMALL_STATE(2512)] = 25650,
  [SMALL_STATE(2513)] = 25718,
  [SMALL_STATE(2514)] = 25816,
  [SMALL_STATE(2515)] = 25914,
  [SMALL_STATE(2516)] = 26012,
  [SMALL_STATE(2517)] = 26086,
  [SMALL_STATE(2518)] = 26154,
  [SMALL_STATE(2519)] = 26254,
  [SMALL_STATE(2520)] = 26350,
  [SMALL_STATE(2521)] = 26448,
  [SMALL_STATE(2522)] = 26516,
  [SMALL_STATE(2523)] = 26616,
  [SMALL_STATE(2524)] = 26688,
  [SMALL_STATE(2525)] = 26759,
  [SMALL_STATE(2526)] = 26826,
  [SMALL_STATE(2527)] = 26933,
  [SMALL_STATE(2528)] = 27036,
  [SMALL_STATE(2529)] = 27109,
  [SMALL_STATE(2530)] = 27182,
  [SMALL_STATE(2531)] = 27247,
  [SMALL_STATE(2532)] = 27320,
  [SMALL_STATE(2533)] = 27385,
  [SMALL_STATE(2534)] = 27452,
  [SMALL_STATE(2535)] = 27523,
  [SMALL_STATE(2536)] = 27596,
  [SMALL_STATE(2537)] = 27665,
  [SMALL_STATE(2538)] = 27730,
  [SMALL_STATE(2539)] = 27799,
  [SMALL_STATE(2540)] = 27872,
  [SMALL_STATE(2541)] = 27937,
  [SMALL_STATE(2542)] = 28002,
  [SMALL_STATE(2543)] = 28067,
  [SMALL_STATE(2544)] = 28132,
  [SMALL_STATE(2545)] = 28205,
  [SMALL_STATE(2546)] = 28306,
  [SMALL_STATE(2547)] = 28394,
  [SMALL_STATE(2548)] = 28482,
  [SMALL_STATE(2549)] = 28570,
  [SMALL_STATE(2550)] = 28658,
  [SMALL_STATE(2551)] = 28746,
  [SMALL_STATE(2552)] = 28834,
  [SMALL_STATE(2553)] = 28922,
  [SMALL_STATE(2554)] = 29010,
  [SMALL_STATE(2555)] = 29098,
  [SMALL_STATE(2556)] = 29194,
  [SMALL_STATE(2557)] = 29290,
  [SMALL_STATE(2558)] = 29384,
  [SMALL_STATE(2559)] = 29480,
  [SMALL_STATE(2560)] = 29576,
  [SMALL_STATE(2561)] = 29664,
  [SMALL_STATE(2562)] = 29752,
  [SMALL_STATE(2563)] = 29840,
  [SMALL_STATE(2564)] = 29912,
  [SMALL_STATE(2565)] = 30010,
  [SMALL_STATE(2566)] = 30098,
  [SMALL_STATE(2567)] = 30186,
  [SMALL_STATE(2568)] = 30274,
  [SMALL_STATE(2569)] = 30368,
  [SMALL_STATE(2570)] = 30456,
  [SMALL_STATE(2571)] = 30544,
  [SMALL_STATE(2572)] = 30632,
  [SMALL_STATE(2573)] = 30720,
  [SMALL_STATE(2574)] = 30792,
  [SMALL_STATE(2575)] = 30862,
  [SMALL_STATE(2576)] = 30958,
  [SMALL_STATE(2577)] = 31024,
  [SMALL_STATE(2578)] = 31122,
  [SMALL_STATE(2579)] = 31210,
  [SMALL_STATE(2580)] = 31298,
  [SMALL_STATE(2581)] = 31364,
  [SMALL_STATE(2582)] = 31432,
  [SMALL_STATE(2583)] = 31498,
  [SMALL_STATE(2584)] = 31564,
  [SMALL_STATE(2585)] = 31638,
  [SMALL_STATE(2586)] = 31710,
  [SMALL_STATE(2587)] = 31788,
  [SMALL_STATE(2588)] = 31876,
  [SMALL_STATE(2589)] = 31962,
  [SMALL_STATE(2590)] = 32032,
  [SMALL_STATE(2591)] = 32118,
  [SMALL_STATE(2592)] = 32184,
  [SMALL_STATE(2593)] = 32272,
  [SMALL_STATE(2594)] = 32360,
  [SMALL_STATE(2595)] = 32448,
  [SMALL_STATE(2596)] = 32536,
  [SMALL_STATE(2597)] = 32624,
  [SMALL_STATE(2598)] = 32712,
  [SMALL_STATE(2599)] = 32786,
  [SMALL_STATE(2600)] = 32874,
  [SMALL_STATE(2601)] = 32962,
  [SMALL_STATE(2602)] = 33050,
  [SMALL_STATE(2603)] = 33138,
  [SMALL_STATE(2604)] = 33226,
  [SMALL_STATE(2605)] = 33314,
  [SMALL_STATE(2606)] = 33384,
  [SMALL_STATE(2607)] = 33472,
  [SMALL_STATE(2608)] = 33538,
  [SMALL_STATE(2609)] = 33626,
  [SMALL_STATE(2610)] = 33722,
  [SMALL_STATE(2611)] = 33810,
  [SMALL_STATE(2612)] = 33898,
  [SMALL_STATE(2613)] = 33962,
  [SMALL_STATE(2614)] = 34058,
  [SMALL_STATE(2615)] = 34146,
  [SMALL_STATE(2616)] = 34234,
  [SMALL_STATE(2617)] = 34322,
  [SMALL_STATE(2618)] = 34410,
  [SMALL_STATE(2619)] = 34498,
  [SMALL_STATE(2620)] = 34586,
  [SMALL_STATE(2621)] = 34674,
  [SMALL_STATE(2622)] = 34762,
  [SMALL_STATE(2623)] = 34850,
  [SMALL_STATE(2624)] = 34938,
  [SMALL_STATE(2625)] = 35026,
  [SMALL_STATE(2626)] = 35098,
  [SMALL_STATE(2627)] = 35183,
  [SMALL_STATE(2628)] = 35288,
  [SMALL_STATE(2629)] = 35381,
  [SMALL_STATE(2630)] = 35466,
  [SMALL_STATE(2631)] = 35533,
  [SMALL_STATE(2632)] = 35598,
  [SMALL_STATE(2633)] = 35663,
  [SMALL_STATE(2634)] = 35736,
  [SMALL_STATE(2635)] = 35807,
  [SMALL_STATE(2636)] = 35884,
  [SMALL_STATE(2637)] = 35971,
  [SMALL_STATE(2638)] = 36056,
  [SMALL_STATE(2639)] = 36125,
  [SMALL_STATE(2640)] = 36210,
  [SMALL_STATE(2641)] = 36311,
  [SMALL_STATE(2642)] = 36408,
  [SMALL_STATE(2643)] = 36479,
  [SMALL_STATE(2644)] = 36544,
  [SMALL_STATE(2645)] = 36639,
  [SMALL_STATE(2646)] = 36724,
  [SMALL_STATE(2647)] = 36789,
  [SMALL_STATE(2648)] = 36886,
  [SMALL_STATE(2649)] = 36971,
  [SMALL_STATE(2650)] = 37066,
  [SMALL_STATE(2651)] = 37161,
  [SMALL_STATE(2652)] = 37258,
  [SMALL_STATE(2653)] = 37329,
  [SMALL_STATE(2654)] = 37398,
  [SMALL_STATE(2655)] = 37463,
  [SMALL_STATE(2656)] = 37548,
  [SMALL_STATE(2657)] = 37643,
  [SMALL_STATE(2658)] = 37708,
  [SMALL_STATE(2659)] = 37793,
  [SMALL_STATE(2660)] = 37886,
  [SMALL_STATE(2661)] = 37955,
  [SMALL_STATE(2662)] = 38050,
  [SMALL_STATE(2663)] = 38115,
  [SMALL_STATE(2664)] = 38180,
  [SMALL_STATE(2665)] = 38247,
  [SMALL_STATE(2666)] = 38332,
  [SMALL_STATE(2667)] = 38403,
  [SMALL_STATE(2668)] = 38488,
  [SMALL_STATE(2669)] = 38593,
  [SMALL_STATE(2670)] = 38691,
  [SMALL_STATE(2671)] = 38755,
  [SMALL_STATE(2672)] = 38821,
  [SMALL_STATE(2673)] = 38913,
  [SMALL_STATE(2674)] = 39005,
  [SMALL_STATE(2675)] = 39095,
  [SMALL_STATE(2676)] = 39191,
  [SMALL_STATE(2677)] = 39287,
  [SMALL_STATE(2678)] = 39381,
  [SMALL_STATE(2679)] = 39445,
  [SMALL_STATE(2680)] = 39541,
  [SMALL_STATE(2681)] = 39633,
  [SMALL_STATE(2682)] = 39729,
  [SMALL_STATE(2683)] = 39795,
  [SMALL_STATE(2684)] = 39887,
  [SMALL_STATE(2685)] = 39953,
  [SMALL_STATE(2686)] = 40045,
  [SMALL_STATE(2687)] = 40109,
  [SMALL_STATE(2688)] = 40173,
  [SMALL_STATE(2689)] = 40245,
  [SMALL_STATE(2690)] = 40315,
  [SMALL_STATE(2691)] = 40391,
  [SMALL_STATE(2692)] = 40477,
  [SMALL_STATE(2693)] = 40561,
  [SMALL_STATE(2694)] = 40629,
  [SMALL_STATE(2695)] = 40713,
  [SMALL_STATE(2696)] = 40805,
  [SMALL_STATE(2697)] = 40869,
  [SMALL_STATE(2698)] = 40959,
  [SMALL_STATE(2699)] = 41027,
  [SMALL_STATE(2700)] = 41119,
  [SMALL_STATE(2701)] = 41217,
  [SMALL_STATE(2702)] = 41281,
  [SMALL_STATE(2703)] = 41350,
  [SMALL_STATE(2704)] = 41415,
  [SMALL_STATE(2705)] = 41508,
  [SMALL_STATE(2706)] = 41571,
  [SMALL_STATE(2707)] = 41666,
  [SMALL_STATE(2708)] = 41763,
  [SMALL_STATE(2709)] = 41828,
  [SMALL_STATE(2710)] = 41893,
  [SMALL_STATE(2711)] = 41994,
  [SMALL_STATE(2712)] = 42057,
  [SMALL_STATE(2713)] = 42120,
  [SMALL_STATE(2714)] = 42215,
  [SMALL_STATE(2715)] = 42278,
  [SMALL_STATE(2716)] = 42341,
  [SMALL_STATE(2717)] = 42412,
  [SMALL_STATE(2718)] = 42503,
  [SMALL_STATE(2719)] = 42596,
  [SMALL_STATE(2720)] = 42679,
  [SMALL_STATE(2721)] = 42770,
  [SMALL_STATE(2722)] = 42861,
  [SMALL_STATE(2723)] = 42924,
  [SMALL_STATE(2724)] = 42987,
  [SMALL_STATE(2725)] = 43056,
  [SMALL_STATE(2726)] = 43147,
  [SMALL_STATE(2727)] = 43210,
  [SMALL_STATE(2728)] = 43303,
  [SMALL_STATE(2729)] = 43398,
  [SMALL_STATE(2730)] = 43471,
  [SMALL_STATE(2731)] = 43564,
  [SMALL_STATE(2732)] = 43647,
  [SMALL_STATE(2733)] = 43738,
  [SMALL_STATE(2734)] = 43829,
  [SMALL_STATE(2735)] = 43892,
  [SMALL_STATE(2736)] = 43959,
  [SMALL_STATE(2737)] = 44052,
  [SMALL_STATE(2738)] = 44127,
  [SMALL_STATE(2739)] = 44220,
  [SMALL_STATE(2740)] = 44283,
  [SMALL_STATE(2741)] = 44382,
  [SMALL_STATE(2742)] = 44475,
  [SMALL_STATE(2743)] = 44560,
  [SMALL_STATE(2744)] = 44651,
  [SMALL_STATE(2745)] = 44720,
  [SMALL_STATE(2746)] = 44810,
  [SMALL_STATE(2747)] = 44904,
  [SMALL_STATE(2748)] = 44968,
  [SMALL_STATE(2749)] = 45030,
  [SMALL_STATE(2750)] = 45092,
  [SMALL_STATE(2751)] = 45162,
  [SMALL_STATE(2752)] = 45230,
  [SMALL_STATE(2753)] = 45304,
  [SMALL_STATE(2754)] = 45388,
  [SMALL_STATE(2755)] = 45470,
  [SMALL_STATE(2756)] = 45536,
  [SMALL_STATE(2757)] = 45618,
  [SMALL_STATE(2758)] = 45680,
  [SMALL_STATE(2759)] = 45744,
  [SMALL_STATE(2760)] = 45808,
  [SMALL_STATE(2761)] = 45872,
  [SMALL_STATE(2762)] = 45966,
  [SMALL_STATE(2763)] = 46028,
  [SMALL_STATE(2764)] = 46124,
  [SMALL_STATE(2765)] = 46190,
  [SMALL_STATE(2766)] = 46252,
  [SMALL_STATE(2767)] = 46342,
  [SMALL_STATE(2768)] = 46432,
  [SMALL_STATE(2769)] = 46520,
  [SMALL_STATE(2770)] = 46610,
  [SMALL_STATE(2771)] = 46702,
  [SMALL_STATE(2772)] = 46792,
  [SMALL_STATE(2773)] = 46882,
  [SMALL_STATE(2774)] = 46950,
  [SMALL_STATE(2775)] = 47038,
  [SMALL_STATE(2776)] = 47132,
  [SMALL_STATE(2777)] = 47226,
  [SMALL_STATE(2778)] = 47324,
  [SMALL_STATE(2779)] = 47414,
  [SMALL_STATE(2780)] = 47484,
  [SMALL_STATE(2781)] = 47580,
  [SMALL_STATE(2782)] = 47642,
  [SMALL_STATE(2783)] = 47705,
  [SMALL_STATE(2784)] = 47770,
  [SMALL_STATE(2785)] = 47861,
  [SMALL_STATE(2786)] = 47928,
  [SMALL_STATE(2787)] = 48019,
  [SMALL_STATE(2788)] = 48110,
  [SMALL_STATE(2789)] = 48205,
  [SMALL_STATE(2790)] = 48294,
  [SMALL_STATE(2791)] = 48385,
  [SMALL_STATE(2792)] = 48476,
  [SMALL_STATE(2793)] = 48567,
  [SMALL_STATE(2794)] = 48632,
  [SMALL_STATE(2795)] = 48693,
  [SMALL_STATE(2796)] = 48786,
  [SMALL_STATE(2797)] = 48875,
  [SMALL_STATE(2798)] = 48966,
  [SMALL_STATE(2799)] = 49059,
  [SMALL_STATE(2800)] = 49120,
  [SMALL_STATE(2801)] = 49183,
  [SMALL_STATE(2802)] = 49272,
  [SMALL_STATE(2803)] = 49333,
  [SMALL_STATE(2804)] = 49396,
  [SMALL_STATE(2805)] = 49457,
  [SMALL_STATE(2806)] = 49518,
  [SMALL_STATE(2807)] = 49587,
  [SMALL_STATE(2808)] = 49654,
  [SMALL_STATE(2809)] = 49727,
  [SMALL_STATE(2810)] = 49810,
  [SMALL_STATE(2811)] = 49891,
  [SMALL_STATE(2812)] = 49956,
  [SMALL_STATE(2813)] = 50037,
  [SMALL_STATE(2814)] = 50098,
  [SMALL_STATE(2815)] = 50187,
  [SMALL_STATE(2816)] = 50250,
  [SMALL_STATE(2817)] = 50343,
  [SMALL_STATE(2818)] = 50406,
  [SMALL_STATE(2819)] = 50471,
  [SMALL_STATE(2820)] = 50532,
  [SMALL_STATE(2821)] = 50593,
  [SMALL_STATE(2822)] = 50662,
  [SMALL_STATE(2823)] = 50729,
  [SMALL_STATE(2824)] = 50802,
  [SMALL_STATE(2825)] = 50885,
  [SMALL_STATE(2826)] = 50966,
  [SMALL_STATE(2827)] = 51031,
  [SMALL_STATE(2828)] = 51112,
  [SMALL_STATE(2829)] = 51173,
  [SMALL_STATE(2830)] = 51236,
  [SMALL_STATE(2831)] = 51297,
  [SMALL_STATE(2832)] = 51360,
  [SMALL_STATE(2833)] = 51453,
  [SMALL_STATE(2834)] = 51540,
  [SMALL_STATE(2835)] = 51629,
  [SMALL_STATE(2836)] = 51718,
  [SMALL_STATE(2837)] = 51807,
  [SMALL_STATE(2838)] = 51896,
  [SMALL_STATE(2839)] = 51959,
  [SMALL_STATE(2840)] = 52026,
  [SMALL_STATE(2841)] = 52113,
  [SMALL_STATE(2842)] = 52202,
  [SMALL_STATE(2843)] = 52269,
  [SMALL_STATE(2844)] = 52336,
  [SMALL_STATE(2845)] = 52427,
  [SMALL_STATE(2846)] = 52490,
  [SMALL_STATE(2847)] = 52579,
  [SMALL_STATE(2848)] = 52668,
  [SMALL_STATE(2849)] = 52733,
  [SMALL_STATE(2850)] = 52800,
  [SMALL_STATE(2851)] = 52893,
  [SMALL_STATE(2852)] = 52956,
  [SMALL_STATE(2853)] = 53045,
  [SMALL_STATE(2854)] = 53105,
  [SMALL_STATE(2855)] = 53201,
  [SMALL_STATE(2856)] = 53291,
  [SMALL_STATE(2857)] = 53379,
  [SMALL_STATE(2858)] = 53441,
  [SMALL_STATE(2859)] = 53501,
  [SMALL_STATE(2860)] = 53591,
  [SMALL_STATE(2861)] = 53651,
  [SMALL_STATE(2862)] = 53713,
  [SMALL_STATE(2863)] = 53801,
  [SMALL_STATE(2864)] = 53881,
  [SMALL_STATE(2865)] = 53945,
  [SMALL_STATE(2866)] = 54025,
  [SMALL_STATE(2867)] = 54085,
  [SMALL_STATE(2868)] = 54151,
  [SMALL_STATE(2869)] = 54243,
  [SMALL_STATE(2870)] = 54309,
  [SMALL_STATE(2871)] = 54397,
  [SMALL_STATE(2872)] = 54487,
  [SMALL_STATE(2873)] = 54577,
  [SMALL_STATE(2874)] = 54671,
  [SMALL_STATE(2875)] = 54729,
  [SMALL_STATE(2876)] = 54791,
  [SMALL_STATE(2877)] = 54851,
  [SMALL_STATE(2878)] = 54919,
  [SMALL_STATE(2879)] = 54979,
  [SMALL_STATE(2880)] = 55041,
  [SMALL_STATE(2881)] = 55101,
  [SMALL_STATE(2882)] = 55161,
  [SMALL_STATE(2883)] = 55229,
  [SMALL_STATE(2884)] = 55295,
  [SMALL_STATE(2885)] = 55355,
  [SMALL_STATE(2886)] = 55449,
  [SMALL_STATE(2887)] = 55507,
  [SMALL_STATE(2888)] = 55565,
  [SMALL_STATE(2889)] = 55623,
  [SMALL_STATE(2890)] = 55721,
  [SMALL_STATE(2891)] = 55793,
  [SMALL_STATE(2892)] = 55851,
  [SMALL_STATE(2893)] = 55911,
  [SMALL_STATE(2894)] = 55969,
  [SMALL_STATE(2895)] = 56029,
  [SMALL_STATE(2896)] = 56121,
  [SMALL_STATE(2897)] = 56181,
  [SMALL_STATE(2898)] = 56263,
  [SMALL_STATE(2899)] = 56353,
  [SMALL_STATE(2900)] = 56411,
  [SMALL_STATE(2901)] = 56468,
  [SMALL_STATE(2902)] = 56525,
  [SMALL_STATE(2903)] = 56582,
  [SMALL_STATE(2904)] = 56671,
  [SMALL_STATE(2905)] = 56728,
  [SMALL_STATE(2906)] = 56785,
  [SMALL_STATE(2907)] = 56842,
  [SMALL_STATE(2908)] = 56909,
  [SMALL_STATE(2909)] = 56998,
  [SMALL_STATE(2910)] = 57055,
  [SMALL_STATE(2911)] = 57112,
  [SMALL_STATE(2912)] = 57169,
  [SMALL_STATE(2913)] = 57226,
  [SMALL_STATE(2914)] = 57283,
  [SMALL_STATE(2915)] = 57340,
  [SMALL_STATE(2916)] = 57397,
  [SMALL_STATE(2917)] = 57454,
  [SMALL_STATE(2918)] = 57511,
  [SMALL_STATE(2919)] = 57568,
  [SMALL_STATE(2920)] = 57625,
  [SMALL_STATE(2921)] = 57682,
  [SMALL_STATE(2922)] = 57739,
  [SMALL_STATE(2923)] = 57796,
  [SMALL_STATE(2924)] = 57853,
  [SMALL_STATE(2925)] = 57910,
  [SMALL_STATE(2926)] = 57967,
  [SMALL_STATE(2927)] = 58024,
  [SMALL_STATE(2928)] = 58081,
  [SMALL_STATE(2929)] = 58138,
  [SMALL_STATE(2930)] = 58195,
  [SMALL_STATE(2931)] = 58252,
  [SMALL_STATE(2932)] = 58309,
  [SMALL_STATE(2933)] = 58366,
  [SMALL_STATE(2934)] = 58423,
  [SMALL_STATE(2935)] = 58480,
  [SMALL_STATE(2936)] = 58537,
  [SMALL_STATE(2937)] = 58594,
  [SMALL_STATE(2938)] = 58651,
  [SMALL_STATE(2939)] = 58708,
  [SMALL_STATE(2940)] = 58765,
  [SMALL_STATE(2941)] = 58822,
  [SMALL_STATE(2942)] = 58911,
  [SMALL_STATE(2943)] = 59000,
  [SMALL_STATE(2944)] = 59057,
  [SMALL_STATE(2945)] = 59114,
  [SMALL_STATE(2946)] = 59171,
  [SMALL_STATE(2947)] = 59228,
  [SMALL_STATE(2948)] = 59317,
  [SMALL_STATE(2949)] = 59406,
  [SMALL_STATE(2950)] = 59499,
  [SMALL_STATE(2951)] = 59556,
  [SMALL_STATE(2952)] = 59613,
  [SMALL_STATE(2953)] = 59678,
  [SMALL_STATE(2954)] = 59765,
  [SMALL_STATE(2955)] = 59858,
  [SMALL_STATE(2956)] = 59951,
  [SMALL_STATE(2957)] = 60008,
  [SMALL_STATE(2958)] = 60065,
  [SMALL_STATE(2959)] = 60122,
  [SMALL_STATE(2960)] = 60179,
  [SMALL_STATE(2961)] = 60236,
  [SMALL_STATE(2962)] = 60295,
  [SMALL_STATE(2963)] = 60352,
  [SMALL_STATE(2964)] = 60409,
  [SMALL_STATE(2965)] = 60466,
  [SMALL_STATE(2966)] = 60523,
  [SMALL_STATE(2967)] = 60580,
  [SMALL_STATE(2968)] = 60637,
  [SMALL_STATE(2969)] = 60694,
  [SMALL_STATE(2970)] = 60751,
  [SMALL_STATE(2971)] = 60808,
  [SMALL_STATE(2972)] = 60867,
  [SMALL_STATE(2973)] = 60924,
  [SMALL_STATE(2974)] = 60981,
  [SMALL_STATE(2975)] = 61038,
  [SMALL_STATE(2976)] = 61095,
  [SMALL_STATE(2977)] = 61152,
  [SMALL_STATE(2978)] = 61209,
  [SMALL_STATE(2979)] = 61266,
  [SMALL_STATE(2980)] = 61323,
  [SMALL_STATE(2981)] = 61388,
  [SMALL_STATE(2982)] = 61475,
  [SMALL_STATE(2983)] = 61536,
  [SMALL_STATE(2984)] = 61625,
  [SMALL_STATE(2985)] = 61720,
  [SMALL_STATE(2986)] = 61811,
  [SMALL_STATE(2987)] = 61868,
  [SMALL_STATE(2988)] = 61925,
  [SMALL_STATE(2989)] = 61982,
  [SMALL_STATE(2990)] = 62039,
  [SMALL_STATE(2991)] = 62102,
  [SMALL_STATE(2992)] = 62159,
  [SMALL_STATE(2993)] = 62218,
  [SMALL_STATE(2994)] = 62275,
  [SMALL_STATE(2995)] = 62332,
  [SMALL_STATE(2996)] = 62399,
  [SMALL_STATE(2997)] = 62456,
  [SMALL_STATE(2998)] = 62545,
  [SMALL_STATE(2999)] = 62634,
  [SMALL_STATE(3000)] = 62691,
  [SMALL_STATE(3001)] = 62748,
  [SMALL_STATE(3002)] = 62805,
  [SMALL_STATE(3003)] = 62862,
  [SMALL_STATE(3004)] = 62919,
  [SMALL_STATE(3005)] = 62976,
  [SMALL_STATE(3006)] = 63033,
  [SMALL_STATE(3007)] = 63090,
  [SMALL_STATE(3008)] = 63147,
  [SMALL_STATE(3009)] = 63204,
  [SMALL_STATE(3010)] = 63265,
  [SMALL_STATE(3011)] = 63322,
  [SMALL_STATE(3012)] = 63379,
  [SMALL_STATE(3013)] = 63436,
  [SMALL_STATE(3014)] = 63493,
  [SMALL_STATE(3015)] = 63550,
  [SMALL_STATE(3016)] = 63607,
  [SMALL_STATE(3017)] = 63664,
  [SMALL_STATE(3018)] = 63725,
  [SMALL_STATE(3019)] = 63782,
  [SMALL_STATE(3020)] = 63839,
  [SMALL_STATE(3021)] = 63896,
  [SMALL_STATE(3022)] = 63953,
  [SMALL_STATE(3023)] = 64010,
  [SMALL_STATE(3024)] = 64075,
  [SMALL_STATE(3025)] = 64132,
  [SMALL_STATE(3026)] = 64189,
  [SMALL_STATE(3027)] = 64246,
  [SMALL_STATE(3028)] = 64303,
  [SMALL_STATE(3029)] = 64370,
  [SMALL_STATE(3030)] = 64427,
  [SMALL_STATE(3031)] = 64484,
  [SMALL_STATE(3032)] = 64541,
  [SMALL_STATE(3033)] = 64606,
  [SMALL_STATE(3034)] = 64663,
  [SMALL_STATE(3035)] = 64720,
  [SMALL_STATE(3036)] = 64777,
  [SMALL_STATE(3037)] = 64848,
  [SMALL_STATE(3038)] = 64905,
  [SMALL_STATE(3039)] = 64962,
  [SMALL_STATE(3040)] = 65043,
  [SMALL_STATE(3041)] = 65122,
  [SMALL_STATE(3042)] = 65185,
  [SMALL_STATE(3043)] = 65264,
  [SMALL_STATE(3044)] = 65321,
  [SMALL_STATE(3045)] = 65378,
  [SMALL_STATE(3046)] = 65435,
  [SMALL_STATE(3047)] = 65494,
  [SMALL_STATE(3048)] = 65551,
  [SMALL_STATE(3049)] = 65608,
  [SMALL_STATE(3050)] = 65665,
  [SMALL_STATE(3051)] = 65722,
  [SMALL_STATE(3052)] = 65779,
  [SMALL_STATE(3053)] = 65868,
  [SMALL_STATE(3054)] = 65957,
  [SMALL_STATE(3055)] = 66044,
  [SMALL_STATE(3056)] = 66133,
  [SMALL_STATE(3057)] = 66222,
  [SMALL_STATE(3058)] = 66313,
  [SMALL_STATE(3059)] = 66400,
  [SMALL_STATE(3060)] = 66489,
  [SMALL_STATE(3061)] = 66546,
  [SMALL_STATE(3062)] = 66637,
  [SMALL_STATE(3063)] = 66694,
  [SMALL_STATE(3064)] = 66751,
  [SMALL_STATE(3065)] = 66808,
  [SMALL_STATE(3066)] = 66865,
  [SMALL_STATE(3067)] = 66922,
  [SMALL_STATE(3068)] = 66979,
  [SMALL_STATE(3069)] = 67036,
  [SMALL_STATE(3070)] = 67093,
  [SMALL_STATE(3071)] = 67150,
  [SMALL_STATE(3072)] = 67207,
  [SMALL_STATE(3073)] = 67264,
  [SMALL_STATE(3074)] = 67329,
  [SMALL_STATE(3075)] = 67388,
  [SMALL_STATE(3076)] = 67447,
  [SMALL_STATE(3077)] = 67508,
  [SMALL_STATE(3078)] = 67567,
  [SMALL_STATE(3079)] = 67626,
  [SMALL_STATE(3080)] = 67693,
  [SMALL_STATE(3081)] = 67758,
  [SMALL_STATE(3082)] = 67829,
  [SMALL_STATE(3083)] = 67910,
  [SMALL_STATE(3084)] = 67989,
  [SMALL_STATE(3085)] = 68052,
  [SMALL_STATE(3086)] = 68131,
  [SMALL_STATE(3087)] = 68190,
  [SMALL_STATE(3088)] = 68249,
  [SMALL_STATE(3089)] = 68306,
  [SMALL_STATE(3090)] = 68363,
  [SMALL_STATE(3091)] = 68420,
  [SMALL_STATE(3092)] = 68477,
  [SMALL_STATE(3093)] = 68534,
  [SMALL_STATE(3094)] = 68627,
  [SMALL_STATE(3095)] = 68684,
  [SMALL_STATE(3096)] = 68741,
  [SMALL_STATE(3097)] = 68798,
  [SMALL_STATE(3098)] = 68855,
  [SMALL_STATE(3099)] = 68912,
  [SMALL_STATE(3100)] = 68969,
  [SMALL_STATE(3101)] = 69026,
  [SMALL_STATE(3102)] = 69083,
  [SMALL_STATE(3103)] = 69140,
  [SMALL_STATE(3104)] = 69197,
  [SMALL_STATE(3105)] = 69254,
  [SMALL_STATE(3106)] = 69311,
  [SMALL_STATE(3107)] = 69383,
  [SMALL_STATE(3108)] = 69445,
  [SMALL_STATE(3109)] = 69519,
  [SMALL_STATE(3110)] = 69593,
  [SMALL_STATE(3111)] = 69667,
  [SMALL_STATE(3112)] = 69745,
  [SMALL_STATE(3113)] = 69803,
  [SMALL_STATE(3114)] = 69863,
  [SMALL_STATE(3115)] = 69925,
  [SMALL_STATE(3116)] = 70011,
  [SMALL_STATE(3117)] = 70085,
  [SMALL_STATE(3118)] = 70147,
  [SMALL_STATE(3119)] = 70233,
  [SMALL_STATE(3120)] = 70321,
  [SMALL_STATE(3121)] = 70377,
  [SMALL_STATE(3122)] = 70449,
  [SMALL_STATE(3123)] = 70521,
  [SMALL_STATE(3124)] = 70595,
  [SMALL_STATE(3125)] = 70667,
  [SMALL_STATE(3126)] = 70759,
  [SMALL_STATE(3127)] = 70817,
  [SMALL_STATE(3128)] = 70875,
  [SMALL_STATE(3129)] = 70949,
  [SMALL_STATE(3130)] = 71005,
  [SMALL_STATE(3131)] = 71093,
  [SMALL_STATE(3132)] = 71167,
  [SMALL_STATE(3133)] = 71225,
  [SMALL_STATE(3134)] = 71299,
  [SMALL_STATE(3135)] = 71395,
  [SMALL_STATE(3136)] = 71453,
  [SMALL_STATE(3137)] = 71527,
  [SMALL_STATE(3138)] = 71585,
  [SMALL_STATE(3139)] = 71643,
  [SMALL_STATE(3140)] = 71707,
  [SMALL_STATE(3141)] = 71797,
  [SMALL_STATE(3142)] = 71891,
  [SMALL_STATE(3143)] = 71949,
  [SMALL_STATE(3144)] = 72037,
  [SMALL_STATE(3145)] = 72095,
  [SMALL_STATE(3146)] = 72167,
  [SMALL_STATE(3147)] = 72241,
  [SMALL_STATE(3148)] = 72313,
  [SMALL_STATE(3149)] = 72387,
  [SMALL_STATE(3150)] = 72461,
  [SMALL_STATE(3151)] = 72549,
  [SMALL_STATE(3152)] = 72637,
  [SMALL_STATE(3153)] = 72699,
  [SMALL_STATE(3154)] = 72757,
  [SMALL_STATE(3155)] = 72829,
  [SMALL_STATE(3156)] = 72885,
  [SMALL_STATE(3157)] = 72959,
  [SMALL_STATE(3158)] = 73023,
  [SMALL_STATE(3159)] = 73113,
  [SMALL_STATE(3160)] = 73173,
  [SMALL_STATE(3161)] = 73231,
  [SMALL_STATE(3162)] = 73289,
  [SMALL_STATE(3163)] = 73361,
  [SMALL_STATE(3164)] = 73427,
  [SMALL_STATE(3165)] = 73491,
  [SMALL_STATE(3166)] = 73565,
  [SMALL_STATE(3167)] = 73621,
  [SMALL_STATE(3168)] = 73693,
  [SMALL_STATE(3169)] = 73767,
  [SMALL_STATE(3170)] = 73865,
  [SMALL_STATE(3171)] = 73937,
  [SMALL_STATE(3172)] = 74011,
  [SMALL_STATE(3173)] = 74069,
  [SMALL_STATE(3174)] = 74141,
  [SMALL_STATE(3175)] = 74211,
  [SMALL_STATE(3176)] = 74271,
  [SMALL_STATE(3177)] = 74345,
  [SMALL_STATE(3178)] = 74417,
  [SMALL_STATE(3179)] = 74497,
  [SMALL_STATE(3180)] = 74563,
  [SMALL_STATE(3181)] = 74655,
  [SMALL_STATE(3182)] = 74733,
  [SMALL_STATE(3183)] = 74791,
  [SMALL_STATE(3184)] = 74882,
  [SMALL_STATE(3185)] = 74969,
  [SMALL_STATE(3186)] = 75058,
  [SMALL_STATE(3187)] = 75145,
  [SMALL_STATE(3188)] = 75232,
  [SMALL_STATE(3189)] = 75321,
  [SMALL_STATE(3190)] = 75380,
  [SMALL_STATE(3191)] = 75435,
  [SMALL_STATE(3192)] = 75526,
  [SMALL_STATE(3193)] = 75581,
  [SMALL_STATE(3194)] = 75636,
  [SMALL_STATE(3195)] = 75691,
  [SMALL_STATE(3196)] = 75782,
  [SMALL_STATE(3197)] = 75845,
  [SMALL_STATE(3198)] = 75930,
  [SMALL_STATE(3199)] = 76021,
  [SMALL_STATE(3200)] = 76108,
  [SMALL_STATE(3201)] = 76165,
  [SMALL_STATE(3202)] = 76252,
  [SMALL_STATE(3203)] = 76339,
  [SMALL_STATE(3204)] = 76426,
  [SMALL_STATE(3205)] = 76481,
  [SMALL_STATE(3206)] = 76536,
  [SMALL_STATE(3207)] = 76593,
  [SMALL_STATE(3208)] = 76652,
  [SMALL_STATE(3209)] = 76709,
  [SMALL_STATE(3210)] = 76766,
  [SMALL_STATE(3211)] = 76857,
  [SMALL_STATE(3212)] = 76948,
  [SMALL_STATE(3213)] = 77003,
  [SMALL_STATE(3214)] = 77060,
  [SMALL_STATE(3215)] = 77149,
  [SMALL_STATE(3216)] = 77204,
  [SMALL_STATE(3217)] = 77291,
  [SMALL_STATE(3218)] = 77346,
  [SMALL_STATE(3219)] = 77407,
  [SMALL_STATE(3220)] = 77464,
  [SMALL_STATE(3221)] = 77551,
  [SMALL_STATE(3222)] = 77606,
  [SMALL_STATE(3223)] = 77693,
  [SMALL_STATE(3224)] = 77778,
  [SMALL_STATE(3225)] = 77865,
  [SMALL_STATE(3226)] = 77928,
  [SMALL_STATE(3227)] = 77991,
  [SMALL_STATE(3228)] = 78050,
  [SMALL_STATE(3229)] = 78107,
  [SMALL_STATE(3230)] = 78194,
  [SMALL_STATE(3231)] = 78251,
  [SMALL_STATE(3232)] = 78344,
  [SMALL_STATE(3233)] = 78403,
  [SMALL_STATE(3234)] = 78460,
  [SMALL_STATE(3235)] = 78517,
  [SMALL_STATE(3236)] = 78582,
  [SMALL_STATE(3237)] = 78673,
  [SMALL_STATE(3238)] = 78736,
  [SMALL_STATE(3239)] = 78799,
  [SMALL_STATE(3240)] = 78868,
  [SMALL_STATE(3241)] = 78947,
  [SMALL_STATE(3242)] = 79024,
  [SMALL_STATE(3243)] = 79085,
  [SMALL_STATE(3244)] = 79162,
  [SMALL_STATE(3245)] = 79253,
  [SMALL_STATE(3246)] = 79331,
  [SMALL_STATE(3247)] = 79387,
  [SMALL_STATE(3248)] = 79473,
  [SMALL_STATE(3249)] = 79561,
  [SMALL_STATE(3250)] = 79623,
  [SMALL_STATE(3251)] = 79681,
  [SMALL_STATE(3252)] = 79737,
  [SMALL_STATE(3253)] = 79793,
  [SMALL_STATE(3254)] = 79857,
  [SMALL_STATE(3255)] = 79919,
  [SMALL_STATE(3256)] = 79987,
  [SMALL_STATE(3257)] = 80065,
  [SMALL_STATE(3258)] = 80141,
  [SMALL_STATE(3259)] = 80201,
  [SMALL_STATE(3260)] = 80277,
  [SMALL_STATE(3261)] = 80333,
  [SMALL_STATE(3262)] = 80421,
  [SMALL_STATE(3263)] = 80507,
  [SMALL_STATE(3264)] = 80565,
  [SMALL_STATE(3265)] = 80633,
  [SMALL_STATE(3266)] = 80719,
  [SMALL_STATE(3267)] = 80811,
  [SMALL_STATE(3268)] = 80897,
  [SMALL_STATE(3269)] = 80985,
  [SMALL_STATE(3270)] = 81041,
  [SMALL_STATE(3271)] = 81097,
  [SMALL_STATE(3272)] = 81153,
  [SMALL_STATE(3273)] = 81239,
  [SMALL_STATE(3274)] = 81293,
  [SMALL_STATE(3275)] = 81351,
  [SMALL_STATE(3276)] = 81407,
  [SMALL_STATE(3277)] = 81463,
  [SMALL_STATE(3278)] = 81549,
  [SMALL_STATE(3279)] = 81607,
  [SMALL_STATE(3280)] = 81693,
  [SMALL_STATE(3281)] = 81779,
  [SMALL_STATE(3282)] = 81835,
  [SMALL_STATE(3283)] = 81891,
  [SMALL_STATE(3284)] = 81947,
  [SMALL_STATE(3285)] = 82005,
  [SMALL_STATE(3286)] = 82093,
  [SMALL_STATE(3287)] = 82151,
  [SMALL_STATE(3288)] = 82213,
  [SMALL_STATE(3289)] = 82301,
  [SMALL_STATE(3290)] = 82357,
  [SMALL_STATE(3291)] = 82441,
  [SMALL_STATE(3292)] = 82497,
  [SMALL_STATE(3293)] = 82581,
  [SMALL_STATE(3294)] = 82671,
  [SMALL_STATE(3295)] = 82729,
  [SMALL_STATE(3296)] = 82785,
  [SMALL_STATE(3297)] = 82841,
  [SMALL_STATE(3298)] = 82905,
  [SMALL_STATE(3299)] = 82967,
  [SMALL_STATE(3300)] = 83035,
  [SMALL_STATE(3301)] = 83125,
  [SMALL_STATE(3302)] = 83201,
  [SMALL_STATE(3303)] = 83261,
  [SMALL_STATE(3304)] = 83337,
  [SMALL_STATE(3305)] = 83393,
  [SMALL_STATE(3306)] = 83481,
  [SMALL_STATE(3307)] = 83543,
  [SMALL_STATE(3308)] = 83629,
  [SMALL_STATE(3309)] = 83715,
  [SMALL_STATE(3310)] = 83809,
  [SMALL_STATE(3311)] = 83865,
  [SMALL_STATE(3312)] = 83949,
  [SMALL_STATE(3313)] = 84035,
  [SMALL_STATE(3314)] = 84093,
  [SMALL_STATE(3315)] = 84149,
  [SMALL_STATE(3316)] = 84205,
  [SMALL_STATE(3317)] = 84269,
  [SMALL_STATE(3318)] = 84325,
  [SMALL_STATE(3319)] = 84393,
  [SMALL_STATE(3320)] = 84471,
  [SMALL_STATE(3321)] = 84547,
  [SMALL_STATE(3322)] = 84607,
  [SMALL_STATE(3323)] = 84683,
  [SMALL_STATE(3324)] = 84739,
  [SMALL_STATE(3325)] = 84825,
  [SMALL_STATE(3326)] = 84913,
  [SMALL_STATE(3327)] = 84991,
  [SMALL_STATE(3328)] = 85067,
  [SMALL_STATE(3329)] = 85123,
  [SMALL_STATE(3330)] = 85179,
  [SMALL_STATE(3331)] = 85265,
  [SMALL_STATE(3332)] = 85351,
  [SMALL_STATE(3333)] = 85435,
  [SMALL_STATE(3334)] = 85521,
  [SMALL_STATE(3335)] = 85607,
  [SMALL_STATE(3336)] = 85673,
  [SMALL_STATE(3337)] = 85729,
  [SMALL_STATE(3338)] = 85789,
  [SMALL_STATE(3339)] = 85865,
  [SMALL_STATE(3340)] = 85955,
  [SMALL_STATE(3341)] = 86015,
  [SMALL_STATE(3342)] = 86071,
  [SMALL_STATE(3343)] = 86159,
  [SMALL_STATE(3344)] = 86247,
  [SMALL_STATE(3345)] = 86303,
  [SMALL_STATE(3346)] = 86369,
  [SMALL_STATE(3347)] = 86459,
  [SMALL_STATE(3348)] = 86515,
  [SMALL_STATE(3349)] = 86571,
  [SMALL_STATE(3350)] = 86627,
  [SMALL_STATE(3351)] = 86719,
  [SMALL_STATE(3352)] = 86775,
  [SMALL_STATE(3353)] = 86831,
  [SMALL_STATE(3354)] = 86919,
  [SMALL_STATE(3355)] = 86975,
  [SMALL_STATE(3356)] = 87061,
  [SMALL_STATE(3357)] = 87147,
  [SMALL_STATE(3358)] = 87233,
  [SMALL_STATE(3359)] = 87295,
  [SMALL_STATE(3360)] = 87361,
  [SMALL_STATE(3361)] = 87417,
  [SMALL_STATE(3362)] = 87481,
  [SMALL_STATE(3363)] = 87537,
  [SMALL_STATE(3364)] = 87623,
  [SMALL_STATE(3365)] = 87679,
  [SMALL_STATE(3366)] = 87765,
  [SMALL_STATE(3367)] = 87849,
  [SMALL_STATE(3368)] = 87905,
  [SMALL_STATE(3369)] = 87989,
  [SMALL_STATE(3370)] = 88079,
  [SMALL_STATE(3371)] = 88163,
  [SMALL_STATE(3372)] = 88249,
  [SMALL_STATE(3373)] = 88335,
  [SMALL_STATE(3374)] = 88421,
  [SMALL_STATE(3375)] = 88505,
  [SMALL_STATE(3376)] = 88591,
  [SMALL_STATE(3377)] = 88677,
  [SMALL_STATE(3378)] = 88769,
  [SMALL_STATE(3379)] = 88831,
  [SMALL_STATE(3380)] = 88920,
  [SMALL_STATE(3381)] = 89005,
  [SMALL_STATE(3382)] = 89088,
  [SMALL_STATE(3383)] = 89143,
  [SMALL_STATE(3384)] = 89226,
  [SMALL_STATE(3385)] = 89279,
  [SMALL_STATE(3386)] = 89336,
  [SMALL_STATE(3387)] = 89391,
  [SMALL_STATE(3388)] = 89448,
  [SMALL_STATE(3389)] = 89503,
  [SMALL_STATE(3390)] = 89558,
  [SMALL_STATE(3391)] = 89621,
  [SMALL_STATE(3392)] = 89682,
  [SMALL_STATE(3393)] = 89749,
  [SMALL_STATE(3394)] = 89826,
  [SMALL_STATE(3395)] = 89901,
  [SMALL_STATE(3396)] = 89960,
  [SMALL_STATE(3397)] = 90035,
  [SMALL_STATE(3398)] = 90090,
  [SMALL_STATE(3399)] = 90145,
  [SMALL_STATE(3400)] = 90208,
  [SMALL_STATE(3401)] = 90269,
  [SMALL_STATE(3402)] = 90354,
  [SMALL_STATE(3403)] = 90421,
  [SMALL_STATE(3404)] = 90498,
  [SMALL_STATE(3405)] = 90573,
  [SMALL_STATE(3406)] = 90632,
  [SMALL_STATE(3407)] = 90707,
  [SMALL_STATE(3408)] = 90762,
  [SMALL_STATE(3409)] = 90847,
  [SMALL_STATE(3410)] = 90932,
  [SMALL_STATE(3411)] = 91017,
  [SMALL_STATE(3412)] = 91102,
  [SMALL_STATE(3413)] = 91185,
  [SMALL_STATE(3414)] = 91270,
  [SMALL_STATE(3415)] = 91355,
  [SMALL_STATE(3416)] = 91448,
  [SMALL_STATE(3417)] = 91533,
  [SMALL_STATE(3418)] = 91618,
  [SMALL_STATE(3419)] = 91711,
  [SMALL_STATE(3420)] = 91770,
  [SMALL_STATE(3421)] = 91825,
  [SMALL_STATE(3422)] = 91880,
  [SMALL_STATE(3423)] = 91965,
  [SMALL_STATE(3424)] = 92018,
  [SMALL_STATE(3425)] = 92073,
  [SMALL_STATE(3426)] = 92134,
  [SMALL_STATE(3427)] = 92227,
  [SMALL_STATE(3428)] = 92312,
  [SMALL_STATE(3429)] = 92365,
  [SMALL_STATE(3430)] = 92422,
  [SMALL_STATE(3431)] = 92509,
  [SMALL_STATE(3432)] = 92592,
  [SMALL_STATE(3433)] = 92673,
  [SMALL_STATE(3434)] = 92756,
  [SMALL_STATE(3435)] = 92841,
  [SMALL_STATE(3436)] = 92924,
  [SMALL_STATE(3437)] = 93007,
  [SMALL_STATE(3438)] = 93062,
  [SMALL_STATE(3439)] = 93143,
  [SMALL_STATE(3440)] = 93230,
  [SMALL_STATE(3441)] = 93317,
  [SMALL_STATE(3442)] = 93370,
  [SMALL_STATE(3443)] = 93455,
  [SMALL_STATE(3444)] = 93542,
  [SMALL_STATE(3445)] = 93599,
  [SMALL_STATE(3446)] = 93654,
  [SMALL_STATE(3447)] = 93709,
  [SMALL_STATE(3448)] = 93772,
  [SMALL_STATE(3449)] = 93833,
  [SMALL_STATE(3450)] = 93900,
  [SMALL_STATE(3451)] = 93977,
  [SMALL_STATE(3452)] = 94052,
  [SMALL_STATE(3453)] = 94111,
  [SMALL_STATE(3454)] = 94186,
  [SMALL_STATE(3455)] = 94241,
  [SMALL_STATE(3456)] = 94298,
  [SMALL_STATE(3457)] = 94383,
  [SMALL_STATE(3458)] = 94468,
  [SMALL_STATE(3459)] = 94523,
  [SMALL_STATE(3460)] = 94606,
  [SMALL_STATE(3461)] = 94691,
  [SMALL_STATE(3462)] = 94784,
  [SMALL_STATE(3463)] = 94839,
  [SMALL_STATE(3464)] = 94892,
  [SMALL_STATE(3465)] = 94979,
  [SMALL_STATE(3466)] = 95034,
  [SMALL_STATE(3467)] = 95093,
  [SMALL_STATE(3468)] = 95148,
  [SMALL_STATE(3469)] = 95233,
  [SMALL_STATE(3470)] = 95288,
  [SMALL_STATE(3471)] = 95343,
  [SMALL_STATE(3472)] = 95396,
  [SMALL_STATE(3473)] = 95479,
  [SMALL_STATE(3474)] = 95532,
  [SMALL_STATE(3475)] = 95587,
  [SMALL_STATE(3476)] = 95674,
  [SMALL_STATE(3477)] = 95759,
  [SMALL_STATE(3478)] = 95842,
  [SMALL_STATE(3479)] = 95935,
  [SMALL_STATE(3480)] = 96020,
  [SMALL_STATE(3481)] = 96103,
  [SMALL_STATE(3482)] = 96165,
  [SMALL_STATE(3483)] = 96219,
  [SMALL_STATE(3484)] = 96273,
  [SMALL_STATE(3485)] = 96357,
  [SMALL_STATE(3486)] = 96419,
  [SMALL_STATE(3487)] = 96471,
  [SMALL_STATE(3488)] = 96523,
  [SMALL_STATE(3489)] = 96613,
  [SMALL_STATE(3490)] = 96673,
  [SMALL_STATE(3491)] = 96739,
  [SMALL_STATE(3492)] = 96815,
  [SMALL_STATE(3493)] = 96901,
  [SMALL_STATE(3494)] = 96957,
  [SMALL_STATE(3495)] = 97011,
  [SMALL_STATE(3496)] = 97091,
  [SMALL_STATE(3497)] = 97165,
  [SMALL_STATE(3498)] = 97223,
  [SMALL_STATE(3499)] = 97309,
  [SMALL_STATE(3500)] = 97395,
  [SMALL_STATE(3501)] = 97485,
  [SMALL_STATE(3502)] = 97571,
  [SMALL_STATE(3503)] = 97653,
  [SMALL_STATE(3504)] = 97711,
  [SMALL_STATE(3505)] = 97765,
  [SMALL_STATE(3506)] = 97819,
  [SMALL_STATE(3507)] = 97901,
  [SMALL_STATE(3508)] = 97983,
  [SMALL_STATE(3509)] = 98039,
  [SMALL_STATE(3510)] = 98099,
  [SMALL_STATE(3511)] = 98181,
  [SMALL_STATE(3512)] = 98235,
  [SMALL_STATE(3513)] = 98289,
  [SMALL_STATE(3514)] = 98343,
  [SMALL_STATE(3515)] = 98431,
  [SMALL_STATE(3516)] = 98521,
  [SMALL_STATE(3517)] = 98577,
  [SMALL_STATE(3518)] = 98633,
  [SMALL_STATE(3519)] = 98717,
  [SMALL_STATE(3520)] = 98777,
  [SMALL_STATE(3521)] = 98843,
  [SMALL_STATE(3522)] = 98923,
  [SMALL_STATE(3523)] = 99009,
  [SMALL_STATE(3524)] = 99085,
  [SMALL_STATE(3525)] = 99159,
  [SMALL_STATE(3526)] = 99217,
  [SMALL_STATE(3527)] = 99299,
  [SMALL_STATE(3528)] = 99373,
  [SMALL_STATE(3529)] = 99427,
  [SMALL_STATE(3530)] = 99511,
  [SMALL_STATE(3531)] = 99593,
  [SMALL_STATE(3532)] = 99647,
  [SMALL_STATE(3533)] = 99731,
  [SMALL_STATE(3534)] = 99815,
  [SMALL_STATE(3535)] = 99889,
  [SMALL_STATE(3536)] = 99947,
  [SMALL_STATE(3537)] = 100031,
  [SMALL_STATE(3538)] = 100115,
  [SMALL_STATE(3539)] = 100169,
  [SMALL_STATE(3540)] = 100223,
  [SMALL_STATE(3541)] = 100313,
  [SMALL_STATE(3542)] = 100371,
  [SMALL_STATE(3543)] = 100457,
  [SMALL_STATE(3544)] = 100539,
  [SMALL_STATE(3545)] = 100623,
  [SMALL_STATE(3546)] = 100707,
  [SMALL_STATE(3547)] = 100795,
  [SMALL_STATE(3548)] = 100881,
  [SMALL_STATE(3549)] = 100962,
  [SMALL_STATE(3550)] = 101015,
  [SMALL_STATE(3551)] = 101068,
  [SMALL_STATE(3552)] = 101121,
  [SMALL_STATE(3553)] = 101206,
  [SMALL_STATE(3554)] = 101293,
  [SMALL_STATE(3555)] = 101348,
  [SMALL_STATE(3556)] = 101433,
  [SMALL_STATE(3557)] = 101486,
  [SMALL_STATE(3558)] = 101575,
  [SMALL_STATE(3559)] = 101660,
  [SMALL_STATE(3560)] = 101743,
  [SMALL_STATE(3561)] = 101828,
  [SMALL_STATE(3562)] = 101917,
  [SMALL_STATE(3563)] = 101970,
  [SMALL_STATE(3564)] = 102023,
  [SMALL_STATE(3565)] = 102106,
  [SMALL_STATE(3566)] = 102159,
  [SMALL_STATE(3567)] = 102214,
  [SMALL_STATE(3568)] = 102267,
  [SMALL_STATE(3569)] = 102320,
  [SMALL_STATE(3570)] = 102381,
  [SMALL_STATE(3571)] = 102440,
  [SMALL_STATE(3572)] = 102505,
  [SMALL_STATE(3573)] = 102558,
  [SMALL_STATE(3574)] = 102631,
  [SMALL_STATE(3575)] = 102688,
  [SMALL_STATE(3576)] = 102761,
  [SMALL_STATE(3577)] = 102816,
  [SMALL_STATE(3578)] = 102869,
  [SMALL_STATE(3579)] = 102928,
  [SMALL_STATE(3580)] = 102981,
  [SMALL_STATE(3581)] = 103062,
  [SMALL_STATE(3582)] = 103115,
  [SMALL_STATE(3583)] = 103170,
  [SMALL_STATE(3584)] = 103255,
  [SMALL_STATE(3585)] = 103338,
  [SMALL_STATE(3586)] = 103421,
  [SMALL_STATE(3587)] = 103502,
  [SMALL_STATE(3588)] = 103585,
  [SMALL_STATE(3589)] = 103668,
  [SMALL_STATE(3590)] = 103749,
  [SMALL_STATE(3591)] = 103830,
  [SMALL_STATE(3592)] = 103911,
  [SMALL_STATE(3593)] = 103966,
  [SMALL_STATE(3594)] = 104019,
  [SMALL_STATE(3595)] = 104074,
  [SMALL_STATE(3596)] = 104127,
  [SMALL_STATE(3597)] = 104212,
  [SMALL_STATE(3598)] = 104293,
  [SMALL_STATE(3599)] = 104346,
  [SMALL_STATE(3600)] = 104399,
  [SMALL_STATE(3601)] = 104452,
  [SMALL_STATE(3602)] = 104507,
  [SMALL_STATE(3603)] = 104582,
  [SMALL_STATE(3604)] = 104634,
  [SMALL_STATE(3605)] = 104722,
  [SMALL_STATE(3606)] = 104806,
  [SMALL_STATE(3607)] = 104894,
  [SMALL_STATE(3608)] = 104972,
  [SMALL_STATE(3609)] = 105022,
  [SMALL_STATE(3610)] = 105076,
  [SMALL_STATE(3611)] = 105160,
  [SMALL_STATE(3612)] = 105242,
  [SMALL_STATE(3613)] = 105296,
  [SMALL_STATE(3614)] = 105348,
  [SMALL_STATE(3615)] = 105400,
  [SMALL_STATE(3616)] = 105460,
  [SMALL_STATE(3617)] = 105546,
  [SMALL_STATE(3618)] = 105604,
  [SMALL_STATE(3619)] = 105690,
  [SMALL_STATE(3620)] = 105754,
  [SMALL_STATE(3621)] = 105834,
  [SMALL_STATE(3622)] = 105888,
  [SMALL_STATE(3623)] = 105968,
  [SMALL_STATE(3624)] = 106048,
  [SMALL_STATE(3625)] = 106126,
  [SMALL_STATE(3626)] = 106208,
  [SMALL_STATE(3627)] = 106288,
  [SMALL_STATE(3628)] = 106372,
  [SMALL_STATE(3629)] = 106456,
  [SMALL_STATE(3630)] = 106508,
  [SMALL_STATE(3631)] = 106582,
  [SMALL_STATE(3632)] = 106654,
  [SMALL_STATE(3633)] = 106710,
  [SMALL_STATE(3634)] = 106782,
  [SMALL_STATE(3635)] = 106834,
  [SMALL_STATE(3636)] = 106914,
  [SMALL_STATE(3637)] = 107000,
  [SMALL_STATE(3638)] = 107080,
  [SMALL_STATE(3639)] = 107160,
  [SMALL_STATE(3640)] = 107238,
  [SMALL_STATE(3641)] = 107318,
  [SMALL_STATE(3642)] = 107400,
  [SMALL_STATE(3643)] = 107480,
  [SMALL_STATE(3644)] = 107530,
  [SMALL_STATE(3645)] = 107614,
  [SMALL_STATE(3646)] = 107694,
  [SMALL_STATE(3647)] = 107774,
  [SMALL_STATE(3648)] = 107858,
  [SMALL_STATE(3649)] = 107910,
  [SMALL_STATE(3650)] = 107962,
  [SMALL_STATE(3651)] = 108046,
  [SMALL_STATE(3652)] = 108098,
  [SMALL_STATE(3653)] = 108178,
  [SMALL_STATE(3654)] = 108248,
  [SMALL_STATE(3655)] = 108302,
  [SMALL_STATE(3656)] = 108382,
  [SMALL_STATE(3657)] = 108434,
  [SMALL_STATE(3658)] = 108488,
  [SMALL_STATE(3659)] = 108540,
  [SMALL_STATE(3660)] = 108620,
  [SMALL_STATE(3661)] = 108706,
  [SMALL_STATE(3662)] = 108760,
  [SMALL_STATE(3663)] = 108838,
  [SMALL_STATE(3664)] = 108892,
  [SMALL_STATE(3665)] = 108944,
  [SMALL_STATE(3666)] = 108996,
  [SMALL_STATE(3667)] = 109076,
  [SMALL_STATE(3668)] = 109158,
  [SMALL_STATE(3669)] = 109218,
  [SMALL_STATE(3670)] = 109302,
  [SMALL_STATE(3671)] = 109360,
  [SMALL_STATE(3672)] = 109442,
  [SMALL_STATE(3673)] = 109524,
  [SMALL_STATE(3674)] = 109604,
  [SMALL_STATE(3675)] = 109686,
  [SMALL_STATE(3676)] = 109738,
  [SMALL_STATE(3677)] = 109820,
  [SMALL_STATE(3678)] = 109898,
  [SMALL_STATE(3679)] = 109984,
  [SMALL_STATE(3680)] = 110038,
  [SMALL_STATE(3681)] = 110090,
  [SMALL_STATE(3682)] = 110142,
  [SMALL_STATE(3683)] = 110226,
  [SMALL_STATE(3684)] = 110308,
  [SMALL_STATE(3685)] = 110360,
  [SMALL_STATE(3686)] = 110420,
  [SMALL_STATE(3687)] = 110478,
  [SMALL_STATE(3688)] = 110542,
  [SMALL_STATE(3689)] = 110616,
  [SMALL_STATE(3690)] = 110696,
  [SMALL_STATE(3691)] = 110780,
  [SMALL_STATE(3692)] = 110864,
  [SMALL_STATE(3693)] = 110916,
  [SMALL_STATE(3694)] = 110968,
  [SMALL_STATE(3695)] = 111032,
  [SMALL_STATE(3696)] = 111112,
  [SMALL_STATE(3697)] = 111186,
  [SMALL_STATE(3698)] = 111258,
  [SMALL_STATE(3699)] = 111314,
  [SMALL_STATE(3700)] = 111386,
  [SMALL_STATE(3701)] = 111438,
  [SMALL_STATE(3702)] = 111490,
  [SMALL_STATE(3703)] = 111568,
  [SMALL_STATE(3704)] = 111652,
  [SMALL_STATE(3705)] = 111732,
  [SMALL_STATE(3706)] = 111804,
  [SMALL_STATE(3707)] = 111860,
  [SMALL_STATE(3708)] = 111916,
  [SMALL_STATE(3709)] = 111988,
  [SMALL_STATE(3710)] = 112072,
  [SMALL_STATE(3711)] = 112122,
  [SMALL_STATE(3712)] = 112212,
  [SMALL_STATE(3713)] = 112292,
  [SMALL_STATE(3714)] = 112344,
  [SMALL_STATE(3715)] = 112424,
  [SMALL_STATE(3716)] = 112506,
  [SMALL_STATE(3717)] = 112560,
  [SMALL_STATE(3718)] = 112612,
  [SMALL_STATE(3719)] = 112664,
  [SMALL_STATE(3720)] = 112724,
  [SMALL_STATE(3721)] = 112782,
  [SMALL_STATE(3722)] = 112846,
  [SMALL_STATE(3723)] = 112920,
  [SMALL_STATE(3724)] = 112992,
  [SMALL_STATE(3725)] = 113048,
  [SMALL_STATE(3726)] = 113120,
  [SMALL_STATE(3727)] = 113172,
  [SMALL_STATE(3728)] = 113224,
  [SMALL_STATE(3729)] = 113308,
  [SMALL_STATE(3730)] = 113378,
  [SMALL_STATE(3731)] = 113432,
  [SMALL_STATE(3732)] = 113486,
  [SMALL_STATE(3733)] = 113538,
  [SMALL_STATE(3734)] = 113590,
  [SMALL_STATE(3735)] = 113650,
  [SMALL_STATE(3736)] = 113708,
  [SMALL_STATE(3737)] = 113772,
  [SMALL_STATE(3738)] = 113846,
  [SMALL_STATE(3739)] = 113918,
  [SMALL_STATE(3740)] = 113974,
  [SMALL_STATE(3741)] = 114046,
  [SMALL_STATE(3742)] = 114126,
  [SMALL_STATE(3743)] = 114178,
  [SMALL_STATE(3744)] = 114230,
  [SMALL_STATE(3745)] = 114314,
  [SMALL_STATE(3746)] = 114364,
  [SMALL_STATE(3747)] = 114416,
  [SMALL_STATE(3748)] = 114466,
  [SMALL_STATE(3749)] = 114546,
  [SMALL_STATE(3750)] = 114628,
  [SMALL_STATE(3751)] = 114710,
  [SMALL_STATE(3752)] = 114790,
  [SMALL_STATE(3753)] = 114870,
  [SMALL_STATE(3754)] = 114952,
  [SMALL_STATE(3755)] = 115032,
  [SMALL_STATE(3756)] = 115114,
  [SMALL_STATE(3757)] = 115164,
  [SMALL_STATE(3758)] = 115252,
  [SMALL_STATE(3759)] = 115308,
  [SMALL_STATE(3760)] = 115390,
  [SMALL_STATE(3761)] = 115472,
  [SMALL_STATE(3762)] = 115527,
  [SMALL_STATE(3763)] = 115580,
  [SMALL_STATE(3764)] = 115631,
  [SMALL_STATE(3765)] = 115710,
  [SMALL_STATE(3766)] = 115793,
  [SMALL_STATE(3767)] = 115876,
  [SMALL_STATE(3768)] = 115927,
  [SMALL_STATE(3769)] = 115978,
  [SMALL_STATE(3770)] = 116057,
  [SMALL_STATE(3771)] = 116108,
  [SMALL_STATE(3772)] = 116159,
  [SMALL_STATE(3773)] = 116242,
  [SMALL_STATE(3774)] = 116327,
  [SMALL_STATE(3775)] = 116378,
  [SMALL_STATE(3776)] = 116437,
  [SMALL_STATE(3777)] = 116518,
  [SMALL_STATE(3778)] = 116599,
  [SMALL_STATE(3779)] = 116652,
  [SMALL_STATE(3780)] = 116703,
  [SMALL_STATE(3781)] = 116754,
  [SMALL_STATE(3782)] = 116835,
  [SMALL_STATE(3783)] = 116916,
  [SMALL_STATE(3784)] = 116995,
  [SMALL_STATE(3785)] = 117076,
  [SMALL_STATE(3786)] = 117135,
  [SMALL_STATE(3787)] = 117192,
  [SMALL_STATE(3788)] = 117273,
  [SMALL_STATE(3789)] = 117336,
  [SMALL_STATE(3790)] = 117417,
  [SMALL_STATE(3791)] = 117468,
  [SMALL_STATE(3792)] = 117549,
  [SMALL_STATE(3793)] = 117608,
  [SMALL_STATE(3794)] = 117681,
  [SMALL_STATE(3795)] = 117758,
  [SMALL_STATE(3796)] = 117811,
  [SMALL_STATE(3797)] = 117892,
  [SMALL_STATE(3798)] = 117949,
  [SMALL_STATE(3799)] = 118000,
  [SMALL_STATE(3800)] = 118053,
  [SMALL_STATE(3801)] = 118124,
  [SMALL_STATE(3802)] = 118179,
  [SMALL_STATE(3803)] = 118258,
  [SMALL_STATE(3804)] = 118309,
  [SMALL_STATE(3805)] = 118372,
  [SMALL_STATE(3806)] = 118443,
  [SMALL_STATE(3807)] = 118502,
  [SMALL_STATE(3808)] = 118559,
  [SMALL_STATE(3809)] = 118638,
  [SMALL_STATE(3810)] = 118717,
  [SMALL_STATE(3811)] = 118796,
  [SMALL_STATE(3812)] = 118877,
  [SMALL_STATE(3813)] = 118928,
  [SMALL_STATE(3814)] = 118981,
  [SMALL_STATE(3815)] = 119054,
  [SMALL_STATE(3816)] = 119111,
  [SMALL_STATE(3817)] = 119184,
  [SMALL_STATE(3818)] = 119263,
  [SMALL_STATE(3819)] = 119326,
  [SMALL_STATE(3820)] = 119405,
  [SMALL_STATE(3821)] = 119476,
  [SMALL_STATE(3822)] = 119557,
  [SMALL_STATE(3823)] = 119636,
  [SMALL_STATE(3824)] = 119687,
  [SMALL_STATE(3825)] = 119742,
  [SMALL_STATE(3826)] = 119821,
  [SMALL_STATE(3827)] = 119900,
  [SMALL_STATE(3828)] = 119973,
  [SMALL_STATE(3829)] = 120036,
  [SMALL_STATE(3830)] = 120107,
  [SMALL_STATE(3831)] = 120160,
  [SMALL_STATE(3832)] = 120231,
  [SMALL_STATE(3833)] = 120290,
  [SMALL_STATE(3834)] = 120341,
  [SMALL_STATE(3835)] = 120414,
  [SMALL_STATE(3836)] = 120485,
  [SMALL_STATE(3837)] = 120564,
  [SMALL_STATE(3838)] = 120619,
  [SMALL_STATE(3839)] = 120682,
  [SMALL_STATE(3840)] = 120733,
  [SMALL_STATE(3841)] = 120790,
  [SMALL_STATE(3842)] = 120869,
  [SMALL_STATE(3843)] = 120950,
  [SMALL_STATE(3844)] = 121033,
  [SMALL_STATE(3845)] = 121086,
  [SMALL_STATE(3846)] = 121157,
  [SMALL_STATE(3847)] = 121228,
  [SMALL_STATE(3848)] = 121283,
  [SMALL_STATE(3849)] = 121334,
  [SMALL_STATE(3850)] = 121405,
  [SMALL_STATE(3851)] = 121456,
  [SMALL_STATE(3852)] = 121509,
  [SMALL_STATE(3853)] = 121590,
  [SMALL_STATE(3854)] = 121669,
  [SMALL_STATE(3855)] = 121720,
  [SMALL_STATE(3856)] = 121801,
  [SMALL_STATE(3857)] = 121852,
  [SMALL_STATE(3858)] = 121903,
  [SMALL_STATE(3859)] = 121982,
  [SMALL_STATE(3860)] = 122069,
  [SMALL_STATE(3861)] = 122148,
  [SMALL_STATE(3862)] = 122231,
  [SMALL_STATE(3863)] = 122282,
  [SMALL_STATE(3864)] = 122365,
  [SMALL_STATE(3865)] = 122442,
  [SMALL_STATE(3866)] = 122493,
  [SMALL_STATE(3867)] = 122544,
  [SMALL_STATE(3868)] = 122627,
  [SMALL_STATE(3869)] = 122710,
  [SMALL_STATE(3870)] = 122761,
  [SMALL_STATE(3871)] = 122812,
  [SMALL_STATE(3872)] = 122863,
  [SMALL_STATE(3873)] = 122914,
  [SMALL_STATE(3874)] = 122967,
  [SMALL_STATE(3875)] = 123018,
  [SMALL_STATE(3876)] = 123099,
  [SMALL_STATE(3877)] = 123152,
  [SMALL_STATE(3878)] = 123207,
  [SMALL_STATE(3879)] = 123288,
  [SMALL_STATE(3880)] = 123367,
  [SMALL_STATE(3881)] = 123418,
  [SMALL_STATE(3882)] = 123469,
  [SMALL_STATE(3883)] = 123556,
  [SMALL_STATE(3884)] = 123637,
  [SMALL_STATE(3885)] = 123714,
  [SMALL_STATE(3886)] = 123793,
  [SMALL_STATE(3887)] = 123874,
  [SMALL_STATE(3888)] = 123953,
  [SMALL_STATE(3889)] = 124030,
  [SMALL_STATE(3890)] = 124101,
  [SMALL_STATE(3891)] = 124181,
  [SMALL_STATE(3892)] = 124259,
  [SMALL_STATE(3893)] = 124337,
  [SMALL_STATE(3894)] = 124409,
  [SMALL_STATE(3895)] = 124467,
  [SMALL_STATE(3896)] = 124547,
  [SMALL_STATE(3897)] = 124617,
  [SMALL_STATE(3898)] = 124699,
  [SMALL_STATE(3899)] = 124783,
  [SMALL_STATE(3900)] = 124867,
  [SMALL_STATE(3901)] = 124945,
  [SMALL_STATE(3902)] = 125025,
  [SMALL_STATE(3903)] = 125105,
  [SMALL_STATE(3904)] = 125183,
  [SMALL_STATE(3905)] = 125263,
  [SMALL_STATE(3906)] = 125343,
  [SMALL_STATE(3907)] = 125421,
  [SMALL_STATE(3908)] = 125475,
  [SMALL_STATE(3909)] = 125553,
  [SMALL_STATE(3910)] = 125603,
  [SMALL_STATE(3911)] = 125687,
  [SMALL_STATE(3912)] = 125737,
  [SMALL_STATE(3913)] = 125819,
  [SMALL_STATE(3914)] = 125897,
  [SMALL_STATE(3915)] = 125979,
  [SMALL_STATE(3916)] = 126059,
  [SMALL_STATE(3917)] = 126141,
  [SMALL_STATE(3918)] = 126197,
  [SMALL_STATE(3919)] = 126247,
  [SMALL_STATE(3920)] = 126299,
  [SMALL_STATE(3921)] = 126377,
  [SMALL_STATE(3922)] = 126427,
  [SMALL_STATE(3923)] = 126505,
  [SMALL_STATE(3924)] = 126587,
  [SMALL_STATE(3925)] = 126665,
  [SMALL_STATE(3926)] = 126719,
  [SMALL_STATE(3927)] = 126801,
  [SMALL_STATE(3928)] = 126855,
  [SMALL_STATE(3929)] = 126925,
  [SMALL_STATE(3930)] = 126975,
  [SMALL_STATE(3931)] = 127053,
  [SMALL_STATE(3932)] = 127115,
  [SMALL_STATE(3933)] = 127197,
  [SMALL_STATE(3934)] = 127275,
  [SMALL_STATE(3935)] = 127327,
  [SMALL_STATE(3936)] = 127415,
  [SMALL_STATE(3937)] = 127465,
  [SMALL_STATE(3938)] = 127543,
  [SMALL_STATE(3939)] = 127625,
  [SMALL_STATE(3940)] = 127707,
  [SMALL_STATE(3941)] = 127785,
  [SMALL_STATE(3942)] = 127837,
  [SMALL_STATE(3943)] = 127887,
  [SMALL_STATE(3944)] = 127937,
  [SMALL_STATE(3945)] = 128017,
  [SMALL_STATE(3946)] = 128067,
  [SMALL_STATE(3947)] = 128145,
  [SMALL_STATE(3948)] = 128195,
  [SMALL_STATE(3949)] = 128253,
  [SMALL_STATE(3950)] = 128331,
  [SMALL_STATE(3951)] = 128409,
  [SMALL_STATE(3952)] = 128487,
  [SMALL_STATE(3953)] = 128549,
  [SMALL_STATE(3954)] = 128621,
  [SMALL_STATE(3955)] = 128691,
  [SMALL_STATE(3956)] = 128741,
  [SMALL_STATE(3957)] = 128795,
  [SMALL_STATE(3958)] = 128845,
  [SMALL_STATE(3959)] = 128923,
  [SMALL_STATE(3960)] = 129003,
  [SMALL_STATE(3961)] = 129083,
  [SMALL_STATE(3962)] = 129153,
  [SMALL_STATE(3963)] = 129237,
  [SMALL_STATE(3964)] = 129315,
  [SMALL_STATE(3965)] = 129393,
  [SMALL_STATE(3966)] = 129473,
  [SMALL_STATE(3967)] = 129557,
  [SMALL_STATE(3968)] = 129639,
  [SMALL_STATE(3969)] = 129727,
  [SMALL_STATE(3970)] = 129779,
  [SMALL_STATE(3971)] = 129863,
  [SMALL_STATE(3972)] = 129939,
  [SMALL_STATE(3973)] = 130021,
  [SMALL_STATE(3974)] = 130071,
  [SMALL_STATE(3975)] = 130153,
  [SMALL_STATE(3976)] = 130235,
  [SMALL_STATE(3977)] = 130285,
  [SMALL_STATE(3978)] = 130365,
  [SMALL_STATE(3979)] = 130423,
  [SMALL_STATE(3980)] = 130479,
  [SMALL_STATE(3981)] = 130541,
  [SMALL_STATE(3982)] = 130613,
  [SMALL_STATE(3983)] = 130693,
  [SMALL_STATE(3984)] = 130777,
  [SMALL_STATE(3985)] = 130847,
  [SMALL_STATE(3986)] = 130901,
  [SMALL_STATE(3987)] = 130971,
  [SMALL_STATE(3988)] = 131021,
  [SMALL_STATE(3989)] = 131097,
  [SMALL_STATE(3990)] = 131147,
  [SMALL_STATE(3991)] = 131203,
  [SMALL_STATE(3992)] = 131282,
  [SMALL_STATE(3993)] = 131363,
  [SMALL_STATE(3994)] = 131442,
  [SMALL_STATE(3995)] = 131491,
  [SMALL_STATE(3996)] = 131568,
  [SMALL_STATE(3997)] = 131617,
  [SMALL_STATE(3998)] = 131692,
  [SMALL_STATE(3999)] = 131767,
  [SMALL_STATE(4000)] = 131844,
  [SMALL_STATE(4001)] = 131901,
  [SMALL_STATE(4002)] = 131978,
  [SMALL_STATE(4003)] = 132029,
  [SMALL_STATE(4004)] = 132078,
  [SMALL_STATE(4005)] = 132127,
  [SMALL_STATE(4006)] = 132176,
  [SMALL_STATE(4007)] = 132231,
  [SMALL_STATE(4008)] = 132282,
  [SMALL_STATE(4009)] = 132331,
  [SMALL_STATE(4010)] = 132410,
  [SMALL_STATE(4011)] = 132489,
  [SMALL_STATE(4012)] = 132550,
  [SMALL_STATE(4013)] = 132627,
  [SMALL_STATE(4014)] = 132706,
  [SMALL_STATE(4015)] = 132755,
  [SMALL_STATE(4016)] = 132836,
  [SMALL_STATE(4017)] = 132913,
  [SMALL_STATE(4018)] = 132970,
  [SMALL_STATE(4019)] = 133019,
  [SMALL_STATE(4020)] = 133096,
  [SMALL_STATE(4021)] = 133151,
  [SMALL_STATE(4022)] = 133212,
  [SMALL_STATE(4023)] = 133283,
  [SMALL_STATE(4024)] = 133364,
  [SMALL_STATE(4025)] = 133445,
  [SMALL_STATE(4026)] = 133514,
  [SMALL_STATE(4027)] = 133593,
  [SMALL_STATE(4028)] = 133670,
  [SMALL_STATE(4029)] = 133747,
  [SMALL_STATE(4030)] = 133824,
  [SMALL_STATE(4031)] = 133877,
  [SMALL_STATE(4032)] = 133928,
  [SMALL_STATE(4033)] = 133981,
  [SMALL_STATE(4034)] = 134034,
  [SMALL_STATE(4035)] = 134115,
  [SMALL_STATE(4036)] = 134196,
  [SMALL_STATE(4037)] = 134247,
  [SMALL_STATE(4038)] = 134326,
  [SMALL_STATE(4039)] = 134395,
  [SMALL_STATE(4040)] = 134444,
  [SMALL_STATE(4041)] = 134525,
  [SMALL_STATE(4042)] = 134574,
  [SMALL_STATE(4043)] = 134623,
  [SMALL_STATE(4044)] = 134700,
  [SMALL_STATE(4045)] = 134777,
  [SMALL_STATE(4046)] = 134828,
  [SMALL_STATE(4047)] = 134899,
  [SMALL_STATE(4048)] = 134976,
  [SMALL_STATE(4049)] = 135059,
  [SMALL_STATE(4050)] = 135108,
  [SMALL_STATE(4051)] = 135187,
  [SMALL_STATE(4052)] = 135256,
  [SMALL_STATE(4053)] = 135309,
  [SMALL_STATE(4054)] = 135378,
  [SMALL_STATE(4055)] = 135459,
  [SMALL_STATE(4056)] = 135539,
  [SMALL_STATE(4057)] = 135615,
  [SMALL_STATE(4058)] = 135665,
  [SMALL_STATE(4059)] = 135713,
  [SMALL_STATE(4060)] = 135761,
  [SMALL_STATE(4061)] = 135817,
  [SMALL_STATE(4062)] = 135871,
  [SMALL_STATE(4063)] = 135931,
  [SMALL_STATE(4064)] = 136001,
  [SMALL_STATE(4065)] = 136077,
  [SMALL_STATE(4066)] = 136153,
  [SMALL_STATE(4067)] = 136229,
  [SMALL_STATE(4068)] = 136277,
  [SMALL_STATE(4069)] = 136345,
  [SMALL_STATE(4070)] = 136395,
  [SMALL_STATE(4071)] = 136475,
  [SMALL_STATE(4072)] = 136527,
  [SMALL_STATE(4073)] = 136595,
  [SMALL_STATE(4074)] = 136641,
  [SMALL_STATE(4075)] = 136689,
  [SMALL_STATE(4076)] = 136765,
  [SMALL_STATE(4077)] = 136813,
  [SMALL_STATE(4078)] = 136887,
  [SMALL_STATE(4079)] = 136965,
  [SMALL_STATE(4080)] = 137043,
  [SMALL_STATE(4081)] = 137121,
  [SMALL_STATE(4082)] = 137197,
  [SMALL_STATE(4083)] = 137277,
  [SMALL_STATE(4084)] = 137329,
  [SMALL_STATE(4085)] = 137405,
  [SMALL_STATE(4086)] = 137453,
  [SMALL_STATE(4087)] = 137533,
  [SMALL_STATE(4088)] = 137613,
  [SMALL_STATE(4089)] = 137691,
  [SMALL_STATE(4090)] = 137765,
  [SMALL_STATE(4091)] = 137841,
  [SMALL_STATE(4092)] = 137891,
  [SMALL_STATE(4093)] = 137939,
  [SMALL_STATE(4094)] = 137987,
  [SMALL_STATE(4095)] = 138043,
  [SMALL_STATE(4096)] = 138119,
  [SMALL_STATE(4097)] = 138179,
  [SMALL_STATE(4098)] = 138249,
  [SMALL_STATE(4099)] = 138317,
  [SMALL_STATE(4100)] = 138369,
  [SMALL_STATE(4101)] = 138437,
  [SMALL_STATE(4102)] = 138485,
  [SMALL_STATE(4103)] = 138561,
  [SMALL_STATE(4104)] = 138637,
  [SMALL_STATE(4105)] = 138711,
  [SMALL_STATE(4106)] = 138787,
  [SMALL_STATE(4107)] = 138863,
  [SMALL_STATE(4108)] = 138939,
  [SMALL_STATE(4109)] = 138989,
  [SMALL_STATE(4110)] = 139037,
  [SMALL_STATE(4111)] = 139113,
  [SMALL_STATE(4112)] = 139195,
  [SMALL_STATE(4113)] = 139273,
  [SMALL_STATE(4114)] = 139349,
  [SMALL_STATE(4115)] = 139423,
  [SMALL_STATE(4116)] = 139505,
  [SMALL_STATE(4117)] = 139581,
  [SMALL_STATE(4118)] = 139657,
  [SMALL_STATE(4119)] = 139733,
  [SMALL_STATE(4120)] = 139809,
  [SMALL_STATE(4121)] = 139885,
  [SMALL_STATE(4122)] = 139967,
  [SMALL_STATE(4123)] = 140045,
  [SMALL_STATE(4124)] = 140121,
  [SMALL_STATE(4125)] = 140203,
  [SMALL_STATE(4126)] = 140283,
  [SMALL_STATE(4127)] = 140361,
  [SMALL_STATE(4128)] = 140415,
  [SMALL_STATE(4129)] = 140494,
  [SMALL_STATE(4130)] = 140567,
  [SMALL_STATE(4131)] = 140642,
  [SMALL_STATE(4132)] = 140691,
  [SMALL_STATE(4133)] = 140738,
  [SMALL_STATE(4134)] = 140813,
  [SMALL_STATE(4135)] = 140888,
  [SMALL_STATE(4136)] = 140935,
  [SMALL_STATE(4137)] = 141010,
  [SMALL_STATE(4138)] = 141057,
  [SMALL_STATE(4139)] = 141112,
  [SMALL_STATE(4140)] = 141187,
  [SMALL_STATE(4141)] = 141232,
  [SMALL_STATE(4142)] = 141309,
  [SMALL_STATE(4143)] = 141356,
  [SMALL_STATE(4144)] = 141429,
  [SMALL_STATE(4145)] = 141502,
  [SMALL_STATE(4146)] = 141577,
  [SMALL_STATE(4147)] = 141630,
  [SMALL_STATE(4148)] = 141705,
  [SMALL_STATE(4149)] = 141764,
  [SMALL_STATE(4150)] = 141841,
  [SMALL_STATE(4151)] = 141918,
  [SMALL_STATE(4152)] = 141993,
  [SMALL_STATE(4153)] = 142068,
  [SMALL_STATE(4154)] = 142143,
  [SMALL_STATE(4155)] = 142218,
  [SMALL_STATE(4156)] = 142297,
  [SMALL_STATE(4157)] = 142346,
  [SMALL_STATE(4158)] = 142393,
  [SMALL_STATE(4159)] = 142440,
  [SMALL_STATE(4160)] = 142495,
  [SMALL_STATE(4161)] = 142548,
  [SMALL_STATE(4162)] = 142607,
  [SMALL_STATE(4163)] = 142676,
  [SMALL_STATE(4164)] = 142751,
  [SMALL_STATE(4165)] = 142818,
  [SMALL_STATE(4166)] = 142869,
  [SMALL_STATE(4167)] = 142936,
  [SMALL_STATE(4168)] = 142983,
  [SMALL_STATE(4169)] = 143060,
  [SMALL_STATE(4170)] = 143137,
  [SMALL_STATE(4171)] = 143212,
  [SMALL_STATE(4172)] = 143287,
  [SMALL_STATE(4173)] = 143362,
  [SMALL_STATE(4174)] = 143439,
  [SMALL_STATE(4175)] = 143516,
  [SMALL_STATE(4176)] = 143565,
  [SMALL_STATE(4177)] = 143638,
  [SMALL_STATE(4178)] = 143685,
  [SMALL_STATE(4179)] = 143758,
  [SMALL_STATE(4180)] = 143807,
  [SMALL_STATE(4181)] = 143854,
  [SMALL_STATE(4182)] = 143901,
  [SMALL_STATE(4183)] = 143956,
  [SMALL_STATE(4184)] = 144033,
  [SMALL_STATE(4185)] = 144086,
  [SMALL_STATE(4186)] = 144145,
  [SMALL_STATE(4187)] = 144194,
  [SMALL_STATE(4188)] = 144263,
  [SMALL_STATE(4189)] = 144330,
  [SMALL_STATE(4190)] = 144381,
  [SMALL_STATE(4191)] = 144448,
  [SMALL_STATE(4192)] = 144495,
  [SMALL_STATE(4193)] = 144544,
  [SMALL_STATE(4194)] = 144619,
  [SMALL_STATE(4195)] = 144664,
  [SMALL_STATE(4196)] = 144739,
  [SMALL_STATE(4197)] = 144814,
  [SMALL_STATE(4198)] = 144883,
  [SMALL_STATE(4199)] = 144950,
  [SMALL_STATE(4200)] = 145023,
  [SMALL_STATE(4201)] = 145074,
  [SMALL_STATE(4202)] = 145151,
  [SMALL_STATE(4203)] = 145198,
  [SMALL_STATE(4204)] = 145265,
  [SMALL_STATE(4205)] = 145340,
  [SMALL_STATE(4206)] = 145415,
  [SMALL_STATE(4207)] = 145462,
  [SMALL_STATE(4208)] = 145541,
  [SMALL_STATE(4209)] = 145616,
  [SMALL_STATE(4210)] = 145695,
  [SMALL_STATE(4211)] = 145742,
  [SMALL_STATE(4212)] = 145793,
  [SMALL_STATE(4213)] = 145872,
  [SMALL_STATE(4214)] = 145947,
  [SMALL_STATE(4215)] = 146026,
  [SMALL_STATE(4216)] = 146101,
  [SMALL_STATE(4217)] = 146147,
  [SMALL_STATE(4218)] = 146221,
  [SMALL_STATE(4219)] = 146293,
  [SMALL_STATE(4220)] = 146339,
  [SMALL_STATE(4221)] = 146397,
  [SMALL_STATE(4222)] = 146471,
  [SMALL_STATE(4223)] = 146545,
  [SMALL_STATE(4224)] = 146621,
  [SMALL_STATE(4225)] = 146695,
  [SMALL_STATE(4226)] = 146769,
  [SMALL_STATE(4227)] = 146815,
  [SMALL_STATE(4228)] = 146861,
  [SMALL_STATE(4229)] = 146935,
  [SMALL_STATE(4230)] = 147009,
  [SMALL_STATE(4231)] = 147073,
  [SMALL_STATE(4232)] = 147145,
  [SMALL_STATE(4233)] = 147191,
  [SMALL_STATE(4234)] = 147263,
  [SMALL_STATE(4235)] = 147311,
  [SMALL_STATE(4236)] = 147387,
  [SMALL_STATE(4237)] = 147433,
  [SMALL_STATE(4238)] = 147501,
  [SMALL_STATE(4239)] = 147577,
  [SMALL_STATE(4240)] = 147651,
  [SMALL_STATE(4241)] = 147699,
  [SMALL_STATE(4242)] = 147753,
  [SMALL_STATE(4243)] = 147817,
  [SMALL_STATE(4244)] = 147889,
  [SMALL_STATE(4245)] = 147943,
  [SMALL_STATE(4246)] = 147995,
  [SMALL_STATE(4247)] = 148061,
  [SMALL_STATE(4248)] = 148119,
  [SMALL_STATE(4249)] = 148193,
  [SMALL_STATE(4250)] = 148267,
  [SMALL_STATE(4251)] = 148335,
  [SMALL_STATE(4252)] = 148401,
  [SMALL_STATE(4253)] = 148451,
  [SMALL_STATE(4254)] = 148527,
  [SMALL_STATE(4255)] = 148603,
  [SMALL_STATE(4256)] = 148653,
  [SMALL_STATE(4257)] = 148727,
  [SMALL_STATE(4258)] = 148779,
  [SMALL_STATE(4259)] = 148845,
  [SMALL_STATE(4260)] = 148921,
  [SMALL_STATE(4261)] = 148967,
  [SMALL_STATE(4262)] = 149041,
  [SMALL_STATE(4263)] = 149115,
  [SMALL_STATE(4264)] = 149181,
  [SMALL_STATE(4265)] = 149227,
  [SMALL_STATE(4266)] = 149273,
  [SMALL_STATE(4267)] = 149348,
  [SMALL_STATE(4268)] = 149423,
  [SMALL_STATE(4269)] = 149498,
  [SMALL_STATE(4270)] = 149573,
  [SMALL_STATE(4271)] = 149648,
  [SMALL_STATE(4272)] = 149691,
  [SMALL_STATE(4273)] = 149734,
  [SMALL_STATE(4274)] = 149809,
  [SMALL_STATE(4275)] = 149884,
  [SMALL_STATE(4276)] = 149959,
  [SMALL_STATE(4277)] = 150034,
  [SMALL_STATE(4278)] = 150077,
  [SMALL_STATE(4279)] = 150152,
  [SMALL_STATE(4280)] = 150227,
  [SMALL_STATE(4281)] = 150302,
  [SMALL_STATE(4282)] = 150377,
  [SMALL_STATE(4283)] = 150450,
  [SMALL_STATE(4284)] = 150525,
  [SMALL_STATE(4285)] = 150600,
  [SMALL_STATE(4286)] = 150675,
  [SMALL_STATE(4287)] = 150748,
  [SMALL_STATE(4288)] = 150793,
  [SMALL_STATE(4289)] = 150868,
  [SMALL_STATE(4290)] = 150911,
  [SMALL_STATE(4291)] = 150986,
  [SMALL_STATE(4292)] = 151033,
  [SMALL_STATE(4293)] = 151078,
  [SMALL_STATE(4294)] = 151123,
  [SMALL_STATE(4295)] = 151198,
  [SMALL_STATE(4296)] = 151273,
  [SMALL_STATE(4297)] = 151326,
  [SMALL_STATE(4298)] = 151397,
  [SMALL_STATE(4299)] = 151468,
  [SMALL_STATE(4300)] = 151543,
  [SMALL_STATE(4301)] = 151586,
  [SMALL_STATE(4302)] = 151661,
  [SMALL_STATE(4303)] = 151712,
  [SMALL_STATE(4304)] = 151755,
  [SMALL_STATE(4305)] = 151798,
  [SMALL_STATE(4306)] = 151841,
  [SMALL_STATE(4307)] = 151884,
  [SMALL_STATE(4308)] = 151941,
  [SMALL_STATE(4309)] = 152014,
  [SMALL_STATE(4310)] = 152081,
  [SMALL_STATE(4311)] = 152146,
  [SMALL_STATE(4312)] = 152195,
  [SMALL_STATE(4313)] = 152260,
  [SMALL_STATE(4314)] = 152335,
  [SMALL_STATE(4315)] = 152380,
  [SMALL_STATE(4316)] = 152455,
  [SMALL_STATE(4317)] = 152530,
  [SMALL_STATE(4318)] = 152605,
  [SMALL_STATE(4319)] = 152678,
  [SMALL_STATE(4320)] = 152751,
  [SMALL_STATE(4321)] = 152826,
  [SMALL_STATE(4322)] = 152901,
  [SMALL_STATE(4323)] = 152976,
  [SMALL_STATE(4324)] = 153019,
  [SMALL_STATE(4325)] = 153062,
  [SMALL_STATE(4326)] = 153105,
  [SMALL_STATE(4327)] = 153180,
  [SMALL_STATE(4328)] = 153223,
  [SMALL_STATE(4329)] = 153298,
  [SMALL_STATE(4330)] = 153373,
  [SMALL_STATE(4331)] = 153416,
  [SMALL_STATE(4332)] = 153459,
  [SMALL_STATE(4333)] = 153534,
  [SMALL_STATE(4334)] = 153609,
  [SMALL_STATE(4335)] = 153652,
  [SMALL_STATE(4336)] = 153695,
  [SMALL_STATE(4337)] = 153770,
  [SMALL_STATE(4338)] = 153813,
  [SMALL_STATE(4339)] = 153888,
  [SMALL_STATE(4340)] = 153931,
  [SMALL_STATE(4341)] = 154006,
  [SMALL_STATE(4342)] = 154081,
  [SMALL_STATE(4343)] = 154154,
  [SMALL_STATE(4344)] = 154229,
  [SMALL_STATE(4345)] = 154304,
  [SMALL_STATE(4346)] = 154379,
  [SMALL_STATE(4347)] = 154454,
  [SMALL_STATE(4348)] = 154529,
  [SMALL_STATE(4349)] = 154604,
  [SMALL_STATE(4350)] = 154679,
  [SMALL_STATE(4351)] = 154754,
  [SMALL_STATE(4352)] = 154829,
  [SMALL_STATE(4353)] = 154904,
  [SMALL_STATE(4354)] = 154979,
  [SMALL_STATE(4355)] = 155054,
  [SMALL_STATE(4356)] = 155129,
  [SMALL_STATE(4357)] = 155204,
  [SMALL_STATE(4358)] = 155279,
  [SMALL_STATE(4359)] = 155354,
  [SMALL_STATE(4360)] = 155403,
  [SMALL_STATE(4361)] = 155478,
  [SMALL_STATE(4362)] = 155553,
  [SMALL_STATE(4363)] = 155628,
  [SMALL_STATE(4364)] = 155703,
  [SMALL_STATE(4365)] = 155778,
  [SMALL_STATE(4366)] = 155853,
  [SMALL_STATE(4367)] = 155928,
  [SMALL_STATE(4368)] = 155971,
  [SMALL_STATE(4369)] = 156014,
  [SMALL_STATE(4370)] = 156089,
  [SMALL_STATE(4371)] = 156164,
  [SMALL_STATE(4372)] = 156239,
  [SMALL_STATE(4373)] = 156314,
  [SMALL_STATE(4374)] = 156389,
  [SMALL_STATE(4375)] = 156464,
  [SMALL_STATE(4376)] = 156539,
  [SMALL_STATE(4377)] = 156614,
  [SMALL_STATE(4378)] = 156689,
  [SMALL_STATE(4379)] = 156764,
  [SMALL_STATE(4380)] = 156807,
  [SMALL_STATE(4381)] = 156849,
  [SMALL_STATE(4382)] = 156891,
  [SMALL_STATE(4383)] = 156933,
  [SMALL_STATE(4384)] = 156975,
  [SMALL_STATE(4385)] = 157017,
  [SMALL_STATE(4386)] = 157059,
  [SMALL_STATE(4387)] = 157101,
  [SMALL_STATE(4388)] = 157143,
  [SMALL_STATE(4389)] = 157185,
  [SMALL_STATE(4390)] = 157227,
  [SMALL_STATE(4391)] = 157269,
  [SMALL_STATE(4392)] = 157311,
  [SMALL_STATE(4393)] = 157353,
  [SMALL_STATE(4394)] = 157395,
  [SMALL_STATE(4395)] = 157437,
  [SMALL_STATE(4396)] = 157479,
  [SMALL_STATE(4397)] = 157521,
  [SMALL_STATE(4398)] = 157563,
  [SMALL_STATE(4399)] = 157605,
  [SMALL_STATE(4400)] = 157647,
  [SMALL_STATE(4401)] = 157689,
  [SMALL_STATE(4402)] = 157731,
  [SMALL_STATE(4403)] = 157773,
  [SMALL_STATE(4404)] = 157815,
  [SMALL_STATE(4405)] = 157857,
  [SMALL_STATE(4406)] = 157899,
  [SMALL_STATE(4407)] = 157941,
  [SMALL_STATE(4408)] = 157983,
  [SMALL_STATE(4409)] = 158025,
  [SMALL_STATE(4410)] = 158067,
  [SMALL_STATE(4411)] = 158109,
  [SMALL_STATE(4412)] = 158151,
  [SMALL_STATE(4413)] = 158193,
  [SMALL_STATE(4414)] = 158235,
  [SMALL_STATE(4415)] = 158277,
  [SMALL_STATE(4416)] = 158319,
  [SMALL_STATE(4417)] = 158361,
  [SMALL_STATE(4418)] = 158403,
  [SMALL_STATE(4419)] = 158445,
  [SMALL_STATE(4420)] = 158487,
  [SMALL_STATE(4421)] = 158529,
  [SMALL_STATE(4422)] = 158571,
  [SMALL_STATE(4423)] = 158613,
  [SMALL_STATE(4424)] = 158655,
  [SMALL_STATE(4425)] = 158697,
  [SMALL_STATE(4426)] = 158739,
  [SMALL_STATE(4427)] = 158781,
  [SMALL_STATE(4428)] = 158823,
  [SMALL_STATE(4429)] = 158865,
  [SMALL_STATE(4430)] = 158907,
  [SMALL_STATE(4431)] = 158949,
  [SMALL_STATE(4432)] = 158991,
  [SMALL_STATE(4433)] = 159032,
  [SMALL_STATE(4434)] = 159073,
  [SMALL_STATE(4435)] = 159114,
  [SMALL_STATE(4436)] = 159155,
  [SMALL_STATE(4437)] = 159196,
  [SMALL_STATE(4438)] = 159244,
  [SMALL_STATE(4439)] = 159290,
  [SMALL_STATE(4440)] = 159330,
  [SMALL_STATE(4441)] = 159370,
  [SMALL_STATE(4442)] = 159416,
  [SMALL_STATE(4443)] = 159464,
  [SMALL_STATE(4444)] = 159504,
  [SMALL_STATE(4445)] = 159544,
  [SMALL_STATE(4446)] = 159584,
  [SMALL_STATE(4447)] = 159624,
  [SMALL_STATE(4448)] = 159664,
  [SMALL_STATE(4449)] = 159704,
  [SMALL_STATE(4450)] = 159744,
  [SMALL_STATE(4451)] = 159786,
  [SMALL_STATE(4452)] = 159826,
  [SMALL_STATE(4453)] = 159866,
  [SMALL_STATE(4454)] = 159906,
  [SMALL_STATE(4455)] = 159946,
  [SMALL_STATE(4456)] = 159986,
  [SMALL_STATE(4457)] = 160026,
  [SMALL_STATE(4458)] = 160066,
  [SMALL_STATE(4459)] = 160106,
  [SMALL_STATE(4460)] = 160146,
  [SMALL_STATE(4461)] = 160205,
  [SMALL_STATE(4462)] = 160244,
  [SMALL_STATE(4463)] = 160285,
  [SMALL_STATE(4464)] = 160326,
  [SMALL_STATE(4465)] = 160365,
  [SMALL_STATE(4466)] = 160404,
  [SMALL_STATE(4467)] = 160443,
  [SMALL_STATE(4468)] = 160482,
  [SMALL_STATE(4469)] = 160523,
  [SMALL_STATE(4470)] = 160562,
  [SMALL_STATE(4471)] = 160601,
  [SMALL_STATE(4472)] = 160660,
  [SMALL_STATE(4473)] = 160701,
  [SMALL_STATE(4474)] = 160740,
  [SMALL_STATE(4475)] = 160779,
  [SMALL_STATE(4476)] = 160818,
  [SMALL_STATE(4477)] = 160856,
  [SMALL_STATE(4478)] = 160894,
  [SMALL_STATE(4479)] = 160932,
  [SMALL_STATE(4480)] = 160970,
  [SMALL_STATE(4481)] = 161010,
  [SMALL_STATE(4482)] = 161048,
  [SMALL_STATE(4483)] = 161086,
  [SMALL_STATE(4484)] = 161124,
  [SMALL_STATE(4485)] = 161162,
  [SMALL_STATE(4486)] = 161200,
  [SMALL_STATE(4487)] = 161238,
  [SMALL_STATE(4488)] = 161276,
  [SMALL_STATE(4489)] = 161314,
  [SMALL_STATE(4490)] = 161352,
  [SMALL_STATE(4491)] = 161390,
  [SMALL_STATE(4492)] = 161428,
  [SMALL_STATE(4493)] = 161466,
  [SMALL_STATE(4494)] = 161504,
  [SMALL_STATE(4495)] = 161542,
  [SMALL_STATE(4496)] = 161580,
  [SMALL_STATE(4497)] = 161618,
  [SMALL_STATE(4498)] = 161656,
  [SMALL_STATE(4499)] = 161694,
  [SMALL_STATE(4500)] = 161732,
  [SMALL_STATE(4501)] = 161770,
  [SMALL_STATE(4502)] = 161808,
  [SMALL_STATE(4503)] = 161846,
  [SMALL_STATE(4504)] = 161884,
  [SMALL_STATE(4505)] = 161922,
  [SMALL_STATE(4506)] = 161960,
  [SMALL_STATE(4507)] = 161998,
  [SMALL_STATE(4508)] = 162036,
  [SMALL_STATE(4509)] = 162074,
  [SMALL_STATE(4510)] = 162112,
  [SMALL_STATE(4511)] = 162152,
  [SMALL_STATE(4512)] = 162190,
  [SMALL_STATE(4513)] = 162228,
  [SMALL_STATE(4514)] = 162266,
  [SMALL_STATE(4515)] = 162304,
  [SMALL_STATE(4516)] = 162361,
  [SMALL_STATE(4517)] = 162418,
  [SMALL_STATE(4518)] = 162475,
  [SMALL_STATE(4519)] = 162516,
  [SMALL_STATE(4520)] = 162573,
  [SMALL_STATE(4521)] = 162611,
  [SMALL_STATE(4522)] = 162647,
  [SMALL_STATE(4523)] = 162683,
  [SMALL_STATE(4524)] = 162721,
  [SMALL_STATE(4525)] = 162759,
  [SMALL_STATE(4526)] = 162797,
  [SMALL_STATE(4527)] = 162835,
  [SMALL_STATE(4528)] = 162873,
  [SMALL_STATE(4529)] = 162911,
  [SMALL_STATE(4530)] = 162949,
  [SMALL_STATE(4531)] = 162987,
  [SMALL_STATE(4532)] = 163025,
  [SMALL_STATE(4533)] = 163061,
  [SMALL_STATE(4534)] = 163099,
  [SMALL_STATE(4535)] = 163158,
  [SMALL_STATE(4536)] = 163217,
  [SMALL_STATE(4537)] = 163276,
  [SMALL_STATE(4538)] = 163335,
  [SMALL_STATE(4539)] = 163394,
  [SMALL_STATE(4540)] = 163453,
  [SMALL_STATE(4541)] = 163512,
  [SMALL_STATE(4542)] = 163571,
  [SMALL_STATE(4543)] = 163630,
  [SMALL_STATE(4544)] = 163689,
  [SMALL_STATE(4545)] = 163748,
  [SMALL_STATE(4546)] = 163807,
  [SMALL_STATE(4547)] = 163866,
  [SMALL_STATE(4548)] = 163925,
  [SMALL_STATE(4549)] = 163984,
  [SMALL_STATE(4550)] = 164043,
  [SMALL_STATE(4551)] = 164102,
  [SMALL_STATE(4552)] = 164137,
  [SMALL_STATE(4553)] = 164172,
  [SMALL_STATE(4554)] = 164231,
  [SMALL_STATE(4555)] = 164290,
  [SMALL_STATE(4556)] = 164325,
  [SMALL_STATE(4557)] = 164384,
  [SMALL_STATE(4558)] = 164443,
  [SMALL_STATE(4559)] = 164502,
  [SMALL_STATE(4560)] = 164561,
  [SMALL_STATE(4561)] = 164620,
  [SMALL_STATE(4562)] = 164657,
  [SMALL_STATE(4563)] = 164711,
  [SMALL_STATE(4564)] = 164765,
  [SMALL_STATE(4565)] = 164801,
  [SMALL_STATE(4566)] = 164837,
  [SMALL_STATE(4567)] = 164891,
  [SMALL_STATE(4568)] = 164927,
  [SMALL_STATE(4569)] = 164961,
  [SMALL_STATE(4570)] = 165015,
  [SMALL_STATE(4571)] = 165049,
  [SMALL_STATE(4572)] = 165083,
  [SMALL_STATE(4573)] = 165137,
  [SMALL_STATE(4574)] = 165171,
  [SMALL_STATE(4575)] = 165225,
  [SMALL_STATE(4576)] = 165259,
  [SMALL_STATE(4577)] = 165293,
  [SMALL_STATE(4578)] = 165347,
  [SMALL_STATE(4579)] = 165381,
  [SMALL_STATE(4580)] = 165414,
  [SMALL_STATE(4581)] = 165449,
  [SMALL_STATE(4582)] = 165482,
  [SMALL_STATE(4583)] = 165537,
  [SMALL_STATE(4584)] = 165574,
  [SMALL_STATE(4585)] = 165607,
  [SMALL_STATE(4586)] = 165640,
  [SMALL_STATE(4587)] = 165675,
  [SMALL_STATE(4588)] = 165708,
  [SMALL_STATE(4589)] = 165741,
  [SMALL_STATE(4590)] = 165796,
  [SMALL_STATE(4591)] = 165848,
  [SMALL_STATE(4592)] = 165884,
  [SMALL_STATE(4593)] = 165936,
  [SMALL_STATE(4594)] = 165968,
  [SMALL_STATE(4595)] = 166000,
  [SMALL_STATE(4596)] = 166032,
  [SMALL_STATE(4597)] = 166064,
  [SMALL_STATE(4598)] = 166096,
  [SMALL_STATE(4599)] = 166128,
  [SMALL_STATE(4600)] = 166160,
  [SMALL_STATE(4601)] = 166194,
  [SMALL_STATE(4602)] = 166228,
  [SMALL_STATE(4603)] = 166260,
  [SMALL_STATE(4604)] = 166294,
  [SMALL_STATE(4605)] = 166346,
  [SMALL_STATE(4606)] = 166398,
  [SMALL_STATE(4607)] = 166434,
  [SMALL_STATE(4608)] = 166469,
  [SMALL_STATE(4609)] = 166504,
  [SMALL_STATE(4610)] = 166535,
  [SMALL_STATE(4611)] = 166594,
  [SMALL_STATE(4612)] = 166643,
  [SMALL_STATE(4613)] = 166702,
  [SMALL_STATE(4614)] = 166761,
  [SMALL_STATE(4615)] = 166820,
  [SMALL_STATE(4616)] = 166871,
  [SMALL_STATE(4617)] = 166920,
  [SMALL_STATE(4618)] = 166969,
  [SMALL_STATE(4619)] = 167020,
  [SMALL_STATE(4620)] = 167079,
  [SMALL_STATE(4621)] = 167138,
  [SMALL_STATE(4622)] = 167172,
  [SMALL_STATE(4623)] = 167218,
  [SMALL_STATE(4624)] = 167264,
  [SMALL_STATE(4625)] = 167296,
  [SMALL_STATE(4626)] = 167330,
  [SMALL_STATE(4627)] = 167376,
  [SMALL_STATE(4628)] = 167410,
  [SMALL_STATE(4629)] = 167452,
  [SMALL_STATE(4630)] = 167486,
  [SMALL_STATE(4631)] = 167518,
  [SMALL_STATE(4632)] = 167550,
  [SMALL_STATE(4633)] = 167584,
  [SMALL_STATE(4634)] = 167618,
  [SMALL_STATE(4635)] = 167660,
  [SMALL_STATE(4636)] = 167692,
  [SMALL_STATE(4637)] = 167726,
  [SMALL_STATE(4638)] = 167760,
  [SMALL_STATE(4639)] = 167806,
  [SMALL_STATE(4640)] = 167836,
  [SMALL_STATE(4641)] = 167870,
  [SMALL_STATE(4642)] = 167904,
  [SMALL_STATE(4643)] = 167935,
  [SMALL_STATE(4644)] = 167966,
  [SMALL_STATE(4645)] = 167997,
  [SMALL_STATE(4646)] = 168030,
  [SMALL_STATE(4647)] = 168063,
  [SMALL_STATE(4648)] = 168089,
  [SMALL_STATE(4649)] = 168117,
  [SMALL_STATE(4650)] = 168143,
  [SMALL_STATE(4651)] = 168169,
  [SMALL_STATE(4652)] = 168197,
  [SMALL_STATE(4653)] = 168223,
  [SMALL_STATE(4654)] = 168255,
  [SMALL_STATE(4655)] = 168283,
  [SMALL_STATE(4656)] = 168315,
  [SMALL_STATE(4657)] = 168345,
  [SMALL_STATE(4658)] = 168375,
  [SMALL_STATE(4659)] = 168407,
  [SMALL_STATE(4660)] = 168433,
  [SMALL_STATE(4661)] = 168459,
  [SMALL_STATE(4662)] = 168497,
  [SMALL_STATE(4663)] = 168535,
  [SMALL_STATE(4664)] = 168561,
  [SMALL_STATE(4665)] = 168589,
  [SMALL_STATE(4666)] = 168615,
  [SMALL_STATE(4667)] = 168641,
  [SMALL_STATE(4668)] = 168667,
  [SMALL_STATE(4669)] = 168693,
  [SMALL_STATE(4670)] = 168719,
  [SMALL_STATE(4671)] = 168745,
  [SMALL_STATE(4672)] = 168771,
  [SMALL_STATE(4673)] = 168797,
  [SMALL_STATE(4674)] = 168823,
  [SMALL_STATE(4675)] = 168849,
  [SMALL_STATE(4676)] = 168875,
  [SMALL_STATE(4677)] = 168901,
  [SMALL_STATE(4678)] = 168927,
  [SMALL_STATE(4679)] = 168954,
  [SMALL_STATE(4680)] = 168981,
  [SMALL_STATE(4681)] = 169008,
  [SMALL_STATE(4682)] = 169035,
  [SMALL_STATE(4683)] = 169062,
  [SMALL_STATE(4684)] = 169089,
  [SMALL_STATE(4685)] = 169116,
  [SMALL_STATE(4686)] = 169143,
  [SMALL_STATE(4687)] = 169170,
  [SMALL_STATE(4688)] = 169197,
  [SMALL_STATE(4689)] = 169224,
  [SMALL_STATE(4690)] = 169251,
  [SMALL_STATE(4691)] = 169278,
  [SMALL_STATE(4692)] = 169305,
  [SMALL_STATE(4693)] = 169332,
  [SMALL_STATE(4694)] = 169359,
  [SMALL_STATE(4695)] = 169386,
  [SMALL_STATE(4696)] = 169413,
  [SMALL_STATE(4697)] = 169440,
  [SMALL_STATE(4698)] = 169467,
  [SMALL_STATE(4699)] = 169494,
  [SMALL_STATE(4700)] = 169521,
  [SMALL_STATE(4701)] = 169548,
  [SMALL_STATE(4702)] = 169575,
  [SMALL_STATE(4703)] = 169602,
  [SMALL_STATE(4704)] = 169629,
  [SMALL_STATE(4705)] = 169666,
  [SMALL_STATE(4706)] = 169693,
  [SMALL_STATE(4707)] = 169720,
  [SMALL_STATE(4708)] = 169747,
  [SMALL_STATE(4709)] = 169778,
  [SMALL_STATE(4710)] = 169815,
  [SMALL_STATE(4711)] = 169842,
  [SMALL_STATE(4712)] = 169869,
  [SMALL_STATE(4713)] = 169896,
  [SMALL_STATE(4714)] = 169925,
  [SMALL_STATE(4715)] = 169952,
  [SMALL_STATE(4716)] = 169979,
  [SMALL_STATE(4717)] = 170006,
  [SMALL_STATE(4718)] = 170033,
  [SMALL_STATE(4719)] = 170060,
  [SMALL_STATE(4720)] = 170087,
  [SMALL_STATE(4721)] = 170116,
  [SMALL_STATE(4722)] = 170145,
  [SMALL_STATE(4723)] = 170172,
  [SMALL_STATE(4724)] = 170201,
  [SMALL_STATE(4725)] = 170228,
  [SMALL_STATE(4726)] = 170255,
  [SMALL_STATE(4727)] = 170282,
  [SMALL_STATE(4728)] = 170309,
  [SMALL_STATE(4729)] = 170336,
  [SMALL_STATE(4730)] = 170363,
  [SMALL_STATE(4731)] = 170390,
  [SMALL_STATE(4732)] = 170417,
  [SMALL_STATE(4733)] = 170444,
  [SMALL_STATE(4734)] = 170473,
  [SMALL_STATE(4735)] = 170500,
  [SMALL_STATE(4736)] = 170527,
  [SMALL_STATE(4737)] = 170554,
  [SMALL_STATE(4738)] = 170581,
  [SMALL_STATE(4739)] = 170608,
  [SMALL_STATE(4740)] = 170635,
  [SMALL_STATE(4741)] = 170662,
  [SMALL_STATE(4742)] = 170689,
  [SMALL_STATE(4743)] = 170716,
  [SMALL_STATE(4744)] = 170744,
  [SMALL_STATE(4745)] = 170774,
  [SMALL_STATE(4746)] = 170802,
  [SMALL_STATE(4747)] = 170832,
  [SMALL_STATE(4748)] = 170860,
  [SMALL_STATE(4749)] = 170888,
  [SMALL_STATE(4750)] = 170916,
  [SMALL_STATE(4751)] = 170944,
  [SMALL_STATE(4752)] = 170972,
  [SMALL_STATE(4753)] = 171000,
  [SMALL_STATE(4754)] = 171030,
  [SMALL_STATE(4755)] = 171056,
  [SMALL_STATE(4756)] = 171088,
  [SMALL_STATE(4757)] = 171116,
  [SMALL_STATE(4758)] = 171144,
  [SMALL_STATE(4759)] = 171172,
  [SMALL_STATE(4760)] = 171200,
  [SMALL_STATE(4761)] = 171228,
  [SMALL_STATE(4762)] = 171256,
  [SMALL_STATE(4763)] = 171286,
  [SMALL_STATE(4764)] = 171314,
  [SMALL_STATE(4765)] = 171337,
  [SMALL_STATE(4766)] = 171360,
  [SMALL_STATE(4767)] = 171383,
  [SMALL_STATE(4768)] = 171422,
  [SMALL_STATE(4769)] = 171449,
  [SMALL_STATE(4770)] = 171478,
  [SMALL_STATE(4771)] = 171505,
  [SMALL_STATE(4772)] = 171532,
  [SMALL_STATE(4773)] = 171555,
  [SMALL_STATE(4774)] = 171584,
  [SMALL_STATE(4775)] = 171611,
  [SMALL_STATE(4776)] = 171650,
  [SMALL_STATE(4777)] = 171677,
  [SMALL_STATE(4778)] = 171700,
  [SMALL_STATE(4779)] = 171723,
  [SMALL_STATE(4780)] = 171748,
  [SMALL_STATE(4781)] = 171773,
  [SMALL_STATE(4782)] = 171808,
  [SMALL_STATE(4783)] = 171835,
  [SMALL_STATE(4784)] = 171860,
  [SMALL_STATE(4785)] = 171895,
  [SMALL_STATE(4786)] = 171918,
  [SMALL_STATE(4787)] = 171941,
  [SMALL_STATE(4788)] = 171966,
  [SMALL_STATE(4789)] = 171989,
  [SMALL_STATE(4790)] = 172012,
  [SMALL_STATE(4791)] = 172035,
  [SMALL_STATE(4792)] = 172058,
  [SMALL_STATE(4793)] = 172083,
  [SMALL_STATE(4794)] = 172108,
  [SMALL_STATE(4795)] = 172135,
  [SMALL_STATE(4796)] = 172170,
  [SMALL_STATE(4797)] = 172197,
  [SMALL_STATE(4798)] = 172222,
  [SMALL_STATE(4799)] = 172257,
  [SMALL_STATE(4800)] = 172284,
  [SMALL_STATE(4801)] = 172307,
  [SMALL_STATE(4802)] = 172330,
  [SMALL_STATE(4803)] = 172355,
  [SMALL_STATE(4804)] = 172378,
  [SMALL_STATE(4805)] = 172403,
  [SMALL_STATE(4806)] = 172426,
  [SMALL_STATE(4807)] = 172451,
  [SMALL_STATE(4808)] = 172476,
  [SMALL_STATE(4809)] = 172501,
  [SMALL_STATE(4810)] = 172524,
  [SMALL_STATE(4811)] = 172549,
  [SMALL_STATE(4812)] = 172572,
  [SMALL_STATE(4813)] = 172601,
  [SMALL_STATE(4814)] = 172626,
  [SMALL_STATE(4815)] = 172649,
  [SMALL_STATE(4816)] = 172672,
  [SMALL_STATE(4817)] = 172695,
  [SMALL_STATE(4818)] = 172722,
  [SMALL_STATE(4819)] = 172745,
  [SMALL_STATE(4820)] = 172768,
  [SMALL_STATE(4821)] = 172791,
  [SMALL_STATE(4822)] = 172826,
  [SMALL_STATE(4823)] = 172849,
  [SMALL_STATE(4824)] = 172876,
  [SMALL_STATE(4825)] = 172899,
  [SMALL_STATE(4826)] = 172922,
  [SMALL_STATE(4827)] = 172945,
  [SMALL_STATE(4828)] = 172970,
  [SMALL_STATE(4829)] = 172993,
  [SMALL_STATE(4830)] = 173016,
  [SMALL_STATE(4831)] = 173041,
  [SMALL_STATE(4832)] = 173064,
  [SMALL_STATE(4833)] = 173087,
  [SMALL_STATE(4834)] = 173114,
  [SMALL_STATE(4835)] = 173137,
  [SMALL_STATE(4836)] = 173164,
  [SMALL_STATE(4837)] = 173186,
  [SMALL_STATE(4838)] = 173212,
  [SMALL_STATE(4839)] = 173250,
  [SMALL_STATE(4840)] = 173274,
  [SMALL_STATE(4841)] = 173298,
  [SMALL_STATE(4842)] = 173320,
  [SMALL_STATE(4843)] = 173356,
  [SMALL_STATE(4844)] = 173380,
  [SMALL_STATE(4845)] = 173406,
  [SMALL_STATE(4846)] = 173434,
  [SMALL_STATE(4847)] = 173458,
  [SMALL_STATE(4848)] = 173486,
  [SMALL_STATE(4849)] = 173508,
  [SMALL_STATE(4850)] = 173530,
  [SMALL_STATE(4851)] = 173554,
  [SMALL_STATE(4852)] = 173592,
  [SMALL_STATE(4853)] = 173614,
  [SMALL_STATE(4854)] = 173652,
  [SMALL_STATE(4855)] = 173674,
  [SMALL_STATE(4856)] = 173698,
  [SMALL_STATE(4857)] = 173736,
  [SMALL_STATE(4858)] = 173774,
  [SMALL_STATE(4859)] = 173796,
  [SMALL_STATE(4860)] = 173826,
  [SMALL_STATE(4861)] = 173856,
  [SMALL_STATE(4862)] = 173880,
  [SMALL_STATE(4863)] = 173904,
  [SMALL_STATE(4864)] = 173926,
  [SMALL_STATE(4865)] = 173948,
  [SMALL_STATE(4866)] = 173986,
  [SMALL_STATE(4867)] = 174024,
  [SMALL_STATE(4868)] = 174048,
  [SMALL_STATE(4869)] = 174086,
  [SMALL_STATE(4870)] = 174120,
  [SMALL_STATE(4871)] = 174144,
  [SMALL_STATE(4872)] = 174168,
  [SMALL_STATE(4873)] = 174206,
  [SMALL_STATE(4874)] = 174230,
  [SMALL_STATE(4875)] = 174254,
  [SMALL_STATE(4876)] = 174292,
  [SMALL_STATE(4877)] = 174330,
  [SMALL_STATE(4878)] = 174368,
  [SMALL_STATE(4879)] = 174394,
  [SMALL_STATE(4880)] = 174416,
  [SMALL_STATE(4881)] = 174438,
  [SMALL_STATE(4882)] = 174460,
  [SMALL_STATE(4883)] = 174498,
  [SMALL_STATE(4884)] = 174523,
  [SMALL_STATE(4885)] = 174544,
  [SMALL_STATE(4886)] = 174569,
  [SMALL_STATE(4887)] = 174594,
  [SMALL_STATE(4888)] = 174631,
  [SMALL_STATE(4889)] = 174656,
  [SMALL_STATE(4890)] = 174679,
  [SMALL_STATE(4891)] = 174716,
  [SMALL_STATE(4892)] = 174753,
  [SMALL_STATE(4893)] = 174774,
  [SMALL_STATE(4894)] = 174799,
  [SMALL_STATE(4895)] = 174820,
  [SMALL_STATE(4896)] = 174845,
  [SMALL_STATE(4897)] = 174882,
  [SMALL_STATE(4898)] = 174919,
  [SMALL_STATE(4899)] = 174956,
  [SMALL_STATE(4900)] = 174993,
  [SMALL_STATE(4901)] = 175030,
  [SMALL_STATE(4902)] = 175067,
  [SMALL_STATE(4903)] = 175104,
  [SMALL_STATE(4904)] = 175141,
  [SMALL_STATE(4905)] = 175178,
  [SMALL_STATE(4906)] = 175203,
  [SMALL_STATE(4907)] = 175240,
  [SMALL_STATE(4908)] = 175263,
  [SMALL_STATE(4909)] = 175284,
  [SMALL_STATE(4910)] = 175321,
  [SMALL_STATE(4911)] = 175342,
  [SMALL_STATE(4912)] = 175365,
  [SMALL_STATE(4913)] = 175386,
  [SMALL_STATE(4914)] = 175423,
  [SMALL_STATE(4915)] = 175460,
  [SMALL_STATE(4916)] = 175483,
  [SMALL_STATE(4917)] = 175506,
  [SMALL_STATE(4918)] = 175527,
  [SMALL_STATE(4919)] = 175564,
  [SMALL_STATE(4920)] = 175589,
  [SMALL_STATE(4921)] = 175614,
  [SMALL_STATE(4922)] = 175639,
  [SMALL_STATE(4923)] = 175664,
  [SMALL_STATE(4924)] = 175687,
  [SMALL_STATE(4925)] = 175724,
  [SMALL_STATE(4926)] = 175761,
  [SMALL_STATE(4927)] = 175798,
  [SMALL_STATE(4928)] = 175835,
  [SMALL_STATE(4929)] = 175872,
  [SMALL_STATE(4930)] = 175909,
  [SMALL_STATE(4931)] = 175946,
  [SMALL_STATE(4932)] = 175983,
  [SMALL_STATE(4933)] = 176008,
  [SMALL_STATE(4934)] = 176045,
  [SMALL_STATE(4935)] = 176070,
  [SMALL_STATE(4936)] = 176095,
  [SMALL_STATE(4937)] = 176118,
  [SMALL_STATE(4938)] = 176141,
  [SMALL_STATE(4939)] = 176163,
  [SMALL_STATE(4940)] = 176183,
  [SMALL_STATE(4941)] = 176211,
  [SMALL_STATE(4942)] = 176231,
  [SMALL_STATE(4943)] = 176251,
  [SMALL_STATE(4944)] = 176273,
  [SMALL_STATE(4945)] = 176293,
  [SMALL_STATE(4946)] = 176313,
  [SMALL_STATE(4947)] = 176333,
  [SMALL_STATE(4948)] = 176353,
  [SMALL_STATE(4949)] = 176377,
  [SMALL_STATE(4950)] = 176397,
  [SMALL_STATE(4951)] = 176417,
  [SMALL_STATE(4952)] = 176437,
  [SMALL_STATE(4953)] = 176457,
  [SMALL_STATE(4954)] = 176477,
  [SMALL_STATE(4955)] = 176501,
  [SMALL_STATE(4956)] = 176523,
  [SMALL_STATE(4957)] = 176547,
  [SMALL_STATE(4958)] = 176575,
  [SMALL_STATE(4959)] = 176595,
  [SMALL_STATE(4960)] = 176619,
  [SMALL_STATE(4961)] = 176653,
  [SMALL_STATE(4962)] = 176687,
  [SMALL_STATE(4963)] = 176707,
  [SMALL_STATE(4964)] = 176741,
  [SMALL_STATE(4965)] = 176775,
  [SMALL_STATE(4966)] = 176795,
  [SMALL_STATE(4967)] = 176829,
  [SMALL_STATE(4968)] = 176849,
  [SMALL_STATE(4969)] = 176883,
  [SMALL_STATE(4970)] = 176903,
  [SMALL_STATE(4971)] = 176927,
  [SMALL_STATE(4972)] = 176947,
  [SMALL_STATE(4973)] = 176971,
  [SMALL_STATE(4974)] = 176991,
  [SMALL_STATE(4975)] = 177011,
  [SMALL_STATE(4976)] = 177033,
  [SMALL_STATE(4977)] = 177055,
  [SMALL_STATE(4978)] = 177075,
  [SMALL_STATE(4979)] = 177095,
  [SMALL_STATE(4980)] = 177117,
  [SMALL_STATE(4981)] = 177139,
  [SMALL_STATE(4982)] = 177159,
  [SMALL_STATE(4983)] = 177179,
  [SMALL_STATE(4984)] = 177199,
  [SMALL_STATE(4985)] = 177227,
  [SMALL_STATE(4986)] = 177247,
  [SMALL_STATE(4987)] = 177279,
  [SMALL_STATE(4988)] = 177299,
  [SMALL_STATE(4989)] = 177319,
  [SMALL_STATE(4990)] = 177351,
  [SMALL_STATE(4991)] = 177373,
  [SMALL_STATE(4992)] = 177393,
  [SMALL_STATE(4993)] = 177417,
  [SMALL_STATE(4994)] = 177437,
  [SMALL_STATE(4995)] = 177471,
  [SMALL_STATE(4996)] = 177491,
  [SMALL_STATE(4997)] = 177519,
  [SMALL_STATE(4998)] = 177539,
  [SMALL_STATE(4999)] = 177573,
  [SMALL_STATE(5000)] = 177607,
  [SMALL_STATE(5001)] = 177631,
  [SMALL_STATE(5002)] = 177655,
  [SMALL_STATE(5003)] = 177689,
  [SMALL_STATE(5004)] = 177723,
  [SMALL_STATE(5005)] = 177757,
  [SMALL_STATE(5006)] = 177777,
  [SMALL_STATE(5007)] = 177797,
  [SMALL_STATE(5008)] = 177819,
  [SMALL_STATE(5009)] = 177839,
  [SMALL_STATE(5010)] = 177873,
  [SMALL_STATE(5011)] = 177907,
  [SMALL_STATE(5012)] = 177931,
  [SMALL_STATE(5013)] = 177951,
  [SMALL_STATE(5014)] = 177985,
  [SMALL_STATE(5015)] = 178019,
  [SMALL_STATE(5016)] = 178053,
  [SMALL_STATE(5017)] = 178073,
  [SMALL_STATE(5018)] = 178107,
  [SMALL_STATE(5019)] = 178127,
  [SMALL_STATE(5020)] = 178161,
  [SMALL_STATE(5021)] = 178195,
  [SMALL_STATE(5022)] = 178215,
  [SMALL_STATE(5023)] = 178245,
  [SMALL_STATE(5024)] = 178279,
  [SMALL_STATE(5025)] = 178309,
  [SMALL_STATE(5026)] = 178329,
  [SMALL_STATE(5027)] = 178361,
  [SMALL_STATE(5028)] = 178381,
  [SMALL_STATE(5029)] = 178409,
  [SMALL_STATE(5030)] = 178437,
  [SMALL_STATE(5031)] = 178457,
  [SMALL_STATE(5032)] = 178477,
  [SMALL_STATE(5033)] = 178497,
  [SMALL_STATE(5034)] = 178527,
  [SMALL_STATE(5035)] = 178555,
  [SMALL_STATE(5036)] = 178589,
  [SMALL_STATE(5037)] = 178609,
  [SMALL_STATE(5038)] = 178632,
  [SMALL_STATE(5039)] = 178659,
  [SMALL_STATE(5040)] = 178686,
  [SMALL_STATE(5041)] = 178705,
  [SMALL_STATE(5042)] = 178734,
  [SMALL_STATE(5043)] = 178763,
  [SMALL_STATE(5044)] = 178792,
  [SMALL_STATE(5045)] = 178811,
  [SMALL_STATE(5046)] = 178838,
  [SMALL_STATE(5047)] = 178867,
  [SMALL_STATE(5048)] = 178896,
  [SMALL_STATE(5049)] = 178925,
  [SMALL_STATE(5050)] = 178954,
  [SMALL_STATE(5051)] = 178977,
  [SMALL_STATE(5052)] = 179006,
  [SMALL_STATE(5053)] = 179035,
  [SMALL_STATE(5054)] = 179064,
  [SMALL_STATE(5055)] = 179093,
  [SMALL_STATE(5056)] = 179122,
  [SMALL_STATE(5057)] = 179145,
  [SMALL_STATE(5058)] = 179174,
  [SMALL_STATE(5059)] = 179201,
  [SMALL_STATE(5060)] = 179230,
  [SMALL_STATE(5061)] = 179257,
  [SMALL_STATE(5062)] = 179284,
  [SMALL_STATE(5063)] = 179313,
  [SMALL_STATE(5064)] = 179342,
  [SMALL_STATE(5065)] = 179371,
  [SMALL_STATE(5066)] = 179400,
  [SMALL_STATE(5067)] = 179423,
  [SMALL_STATE(5068)] = 179452,
  [SMALL_STATE(5069)] = 179479,
  [SMALL_STATE(5070)] = 179508,
  [SMALL_STATE(5071)] = 179535,
  [SMALL_STATE(5072)] = 179556,
  [SMALL_STATE(5073)] = 179579,
  [SMALL_STATE(5074)] = 179606,
  [SMALL_STATE(5075)] = 179635,
  [SMALL_STATE(5076)] = 179664,
  [SMALL_STATE(5077)] = 179693,
  [SMALL_STATE(5078)] = 179722,
  [SMALL_STATE(5079)] = 179751,
  [SMALL_STATE(5080)] = 179780,
  [SMALL_STATE(5081)] = 179809,
  [SMALL_STATE(5082)] = 179838,
  [SMALL_STATE(5083)] = 179867,
  [SMALL_STATE(5084)] = 179896,
  [SMALL_STATE(5085)] = 179925,
  [SMALL_STATE(5086)] = 179952,
  [SMALL_STATE(5087)] = 179981,
  [SMALL_STATE(5088)] = 180000,
  [SMALL_STATE(5089)] = 180029,
  [SMALL_STATE(5090)] = 180058,
  [SMALL_STATE(5091)] = 180087,
  [SMALL_STATE(5092)] = 180108,
  [SMALL_STATE(5093)] = 180137,
  [SMALL_STATE(5094)] = 180166,
  [SMALL_STATE(5095)] = 180193,
  [SMALL_STATE(5096)] = 180222,
  [SMALL_STATE(5097)] = 180251,
  [SMALL_STATE(5098)] = 180278,
  [SMALL_STATE(5099)] = 180307,
  [SMALL_STATE(5100)] = 180334,
  [SMALL_STATE(5101)] = 180363,
  [SMALL_STATE(5102)] = 180392,
  [SMALL_STATE(5103)] = 180419,
  [SMALL_STATE(5104)] = 180446,
  [SMALL_STATE(5105)] = 180467,
  [SMALL_STATE(5106)] = 180488,
  [SMALL_STATE(5107)] = 180509,
  [SMALL_STATE(5108)] = 180538,
  [SMALL_STATE(5109)] = 180567,
  [SMALL_STATE(5110)] = 180596,
  [SMALL_STATE(5111)] = 180615,
  [SMALL_STATE(5112)] = 180644,
  [SMALL_STATE(5113)] = 180663,
  [SMALL_STATE(5114)] = 180682,
  [SMALL_STATE(5115)] = 180711,
  [SMALL_STATE(5116)] = 180740,
  [SMALL_STATE(5117)] = 180769,
  [SMALL_STATE(5118)] = 180792,
  [SMALL_STATE(5119)] = 180811,
  [SMALL_STATE(5120)] = 180830,
  [SMALL_STATE(5121)] = 180849,
  [SMALL_STATE(5122)] = 180878,
  [SMALL_STATE(5123)] = 180907,
  [SMALL_STATE(5124)] = 180936,
  [SMALL_STATE(5125)] = 180955,
  [SMALL_STATE(5126)] = 180984,
  [SMALL_STATE(5127)] = 181013,
  [SMALL_STATE(5128)] = 181032,
  [SMALL_STATE(5129)] = 181051,
  [SMALL_STATE(5130)] = 181080,
  [SMALL_STATE(5131)] = 181107,
  [SMALL_STATE(5132)] = 181134,
  [SMALL_STATE(5133)] = 181153,
  [SMALL_STATE(5134)] = 181172,
  [SMALL_STATE(5135)] = 181199,
  [SMALL_STATE(5136)] = 181218,
  [SMALL_STATE(5137)] = 181245,
  [SMALL_STATE(5138)] = 181264,
  [SMALL_STATE(5139)] = 181283,
  [SMALL_STATE(5140)] = 181310,
  [SMALL_STATE(5141)] = 181329,
  [SMALL_STATE(5142)] = 181348,
  [SMALL_STATE(5143)] = 181367,
  [SMALL_STATE(5144)] = 181386,
  [SMALL_STATE(5145)] = 181415,
  [SMALL_STATE(5146)] = 181444,
  [SMALL_STATE(5147)] = 181471,
  [SMALL_STATE(5148)] = 181500,
  [SMALL_STATE(5149)] = 181529,
  [SMALL_STATE(5150)] = 181558,
  [SMALL_STATE(5151)] = 181577,
  [SMALL_STATE(5152)] = 181604,
  [SMALL_STATE(5153)] = 181631,
  [SMALL_STATE(5154)] = 181658,
  [SMALL_STATE(5155)] = 181687,
  [SMALL_STATE(5156)] = 181716,
  [SMALL_STATE(5157)] = 181745,
  [SMALL_STATE(5158)] = 181772,
  [SMALL_STATE(5159)] = 181799,
  [SMALL_STATE(5160)] = 181826,
  [SMALL_STATE(5161)] = 181855,
  [SMALL_STATE(5162)] = 181884,
  [SMALL_STATE(5163)] = 181913,
  [SMALL_STATE(5164)] = 181938,
  [SMALL_STATE(5165)] = 181965,
  [SMALL_STATE(5166)] = 181994,
  [SMALL_STATE(5167)] = 182023,
  [SMALL_STATE(5168)] = 182046,
  [SMALL_STATE(5169)] = 182075,
  [SMALL_STATE(5170)] = 182104,
  [SMALL_STATE(5171)] = 182133,
  [SMALL_STATE(5172)] = 182160,
  [SMALL_STATE(5173)] = 182189,
  [SMALL_STATE(5174)] = 182218,
  [SMALL_STATE(5175)] = 182245,
  [SMALL_STATE(5176)] = 182274,
  [SMALL_STATE(5177)] = 182303,
  [SMALL_STATE(5178)] = 182332,
  [SMALL_STATE(5179)] = 182359,
  [SMALL_STATE(5180)] = 182388,
  [SMALL_STATE(5181)] = 182415,
  [SMALL_STATE(5182)] = 182444,
  [SMALL_STATE(5183)] = 182471,
  [SMALL_STATE(5184)] = 182500,
  [SMALL_STATE(5185)] = 182527,
  [SMALL_STATE(5186)] = 182554,
  [SMALL_STATE(5187)] = 182583,
  [SMALL_STATE(5188)] = 182610,
  [SMALL_STATE(5189)] = 182637,
  [SMALL_STATE(5190)] = 182664,
  [SMALL_STATE(5191)] = 182691,
  [SMALL_STATE(5192)] = 182718,
  [SMALL_STATE(5193)] = 182745,
  [SMALL_STATE(5194)] = 182772,
  [SMALL_STATE(5195)] = 182799,
  [SMALL_STATE(5196)] = 182826,
  [SMALL_STATE(5197)] = 182853,
  [SMALL_STATE(5198)] = 182880,
  [SMALL_STATE(5199)] = 182909,
  [SMALL_STATE(5200)] = 182936,
  [SMALL_STATE(5201)] = 182965,
  [SMALL_STATE(5202)] = 182994,
  [SMALL_STATE(5203)] = 183023,
  [SMALL_STATE(5204)] = 183052,
  [SMALL_STATE(5205)] = 183081,
  [SMALL_STATE(5206)] = 183110,
  [SMALL_STATE(5207)] = 183139,
  [SMALL_STATE(5208)] = 183168,
  [SMALL_STATE(5209)] = 183195,
  [SMALL_STATE(5210)] = 183224,
  [SMALL_STATE(5211)] = 183253,
  [SMALL_STATE(5212)] = 183278,
  [SMALL_STATE(5213)] = 183297,
  [SMALL_STATE(5214)] = 183324,
  [SMALL_STATE(5215)] = 183352,
  [SMALL_STATE(5216)] = 183374,
  [SMALL_STATE(5217)] = 183402,
  [SMALL_STATE(5218)] = 183426,
  [SMALL_STATE(5219)] = 183454,
  [SMALL_STATE(5220)] = 183474,
  [SMALL_STATE(5221)] = 183502,
  [SMALL_STATE(5222)] = 183520,
  [SMALL_STATE(5223)] = 183544,
  [SMALL_STATE(5224)] = 183572,
  [SMALL_STATE(5225)] = 183596,
  [SMALL_STATE(5226)] = 183618,
  [SMALL_STATE(5227)] = 183642,
  [SMALL_STATE(5228)] = 183660,
  [SMALL_STATE(5229)] = 183688,
  [SMALL_STATE(5230)] = 183716,
  [SMALL_STATE(5231)] = 183738,
  [SMALL_STATE(5232)] = 183758,
  [SMALL_STATE(5233)] = 183786,
  [SMALL_STATE(5234)] = 183808,
  [SMALL_STATE(5235)] = 183830,
  [SMALL_STATE(5236)] = 183858,
  [SMALL_STATE(5237)] = 183878,
  [SMALL_STATE(5238)] = 183900,
  [SMALL_STATE(5239)] = 183928,
  [SMALL_STATE(5240)] = 183950,
  [SMALL_STATE(5241)] = 183978,
  [SMALL_STATE(5242)] = 184000,
  [SMALL_STATE(5243)] = 184028,
  [SMALL_STATE(5244)] = 184046,
  [SMALL_STATE(5245)] = 184064,
  [SMALL_STATE(5246)] = 184082,
  [SMALL_STATE(5247)] = 184110,
  [SMALL_STATE(5248)] = 184136,
  [SMALL_STATE(5249)] = 184160,
  [SMALL_STATE(5250)] = 184188,
  [SMALL_STATE(5251)] = 184216,
  [SMALL_STATE(5252)] = 184244,
  [SMALL_STATE(5253)] = 184264,
  [SMALL_STATE(5254)] = 184292,
  [SMALL_STATE(5255)] = 184320,
  [SMALL_STATE(5256)] = 184348,
  [SMALL_STATE(5257)] = 184376,
  [SMALL_STATE(5258)] = 184396,
  [SMALL_STATE(5259)] = 184424,
  [SMALL_STATE(5260)] = 184442,
  [SMALL_STATE(5261)] = 184462,
  [SMALL_STATE(5262)] = 184482,
  [SMALL_STATE(5263)] = 184504,
  [SMALL_STATE(5264)] = 184530,
  [SMALL_STATE(5265)] = 184554,
  [SMALL_STATE(5266)] = 184576,
  [SMALL_STATE(5267)] = 184604,
  [SMALL_STATE(5268)] = 184624,
  [SMALL_STATE(5269)] = 184652,
  [SMALL_STATE(5270)] = 184680,
  [SMALL_STATE(5271)] = 184708,
  [SMALL_STATE(5272)] = 184728,
  [SMALL_STATE(5273)] = 184752,
  [SMALL_STATE(5274)] = 184780,
  [SMALL_STATE(5275)] = 184808,
  [SMALL_STATE(5276)] = 184826,
  [SMALL_STATE(5277)] = 184844,
  [SMALL_STATE(5278)] = 184864,
  [SMALL_STATE(5279)] = 184892,
  [SMALL_STATE(5280)] = 184920,
  [SMALL_STATE(5281)] = 184948,
  [SMALL_STATE(5282)] = 184976,
  [SMALL_STATE(5283)] = 185004,
  [SMALL_STATE(5284)] = 185022,
  [SMALL_STATE(5285)] = 185040,
  [SMALL_STATE(5286)] = 185060,
  [SMALL_STATE(5287)] = 185078,
  [SMALL_STATE(5288)] = 185098,
  [SMALL_STATE(5289)] = 185122,
  [SMALL_STATE(5290)] = 185150,
  [SMALL_STATE(5291)] = 185167,
  [SMALL_STATE(5292)] = 185186,
  [SMALL_STATE(5293)] = 185205,
  [SMALL_STATE(5294)] = 185228,
  [SMALL_STATE(5295)] = 185251,
  [SMALL_STATE(5296)] = 185274,
  [SMALL_STATE(5297)] = 185293,
  [SMALL_STATE(5298)] = 185314,
  [SMALL_STATE(5299)] = 185333,
  [SMALL_STATE(5300)] = 185352,
  [SMALL_STATE(5301)] = 185375,
  [SMALL_STATE(5302)] = 185398,
  [SMALL_STATE(5303)] = 185419,
  [SMALL_STATE(5304)] = 185440,
  [SMALL_STATE(5305)] = 185461,
  [SMALL_STATE(5306)] = 185480,
  [SMALL_STATE(5307)] = 185503,
  [SMALL_STATE(5308)] = 185524,
  [SMALL_STATE(5309)] = 185543,
  [SMALL_STATE(5310)] = 185566,
  [SMALL_STATE(5311)] = 185585,
  [SMALL_STATE(5312)] = 185604,
  [SMALL_STATE(5313)] = 185621,
  [SMALL_STATE(5314)] = 185644,
  [SMALL_STATE(5315)] = 185665,
  [SMALL_STATE(5316)] = 185688,
  [SMALL_STATE(5317)] = 185711,
  [SMALL_STATE(5318)] = 185734,
  [SMALL_STATE(5319)] = 185757,
  [SMALL_STATE(5320)] = 185774,
  [SMALL_STATE(5321)] = 185793,
  [SMALL_STATE(5322)] = 185814,
  [SMALL_STATE(5323)] = 185833,
  [SMALL_STATE(5324)] = 185852,
  [SMALL_STATE(5325)] = 185871,
  [SMALL_STATE(5326)] = 185888,
  [SMALL_STATE(5327)] = 185911,
  [SMALL_STATE(5328)] = 185927,
  [SMALL_STATE(5329)] = 185943,
  [SMALL_STATE(5330)] = 185959,
  [SMALL_STATE(5331)] = 185975,
  [SMALL_STATE(5332)] = 185991,
  [SMALL_STATE(5333)] = 186007,
  [SMALL_STATE(5334)] = 186023,
  [SMALL_STATE(5335)] = 186041,
  [SMALL_STATE(5336)] = 186057,
  [SMALL_STATE(5337)] = 186073,
  [SMALL_STATE(5338)] = 186089,
  [SMALL_STATE(5339)] = 186105,
  [SMALL_STATE(5340)] = 186121,
  [SMALL_STATE(5341)] = 186137,
  [SMALL_STATE(5342)] = 186153,
  [SMALL_STATE(5343)] = 186169,
  [SMALL_STATE(5344)] = 186185,
  [SMALL_STATE(5345)] = 186205,
  [SMALL_STATE(5346)] = 186221,
  [SMALL_STATE(5347)] = 186237,
  [SMALL_STATE(5348)] = 186253,
  [SMALL_STATE(5349)] = 186269,
  [SMALL_STATE(5350)] = 186285,
  [SMALL_STATE(5351)] = 186301,
  [SMALL_STATE(5352)] = 186317,
  [SMALL_STATE(5353)] = 186333,
  [SMALL_STATE(5354)] = 186349,
  [SMALL_STATE(5355)] = 186365,
  [SMALL_STATE(5356)] = 186381,
  [SMALL_STATE(5357)] = 186397,
  [SMALL_STATE(5358)] = 186413,
  [SMALL_STATE(5359)] = 186429,
  [SMALL_STATE(5360)] = 186445,
  [SMALL_STATE(5361)] = 186461,
  [SMALL_STATE(5362)] = 186477,
  [SMALL_STATE(5363)] = 186493,
  [SMALL_STATE(5364)] = 186509,
  [SMALL_STATE(5365)] = 186525,
  [SMALL_STATE(5366)] = 186541,
  [SMALL_STATE(5367)] = 186557,
  [SMALL_STATE(5368)] = 186573,
  [SMALL_STATE(5369)] = 186589,
  [SMALL_STATE(5370)] = 186605,
  [SMALL_STATE(5371)] = 186621,
  [SMALL_STATE(5372)] = 186637,
  [SMALL_STATE(5373)] = 186653,
  [SMALL_STATE(5374)] = 186669,
  [SMALL_STATE(5375)] = 186685,
  [SMALL_STATE(5376)] = 186701,
  [SMALL_STATE(5377)] = 186717,
  [SMALL_STATE(5378)] = 186735,
  [SMALL_STATE(5379)] = 186751,
  [SMALL_STATE(5380)] = 186767,
  [SMALL_STATE(5381)] = 186783,
  [SMALL_STATE(5382)] = 186799,
  [SMALL_STATE(5383)] = 186819,
  [SMALL_STATE(5384)] = 186835,
  [SMALL_STATE(5385)] = 186851,
  [SMALL_STATE(5386)] = 186867,
  [SMALL_STATE(5387)] = 186889,
  [SMALL_STATE(5388)] = 186905,
  [SMALL_STATE(5389)] = 186921,
  [SMALL_STATE(5390)] = 186937,
  [SMALL_STATE(5391)] = 186955,
  [SMALL_STATE(5392)] = 186971,
  [SMALL_STATE(5393)] = 186987,
  [SMALL_STATE(5394)] = 187005,
  [SMALL_STATE(5395)] = 187025,
  [SMALL_STATE(5396)] = 187045,
  [SMALL_STATE(5397)] = 187061,
  [SMALL_STATE(5398)] = 187081,
  [SMALL_STATE(5399)] = 187097,
  [SMALL_STATE(5400)] = 187113,
  [SMALL_STATE(5401)] = 187129,
  [SMALL_STATE(5402)] = 187145,
  [SMALL_STATE(5403)] = 187161,
  [SMALL_STATE(5404)] = 187181,
  [SMALL_STATE(5405)] = 187197,
  [SMALL_STATE(5406)] = 187215,
  [SMALL_STATE(5407)] = 187231,
  [SMALL_STATE(5408)] = 187251,
  [SMALL_STATE(5409)] = 187271,
  [SMALL_STATE(5410)] = 187287,
  [SMALL_STATE(5411)] = 187307,
  [SMALL_STATE(5412)] = 187323,
  [SMALL_STATE(5413)] = 187339,
  [SMALL_STATE(5414)] = 187355,
  [SMALL_STATE(5415)] = 187375,
  [SMALL_STATE(5416)] = 187397,
  [SMALL_STATE(5417)] = 187419,
  [SMALL_STATE(5418)] = 187435,
  [SMALL_STATE(5419)] = 187451,
  [SMALL_STATE(5420)] = 187467,
  [SMALL_STATE(5421)] = 187485,
  [SMALL_STATE(5422)] = 187501,
  [SMALL_STATE(5423)] = 187521,
  [SMALL_STATE(5424)] = 187537,
  [SMALL_STATE(5425)] = 187553,
  [SMALL_STATE(5426)] = 187569,
  [SMALL_STATE(5427)] = 187585,
  [SMALL_STATE(5428)] = 187601,
  [SMALL_STATE(5429)] = 187617,
  [SMALL_STATE(5430)] = 187633,
  [SMALL_STATE(5431)] = 187651,
  [SMALL_STATE(5432)] = 187667,
  [SMALL_STATE(5433)] = 187683,
  [SMALL_STATE(5434)] = 187699,
  [SMALL_STATE(5435)] = 187715,
  [SMALL_STATE(5436)] = 187731,
  [SMALL_STATE(5437)] = 187747,
  [SMALL_STATE(5438)] = 187763,
  [SMALL_STATE(5439)] = 187783,
  [SMALL_STATE(5440)] = 187799,
  [SMALL_STATE(5441)] = 187815,
  [SMALL_STATE(5442)] = 187831,
  [SMALL_STATE(5443)] = 187847,
  [SMALL_STATE(5444)] = 187863,
  [SMALL_STATE(5445)] = 187879,
  [SMALL_STATE(5446)] = 187897,
  [SMALL_STATE(5447)] = 187913,
  [SMALL_STATE(5448)] = 187929,
  [SMALL_STATE(5449)] = 187951,
  [SMALL_STATE(5450)] = 187969,
  [SMALL_STATE(5451)] = 187985,
  [SMALL_STATE(5452)] = 188001,
  [SMALL_STATE(5453)] = 188017,
  [SMALL_STATE(5454)] = 188033,
  [SMALL_STATE(5455)] = 188049,
  [SMALL_STATE(5456)] = 188065,
  [SMALL_STATE(5457)] = 188081,
  [SMALL_STATE(5458)] = 188097,
  [SMALL_STATE(5459)] = 188113,
  [SMALL_STATE(5460)] = 188129,
  [SMALL_STATE(5461)] = 188145,
  [SMALL_STATE(5462)] = 188163,
  [SMALL_STATE(5463)] = 188181,
  [SMALL_STATE(5464)] = 188199,
  [SMALL_STATE(5465)] = 188215,
  [SMALL_STATE(5466)] = 188231,
  [SMALL_STATE(5467)] = 188247,
  [SMALL_STATE(5468)] = 188263,
  [SMALL_STATE(5469)] = 188283,
  [SMALL_STATE(5470)] = 188299,
  [SMALL_STATE(5471)] = 188315,
  [SMALL_STATE(5472)] = 188331,
  [SMALL_STATE(5473)] = 188347,
  [SMALL_STATE(5474)] = 188363,
  [SMALL_STATE(5475)] = 188379,
  [SMALL_STATE(5476)] = 188395,
  [SMALL_STATE(5477)] = 188411,
  [SMALL_STATE(5478)] = 188427,
  [SMALL_STATE(5479)] = 188443,
  [SMALL_STATE(5480)] = 188459,
  [SMALL_STATE(5481)] = 188475,
  [SMALL_STATE(5482)] = 188495,
  [SMALL_STATE(5483)] = 188511,
  [SMALL_STATE(5484)] = 188527,
  [SMALL_STATE(5485)] = 188547,
  [SMALL_STATE(5486)] = 188567,
  [SMALL_STATE(5487)] = 188583,
  [SMALL_STATE(5488)] = 188599,
  [SMALL_STATE(5489)] = 188615,
  [SMALL_STATE(5490)] = 188631,
  [SMALL_STATE(5491)] = 188651,
  [SMALL_STATE(5492)] = 188667,
  [SMALL_STATE(5493)] = 188683,
  [SMALL_STATE(5494)] = 188703,
  [SMALL_STATE(5495)] = 188721,
  [SMALL_STATE(5496)] = 188736,
  [SMALL_STATE(5497)] = 188755,
  [SMALL_STATE(5498)] = 188774,
  [SMALL_STATE(5499)] = 188793,
  [SMALL_STATE(5500)] = 188808,
  [SMALL_STATE(5501)] = 188823,
  [SMALL_STATE(5502)] = 188842,
  [SMALL_STATE(5503)] = 188861,
  [SMALL_STATE(5504)] = 188878,
  [SMALL_STATE(5505)] = 188895,
  [SMALL_STATE(5506)] = 188910,
  [SMALL_STATE(5507)] = 188927,
  [SMALL_STATE(5508)] = 188944,
  [SMALL_STATE(5509)] = 188963,
  [SMALL_STATE(5510)] = 188982,
  [SMALL_STATE(5511)] = 189001,
  [SMALL_STATE(5512)] = 189016,
  [SMALL_STATE(5513)] = 189033,
  [SMALL_STATE(5514)] = 189052,
  [SMALL_STATE(5515)] = 189071,
  [SMALL_STATE(5516)] = 189090,
  [SMALL_STATE(5517)] = 189107,
  [SMALL_STATE(5518)] = 189126,
  [SMALL_STATE(5519)] = 189145,
  [SMALL_STATE(5520)] = 189164,
  [SMALL_STATE(5521)] = 189179,
  [SMALL_STATE(5522)] = 189194,
  [SMALL_STATE(5523)] = 189213,
  [SMALL_STATE(5524)] = 189232,
  [SMALL_STATE(5525)] = 189251,
  [SMALL_STATE(5526)] = 189270,
  [SMALL_STATE(5527)] = 189289,
  [SMALL_STATE(5528)] = 189308,
  [SMALL_STATE(5529)] = 189327,
  [SMALL_STATE(5530)] = 189346,
  [SMALL_STATE(5531)] = 189365,
  [SMALL_STATE(5532)] = 189384,
  [SMALL_STATE(5533)] = 189403,
  [SMALL_STATE(5534)] = 189422,
  [SMALL_STATE(5535)] = 189441,
  [SMALL_STATE(5536)] = 189460,
  [SMALL_STATE(5537)] = 189479,
  [SMALL_STATE(5538)] = 189498,
  [SMALL_STATE(5539)] = 189517,
  [SMALL_STATE(5540)] = 189532,
  [SMALL_STATE(5541)] = 189551,
  [SMALL_STATE(5542)] = 189570,
  [SMALL_STATE(5543)] = 189589,
  [SMALL_STATE(5544)] = 189604,
  [SMALL_STATE(5545)] = 189623,
  [SMALL_STATE(5546)] = 189638,
  [SMALL_STATE(5547)] = 189657,
  [SMALL_STATE(5548)] = 189674,
  [SMALL_STATE(5549)] = 189693,
  [SMALL_STATE(5550)] = 189710,
  [SMALL_STATE(5551)] = 189729,
  [SMALL_STATE(5552)] = 189748,
  [SMALL_STATE(5553)] = 189763,
  [SMALL_STATE(5554)] = 189778,
  [SMALL_STATE(5555)] = 189797,
  [SMALL_STATE(5556)] = 189816,
  [SMALL_STATE(5557)] = 189835,
  [SMALL_STATE(5558)] = 189854,
  [SMALL_STATE(5559)] = 189873,
  [SMALL_STATE(5560)] = 189890,
  [SMALL_STATE(5561)] = 189909,
  [SMALL_STATE(5562)] = 189928,
  [SMALL_STATE(5563)] = 189945,
  [SMALL_STATE(5564)] = 189964,
  [SMALL_STATE(5565)] = 189979,
  [SMALL_STATE(5566)] = 189994,
  [SMALL_STATE(5567)] = 190011,
  [SMALL_STATE(5568)] = 190030,
  [SMALL_STATE(5569)] = 190047,
  [SMALL_STATE(5570)] = 190064,
  [SMALL_STATE(5571)] = 190083,
  [SMALL_STATE(5572)] = 190102,
  [SMALL_STATE(5573)] = 190121,
  [SMALL_STATE(5574)] = 190140,
  [SMALL_STATE(5575)] = 190155,
  [SMALL_STATE(5576)] = 190174,
  [SMALL_STATE(5577)] = 190193,
  [SMALL_STATE(5578)] = 190208,
  [SMALL_STATE(5579)] = 190222,
  [SMALL_STATE(5580)] = 190236,
  [SMALL_STATE(5581)] = 190250,
  [SMALL_STATE(5582)] = 190264,
  [SMALL_STATE(5583)] = 190278,
  [SMALL_STATE(5584)] = 190292,
  [SMALL_STATE(5585)] = 190306,
  [SMALL_STATE(5586)] = 190320,
  [SMALL_STATE(5587)] = 190336,
  [SMALL_STATE(5588)] = 190350,
  [SMALL_STATE(5589)] = 190364,
  [SMALL_STATE(5590)] = 190378,
  [SMALL_STATE(5591)] = 190394,
  [SMALL_STATE(5592)] = 190408,
  [SMALL_STATE(5593)] = 190422,
  [SMALL_STATE(5594)] = 190436,
  [SMALL_STATE(5595)] = 190450,
  [SMALL_STATE(5596)] = 190464,
  [SMALL_STATE(5597)] = 190478,
  [SMALL_STATE(5598)] = 190494,
  [SMALL_STATE(5599)] = 190508,
  [SMALL_STATE(5600)] = 190522,
  [SMALL_STATE(5601)] = 190536,
  [SMALL_STATE(5602)] = 190550,
  [SMALL_STATE(5603)] = 190566,
  [SMALL_STATE(5604)] = 190580,
  [SMALL_STATE(5605)] = 190594,
  [SMALL_STATE(5606)] = 190608,
  [SMALL_STATE(5607)] = 190622,
  [SMALL_STATE(5608)] = 190638,
  [SMALL_STATE(5609)] = 190652,
  [SMALL_STATE(5610)] = 190666,
  [SMALL_STATE(5611)] = 190680,
  [SMALL_STATE(5612)] = 190694,
  [SMALL_STATE(5613)] = 190708,
  [SMALL_STATE(5614)] = 190722,
  [SMALL_STATE(5615)] = 190736,
  [SMALL_STATE(5616)] = 190750,
  [SMALL_STATE(5617)] = 190764,
  [SMALL_STATE(5618)] = 190778,
  [SMALL_STATE(5619)] = 190792,
  [SMALL_STATE(5620)] = 190806,
  [SMALL_STATE(5621)] = 190820,
  [SMALL_STATE(5622)] = 190834,
  [SMALL_STATE(5623)] = 190848,
  [SMALL_STATE(5624)] = 190862,
  [SMALL_STATE(5625)] = 190876,
  [SMALL_STATE(5626)] = 190892,
  [SMALL_STATE(5627)] = 190906,
  [SMALL_STATE(5628)] = 190920,
  [SMALL_STATE(5629)] = 190934,
  [SMALL_STATE(5630)] = 190948,
  [SMALL_STATE(5631)] = 190964,
  [SMALL_STATE(5632)] = 190978,
  [SMALL_STATE(5633)] = 190992,
  [SMALL_STATE(5634)] = 191006,
  [SMALL_STATE(5635)] = 191020,
  [SMALL_STATE(5636)] = 191034,
  [SMALL_STATE(5637)] = 191050,
  [SMALL_STATE(5638)] = 191064,
  [SMALL_STATE(5639)] = 191080,
  [SMALL_STATE(5640)] = 191094,
  [SMALL_STATE(5641)] = 191107,
  [SMALL_STATE(5642)] = 191120,
  [SMALL_STATE(5643)] = 191133,
  [SMALL_STATE(5644)] = 191146,
  [SMALL_STATE(5645)] = 191159,
  [SMALL_STATE(5646)] = 191172,
  [SMALL_STATE(5647)] = 191185,
  [SMALL_STATE(5648)] = 191198,
  [SMALL_STATE(5649)] = 191211,
  [SMALL_STATE(5650)] = 191224,
  [SMALL_STATE(5651)] = 191237,
  [SMALL_STATE(5652)] = 191250,
  [SMALL_STATE(5653)] = 191263,
  [SMALL_STATE(5654)] = 191276,
  [SMALL_STATE(5655)] = 191289,
  [SMALL_STATE(5656)] = 191302,
  [SMALL_STATE(5657)] = 191315,
  [SMALL_STATE(5658)] = 191328,
  [SMALL_STATE(5659)] = 191341,
  [SMALL_STATE(5660)] = 191354,
  [SMALL_STATE(5661)] = 191367,
  [SMALL_STATE(5662)] = 191380,
  [SMALL_STATE(5663)] = 191393,
  [SMALL_STATE(5664)] = 191406,
  [SMALL_STATE(5665)] = 191419,
  [SMALL_STATE(5666)] = 191432,
  [SMALL_STATE(5667)] = 191445,
  [SMALL_STATE(5668)] = 191458,
  [SMALL_STATE(5669)] = 191471,
  [SMALL_STATE(5670)] = 191484,
  [SMALL_STATE(5671)] = 191497,
  [SMALL_STATE(5672)] = 191510,
  [SMALL_STATE(5673)] = 191523,
  [SMALL_STATE(5674)] = 191536,
  [SMALL_STATE(5675)] = 191549,
  [SMALL_STATE(5676)] = 191562,
  [SMALL_STATE(5677)] = 191575,
  [SMALL_STATE(5678)] = 191588,
  [SMALL_STATE(5679)] = 191601,
  [SMALL_STATE(5680)] = 191614,
  [SMALL_STATE(5681)] = 191627,
  [SMALL_STATE(5682)] = 191640,
  [SMALL_STATE(5683)] = 191653,
  [SMALL_STATE(5684)] = 191666,
  [SMALL_STATE(5685)] = 191679,
  [SMALL_STATE(5686)] = 191692,
  [SMALL_STATE(5687)] = 191705,
  [SMALL_STATE(5688)] = 191718,
  [SMALL_STATE(5689)] = 191731,
  [SMALL_STATE(5690)] = 191744,
  [SMALL_STATE(5691)] = 191757,
  [SMALL_STATE(5692)] = 191770,
  [SMALL_STATE(5693)] = 191783,
  [SMALL_STATE(5694)] = 191796,
  [SMALL_STATE(5695)] = 191809,
  [SMALL_STATE(5696)] = 191822,
  [SMALL_STATE(5697)] = 191835,
  [SMALL_STATE(5698)] = 191848,
  [SMALL_STATE(5699)] = 191861,
  [SMALL_STATE(5700)] = 191874,
  [SMALL_STATE(5701)] = 191887,
  [SMALL_STATE(5702)] = 191900,
  [SMALL_STATE(5703)] = 191913,
  [SMALL_STATE(5704)] = 191926,
  [SMALL_STATE(5705)] = 191939,
  [SMALL_STATE(5706)] = 191952,
  [SMALL_STATE(5707)] = 191965,
  [SMALL_STATE(5708)] = 191978,
  [SMALL_STATE(5709)] = 191991,
  [SMALL_STATE(5710)] = 192004,
  [SMALL_STATE(5711)] = 192017,
  [SMALL_STATE(5712)] = 192030,
  [SMALL_STATE(5713)] = 192043,
  [SMALL_STATE(5714)] = 192056,
  [SMALL_STATE(5715)] = 192069,
  [SMALL_STATE(5716)] = 192082,
  [SMALL_STATE(5717)] = 192095,
  [SMALL_STATE(5718)] = 192108,
  [SMALL_STATE(5719)] = 192121,
  [SMALL_STATE(5720)] = 192134,
  [SMALL_STATE(5721)] = 192147,
  [SMALL_STATE(5722)] = 192160,
  [SMALL_STATE(5723)] = 192173,
  [SMALL_STATE(5724)] = 192186,
  [SMALL_STATE(5725)] = 192199,
  [SMALL_STATE(5726)] = 192212,
  [SMALL_STATE(5727)] = 192225,
  [SMALL_STATE(5728)] = 192238,
  [SMALL_STATE(5729)] = 192251,
  [SMALL_STATE(5730)] = 192264,
  [SMALL_STATE(5731)] = 192277,
  [SMALL_STATE(5732)] = 192290,
  [SMALL_STATE(5733)] = 192303,
  [SMALL_STATE(5734)] = 192316,
  [SMALL_STATE(5735)] = 192329,
  [SMALL_STATE(5736)] = 192342,
  [SMALL_STATE(5737)] = 192355,
  [SMALL_STATE(5738)] = 192368,
  [SMALL_STATE(5739)] = 192381,
  [SMALL_STATE(5740)] = 192394,
  [SMALL_STATE(5741)] = 192407,
  [SMALL_STATE(5742)] = 192420,
  [SMALL_STATE(5743)] = 192433,
  [SMALL_STATE(5744)] = 192446,
  [SMALL_STATE(5745)] = 192459,
  [SMALL_STATE(5746)] = 192472,
  [SMALL_STATE(5747)] = 192485,
  [SMALL_STATE(5748)] = 192498,
  [SMALL_STATE(5749)] = 192511,
  [SMALL_STATE(5750)] = 192524,
  [SMALL_STATE(5751)] = 192537,
  [SMALL_STATE(5752)] = 192550,
  [SMALL_STATE(5753)] = 192563,
  [SMALL_STATE(5754)] = 192576,
  [SMALL_STATE(5755)] = 192589,
  [SMALL_STATE(5756)] = 192602,
  [SMALL_STATE(5757)] = 192615,
  [SMALL_STATE(5758)] = 192628,
  [SMALL_STATE(5759)] = 192641,
  [SMALL_STATE(5760)] = 192654,
  [SMALL_STATE(5761)] = 192667,
  [SMALL_STATE(5762)] = 192680,
  [SMALL_STATE(5763)] = 192693,
  [SMALL_STATE(5764)] = 192706,
  [SMALL_STATE(5765)] = 192719,
  [SMALL_STATE(5766)] = 192732,
  [SMALL_STATE(5767)] = 192745,
  [SMALL_STATE(5768)] = 192758,
  [SMALL_STATE(5769)] = 192771,
  [SMALL_STATE(5770)] = 192784,
  [SMALL_STATE(5771)] = 192797,
  [SMALL_STATE(5772)] = 192810,
  [SMALL_STATE(5773)] = 192823,
  [SMALL_STATE(5774)] = 192836,
  [SMALL_STATE(5775)] = 192849,
  [SMALL_STATE(5776)] = 192862,
  [SMALL_STATE(5777)] = 192875,
  [SMALL_STATE(5778)] = 192888,
  [SMALL_STATE(5779)] = 192901,
  [SMALL_STATE(5780)] = 192914,
  [SMALL_STATE(5781)] = 192927,
  [SMALL_STATE(5782)] = 192940,
  [SMALL_STATE(5783)] = 192953,
  [SMALL_STATE(5784)] = 192966,
  [SMALL_STATE(5785)] = 192979,
  [SMALL_STATE(5786)] = 192992,
  [SMALL_STATE(5787)] = 193005,
  [SMALL_STATE(5788)] = 193018,
  [SMALL_STATE(5789)] = 193031,
  [SMALL_STATE(5790)] = 193044,
  [SMALL_STATE(5791)] = 193057,
  [SMALL_STATE(5792)] = 193070,
  [SMALL_STATE(5793)] = 193083,
  [SMALL_STATE(5794)] = 193096,
  [SMALL_STATE(5795)] = 193109,
  [SMALL_STATE(5796)] = 193122,
  [SMALL_STATE(5797)] = 193135,
  [SMALL_STATE(5798)] = 193148,
  [SMALL_STATE(5799)] = 193161,
  [SMALL_STATE(5800)] = 193174,
  [SMALL_STATE(5801)] = 193187,
  [SMALL_STATE(5802)] = 193200,
  [SMALL_STATE(5803)] = 193213,
  [SMALL_STATE(5804)] = 193226,
  [SMALL_STATE(5805)] = 193239,
  [SMALL_STATE(5806)] = 193252,
  [SMALL_STATE(5807)] = 193265,
  [SMALL_STATE(5808)] = 193278,
  [SMALL_STATE(5809)] = 193291,
  [SMALL_STATE(5810)] = 193304,
  [SMALL_STATE(5811)] = 193317,
  [SMALL_STATE(5812)] = 193330,
  [SMALL_STATE(5813)] = 193343,
  [SMALL_STATE(5814)] = 193356,
  [SMALL_STATE(5815)] = 193369,
  [SMALL_STATE(5816)] = 193382,
  [SMALL_STATE(5817)] = 193395,
  [SMALL_STATE(5818)] = 193408,
  [SMALL_STATE(5819)] = 193421,
  [SMALL_STATE(5820)] = 193434,
  [SMALL_STATE(5821)] = 193447,
  [SMALL_STATE(5822)] = 193460,
  [SMALL_STATE(5823)] = 193473,
  [SMALL_STATE(5824)] = 193486,
  [SMALL_STATE(5825)] = 193499,
  [SMALL_STATE(5826)] = 193512,
  [SMALL_STATE(5827)] = 193525,
  [SMALL_STATE(5828)] = 193538,
  [SMALL_STATE(5829)] = 193551,
  [SMALL_STATE(5830)] = 193564,
  [SMALL_STATE(5831)] = 193577,
  [SMALL_STATE(5832)] = 193590,
  [SMALL_STATE(5833)] = 193603,
  [SMALL_STATE(5834)] = 193616,
  [SMALL_STATE(5835)] = 193629,
  [SMALL_STATE(5836)] = 193642,
  [SMALL_STATE(5837)] = 193655,
  [SMALL_STATE(5838)] = 193668,
  [SMALL_STATE(5839)] = 193681,
  [SMALL_STATE(5840)] = 193694,
  [SMALL_STATE(5841)] = 193707,
  [SMALL_STATE(5842)] = 193720,
  [SMALL_STATE(5843)] = 193733,
  [SMALL_STATE(5844)] = 193746,
  [SMALL_STATE(5845)] = 193759,
  [SMALL_STATE(5846)] = 193772,
  [SMALL_STATE(5847)] = 193785,
  [SMALL_STATE(5848)] = 193798,
  [SMALL_STATE(5849)] = 193811,
  [SMALL_STATE(5850)] = 193824,
  [SMALL_STATE(5851)] = 193837,
  [SMALL_STATE(5852)] = 193850,
  [SMALL_STATE(5853)] = 193863,
  [SMALL_STATE(5854)] = 193876,
  [SMALL_STATE(5855)] = 193889,
  [SMALL_STATE(5856)] = 193902,
  [SMALL_STATE(5857)] = 193915,
  [SMALL_STATE(5858)] = 193928,
  [SMALL_STATE(5859)] = 193941,
  [SMALL_STATE(5860)] = 193954,
  [SMALL_STATE(5861)] = 193967,
  [SMALL_STATE(5862)] = 193980,
  [SMALL_STATE(5863)] = 193993,
  [SMALL_STATE(5864)] = 194006,
  [SMALL_STATE(5865)] = 194019,
  [SMALL_STATE(5866)] = 194032,
  [SMALL_STATE(5867)] = 194045,
  [SMALL_STATE(5868)] = 194058,
  [SMALL_STATE(5869)] = 194071,
  [SMALL_STATE(5870)] = 194084,
  [SMALL_STATE(5871)] = 194097,
  [SMALL_STATE(5872)] = 194110,
  [SMALL_STATE(5873)] = 194123,
  [SMALL_STATE(5874)] = 194136,
  [SMALL_STATE(5875)] = 194149,
  [SMALL_STATE(5876)] = 194162,
  [SMALL_STATE(5877)] = 194175,
  [SMALL_STATE(5878)] = 194188,
  [SMALL_STATE(5879)] = 194201,
  [SMALL_STATE(5880)] = 194214,
  [SMALL_STATE(5881)] = 194227,
  [SMALL_STATE(5882)] = 194240,
  [SMALL_STATE(5883)] = 194253,
  [SMALL_STATE(5884)] = 194266,
  [SMALL_STATE(5885)] = 194279,
  [SMALL_STATE(5886)] = 194292,
  [SMALL_STATE(5887)] = 194305,
  [SMALL_STATE(5888)] = 194318,
  [SMALL_STATE(5889)] = 194331,
  [SMALL_STATE(5890)] = 194344,
  [SMALL_STATE(5891)] = 194357,
  [SMALL_STATE(5892)] = 194370,
  [SMALL_STATE(5893)] = 194383,
  [SMALL_STATE(5894)] = 194396,
  [SMALL_STATE(5895)] = 194409,
  [SMALL_STATE(5896)] = 194422,
  [SMALL_STATE(5897)] = 194435,
  [SMALL_STATE(5898)] = 194448,
  [SMALL_STATE(5899)] = 194461,
  [SMALL_STATE(5900)] = 194474,
  [SMALL_STATE(5901)] = 194487,
  [SMALL_STATE(5902)] = 194500,
  [SMALL_STATE(5903)] = 194513,
  [SMALL_STATE(5904)] = 194526,
  [SMALL_STATE(5905)] = 194539,
  [SMALL_STATE(5906)] = 194552,
  [SMALL_STATE(5907)] = 194565,
  [SMALL_STATE(5908)] = 194578,
  [SMALL_STATE(5909)] = 194591,
  [SMALL_STATE(5910)] = 194604,
  [SMALL_STATE(5911)] = 194617,
  [SMALL_STATE(5912)] = 194630,
  [SMALL_STATE(5913)] = 194643,
  [SMALL_STATE(5914)] = 194656,
  [SMALL_STATE(5915)] = 194669,
  [SMALL_STATE(5916)] = 194682,
  [SMALL_STATE(5917)] = 194695,
  [SMALL_STATE(5918)] = 194708,
  [SMALL_STATE(5919)] = 194721,
  [SMALL_STATE(5920)] = 194734,
  [SMALL_STATE(5921)] = 194747,
  [SMALL_STATE(5922)] = 194760,
  [SMALL_STATE(5923)] = 194773,
  [SMALL_STATE(5924)] = 194786,
  [SMALL_STATE(5925)] = 194799,
  [SMALL_STATE(5926)] = 194812,
  [SMALL_STATE(5927)] = 194825,
  [SMALL_STATE(5928)] = 194838,
  [SMALL_STATE(5929)] = 194851,
  [SMALL_STATE(5930)] = 194864,
  [SMALL_STATE(5931)] = 194877,
  [SMALL_STATE(5932)] = 194890,
  [SMALL_STATE(5933)] = 194903,
  [SMALL_STATE(5934)] = 194916,
  [SMALL_STATE(5935)] = 194929,
  [SMALL_STATE(5936)] = 194942,
  [SMALL_STATE(5937)] = 194955,
  [SMALL_STATE(5938)] = 194968,
  [SMALL_STATE(5939)] = 194981,
  [SMALL_STATE(5940)] = 194994,
  [SMALL_STATE(5941)] = 195007,
  [SMALL_STATE(5942)] = 195020,
  [SMALL_STATE(5943)] = 195033,
  [SMALL_STATE(5944)] = 195046,
  [SMALL_STATE(5945)] = 195059,
  [SMALL_STATE(5946)] = 195072,
  [SMALL_STATE(5947)] = 195085,
  [SMALL_STATE(5948)] = 195098,
  [SMALL_STATE(5949)] = 195111,
  [SMALL_STATE(5950)] = 195124,
  [SMALL_STATE(5951)] = 195137,
  [SMALL_STATE(5952)] = 195150,
  [SMALL_STATE(5953)] = 195163,
  [SMALL_STATE(5954)] = 195176,
  [SMALL_STATE(5955)] = 195189,
  [SMALL_STATE(5956)] = 195202,
  [SMALL_STATE(5957)] = 195215,
  [SMALL_STATE(5958)] = 195228,
  [SMALL_STATE(5959)] = 195241,
  [SMALL_STATE(5960)] = 195254,
  [SMALL_STATE(5961)] = 195267,
  [SMALL_STATE(5962)] = 195280,
  [SMALL_STATE(5963)] = 195293,
  [SMALL_STATE(5964)] = 195306,
  [SMALL_STATE(5965)] = 195319,
  [SMALL_STATE(5966)] = 195332,
  [SMALL_STATE(5967)] = 195345,
  [SMALL_STATE(5968)] = 195358,
  [SMALL_STATE(5969)] = 195371,
  [SMALL_STATE(5970)] = 195384,
  [SMALL_STATE(5971)] = 195397,
  [SMALL_STATE(5972)] = 195410,
  [SMALL_STATE(5973)] = 195423,
  [SMALL_STATE(5974)] = 195436,
  [SMALL_STATE(5975)] = 195449,
  [SMALL_STATE(5976)] = 195462,
  [SMALL_STATE(5977)] = 195475,
  [SMALL_STATE(5978)] = 195488,
  [SMALL_STATE(5979)] = 195501,
  [SMALL_STATE(5980)] = 195514,
  [SMALL_STATE(5981)] = 195527,
  [SMALL_STATE(5982)] = 195540,
  [SMALL_STATE(5983)] = 195553,
  [SMALL_STATE(5984)] = 195566,
  [SMALL_STATE(5985)] = 195579,
  [SMALL_STATE(5986)] = 195592,
  [SMALL_STATE(5987)] = 195605,
  [SMALL_STATE(5988)] = 195618,
  [SMALL_STATE(5989)] = 195631,
  [SMALL_STATE(5990)] = 195635,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5764),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5774),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5978),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lhs, 1, 0, 0),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lhs, 1, 0, 0),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5704),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lhs, 1, 0, 2),
  [179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lhs, 1, 0, 2),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5902),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2982),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5788),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier_call, 1, 0, 4),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier_call, 1, 0, 4),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return, 1, 0, 0),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 1, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1, 0, 0),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield, 1, 0, 0),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 1, 0, 0),
  [425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 1, 0, 0),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next, 1, 0, 0),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next, 1, 0, 0),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable, 1, 0, 0),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable, 1, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5475),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5478),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4732),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5113),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5373),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4660),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4681),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4995),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4946),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4304),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4306),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4379),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4667),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4669),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4412),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4415),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4425),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4680),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4685),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5120),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5128),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5137),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4674),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5423),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_argument, 1, 0, 0),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_argument, 1, 0, 0),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2, 0, 17),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 2, 0, 17),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4952),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4334),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4665),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4417),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4407),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5381),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5387),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4684),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5389),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5135),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5456),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5142),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5458),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4945),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5341),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 2),
  [1071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 2),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [1101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1909),
  [1104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5774),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(747),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0),
  [1112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5978),
  [1115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2438),
  [1118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(360),
  [1121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5704),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0),
  [1126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2055),
  [1129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [1132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1970),
  [1135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2086),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1975),
  [1141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1979),
  [1144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [1147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(51),
  [1153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [1156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2242),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2235),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(417),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(409),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(407),
  [1171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(411),
  [1174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1969),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(279),
  [1180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(427),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(199),
  [1189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(610),
  [1192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(615),
  [1195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(616),
  [1198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(626),
  [1201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2655),
  [1204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2648),
  [1207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2218),
  [1210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2082),
  [1213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1962),
  [1216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1964),
  [1219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1913),
  [1222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2402),
  [1225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4566),
  [1228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [1231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5181),
  [1234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5064),
  [1237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5069),
  [1240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5077),
  [1243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5009),
  [1246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5002),
  [1249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(530),
  [1252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5103),
  [1255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1745),
  [1258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1964),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 1, 0, 0),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 1, 0, 0),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [1273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then, 1, 0, 0),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then, 2, 0, 0),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5336),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsif, 3, 0, 64),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 1, 0, 0),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5401),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 4, 0, 94),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 3, 0, 74),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 2, 0, 0),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2956),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 3, 0, 72),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2829),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [1439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 2, 0, 0),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [1443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_clause, 4, 0, 111),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [1449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ensure, 1, 0, 0),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 3, 0, 68),
  [1475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_clause, 3, 0, 68),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 4, 0, 89),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [1607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2131),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2464),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4401),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5342),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [2038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [2062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__terminator, 1, 0, 0),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [2120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [2154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 2, 0, 29),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 3, 0, 0),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 2, 0, 0),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 2, 0, 28),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 2, 0, 29),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 2, 0, 28),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 2, 0, 28),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forward_argument, 1, 0, 0),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forward_argument, 1, 0, 0),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_argument, 1, 0, 0),
  [2494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_argument, 1, 0, 0),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_argument, 1, 0, 0),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_argument, 1, 0, 0),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5436),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_parameter, 2, 0, 30),
  [2610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_parameter, 2, 0, 30),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call, 3, 0, 49),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call, 3, 0, 49),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scope_resolution, 3, 0, 51),
  [2622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scope_resolution, 3, 0, 51),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1, 0, 0),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1, 0, 0),
  [2628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_suffix, 1, 0, 0),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_suffix, 1, 0, 0),
  [2632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier, 1, 0, 6),
  [2634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier, 1, 0, 6),
  [2636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nonlocal_variable, 1, 0, 0),
  [2638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nonlocal_variable, 1, 0, 0),
  [2640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_suffix, 1, 0, 0),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_suffix, 1, 0, 0),
  [2644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier, 1, 0, 7),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier, 1, 0, 7),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4264),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_parameter, 1, 0, 0),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [2660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_parameter, 1, 0, 0),
  [2662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_assignment, 1, 0, 0),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4983),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5230),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5233),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5234),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5237),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5262),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5265),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5590),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5117),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4997),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4834),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5488),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5057),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant, 1, 0, 0),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4654),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 3, 0, 0),
  [2764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mlhs, 3, 0, 0),
  [2766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 2, 0, 0),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mlhs, 2, 0, 0),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_assignment, 1, 0, 0),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4864),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5212),
  [2796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5044),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4443),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 2, 0, 77),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5918),
  [2812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 2, 0, 77),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4421),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4175),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 2, 0, 28),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 2, 0, 29),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 2, 0, 29),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4861),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4774),
  [2866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4695),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4706),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5892),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4631),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4561),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4498),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4529),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4436),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4705),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [2930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4608),
  [2932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4639),
  [2934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4797),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [2944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4664),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [2948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__chained_command_call, 3, 0, 49),
  [2950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__chained_command_call, 3, 0, 49),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4816),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [2962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__terminator, 1, 0, 0),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scope_resolution, 2, 0, 14),
  [2966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scope_resolution, 2, 0, 14),
  [2968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant_resolution, 2, 0, 14),
  [2970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant_resolution, 2, 0, 14),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 3, 0, 48),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 3, 0, 48),
  [2976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 1, 0, 0),
  [2986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 1, 0, 0),
  [2988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 4, 0, 48),
  [2990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 4, 0, 48),
  [2992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant, 1, 0, 0),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__keyword_variable, 1, 0, 0),
  [2998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 6, 0, 121),
  [3000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 6, 0, 121),
  [3002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 115),
  [3004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 115),
  [3006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 5, 0, 103),
  [3008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 5, 0, 103),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil, 1, 0, 0),
  [3012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil, 1, 0, 0),
  [3014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [3018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 96),
  [3020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 96),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 16),
  [3024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 16),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 75),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 75),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 75),
  [3034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 75),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 16),
  [3038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 16),
  [3040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 0),
  [3042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 0),
  [3044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 95),
  [3046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, 0, 95),
  [3048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 4, 0, 79),
  [3050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 4, 0, 79),
  [3052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 95),
  [3054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 95),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 75),
  [3060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 75),
  [3062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 96),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 96),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 97),
  [3068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 97),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 114),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 114),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 2, 0, 0),
  [3076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 2, 0, 0),
  [3078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [3080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr_basic, 1, 0, 0),
  [3084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 0),
  [3086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [3088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [3092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0),
  [3096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 4, 0, 0),
  [3102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 4, 0, 0),
  [3104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 6, 0, 122),
  [3106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 6, 0, 122),
  [3108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [3116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 7, 0, 124),
  [3118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 7, 0, 124),
  [3120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 117),
  [3122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 117),
  [3124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 6, 0, 123),
  [3126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 6, 0, 123),
  [3128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 7, 0, 125),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 7, 0, 125),
  [3132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 8, 0, 126),
  [3134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 8, 0, 126),
  [3136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 119),
  [3138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 119),
  [3140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 0),
  [3142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 0),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 2, 0, 0),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 2, 0, 0),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 4, 0, 113),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 4, 0, 113),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 3, 0, 0),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 3, 0, 0),
  [3156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [3188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 2, 0, 17),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [3236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chained_string, 2, 0, 0),
  [3246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_chained_string, 2, 0, 0),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [3252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_literal, 1, 0, 0),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0),
  [3260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0),
  [3262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5181),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [3269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_numeric, 1, 0, 0),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_numeric, 1, 0, 0),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__int_or_float, 1, 0, 0),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__int_or_float, 1, 0, 0),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 50),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 50),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 18),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 18),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 23),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 23),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_retry, 1, 0, 0),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_retry, 1, 0, 0),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 8),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 8),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 20),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 20),
  [3319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redo, 1, 0, 0),
  [3321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redo, 1, 0, 0),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 1, 0, 0),
  [3335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chained_string_repeat1, 1, 0, 0),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [3339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 2, 0, 17),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 4, 0, 69),
  [3343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 4, 0, 69),
  [3345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_class, 6, 0, 106),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_class, 6, 0, 106),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 52),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 52),
  [3353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subshell, 3, 0, 24),
  [3355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subshell, 3, 0, 24),
  [3357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 54),
  [3359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 54),
  [3361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_statements, 2, 0, 0),
  [3363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_statements, 2, 0, 0),
  [3365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, 0, 33),
  [3371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, 0, 33),
  [3373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 3, 0, 0),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 3, 0, 0),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, 0, 25),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, 0, 25),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, 0, 0),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, 0, 0),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 2, 0, 0),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 2, 0, 0),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [3393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, 0, 1),
  [3395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, 0, 1),
  [3397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 3, 0, 26),
  [3399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 3, 0, 26),
  [3401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 3, 0, 0),
  [3403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 3, 0, 0),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 19),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 19),
  [3409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [3413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0),
  [3415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0),
  [3417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 5, 0, 55),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 5, 0, 55),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 5, 0, 26),
  [3423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 5, 0, 26),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 107),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, 0, 107),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 53),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3, 0, 53),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_assignment, 3, 0, 40),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_assignment, 3, 0, 40),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 5, 0, 56),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 5, 0, 56),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 30),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 30),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_statements, 3, 0, 0),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_statements, 3, 0, 0),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delimited_symbol, 2, 0, 8),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delimited_symbol, 2, 0, 8),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 66),
  [3459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 66),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 5, 0, 27),
  [3463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 5, 0, 27),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 5, 0, 0),
  [3467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 5, 0, 0),
  [3469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 62),
  [3471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 62),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 2, 0, 0),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 0),
  [3481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 0),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_retry, 2, 0, 0),
  [3485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_retry, 2, 0, 0),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 81),
  [3489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 81),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 14),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 14),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 62),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, 0, 62),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 55),
  [3501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 55),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 60),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 60),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 82),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 82),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 26),
  [3513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 26),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 14),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, 0, 14),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [3521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_class, 5, 0, 66),
  [3525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_class, 5, 0, 66),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 83),
  [3529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 83),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 3, 0, 0),
  [3533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 3, 0, 0),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 3, 0, 32),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 3, 0, 32),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 33),
  [3541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 33),
  [3543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_until, 3, 0, 32),
  [3545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_until, 3, 0, 32),
  [3547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 1, 0, 5),
  [3549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 1, 0, 5),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_method, 4, 0, 59),
  [3553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_method, 4, 0, 59),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 0),
  [3557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 0),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 2, 0, 0),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 2, 0, 0),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__numeric, 1, 0, 0),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__numeric, 1, 0, 0),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 84),
  [3569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 84),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, 0, 84),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 5, 0, 84),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [3577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [3579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 2, 0, 0),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 2, 0, 0),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 2, 0, 0),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 2, 0, 0),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 14),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 14),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next, 2, 0, 0),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next, 2, 0, 0),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6, 0, 66),
  [3597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6, 0, 66),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 108),
  [3601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 108),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, 0, 0),
  [3605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, 0, 0),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 2, 0, 13),
  [3609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 2, 0, 13),
  [3611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 14),
  [3613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 3, 0, 14),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redo, 2, 0, 0),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redo, 2, 0, 0),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 4, 0, 63),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 4, 0, 63),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 4, 0, 64),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 4, 0, 64),
  [3627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 21),
  [3629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 21),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_minus_pow, 2, 0, 12),
  [3633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unary_minus_pow, 2, 0, 12),
  [3635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 2, 0, 0),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 2, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 4, 0, 65),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 4, 0, 65),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2, 0, 0),
  [3655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield, 2, 0, 0),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, 0, 85),
  [3659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, 0, 85),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0),
  [3663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0),
  [3665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 2, 0, 0),
  [3667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 2, 0, 0),
  [3669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 109),
  [3671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 109),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, 0, 86),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, 0, 86),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6, 0, 33),
  [3679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6, 0, 33),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, 0, 37),
  [3683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, 0, 37),
  [3685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 0),
  [3687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 0),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 112),
  [3691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 112),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 5, 0, 85),
  [3695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 5, 0, 85),
  [3697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delimited_symbol, 3, 0, 23),
  [3699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delimited_symbol, 3, 0, 23),
  [3701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 5, 0, 86),
  [3703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 5, 0, 86),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 56),
  [3707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 56),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 6, 0, 55),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 6, 0, 55),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 6, 0, 56),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 6, 0, 56),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 27),
  [3719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 27),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 60),
  [3723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 60),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 3, 0, 0),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 3, 0, 0),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 66),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 66),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 61),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 61),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 2, 0, 0),
  [3739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 2, 0, 0),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 0),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 0),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 4, 0, 0),
  [3747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 4, 0, 0),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 3, 0, 27),
  [3751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 3, 0, 27),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 22),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 22),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rational, 2, 0, 0),
  [3763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rational, 2, 0, 0),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_method, 6, 0, 104),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_method, 6, 0, 104),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 87),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 87),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_literal, 2, 0, 11),
  [3775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_literal, 2, 0, 11),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_unary, 2, 0, 11),
  [3779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_unary, 2, 0, 11),
  [3781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [3789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_expr, 2, 0, 16),
  [3791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__body_expr, 2, 0, 16),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 3, 0, 0),
  [3795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 3, 0, 0),
  [3797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 7, 0, 66),
  [3799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 7, 0, 66),
  [3801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 7, 0, 116),
  [3803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 7, 0, 116),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, 0, 63),
  [3807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, 0, 63),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 2, 0, 10),
  [3815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 2, 0, 10),
  [3817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, 0, 64),
  [3819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, 0, 64),
  [3821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 5, 0, 105),
  [3823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 5, 0, 105),
  [3825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 4, 0, 80),
  [3827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 4, 0, 80),
  [3829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 33),
  [3831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 33),
  [3833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 91),
  [3835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 91),
  [3837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 92),
  [3839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 92),
  [3841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 0),
  [3843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 0),
  [3845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 2, 0, 16),
  [3847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 2, 0, 16),
  [3849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 2, 0, 31),
  [3851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 2, 0, 31),
  [3853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subshell, 2, 0, 9),
  [3855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subshell, 2, 0, 9),
  [3857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return, 2, 0, 0),
  [3859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 2, 0, 0),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_lambda, 1, 0, 0),
  [3863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 4, 0, 0),
  [3865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 4, 0, 0),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [3871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary, 2, 0, 11),
  [3873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary, 2, 0, 11),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4464),
  [3883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5606),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4812),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3162),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [3995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [4041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_right_assignment_list, 2, 0, 0),
  [4047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_right_assignment_list, 2, 0, 0),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(821),
  [4054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pow, 3, 0, 40),
  [4056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pow, 3, 0, 40),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [4082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 3, 0, 40),
  [4084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 3, 0, 40),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [4088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 3, 0, 41),
  [4090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 3, 0, 41),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [4094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional, 5, 0, 102),
  [4096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional, 5, 0, 102),
  [4098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_argument, 2, 0, 0),
  [4100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_argument, 2, 0, 0),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [4106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2, 0, 15),
  [4108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 2, 0, 15),
  [4110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier_arg, 3, 0, 38),
  [4112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier_arg, 3, 0, 38),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [4130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [4156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [4164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(838),
  [4167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [4187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4475),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [4207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4581),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [4229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [4233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [4279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [4281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [4287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [4315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4761),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4810),
  [4321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [4331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [4343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [4347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(830),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [4409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [4411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [4429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [4435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [4440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 58),
  [4442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier_expression, 3, 0, 38),
  [4444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 57),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [4452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_argument, 2, 0, 0),
  [4454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_argument, 2, 0, 0),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [4469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [4473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [4479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [4481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [4499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [4513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [4541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5170),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [4546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(827),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [4631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [4635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [4661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [4667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(817),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [4678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [4716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [4718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [4730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [4750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [4774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [4782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_name, 1, 0, 0),
  [4784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_name, 1, 0, 0),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [4788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(815),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4836),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4848),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4870),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [4805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4805),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [4809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [4811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [4813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [4817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [4823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [4853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [4857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [4861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [4863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [4879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4808),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [4891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier_expression, 3, 0, 38),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [4899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_argument, 2, 0, 0),
  [4901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_argument, 2, 0, 0),
  [4903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 57),
  [4905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 58),
  [4907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(825),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(813),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [4917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [4923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [4951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [4957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [4959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [4977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [4983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter, 2, 0, 30),
  [4985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter, 2, 0, 30),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(819),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [5016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [5018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [5036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [5040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(833),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3170),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [5069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [5073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [5075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [5077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [5109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [5111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [5127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [5133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(835),
  [5136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [5140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [5160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [5171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [5183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [5187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [5209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [5223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [5225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [5241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [5253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(822),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [5294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [5316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [5326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [5336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5200),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [5341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [5351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(829),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [5356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [5360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [5362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [5364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [5382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [5392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [5396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [5398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [5400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [5418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [5434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [5438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [5440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [5466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(824),
  [5469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [5475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(832),
  [5478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(811),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [5483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(816),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [5516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [5522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [5526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [5530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5836),
  [5604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 2, 0, 0),
  [5606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 2, 0, 0),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(823),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [5617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [5621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [5623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [5625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [5643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [5657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(818),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [5662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 3, 0, 0),
  [5664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 3, 0, 0),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [5676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [5680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [5698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [5722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [5768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [5772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [5776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [5778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [5810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(836),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [5817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(840),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [5824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [5828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [5852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [5856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [5858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [5860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [5878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [5886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [5888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [5902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptions, 1, 0, 0),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [5944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [5950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [5952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [5978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [5986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [6014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(841),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [6025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [6029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [6031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [6033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [6051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [6061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [6067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [6071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [6077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [6083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [6095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(812),
  [6098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [6104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [6110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [6114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [6120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [6126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [6146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [6148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [6166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [6172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [6180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [6204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 76),
  [6206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_parameter, 3, 0, 76),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [6212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in, 2, 0, 0),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [6216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(814),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [6221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [6225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [6227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [6229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [6247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [6253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [6255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [6269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [6279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [6285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_parameter, 3, 0, 76),
  [6287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_parameter, 3, 0, 76),
  [6289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_parameter, 2, 0, 14),
  [6291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_parameter, 2, 0, 14),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [6303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [6305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [6327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [6347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant_resolution, 3, 0, 51),
  [6349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant_resolution, 3, 0, 51),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [6441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_value, 1, 0, 0),
  [6443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_value, 1, 0, 0),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [6465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant, 1, 0, 47),
  [6467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant, 1, 0, 47),
  [6469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [6489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_literal, 1, 0, 0),
  [6491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__keyword_variable, 1, 0, 0),
  [6493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_lambda, 1, 0, 0),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_primitive, 1, 0, 0),
  [6497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_primitive, 1, 0, 0),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call_with_block, 3, 0, 54),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call_with_block, 3, 0, 54),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call_with_block, 3, 0, 52),
  [6505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call_with_block, 3, 0, 52),
  [6507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call, 2, 0, 20),
  [6509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call, 2, 0, 20),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [6515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call, 2, 0, 18),
  [6517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call, 2, 0, 18),
  [6519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_reference_pattern, 2, 0, 14),
  [6521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_reference_pattern, 2, 0, 14),
  [6523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_reference_pattern, 4, 0, 66),
  [6525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_reference_pattern, 4, 0, 66),
  [6527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr_basic, 1, 0, 0),
  [6529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 101),
  [6531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, 0, 101),
  [6533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 3, 0, 41),
  [6535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 3, 0, 41),
  [6537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 3, 0, 0),
  [6539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 3, 0, 0),
  [6541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [6543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [6545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [6547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [6551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_value, 1, 0, 46),
  [6553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_value, 1, 0, 46),
  [6555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_find_pattern, 3, 0, 0),
  [6557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_find_pattern, 3, 0, 0),
  [6559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4, 0, 101),
  [6561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 4, 0, 101),
  [6563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 2, 0, 0),
  [6565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_find_pattern, 4, 0, 101),
  [6567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_find_pattern, 4, 0, 101),
  [6569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 2, 0, 15),
  [6571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 2, 0, 15),
  [6573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [6575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99),
  [6577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99),
  [6579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 4, 0, 101),
  [6581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 4, 0, 101),
  [6583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5951),
  [6585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr_alt, 1, 0, 0),
  [6587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr_alt, 1, 0, 0),
  [6589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3, 0, 58),
  [6591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 3, 0, 58),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [6595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0),
  [6597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0),
  [6599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr, 1, 0, 0),
  [6601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr, 1, 0, 0),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [6605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [6607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, 0, 98),
  [6609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, 0, 98),
  [6611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3, 0, 57),
  [6613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 3, 0, 57),
  [6615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_parameter, 2, 0, 14),
  [6617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_parameter, 2, 0, 14),
  [6619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_command, 2, 0, 0),
  [6621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_command, 2, 0, 0),
  [6623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_nil, 2, 0, 0),
  [6625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_nil, 2, 0, 0),
  [6627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_unary, 2, 0, 11),
  [6629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_unary, 2, 0, 11),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [6633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next_command, 2, 0, 0),
  [6635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next_command, 2, 0, 0),
  [6637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0),
  [6639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0),
  [6641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 29),
  [6643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 29),
  [6645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__find_pattern_body, 4, 0, 0),
  [6647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__find_pattern_body, 4, 0, 0),
  [6649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100),
  [6651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2190),
  [6654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 3),
  [6656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 3),
  [6658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 1, 0, 0),
  [6660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 1, 0, 0),
  [6662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_assignment, 3, 0, 53),
  [6664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_assignment, 3, 0, 53),
  [6666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 44),
  [6668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 44),
  [6670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_operator_assignment, 3, 0, 40),
  [6672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_operator_assignment, 3, 0, 40),
  [6674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_test_pattern, 3, 0, 42),
  [6676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_pattern, 3, 0, 42),
  [6678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 3, 0, 0),
  [6680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 3, 0, 0),
  [6682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 4, 0, 0),
  [6684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 4, 0, 0),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [6690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 45),
  [6692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 45),
  [6694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0),
  [6696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0),
  [6698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, 0, 42),
  [6700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_pattern, 3, 0, 42),
  [6702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_command, 2, 0, 0),
  [6704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_command, 2, 0, 0),
  [6706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument, 1, 0, 0),
  [6708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument, 1, 0, 0),
  [6710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 28),
  [6712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 28),
  [6714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_command, 2, 0, 0),
  [6716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_command, 2, 0, 0),
  [6718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_any_rest, 1, 0, 0),
  [6720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_any_rest, 1, 0, 0),
  [6722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternative_pattern, 2, 0, 78),
  [6724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_binary, 3, 0, 40),
  [6726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_binary, 3, 0, 40),
  [6728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 43),
  [6730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 43),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5980),
  [6734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5647),
  [6736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4476),
  [6738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_parameter, 1, 0, 0),
  [6740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_parameter, 1, 0, 0),
  [6742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4478),
  [6744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 2, 0, 0),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [6748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4821),
  [6751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2165),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [6756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_argument_list, 1, 0, 0),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [6764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_argument_list, 2, 0, 0),
  [6766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 1, 0, 0),
  [6768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [6772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(445),
  [6775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 0),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [6785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0),
  [6787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [6791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5297),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [6801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [6805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [6811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [6813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [6817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [6819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 3, 0, 35),
  [6821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 3, 0, 35),
  [6823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block, 3, 0, 0),
  [6825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_block, 3, 0, 0),
  [6827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [6829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_block, 4, 0, 0),
  [6831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_block, 4, 0, 0),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [6835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [6837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block, 4, 0, 0),
  [6839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_block, 4, 0, 0),
  [6841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [6844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_block, 3, 0, 0),
  [6846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_block, 3, 0, 0),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [6850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef, 2, 0, 0),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [6866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [6868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef, 3, 0, 0),
  [6870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0), SHIFT_REPEAT(2665),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [6889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_until_modifier, 3, 0, 39),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [6893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier, 3, 0, 38),
  [6895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_modifier, 3, 0, 39),
  [6897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless_modifier, 3, 0, 39),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [6901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_modifier, 3, 0, 39),
  [6903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100),
  [6905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2196),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [6920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternative_pattern, 2, 0, 78),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [6964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2148),
  [6967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 1, 0, 0),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [6973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 2, 0, 0),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [6977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4781),
  [6980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 0),
  [6982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 2, 0, 0),
  [6984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(447),
  [6987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_argument_list, 1, 0, 0),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [6995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_argument_list, 2, 0, 0),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [7007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [7009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(453),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [7022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [7024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4811),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [7030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2188),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [7039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [7043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless_modifier, 3, 0, 39),
  [7045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier, 3, 0, 38),
  [7047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_until_modifier, 3, 0, 39),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [7051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_undef, 3, 0, 0),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [7055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(456),
  [7058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0), SHIFT_REPEAT(2645),
  [7061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_modifier, 3, 0, 39),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [7065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_modifier, 3, 0, 39),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [7069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [7073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_undef, 2, 0, 0),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [7097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4849),
  [7099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 2, 0, 0),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [7105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4798),
  [7108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2164),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [7115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2191),
  [7118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 100), SHIFT_REPEAT(2195),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [7131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(454),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [7172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4784),
  [7175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [7177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5121),
  [7179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [7187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5125),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [7195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5086),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [7199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5090),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [7203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5078),
  [7205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [7207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [7211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [7215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5082),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [7219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [7223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5084),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [7229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(443),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [7234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4795),
  [7237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5186),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [7241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5202),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [7247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5206),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [7259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(450),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5162),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [7270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5123),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [7274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5063),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [7278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5166),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [7282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5095),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [7286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5059),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [7290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5074),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [7296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2160),
  [7299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [7308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2158),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [7315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5017),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [7319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5020),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5417),
  [7323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4966),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [7327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4968),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [7331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5812),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [7335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5820),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [7341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(451),
  [7344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__mlhs_repeat1, 2, 0, 0),
  [7346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(358),
  [7349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0),
  [7351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5287),
  [7354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5287),
  [7357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0),
  [7359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5494),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [7364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5772),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [7368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 26),
  [7370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 26),
  [7372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5013),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5795),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [7386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5019),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [7390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_assignment, 2, 0, 0),
  [7392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4994),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [7396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5682),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [7400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5685),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [7404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 27),
  [7406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 27),
  [7408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5742),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5777),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [7416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5713),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [7420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5814),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5442),
  [7424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_statement, 2, 0, 0),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [7430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [7434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_statement, 1, 0, 0),
  [7436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0),
  [7438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(680),
  [7441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(270),
  [7444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(297),
  [7447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [7451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5062),
  [7454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then, 2, 0, 0),
  [7456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [7506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exception_variable, 2, 0, 0),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [7510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [7538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then, 3, 0, 0),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [7546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(452),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [7563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [7602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(343),
  [7605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(5323),
  [7608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0),
  [7610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(5405),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [7617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(357),
  [7620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5298),
  [7623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5449),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [7636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5221),
  [7638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameter, 1, 0, 0),
  [7640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameter, 1, 0, 0),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [7652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [7690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptions, 2, 0, 0),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [7698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameter, 2, 0, 14),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [7708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [7712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 2, 0, 0),
  [7714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 2, 0, 0),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [7726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 0),
  [7728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forward_parameter, 1, 0, 0),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [7742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 0),
  [7744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [7752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [7766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(826),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5328),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [7777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [7780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 36),
  [7782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__literal_contents, 1, 0, 0),
  [7784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__literal_contents, 1, 0, 0),
  [7786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 90), SHIFT_REPEAT(805),
  [7789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 90),
  [7791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mlhs_repeat1, 2, 0, 0), SHIFT_REPEAT(1973),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [7798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 3, 0, 63),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [7804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_guard, 2, 0, 64),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [7810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0),
  [7812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0), SHIFT_REPEAT(808),
  [7815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 2, 0, 70),
  [7817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 2, 0, 70), SHIFT_REPEAT(2028),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [7830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 1, 0, 0),
  [7832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [7836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [7838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless_guard, 2, 0, 64),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [7842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 1, 0, 0),
  [7844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 1, 0, 0),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [7852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 2, 0, 0),
  [7854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4638),
  [7857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_body, 1, 0, 0),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [7863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructured_left_assignment, 3, 0, 0),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [7871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bare_parameters, 1, 0, 0),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [7875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 2, 0, 16),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [7879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bare_parameters, 2, 0, 0),
  [7881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 3, 0, 0),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [7897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(444),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [7906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 3, 0, 71),
  [7908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 3, 0, 73),
  [7910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4626),
  [7913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4623),
  [7916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ensure, 2, 0, 0),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [7928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2, 0, 0),
  [7930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 68),
  [7932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 4, 0, 93),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [7936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 1, 0, 0),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [7940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 1, 0, 0),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [7958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__guard, 1, 0, 0),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [7964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [7968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4622),
  [7971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 0), SHIFT_REPEAT(5263),
  [7974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 0),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [7984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4712),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [7988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 1, 0, 34),
  [7990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 120), SHIFT_REPEAT(5910),
  [7993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 120),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [8013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [8035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [8039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [8049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 1, 0, 0),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [8055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4430),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [8061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 4, 0, 88),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [8065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 3, 0, 67),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [8075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_clause, 4, 0, 110),
  [8077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_clause, 3, 0, 67),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [8089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 0), SHIFT_REPEAT(5247),
  [8092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 0),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [8110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hash_repeat1, 2, 0, 0),
  [8112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_repeat1, 2, 0, 0), SHIFT_REPEAT(804),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [8129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5384),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [8145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 118),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [8205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_left_assignment_list, 1, 0, 0),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [8339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_statement, 1, 0, 0),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [8343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [8345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [8353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 4, 0, 85),
  [8355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 4, 0, 86),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [8359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [8361] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [8369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [8373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [8377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [8403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [8447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [8459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [8465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [8527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3, 0, 0),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [8555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [8571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [8583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [8601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [8603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [8605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [8611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [8613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [8619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [8637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [8639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [8641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [8645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [8647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [8665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [8673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [8773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [8809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_body, 1, 0, 0),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [8861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 2, 0, 0),
  [8863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 3, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__line_break = 0,
  ts_external_token__no_line_break = 1,
  ts_external_token_simple_symbol = 2,
  ts_external_token__string_start = 3,
  ts_external_token__symbol_start = 4,
  ts_external_token__subshell_start = 5,
  ts_external_token__regex_start = 6,
  ts_external_token__string_array_start = 7,
  ts_external_token__symbol_array_start = 8,
  ts_external_token__heredoc_body_start = 9,
  ts_external_token_string_content = 10,
  ts_external_token_heredoc_content = 11,
  ts_external_token__string_end = 12,
  ts_external_token_heredoc_end = 13,
  ts_external_token_heredoc_beginning = 14,
  ts_external_token_SLASH = 15,
  ts_external_token__block_ampersand = 16,
  ts_external_token__splat_star = 17,
  ts_external_token__unary_minus = 18,
  ts_external_token__unary_minus_num = 19,
  ts_external_token__binary_minus = 20,
  ts_external_token__binary_star = 21,
  ts_external_token__singleton_class_left_angle_left_langle = 22,
  ts_external_token_hash_key_symbol = 23,
  ts_external_token__identifier_suffix = 24,
  ts_external_token__constant_suffix = 25,
  ts_external_token__hash_splat_star_star = 26,
  ts_external_token__binary_star_star = 27,
  ts_external_token__element_reference_bracket = 28,
  ts_external_token__short_interpolation = 29,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break,
  [ts_external_token__no_line_break] = sym__no_line_break,
  [ts_external_token_simple_symbol] = sym_simple_symbol,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__symbol_start] = sym__symbol_start,
  [ts_external_token__subshell_start] = sym__subshell_start,
  [ts_external_token__regex_start] = sym__regex_start,
  [ts_external_token__string_array_start] = sym__string_array_start,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start,
  [ts_external_token_string_content] = sym_string_content,
  [ts_external_token_heredoc_content] = sym_heredoc_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand,
  [ts_external_token__splat_star] = sym__splat_star,
  [ts_external_token__unary_minus] = sym__unary_minus,
  [ts_external_token__unary_minus_num] = sym__unary_minus_num,
  [ts_external_token__binary_minus] = sym__binary_minus,
  [ts_external_token__binary_star] = sym__binary_star,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle,
  [ts_external_token_hash_key_symbol] = sym_hash_key_symbol,
  [ts_external_token__identifier_suffix] = sym__identifier_suffix,
  [ts_external_token__constant_suffix] = sym__constant_suffix,
  [ts_external_token__hash_splat_star_star] = sym__hash_splat_star_star,
  [ts_external_token__binary_star_star] = sym__binary_star_star,
  [ts_external_token__element_reference_bracket] = sym__element_reference_bracket,
  [ts_external_token__short_interpolation] = sym__short_interpolation,
};

static const bool ts_external_scanner_states[42][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token_heredoc_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [2] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [3] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [4] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [5] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [6] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [7] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [8] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [9] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [10] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [11] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [12] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [13] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [14] = {
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [15] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [16] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [17] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [18] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [19] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [20] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [21] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
  },
  [22] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [23] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
  },
  [24] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [25] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [26] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [27] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [28] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [29] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [30] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [31] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [32] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [33] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [34] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [35] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [36] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [37] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [38] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [39] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_content] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [40] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [41] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_end] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_ruby_external_scanner_create(void);
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_ruby(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
